﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
/*! CocoonJSExtensions - v2.0.0 - 2014-07-23 www.ludei.com */(function() {
    // There should not be a CocoonJS object when this code is executed.
    // if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
     * The basic object for all the CocoonJS related specific APIs === extensions.
     * @namespace
     */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

    CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

    /**
     * This type represents a 2D size structure with horizontal and vertical values.
     * @class
     */
    CocoonJS.Size = {
        /**
         * The horizontal size value.
         */
        width: 0,

        /**
         * The vertical size value.
         */
        height: 0
    };

    /**
     * This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
     * This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
     * @param {function} subc The subclass function.
     * @param {function} superc The superclass function.
     */
    CocoonJS.extend = function(subc, superc) {
        var subcp = subc.prototype;

        // Class pattern.
        var CocoonJSExtendHierarchyChainClass = function() {};
        CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

        subc.prototype = new CocoonJSExtendHierarchyChainClass(); // chain prototypes.
        subc.superclass = superc.prototype;
        subc.prototype.constructor = subc;

        // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
        if (superc.prototype.constructor === Object.prototype.constructor) {
            superc.prototype.constructor = superc;
        }

        // Check all the elements in the subclass prototype and add them to the chain object's prototype.
        for (var method in subcp) {
            if (subcp.hasOwnProperty(method)) {
                subc.prototype[method] = subcp[method];

                // // tenemos en super un metodo con igual nombre.
                // if ( superc.prototype[method]) 
                // {
                //     subc.prototype[method]= (function(fn, fnsuper) 
                //     {
                //         return function() 
                //         {
                //             var prevMethod= this.__super;

                //             this.__super= fnsuper;

                //             var retValue= fn.apply(
                //                     this,
                //                     Array.prototype.slice.call(arguments) );

                //             this.__super= prevMethod;

                //             return retValue;
                //         };
                //     })(subc.prototype[method], superc.prototype[method]);
                // }
            }
        }
    }

    /**
     * IMPORTANT: This function should only be used by Ludei.
     * This function allows a call to the native extension object function reusing the same arguments object.
     * Why is interesting to use this function instead of calling the native object's function directly?
     * As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
     * undefined arguments are passed to the native side. Some native functions do not check the parameters validation
     * correctly (just check the number of parameters passed).
     * Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
     * call, but it takes more work than using this approach.
     * @static
     * @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
     * @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
     * @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
     * @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
     * @returns Whatever the native function call returns.
     */
    CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
        if (CocoonJS.nativeExtensionObjectAvailable) {
            var argumentsArray = Array.prototype.slice.call(args);
            argumentsArray.unshift(nativeFunctionName);
            var nativeExtensionObject = ext[nativeExtensionObjectName];
            var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
            var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
            var finalRet = ret;
            if (typeof ret === "string") {
                try {
                    finalRet = JSON.parse(ret);
                } catch (error) {}
            }
            return finalRet;
        }
    };

    /**
     * Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
     * It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
     * path could be "CocoonJS.App" or "document.body".
     * @param {Object} baseObject The object to start from to find the object using the given text path.
     * @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
     * For example:
     * var body = getObjectFromPath(window, "document.body");
     */
    CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
        var parts = objectPath.split('.');
        var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) {
            obj[parts[i]] = obj[parts[i]] || undefined;
            obj = obj[parts[i]];
        }
        return obj;
    };

    /**
     * Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
     * @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
     * @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
     * @return The key that corresponds to the given value it is has been found or null.
     */
    CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value) {
                finalKey = key;
                break;
            }
        }
        return finalKey;
    }

    /**
     * Finds a string inside a given array of strings by looking for a given substring. It can also
     * specify if the search must be performed taking care or not of the case sensitivity.
     * @param {Array} stringArray The array of strings in which to to look for the string.
     * @param {string} subString The substring to look for inside all the strings of the array.
     * @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the
     * case sensitiveness (true) or not (false).
     * @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
     */
    CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
        var foundString = null;
        subString = caseSensitive ? subString : subString.toUpperCase();
        for (var i = 0; foundString == null && i < stringArray.length; i++) {
            foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
            foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null;
        }
        return foundString;
    };

    /**
     * A class that represents objects to handle events. Event handlers have always the same structure:
     * Mainly they provide the addEventListener and removeEventListener functions.
     * Both functions receive a callback function that will be added or removed. All the added callback
     * functions will be called when the event takes place.
     * Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
     * @constructor
     * @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
     * @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
     * @param {string} nativeEventName The name of the native event inside the ext object.
     * @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
     * will be called before any of the other listeners.
     */
    CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
        this.listeners = [];
        this.listenersOnce = [];
        this.chainFunction = chainFunction;

        /**
         * Adds a callback function so it can be called when the event takes place.
         * @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.addEventListener = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                listener.CocoonJSEventHandlerChainFunction = f;
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            var indexOfListener = this.listeners.indexOf(listener);
            if (indexOfListener < 0) {
                this.listeners.push(listener);
            }
        };

        this.addEventListenerOnce = function(listener) {
            if (chainFunction) {
                var f = function() {
                    chainFunction(arguments.callee.sourceListener, Array.prototype.slice.call(arguments));
                };
                f.sourceListener = listener;
                listener = f;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                    this.listenersOnce.push(listener);
                }
            }
        };

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function(listener) {

            if (chainFunction) {
                listener = listener.CocoonJSEventHandlerChainFunction;
                delete listener.CocoonJSEventHandlerChainFunction;
            }

            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            } else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

        this.notifyEventListeners = function() {
            var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            var argumentsArray = Array.prototype.slice.call(arguments);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName, argumentsArray);
            } else {
                var listeners = Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce = [];
            }
        };
        return this;
    };

    /**
     * A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
     */
    CocoonJS.Timer = function() {
        this.reset();
        return this;
    };

    CocoonJS.Timer.prototype = {
        currentTimeInMillis: 0,
        lastTimeInMillis: 0,
        elapsedTimeInMillis: 0,
        elapsedTimeInSeconds: 0,
        accumTimeInMillis: 0,

        /**
		Resets the timer to 0.
		*/
        reset: function() {
            this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
            this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
        },

        /**
		Updates the timer calculating the elapsed time between update calls.
		*/
        update: function() {
            this.currentTimeInMillis = new Date().getTime();
            this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
            this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
            this.lastTimeInMillis = this.currentTimeInMillis;
            this.accumTimeInMillis += this.elapsedTimeInMillis;
        }
    };

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     * @enum
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
    * The predefined possible orientations. there can be a bit level combination of them using the OR operator.
    * @namespace
    * @enum
    */
    CocoonJS.App.Orientations = {
        PORTRAIT : 1,
        PORTRAIT_UPSIDE_DOWN : 2,
        LANDSCAPE_LEFT : 4,
        LANDSCAPE_RIGHT : 8,
        PORTRAIT : 1 | 2,
        LANDSCAPE : 4 | 8,
        BOTH : 1 | 2 | 4 | 8
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     * @enum
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     * @enum
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     * @enum
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * @ignore
     * Forward service might not be available if only one JS service is included
     */
    function isNativeBridgeServiceAvailable(){
        if (CocoonJS.App.forward.nativeAvailable === 'boolean') {
            //cached value
            return CocoonJS.App.forward.nativeAvailable;
        }
        else {
            var available = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forwardAvailable", arguments);
            available = !!available;
            CocoonJS.App.forward.nativeAvailable = available;
            return available;
        }

    }

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                var frame = window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'];
                if (frame) {
                    return frame.window.eval(javaScriptCode);
                }
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable && isNativeBridgeServiceAvailable()) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else {
            setTimeout(function() {
                var res;
                if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                    res = window.parent.eval(javaScriptCode);
                }
                else {
                    var frame = window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'];
                    if (frame) {
                        res = frame.window.eval(javaScriptCode);
                    }
                }
                typeof(returnCallback) === "function" && returnCallback.call(this, res);
            }, 1);
        }
    };


    CocoonJS.App.setNPOTEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setNPOTEnabled", enabled);
        }
    };

    CocoonJS.App.setMaxMemory = function (memoryInMBs) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setMaxMemory", memoryInMBs);
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            setTimeout(function() {
                var result = prompt(message, text);
                var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
                eventObject.notifyEventListeners(result);
            }, 0);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            setTimeout(function() {
                var result = confirm(message);
                var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
                eventObject.notifyEventListeners();
            }, 0);
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Opens a given share native window to share some specific text content in any system specific social sharing options. For example, Twitter, Facebook, SMS, Mail, ...
     * @function
     * @param {string} textToShare The text content that will be shared.
     */
    CocoonJS.App.share = function(textToShare) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "share", arguments, true);
        }
        else {
            // TODO: Is there something we could do to share in a browser?
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleep” state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    CocoonJS.App.addADivToDisableInput = function() {
        var div = document.createElement("div");
        div.id = "CocoonJSInputBlockingDiv";
        div.style.left = 0;
        div.style.top = 0;
        div.style.width = "100%";
        div.style.height = "100%";
        div.style.position = "absolute";
        div.style.backgroundColor = 'transparent';
        div.style.border = "0px solid #000"; 
        div.style.zIndex = 999999999;
        document.body.appendChild(div);
    };

    CocoonJS.App.removeTheDivToEnableInput = function() {
        var div = document.getElementById("CocoonJSInputBlockingDiv");
        if (div) document.body.removeChild(div);
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
        else if (!navigator.isCocoonJS) {
            if (!CocoonJS.App.EmulatedWebViewIFrame) {
                CocoonJS.App.forwardEventsToCocoonJSEnabled = false;
                CocoonJS.App.forwardAsync("CocoonJS && CocoonJS.App && CocoonJS.App.disableTouchInCocoonJS();");
            }
            else {
                // CocoonJS.App.addADivToDisableInput();
            }
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
        else if (!navigator.isCocoonJS) {
            if (!CocoonJS.App.EmulatedWebViewIFrame) {
                CocoonJS.App.forwardEventsToCocoonJSEnabled = true;
                CocoonJS.App.forwardAsync("CocoonJS && CocoonJS.App.enableTouchInCocoonJS();");
            }
            else {
                // CocoonJS.App.removeTheDivToEnableInput();
            }
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
        else if (!navigator.isCocoonJS) {
            if (!CocoonJS.App.EmulatedWebViewIFrame) {
                CocoonJS.App.addADivToDisableInput();
            }
            else {
                CocoonJS.App.forwardAsync("CocoonJS && CocoonJS.App.disableTouchInTheWebView();");
            }
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
        else if (!navigator.isCocoonJS) {
            if (!CocoonJS.App.EmulatedWebViewIFrame) {
                CocoonJS.App.removeTheDivToEnableInput();
            }
            else {
                CocoonJS.App.forwardAsync("CocoonJS && CocoonJS.App.enableTouchInTheWebView();");
            }
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        // Control the parameters.
        if (!typeName) throw "The given typeName must be valid.";
        if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
        attributeNames = attributeNames ? attributeNames : [];
        functionNames = functionNames ? functionNames : [];
        eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

        // The parent object will be the window. It could be another object but careful, the destination side should know about this.
        // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
        var parentObject = window;

        // Setup the destination side too.
        var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
        CocoonJS.App.forward(jsCode);

        var originalType = parentObject[typeName];

        // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
        // internally calling to their counterparts in the destination environment.
        parentObject[typeName] = function () {
            var _this = this;

            // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
            this._cocoonjs_proxy_object_data = {};
            // The id is obtained calling to the destination side to create an instance of the type.
            var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
            this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
            // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
            // webview makes the corresponding calls.
            this._cocoonjs_proxy_object_data.eventHandlers = {};
            // Also store the typename inside each instance.
            this._cocoonjs_proxy_object_data.typeName = typeName;
            // A dictionary to store the event handlers
            this._cocoonjs_proxy_object_data.eventListeners = {};

            // TODO: eventHandlers and eventListeners should be in the same list ;)

            // Store all the proxy instances in a list that belongs to the type itself.
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

            // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
            for (var i = 0; i < attributeNames.length; i++) {
                (function (attributeName) {
                    _this.__defineSetter__(attributeName, function (value) {
                        var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                    _this.__defineGetter__(attributeName, function () {
                        var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                        return CocoonJS.App.forward(jsCode);
                    });
                })(attributeNames[i]);
            }

            // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
            for (var i = 0; i < functionNames.length; i++) {
                (function (functionName) {
                    _this[functionName] = function () {
                        // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                        var argumentsArray = Array.prototype.slice.call(arguments);
                        argumentsArray.unshift(functionName);
                        argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                        argumentsArray.unshift(typeName);
                        // Use the array to create the correct function call.
                        var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                        for (var i = 0; i < argumentsArray.length; i++) {
                            // The second argument (the id) should not be stringified
                            jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                        }
                        jsCode += ");";
                        // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                        // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                        var ret = CocoonJS.App.forwardAsync(jsCode);
                        return ret;
                    };
                })(functionNames[i]);
            }

            // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
            // array so they can be called when the destination environment makes the corresponding callback call.
            for (var i = 0; i < eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    _this.__defineSetter__(eventHandlerName, function (value) {
                        _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                    });
                    _this.__defineGetter__(eventHandlerName, function () {
                        return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                    });
                })(eventHandlerNames[i]);
            }

            // Setup the add and remove event listeners in the proxy object
            _this.addEventListener = function (eventTypeName, eventCallback) {
                var addEventCallback = true;
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    // As the eventListeners were already added, check that the same callback has not been added.
                    addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                }
                else {
                    // There are no event listeners, so add the one and add the listeners array for the specific event type name
                    eventListeners = [];
                    _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                    // Forward the call so the other end registers a event listener (only one is needed).
                    var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                }
                // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                if (addEventCallback) {
                    eventListeners.push(eventCallback);
                }
            };

            _this.removeEventListener = function (eventTypeName, eventCallback) {
                // Check for the eventListeners
                var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                if (eventListeners) {
                    var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                    if (eventCallbackIndex >= 0) {
                        eventListeners.splice(eventCallbackIndex, 1);
                    }
                }
            };

            // Return the proxy instance.
            return this;
        };

        // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            originalType:originalType,
            proxyObjects:[]
        };

        /**
         * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
         * This function should be manually called whenever a proxy instance won't be accessed anymore.
         * @param {object} object The proxy object to be deleted.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
            var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
            if (proxyObjectKey) {
                var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                CocoonJS.App.forwardAsync(jsCode);
                object._cocoonjs_proxy_object_data = null;
                delete this.proxyObjects[proxyObjectKey];
            }
        };

        /**
         * Calls a event handler for the given proxy object id and eventHandlerName.
         * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
         * @param {string} eventHandlerName The name of the handler to be called.
         * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
         * structure to the event passing the target (the proxy object).
         * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
         * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
         */
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
            var object = this.proxyObjects[id];
            var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
            if (eventHandler) {
                eventHandler({ target:object });
            }
        };

        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
            var object = this.proxyObjects[id];
            var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
            for (var i = 0; i < eventListeners.length; i++) {
                eventListeners[i]({ target:object });
            }
        };
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        var parentObject = window;
        if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        var parentObject = window;
        if (object && object._cocoonjs_proxy_object_data) {
            parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        var parentObject = window;
        parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        var parentObject = window;

        // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
        // and the names of all the event handlers and some utility functions.
        parentObject[typeName]._cocoonjs_proxy_type_data =
        {
            nextId:0,
            proxyObjects:{},
            eventHandlerNames:eventHandlerNames
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        var parentObject = window;
        if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
            delete parentObject[typeName]._cocoonjs_proxy_type_data;
        }
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        var parentObject = window;

        var proxyObject = new parentObject[typeName]();
        // Also store some additional information in the proxy object
        proxyObject._cocoonjs_proxy_object_data = {};
        // Like the type name, that could be useful late ;)
        proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
        // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
        var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
        // Store the created object in the structure defined in the setup of proxification with an id associated to it
        parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
        // Also store the id inside the proxy object itself
        proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
        // Calculate a new id for the next object.
        parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

        // Setup all the event handlers.
        for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
            (function (eventHandlerName) {
                proxyObject[eventHandlerName] = function (event) {
                    var proxyObject = this; // event.target;
                    // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                    var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                };
            })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
        }

        // Add the dictionary where the event listeners (callbacks) will be added.
        proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

        return proxyObjectId;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        var parentObject = window;
        var argumentsArray = Array.prototype.slice.call(arguments);
        argumentsArray.splice(0, 3);
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
        return result;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        proxyObject[attributeName] = attributeValue;
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        var parentObject = window;
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        return proxyObject[attributeName];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        var parentObject = window;
        delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
    };

    /**
     * @ignore
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        var parentObject = window;
        // Look for the proxy object
        var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

        var callback = function (event) {
            var proxyObject = this; // event.target;
            // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
            // TODO: Is there a way to retrieve the callbackId without a closure?
            var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
            CocoonJS.App.forwardAsync(jsCode);
        };

        proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

        // Finally add the event listener callback to the proxy object
        proxyObject.addEventListener(eventTypeName, callback);
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };

    /**
     *
     * @constructor
     */
    CocoonJS.App.WebDialog = function() {

        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            this.webDialogID = window.ext.IDTK_APP.makeCall("createWebDialog");
        }
        else {
            var iframe = document.createElement("iframe");
            iframe.id = "CocoonJSWebDialogIFrame";
            iframe.name = "CocoonJSWebDialogIFrame";
            iframe.style.cssText = "position:fixed;left:0;top:0;bottom:0;right:0; width:100%; height:100%;margin:0;padding:0;";
            var me = this;
            iframe.onload = function(){
                me.iframeloaded = true;
                var js = "CocoonJS = {}; CocoonJS.WebDialog = {}; CocoonJS.WebDialog.close = function()" +
                    "{" +
                    "   window.parent.CocoonJSCloseWebDialog();" +
                    "};";
                me.evalIframe(js);
                for (var i = 0; i < me.pendingEvals.length; ++i) {
                    me.evalIframe(me.pendingEvals[i]);
                }
                me.pendingEvals = [];
            }
            iframe.onerror = function(){
                me.close();
            }
            this.iframe = iframe;
            this.pendingEvals = [];

            window.CocoonJSCloseWebDialog = function() {
               me.close();
            }
        }

    }

    CocoonJS.App.WebDialog.prototype = {

        show: function(url, callback) {
            this.closeCallback = function() {
                CocoonJS.App.enableTouchInCocoonJS();
                if (callback)
                    callback();
            }
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                CocoonJS.App.disableTouchInCocoonJS();
                return window.ext.IDTK_APP.makeCallAsync("showWebDialog", this.webDialogID, url, this.closeCallback);
            }
            else {
                this.iframe.src = url;
                document.body.appendChild(this.iframe);
            }

        },
        close: function() {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("closeWebDialog", this.webDialogID);
            }
            else {
                if (this.iframe.parentNode) {
                    this.iframe.parentNode.removeChild(this.iframe);
                }
            }
            if (this.closeCallback)
                this.closeCallback();
        },
        evalIframe: function(js) {
            window.frames["CocoonJSWebDialogIFrame"].eval(js);
        },
        eval: function(js) {
            if (CocoonJS.App.nativeExtensionObjectAvailable) {
                return window.ext.IDTK_APP.makeCallAsync("evalWebDialog", this.webDialogID, js);
            }
            else {
                if (this.iframeloaded)
                    this.evalIframe(js);
                else
                    this.pendingEvals.push(js);
            }
        }

    };


    /**
    * Retrieves the preferred orientation that has been set in the system.
    * @return {number} The preferred orientation in the system as a combination of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.getPreferredOrientation = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getPreferredOrientation");
        }
        else {
            return 0;
        }
    };

    /**
    * Sets the preferred orientation in the system.
    * @param {number} preferredOrientation The preferred orientation to be set. A combinatio of the possible {@link CocoonJS.App.Orientations}
    */
    CocoonJS.App.setPreferredOrientation = function(preferredOrientation) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("setPreferredOrientation", preferredOrientation);
        }
    }

    /**
    * Queries if a file exists in the specified path and storage type. If none or unknown storage type is specified, the TEMPORARY_STORAGE is used as default.
    * @param {string} path The relative path to look for inside the storage of the underlying system.
    * @param {CocoonJS.App.StorageType} storageType The storage type where to look for the specified path inside the system.
    */
    CocoonJS.App.existsPath = function(path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("existsPath", path, storageType);
        }
        return false;
    }

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspending.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspending = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspending");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();
;(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

    function checkEmulatedWebViewReady() {
        var emulatedWB = CocoonJS.App.EmulatedWebView;
        if (emulatedWB) {
            return; //ready
        }

        emulatedWB = document.createElement('div'); 
        emulatedWB.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
        emulatedWB.style.width = 0; 
        emulatedWB.style.height = 0; 
        emulatedWB.style.position = "absolute"; 
        emulatedWB.style.left = 0; 
        emulatedWB.style.top = 0;
        emulatedWB.style.backgroundColor = 'transparent';
        emulatedWB.style.border = "0px solid #000"; 

        var frame = document.createElement("IFRAME");
        frame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
        frame.style.width = 0; 
        frame.style.height = 0; 
        frame.frameBorder = 0;
        frame.allowtransparency = true;

        emulatedWB.appendChild(frame);
        CocoonJS.App.EmulatedWebView = emulatedWB;
        CocoonJS.App.EmulatedWebViewIFrame = frame;

        if(!document.body) {
            document.body = document.createElement("body");
        }
        document.body.appendChild(CocoonJS.App.EmulatedWebView);
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (navigator.isCocoonJS && CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadInTheWebView", arguments)
        }
        else
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if ((xhr.status >= 200 && xhr.status <=299) || xhr.status === 0)
                    {

                        checkEmulatedWebViewReady();
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reloadWebView", arguments);
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable && navigator.isCocoonJS)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTheWebView", arguments)
        }
        else
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width/window.devicePixelRatio : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height/window.devicePixelRatio : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";

            console.log(CocoonJS.App.EmulatedWebViewIFrame.style.cssText);
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            checkEmulatedWebViewReady();
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * Setups the internal text texture cache size.
     * The CocoonJS Canvas+ environment is very inefficient when it comes to drawing texts.
     * In order to improve the performance, a text texture cache is used internally. Once a text is drawn
     * a texture is stored that matches that text and that text configuration. If the same text is called to 
     * be drawn, this cached texture would be used. 
     * This function allows to set the size of the cache. A value of 0 would mean that no cache
     * will be used. 
     * @param size The size of the text cache.
     */
    CocoonJS.App.setTextCacheSize = function (size) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setTextCacheSize", arguments);
        }
    }

    CocoonJS.App.forwardedEventFromTheWebView = function(eventName, eventDataString) {
        var eventData = JSON.parse(eventDataString);
        eventData.target = window;
        var event = new Event(eventName);
        for (var att in eventData) {
            event[att] = eventData[att];
        }
        event.target = window;
        window.dispatchEvent(event);
        var canvases = document.getElementsByTagName("canvas");
        for (var i = 0; i < canvases.length; i++) {
            event.target = canvases[i];
            canvases[i].dispatchEvent(event);
        }
    }

    
})();
;(function(){
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");
    if (navigator.isCocoonJS) return;

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.App.nativeExtensionObjectAvailable;

    /**
    * Shows a transparent WebView on top of the CocoonJS hardware accelerated environment rendering context.
    * @function
    * @param {number} [x] The horizontal position where to show the WebView.
    * @param {number} [y] The vertical position where to show the WebView.
    * @param {number} [width] The horitonzal size of the WebView.
    * @param {number} [height] the vertical size of the WebView.
    */
    CocoonJS.App.show = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "show", arguments);
        }
        else
        {
            var div = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv');
            div.style.left = (x ? x : div.style.left)+'px';
            div.style.top = (y ? y : div.style.top)+'px';
            div.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            div.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
            div.style.display = "block";
            var iframe = window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewIFrame');
            iframe.style.width = (width ? width/window.devicePixelRatio : window.parent.innerWidth)+'px';
            iframe.style.height = (height ? height/window.devicePixelRatio : window.parent.innerHeight)+'px';
        }
    };

    /**
    * Hides the transparent WebView on top of the CocoonJS hardware acceleration environment rendering contect.
    * @function
    */
    CocoonJS.App.hide = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "hide", arguments);
        }
        else
        {
            window.parent.document.getElementById('CocoonJS_App_ForCocoonJS_WebViewDiv').style.display = "none";
        }
    };

    /**
    * Loads a resource in the CocoonJS environment from the CocoonJS environment. 
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    */
    CocoonJS.App.loadInCocoonJS = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else
        {
            CocoonJS.App.forwardAsync("CocoonJS.App.load('" + path + "');");
        }
    };

    /**
     * Reloads the last loaded path in the CocoonJS context.
     * @function
     */
    CocoonJS.App.reloadCocoonJS = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            window.parent.location.reload();
        }
    };

    /**
    * This function allows to forward console messages from the WebView to the CocoonJS
    * debug console. What it does is to change the console object for a new one
    * with all it's methods (log, error, info, debug and warn) forwarding their
    * messages to the CocoonJS environment.
    * The original console object is stored in the CocoonJS.App.originalConsole property.
    * @function
    */
    CocoonJS.App.proxifyConsole = function() 
    {
        if (!CocoonJS.nativeExtensionObjectAvailable) return;

        if (typeof CocoonJS.App.originalConsole === 'undefined')
        {
            CocoonJS.App.originalConsole = window.console;
        }
        var functions = ["log", "error", "info", "debug", "warn"];

        var newConsole = {};
        for (var i = 0; i < functions.length; i++)
        {
            newConsole[functions[i]] = function(functionName)
            {
                return function(message)
                {
                    var jsCode = "console." + functionName + "(" + JSON.stringify(message) + ");";
                    CocoonJS.App.originalConsole.log(jsCode);
                    ext.IDTK_APP.makeCallAsync("forward", jsCode);
                };
            }(functions[i]);
        }
        if (!newConsole.assert) {
            newConsole.assert = function assert() {
                if (arguments.length > 0 && !arguments[0]) {
                    var str = 'Assertion failed: ' + (arguments.length > 1 ? arguments[1] : '');
                    newConsole.error(str);
                }
            }
        }        
        window.console = newConsole;
    };

    /**
    * This function restores the original console object and removes the proxified console object.
    * @function
    */
    CocoonJS.App.deproxifyConsole = function()
    {
        if (window.navigator.isCocoonJS || !CocoonJS.nativeExtensionObjectAvailable) return;
        if (typeof CocoonJS.App.originalConsole !== 'undefined')
        {
            window.console = CocoonJS.App.originalConsole;
            CocoonJS.App.originalConsole = undefined;
        }
    };

    /**
    * Everytime the page is loaded, proxify the console.
    * @ignore
    */
    window.addEventListener("load", function()
    {
        CocoonJS.App.proxifyConsole();

        // Only if we are completely outside CocoonJS (or CocoonJS' webview),
        // setup event forwarding from the webview (iframe) to CocoonJS.
        if (!CocoonJS.App.nativeExtensionObjectAvailable) {
            CocoonJS.App.forwardEventsToCocoonJSEnabled = true;
            var EVENT_ATTRIBUTES = [ 'timeStamp', 'button', 'type', 'x', 'y', 'pageX', 'pageY', 'clientX', 'clientY', 'offsetX', 'offsetY'];
            var EVENTS = [ "dblclick", "touchmove", "mousemove", "touchend", "touchcancel", "mouseup", "touchstart", "mousedown", "release", "dragleft", "dragright", "swipeleft", "swiperight" ];
            function forwardEventToCocoonJS(eventName, event) {
                var eventData = {};
                var att, i;
                for (var att in event) {
                    i = EVENT_ATTRIBUTES.indexOf(att);
                    if (i >= 0) {
                        eventData[att] = event[att];
                    }
                }
                var jsCode = "CocoonJS && CocoonJS.App && CocoonJS.App.forwardedEventFromTheWebView && CocoonJS.App.forwardedEventFromTheWebView(" + JSON.stringify(eventName) + ", '" + JSON.stringify(eventData) + "');";
                CocoonJS.App.forward(jsCode);
            }
            for (i = 0; i < EVENTS.length; i++) {
                window.addEventListener(EVENTS[i], (function(eventName) {
                    return function(event) {
                        if (CocoonJS.App.forwardEventsToCocoonJSEnabled) {
                            forwardEventToCocoonJS(eventName, event);
                        }
                    };
                })(EVENTS[i]));
            }
        }

    });

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSSucceed} event calls.
     * @name OnLoadInCocoonJSSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInCocoonJSSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInCocoonJSFailed} event calls.
     * @name OnLoadInCocoonJSFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in CocoonJS.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the CocoonJS load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInCocoonJSFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInCocoonJSFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * @namespace
     */
    CocoonJS.Social = {};

    /**
     * This class provides an abstraction API for all the Social Services
     * Each Social service has it's own official API but can also be used within this API interface
     * @class
     */
    CocoonJS.Social.SocialService = function() {
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login status changes
         * The callback parameters: loggedIn status (boolean) and error
         * @memberOf CocoonJS.Social.SocialService
         */
        this.onLoginStatusChanged = new CocoonJS.EventHandler("", "dummy", "onLoginStatusChanged");

        return this;
    }

    CocoonJS.Social.SocialService.prototype = {

        /**
         * Check if the user is logged in.
         * @return {boolean} true if the user is still logged in, false otherwise.
         */
        isLoggedIn: function() {
             return false;
        },

        /**
         * Authenticate the user
         * @param {function} callback. The callback function. Response params: loggedIn(boolean) and error
         */
        login : function(callback) {
            if (callback)
                callback(false, {message:"Not implemented!"});
        },

        /**
         * Log the user out of your application.
         * @param {function} [callback] The callback function. Response params: error
         */
        logout: function(callback) {
            if (callback)
                callback({message:"Not implemented!"});
        },

        /**
         * Returns the information of the currently logged in user.
         * @return {@link CocoonJS.Social.User}
         */
        getLoggedInUser : function() {
            return null;
        },

        /**
         * Checks if the current logged in user has publish permissions
         * @param callback The callback function. Response params: permissions granted and error
         */
        hasPublishPermissions: function(callback) {
            callback(true);
        },

        /**
         * Requests publish permissions for the current logged in user
         * @param callback The callback function. Response params: granted and error
         */
        requestPublishPermissions: function(callback) {
            if (callback)
                callback(true, null);
        },
        /**
         * Retrieves user information for a specific user ID.
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestUser: function(callback, userID) {
            callback(null, {message:"Not implemented!"});
        },
        /**
         * Request to retrieve the profile image of a user
         * @param {function} callback The callback function. Response params: ImageURL and error.
         * @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
         * @param {CocoonJS.Social.ImageSize} [imageSize] The desired size of the image. Default value: SMALL.
         */
        requestUserImage : function(callback, userID, imageSize) {
            callback("", {message:"Not implemented!"})
        },

        /**
         * Retrieves user friends for a specific user ID.
         * @param {function} callback The callback function. Response params: Array of {@link CocoonJS.Social.User} and error.
         * @param {string} [userID] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestFriends: function(callback, userID) {
            callback([], {message:"Not implemented!"});
        },

        /**
         * Shares a message without the intervention of the user
         * This action might require publish permissions. If the user has not publish permissions they are automatically requested.
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessage: function(message, callback) {
            callback({message:"Not implemented!"});
        },

        /**
         * Presents a native/web dialog that allows the user to share a message
         * @param {CocoonJS.Social.Message} message A object representing the information to be published.
         * @param {function} [callback] The callback function. Response params: error
         */
        publishMessageWithDialog: function(message, callback) {
            callback({message:"Not implemented!"});
        }
    }


    /**
     * This class extends the Social Service API with an extended Social Gaming abstraction API (achievements, leaderboards, etc.)
     * @class
     */
    CocoonJS.Social.SocialGamingService = function() {
        CocoonJS.Social.SocialGamingService.superclass.constructor.call(this);
        return this;
    }

    CocoonJS.Social.SocialGamingService.prototype = {

        _cachedAchievements: null,
        _achievementsMap: null,
        _leaderboardsTemplate: null,
        _achievementsTemplate: null,

        /**
         * Retrieves the score for a user from a specific leaderboard
         * @param {function} callback The callback function. Response params: {@link CocoonJS.Social.Score} and error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to retrieve the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        requestScore: function(callback, params) {
            callback(null, {message:"Not implemented!"})
        },

        /**
         * Submits the score for a user to a specific leaderboard
         * @param {number} score the score to submit
         * @param {function} [callback] The callback function. Response params: error.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to submit the score. If no params are specified, the currently logged in user and the default leaderboard are assumed.
         */
        submitScore: function(score, callback, params ) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Shows a modal leaderboard view using a platform dependant view.
         * @param {CocoonJS.Social.ScoreParams} [params] The params to choose the leaderboard and other settings. If no params are specified the default leaderboard id and settings will be assumed.
         * @param {function} [callback] The callback function invoked when the modal leaderboard view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showLeaderboard : function(callback, params) {
            if (callback)
                callback({message:"Not implemented!"})
        },

        /**
         * Retrieves all the achievements of the application.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         */
        requestAllAchievements : function(callback) {
            callback([], {message:"Not implemented!"})
        },

        /**
         * Retrieves the achievements earned by a user.
         * @param {function} callback The callback function. Response params: array of {@link CocoonJS.Social.Achievement} and error.
         * @param {string} [userId] The id of the user to retrieve the information from. If no userID is specified, the currently logged in user is assumed.
         */
        requestAchievements : function(callback, userID) {
            callback([], {message:"Not implemented!"})
        },
        /**
         * Submits the achievement for the current logged In user
         * @param achievementID The achievement ID to submit
         * @param callback [callback] The callback function. Response params: error.
         */
        submitAchievement: function(achievementID, callback) {
            if (callback)
                callback({message:"Not implemented!"})
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (callback)
                callback([], {message:"Not implemented!"})
        },
        /**
         * Shows a modal achievements view using a platform dependant view.
         * @param {function} [callback] The callback function invoked when the modal achievements view is closed by the user. Response params: error.
         * @see setTemplates
         */
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        },

        /**
         * Set the map for using custom achievement IDs.
         * The map must be a customID to realID map (accessing map.customID must return the real achievement ID)
         * Whenever this map is enabled users are able to submit achievements with the real achievement ID or with the custom one.
         * @params {object} map The achievements map. A null map disables this feature.
         */
        setAchievementsMap: function(map) {
            this._achievementsMap = map;
            if (this._cachedAchievements) {
               this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * Provides some templates to be used in the leaderboards and achievements views
         * Some social services (like Facebook) don't have a native view to show achievements or leaderboards views, and use html templates instead
         * @param {string} leaderboardsTemplate relative path to the leaderboards template
         * @param {string} achievementsTemplate relative path to the achievements template
         * @see showAchievements
         * @see showLeaderboard
         */
        setTemplates: function(leaderboardsTemplate, achievementsTemplate) {
            this._leaderboardsTemplate = leaderboardsTemplate;
            this._achievementsTemplate = achievementsTemplate;
        },

        //Internal utility methods

        /**
         * @ignore
         */
        setCachedAchievements: function(achievements) {
            this._cachedAchievements = achievements;
            if (achievements && this._achievementsMap) {
                this.syncAchievementsMap(this._cachedAchievements);
            }
        },

        /**
         * @ignore
         */
        findAchievement: function(id) {
            if (!this._cachedAchievements)
                return null;
            for (var i = 0; i < this._cachedAchievements.length; ++i) {
                if (id === this._cachedAchievements[i].achievementID) {
                    return this._cachedAchievements[i];
                }
            }
            return null;
        },

        /**
         * @ignore
         */
        translateAchievementID: function(id) {
            if (this._achievementsMap) {
                for (var customID in this._achievementsMap) {
                    if (customID == id) { //important: compare with double equal, because id can be numeric
                        return this._achievementsMap[customID];
                    }
                }
            }
            return id;
        },
        /**
         * @ignore
         * @param {array} achievements array of achievements
         */
        syncAchievementsMap: function(achievements) {
            if (!this._achievementsMap)
                return;
            for (var i = 0; i< achievements.length; ++i) {
                for (var customID in this._achievementsMap) {
                     if (this._achievementsMap[customID] === achievements[i].achievementID) {
                         achievements[i].customID = customID;
                     }
                }
            }

        }
    }

    /**
     * @ignore
     */
    CocoonJS.extend(CocoonJS.Social.SocialGamingService, CocoonJS.Social.SocialService);


    /**
     * This enumeration represents the possible images to be obtained for a user in the social gaming extension.
     * @namespace
     * @enum
     */
    CocoonJS.Social.ImageSize =
    {
        /**
         * Represent a thumbnail like image size.
         */
        THUMB : "thumb",
        /**
         * Represents the small image size.
         */
        SMALL : "small",
        /**
         * Represents the medium image size.
         */
        MEDIUM : "medium",
        /**
         * Represents the large image size.
         */
        LARGE : "large"
    };


    /**
     * The data structure that represents the information of a user inside the social gaming extension.
     * @class
     * @constructor
     * @param {string} userID The id of the user.
     * @param {string} userName The user name of the user.
     */
    CocoonJS.Social.User = function(userID, userName, userImage)
    {
        /**
         * The id of the user.
         * @field
         * @type string
         */
        this.userID = userID;
        /**
         * The user name of the user.
         * @field
         * @type string
         */
        this.userName = userName;

        /**
         * The user image URL
         * If the image URL is not provided by default fetch it using requestUserImage method.
         * @field
         * @type {string}
         */
        this.userImage = userImage;

        return this;
    };

    /**
     * This type represents a message to be published.
     * @class
     * @constructor
     * @param {string} message The message to be published.
     * @param {string} mediaURL An URL to a media (image, video, ...)
     * @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
     * @param {string} linkText The text that will appear in the message link.
     * @param {string} linkCaption The text caption that will appear in the message link.
     */
    CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
    {
        /**
         * The message to be published.
         * @field
         * @type string
         */
        this.message = message;
        /**
         * An URL to a media (image, video, ...)
         * @field
         * @type string
         */
        this.mediaURL = mediaURL;
        /**
         * An URL to add to the message so the user can click on that link to get more information.
         * @field
         * @type string
         */
        this.linkURL = linkURL;
        /**
         * The text that will appear in the message link.
         * @field
         * @type string
         */
        this.linkText = linkText;
        /**
         * The text caption that will appear in the message link.
         * @field
         * @type string
         */
        this.linkCaption = linkCaption;

        return this;
    };


    /**
     * The data structure that represents the information of the user score in the application.
     * @class
     * @constructor
     * @param {string} userID The user id.
     * @param {number} score The score of the user.
     * @param {string} userName The name of the user.
     * @param {string} imageURL The url of the user image.
     * @param {number} leaderboardID The id of the leaderboard the score belongs to.
     */
    CocoonJS.Social.Score = function(userID, score, userName, imageURL, leaderboardID)
    {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The score of the user.
         * @type number
         */
        this.score = score || 0;
        /**
         * The name of the user.
         * @type string
         */
        this.userName = userName;
        /**
         * The url of the user image.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The id of the leaderboard the score belongs to.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        return this;
    };

    /**
     * The data structure that represents params to retrieve or submit scores
     * @class
     * @constructor
     * @param {string} userID The user id. If no userID is specified the current logged in user is assumed.
     * @param {string} leaderboardID The leaderboard ID. If no leaderboard is specified the default leaderboard is assumed.
     * @param {boolean} [friendScope = false] If enabled the query will get only scores from friends in the social network
     * @param {CocoonJS.Social.TimeScope} [timeScope=0] The time scope for the scores.
     */
    CocoonJS.Social.ScoreParams = function(userID, leaderboardID, friends, timeScope) {
        /**
         * The user id.
         * @type string
         */
        this.userID = userID;
        /**
         * The id of the leaderboard.
         * @type string
         */
        this.leaderboardID = leaderboardID;

        /**
         * Friends scope
         * @type {boolean}
         */
        this.friends = !!friends;

        /**
         * The time scope
         * @type {number}
         */
        this.timeScope = timeScope || 2;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.TimeScope =
    {
        ALL_TIME: 0,
        WEEK: 1,
        TODAY:2
    };

    /**
     * The data structure that represents the information of an achievement in the application.
     * @class
     * @constructor
     * @param {string} achievementID The id of the achievement info.
     * @param {string} title The title of the achievement.
     * @param {string} description The description of the achievement.
     * @param {string} imageURL The url to the image representing the achievement.
     * @param {number} points The points value of the achievement
     */
    CocoonJS.Social.Achievement = function(achievementID, title, description, imageURL, points)
    {
        /**
         * The id of the achievement.
         * @type string
         */
        this.achievementID = achievementID;
        /**
         * The optional custom id of the achievement defined by the user.
         * @type string
         */
        this.customID = achievementID;
        /**
         * The title of the achievement.
         * @type string
         */
        this.title = title;
        /**
         * The description of the achievement.
         * @type string
         */
        this.description = description;
        /**
         * The url to the image representing the achievement.
         * @type string
         */
        this.imageURL = imageURL;
        /**
         * The points value of the achievement
         * @type number
         */
        this.points = points || 0;

        return this;
    };

})();(function(){

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original GameCenter API (somehow ;)) with the addition of the possibility to 
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei) and multiplayer support.
     */
    CocoonJS.Social.GameCenterExtension = function() {
        this.nativeExtensionName = "IDTK_SRV_GAMECENTER";
        this.extensionName = "Social.GameCenter";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        var me = this;
        if (this.nativeExtensionObjectAvailable) {
            this.onGameCenterLoginStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onGameCenterLoginStateChanged");

            this.onGameCenterLoginStateChanged.addEventListener(function(localPlayer,error){
                me._currentPlayer = localPlayer;
            });
        }
        return this;
    };

    CocoonJS.Social.GameCenterExtension.prototype = {

        _currentPlayer: null,

        /**
         * Return a CocoonJS SocialGaming interface for the Game Center Extension
         * You can use the Game Center extension in two ways, with 1:1 official API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceGameCenter(this);
            }
            return this._socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GameCenter;
        },

        isLoggedIn: function() {
            return this._currentPlayer && this._currentPlayer.isAuthenticated;
        },

        /**
         * Authenticate the user
         * @params {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.LocalPlayer and error.
         */
        login: function(callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [function(response, error) {
                    me._currentPlayer = response;
                    if (callback) {
                        callback(response,error);
                    }
                }], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Synchronous accessor for the current authResponse
         * @returns {CocoonJS.Social.GameCenter.LocalPlayer} current Local Player data
         */
        getLocalPlayer: function() {
            if (this._currentPlayer)
                return this._currentPlayer;
            if (this.nativeExtensionObjectAvailable) {
                this._currentPlayer = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayer", []);
                return this._currentPlayer;
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the players for the provided identifiers.
         * @param {array} playerIDs Array of player identifiers
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadPlayers: function(playerIDs, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadPlayers", [playerIDs, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the friends for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Player array and error
         */
        loadFriends: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadFriends", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the earned achievements for the current logged in user.
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Achievements array and error
         */
        loadAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.AchievementDescription array and error
         */
        loadAchievementDescriptions: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadAchievementDescriptions", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Load the application achievement descriptions
         * @param {function} callback The callback function. Response params: CocoonJS.Social.GameCenter.Leaderboard object and error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional query parameters
         */
        loadScores: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "loadScores", [query,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user score to the server
         * @param {CocoonJS.Social.GameCenter.Score} score definition of the score and it's category (leaderboardID).
         * If no category is specified the default one is used.
         * @param {function} callback The callback function. Response params: error
         */
        submitScore: function(score, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitScore", [score,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Report user earned achievements to the server
         * @param {array} achievements Array of CocoonJS.Social.GameCenter.Achievement objects
         * @param {function} callback The callback function. Response params: error
         */
        submitAchievements: function(achievements, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitAchievements", [achievements,callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Resets all the achievements of the current logged in user
         * @param {function} [callback] The callback function. Response params: error.
         */
        resetAchievements : function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for achievements
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         */
        showAchievements: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                throw "Game Center not available";
            }
        },
        /**
         * Shows a native view with the standard user interface for leaderboards
         * @param {function} callback The callback function when the view is closed by the user. Response params: error
         * @param {CocoonJS.Social.GameCenter.Leaderboard} [query] Optional parameters
         */
        showLeaderboards: function(callback, query) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboards", [query, callback], true);
            }
            else {
                throw "Game Center not available";
            }
        }
    };

    /**
     * @namespace
     * This is the global variable that enables access to the GameCenter API mimic and the high level abstract API
     * to handle Social and Multiplayer aspects created by Ludei.
     * @see CocoonJS.Social.GameCenterExtension
     */
    CocoonJS.Social.GameCenter = new CocoonJS.Social.GameCenterExtension();

    /**
     * @class
     * The data structure that represents the information of a Game Center player (Readonly)
     */
    CocoonJS.Social.GameCenter.Player = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * True if the user is friend of the local player
         * @type boolean
         */
        this.isFriend = false;
    }

    /**
     * @class
     * The data structure that represents the information of the Game Center Local Player (Readonly)
     */
    CocoonJS.Social.GameCenter.LocalPlayer = function() {
        /**
         * The identifier of the player.
         * @type string
         */
        this.playerID = "";
        /**
         * The alias of the player.
         * @type string
         */
        this.alias = "";
        /**
         * Indicates the authentication state of the current player
         * @type boolean
         */
        this.isAuthenticated = false;
    }

    /**
     * The data structure that represents an earned achievement by the user
     * @class
     * @constructor
     * @param {string} identifier The id of the achievement.
     * @param {number} [percentComplete] The percentage on which the achievement has been completed. 100% by default.
     */
    CocoonJS.Social.GameCenter.Achievement = function(identifier, percentComplete) {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = identifier;
        /**
         * Percentage of achievement complete (from 0 to 100)
         * @type number
         */
        this.percentComplete = percentComplete;
        /**
         *  Date the achievement was last reported (unix time)
         * @type number
         */
        this.lastReportedDate = 0;
    }

    /**
     * @class
     * The data structure that represents achievements defined by the application (Readonly)
     */
    CocoonJS.Social.GameCenter.AchievementDescription = function() {
        /**
         * The identifier of the achievement.
         * @type string
         */
        this.identifier = "";
        /**
         * The title of the achievement
         * @type string
         */
        this.title = "";
        /**
         * The description for an achieved achievement
         * @type string
         */
        this.achievedDescription = "";
        /**
         * The description for an unachieved achievement.
         * @type string
         */
        this.achievedDescription = "";

        /**
         * The maximum points of the achievement
         * @type number
         */
        this.maximumPoints = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that a score in the leaderboards
     * @param {number} value The value of the score.
     * @param {string} category The category where the score is associated.
     */
    CocoonJS.Social.GameCenter.Score = function(value,category) {
        /**
         * The score value as a 64bit integer.
         * @type number
         */
        this.value = value;
        /**
         * Leaderboard category
         * @type string
         */
        this.category = category;
        /**
         * The identifier of the player that recorded the score
         * @type string
         */
        this.playerID = "";
        /**
         * The rank of the player within the leaderboard
         * @type number
         */
        this.rank = 0;
    }

    /**
     * @class
     * @constructor
     * The data structure that represents the set of high scores for the current game
     * @param {string} category The category of the leaderboard.
     * @param {array} payerIDs
     * @param {CocoonJS.Social.GameCenter.TimeScope} timeScope
     * @param {CocoonJS.Social.GameCenter.PayerScope} payerScope
     * @param {number} rangeStart
     * @param {number} rangeLength
     */
    CocoonJS.Social.GameCenter.Leaderboard = function(category, playerIDs, timeScope, playerScope, rangeStart, rangeLength) {
        /**
         * leaderboard category (query parameter)
         * @type string
         */
        this.category = category;
        /**
         * Player identifiers array (query parameter)
         * @type string
         */
        this.playerIDs = category;
        /**
         * Time scope (query parameter)
         * @type CocoonJS.Social.GameCenter.TimeScope
         */
        this.timeScope = timeScope;
        /**
         * Player scope (query parameter)
         * @type CocoonJS.Social.GameCenter.PlayerScope
         */
        this.playerScope = playerScope;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeStart = rangeStart;
        /**
         * Leaderboards start at index 1 and the length should be less than 100 (query parameter)
         * @type number
         */
        this.rangeLength = rangeLength;
        /**
         * Scores array (response parameter)
         * @type Array of CocoonJS.Social.GameCenter.Score
         */
        this.scores = [];
        /**
         * Local player score (response parameter)
         * @type CocoonJS.Social.GameCenter.Score
         */
        this.localPlayerScore = [];
        /**
         * Localized category title
         * @type string
         */
        this.localizedTitle = localizedTitle;
    }

    /**
     * @enum
     * This enumeration represents the possible Time Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.TimeScope =
    {
        TODAY: 0,
        WEEK: 1,
        ALL_TIME:2
    };

    /**
     * @enum
     * This enumeration represents the possible Player Scopes for a leaderboad query.
     */
    CocoonJS.Social.GameCenter.PlayerScope =
    {
        GLOBAL: 0,
        FRIENDS: 1
    };


    //Social API Interface
    CocoonJS.Social.SocialGamingServiceGameCenter = function(gcExtension) {
        CocoonJS.Social.SocialGamingServiceGameCenter.superclass.constructor.call(this);
        this.gc = gcExtension;
        var me = this;
        this.gc.onGameCenterLoginStateChanged.addEventListener(function(localPlayer, error){
            me.onLoginStatusChanged.notifyEventListeners(localPlayer.isAuthenticated,error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceGameCenter.prototype =  {

        _cachedAchievements: null,

        isLoggedIn: function() {
            return this.gc.isLoggedIn();
        },
        login : function(callback) {
            this.gc.login(function(localPlayer, error){
                if (callback)
                    callback(localPlayer.isAuthenticated, error);
            });
        },
        logout: function(callback) {
            if (callback)
                callback({message:"User has to logout from the Game Center APP"});
        },
        getLoggedInUser : function() {
            return fromGCPLayerToCocoonUser(this.gc._currentPlayer ? this.gc._currentPlayer : this.gc.getLocalPlayer());
        },

        requestUser: function(callback, userId) {
            if (userId) {
                this.gc.loadPlayers([userId], function(response, error) {
                    var user = response && response.length ? fromGCPLayerToCocoonUser(response[0]) : null;
                    callback(user, error);
                });
            }
            else {
                var me = this;
                setTimeout(function(){
                    callback(me.getLoggedInUser());
                })
            }
        },
        requestFriends: function(callback, userId) {
            this.gc.loadFriends(function(friends, error){
                var users = [];
                if (friends && friends.length) {
                    for (var i= 0; i< friends.length; ++i) {
                        users.push(fromGCPLayerToCocoonUser(friends[i]));
                    }
                }
                callback(users, error);
            });
        },
        requestScore: function(callback, params) {
            var query = {};
            var options = params || {};
            if (options.leaderboardID)
                query.category = options.leaderboardID;
            query.playerIDs = [options.userID || this.getLoggedInUser().userID];

            this.gc.loadScores(function(response, error) {
                var gcScore = null;
                if (options.userID && response && response.scores && response.scores.length)
                    gcScore = response.scores[0];
                else if (response && response.localPlayerScore)
                    gcScore = response.localPlayerScore;
                var loadedScore = gcScore ? new CocoonJS.Social.Score(gcScore.playerID, gcScore.value, "","", gcScore.category) : null;
                callback(loadedScore,error);
            }, query);
        },

        submitScore: function(score, callback, params) {
            var options = params || {};
            this.gc.submitScore({value:score, category:options.leaderboardID || ""}, function(error){
                if (callback)
                    callback(error);
            });
        },

        showLeaderboard : function(callback, params) {
            var options = params || {};
            this.gc.showLeaderboards(function(error){
                if (callback)
                    callback(error);
            }, {category:options.leaderboardID || ""});
        },
        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gc.loadAchievementDescriptions(function(response, error){
                    if (error) {
                        callback([],error);
                    }
                    else {
                       var achievements = [];
                       if (response && response.length) {
                           for (var i = 0; i < response.length; i++) {
                               achievements.push(fromGCAchievementDescriptionToCocoonAchievement(response[i]))
                           }
                       }
                       me.setCachedAchievements(achievements);
                       callback(achievements, null);
                    }

                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                me.gc.loadAchievements(function(response, error){
                    if (!error) {
                        var achievements = [];
                        if (response && response.length) {
                            for (var i = 0; i < response.length; i++) {
                                var ach = me.findAchievement(response[i].identifier);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }

                });
            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            this.gc.submitAchievements([{identifier:achID, percentComplete:100}], callback);
        },
        resetAchievements : function(callback) {
            this.gc.resetAchievements(callback);
        },
        showAchievements : function(callback) {
            this.gc.showAchievements(function(error){
                if (callback)
                    callback(error);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGameCenter, CocoonJS.Social.SocialGamingService);

    /**
     * @ignore
     */
    function fromGCPLayerToCocoonUser(player){
        return new CocoonJS.Social.User(player.playerID, player.alias);
    }
    /**
     * @ignore
     */
    function fromGCAchievementDescriptionToCocoonAchievement(ach) {
        return new CocoonJS.Social.Achievement(ach.identifier,ach.title, ach.achievedDescription,"", ach.maximumPoints);
    }
})();
;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (!window.CocoonJS.Social) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /**
     * @class
     * @constructor
     * Represents a type that mimics the original Google Play Games API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     * Original Google Play Games API: https://developers.google.com/api-client-library/javascript/referencedocs/
     */
    CocoonJS.Social.GooglePlayGamesExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_GOOGLE_PLAY_GAMES";
        this.extensionName = "Social.GooglePlayGames";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';

        this.auth = new CocoonJS.Social.GooglePlayGamesAuthExtension(this);
        this.client = new CocoonJS.Social.GooglePlayGamesClientExtension(this);
        this.defaultScopes = ["https://www.googleapis.com/auth/games","https://www.googleapis.com/auth/plus.login"];
        this.gamesAPI = "/games/v1";
        this.plusAPI = "/plus/v1";

        this.onSessionChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSessionChanged");

        CocoonJS.Social.GooglePlayGames = this; //the object it's being created but the addEventListener needs it now
        var me = this;
        this.onSessionChanged.addEventListener(function(session, error) {
            me.token = fromSessionToAuthTokenObject(session,error);
            if (session && session.access_token) {
                //fetch user data
                me.client.request({path: me.gamesAPI + "/players/me", callback: function(response) {
                    me.currentPlayer = response;
                }});
            }
        });

        return this;
    };

    CocoonJS.Social.GooglePlayGamesExtension.prototype = {

        token: null,
        settings: {},
        socialService: null,
        currentPlayer: null,
        initialized: false,

        auth: null,
        client: null,

        /**
         * Initializes the service and tries to restore the last session
         * @param {Object} params Initialization options
         * params.clientId {string} The application clientID. Omit if its already provided in the native application via cloud configuration.
         * params.defaultLeaderboard {string} The default leaderboard ID. You can omit it if you specify the leaderboardID in all the score queries or submits
         * params.showAchievementNotifications {boolean} Enable or disable the native view notifications when an achievement is unlocked.
         */
        init: function(params) {
            if (!params || typeof params !== 'object')
                throw "Invalid params argument";
            this.settings = params;
            this.initialized = true;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [this.settings.clientId], true);
            }
            else {

                var me = this;
                var initWebAPi = function() {
                    gapi.auth.authorize({immediate: true, scope: me.defaultScopes, client_id:me.settings.clientId},function(response) {
                        me.token = response;
                        if (response && response.access_token) {
                            me.onSessionChanged.notifyEventListeners(response);
                        }
                    })
                }

                if (!window.gapi) {
                    window.onGapiLoadCallback = function() {
                        //initialization timeout recommended by google to avoid some race conditions
                        window.setTimeout(initWebAPi, 1);
                    }
                    var script = document.createElement("script");
                    script.src = "https://apis.google.com/js/client.js?onload=onGapiLoadCallback";
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    initWebAPi();
                }
            }
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Google Play Games Extension
         * You can use the Google Play Games extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this.initialized) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this.socialService) {
                this.socialService = new CocoonJS.Social.SocialGamingServiceGooglePlayGames(this);
            }
            return this.socialService;
        },

        /**
         * Return a CocoonJS Multiplayer interface for the Game Center Extension
         * @returns {CocoonJS.Multiplayer.MultiplayerService}
         */
        getMultiplayerInterface: function() {
            return CocoonJS.Multiplayer.GooglePlayGames;
        },

        share: function() {


            window.open(this.href,'', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,height=600,width=600');return false;

        }

    };

    CocoonJS.Social.GooglePlayGamesAuthExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesAuthExtension.prototype = {
        /**
         * Initiates the OAuth 2.0 authorization process.
         * The browser displays a popup window prompting the user authenticate and authorize.
         * After the user authorizes, the popup closes and the callback function fires.
         * @param {object} A key/value map of parameters for the request (client_id, inmediate, response_type, scope)
         * @param {function} callback The function to call once the login process is complete. The function takes an OAuth 2.0 token object as its only parameter.
         */
        authorize: function(params, callback) {
            var me = this;
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "authorize", [params, function(response, error) {
                    me.extension.token = fromSessionToAuthTokenObject(response,error);
                    if (callback) {
                        callback(me.extension.token);
                    }
                }], true);
            }
            else {
                gapi.auth.authorize(params, function(response){
                    me.extension.token = response;
                    me.extension.onSessionChanged.notifyEventListeners(response, response ? response.error : null);
                    if (callback)
                        callback(response);
                });
            }
        },

        /**
         * Log the user out of the application
         * @param callback
         */
        disconnect: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "disconnect", [callback], true);
            }
            else {
                //TODO
                if (callback)
                    callback({error: "Not implemented yet"});
            }
        },

        /**
         *  Initializes the authorization feature. Call this when the client loads to prevent popup blockers from blocking the auth window on gapi.auth.authorize calls.
         *  @param {Function} callback A callback to execute when the auth feature is ready to make authorization calls
         */
        init: function(callback) {

            if (this.extension.nativeExtensionObjectAvailable) {
                callback();
            }
            else {
                gapi.auth.init(callback);
            }
        },

        /**
         * Retrieves the OAuth 2.0 token for the application.
         */
        getToken: function() {
            if (this.extension.nativeExtensionObjectAvailable) {
                return this.extension.token;
            }
            else {
                return gapi.auth.getToken();
            }
        },
        /*
         * Retrieves the OAuth 2.0 token for the application.
         */
        setToken: function(token) {
            if (this.extension.nativeExtensionObjectAvailable) {
                this.extension.token = token;
            }
            else {
                gapi.auth.setToken(token);
            }
        }
    }


    CocoonJS.Social.GooglePlayGamesClientExtension = function(extension) {
        this.extension = extension;
        return this;
    }

    CocoonJS.Social.GooglePlayGamesClientExtension.prototype = {

        /**
         * Sets the API key for the application, which can be found in the Developer Console. Some APIs require this to be set in order to work.
         * @param apiKey The API key to set
         */
        setApiKey: function(apiKey) {
            if (this.extension.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "setApiKey", [apiKey],true);
            }
            else {
                gapi.client.setApiKey(apiKey);
            }
        },

        /**
         * Creates a HTTP request for making RESTful requests.
         * @param {object} args (More info: https://developers.google.com/api-client-library/javascript/reference/referencedocs#gapiclientrequest)
         * @return {object} If no callback is supplied, a request object is returned. The request can then be executed using gapi.client.HttpRequest.execute(callback).
         */
        request: function(args) {
            if (this.extension.nativeExtensionObjectAvailable) {
                if (args.callback) {
                    CocoonJS.makeNativeExtensionObjectFunctionCall(this.extension.nativeExtensionName, "request", [args, function(response,error){
                        var result = response;
                        if (error) {
                            result = response || {};
                            result.error = error;
                        }
                        args.callback(result);
                    }],true);
                    return null;
                }
                else {
                    var me = this;
                    //return a function to mimic the HttpRequest class
                    var httpRequest =  {
                        execute: function(callback) {
                            CocoonJS.makeNativeExtensionObjectFunctionCall(me.extension.nativeExtensionName, "request", [args, function(response, error){
                                var result = response;
                                if (error) {
                                    result = response || {};
                                    result.error = error;
                                }
                                callback(result);
                            }],true);
                        }
                    };
                    return httpRequest;
                }
            }
            else {
                return gapi.client.request(args);
            }
        }
    }

    /**
     * @namespace
     * This is the global variable that enables access to the Google Play Games API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.GooglePlayGamesExtension
     */
    CocoonJS.Social.GooglePlayGames = new CocoonJS.Social.GooglePlayGamesExtension();


    /**
     * @ignore
     */
    function fromSessionToAuthTokenObject(response, error) {
        var obj = response || {};
        return {
            access_token: response.access_token,
            state: response.state,
            error: error,
            expires_in: response.expirationDate ? response.expirationDate - Date.now() : 0,
            player_id: response.playerId
        }
    }


    CocoonJS.Social.SocialGamingServiceGooglePlayGames = function (apiObject) {
        CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.constructor.call(this);
        this.gapi = apiObject;
        var me = this;

        this.gapi.onSessionChanged.addEventListener(function(session){
            var obj = session || {};
            me.onLoginStatusChanged.notifyEventListeners(!!obj.access_token, obj.error);
        });

        return this;
    }

    CocoonJS.Social.SocialGamingServiceGooglePlayGames.prototype =  {

        isLoggedIn: function() {
            return (this.gapi.token && this.gapi.token.access_token) ? true: false;
        },
        login : function(callback) {
            var me = this;
            this.gapi.auth.authorize({client_id:this.gapi.settings.clientId, scope: this.gapi.defaultScopes}, function(response) {
                if (callback) {
                    callback(me.isLoggedIn(),response.error);
                }
            });
        },
        logout: function(callback) {
            this.gapi.auth.disconnect(callback);
        },
        getLoggedInUser : function() {
            return this.gapi.currentPlayer ? fromGPUserToCocoonUser(this.gapi.currentPlayer) : null;
        },
        requestUser: function(callback, userId) {
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId, callback: function(response) {
                var user = response && !response.error ? fromGPPlayerToCocoonUser(response) : null;
                callback(user, response.error);
            }});
        },
        requestUserImage: function(callback, userID, imageSize) {
            this.requestUser(function(user, error){
                if (user && user.userImage) {
                    var pixelSize = fromImageSizeToGPSize(imageSize || CocoonJS.Social.ImageSize.MEDIUM);
                    if (user.userImage.indexOf("sz=") ===  -1) {
                        user.userImage+="?sz=" + pixelSize;
                    }
                    else {
                        user.userImage = user.userImage.replace(/sz=\d+/g,"sz=" + pixelSize);
                    }
                }
                callback(user ? user.userImage : null, error);
            }, userID);

        },
        requestFriends: function(callback, userId) {
            var params = { orderBy: "best"};
            var playerId = userId || "me";
            this.gapi.client.request({path: this.gapi.plusAPI + "/people/" + playerId + "/people/visible", params: params, callback: function(response) {
                if (response && !response.error) {
                    var friends = [];
                    for (var i = 0; i< response.items.length; ++i) {
                        friends.push(fromGPPersonToCocoonUser(response.items[i]));
                    }
                    callback(friends);
                }
                else {
                    callback([], response ? response.error : null);
                }
            }});
        },

        publishMessage: function(message, callback) {
            if (callback)
                callback("Not supported... use publishMessageWithDialog method instead");
        },

        publishMessageWithDialog: function(message, callback) {

            if (this.gapi.nativeExtensionObjectAvailable) {
                var params = {
                    prefilledText: message.message,
                    mediaUrl: message.mediaURL,
                    mediaTitle: message.linkCaption,
                    mediaDescription: message.linkText,
                    url: message.linkURL
                }

                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "shareMessage", [params, callback], true)
            }
            else {

                var me = this;
                var share = function() {
                    var options = {
                        contenturl: 'https://plus.google.com/pages/',
                        contentdeeplinkid: '/pages',
                        clientid: me.gapi.settings.clientId,
                        cookiepolicy: 'single_host_origin',
                        prefilltext: message.message,
                        calltoactionlabel: 'CREATE',
                        calltoactionurl: 'http://plus.google.com/pages/create',
                        calltoactiondeeplinkid: '/pages/create'
                    };

                    gapi.interactivepost.render('sharePost', options);
                }

                if (!gapi.interactivepost) {
                    var script = document.createElement('script'); script.type = 'text/javascript'; script.async = true;
                    script.src = 'https://apis.google.com/js/plusone.js';
                    script.onload = function() {
                        share();
                    }
                    document.getElementsByTagName('head')[0].appendChild(script);
                }
                else {
                    share();
                }
            }
        },

        requestScore: function(callback, params) {
            params = params || {};
            var playerId = params.userID || "me";
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            this.gapi.client.request({path: this.gapi.gamesAPI + "/players/" + playerId + "/leaderboards/" + leaderboardID + "/scores/ALL_TIME", callback: function(response) {
                if (response && response.error) {
                    callback(null, response.error)
                }
                else if (response && response.items && response.items.length > 0) {
                    var item = response.items[0];
                    var data = new CocoonJS.Social.Score(playerId, item.scoreValue,"","", item.leaderboard_id);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }
            }});

        },

        submitScore: function(score, callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";


            this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/scores",
                                      method: "POST", params:{score: score}, callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
            }});

        },

        showLeaderboard : function(callback, params) {
            params = params || {};
            var leaderboardID = params.leaderboardID || this.gapi.settings.defaultLeaderboard;
            if (!leaderboardID)
                throw "leaderboardID not provided in the params. You can also set the default leaderboard in the init method";

            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                var timeScope = params.timeScope || 0;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showLeaderboard", [leaderboardID, timeScope, callback], true);
            }
            else {
                if (!this._leaderboardsTemplate)
                    throw "Please, provide a html template for leaderboards with the setTemplates method";
                var dialog = new CocoonJS.App.WebDialog();
                var callbackSent = false;
                dialog.show(this._leaderboardsTemplate, function(error) {
                    dialog.closed = true;
                    if (!callbackSent && callback)
                        callback(error);
                });
                var me = this;
                var collection = params.friends ? "SOCIAL" : "PUBLIC";
                var timeSpan = "ALL_TIME";
                if (params.timeScope === CocoonJS.Social.TimeScope.WEEK) {
                    timeSpan = "WEEKLY";
                }
                else if (params.timeScope === CocoonJS.Social.TimeScope.TODAY) {
                    timeSpan = "DAILY";
                }
                this.gapi.client.request({path: this.gapi.gamesAPI + "/leaderboards/" + leaderboardID + "/window/" + collection,
                    method: "GET", params:{timeSpan: timeSpan}, callback: function(response) {
                        if (dialog.closed)
                            return;
                        if (response.error) {
                            if (callback) {
                                callbackSent = true;
                                callback(response.error);
                                dialog.close();
                            }
                            return;
                        }
                        var scores = [];
                        var items = [];
                        if (response && response.items) {
                            items = response.items.slice(0);
                        }
                        if (response && response.playerScore) {
                            items.push(response.playerScore);
                        }
                        for (var i = 0; i< items.length; ++i) {
                            var item = items[i];
                            var score = fromGPScoreToCocoonScore(item, leaderboardID);
                            score.imageURL+="?sz=50";
                            score.position = item.scoreRank || i + 1;
                            score.me = false;
                            scores.push(score);
                        }
                        var js = "addScores(" + JSON.stringify(scores) + ")";
                        dialog.eval(js);
                    }});
            }
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {
            if (!this._cachedAchievements || reload) {
                var me = this;
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements", callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response && response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                achievements.push(fromGPAchievementToCocoonAchievement(response.items[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){
                if (error) {
                    callback([], error);
                    return;
                }
                var playerID = userID || "me";
                me.gapi.client.request({path: me.gapi.gamesAPI + "/players/" + playerID + "/achievements",
                                        params: {state: "UNLOCKED"}, callback: function(response) {
                    if (response && !response.error) {
                        var achievements = [];
                        if (response.items) {
                            for (var i = 0; i < response.items.length; i++) {
                                var ach = me.findAchievement(response.items[i].id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response ? response.error : null);
                    }
                }});

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            if (this.gapi.nativeExtensionObjectAvailable) {
                //native API allows to show a native notification view. (REST API doesn't)
                var showNotification = !!this.gapi.settings.showAchievementNotifications;
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "unlockAchievement", [achID, showNotification, callback], true);
            }
            else {
                //REST api
                this.gapi.client.request({path: this.gapi.gamesAPI + "/achievements/" + achID + "/unlock",
                    method: "POST", callback: function(response) {
                        if (callback) {
                            callback(response ? response.error : null);
                        }
                    }});
            }
        },
        resetAchievements : function(callback) {
            this.gapi.client.request({path: "/games/v1management/achievements/reset",
                method: "POST", callback: function(response) {
                    if (callback) {
                        callback(response ? response.error : null);
                    }
                }});
        },
        showAchievements : function(callback) {
            var ios = /(iPad|iPhone|iPod)/ig.test( navigator.userAgent );
            if (!ios && this.gapi.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.gapi.nativeExtensionName, "showAchievements", [callback], true);
            }
            else {
                CocoonJS.Social.SocialGamingServiceGooglePlayGames.superclass.showAchievements.call(this);
            }
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceGooglePlayGames, CocoonJS.Social.SocialGamingService);


    /**
     *@ignore
     */
    function fromGPPlayerToCocoonUser (gpPlayer) {
        return new CocoonJS.Social.User (gpPlayer.playerId, gpPlayer.displayName, gpPlayer.avatarImageUrl);
    }
    /**
     *@ignore
     */
    function fromGPPersonToCocoonUser (gpUser) {
        var avatar = gpUser.image ? gpUser.image.url : "";
        avatar = avatar.replace(/sz=\d+/g,"sz=100");
        return new CocoonJS.Social.User (gpUser.id, gpUser.displayName, avatar);
    }
    /**
     *@ignore
     */
    function fromImageSizeToGPSize (imageSize) {
        if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
            return 100;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
            return 200;
        }
        else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
            return 512;
        }
    }
    /**
     *@ignore
     */
    function fromGPAchievementToCocoonAchievement(gpItem) {
        var result = new CocoonJS.Social.Achievement (
            gpItem.id,
            gpItem.name,
            gpItem.description,
            gpItem.revealedIconUrl,
            0
        );
        result.gpAchievementData = gpItem;
        return result;
    }
    /**
     *@ignore
     */
    function fromGPScoreToCocoonScore(gpItem, leaderboardID) {
        return new CocoonJS.Social.Score(gpItem.player.playerId, gpItem.scoreValue, gpItem.player.displayName, gpItem.player.avatarImageUrl, leaderboardID);
    }

})();
;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Manager extension object.");

    CocoonJS.Social.ManagerService = function() {
       this.services = [];
    }

    CocoonJS.Social.ManagerService.prototype = {

        services:null,

        registerSocialService : function(service) {
            this.services.push(service);
        },

        submitAchievement : function(achievementID) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitAchievement(achievementID, function(error) {
                        if (error)
                            console.error("Error submitting achievement: " + error.message);
                    });
                }
            }
        },

        submitScore : function(score, params) {
            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.readOnlyHint && service.isLoggedIn())  {
                    service.submitScore(score, function(error) {
                        if (error)
                            console.error("Error submitting score: " + error.message);
                    }, params);
                }
            }
        },

        getLoggedInServices : function() {
            var result= [];

            for (var i = 0; i < this.services.length; ++i) {
                var service = this.services[i];
                if (!service.fakeSocialService &&  service.isLoggedIn())  {
                    result.push(service);
                }
            }
            return result;
        },

        isLoggedInAnySocialService : function() {
            return this.getLoggedInServices().length > 0;
        }
    }

    CocoonJS.Social.Manager = new CocoonJS.Social.ManagerService();

})();;(function() {

    // The CocoonJS and CocoonJS.Social must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating the extension types.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS.Social === null) throw("The CocoonJS.Social object must exist and be valid before creating the extension types.");

    /** 
     * @class
     * @constructor 
     * Represents a type that mimics the original Facebook API with the addition of the possibility to
     * retrieve an abstract high level interface API to handle a SocialGamingService (APIs defined by Ludei).
     */
    CocoonJS.Social.FacebookExtension = function (){
        this.nativeExtensionName = "IDTK_SRV_FACEBOOK";
        this.extensionName = "Social.Facebook";
        this.nativeExtensionObjectAvailable =  CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[this.nativeExtensionName] !== 'undefined';
        this.Event = new CocoonJS.Social.FacebookEvent(this.nativeExtensionObjectAvailable);

        var me = this;
        if (this.nativeExtensionObjectAvailable) {

            this.onFacebookSessionStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onFacebookSessionStateChanged");

            CocoonJS.Social.Facebook = this; //the object it's being created but the addEventListener needs it now
            this.onFacebookSessionStateChanged.addEventListener(function(session, error) {
                var data = fromCocoonFBSessionToFBAPISession(session,error);
                if (session.state == 0) {
                    me.Event.notify("auth.login", data);
                }
                me.Event.notify("auth.authResponseChange", data);
                me.Event.notify("auth.statusChange", data);
            });
        }
        return this;
    };

    CocoonJS.Social.FacebookExtension.prototype = {

        _currentSession: null,
        _appId: null,
        _socialService: null,

        /**
         * Initialize the SDK with your app ID. This will let you make calls against the Facebook API. All FB.API methods must be called after FB.init.
         * @param {object} options. Check available options here: https://developers.facebook.com/docs/reference/javascript/FB.init/
         */
        init: function(options) {
            if (!options || !options.appId) {
                throw "appId must be specified!";
            }

            this._appId = options.appId;

            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "init", [options], true);
            }
            else {
                FB.init(options);
            }

            var me = this;
            this.Event.subscribe("auth.authResponseChange", function(session) {
                me._currentSession = session;
                if (session.authResponse && !session.authResponse.user){
                    me.api("me?fields=username", function(response) {
                        me._currentSession.authResponse.user = response;
                    });
                }
            });
        },

        /**
         * Return a CocoonJS SocialGaming interface for the Facebook Extension
         * You can use the Facebook extension in two ways, with the official SDK API equivalent or with the CocoonJS Social API abstraction
         * @see CocoonJS.Social.SocialGamingService
         * @returns {CocoonJS.Social.SocialGamingService}
         */
        getSocialInterface: function() {

            if (!this._appId) {
                throw "You must call init() before getting the Social Interface";
            }
            if (!this._socialService) {
                this._socialService = new CocoonJS.Social.SocialGamingServiceFacebook(this);
            }
            return this._socialService;
        },

        /**
         * Authenticate the user
         * By default, calling login will attempt to authenticate the user with only the basic permissions.
         * If you want one or more additional permissions, call login with an option object,
         * and set the scope parameter with a comma-separated list of the permissions you wish to request from the user
         * @param {object} login options
         * @params {function} callback The callback function with received session data or error.
         */
        login: function(callback, options) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "login", [options, function(response, error) {
                    me._currentSession = fromCocoonFBSessionToFBAPISession(response,error);
                    if (callback) {
                        callback(me._currentSession);
                    }

                }], true);
            }
            else {
                FB.login(function(response){
                    me._currentSession = response;
                    if (callback)
                        callback(response);
                }, options);
            }

        },

        /**
         * Log the user out of your application
         * You will need to have a valid access token for the user in order to call the function.
         * @param {function} callback called when the user is logged out
         */
        logout: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "logout", [function(response, error) {
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response, error));
                    }

                }],true);
            }
            else {
                FB.logout(function(response){
                    if (callback) {
                        callback(response);
                    }
                });
            }

        },

        /**
         * Synchronous accessor for the current authResponse
         * @returns {object} current Facebook session data
         */
        getAuthResponse: function() {

            if (this.nativeExtensionObjectAvailable) {
                var response = CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getFacebookSession", []);
                return fromCocoonFBSessionToFBAPISession(response);
            }
            else {
                return FB.getAuthResponse();
            }

        },

        /**
         * Allows you to determine if a user is logged in to Facebook and has authenticated your app.
         * There are three possible states for a user:
         * 1. the user is logged into Facebook and has authenticated your application (connected)
         * 2. the user is logged into Facebook but has not authenticated your application (not_authorized)
         * 3. the user is not logged into Facebook at this time and so we don't know if they've authenticated your application or not
         * @param {function} callback The callback function.
         * @param {boolean} force Force reloading the login status (default false).
         */
        getLoginStatus: function(callback, force) {
            if (this.nativeExtensionObjectAvailable) {

                var me = this;
                setTimeout(function(){
                    var response = CocoonJS.makeNativeExtensionObjectFunctionCall(me.nativeExtensionName, "getFacebookSession", []);
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(response));
                    }

                },50);
            }
            else {
                FB.getLoginStatus(callback, force);
            }

        },
        /**
         * Makes API calls to the Graph API.
         * @param path The Graph API url path
         * @param method the http method (default "GET")
         * @param params the parameters for the query
         * @param cb the callback function to handle the response
         */
        api: function(path, method, params, cb ) {

            if (this.nativeExtensionObjectAvailable) {
                var openGraph = arguments[0];
                var httpMethod = arguments.length > 3 ? arguments[1] : "GET";
                var options = null;
                if (arguments.length == 3) options = arguments[1];
                if (arguments.length == 4) options = arguments[2];
                var callback = arguments.length > 1 ? arguments[arguments.length -1 ] : function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "api", [openGraph, httpMethod, options, callback], true);
            }
            else {
                FB.api(path,method,params,cb);
            }
        },

        /**
         * A generic method for triggering Dialogs which allow the user to take some action.
         * @param params The required arguments vary based on the method being used, but specifying the method itself is mandatory
         * @param cb Callback function to handle the result. Not all methods may have a response.
         */
        ui: function(params, cb) {

            if (this.nativeExtensionObjectAvailable){
                var params = arguments[0];
                var callback = arguments.length > 1 ? arguments[1]: function(){};

                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "ui", [params, callback], true);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.ui(params,cb);
            }
        },

        /**
         * @param {string} permissionsType "read" or "publish"
         * @param permissions comma separated Facebook permission names
         * @param callback response authResponse callback
         */

        requestAdditionalPermissions: function(permissionsType, permissions, callback) {
            if (this.nativeExtensionObjectAvailable) {

                var permsArray = permissions.split(',');
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAdditionalPermissions", [permissionsType, permsArray, function(session, error){
                    if (callback) {
                        callback(fromCocoonFBSessionToFBAPISession(session,error));
                    }
                }], true);
            }
            else {
                FB.login(callback, {scope:permissions});
            }
        },

        /**
         * Query the current user facebook permissions
         * @param callback Handler function which receives a dictionary with the granted permissions
         */
        getPermissions: function(callback) {
            this.api('me/permissions', function(response) {
                callback(response.data && response.data[0] ? response.data[0] : {});
            });
        },

        /**
         * Presents a dialog in the Facebook application that allows the user to share a status update
         * If the Facebook Application is not available it does a fallback to a feed dialog
         * No publish permissions are required.
         * @param params Dialog params (description, caption, name, link, picture)
         * @param callback Handler with response data or error
         */
        showShareDialog: function(params, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showShareDialog", [params, callback], true);
            }
            else {
                params.method = "feed";
                FB.ui(params, callback);
            }
        },

        /**
         * Upload a local image file to Facebook and get response
         * @param file The local file url to submit to Facebook (For example the one capture with screenCapture API)
         * @param callback Handler to process response with the photoid and other data or the error
         */
        uploadPhoto: function(file, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "uploadPhoto", [file, callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        },

        /**
         * Shows a native UI component that can be used to pick friends.
         * @param callback Handlerv function. The response contains the boolen 'donePressed' value and an array of selected users in the 'selection' property.
         */
        showFriendPicker: function(callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showFriendPicker", [callback], true);
            }
            else {
                //TODO
                callback({error: {message: "Not implemented"}});
            }
        }

    };

    /**
     * @class
     * @constructor
     */
    CocoonJS.Social.FacebookEvent = function(nativeAvailable ) {
        this.nativeExtensionObjectAvailable = nativeAvailable;
        return this;
    }

    CocoonJS.Social.FacebookEvent.prototype = {
        /**
         * Global Events to which you can subscribe:
         * auth.login - fired when the auth status changes from unknown to connected
         * auth.authResponseChange - fired when the authResponse changes
         * auth.statusChange - fired when the status changes
         * @param name Name of the event
         * @param callback The handler function
         */
        subscribe: function(name, callback){
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                this[eventKey] = this[eventKey] || [];
                this[eventKey].push(callback);
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.subscribe(name,callback);
            }
        },
        /**
         * Removes handlers on events so that it no longer invokes your callback when the event fires.
         * @param name Name of the event.
         * @param callback The handler function.
         */
        unsubscribe: function(name, callback) {
            if (this.nativeExtensionObjectAvailable)
            {
                var eventKey = name + 'listeners';
                var array = this[eventKey];
                if (array) {
                    var index = array.indexOf(callback);
                    if (index !== -1) {
                        array.splice(index,1);
                    }
                }
            }
            else if (!navigator.isCocoonJS)
            {
                FB.Event.unsubscribe(name,callback);
            }
        },

        /**
         * @ignore
         */
        notify: function(name, param) {
            var eventKey = name + 'listeners';
            var array = this[eventKey];
            if (array) {
                for (var i = 0; i< array.length; ++i) {
                    array[i](param);
                }
            }

        }
    };

    /**
     * @namespace 
     * This is the global variable that enables access to the Facebook API mimic and the high level abstract API
     * to handle Social aspects, created by Ludei.
     * @see CocoonJS.Social.FacebookExtension
     */
    CocoonJS.Social.Facebook = new CocoonJS.Social.FacebookExtension();

    /**
     * @ignore
     */
    function fromCocoonFBStatusToFBAPIState(state) {
        if (state === 0) {
            return "connected";
        }
        else if (state === 1) {
            return "not_authorized";
        }
        else {
            return "unknown";
        }
    }

    /**
     * @ignore
     */
    function fromCocoonFBSessionToFBAPISession(response, error) {

        var authResponse = null;
        if (response.state === 0) {
            authResponse = {
                accessToken: response.accessToken,
                expirationDate: response.expirationDate,
                userID: response.user ? response.userID : null,
                permissions: response.permissions,
                user: response.user
            }
        }

        return {
            status: fromCocoonFBStatusToFBAPIState(response.state),
            authResponse: authResponse,
            error: error
        }

    }

    CocoonJS.Social.SocialGamingServiceFacebook = function (fbExtension) {
        CocoonJS.Social.SocialGamingServiceFacebook.superclass.constructor.call(this);
        this.fb = fbExtension;
        var me = this;
        this.fb.Event.subscribe("auth.authResponseChange", function(session) {
            me.onLoginStatusChanged.notifyEventListeners(session.status == "connected", session.error);
        });
        return this;
    }

    CocoonJS.Social.SocialGamingServiceFacebook.prototype =  {

        currentPermissions: null,

        isLoggedIn: function() {
            return this.fb._currentSession && this.fb._currentSession.status === "connected";
        },
        login : function(callback) {
            var me = this;
            this.fb.login(function(response){
                if (callback)
                    callback(me.isLoggedIn(), response.error);
            });
        },
        logout: function(callback) {
            this.fb.logout(function(response){
                if (callback)
                    callback(response.error);
            });
        },
        getLoggedInUser : function() {
            var authResponse = this.fb._currentSession ? this.fb._currentSession.authResponse : null;
            if (authResponse && authResponse.user) {
                return fromFBUserToCocoonUser(authResponse.user);
            }
            else if (authResponse && authResponse.userID) {
                return new CocoonJS.Social.User(authResponse.userID, "Loading...");
            }
            return null;
        },
        hasPublishPermissions: function(callback) {
            this.fb.getPermissions(function(perms, error){
               callback(perms.publish_actions, error);
            });
        },
        requestPublishPermissions: function(callback) {
            var me = this;
            this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response){
                if (response.error)
                    callback(false, error);
                else {
                    me.hasPublishPermissions(function(granted, error){
                        callback(granted,error);
                    });
                }
            });
        },
        requestUser: function(calback, userId) {
            var apiCall = (userId || "me");
            this.fb.api(apiCall, function(response){
                var user = response.error ? null : fromFBUserToCocoonUser(response);
                calback(user, response.error);
            });
        },
        requestUserImage: function(callback, userID, imageSize) {
            if (!userID && this.isLoggedIn()) {
                userID = this.fb._currentSession.authResponse.userID;
            }
            var fbPictureSize = "small";
            if (imageSize === CocoonJS.Social.ImageSize.THUMB) {
                  fbPictureSize = "square"
            }
            else if (imageSize === CocoonJS.Social.ImageSize.MEDIUM) {
                fbPictureSize = "normal";
            }
            else if (imageSize === CocoonJS.Social.ImageSize.LARGE) {
                fbPictureSize = "large";
            }
            var url = "https://graph.facebook.com/" + userID + "/picture?type=" + fbPictureSize;
            callback(url);
        },
        requestFriends: function(callback, userId) {
            var apiCall = (userId || "me") + "/friends";
            this.fb.api(apiCall, function(response){
                var friends = [];
                if (!response.error) {
                    for (var i=0; i<response.data.length; i++)
                    {
                        friends.push(fromFBUserToCocoonUser(response.data[i]));
                    }
                }
                callback(friends, response.error);
            });
        },

        //internal utility function
        preparePublishAction: function(callback) {
            if (!this.currentPermissions) {
                var me = this;
                this.fb.getPermissions(function(perms){
                    me.currentPermissions = perms;
                    if (perms)
                        me.preparePublishAction(callback);
                });
            }
            else if (this.currentPermissions.publish_actions) {
                callback(true);
            }
            else{
                this.currentPermissions = null;
                this.fb.requestAdditionalPermissions("publish", "publish_actions", function(response) {
                     callback(response.error ? false : true);
                });
            }

        },
        publishMessage: function(message, callback) {
            this.preparePublishAction(function(granted) {
                if (granted) {
                    var params = fromCocoonMessageToFBMessage(message);
                    var apiCall = "me/feed";
                    this.fb.api(apiCall, params, function(response) {
                        if (callback)
                            callback(response.error);
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }
            });
        },

        publishMessageWithDialog: function(message, callback) {
            this.fb.showShareDialog(fromCocoonMessageToFBMessage(message), function(response){
                 if (callback) {
                     callback(response.error);
                 }
            });
        },

        requestScore: function(callback, params) {
            var apiCall = ((params && params.userID) ? params.userID : "me") + "/scores";
            this.fb.api(apiCall, function(response) {
                if (response.error) {
                    callback(null, response.error)
                }
                else if (response.data && response.data.length > 0) {
                    var data = fromFBScoreToCocoonScore(response.data[0]);
                    callback(data, null);
                }
                else {
                    //No score has been submitted yet for the user
                    callback(null,null);
                }

            });
        },

        submitScore: function(score, callback, params) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestScore(function(currentScore, error) {
                        if (error) {
                            //can't get the user top score. Don't send the new one because it might be worse than the top score
                            if (callback)
                                callback(error);
                           return;
                        }
                        var topScore = currentScore ? currentScore.score : 0;
                        if (score <= topScore) {
                            //don't submit the new score because a better score is already submitted
                            if (callback)
                                callback(null);
                            return;
                        }
                        var apiCall = "/" + ((params && params.userID) ? params.userID : "me") + "/scores";
                        me.fb.api(apiCall, 'POST', {score:score}, function (response) {
                             if (callback)
                                callback(response.error);
                        });
                    }, params)
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            })
        },

        showLeaderboard : function(callback, params) {
            if (!this._leaderboardsTemplate)
                throw "Please, provide a html template for leaderboards with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._leaderboardsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.fb.api(me.fb._appId + "/scores", function(response) {
                if (dialog.closed)
                    return;
                if (response.error) {
                    if (callback) {
                        callbackSent = true;
                        callback(response.error);
                        dialog.close();
                    }
                    return;
                }
                var scores = [];
                if (response.data && response.data.length) {
                    for (var i = 0; i< response.data.length; ++i) {
                        var score = fromFBScoreToCocoonScore(response.data[i]);
                        score.position = i;
                        score.imageURL = "https://graph.facebook.com/" + score.userID + "/picture";
                        score.me = score.userID === me.fb._currentSession.authResponse.userID;
                        scores.push(score);
                    }
                }
                var js = "addScores(" + JSON.stringify(scores) + ")";
                dialog.eval(js);
            });
        },

        //internal utility function
        prepareAchievements: function(reload, callback) {

            if (!this._cachedAchievements || reload) {
                var me = this;
                this.fb.api(this.fb._appId + '/achievements', function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                achievements.push(fromFBAchievementToCocoonAchievement(response.data[i]))
                            }
                        }
                        me.setCachedAchievements(achievements);
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });
            }
            else {
                callback(this._cachedAchievements, null);
            }
        },

        requestAllAchievements : function(callback) {
            this.prepareAchievements(true, callback);
        },

        requestAchievements : function(callback, userID) {
            var me = this;
            this.prepareAchievements(false, function(allAchievements, error){

                if (error) {
                    callback([], error);
                    return;
                }
                var apiCall = (userID || "me") + "/achievements";
                me.fb.api(apiCall, function(response) {
                    if (!response.error) {
                        var achievements = [];
                        if (response.data) {
                            for (var i = 0; i < response.data.length; i++) {
                                var ach = me.findAchievement((response.data[i].achievement || response.data[i].data.achievement).id);
                                if (ach)
                                    achievements.push(ach);
                            }
                        }
                        callback(achievements, null);
                    }
                    else {
                        callback([], response.error);
                    }
                });

            });
        },
        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var achID = this.translateAchievementID(achievementID);
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.fb.api("me/achievements", "POST", {achievement:achID}, function (response) {
                        if (callback) {
                            callback(response.error);
                        }
                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        resetAchievements : function(callback) {
            var me = this;
            this.preparePublishAction(function(granted) {
                if (granted) {
                    me.requestAchievements(function(achievements, error){
                        if (error) {
                            if (callback)
                                callback(error);
                            return;
                        }
                        var someError = null;
                        var remaining = achievements.length;
                        for (var i = 0; i < achievements.length; ++i) {
                            me.fb.api("me/achievements", "DELETE", {achievement:achievements[i].fbAchievementData.url}, function (response) {
                                if (response.error) {
                                   someError = response.error;
                                }
                                remaining--;
                                if (remaining == 0 && callback) {
                                    callback(someError);
                                }
                            });
                        }

                    });
                }
                else {
                    if (callback)
                        callback({message: "No publish_actions permission granted"});
                }

            });
        },
        showAchievements : function(callback) {
            if (!this._achievementsTemplate)
                throw "Please, provide a html template for achievements with the setTemplates method";
            var dialog = new CocoonJS.App.WebDialog();
            var callbackSent = false;
            dialog.show(this._achievementsTemplate, function(error) {
                dialog.closed = true;
                if (!callbackSent && callback)
                    callback(error);
            });
            var me = this;
            this.requestAchievements(function(achievements, error){
                if (dialog.closed)
                    return;
                if (error) {
                    callbackSent = true;
                    if (callback)
                        callback(error);
                    return;
                }

                var achs = [];
                if (me._cachedAchievements) {
                    for (var i = 0; i < me._cachedAchievements.length; ++i) {
                        var ach = me._cachedAchievements[i];
                        achs.push(ach);
                        if (achievements && achievements.length) {
                            for (var j = 0; j< achievements.length; ++j) {
                                if (achievements[j].achievementID === ach.achievementID) {
                                    ach.achieved = true;
                                    break;
                                }
                            }
                        }
                    }
                }
                var js = "addAchievements(" + JSON.stringify(achs) + ");";
                dialog.eval(js);
            });
        }
    }

    CocoonJS.extend(CocoonJS.Social.SocialGamingServiceFacebook, CocoonJS.Social.SocialGamingService);

    /**
     *@ignore
     */
    function fromFBUserToCocoonUser (facebookUser) {
        return new CocoonJS.Social.User (facebookUser.id, facebookUser.username);
    }

    /**
     *@ignore
     */
    function fromCocoonMessageToFBMessage(message) {
        return {
            link: message.linkURL,
            description: message.message,
            name: message.linkText,
            caption: message.linkCaption,
            picture: message.mediaURL
        }
    }
    /**
     *@ignore
     */
    function fromFBScoreToCocoonScore(fbResponse, requestScoreParams) {
        var result = new CocoonJS.Social.Score(fbResponse.user.id, fbResponse.score, fbResponse.user.name);
        if (requestScoreParams) {
            result.leaderboardID = requestScoreParams.leaderboardID;
        }
        result.imageURL = 'https://graph.facebook.com/' + fbResponse.user.id + '/picture';
        return result;
    }
    /**
     *@ignore
     */
    function fromFBAchievementToCocoonAchievement(fbResponse) {
        var result = new CocoonJS.Social.Achievement (
            fbResponse.id,
            fbResponse.title,
            fbResponse.description,
            fbResponse.image[0].url,
            fbResponse.data.points
        );
        result.fbAchievementData = fbResponse;
        return result;
    }

    if (!navigator.isCocoonJS) {
        // Load the Facebook SDK
        var parent = document.getElementsByTagName('script')[0];
        var script = document.createElement('script');
        //script.async = true;
        var prot= location.protocol ? location.protocol : "http:"
        script.src = prot + "//connect.facebook.net/en_US/all.js";
        parent.parentNode.insertBefore(script, parent);
    }

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.Social === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.Social object must exist and be valid before creating a Social Local Storage extension object.");


    /**
     * @constructor
     */
    CocoonJS.Social.LocalStorageService = function() {
        CocoonJS.Social.LocalStorageService.superclass.constructor.call(this);
        this.fakeSocialService = true;
    }

    CocoonJS.Social.LocalStorageService.prototype = {

        loggedIn: false,
        keys: {
            score: "CocoonJS.Social.LocalStorageService.score",
            earnedAchievements: "CocoonJS.Social.LocalStorageService.earned"
        },
        isLoggedIn: function() {
            return this.loggedIn;
        },

        login : function(callback) {
            if (!this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = true;
            if (callback)
                setTimeout(function(){callback(true)},0);
        },

        logout: function(callback) {
            if (this.loggedIn)
                this.onLoginStatusChanged.notifyEventListeners(true);
            this.loggedIn = false;

            if (callback)
                setTimeout(function(){callback()},0);
        },

        getLoggedInUser : function() {
            return new CocoonJS.Social.User("me", "LocalStorage");
        },

        requestUser: function(callback, userID) {
            var user = new CocoonJS.Social.User(userID || "me", "LocalStorage");
            if (callback)
                setTimeout(function(){callback(user)},0);
        },

        requestScore: function(callback, params) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var score = parseInt(scoreItem) || 0;
            setTimeout(function(){callback(new CocoonJS.Social.Score("me", score))},0);
        },

        submitScore: function(score, callback, params ) {
            var scoreItem = localStorage.getItem(this.keys.score);
            var topScore = parseInt(scoreItem) || 0;
            if (score > topScore)
                localStorage.setItem(this.keys.score, score);
            if (callback)
                setTimeout(function(){callback()},0);
        },
        getLocalStorageEarnedAchievements: function() {
            var achievementsItem = localStorage.getItem(this.keys.earnedAchievements);
            var earned = [];
            if (achievementsItem) {
                var array = JSON.stringify(achievementsItem);
                if (array && array.length) {
                    earned = array;
                }
            }
            return earned;
        },
        requestAchievements : function(callback, userID) {
            var earned = this.getLocalStorageEarnedAchievements();
            setTimeout(function(){callback(earned)},0);
        },

        submitAchievement: function(achievementID, callback) {
            if (achievementID === null || typeof achievementID === 'undefined')
                throw "No achievementID specified";
            var earned = this.getLocalStorageEarnedAchievements();
            var exists = false;
            for (var i = 0; i< earned.length; ++i) {
               if (earned[i] === achievementID) {
                   exists = true;
                   break;
               }
            }
            if (!exists) {
                earned.push(achievementID);
                localStorage.setItem(this.keys.earnedAchievements, JSON.stringify(earned));
            }

            if (callback)
                setTimeout(function(){callback()},0);
        },
        resetAchievements : function(callback) {
            localStorage.removeItem(this.keys.earnedAchievements);
            if (callback)
                setTimeout(function(){callback()},0);
        }
    };

    CocoonJS.extend(CocoonJS.Social.LocalStorageService, CocoonJS.Social.SocialGamingService);

    CocoonJS.Social.LocalStorage = new CocoonJS.Social.LocalStorageService();

})();;(function() {

    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    CocoonJS.Multiplayer = {};

	/**
	* This type represents the access to a native Multiplayer extension API.
    * This service allows to programmatically create matches to invite other players and to receive match invitations sent by other players.
    * Your game must authenticate the related social service before you can use this service.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Multiplayer.MultiplayerService = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

        var me = this;

        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an invitation has been received from another player and the user has accepted it
         * The invitation will start loading.
         * While the invitation is loading a system view might appear on the screen.
         * You should pause/stop your current game and prepare it to process a new match
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         */
        this.onInvitationReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationReceived");
        /**
         * This {@link CocoonJS.EventHandler} object allows listening to events called when an accepted invitation has been loaded
         * The invitation is ready to be processed (start the match or handle the error)
         * @memberOf CocoonJS.Multiplayer.MultiplayerService
         * Received params: {CocoonJS.Multiplayer.Match} and error
         */
        this.onInvitationLoaded = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onInvitationLoaded", function(sourceListener, args){
            var matchID = args[0];
            var error = args[1];
            if (matchID && !error) {
                me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                sourceListener(me.currentMatch, null)
            }
            else {
                sourceListener(null, error);
            }
        });



        return this;
	};


	CocoonJS.Multiplayer.MultiplayerService.prototype = {

        currentMatch: null,

        /**
         * Presents a system View for the matchmaking and creates a new Match
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findMatch : function(matchRequest, callback)  {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findMatch", [matchRequest, function(matchID,error) {
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Sends an automatch request to join the authenticated user to a match. It doesn't present a system view while waiting to other players.
         * @param  {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {Function} callback The callback function. Response parameters: {CocoonJS.Multiplayer.Match} and error;
         */
        findAutoMatch : function(matchRequest, callback) {
            var me = this;
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "findAutoMatch", [matchRequest, function(matchID, error){
                    if (matchID && !error) {
                        me.currentMatch =  new CocoonJS.Multiplayer.Match(me.nativeExtensionName, me.extensionName, matchID);
                        callback(me.currentMatch, null)
                    }
                    else {
                        callback(null, error);
                    }
                }], true);
            }
        },

        /**
         * Cancels the ongoing automatch request
         */
        cancelAutoMatch : function() {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "cancelAutoMatch", [], true);
            }
        },

        /**
         * Automatically adds players to an ongoing match owned by the user.
         * @param {CocoonJS.Multiplayer.MatchRequest} matchRequest The parameters for the match
         * @param {CocoonJS.Multiplayer.Match} matchRequest The match where new players will be added
         * @param {Function} callback The callback function. Response parameters: error
         */
        addPlayersToMatch : function(matchRequest, match, callback) {
            if (this.nativeExtensionObjectAvailable) {
                CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "addPlayersToMatch", [matchRequest, match.matchID, callback], true);
            }
        },
        /**
         * Get the current match reference.
         * @return {CocoonJS.Multiplayer.Match} the current match reference
         */
        getMatch : function() {
            return this.currentMatch;
        }
	};

	/**
	* This type provides a transmission network between a group of users.
	* The match might be returned before connections have been established between players. At this stage, all the players are in the process of connecting to each other.
	* Always check the getExpectedPlayerCount value before starting a match. When its value reaches zero, all expected players are connected, and your game can begin the match.
	* Do not forget to call the start method of the match when your game is ready to process received messages via onMatchDataReceived listener.
	* @class
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	* @param {number} matchID The match ID user for native service bridge.
	*/
	CocoonJS.Multiplayer.Match = function(nativeExtensionName, extensionName, matchID)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + nativeExtensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';
	    this.matchID = matchID;
	    var me = this;


	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a match receives data from the network
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchDataReceivedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} data The received data
	    * @param {string} playerID The playerID where the data is received from.
	    */
	    this.onMatchDataReceived = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchDataReceived", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a player connection state changes.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchStateChangedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {CocoonJS.Multiplayer.ConnectionState} The new connection state of the player
	    */
	    this.onMatchStateChanged = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchStateChanged", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a netowrk connection with a player fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchConnectionWithPlayerFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} playerID The player whose state has changed
	    * @param {string} error The error message
	    */
	    this.onMatchConnectionWithPlayerFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchConnectionWithPlayerFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1], args[2]);
	    		}
	    	});

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the match fails
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnMatchFailedListener}
	    * @memberOf CocoonJS.Multiplayer.Match
	    * @param {CocoonJS.Multiplayer.Match} match The source match.
	    * @param {string} error The error message
	    */
	    this.onMatchFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onMatchFailed", function(sourceListener, args) {
	    		if (me.matchID === args[0]) {
	    			sourceListener(me, args[1]);
	    		}
	    	});
	};

	CocoonJS.Multiplayer.Match.prototype = {

		/**
		* Start processing received messages. The user must call this method when the game is ready to process messages. Messages received before being prepared are stored and processed later.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		*/
		start : function() {
			if (this.nativeExtensionObjectAvailable) {
				CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "startMatch", [this.matchID], true);
			}
		},

		/**
		* Transmits data to all players connected to the match. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendDataToAllPlayers : function(data, sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendDataToAllPlayers", [this.matchID, data, sendMode]);
			}
		},

		/**
		* Transmits data to a list of connected players. The match queues the data and transmits it when the network becomes available.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		* @param {string} data The data to transmit
		* @param {array} playerIDs An array containing the identifier strings for the list of players who should receive the data
		* @param {CocoonJS.Multiplayer.SendDataMode} sendMode The optional {@link CocoonJS.Multiplayer.SendDataMode} value. The default value is RELIABLE.
		* @return {boolean} TRUE if the data was successfully queued for transmission; FALSE if the match was unable to queue the data
		*/
		sendData : function(data, playerIDs,  sendMode) {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "sendData", [this.matchID, data, playerIDs, sendMode]);
			}
		},

		/**
		* Disconnects the local player from the match and releases the match. Calling disconnect notifies other players that you have left the match.
		* @see CocoonJS.Multiplayer.Match.onMatchDataReceived
		* @see CocoonJS.Multiplayer.Match.onMatchStateChanged
		* @see CocoonJS.Multiplayer.Match.onMatchConnectionWithPlayerFailed
		* @see CocoonJS.Multiplayer.Match.onMatchFailed
		*/
		disconnect : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "disconnect", [this.matchID], true);
			}
		},

		/**
		* Requests additional information of the current players in the match
        * @param {Function} callback The callback function. Response params: players array and error
		*/
		requestPlayersInfo : function(callback) {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestPlayersInfo", [this.matchID, callback], true);
			}
		},

		/**
		* Method to request the remaining players count who have not yet connected to the match.
		* @function
		* @return {number} The remaining number of players who have not yet connected to the match
		*/
		getExpectedPlayerCount : function() {
			if (this.nativeExtensionObjectAvailable) {
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getExpectedPlayerCount", [this.matchID]);
			}
		},
		/**
		* This method returns an array with all the player identifiers taking part in the match.
		* @return {array} The player identifiers for the players in the match
		*/
		getPlayerIDs : function() {
			if (this.nativeExtensionObjectAvailable){
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPlayerIDs", [this.matchID]);
			}
		},

        /**
         * Gets the local playerID taking part in the match.
         * @return {string} the playerID attached to the match manager.
         */
        getLocalPlayerID : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLocalPlayerID", [this.matchID]);
            }
            return "";
        },

	};

	/**
	* This enum represents the modes to send data
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.SendDataMode =  {
		/**
		* The data is sent continuously until it is successfully received by the intended recipients or the connection times out
		*/
	    RELIABLE : 0,

		/**
		* The data is sent once and is not sent again if a transmission error occurs.
		*/
	    UNRELIABLE : 1
	};


	/**
	* This enum represents the connection state of a player
	* @namespace
	* @enum
	*/
	CocoonJS.Multiplayer.ConnectionState = {
		/**
		* The connection is in unknown state.
		*/
	    UNKNOWN : 0,

	    /**
		* The connection is in connected state.
		*/
	    CONNECTED : 1,

	    /**
		* The connection is in disconnected state.
		*/
	    DISCONNECTED : 2
	};

	/**
	* The data structure that represents the information of a player inside a multiplayer match.
	* @class
	* @constructor
	* @param {string} The id of the user.
	* @param {string} The name of the user.
	*/
	CocoonJS.Multiplayer.PlayerInfo = function(userID, userName) {
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This data structure is used to specify the parameters for a new new multiplayer match.
	* @class
	* @constructor
	* @param {number} minPlayers The minimum number of players that may join the match.
	* @param {number} maxPlayers The maximum number of players that may join the match.
	* @param {array}  [playersToInvite] Optional list of player identifers for players to invite to the match.
	* @param {number} [playerGroup] Optional number identifying a subset of players allowed to join the match.
	* @param {number} [playerAttributes] Optional mask that specifies the role that the local player would like to play in the game.
	*/
	CocoonJS.Multiplayer.MatchRequest = function(minPlayers, maxPlayers, playersToInvite, playerGroup, playerAttributes) {
		/**
		* The minimum number of players that may join the match.
		* @field
		* @type number
		*/
		this.minPlayers = minPlayers;

		/**
		* The maximum number of players that may join the match.
		* @field
		* @type number
		*/
		this.maxPlayers = maxPlayers;

		/**
		* Optional list of player identifers for players to invite to the match.
		* @field
		* @type Array
		*/
		this.playersToInvite = playersToInvite;

		/**
		* Optional number identifying a subset of players allowed to join the match.
		* @field
		* @type number
		*/
		this.playerGroup = playerGroup;

		/**
		* Optional mask that specifies the role that the local player would like to play in the game.
		* @field
		* @type number
		*/
		this.playerAttributes = playerAttributes;

		return this;
	};

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Game Center extension object.");

	/**
	* @namespace
	* This instance represents the extension object to access GameCenter Multiplayer API.
	* @see CocoonJS.Multiplayer.MultiplayerService
	*/
	CocoonJS.Multiplayer.GameCenter = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GAMECENTER", "Multiplayer.GameCenter");
})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window.CocoonJS) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Multiplayer Loopback extension object.");


    var loopbackServices = [];
    var indexCounter = 0;
    var matchServices = [];
    var matchCounter = 0;

    /**
     * This service provides a loopback implementation of the {@link CocoonJS.Multiplayer.MultiplayerService}
     * @constructor
     */
    CocoonJS.Multiplayer.LoopbackService = function() {

        CocoonJS.Multiplayer.LoopbackService.superclass.constructor.call(this, "dummy","dummy");
        loopbackServices.push(this);
        this.playerID = "" + indexCounter;
        indexCounter++;

    }

    CocoonJS.Multiplayer.LoopbackService.prototype =  {

        findMatch : function(request, callback)  {

            this.findMatchCallback = callback;

            //checks if the service is already added to the match list
            var exists = false;
            for (var i = 0; i< matchServices.length; ++i) {
                if (matchServices[i] === this) {
                    exists = true; break;
                }
            }
            if (!exists)
                matchServices.push(this);

            //Create the match is all required players are ready
            //TODO: check more conditions (playerGroup, playerAttributes) to complete a match
            if (matchServices.length >= request.minPlayers) {
                var playerIDs = [];
                //create playerIDs array
                for (var i = 0; i< matchServices.length; ++i) {
                    playerIDs.push(matchServices[i].getPlayerID());
                }

                //notify the found match to each manager
                for (var i = 0; i< matchServices.length; ++i) {
                    var match = new LoopbackMatch(matchServices[i]);
                    match.playerIDs = playerIDs.slice();
                    matchServices[i].currentMatch = match;
                    matchServices[i].findMatchCallback(match, null);
                }
                //clear pending list
                matchServices = [];
            }


        },
        findAutoMatch : function(matchRequest, callback) {
            this.findMatch(matchRequest,callback);
        },
        cancelAutoMatch : function() {

        },

        addPlayersToMatch : function(matchRequest, match, callback) {
            callback({message:"Not implemmented"});
        },
        getPlayerID : function() {
            return this.playerID;
        },

        getMatch : function() {
            return this.currentMatch;
        }
    }

    CocoonJS.extend(CocoonJS.Multiplayer.LoopbackService, CocoonJS.Multiplayer.MultiplayerService);

    var LoopbackMatch = function(service) {
        matchCounter++;
        LoopbackMatch.superclass.constructor.call(this, "","",matchCounter);
        this.started = false;
        this.disconnected = false;
        this.pendingData = [];
        this.service = service;
    }

    LoopbackMatch.prototype = {

        start : function() {
            var me = this;
            setTimeout(function() {
                me.started = true;
                for (var i = 0; i < me.pendingData.length; ++i) {
                    me.onMatchDataReceived.notifyEventListeners(me.matchID,me.pendingData[i].data, me.pendingData[i].player);
                }

            },0);

        },
        sendDataToAllPlayers : function(data, sendMode) {
            this.sendData(data, this.playerIDs, sendMode);
        },

        sendData : function(data, playerIDs,  sendMode) {
            var me = this;
            setTimeout(function() {
                for (var i = 0; i< loopbackServices.length; ++i) {
                    var destService = null;
                    for (var j = 0; j < playerIDs.length; ++j) {
                        if (playerIDs[j] === loopbackServices[i].getPlayerID()) {
                            destService = loopbackServices[i];
                        }
                    }
                    if (destService) {
                        destService.getMatch().notifyDataReceived(data,me.service.getPlayerID());
                    }
                }
            },0);
        },

        disconnect : function() {
            this.disconnected = true;
            for (var i = 0; i < this.playerIDs.length; ++i) {
                var p = this.playerIDs[i];
                for (var j = 0; j < loopbackServices.length; ++j) {
                    if (loopbackServices[j].getPlayerID() === p) {
                        var match = loopbackServices[i].getMatch();
                        if (!match.disconnected) {
                            match.onMatchStateChanged.notifyEventListeners(match, this.service.getPlayerID(), CocoonJS.Multiplayer.ConnectionState.DISCONNECTED);
                        }
                    }
                }
            }
        },

        requestPlayersInfo : function(callback) {
            var me = this;
            setTimeout(function() {
               var playersInfo = [];
                for (var i = 0; i < me.playerIDs.length; ++i) {
                    playersInfo[i] = {userID: me.playerIDs[i], userName: "Player" + me.playerIDs[i]};
                };
                callback(playersInfo);
            },1);
        },

        getExpectedPlayerCount : function() {
            return 0;
        },
        getPlayerIDs : function() {
            return this.playerIDs;
        },
        getLocalPlayerID: function() {
            return this.service.playerID;
        },
        notifyDataReceived: function(data, fromPlayer) {
            if (!this.started) {
                this.pendingData.push({data:data, player:fromPlayer});
            }
            else {
                this.onMatchDataReceived.notifyEventListeners(this.matchID,data,fromPlayer);
            }
        }

    };

    CocoonJS.extend(LoopbackMatch, CocoonJS.Multiplayer.Match);

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (!window) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (!window.CocoonJS.Multiplayer) throw("The CocoonJS.Multiplayer object must exist and be valid before creating a Google Play Games extension object.");

    /**
     * @namespace
     * This instance represents the extension object to access Google Play Games Multiplayer API.
     * @see CocoonJS.Multiplayer.MultiplayerService
     */
    CocoonJS.Multiplayer.GooglePlayGames = new CocoonJS.Multiplayer.MultiplayerService("IDTK_SRV_MULTIPLAYER_GPG", "Multiplayer.GooglePlayGames");
})();
;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();;(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS camera extension API.
    * @namespace
    */
    CocoonJS.Camera = {};

    CocoonJS.Camera.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_CAMERA !== 'undefined';

    /**
    * The predefined possible camera types.
    * @namespace 
    */
	CocoonJS.Camera.CameraType = {
		/**
		* Represents the front camera on the device.
		*/
	    FRONT : "FRONT",

	    /**
	    * Represents the back camera on the device.
	    */
	    BACK : "BACK"
	};

    /**
    * The predefined possible camera video capturing image format types.
    * @namespace 
    */
	CocoonJS.Camera.CaptureFormatType = {
		/**
		*/
	    JPEG : "JPEG",

		/**
		*/
	    RGB_565 : "RGB_565",

		/**
		*/
	    NV21 : "NV21", 

		/**
		*/
	    NV16 : "NV16",

		/**
		*/
	    YUY2 : "YUY2",

		/**
		*/
	    YV12 : "YV12",

		/**
		*/
	    BGRA32 : "32BGRA"
	};

	/**
	* The data structure that represents the information of a camera. It includes all the information to be able to setup a camera to capture video or to take pictures.
	* @namespace
	*/
	CocoonJS.Camera.CameraInfo =  {
		/**
		* The index of the camera.
		*/
		cameraIndex : 0,

		/**
		* The type of the camera among the possible values in {@link CocoonJS.Camera.CameraType}.
		*/
		cameraType : CocoonJS.Camera.CameraType.BACK,

		/**
		* An array of {@link CocoonJS.Size} values that represent the supported video sizes for the camera.
		*/
		supportedVideoSizes : [],

		/**
		* An array of numbers that represent the supported video frame rates for the camera.
		*/
		supportedVideoFrameRates : [],

		/**
		* An array of {@link CocoonJS.Camera.CaptureFormatType} values that represent the supported video format types for the camera.
		*/
		supportedVideoCaptureImageFormats : []
	};

	/**
	* Returns the number of available camera in the platform/device.
	* @returns {number} The number of cameras available in the platform/device.
	*/
	CocoonJS.Camera.getNumberOfCameras = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getNumberOfCameras", arguments);
		}
	};

	/**
	* Returns an array of {@link CocoonJS.Camera.CameraInfo} objects representing all the information of all the cameras available in the platform/device.
	* @returns {Array} An array of {@link CocoonJS.Camera.CameraInfo} objects.
	*/
	CocoonJS.Camera.getAllCamerasInfo = function()
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getAllCamerasInfo", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the specified camera index in the platform/device.
	* @param {number} cameraIndex The index of the camera to get the info from. The index should be inside 0 and N (N being the value returned by {@link CocoonJS.Camera.getNumberOfCameras}).
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the given camera index.
	*/
	CocoonJS.Camera.getCameraInfoByIndex = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByIndex", arguments);
		}
	};

	/**
	* Returns the {@link CocoonJS.Camera.CameraInfo} object that represents all the information of the first camera of the specified type found in the platform/device.
	* @param {CocoonJS.Camera.CameraType} cameraType The type of the camera to get the info from. 
	* @returns {CocoonJS.Camera.CameraInfo} The {@link CocoonJS.Camera.CameraInfo} of the first camera of the given camera type that has been found in the platform/device.
	*/
	CocoonJS.Camera.getCameraInfoByType = function(cameraType)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "getCameraInfoByType", arguments);
		}
	};

	/**
	* Starts a camera to capture video. The developer must specify at least the index of the camera to be used. Some other setup parameters can also be passed to control the video capture. A image object
	* that will be automatically updated with the captured frames is returned so the developer just need to draw the image in every frame. A null image object is returned if the setup did not work or there is
	* no available camera.
	* @param {number} cameraIndex The index of the camera to start video capture with.
	* @param captureWidth The hozirontal size of the video capture resolution. If the value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureHeight The vertical size of the video capture resolution. If value does not correspond to any of the sizes supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum size available is used.
	* @param captureFrameRate The frame rate to capture the video at. If the value does not correspond to any of the frame rates supported by the camera, the closest one is used. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the maximum frame rate available is used.
	* @param captureImageFormat A value from the available {@link CocoonJS.Camera.CaptureFormatType} formats to specify the format of the images that will be captured. See {@link CocoonJS.Camera.CameraInfo}.
	* If no value is given, the first available capture image format is used.
	* @returns {image} A image object that will automatically update itself with the captured frames or null if the camera capture could not start.
	*/
	CocoonJS.Camera.startCapturing = function(cameraIndex, captureWidth, captureHeight, captureFrameRate, captureImageFormat)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "startCapturing", arguments);
		}
	};

	/**
	* Stops a camera that is already started capturing video.
	* @param cameraIndex The index of the camera to stop capturing video.
	*/
	CocoonJS.Camera.stopCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "stopCapturing", arguments);
		}
	};

	/**
	* Indicates if a camera is capturing video or not.
	* @param cameraIndex The index of the camera to check if is capturing video or not.
	* @returns {boolean} A flag indicating if the given camera (by index) is capturing video (true) or not (false).
	*/
	CocoonJS.Camera.isCapturing = function(cameraIndex)
	{
		if (CocoonJS.Camera.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_CAMERA", "isCapturing", arguments);
		}
	};

})();;(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    /**
    * This enumeration simplifies the access to the indices for button and axis elements according to the HTML5 gamepad standard API specification.
    * You may use these values to access the buttons and axes arrays inside the Gamepad objects, according to the W3C gamepad API specification.
    * For example: 
    * gamepad.button[CocoonJS.Gamepad.BUTTON_LEFT_TRIGGER]; 
    * gamepad.axes[CocoonJS.Gamepad.AXIS_LEFT_JOYSTICK_X]; 
    * @namespace
    */
    CocoonJS.Gamepad.Indices = {
        /**
        * Represents the button 0 (the A on the XBOX controller, the O on the OUYA controller)
        */
        BUTTON_0                : 0, 
        /**
        * Represents the button 1 (the B on the XBOX controller, the A on the OUYA controller)
        */
        BUTTON_1                : 1,
        /**
        * Represents the button 2 (the X on the XBOX controller, the U on the OUYA controller)
        */
        BUTTON_2                : 2,
        /**
        * Represents the button 3 (the Y on the XBOX controller, the Y on the OUYA controller)
        */
        BUTTON_3                : 3,
        /**
        * Represents the left bumper button.
        */
        BUTTON_LEFT_BUMPER      : 4,
        /**
        * Represents the right bumper button.
        */
        BUTTON_RIGHT_BUMPER     : 5,
        
        /**
        * Represents the left trigger button.
        */
        BUTTON_LEFT_TRIGGER     : 6,
        /**
        * Represents the right trigger button.
        */
        BUTTON_RIGHT_TRIGGER    : 7,
        
        /**
        * Represents the left joystick button.
        */
        BUTTON_LEFT_JOYSTICK    : 10,
        /**
        * Represents the right joystick button.
        */
        BUTTON_RIGHT_JOYSTICK   : 11,
        /**
        * Represents the dpad up button.
        */
        BUTTON_DPAD_UP          : 12,
        /**
        * Represents the dpad down button.
        */
        BUTTON_DPAD_DOWN        : 13,
        /**
        * Represents the dpad left button.
        */
        BUTTON_DPAD_LEFT        : 14,
        /**
        * Represents the dpad right button.
        */
        BUTTON_DPAD_RIGHT       : 15,
        /**
        * Represents the menu button.
        */
        BUTTON_MENU             : 16,
        
        /**
        * Represents the left joystick horizontal axis.
        */
        AXIS_LEFT_JOYSTICK_X     : 0,
        /**
        * Represents the left joystick vertical axis.
        */
        AXIS_LEFT_JOYSTICK_Y     : 1,
        /**
        * Represents the right joystick horizontal axis.
        */
        AXIS_RIGHT_JOYSTICK_X    : 2,
        /**
        * Represents the right joystick vertical axis.
        */
        AXIS_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();



;(function() {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw ("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the CocoonJS Notification extension.
     * @namespace
     */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.createLocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {

        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "createLocalNotification", arguments);
        }
    };


    /**
     * The data structure that represents the information of a local notification.
     * @namespace
     * @constructor
     * @deprecated
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {string} contentBody The body content to be showed in the expanded notification information.
     * @param {string} contentTitle The title to be showed in the expanded notification information.
     * @param {number} date Time in millisecs from 1970 when the notification will be fired.
     */
    CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime) {
        //The id is initialized with -1 for compatibility issues.
        //The new way to use is createLocalNotification. These can be cancelled and the ID is sent from native code to the 
        this.id = -1;

        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * (iOS only) The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData;

        /**
         * (Android only) The body content to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentBody !== undefined)
            this.contentBody = contentBody;
        else
            this.contentBody = "";

        /**
         * (Android only) The title to be showed in the expanded notification information.
         * @field
         * @type string
         */
        if (contentTitle !== undefined)
            this.contentTitle = contentTitle;
        else
            this.contentTitle = "";

        /**
         * Time in millisecs from 1970 when the local notification will be fired
         * @field
         * @type number
         */
        var currentTime = new Date().getTime();
        if (scheduleTime !== undefined) {
            this.scheduleTime = scheduleTime;
        } else {
            this.scheduleTime = currentTime;
        }
    };

    /**
     * The data structure that represents the information of a push notification.
     * @namespace
     * @constructor
     * @param {string} message The notification message.
     * @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
     * @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
     * @param {object} userData The JSON data to attached to the notification.
     * @param {array} channels An array containing the channels names this notification will be delivered to.
     * @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     * @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
     */
    CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval) {
        /**
         * The notification message.
         * @field
         * @type string
         */
        this.message = message;

        /**
         * A flag that indicates if the sound should be enabled for the notification.
         * @field
         * @type boolean
         */
        this.soundEnabled = soundEnabled;

        /**
         * The number that will appear in the badge of the application icon in the home screen.
         * @field
         * @type number
         */
        this.badgeNumber = badgeNumber;

        /**
         * The JSON data to attached to the notification.
         * @field
         * @type object
         */
        this.userData = userData

        /**
         * An array containing the channels names this notification will be delivered to.
         * @field
         * @type array
         */
        this.channels = channels;

        /**
         * A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTime !== undefined)
            this.expirationTime = expirationTime;
        else
            this.expirationTime = 0;

        /**
         * An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
         * @field
         * @type number
         */
        if (expirationTimeInterval !== undefined)
            this.expirationTimeInterval = expirationTimeInterval;
        else
            this.expirationTimeInterval = 0;
    };

    /**
     * Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
     */
    CocoonJS.Notification.start = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments);
        }
    };


    /**
     * Register to be able to receive push notifications.
     * The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
     * @function
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
     * @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
     */
    CocoonJS.Notification.registerForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
        }
    };

    /**
     * Unregister from receiving push notifications.
     * The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
     * @function
     * @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
     */
    CocoonJS.Notification.unregisterForPushNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
        }
    };

    /**
     * Cancel the local notification with Id provided.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelLocalNotification = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments);
        }
    };

    /**
     * Cancel the last sent local notification.
     * The last sent local notification will be remove from the notifications bar.
     * @function
     */

    //TODO: Change this function to be an extension of cancelLocalNotification
    CocoonJS.Notification.cancelLastSentLocalNotificiation = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
        }
    };

    /**
     * Cancel all sent local notifications.
     * All the notifications will ve removed from the notifications bar.
     * @function
     */
    CocoonJS.Notification.cancelAllLocalNotifications = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments);
        }
    };

    /**
     * Send a local notification.
     * @function
     * @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
     */
    CocoonJS.Notification.sendLocalNotification = function(localNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
        }
    };

    /**
     * Subscribe to a channel in order to receive notifications targeted to that channel.
     * @function
     * @param {string} channel The channel id to subscribe to.
     */
    CocoonJS.Notification.subscribeToChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
        }
    };

    /**
     * Unsubscribe from a channel in order to stop receiving notifications targeted to it.
     * @function
     * @param {string} channel The channel id to unsubscribe from.
     */
    CocoonJS.Notification.unsubscribeFromChannel = function(channel) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
        }
    };

    /**
     * Send a push notification.
     * @function
     * @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
     * @see CocoonJS.Notification.onPushNotificationDeliverySucceed
     * @see CocoonJS.Notification.onPushNotificationDeliveryFailed
     */
    CocoonJS.Notification.sendPushNotification = function(pushNotification) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
        }
    };

    /**
     * (iOS only) Set the badge number for this application.
     * This is useful if you want to modify the badge number set by a notification.
     * @function
     * @param {number} badgeNumber The number of the badge.
     */
    CocoonJS.Notification.setBadgeNumber = function(badgeNumber) {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
        }
    };

    /**
     * (iOS only) Returns the current badge number.
     * @function
     * @returns {number} The badge number.
     */
    CocoonJS.Notification.getBadgeNumber = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
        }
    };

    /**
     * Returns the last received user data from a Local notification.
     * @function
     * @returns {object} The last received user data from a Local notification.
     */
    CocoonJS.Notification.getLastReceivedLocalNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
        }
    };

    /**
     * Returns the last received user data from a Push notification.
     * @function
     * @returns {object} The last received user data from a Push notification.
     */
    CocoonJS.Notification.getLastReceivedPushNotificationData = function() {
        if (CocoonJS.Notification.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
        }
    };

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @param {string} token The token (apid or device token) received at registration time.
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
     * The callback function does not receive any parameter.
     * @static
     * @event
     * @memberOf CocoonJS.Notification
     */
    CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
     * The callback function receives a parameter with the userData of the received notification.
     * @static
     * @event
     * @param {object} userData An object with the notification userData information.
     */
    CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
     * The callback function receives a parameter with the notificationId of the delivered notification.
     * @static
     * @event
     * @param {string} userData A string with the notification userData information.
     */
    CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
     * The callback function receives a parameter with error information.
     * @static
     * @event
     * @param {string} msg The error message.
     */
    CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

CocoonJS.App.setNPOTEnabled(false); //change to true to reduce memory usage. It might reduce performance on old GPUs.
//CocoonJS.App.setMaxMemory(70); //Uncomment this line to set the maxMemory threshold in Megabytes.

/*! CocoonJSExtensions - v2.0.0 - 2014-04-10 www.ludei.com */window.ext&&"undefined"!=typeof window.ext.IDTK_SRV_BOX2D?(window.Box2D={},window.Box2D.Dynamics={},window.Box2D.Dynamics.Joints={},window.Box2D.Common={},window.Box2D.Common.Math={},window.Box2D.Collision={},window.Box2D.Collision.Shapes={},function(){"use strict";function a(a){console.error(a)}var b=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b};window.Box2D.Common.Math.b2Vec2=b,b.prototype.SetZero=function(){this.x=0,this.y=0},b.prototype.Set=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0),this.x=a,this.y=b},b.prototype.SetV=function(b){void 0===b&&a("undefined 'v' in b2Vec2.SetV"),this.x=b.x,this.y=b.y},b.Make=function(a,c){return void 0===a&&(a=0),void 0===c&&(c=0),new b(a,c)},void 0===b.Get&&(b.Get=b.Make,b._freeCache=[],b.Free=function(){}),b.prototype.Copy=function(){return new b(this.x,this.y)},b.prototype.Add=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Add"),this.x+=b.x,this.y+=b.y},b.prototype.Subtract=function(b){void 0===b&&a("undefined 'v' in b2Vec2.Subtract"),this.x-=b.x,this.y-=b.y},b.prototype.Multiply=function(a){void 0===a&&(a=0),this.x*=a,this.y*=a},b.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)},b.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y},b.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;return this.x*=b,this.y*=b,a},b.prototype.NegativeSelf=function(){this.x=-this.x,this.y=-this.y};var c=function(){this.col1=new b,this.col2=new b,this.SetIdentity()};window.Box2D.Common.Math.b2Mat22=c,c.FromAngle=function(a){void 0===a&&(a=0);var b=new c;return b.Set(a),b},c.FromVV=function(a,b){var d=new c;return d.SetVV(a,b),d},c.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a),c=Math.sin(a);this.col1.x=b,this.col2.x=-c,this.col1.y=c,this.col2.y=b},c.prototype.SetVV=function(a,b){this.col1.SetV(a),this.col2.SetV(b)},c.prototype.Copy=function(){var a=new c;return a.SetM(this),a},c.prototype.SetM=function(a){this.col1.SetV(a.col1),this.col2.SetV(a.col2)},c.prototype.AddM=function(a){this.col1.x+=a.col1.x,this.col1.y+=a.col1.y,this.col2.x+=a.col2.x,this.col2.y+=a.col2.y},c.prototype.SetIdentity=function(){this.col1.x=1,this.col2.x=0,this.col1.y=0,this.col2.y=1},c.prototype.SetZero=function(){this.col1.x=0,this.col2.x=0,this.col1.y=0,this.col2.y=0},c.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)},c.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*d;return 0!==f&&(f=1/f),a.col1.x=f*e,a.col2.x=-f*c,a.col1.y=-f*d,a.col2.y=f*b,a},c.prototype.Solve=function(a,b,c){void 0===b&&(b=0),void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,g=this.col2.y,h=d*g-e*f;return 0!==h&&(h=1/h),a.x=h*(g*b-e*c),a.y=h*(d*c-f*b),a},c.prototype.Abs=function(){this.col1.Abs(),this.col2.Abs()};var d=function(a,d){this.position=new b,this.R=new c,void 0===a&&(a=null),void 0===d&&(d=null),a&&(this.position.SetV(a),this.R.SetM(d))};window.Box2D.Common.Math.b2Transform=d,d.prototype.Initialize=function(a,b){this.position.SetV(a),this.R.SetM(b)},d.prototype.SetIdentity=function(){this.position.SetZero(),this.R.SetIdentity()},d.prototype.Set=function(a){this.position.SetV(a.position),this.R.SetM(a.R)},d.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var e=function(){};window.Box2D.Common.Math.b2Math=e,e.IsValid=function(a){return void 0===a&&(a=0),isFinite(a)},e.Dot=function(a,b){return a.x*b.x+a.y*b.y},e.CrossVV=function(a,b){return a.x*b.y-a.y*b.x},e.CrossVF=function(a,c){void 0===c&&(c=0);var d=new b(c*a.y,-c*a.x);return d},e.CrossFV=function(a,c){void 0===a&&(a=0);var d=new b(-a*c.y,a*c.x);return d},e.MulMV=function(c,d){void 0===d&&a("undefined 'v' in b2Math.MulMV");var e=new b(c.col1.x*d.x+c.col2.x*d.y,c.col1.y*d.x+c.col2.y*d.y);return e},e.MulTMV=function(a,c){var d=new b(e.Dot(c,a.col1),e.Dot(c,a.col2));return d},e.MulX=function(a,b){var c=e.MulMV(a.R,b);return c.x+=a.position.x,c.y+=a.position.y,c},e.MulXT=function(a,b){var c=e.SubtractVV(b,a.position),d=c.x*a.R.col1.x+c.y*a.R.col1.y;return c.y=c.x*a.R.col2.x+c.y*a.R.col2.y,c.x=d,c},e.AddVV=function(a,c){var d=new b(a.x+c.x,a.y+c.y);return d},e.SubtractVV=function(a,c){var d=new b(a.x-c.x,a.y-c.y);return d},e.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)},e.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d},e.MulFV=function(a,c){void 0===a&&(a=0);var d=new b(a*c.x,a*c.y);return d},e.AddMM=function(a,b){var d=c.FromVV(e.AddVV(a.col1,b.col1),e.AddVV(a.col2,b.col2));return d},e.MulMM=function(a,b){var d=c.FromVV(e.MulMV(a,b.col1),e.MulMV(a,b.col2));return d},e.MulTMM=function(a,d){var f=new b(e.Dot(a.col1,d.col1),e.Dot(a.col2,d.col1)),g=new b(e.Dot(a.col1,d.col2),e.Dot(a.col2,d.col2)),h=c.FromVV(f,g);return h},e.Abs=function(a){return void 0===a&&(a=0),a>0?a:-a},e.AbsV=function(a){var c=new b(e.Abs(a.x),e.Abs(a.y));return c},e.AbsM=function(a){var b=c.FromVV(e.AbsV(a.col1),e.AbsV(a.col2));return b},e.Min=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),b>a?a:b},e.MinV=function(a,c){var d=new b(e.Min(a.x,c.x),e.Min(a.y,c.y));return d},e.Max=function(a,b){return void 0===a&&(a=0),void 0===b&&(b=0),a>b?a:b},e.MaxV=function(a,c){var d=new b(e.Max(a.x,c.x),e.Max(a.y,c.y));return d},e.Clamp=function(a,b,c){return void 0===a&&(a=0),void 0===b&&(b=0),void 0===c&&(c=0),b>a?b:a>c?c:a},e.ClampV=function(a,b,c){return e.MaxV(b,e.MinV(a,c))},e.Swap=function(a,b){var c=a[0];a[0]=b[0],b[0]=c},e.Random=function(){return 2*Math.random()-1},e.RandomRange=function(a,b){void 0===a&&(a=0),void 0===b&&(b=0);var c=Math.random();return c=(b-a)*c+a},e.NextPowerOfTwo=function(a){return void 0===a&&(a=0),a|=a>>1&2147483647,a|=a>>2&1073741823,a|=a>>4&268435455,a|=a>>8&16777215,a|=a>>16&65535,a+1},e.IsPowerOfTwo=function(a){void 0===a&&(a=0);var b=a>0&&0===(a&a-1);return b},e.b2Vec2_zero=new b(0,0),e.b2Mat22_identity=c.FromVV(new b(1,0),new b(0,1)),e.b2Transform_identity=new d(e.b2Vec2_zero,e.b2Mat22_identity);var f=function(){this.e_aabbBit=4,this.e_centerOfMassBit=16,this.e_controllerBit=32,this.e_jointBit=2,this.e_pairBit=8,this.e_shapeBit=0};window.Box2D.Dynamics.b2DebugDraw=f,f.prototype.AppendFlags=function(){},f.prototype.ClearFlags=function(){},f.prototype.DrawCircle=function(){},f.prototype.DrawPolygon=function(){},f.prototype.DrawSegment=function(){},f.prototype.DrawSolidCircle=function(){},f.prototype.DrawSolidPolygon=function(){},f.prototype.DrawTransform=function(){},f.prototype.GetAlpha=function(){},f.prototype.GetDrawScale=function(){},f.prototype.GetFillAlpha=function(){},f.prototype.GetFlags=function(){},f.prototype.GetLineThickness=function(){},f.prototype.GetSprite=function(){},f.prototype.GetXFormScale=function(){},f.prototype.SetAlpha=function(){},f.prototype.SetDrawScale=function(){},f.prototype.SetFillAlpha=function(){},f.prototype.SetFlags=function(){},f.prototype.SetLineThickness=function(){},f.prototype.SetSprite=function(){},f.prototype.SetXFormScale=function(){};var g=function(){this.position=new b(0,0),this.linearVelocity=new b,this.userData=null,this.angle=0,this.linearVelocity.Set(0,0),this.angularVelocity=0,this.linearDamping=0,this.angularDamping=0,this.allowSleep=!0,this.awake=!0,this.fixedRotation=!1,this.bullet=!1,this.type=i.b2_staticBody,this.active=!0,this.inertiaScale=1};window.Box2D.Dynamics.b2BodyDef=g;var h=function(a,c,d,e){this.m_body=a,this.m_userData=c,this.m_fixtureID=d,this.m_shape={},this.m_shape.m_centroid=new b,this.m_isSensor=!1,this.m_density=e.density,this.m_friction=e.friction,this.m_restitution=e.restitution,this.m_isSensor=e.isSensor};window.Box2D.Dynamics.b2Fixture=h,h.prototype.GetBody=function(){return this.m_body},h.prototype.GetShape=function(){return console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding"),null},h.prototype.GetUserData=function(){return this.m_userData},h.prototype.SetSensor=function(a){this.m_isSensor=a,window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)},h.prototype.IsSensor=function(){return this.m_isSensor},h.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_density=a},h.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_friction=a},h.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a),this.m_restitution=a},h.prototype.GetDensity=function(){return this.m_density},h.prototype.GetFriction=function(){return this.m_friction},h.prototype.GetRestitution=function(){return this.m_restitution};var i=function(a,b){var e=a.userData;a.userData=null,this.m_world=b,this.m_xf=new d(a.position,c.FromAngle(a.angle)),this.m_fixtures=[],this.m_active=a.active,a.type===i.b2_staticBody&&(a.density=0),this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",b.m_worldID,a),this.m_userData=e,a.userData=e};window.Box2D.Dynamics.b2Body=i,i.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;var d=new h(this,b,c,a);return this.m_world.m_fixturesList[c]=d,this.m_fixtures.push(d),d},i.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]},i.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID),delete this.m_world.m_fixturesList[a.m_fixtureID]},i.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b),this.m_xf.R.Set(b),this.m_xf.position.SetV(a)},i.prototype.GetPosition=function(){return this.m_xf.position},i.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())},i.prototype.GetLinearVelocity=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetWorldCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalCenter=function(){var a=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",this.m_world.m_worldID,this.m_bodyID);return new b(a[0],a[1])},i.prototype.GetLocalPoint=function(a){return e.MulXT(this.m_xf,a)},i.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)},i.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,this.m_bodyID)},i.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)},i.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",this.m_world.m_worldID,this.m_bodyID,a.x,a.y)},i.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)},i.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)},i.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)},i.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)},i.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a),this.m_active=a},i.prototype.IsActive=function(){return this.m_active},i.prototype.GetAngle=function(){return this.m_xf.R.GetAngle()},i.prototype.SetAngle=function(a){void 0===a&&(a=0),this.SetPositionAndAngle(this.GetPosition(),a)},i.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b},i.prototype.SetUserData=function(a){this.m_userData=a},i.prototype.GetUserData=function(){return this.m_userData},i.prototype.GetWorld=function(){return this.m_world},window.Box2D.Dynamics.b2Body.b2_staticBody=0,window.Box2D.Dynamics.b2Body.b2_kinematicBody=1,window.Box2D.Dynamics.b2Body.b2_dynamicBody=2;var j=function(a,b,c){this.m_fixtureA=a,this.m_fixtureB=b,this.m_touching=c};window.Box2D.Dynamics.b2Contact=j,j.prototype.GetFixtureA=function(){return this.m_fixtureA},j.prototype.GetFixtureB=function(){return this.m_fixtureB},j.prototype.IsTouching=function(){return this.m_touching};var k=function(){};window.Box2D.Dynamics.b2ContactListener=k,k.prototype.BeginContact=function(){},k.prototype.EndContact=function(){},k.prototype.PreSolve=function(){},k.prototype.PostSolve=function(){},window.Box2D.Dynamics.b2ContactListener.b2_defaultListener=new k;var l=function(){};window.Box2D.Dynamics.b2ContactFilter=l;var m=function(a,b){this.m_bodyList=[],this.m_jointList=[],this.m_fixturesList=[],this.m_contactListener=null,this.m_jointsList=[],this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};window.Box2D.Dynamics.b2World=m,m.prototype.SetContactListener=function(a){this.m_contactListener=a},m.prototype.SetContactFilter=function(a){var b=a,c=this,d=function(a,d){var e=c.m_fixturesList[a],f=c.m_fixturesList[d];return b.ShouldCollide(e,f)};window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,d)},m.prototype.CreateBody=function(a){var b=new i(a,this);return this.m_bodyList[b.m_bodyID]=b,b},m.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID),delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]},m.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID,a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===o.e_revoluteJoint&&(d="createRevoluteJoint");var e=new o(a);return e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a),a.bodyA=b,a.bodyB=c,this.m_jointsList.push(e),e}},m.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)},m.prototype.GetJointList=function(){if(0===this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];return this.m_jointsList[this.m_jointsList.length-1].next=null,this.m_jointsList[0]},m.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)},m.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)},m.prototype.Step=function(a,b,c){var d,e=window.ext.IDTK_SRV_BOX2D.makeCall("step",this.m_worldID,a,b,c),f=e[0];for(d=1;4*f>=d;d+=4){var g=this.m_bodyList[e[d+0]];if(null===g)break;g.m_xf.position.Set(e[d+1],e[d+2]),g.m_xf.R.Set(e[d+3])}if(null!==this.m_contactListener){var h=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID);for(f=h[0],d=1;3*f>=d;d+=3){var i=h[d+0],k=h[d+1],l=h[d+2],m=this.m_fixturesList[i],n=this.m_fixturesList[k];"undefined"!=typeof m&&"undefined"!=typeof n?this.m_contactListener.BeginContact(new j(m,n,l)):console.log("One of the fixtures in a contact DOESN'T EXIST!!")}}},m.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)},m.prototype.SetDebugDraw=function(){},m.prototype.DrawDebugData=function(){},window.Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a,this.type="circle"},window.Box2D.Collision.Shapes.b2PolygonShape=function(){this.SetAsBox=function(a,b){this.type="box",this.width=a,this.height=b},this.SetAsEdge=function(a,b){this.type="edge",this.p1x=a.x,this.p1y=a.y,this.p2x=b.x,this.p2y=b.y},this.SetAsArray=function(a,b){this.type="polygon",this.vertices=[];for(var c=0;b>c;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)}};var n=function(){this.shape=null,this.userData=null,this.friction=.2,this.restitution=0,this.density=0,this.isSensor=!1,this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};window.Box2D.Dynamics.b2FixtureDef=n;var o=function(a){this.bodyA=a.bodyA,this.bodyB=a.bodyB,this.userData=a.userData,this.type=a.type,this.next=null};window.Box2D.Dynamics.Joints.b2Joint=o,o.prototype.GetBodyA=function(){return this.bodyA},o.prototype.GetBodyB=function(){return this.bodyB},o.prototype.GetUserData=function(){return this.userData},o.prototype.GetType=function(){return this.type},o.prototype.GetNext=function(){return this.next},o.e_distanceJoint=0,o.e_revoluteJoint=1;var p=function(a,c,d,e){if(this.type=o.e_distanceJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),void 0!==d&&void 0!==e){var f=e.x-d.x,g=e.y-d.y;this.length=Math.sqrt(f*f+g*g)}this.frequencyHz=0,this.dampingRatio=0};window.Box2D.Dynamics.Joints.b2DistanceJointDef=p;var q=function(a,c,d,e){this.type=o.e_revoluteJoint,this.localAnchorA=new b,this.localAnchorB=new b,this.userData=null,void 0!==a&&(this.bodyA=a),void 0!==c&&(this.bodyB=c),void 0!==d&&this.localAnchorA.SetV(d),void 0!==e&&this.localAnchorB.SetV(e),this.referenceAngle=0,this.lowerAngle=0,this.upperAngle=0,this.maxMotorTorque=0,this.motorSpeed=0,this.enableLimit=!1,this.enableMotor=!1};q.prototype.Initialize=function(a,b,c){this.bodyA=a,this.bodyB=b,this.localAnchorA=this.bodyA.GetLocalPoint(c),this.localAnchorB=this.bodyB.GetLocalPoint(c),this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()},window.Box2D.Dynamics.Joints.b2RevoluteJointDef=q}()):console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");

(function() {
var cr = {};
cr.plugins_ = {};
cr.behaviors = {};
if (typeof Object.getPrototypeOf !== "function")
{
	if (typeof "test".__proto__ === "object")
	{
		Object.getPrototypeOf = function(object) {
			return object.__proto__;
		};
	}
	else
	{
		Object.getPrototypeOf = function(object) {
			return object.constructor.prototype;
		};
	}
}
(function(){
	cr.logexport = function (msg)
	{
		if (window.console && window.console.log)
			window.console.log(msg);
	};
	cr.seal = function(x)
	{
		return x;
	};
	cr.freeze = function(x)
	{
		return x;
	};
	cr.is_undefined = function (x)
	{
		return typeof x === "undefined";
	};
	cr.is_number = function (x)
	{
		return typeof x === "number";
	};
	cr.is_string = function (x)
	{
		return typeof x === "string";
	};
	cr.isPOT = function (x)
	{
		return x > 0 && ((x - 1) & x) === 0;
	};
	cr.nextHighestPowerOfTwo = function(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	cr.abs = function (x)
	{
		return (x < 0 ? -x : x);
	};
	cr.max = function (a, b)
	{
		return (a > b ? a : b);
	};
	cr.min = function (a, b)
	{
		return (a < b ? a : b);
	};
	cr.PI = Math.PI;
	cr.round = function (x)
	{
		return (x + 0.5) | 0;
	};
	cr.floor = function (x)
	{
		if (x >= 0)
			return x | 0;
		else
			return (x | 0) - 1;		// correctly round down when negative
	};
	cr.ceil = function (x)
	{
		var f = x | 0;
		return (f === x ? f : f + 1);
	};
	function Vector2(x, y)
	{
		this.x = x;
		this.y = y;
		cr.seal(this);
	};
	Vector2.prototype.offset = function (px, py)
	{
		this.x += px;
		this.y += py;
		return this;
	};
	Vector2.prototype.mul = function (px, py)
	{
		this.x *= px;
		this.y *= py;
		return this;
	};
	cr.vector2 = Vector2;
	cr.segments_intersect = function(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y)
	{
		var max_ax, min_ax, max_ay, min_ay, max_bx, min_bx, max_by, min_by;
		if (a1x < a2x)
		{
			min_ax = a1x;
			max_ax = a2x;
		}
		else
		{
			min_ax = a2x;
			max_ax = a1x;
		}
		if (b1x < b2x)
		{
			min_bx = b1x;
			max_bx = b2x;
		}
		else
		{
			min_bx = b2x;
			max_bx = b1x;
		}
		if (max_ax < min_bx || min_ax > max_bx)
			return false;
		if (a1y < a2y)
		{
			min_ay = a1y;
			max_ay = a2y;
		}
		else
		{
			min_ay = a2y;
			max_ay = a1y;
		}
		if (b1y < b2y)
		{
			min_by = b1y;
			max_by = b2y;
		}
		else
		{
			min_by = b2y;
			max_by = b1y;
		}
		if (max_ay < min_by || min_ay > max_by)
			return false;
		var dpx = b1x - a1x + b2x - a2x;
		var dpy = b1y - a1y + b2y - a2y;
		var qax = a2x - a1x;
		var qay = a2y - a1y;
		var qbx = b2x - b1x;
		var qby = b2y - b1y;
		var d = cr.abs(qay * qbx - qby * qax);
		var la = qbx * dpy - qby * dpx;
		if (cr.abs(la) > d)
			return false;
		var lb = qax * dpy - qay * dpx;
		return cr.abs(lb) <= d;
	};
	function Rect(left, top, right, bottom)
	{
		this.set(left, top, right, bottom);
		cr.seal(this);
	};
	Rect.prototype.set = function (left, top, right, bottom)
	{
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	};
	Rect.prototype.copy = function (r)
	{
		this.left = r.left;
		this.top = r.top;
		this.right = r.right;
		this.bottom = r.bottom;
	};
	Rect.prototype.width = function ()
	{
		return this.right - this.left;
	};
	Rect.prototype.height = function ()
	{
		return this.bottom - this.top;
	};
	Rect.prototype.offset = function (px, py)
	{
		this.left += px;
		this.top += py;
		this.right += px;
		this.bottom += py;
		return this;
	};
	Rect.prototype.normalize = function ()
	{
		var temp = 0;
		if (this.left > this.right)
		{
			temp = this.left;
			this.left = this.right;
			this.right = temp;
		}
		if (this.top > this.bottom)
		{
			temp = this.top;
			this.top = this.bottom;
			this.bottom = temp;
		}
	};
	Rect.prototype.intersects_rect = function (rc)
	{
		return !(rc.right < this.left || rc.bottom < this.top || rc.left > this.right || rc.top > this.bottom);
	};
	Rect.prototype.intersects_rect_off = function (rc, ox, oy)
	{
		return !(rc.right + ox < this.left || rc.bottom + oy < this.top || rc.left + ox > this.right || rc.top + oy > this.bottom);
	};
	Rect.prototype.contains_pt = function (x, y)
	{
		return (x >= this.left && x <= this.right) && (y >= this.top && y <= this.bottom);
	};
	Rect.prototype.equals = function (r)
	{
		return this.left === r.left && this.top === r.top && this.right === r.right && this.bottom === r.bottom;
	};
	cr.rect = Rect;
	function Quad()
	{
		this.tlx = 0;
		this.tly = 0;
		this.trx = 0;
		this.try_ = 0;	// is a keyword otherwise!
		this.brx = 0;
		this.bry = 0;
		this.blx = 0;
		this.bly = 0;
		cr.seal(this);
	};
	Quad.prototype.set_from_rect = function (rc)
	{
		this.tlx = rc.left;
		this.tly = rc.top;
		this.trx = rc.right;
		this.try_ = rc.top;
		this.brx = rc.right;
		this.bry = rc.bottom;
		this.blx = rc.left;
		this.bly = rc.bottom;
	};
	Quad.prototype.set_from_rotated_rect = function (rc, a)
	{
		if (a === 0)
		{
			this.set_from_rect(rc);
		}
		else
		{
			var sin_a = Math.sin(a);
			var cos_a = Math.cos(a);
			var left_sin_a = rc.left * sin_a;
			var top_sin_a = rc.top * sin_a;
			var right_sin_a = rc.right * sin_a;
			var bottom_sin_a = rc.bottom * sin_a;
			var left_cos_a = rc.left * cos_a;
			var top_cos_a = rc.top * cos_a;
			var right_cos_a = rc.right * cos_a;
			var bottom_cos_a = rc.bottom * cos_a;
			this.tlx = left_cos_a - top_sin_a;
			this.tly = top_cos_a + left_sin_a;
			this.trx = right_cos_a - top_sin_a;
			this.try_ = top_cos_a + right_sin_a;
			this.brx = right_cos_a - bottom_sin_a;
			this.bry = bottom_cos_a + right_sin_a;
			this.blx = left_cos_a - bottom_sin_a;
			this.bly = bottom_cos_a + left_sin_a;
		}
	};
	Quad.prototype.offset = function (px, py)
	{
		this.tlx += px;
		this.tly += py;
		this.trx += px;
		this.try_ += py;
		this.brx += px;
		this.bry += py;
		this.blx += px;
		this.bly += py;
		return this;
	};
	var minresult = 0;
	var maxresult = 0;
	function minmax4(a, b, c, d)
	{
		if (a < b)
		{
			if (c < d)
			{
				if (a < c)
					minresult = a;
				else
					minresult = c;
				if (b > d)
					maxresult = b;
				else
					maxresult = d;
			}
			else
			{
				if (a < d)
					minresult = a;
				else
					minresult = d;
				if (b > c)
					maxresult = b;
				else
					maxresult = c;
			}
		}
		else
		{
			if (c < d)
			{
				if (b < c)
					minresult = b;
				else
					minresult = c;
				if (a > d)
					maxresult = a;
				else
					maxresult = d;
			}
			else
			{
				if (b < d)
					minresult = b;
				else
					minresult = d;
				if (a > c)
					maxresult = a;
				else
					maxresult = c;
			}
		}
	};
	Quad.prototype.bounding_box = function (rc)
	{
		minmax4(this.tlx, this.trx, this.brx, this.blx);
		rc.left = minresult;
		rc.right = maxresult;
		minmax4(this.tly, this.try_, this.bry, this.bly);
		rc.top = minresult;
		rc.bottom = maxresult;
	};
	Quad.prototype.contains_pt = function (x, y)
	{
		var v0x = this.trx - this.tlx;
		var v0y = this.try_ - this.tly;
		var v1x = this.brx - this.tlx;
		var v1y = this.bry - this.tly;
		var v2x = x - this.tlx;
		var v2y = y - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		var dot11 = v1x * v1x + v1y * v1y
		var dot12 = v1x * v2x + v1y * v2y
		var invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		if ((u >= 0.0) && (v > 0.0) && (u + v < 1))
			return true;
		v0x = this.blx - this.tlx;
		v0y = this.bly - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		return (u >= 0.0) && (v > 0.0) && (u + v < 1);
	};
	Quad.prototype.at = function (i, xory)
	{
		if (xory)
		{
			switch (i)
			{
				case 0: return this.tlx;
				case 1: return this.trx;
				case 2: return this.brx;
				case 3: return this.blx;
				case 4: return this.tlx;
				default: return this.tlx;
			}
		}
		else
		{
			switch (i)
			{
				case 0: return this.tly;
				case 1: return this.try_;
				case 2: return this.bry;
				case 3: return this.bly;
				case 4: return this.tly;
				default: return this.tly;
			}
		}
	};
	Quad.prototype.midX = function ()
	{
		return (this.tlx + this.trx  + this.brx + this.blx) / 4;
	};
	Quad.prototype.midY = function ()
	{
		return (this.tly + this.try_ + this.bry + this.bly) / 4;
	};
	Quad.prototype.intersects_segment = function (x1, y1, x2, y2)
	{
		if (this.contains_pt(x1, y1) || this.contains_pt(x2, y2))
			return true;
		var a1x, a1y, a2x, a2y;
		var i;
		for (i = 0; i < 4; i++)
		{
			a1x = this.at(i, true);
			a1y = this.at(i, false);
			a2x = this.at(i + 1, true);
			a2y = this.at(i + 1, false);
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	Quad.prototype.intersects_quad = function (rhs)
	{
		var midx = rhs.midX();
		var midy = rhs.midY();
		if (this.contains_pt(midx, midy))
			return true;
		midx = this.midX();
		midy = this.midY();
		if (rhs.contains_pt(midx, midy))
			return true;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		var i, j;
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 4; j++)
			{
				a1x = this.at(i, true);
				a1y = this.at(i, false);
				a2x = this.at(i + 1, true);
				a2y = this.at(i + 1, false);
				b1x = rhs.at(j, true);
				b1y = rhs.at(j, false);
				b2x = rhs.at(j + 1, true);
				b2y = rhs.at(j + 1, false);
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	cr.quad = Quad;
	cr.RGB = function (red, green, blue)
	{
		return Math.max(Math.min(red, 255), 0)
			 | (Math.max(Math.min(green, 255), 0) << 8)
			 | (Math.max(Math.min(blue, 255), 0) << 16);
	};
	cr.GetRValue = function (rgb)
	{
		return rgb & 0xFF;
	};
	cr.GetGValue = function (rgb)
	{
		return (rgb & 0xFF00) >> 8;
	};
	cr.GetBValue = function (rgb)
	{
		return (rgb & 0xFF0000) >> 16;
	};
	cr.shallowCopy = function (a, b, allowOverwrite)
	{
		var attr;
		for (attr in b)
		{
			if (b.hasOwnProperty(attr))
			{
;
				a[attr] = b[attr];
			}
		}
		return a;
	};
	cr.arrayRemove = function (arr, index)
	{
		var i, len;
		index = cr.floor(index);
		if (index < 0 || index >= arr.length)
			return;							// index out of bounds
		for (i = index, len = arr.length - 1; i < len; i++)
			arr[i] = arr[i + 1];
		arr.length = len;
	};
	cr.shallowAssignArray = function (dest, src)
	{
		dest.length = src.length;
		var i, len;
		for (i = 0, len = src.length; i < len; i++)
			dest[i] = src[i];
	};
	cr.appendArray = function (a, b)
	{
		a.push.apply(a, b);
	};
	cr.fastIndexOf = function (arr, item)
	{
		var i, len;
		for (i = 0, len = arr.length; i < len; ++i)
		{
			if (arr[i] === item)
				return i;
		}
		return -1;
	};
	cr.arrayFindRemove = function (arr, item)
	{
		var index = cr.fastIndexOf(arr, item);
		if (index !== -1)
			cr.arrayRemove(arr, index);
	};
	cr.clamp = function(x, a, b)
	{
		if (x < a)
			return a;
		else if (x > b)
			return b;
		else
			return x;
	};
	cr.to_radians = function(x)
	{
		return x / (180.0 / cr.PI);
	};
	cr.to_degrees = function(x)
	{
		return x * (180.0 / cr.PI);
	};
	cr.clamp_angle_degrees = function (a)
	{
		a %= 360;       // now in (-360, 360) range
		if (a < 0)
			a += 360;   // now in [0, 360) range
		return a;
	};
	cr.clamp_angle = function (a)
	{
		a %= 2 * cr.PI;       // now in (-2pi, 2pi) range
		if (a < 0)
			a += 2 * cr.PI;   // now in [0, 2pi) range
		return a;
	};
	cr.to_clamped_degrees = function (x)
	{
		return cr.clamp_angle_degrees(cr.to_degrees(x));
	};
	cr.to_clamped_radians = function (x)
	{
		return cr.clamp_angle(cr.to_radians(x));
	};
	cr.angleTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.atan2(dy, dx);
	};
	cr.angleDiff = function (a1, a2)
	{
		if (a1 === a2)
			return 0;
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		var n = s1 * s2 + c1 * c2;
		if (n >= 1)
			return 0;
		if (n <= -1)
			return cr.PI;
		return Math.acos(n);
	};
	cr.angleRotate = function (start, end, step)
	{
		var ss = Math.sin(start);
		var cs = Math.cos(start);
		var se = Math.sin(end);
		var ce = Math.cos(end);
		if (Math.acos(ss * se + cs * ce) > step)
		{
			if (cs * se - ss * ce > 0)
				return cr.clamp_angle(start + step);
			else
				return cr.clamp_angle(start - step);
		}
		else
			return cr.clamp_angle(end);
	};
	cr.angleClockwise = function (a1, a2)
	{
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		return c1 * s2 - s1 * c2 <= 0;
	};
	cr.rotatePtAround = function (px, py, a, ox, oy, getx)
	{
		if (a === 0)
			return getx ? px : py;
		var sin_a = Math.sin(a);
		var cos_a = Math.cos(a);
		px -= ox;
		py -= oy;
		var left_sin_a = px * sin_a;
		var top_sin_a = py * sin_a;
		var left_cos_a = px * cos_a;
		var top_cos_a = py * cos_a;
		px = left_cos_a - top_sin_a;
		py = top_cos_a + left_sin_a;
		px += ox;
		py += oy;
		return getx ? px : py;
	}
	cr.distanceTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.sqrt(dx*dx + dy*dy);
	};
	cr.xor = function (x, y)
	{
		return !x !== !y;
	};
	cr.lerp = function (a, b, x)
	{
		return a + (b - a) * x;
	};
	cr.unlerp = function (a, b, c)
	{
		if (a === b)
			return 0;		// avoid divide by 0
		return (c - a) / (b - a);
	};
	cr.anglelerp = function (a, b, x)
	{
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			return a + diff * x;
		}
		else
		{
			return a - diff * x;
		}
	};
	cr.qarp = function (a, b, c, x)
	{
		return cr.lerp(cr.lerp(a, b, x), cr.lerp(b, c, x), x);
	};
	cr.cubic = function (a, b, c, d, x)
	{
		return cr.lerp(cr.qarp(a, b, c, x), cr.qarp(b, c, d, x), x);
	};
	cr.cosp = function (a, b, x)
	{
		return (a + b + (a - b) * Math.cos(x * Math.PI)) / 2;
	};
	cr.hasAnyOwnProperty = function (o)
	{
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
				return true;
		}
		return false;
	};
	cr.wipe = function (obj)
	{
		var p;
		for (p in obj)
		{
			if (obj.hasOwnProperty(p))
				delete obj[p];
		}
	};
	var startup_time = +(new Date());
	cr.performance_now = function()
	{
		if (typeof window["performance"] !== "undefined")
		{
			var winperf = window["performance"];
			if (typeof winperf.now !== "undefined")
				return winperf.now();
			else if (typeof winperf["webkitNow"] !== "undefined")
				return winperf["webkitNow"]();
			else if (typeof winperf["mozNow"] !== "undefined")
				return winperf["mozNow"]();
			else if (typeof winperf["msNow"] !== "undefined")
				return winperf["msNow"]();
		}
		return Date.now() - startup_time;
	};
	var isChrome = false;
	var isSafari = false;
	var isiOS = false;
	var isEjecta = false;
	if (typeof window !== "undefined")		// not c2 editor
	{
		isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);
		isSafari = !isChrome && /safari/i.test(navigator.userAgent);
		isiOS = /(iphone|ipod|ipad)/i.test(navigator.userAgent);
		isEjecta = window["c2ejecta"];
	}
	var supports_set = ((!isSafari && !isEjecta && !isiOS) && (typeof Set !== "undefined" && typeof Set.prototype["forEach"] !== "undefined"));
	function ObjectSet_()
	{
		this.s = null;
		this.items = null;			// lazy allocated (hopefully results in better GC performance)
		this.item_count = 0;
		if (supports_set)
		{
			this.s = new Set();
		}
		this.values_cache = [];
		this.cache_valid = true;
		cr.seal(this);
	};
	ObjectSet_.prototype.contains = function (x)
	{
		if (this.isEmpty())
			return false;
		if (supports_set)
			return this.s["has"](x);
		else
			return (this.items && this.items.hasOwnProperty(x));
	};
	ObjectSet_.prototype.add = function (x)
	{
		if (supports_set)
		{
			if (!this.s["has"](x))
			{
				this.s["add"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			var items = this.items;
			if (!items)
			{
				this.items = {};
				this.items[str] = x;
				this.item_count = 1;
				this.cache_valid = false;
			}
			else if (!items.hasOwnProperty(str))
			{
				items[str] = x;
				this.item_count++;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.remove = function (x)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			if (this.s["has"](x))
			{
				this.s["delete"](x);
				this.cache_valid = false;
			}
		}
		else if (this.items)
		{
			var str = x.toString();
			var items = this.items;
			if (items.hasOwnProperty(str))
			{
				delete items[str];
				this.item_count--;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.clear = function (/*wipe_*/)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			this.s["clear"]();			// best!
		}
		else
		{
				this.items = null;		// creates garbage; will lazy allocate on next add()
			this.item_count = 0;
		}
		this.values_cache.length = 0;
		this.cache_valid = true;
	};
	ObjectSet_.prototype.isEmpty = function ()
	{
		return this.count() === 0;
	};
	ObjectSet_.prototype.count = function ()
	{
		if (supports_set)
			return this.s["size"];
		else
			return this.item_count;
	};
	var current_arr = null;
	var current_index = 0;
	function set_append_to_arr(x)
	{
		current_arr[current_index++] = x;
	};
	ObjectSet_.prototype.update_cache = function ()
	{
		if (this.cache_valid)
			return;
		if (supports_set)
		{
			this.values_cache.length = this.s["size"];
			current_arr = this.values_cache;
			current_index = 0;
			this.s["forEach"](set_append_to_arr);
;
			current_arr = null;
			current_index = 0;
		}
		else
		{
			var values_cache = this.values_cache;
			values_cache.length = this.item_count;
			var p, n = 0, items = this.items;
			if (items)
			{
				for (p in items)
				{
					if (items.hasOwnProperty(p))
						values_cache[n++] = items[p];
				}
			}
;
		}
		this.cache_valid = true;
	};
	ObjectSet_.prototype.valuesRef = function ()
	{
		this.update_cache();
		return this.values_cache;
	};
	cr.ObjectSet = ObjectSet_;
	var tmpSet = new cr.ObjectSet();
	cr.removeArrayDuplicates = function (arr)
	{
		var i, len;
		for (i = 0, len = arr.length; i < len; ++i)
		{
			tmpSet.add(arr[i]);
		}
		cr.shallowAssignArray(arr, tmpSet.valuesRef());
		tmpSet.clear();
	};
	function KahanAdder_()
	{
		this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
		cr.seal(this);
	};
	KahanAdder_.prototype.add = function (v)
	{
		this.y = v - this.c;
	    this.t = this.sum + this.y;
	    this.c = (this.t - this.sum) - this.y;
	    this.sum = this.t;
	};
    KahanAdder_.prototype.reset = function ()
    {
        this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
    };
	cr.KahanAdder = KahanAdder_;
	cr.regexp_escape = function(text)
	{
		return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
	};
	function CollisionPoly_(pts_array_)
	{
		this.pts_cache = [];
		this.bboxLeft = 0;
		this.bboxTop = 0;
		this.bboxRight = 0;
		this.bboxBottom = 0;
		this.convexpolys = null;		// for physics behavior to cache separated polys
		this.set_pts(pts_array_);
		cr.seal(this);
	};
	CollisionPoly_.prototype.set_pts = function(pts_array_)
	{
		this.pts_array = pts_array_;
		this.pts_count = pts_array_.length / 2;			// x, y, x, y... in array
		this.pts_cache.length = pts_array_.length;
		this.cache_width = -1;
		this.cache_height = -1;
		this.cache_angle = 0;
	};
	CollisionPoly_.prototype.is_empty = function()
	{
		return !this.pts_array.length;
	};
	CollisionPoly_.prototype.update_bbox = function ()
	{
		var myptscache = this.pts_cache;
		var bboxLeft_ = myptscache[0];
		var bboxRight_ = bboxLeft_;
		var bboxTop_ = myptscache[1];
		var bboxBottom_ = bboxTop_;
		var x, y, i = 1, i2, len = this.pts_count;
		for ( ; i < len; ++i)
		{
			i2 = i*2;
			x = myptscache[i2];
			y = myptscache[i2+1];
			if (x < bboxLeft_)
				bboxLeft_ = x;
			if (x > bboxRight_)
				bboxRight_ = x;
			if (y < bboxTop_)
				bboxTop_ = y;
			if (y > bboxBottom_)
				bboxBottom_ = y;
		}
		this.bboxLeft = bboxLeft_;
		this.bboxRight = bboxRight_;
		this.bboxTop = bboxTop_;
		this.bboxBottom = bboxBottom_;
	};
	CollisionPoly_.prototype.set_from_rect = function(rc, offx, offy)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = rc.left - offx;
		myptscache[1] = rc.top - offy;
		myptscache[2] = rc.right - offx;
		myptscache[3] = rc.top - offy;
		myptscache[4] = rc.right - offx;
		myptscache[5] = rc.bottom - offy;
		myptscache[6] = rc.left - offx;
		myptscache[7] = rc.bottom - offy;
		this.cache_width = rc.right - rc.left;
		this.cache_height = rc.bottom - rc.top;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_quad = function(q, offx, offy, w, h)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = q.tlx - offx;
		myptscache[1] = q.tly - offy;
		myptscache[2] = q.trx - offx;
		myptscache[3] = q.try_ - offy;
		myptscache[4] = q.brx - offx;
		myptscache[5] = q.bry - offy;
		myptscache[6] = q.blx - offx;
		myptscache[7] = q.bly - offy;
		this.cache_width = w;
		this.cache_height = h;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_poly = function (r)
	{
		this.pts_count = r.pts_count;
		cr.shallowAssignArray(this.pts_cache, r.pts_cache);
		this.bboxLeft = r.bboxLeft;
		this.bboxTop - r.bboxTop;
		this.bboxRight = r.bboxRight;
		this.bboxBottom = r.bboxBottom;
	};
	CollisionPoly_.prototype.cache_poly = function(w, h, a)
	{
		if (this.cache_width === w && this.cache_height === h && this.cache_angle === a)
			return;		// cache up-to-date
		this.cache_width = w;
		this.cache_height = h;
		this.cache_angle = a;
		var i, i2, i21, len, x, y;
		var sina = 0;
		var cosa = 1;
		var myptsarray = this.pts_array;
		var myptscache = this.pts_cache;
		if (a !== 0)
		{
			sina = Math.sin(a);
			cosa = Math.cos(a);
		}
		for (i = 0, len = this.pts_count; i < len; i++)
		{
			i2 = i*2;
			i21 = i2+1;
			x = myptsarray[i2] * w;
			y = myptsarray[i21] * h;
			myptscache[i2] = (x * cosa) - (y * sina);
			myptscache[i21] = (y * cosa) + (x * sina);
		}
		this.update_bbox();
	};
	CollisionPoly_.prototype.contains_pt = function (a2x, a2y)
	{
		var myptscache = this.pts_cache;
		if (a2x === myptscache[0] && a2y === myptscache[1])
			return true;
		var i, i2, imod, len = this.pts_count;
		var a1x = this.bboxLeft - 110;
		var a1y = this.bboxTop - 101;
		var a3x = this.bboxRight + 131
		var a3y = this.bboxBottom + 120;
		var b1x, b1y, b2x, b2y;
		var count1 = 0, count2 = 0;
		for (i = 0; i < len; i++)
		{
			i2 = i*2;
			imod = ((i+1)%len)*2;
			b1x = myptscache[i2];
			b1y = myptscache[i2+1];
			b2x = myptscache[imod];
			b2y = myptscache[imod+1];
			if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
				count1++;
			if (cr.segments_intersect(a3x, a3y, a2x, a2y, b1x, b1y, b2x, b2y))
				count2++;
		}
		return (count1 % 2 === 1) || (count2 % 2 === 1);
	};
	CollisionPoly_.prototype.intersects_poly = function (rhs, offx, offy)
	{
		var rhspts = rhs.pts_cache;
		var mypts = this.pts_cache;
		if (this.contains_pt(rhspts[0] + offx, rhspts[1] + offy))
			return true;
		if (rhs.contains_pt(mypts[0] - offx, mypts[1] - offy))
			return true;
		var i, i2, imod, leni, j, j2, jmod, lenj;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2];
			a1y = mypts[i2+1];
			a2x = mypts[imod];
			a2y = mypts[imod+1];
			for (j = 0, lenj = rhs.pts_count; j < lenj; j++)
			{
				j2 = j*2;
				jmod = ((j+1)%lenj)*2;
				b1x = rhspts[j2] + offx;
				b1y = rhspts[j2+1] + offy;
				b2x = rhspts[jmod] + offx;
				b2y = rhspts[jmod+1] + offy;
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	CollisionPoly_.prototype.intersects_segment = function (offx, offy, x1, y1, x2, y2)
	{
		var mypts = this.pts_cache;
		if (this.contains_pt(x1 - offx, y1 - offy))
			return true;
		var i, leni, i2, imod;
		var a1x, a1y, a2x, a2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2] + offx;
			a1y = mypts[i2+1] + offy;
			a2x = mypts[imod] + offx;
			a2y = mypts[imod+1] + offy;
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	CollisionPoly_.prototype.mirror = function (px)
	{
		var i, leni, i2;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			this.pts_cache[i2] = px * 2 - this.pts_cache[i2];
		}
	};
	CollisionPoly_.prototype.flip = function (py)
	{
		var i, leni, i21;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i21 = i*2+1;
			this.pts_cache[i21] = py * 2 - this.pts_cache[i21];
		}
	};
	CollisionPoly_.prototype.diag = function ()
	{
		var i, leni, i2, i21, temp;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			i21 = i2+1;
			temp = this.pts_cache[i2];
			this.pts_cache[i2] = this.pts_cache[i21];
			this.pts_cache[i21] = temp;
		}
	};
	cr.CollisionPoly = CollisionPoly_;
	function SparseGrid_(cellwidth_, cellheight_)
	{
		this.cellwidth = cellwidth_;
		this.cellheight = cellheight_;
		this.cells = {};
	};
	SparseGrid_.prototype.totalCellCount = 0;
	SparseGrid_.prototype.getCell = function (x_, y_, create_if_missing)
	{
		var ret;
		var col = this.cells[x_];
		if (!col)
		{
			if (create_if_missing)
			{
				ret = allocGridCell(this, x_, y_);
				this.cells[x_] = {};
				this.cells[x_][y_] = ret;
				return ret;
			}
			else
				return null;
		}
		ret = col[y_];
		if (ret)
			return ret;
		else if (create_if_missing)
		{
			ret = allocGridCell(this, x_, y_);
			this.cells[x_][y_] = ret;
			return ret;
		}
		else
			return null;
	};
	SparseGrid_.prototype.XToCell = function (x_)
	{
		return cr.floor(x_ / this.cellwidth);
	};
	SparseGrid_.prototype.YToCell = function (y_)
	{
		return cr.floor(y_ / this.cellheight);
	};
	SparseGrid_.prototype.update = function (inst, oldrange, newrange)
	{
		var x, lenx, y, leny, cell;
		if (oldrange)
		{
			for (x = oldrange.left, lenx = oldrange.right; x <= lenx; ++x)
			{
				for (y = oldrange.top, leny = oldrange.bottom; y <= leny; ++y)
				{
					if (newrange && newrange.contains_pt(x, y))
						continue;	// is still in this cell
					cell = this.getCell(x, y, false);	// don't create if missing
					if (!cell)
						continue;	// cell does not exist yet
					cell.remove(inst);
					if (cell.isEmpty())
					{
						freeGridCell(cell);
						this.cells[x][y] = null;
					}
				}
			}
		}
		if (newrange)
		{
			for (x = newrange.left, lenx = newrange.right; x <= lenx; ++x)
			{
				for (y = newrange.top, leny = newrange.bottom; y <= leny; ++y)
				{
					if (oldrange && oldrange.contains_pt(x, y))
						continue;	// is still in this cell
					this.getCell(x, y, true).insert(inst);
				}
			}
		}
	};
	SparseGrid_.prototype.queryRange = function (rc, result)
	{
		var x, lenx, ystart, y, leny, cell;
		x = this.XToCell(rc.left);
		ystart = this.YToCell(rc.top);
		lenx = this.XToCell(rc.right);
		leny = this.YToCell(rc.bottom);
		for ( ; x <= lenx; ++x)
		{
			for (y = ystart; y <= leny; ++y)
			{
				cell = this.getCell(x, y, false);
				if (!cell)
					continue;
				cell.dump(result);
			}
		}
	};
	cr.SparseGrid = SparseGrid_;
	var gridcellcache = [];
	function allocGridCell(grid_, x_, y_)
	{
		var ret;
		SparseGrid_.prototype.totalCellCount++;
		if (gridcellcache.length)
		{
			ret = gridcellcache.pop();
			ret.grid = grid_;
			ret.x = x_;
			ret.y = y_;
			return ret;
		}
		else
			return new cr.GridCell(grid_, x_, y_);
	};
	function freeGridCell(c)
	{
		SparseGrid_.prototype.totalCellCount--;
		c.objects.clear();
		if (gridcellcache.length < 1000)
			gridcellcache.push(c);
	};
	function GridCell_(grid_, x_, y_)
	{
		this.grid = grid_;
		this.x = x_;
		this.y = y_;
		this.objects = new cr.ObjectSet();
	};
	GridCell_.prototype.isEmpty = function ()
	{
		return this.objects.isEmpty();
	};
	GridCell_.prototype.insert = function (inst)
	{
		this.objects.add(inst);
	};
	GridCell_.prototype.remove = function (inst)
	{
		this.objects.remove(inst);
	};
	GridCell_.prototype.dump = function (result)
	{
		cr.appendArray(result, this.objects.valuesRef());
	};
	cr.GridCell = GridCell_;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	cr.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	cr.setGLBlend = function(this_, effect, gl)
	{
		if (!gl)
			return;
		this_.srcBlend = gl.ONE;
		this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	cr.round6dp = function (x)
	{
		return Math.round(x * 1000000) / 1000000;
	};
	/*
	var localeCompare_options = {
		"usage": "search",
		"sensitivity": "accent"
	};
	var has_localeCompare = !!"a".localeCompare;
	var localeCompare_works1 = (has_localeCompare && "a".localeCompare("A", undefined, localeCompare_options) === 0);
	var localeCompare_works2 = (has_localeCompare && "a".localeCompare("á", undefined, localeCompare_options) !== 0);
	var supports_localeCompare = (has_localeCompare && localeCompare_works1 && localeCompare_works2);
	*/
	cr.equals_nocase = function (a, b)
	{
		if (typeof a !== "string" || typeof b !== "string")
			return false;
		if (a.length !== b.length)
			return false;
		if (a === b)
			return true;
		/*
		if (supports_localeCompare)
		{
			return (a.localeCompare(b, undefined, localeCompare_options) === 0);
		}
		else
		{
		*/
			return a.toLowerCase() === b.toLowerCase();
	};
	cr.isCanvasInputEvent = function (e)
	{
		var target = e.target;
		if (!target)
			return true;
		if (target === document || target === window)
			return true;
		if (document && document.body && target === document.body)
			return true;
		if (cr.equals_nocase(target.tagName, "canvas"))
			return true;
		return false;
	};
}());
var MatrixArray=typeof Float32Array!=="undefined"?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(g===1)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1],a=a[2],g=b[0],f=b[1],b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1],a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1],a=a[2]-b[2],b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],n=a[11],o=a[12],m=a[13],p=a[14],a=a[15];return o*k*h*e-j*m*h*e-o*f*l*e+g*m*l*e+j*f*p*e-g*k*p*e-o*k*d*i+j*m*d*i+o*c*l*i-b*m*l*i-j*c*p*i+b*k*p*i+o*f*d*n-g*m*d*n-o*c*h*n+b*m*h*n+g*c*p*n-b*f*p*n-j*f*d*a+g*k*d*a+j*c*h*a-b*k*h*a-g*c*l*a+b*f*l*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],h=a[5],i=a[6],j=a[7],k=a[8],l=a[9],n=a[10],o=a[11],m=a[12],p=a[13],r=a[14],s=a[15],A=c*h-d*f,B=c*i-e*f,t=c*j-g*f,u=d*i-e*h,v=d*j-g*h,w=e*j-g*i,x=k*p-l*m,y=k*r-n*m,z=k*s-o*m,C=l*r-n*p,D=l*s-o*p,E=n*s-o*r,q=1/(A*E-B*D+t*C+u*z-v*y+w*x);b[0]=(h*E-i*D+j*C)*q;b[1]=(-d*E+e*D-g*C)*q;b[2]=(p*w-r*v+s*u)*q;b[3]=(-l*w+n*v-o*u)*q;b[4]=(-f*E+i*z-j*y)*q;b[5]=(c*E-e*z+g*y)*q;b[6]=(-m*w+r*t-s*B)*q;b[7]=(k*w-n*t+o*B)*q;b[8]=(f*D-h*z+j*x)*q;
b[9]=(-c*D+d*z-g*x)*q;b[10]=(m*v-p*t+s*A)*q;b[11]=(-k*v+l*t-o*A)*q;b[12]=(-f*C+h*y-i*x)*q;b[13]=(c*C-d*y+e*x)*q;b[14]=(-m*u+p*B-r*A)*q;b[15]=(k*u-l*B+n*A)*q;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],h=a[6],i=a[8],j=a[9],k=a[10],l=k*f-h*j,n=-k*g+h*i,o=j*g-f*i,m=c*l+d*n+e*o;if(!m)return null;m=1/m;b||(b=mat3.create());b[0]=l*m;b[1]=(-k*d+e*j)*m;b[2]=(h*d-e*f)*m;b[3]=n*m;b[4]=(k*c-e*i)*m;b[5]=(-h*c+e*g)*m;b[6]=o*m;b[7]=(-j*c+d*i)*m;b[8]=(f*c-d*g)*m;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],h=a[4],i=a[5],j=a[6],k=a[7],l=a[8],n=a[9],o=a[10],m=a[11],p=a[12],r=a[13],s=a[14],a=a[15],A=b[0],B=b[1],t=b[2],u=b[3],v=b[4],w=b[5],x=b[6],y=b[7],z=b[8],C=b[9],D=b[10],E=b[11],q=b[12],F=b[13],G=b[14],b=b[15];c[0]=A*d+B*h+t*l+u*p;c[1]=A*e+B*i+t*n+u*r;c[2]=A*g+B*j+t*o+u*s;c[3]=A*f+B*k+t*m+u*a;c[4]=v*d+w*h+x*l+y*p;c[5]=v*e+w*i+x*n+y*r;c[6]=v*g+w*j+x*o+y*s;c[7]=v*f+w*k+x*m+y*a;c[8]=z*d+C*h+D*l+E*p;c[9]=z*e+C*i+D*n+E*r;c[10]=z*g+C*
j+D*o+E*s;c[11]=z*f+C*k+D*m+E*a;c[12]=q*d+F*h+G*l+b*p;c[13]=q*e+F*i+G*n+b*r;c[14]=q*g+F*j+G*o+b*s;c[15]=q*f+F*k+G*m+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1],b=b[2],g,f,h,i,j,k,l,n,o,m,p,r;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;g=a[0];f=a[1];h=a[2];i=a[3];j=a[4];k=a[5];l=a[6];n=a[7];o=a[8];m=a[9];p=a[10];r=a[11];c[0]=g;c[1]=f;c[2]=h;c[3]=i;c[4]=j;c[5]=k;c[6]=l;c[7]=n;c[8]=o;c[9]=m;c[10]=p;c[11]=r;c[12]=g*d+j*e+o*b+a[12];c[13]=f*d+k*e+m*b+a[13];c[14]=h*d+l*e+p*b+a[14];c[15]=i*d+n*e+r*b+a[15];
return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1],b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1],c=c[2],f=Math.sqrt(e*e+g*g+c*c),h,i,j,k,l,n,o,m,p,r,s,A,B,t,u,v,w,x,y,z;if(!f)return null;f!==1&&(f=1/f,e*=f,g*=f,c*=f);h=Math.sin(b);i=Math.cos(b);j=1-i;b=a[0];f=a[1];k=a[2];l=a[3];n=a[4];o=a[5];m=a[6];p=a[7];r=a[8];s=a[9];A=a[10];B=a[11];t=e*e*j+i;u=g*e*j+c*h;v=c*e*j-g*h;w=e*g*j-c*h;x=g*g*j+i;y=c*g*j+e*h;z=e*c*j+g*h;e=g*c*j-e*h;g=c*c*j+i;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*t+n*u+r*v;d[1]=f*t+o*u+s*v;d[2]=k*t+m*u+A*
v;d[3]=l*t+p*u+B*v;d[4]=b*w+n*x+r*y;d[5]=f*w+o*x+s*y;d[6]=k*w+m*x+A*y;d[7]=l*w+p*x+B*y;d[8]=b*z+n*e+r*g;d[9]=f*z+o*e+s*g;d[10]=k*z+m*e+A*g;d[11]=l*z+p*e+B*g;return d};mat4.rotateX=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[4],g=a[5],f=a[6],h=a[7],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+i*d;c[5]=g*b+j*d;c[6]=f*b+k*d;c[7]=h*b+l*d;c[8]=e*-d+i*b;c[9]=g*-d+j*b;c[10]=f*-d+k*b;c[11]=h*-d+l*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*-d;c[1]=g*b+j*-d;c[2]=f*b+k*-d;c[3]=h*b+l*-d;c[8]=e*d+i*b;c[9]=g*d+j*b;c[10]=f*d+k*b;c[11]=h*d+l*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[4],j=a[5],k=a[6],l=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*d;c[1]=g*b+j*d;c[2]=f*b+k*d;c[3]=h*b+l*d;c[4]=e*-d+i*b;c[5]=g*-d+j*b;c[6]=f*-d+k*b;c[7]=h*-d+l*b;return c};
mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=e*2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=e*2/i;f[6]=0;f[7]=0;f[8]=(b+a)/h;f[9]=(d+c)/i;f[10]=-(g+e)/j;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(g*e*2)/j;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/i;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/j;f[11]=0;f[12]=-(a+b)/h;f[13]=-(d+c)/i;f[14]=-(g+e)/j;f[15]=1;return f};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,g,f,h,i,j,k,l,n=a[0],o=a[1],a=a[2];g=c[0];f=c[1];e=c[2];c=b[1];j=b[2];if(n===b[0]&&o===c&&a===j)return mat4.identity(d);c=n-b[0];j=o-b[1];k=a-b[2];l=1/Math.sqrt(c*c+j*j+k*k);c*=l;j*=l;k*=l;b=f*k-e*j;e=e*c-g*k;g=g*j-f*c;(l=Math.sqrt(b*b+e*e+g*g))?(l=1/l,b*=l,e*=l,g*=l):g=e=b=0;f=j*g-k*e;h=k*b-c*g;i=c*e-j*b;(l=Math.sqrt(f*f+h*h+i*i))?(l=1/l,f*=l,h*=l,i*=l):i=h=f=0;d[0]=b;d[1]=f;d[2]=c;d[3]=0;d[4]=e;d[5]=h;d[6]=j;d[7]=0;d[8]=g;d[9]=i;d[10]=k;d[11]=
0;d[12]=-(b*n+e*o+g*a);d[13]=-(f*n+h*o+i*a);d[14]=-(c*n+j*o+k*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],g=a[2],f=a[3],h=d+d,i=e+e,j=g+g,a=d*h,k=d*i;d*=j;var l=e*i;e*=j;g*=j;h*=f;i*=f;f*=j;c[0]=1-(l+g);c[1]=k+f;c[2]=d-i;c[3]=0;c[4]=k-f;c[5]=1-(a+g);c[6]=e+h;c[7]=0;c[8]=d+i;c[9]=e-h;c[10]=1-(a+l);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2],a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(f===0)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],a=a[3],f=b[0],h=b[1],i=b[2],b=b[3];c[0]=d*b+a*f+e*i-g*h;c[1]=e*b+a*h+g*f-d*i;c[2]=g*b+a*i+d*h-e*f;c[3]=a*b-d*f-e*h-g*i;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=a[0],f=a[1],h=a[2],a=a[3],i=a*d+f*g-h*e,j=a*e+h*d-b*g,k=a*g+b*e-f*d,d=-b*d-f*e-h*g;c[0]=i*a+d*-b+j*-h-k*-f;c[1]=j*a+d*-f+k*-b-i*-h;c[2]=k*a+d*-h+i*-f-j*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=k-g;b[4]=1-(j+e);b[5]=d+f;b[6]=c+h;b[7]=d-f;b[8]=1-(j+l);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=0;b[4]=k-g;b[5]=1-(j+e);b[6]=d+f;b[7]=0;b[8]=c+h;b[9]=d-f;b[10]=1-(j+l);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],g,f;if(Math.abs(e)>=1)return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;g=Math.acos(e);f=Math.sqrt(1-e*e);if(Math.abs(f)<0.001)return d[0]=a[0]*0.5+b[0]*0.5,d[1]=a[1]*0.5+b[1]*0.5,d[2]=a[2]*0.5+b[2]*0.5,d[3]=a[3]*0.5+b[3]*0.5,d;e=Math.sin((1-c)*g)/f;c=Math.sin(c*g)/f;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function()
{
	var MAX_VERTICES = 8000;						// equates to 2500 objects being drawn
	var MAX_INDICES = (MAX_VERTICES / 2) * 3;		// 6 indices for every 4 vertices
	var MAX_POINTS = 8000;
	var MULTI_BUFFERS = 4;							// cycle 4 buffers to try and avoid blocking
	var BATCH_NULL = 0;
	var BATCH_QUAD = 1;
	var BATCH_SETTEXTURE = 2;
	var BATCH_SETOPACITY = 3;
	var BATCH_SETBLEND = 4;
	var BATCH_UPDATEMODELVIEW = 5;
	var BATCH_RENDERTOTEXTURE = 6;
	var BATCH_CLEAR = 7;
	var BATCH_POINTS = 8;
	var BATCH_SETPROGRAM = 9;
	var BATCH_SETPROGRAMPARAMETERS = 10;
	var BATCH_SETTEXTURE1 = 11;
	/*
	var lose_ext = null;
	window.lose_context = function ()
	{
		if (!lose_ext)
		{
			console.log("WEBGL_lose_context not supported");
			return;
		}
		lose_ext.loseContext();
	};
	window.restore_context = function ()
	{
		if (!lose_ext)
		{
			console.log("WEBGL_lose_context not supported");
			return;
		}
		lose_ext.restoreContext();
	};
	*/
	function GLWrap_(gl, isMobile)
	{
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.width = 0;		// not yet known, wait for call to setSize()
		this.height = 0;
		this.cam = vec3.create([0, 0, 100]);			// camera position
		this.look = vec3.create([0, 0, 0]);				// lookat position
		this.up = vec3.create([0, 1, 0]);				// up vector
		this.worldScale = vec3.create([1, 1, 1]);		// world scaling factor
		this.enable_mipmaps = true;
		this.matP = mat4.create();						// perspective matrix
		this.matMV = mat4.create();						// model view matrix
		this.lastMV = mat4.create();
		this.currentMV = mat4.create();
		this.gl = gl;
		this.initState();
	};
	GLWrap_.prototype.initState = function ()
	{
		var gl = this.gl;
		var i, len;
		this.lastOpacity = 1;
		this.lastTexture0 = null;			// last bound to TEXTURE0
		this.lastTexture1 = null;			// last bound to TEXTURE1
		this.currentOpacity = 1;
		gl.clearColor(0, 0, 0, 0);
		gl.clear(gl.COLOR_BUFFER_BIT);
		gl.enable(gl.BLEND);
        gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
		gl.disable(gl.CULL_FACE);
		gl.disable(gl.DEPTH_TEST);
		this.maxTextureSize = gl.getParameter(gl.MAX_TEXTURE_SIZE);
		this.lastSrcBlend = gl.ONE;
		this.lastDestBlend = gl.ONE_MINUS_SRC_ALPHA;
		this.pointBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
		this.vertexBuffers = new Array(MULTI_BUFFERS);
		this.texcoordBuffers = new Array(MULTI_BUFFERS);
		for (i = 0; i < MULTI_BUFFERS; i++)
		{
			this.vertexBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[i]);
			this.texcoordBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[i]);
		}
		this.curBuffer = 0;
		this.indexBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.indexBuffer);
		this.vertexData = new Float32Array(MAX_VERTICES * 2);
		this.texcoordData = new Float32Array(MAX_VERTICES * 2);
		this.pointData = new Float32Array(MAX_POINTS * 4);
		var indexData = new Uint16Array(MAX_INDICES);
		i = 0, len = MAX_INDICES;
		var fv = 0;
		while (i < len)
		{
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 1;	// top right
			indexData[i++] = fv + 2;	// bottom right (first tri)
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 2;	// bottom right
			indexData[i++] = fv + 3;	// bottom left
			fv += 4;
		}
		gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, indexData, gl.STATIC_DRAW);
		this.vertexPtr = 0;
		this.pointPtr = 0;
		var fsSource, vsSource;
		this.shaderPrograms = [];
		fsSource = [
			"varying mediump vec2 vTex;",
			"uniform lowp float opacity;",
			"uniform lowp sampler2D samplerFront;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, vTex);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		vsSource = [
			"attribute highp vec2 aPos;",
			"attribute mediump vec2 aTex;",
			"varying mediump vec2 vTex;",
			"uniform highp mat4 matP;",
			"uniform highp mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	vTex = aTex;",
			"}"
		].join("\n");
		var shaderProg = this.createShaderProgram({src: fsSource}, vsSource, "<default>");
;
		this.shaderPrograms.push(shaderProg);		// Default shader is always shader 0
		fsSource = [
			"uniform mediump sampler2D samplerFront;",
			"varying lowp float opacity;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, gl_PointCoord);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		var pointVsSource = [
			"attribute vec4 aPos;",
			"varying float opacity;",
			"uniform mat4 matP;",
			"uniform mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	gl_PointSize = aPos.z;",
			"	opacity = aPos.w;",
			"}"
		].join("\n");
		shaderProg = this.createShaderProgram({src: fsSource}, pointVsSource, "<point>");
;
		this.shaderPrograms.push(shaderProg);		// Point shader is always shader 1
		for (var shader_name in cr.shaders)
		{
			if (cr.shaders.hasOwnProperty(shader_name))
				this.shaderPrograms.push(this.createShaderProgram(cr.shaders[shader_name], vsSource, shader_name));
		}
		gl.activeTexture(gl.TEXTURE0);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.batch = [];
		this.batchPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.lastProgram = -1;				// start -1 so first switchProgram can do work
		this.currentProgram = -1;			// current program during batch execution
		this.currentShader = null;
		this.fbo = gl.createFramebuffer();
		this.renderToTex = null;
		this.tmpVec3 = vec3.create([0, 0, 0]);
;
		var pointsizes = gl.getParameter(gl.ALIASED_POINT_SIZE_RANGE);
		this.minPointSize = pointsizes[0];
		this.maxPointSize = pointsizes[1];
		if (this.maxPointSize > 2048)
			this.maxPointSize = 2048;
;
;
		this.switchProgram(0);
		cr.seal(this);
	};
	function GLShaderProgram(gl, shaderProgram, name)
	{
		this.gl = gl;
		this.shaderProgram = shaderProgram;
		this.name = name;
		this.locAPos = gl.getAttribLocation(shaderProgram, "aPos");
		this.locATex = gl.getAttribLocation(shaderProgram, "aTex");
		this.locMatP = gl.getUniformLocation(shaderProgram, "matP");
		this.locMatMV = gl.getUniformLocation(shaderProgram, "matMV");
		this.locOpacity = gl.getUniformLocation(shaderProgram, "opacity");
		this.locSamplerFront = gl.getUniformLocation(shaderProgram, "samplerFront");
		this.locSamplerBack = gl.getUniformLocation(shaderProgram, "samplerBack");
		this.locDestStart = gl.getUniformLocation(shaderProgram, "destStart");
		this.locDestEnd = gl.getUniformLocation(shaderProgram, "destEnd");
		this.locSeconds = gl.getUniformLocation(shaderProgram, "seconds");
		this.locPixelWidth = gl.getUniformLocation(shaderProgram, "pixelWidth");
		this.locPixelHeight = gl.getUniformLocation(shaderProgram, "pixelHeight");
		this.locLayerScale = gl.getUniformLocation(shaderProgram, "layerScale");
		this.locLayerAngle = gl.getUniformLocation(shaderProgram, "layerAngle");
		this.locViewOrigin = gl.getUniformLocation(shaderProgram, "viewOrigin");
		this.hasAnyOptionalUniforms = !!(this.locPixelWidth || this.locPixelHeight || this.locSeconds || this.locSamplerBack || this.locDestStart || this.locDestEnd || this.locLayerScale || this.locLayerAngle || this.locViewOrigin);
		this.lpPixelWidth = -999;		// set to something unlikely so never counts as cached on first set
		this.lpPixelHeight = -999;
		this.lpOpacity = 1;
		this.lpDestStartX = 0.0;
		this.lpDestStartY = 0.0;
		this.lpDestEndX = 1.0;
		this.lpDestEndY = 1.0;
		this.lpLayerScale = 1.0;
		this.lpLayerAngle = 0.0;
		this.lpViewOriginX = 0.0;
		this.lpViewOriginY = 0.0;
		this.lastCustomParams = [];
		this.lpMatMV = mat4.create();
		if (this.locOpacity)
			gl.uniform1f(this.locOpacity, 1);
		if (this.locSamplerFront)
			gl.uniform1i(this.locSamplerFront, 0);
		if (this.locSamplerBack)
			gl.uniform1i(this.locSamplerBack, 1);
		if (this.locDestStart)
			gl.uniform2f(this.locDestStart, 0.0, 0.0);
		if (this.locDestEnd)
			gl.uniform2f(this.locDestEnd, 1.0, 1.0);
		if (this.locLayerScale)
			gl.uniform1f(this.locLayerScale, 1.0);
		if (this.locLayerAngle)
			gl.uniform1f(this.locLayerAngle, 0.0);
		if (this.locViewOrigin)
			gl.uniform2f(this.locViewOrigin, 0.0, 0.0);
		this.hasCurrentMatMV = false;		// matMV needs updating
	};
	function areMat4sEqual(a, b)
	{
		return a[0]===b[0]&&a[1]===b[1]&&a[2]===b[2]&&a[3]===b[3]&&
			   a[4]===b[4]&&a[5]===b[5]&&a[6]===b[6]&&a[7]===b[7]&&
			   a[8]===b[8]&&a[9]===b[9]&&a[10]===b[10]&&a[11]===b[11]&&
			   a[12]===b[12]&&a[13]===b[13]&&a[14]===b[14]&&a[15]===b[15];
	};
	GLShaderProgram.prototype.updateMatMV = function (mv)
	{
		if (areMat4sEqual(this.lpMatMV, mv))
			return;		// no change, save the expensive GL call
		mat4.set(mv, this.lpMatMV);
		this.gl.uniformMatrix4fv(this.locMatMV, false, mv);
	};
	GLWrap_.prototype.createShaderProgram = function(shaderEntry, vsSource, name)
	{
		var gl = this.gl;
		var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
		gl.shaderSource(fragmentShader, shaderEntry.src);
		gl.compileShader(fragmentShader);
		if (!gl.getShaderParameter(fragmentShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			return null;
		}
		var vertexShader = gl.createShader(gl.VERTEX_SHADER);
		gl.shaderSource(vertexShader, vsSource);
		gl.compileShader(vertexShader);
		if (!gl.getShaderParameter(vertexShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			return null;
		}
		var shaderProgram = gl.createProgram();
		gl.attachShader(shaderProgram, fragmentShader);
		gl.attachShader(shaderProgram, vertexShader);
		gl.linkProgram(shaderProgram);
		if (!gl.getProgramParameter(shaderProgram, gl.LINK_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			gl.deleteProgram(shaderProgram);
			return null;
		}
		gl.useProgram(shaderProgram);
		gl.deleteShader(fragmentShader);
		gl.deleteShader(vertexShader);
		var ret = new GLShaderProgram(gl, shaderProgram, name);
		ret.extendBoxHorizontal = shaderEntry.extendBoxHorizontal || 0;
		ret.extendBoxVertical = shaderEntry.extendBoxVertical || 0;
		ret.crossSampling = !!shaderEntry.crossSampling;
		ret.animated = !!shaderEntry.animated;
		ret.parameters = shaderEntry.parameters || [];
		var i, len;
		for (i = 0, len = ret.parameters.length; i < len; i++)
		{
			ret.parameters[i][1] = gl.getUniformLocation(shaderProgram, ret.parameters[i][0]);
			ret.lastCustomParams.push(0);
			gl.uniform1f(ret.parameters[i][1], 0);
		}
		cr.seal(ret);
		return ret;
	};
	GLWrap_.prototype.getShaderIndex = function(name_)
	{
		var i, len;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			if (this.shaderPrograms[i].name === name_)
				return i;
		}
		return -1;
	};
	GLWrap_.prototype.project = function (x, y, out)
	{
		var mv = this.matMV;
		var proj = this.matP;
		var fTempo = [0, 0, 0, 0, 0, 0, 0, 0];
		fTempo[0] = mv[0]*x+mv[4]*y+mv[12];
		fTempo[1] = mv[1]*x+mv[5]*y+mv[13];
		fTempo[2] = mv[2]*x+mv[6]*y+mv[14];
		fTempo[3] = mv[3]*x+mv[7]*y+mv[15];
		fTempo[4] = proj[0]*fTempo[0]+proj[4]*fTempo[1]+proj[8]*fTempo[2]+proj[12]*fTempo[3];
		fTempo[5] = proj[1]*fTempo[0]+proj[5]*fTempo[1]+proj[9]*fTempo[2]+proj[13]*fTempo[3];
		fTempo[6] = proj[2]*fTempo[0]+proj[6]*fTempo[1]+proj[10]*fTempo[2]+proj[14]*fTempo[3];
		fTempo[7] = -fTempo[2];
		if(fTempo[7]===0.0)	//The w value
			return;
		fTempo[7]=1.0/fTempo[7];
		fTempo[4]*=fTempo[7];
		fTempo[5]*=fTempo[7];
		fTempo[6]*=fTempo[7];
		out[0]=(fTempo[4]*0.5+0.5)*this.width;
		out[1]=(fTempo[5]*0.5+0.5)*this.height;
	};
	GLWrap_.prototype.setSize = function(w, h, force)
	{
		if (this.width === w && this.height === h && !force)
			return;
		this.endBatch();
		this.width = w;
		this.height = h;
		this.gl.viewport(0, 0, w, h);
		mat4.perspective(45, w / h, 1, 1000, this.matP);
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		var tl = [0, 0];
		var br = [0, 0];
		this.project(0, 0, tl);
		this.project(1, 1, br);
		this.worldScale[0] = 1 / (br[0] - tl[0]);
		this.worldScale[1] = -1 / (br[1] - tl[1]);
		var i, len, s;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			s = this.shaderPrograms[i];
			s.hasCurrentMatMV = false;
			if (s.locMatP)
			{
				this.gl.useProgram(s.shaderProgram);
				this.gl.uniformMatrix4fv(s.locMatP, false, this.matP);
			}
		}
		this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE1);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE0);
		this.lastTexture0 = null;
		this.lastTexture1 = null;
	};
	GLWrap_.prototype.resetModelView = function ()
	{
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		mat4.scale(this.matMV, this.worldScale);
	};
	GLWrap_.prototype.translate = function (x, y)
	{
		if (x === 0 && y === 0)
			return;
		this.tmpVec3[0] = x;// * this.worldScale[0];
		this.tmpVec3[1] = y;// * this.worldScale[1];
		this.tmpVec3[2] = 0;
		mat4.translate(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.scale = function (x, y)
	{
		if (x === 1 && y === 1)
			return;
		this.tmpVec3[0] = x;
		this.tmpVec3[1] = y;
		this.tmpVec3[2] = 1;
		mat4.scale(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.rotateZ = function (a)
	{
		if (a === 0)
			return;
		mat4.rotateZ(this.matMV, a);
	};
	GLWrap_.prototype.updateModelView = function()
	{
		var anydiff = false;
		for (var i = 0; i < 16; i++)
		{
			if (this.lastMV[i] !== this.matMV[i])
			{
				anydiff = true;
				break;
			}
		}
		if (!anydiff)
			return;
		var b = this.pushBatch();
		b.type = BATCH_UPDATEMODELVIEW;
		if (b.mat4param)
			mat4.set(this.matMV, b.mat4param);
		else
			b.mat4param = mat4.create(this.matMV);
		mat4.set(this.matMV, this.lastMV);
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	/*
	var debugBatch = false;
	jQuery(document).mousedown(
		function(info) {
			if (info.which === 2)
				debugBatch = true;
		}
	);
	*/
	function GLBatchJob(type_, glwrap_)
	{
		this.type = type_;
		this.glwrap = glwrap_;
		this.gl = glwrap_.gl;
		this.opacityParam = 0;		// for setOpacity()
		this.startIndex = 0;		// for quad()
		this.indexCount = 0;		// "
		this.texParam = null;		// for setTexture()
		this.mat4param = null;		// for updateModelView()
		this.shaderParams = [];		// for user parameters
		cr.seal(this);
	};
	GLBatchJob.prototype.doSetTexture = function ()
	{
		this.gl.bindTexture(this.gl.TEXTURE_2D, this.texParam);
	};
	GLBatchJob.prototype.doSetTexture1 = function ()
	{
		var gl = this.gl;
		gl.activeTexture(gl.TEXTURE1);
		gl.bindTexture(gl.TEXTURE_2D, this.texParam);
		gl.activeTexture(gl.TEXTURE0);
	};
	GLBatchJob.prototype.doSetOpacity = function ()
	{
		var o = this.opacityParam;
		var glwrap = this.glwrap;
		glwrap.currentOpacity = o;
		var curProg = glwrap.currentShader;
		if (curProg.locOpacity && curProg.lpOpacity !== o)
		{
			curProg.lpOpacity = o;
			this.gl.uniform1f(curProg.locOpacity, o);
		}
	};
	GLBatchJob.prototype.doQuad = function ()
	{
		this.gl.drawElements(this.gl.TRIANGLES, this.indexCount, this.gl.UNSIGNED_SHORT, this.startIndex * 2);
	};
	GLBatchJob.prototype.doSetBlend = function ()
	{
		this.gl.blendFunc(this.startIndex, this.indexCount);
	};
	GLBatchJob.prototype.doUpdateModelView = function ()
	{
		var i, len, s, shaderPrograms = this.glwrap.shaderPrograms, currentProgram = this.glwrap.currentProgram;
		for (i = 0, len = shaderPrograms.length; i < len; i++)
		{
			s = shaderPrograms[i];
			if (i === currentProgram && s.locMatMV)
			{
				s.updateMatMV(this.mat4param);
				s.hasCurrentMatMV = true;
			}
			else
				s.hasCurrentMatMV = false;
		}
		mat4.set(this.mat4param, this.glwrap.currentMV);
	};
	GLBatchJob.prototype.doRenderToTexture = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		if (this.texParam)
		{
			if (glwrap.lastTexture1 === this.texParam)
			{
				gl.activeTexture(gl.TEXTURE1);
				gl.bindTexture(gl.TEXTURE_2D, null);
				glwrap.lastTexture1 = null;
				gl.activeTexture(gl.TEXTURE0);
			}
			gl.bindFramebuffer(gl.FRAMEBUFFER, glwrap.fbo);
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texParam, 0);
		}
		else
		{
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
			gl.bindFramebuffer(gl.FRAMEBUFFER, null);
		}
	};
	GLBatchJob.prototype.doClear = function ()
	{
		var gl = this.gl;
		if (this.startIndex === 0)		// clear whole surface
		{
			gl.clearColor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clear(gl.COLOR_BUFFER_BIT);
		}
		else							// clear rectangle
		{
			gl.enable(gl.SCISSOR_TEST);
			gl.scissor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clearColor(0, 0, 0, 0);
			gl.clear(this.gl.COLOR_BUFFER_BIT);
			gl.disable(gl.SCISSOR_TEST);
		}
	};
	GLBatchJob.prototype.doPoints = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[1];
		gl.useProgram(s.shaderProgram);
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			s.updateMatMV(glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		gl.enableVertexAttribArray(s.locAPos);
		gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.pointBuffer);
		gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		gl.drawArrays(gl.POINTS, this.startIndex / 4, this.indexCount);
		s = glwrap.currentShader;
		gl.useProgram(s.shaderProgram);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	};
	GLBatchJob.prototype.doSetProgram = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[this.startIndex];		// recycled param to save memory
		glwrap.currentProgram = this.startIndex;			// current batch program
		glwrap.currentShader = s;
		gl.useProgram(s.shaderProgram);						// switch to
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			s.updateMatMV(glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		if (s.locOpacity && s.lpOpacity !== glwrap.currentOpacity)
		{
			s.lpOpacity = glwrap.currentOpacity;
			gl.uniform1f(s.locOpacity, glwrap.currentOpacity);
		}
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	}
	GLBatchJob.prototype.doSetProgramParameters = function ()
	{
		var i, len, s = this.glwrap.currentShader;
		var gl = this.gl;
		var mat4param = this.mat4param;
		if (s.locSamplerBack && this.glwrap.lastTexture1 !== this.texParam)
		{
			gl.activeTexture(gl.TEXTURE1);
			gl.bindTexture(gl.TEXTURE_2D, this.texParam);
			this.glwrap.lastTexture1 = this.texParam;
			gl.activeTexture(gl.TEXTURE0);
		}
		var v = mat4param[0];
		var v2;
		if (s.locPixelWidth && v !== s.lpPixelWidth)
		{
			s.lpPixelWidth = v;
			gl.uniform1f(s.locPixelWidth, v);
		}
		v = mat4param[1];
		if (s.locPixelHeight && v !== s.lpPixelHeight)
		{
			s.lpPixelHeight = v;
			gl.uniform1f(s.locPixelHeight, v);
		}
		v = mat4param[2];
		v2 = mat4param[3];
		if (s.locDestStart && (v !== s.lpDestStartX || v2 !== s.lpDestStartY))
		{
			s.lpDestStartX = v;
			s.lpDestStartY = v2;
			gl.uniform2f(s.locDestStart, v, v2);
		}
		v = mat4param[4];
		v2 = mat4param[5];
		if (s.locDestEnd && (v !== s.lpDestEndX || v2 !== s.lpDestEndY))
		{
			s.lpDestEndX = v;
			s.lpDestEndY = v;
			gl.uniform2f(s.locDestEnd, v, v2);
		}
		v = mat4param[6];
		if (s.locLayerScale && v !== s.lpLayerScale)
		{
			s.lpLayerScale = v;
			gl.uniform1f(s.locLayerScale, v);
		}
		v = mat4param[7];
		if (s.locLayerAngle && v !== s.lpLayerAngle)
		{
			s.lpLayerAngle = v;
			gl.uniform1f(s.locLayerAngle, v);
		}
		v = mat4param[8];
		v2 = mat4param[9];
		if (s.locViewOrigin && (v !== s.lpViewOriginX || v !== s.lpViewOriginY))
		{
			s.lpViewOriginX = v;
			s.lpViewOriginY = v2;
			gl.uniform2f(s.locViewOrigin, v, v2);
		}
		if (s.locSeconds)
			gl.uniform1f(s.locSeconds, cr.performance_now() / 1000.0);
		if (s.parameters.length)
		{
			for (i = 0, len = s.parameters.length; i < len; i++)
			{
				v = this.shaderParams[i];
				if (v !== s.lastCustomParams[i])
				{
					s.lastCustomParams[i] = v;
					gl.uniform1f(s.parameters[i][1], v);
				}
			}
		}
	};
	GLWrap_.prototype.pushBatch = function ()
	{
		if (this.batchPtr === this.batch.length)
			this.batch.push(new GLBatchJob(BATCH_NULL, this));
		return this.batch[this.batchPtr++];
	};
	GLWrap_.prototype.endBatch = function ()
	{
		if (this.batchPtr === 0)
			return;
		if (this.gl.isContextLost())
			return;
		var gl = this.gl;
		if (this.pointPtr > 0)
		{
			gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
			gl.bufferData(gl.ARRAY_BUFFER, this.pointData.subarray(0, this.pointPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name === "<point>")
				gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		}
		if (this.vertexPtr > 0)
		{
			var s = this.currentShader;
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.vertexData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.texcoordData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locATex >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
		var i, len, b;
		for (i = 0, len = this.batchPtr; i < len; i++)
		{
			b = this.batch[i];
			switch (b.type) {
			case 1:
				b.doQuad();
				break;
			case 2:
				b.doSetTexture();
				break;
			case 3:
				b.doSetOpacity();
				break;
			case 4:
				b.doSetBlend();
				break;
			case 5:
				b.doUpdateModelView();
				break;
			case 6:
				b.doRenderToTexture();
				break;
			case 7:
				b.doClear();
				break;
			case 8:
				b.doPoints();
				break;
			case 9:
				b.doSetProgram();
				break;
			case 10:
				b.doSetProgramParameters();
				break;
			case 11:
				b.doSetTexture1();
				break;
			}
		}
		this.batchPtr = 0;
		this.vertexPtr = 0;
		this.pointPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.curBuffer++;
		if (this.curBuffer >= MULTI_BUFFERS)
			this.curBuffer = 0;
	};
	GLWrap_.prototype.setOpacity = function (op)
	{
		if (op === this.lastOpacity)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETOPACITY;
		b.opacityParam = op;
		this.lastOpacity = op;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setTexture = function (tex)
	{
		if (tex === this.lastTexture0)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_SETTEXTURE;
		b.texParam = tex;
		this.lastTexture0 = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setBlend = function (s, d)
	{
		if (s === this.lastSrcBlend && d === this.lastDestBlend)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETBLEND;
		b.startIndex = s;		// recycle params to save memory
		b.indexCount = d;
		this.lastSrcBlend = s;
		this.lastDestBlend = d;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.isPremultipliedAlphaBlend = function ()
	{
		return (this.lastSrcBlend === this.gl.ONE && this.lastDestBlend === this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setAlphaBlend = function ()
	{
		this.setBlend(this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setNoPremultiplyAlphaBlend = function ()
	{
		this.setBlend(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	var LAST_VERTEX = MAX_VERTICES * 2 - 8;
	GLWrap_.prototype.quad = function(tlx, tly, trx, try_, brx, bry, blx, bly)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = 0;
		vd[v] = tly;
		td[v++] = 0;
		vd[v] = trx;
		td[v++] = 1;
		vd[v] = try_;
		td[v++] = 0;
		vd[v] = brx;
		td[v++] = 1;
		vd[v] = bry;
		td[v++] = 1;
		vd[v] = blx;
		td[v++] = 0;
		vd[v] = bly;
		td[v++] = 1;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTex = function(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		var rc_left = rcTex.left;
		var rc_top = rcTex.top;
		var rc_right = rcTex.right;
		var rc_bottom = rcTex.bottom;
		vd[v] = tlx;
		td[v++] = rc_left;
		vd[v] = tly;
		td[v++] = rc_top;
		vd[v] = trx;
		td[v++] = rc_right;
		vd[v] = try_;
		td[v++] = rc_top;
		vd[v] = brx;
		td[v++] = rc_right;
		vd[v] = bry;
		td[v++] = rc_bottom;
		vd[v] = blx;
		td[v++] = rc_left;
		vd[v] = bly;
		td[v++] = rc_bottom;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTexUV = function(tlx, tly, trx, try_, brx, bry, blx, bly, tlu, tlv, tru, trv, bru, brv, blu, blv)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = tlu;
		vd[v] = tly;
		td[v++] = tlv;
		vd[v] = trx;
		td[v++] = tru;
		vd[v] = try_;
		td[v++] = trv;
		vd[v] = brx;
		td[v++] = bru;
		vd[v] = bry;
		td[v++] = brv;
		vd[v] = blx;
		td[v++] = blu;
		vd[v] = bly;
		td[v++] = blv;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.convexPoly = function(pts)
	{
		var pts_count = pts.length / 2;
;
		var tris = pts_count - 2;	// 3 points = 1 tri, 4 points = 2 tris, 5 points = 3 tris etc.
		var last_tri = tris - 1;
		var p0x = pts[0];
		var p0y = pts[1];
		var i, i2, p1x, p1y, p2x, p2y, p3x, p3y;
		for (i = 0; i < tris; i += 2)		// draw 2 triangles at a time
		{
			i2 = i * 2;
			p1x = pts[i2 + 2];
			p1y = pts[i2 + 3];
			p2x = pts[i2 + 4];
			p2y = pts[i2 + 5];
			if (i === last_tri)
			{
				this.quad(p0x, p0y, p1x, p1y, p2x, p2y, p2x, p2y);
			}
			else
			{
				p3x = pts[i2 + 6];
				p3y = pts[i2 + 7];
				this.quad(p0x, p0y, p1x, p1y, p2x, p2y, p3x, p3y);
			}
		}
	};
	var LAST_POINT = MAX_POINTS - 4;
	GLWrap_.prototype.point = function(x_, y_, size_, opacity_)
	{
		if (this.pointPtr >= LAST_POINT)
			this.endBatch();
		var p = this.pointPtr;			// point cursor
		var pd = this.pointData;		// point data array
		if (this.hasPointBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount++;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_POINTS;
			b.startIndex = p;
			b.indexCount = 1;
			this.hasPointBatchTop = true;
			this.hasQuadBatchTop = false;
		}
		pd[p++] = x_;
		pd[p++] = y_;
		pd[p++] = size_;
		pd[p++] = opacity_;
		this.pointPtr = p;
	};
	GLWrap_.prototype.switchProgram = function (progIndex)
	{
		if (this.lastProgram === progIndex)
			return;			// no change
		var shaderProg = this.shaderPrograms[progIndex];
		if (!shaderProg)
		{
			if (this.lastProgram === 0)
				return;								// already on default shader
			progIndex = 0;
			shaderProg = this.shaderPrograms[0];
		}
		var b = this.pushBatch();
		b.type = BATCH_SETPROGRAM;
		b.startIndex = progIndex;
		this.lastProgram = progIndex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.programUsesDest = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd);
	};
	GLWrap_.prototype.programUsesCrossSampling = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd || s.crossSampling);
	};
	GLWrap_.prototype.programExtendsBox = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return s.extendBoxHorizontal !== 0 || s.extendBoxVertical !== 0;
	};
	GLWrap_.prototype.getProgramBoxExtendHorizontal = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxHorizontal;
	};
	GLWrap_.prototype.getProgramBoxExtendVertical = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxVertical;
	};
	GLWrap_.prototype.getProgramParameterType = function (progIndex, paramIndex)
	{
		return this.shaderPrograms[progIndex].parameters[paramIndex][2];
	};
	GLWrap_.prototype.programIsAnimated = function (progIndex)
	{
		return this.shaderPrograms[progIndex].animated;
	};
	GLWrap_.prototype.setProgramParameters = function (backTex, pixelWidth, pixelHeight, destStartX, destStartY, destEndX, destEndY, layerScale, layerAngle, viewOriginLeft, viewOriginTop, params)
	{
		var i, len;
		var s = this.shaderPrograms[this.lastProgram];
		var b, mat4param, shaderParams;
		if (s.hasAnyOptionalUniforms || params.length)
		{
			b = this.pushBatch();
			b.type = BATCH_SETPROGRAMPARAMETERS;
			if (b.mat4param)
				mat4.set(this.matMV, b.mat4param);
			else
				b.mat4param = mat4.create();
			mat4param = b.mat4param;
			mat4param[0] = pixelWidth;
			mat4param[1] = pixelHeight;
			mat4param[2] = destStartX;
			mat4param[3] = destStartY;
			mat4param[4] = destEndX;
			mat4param[5] = destEndY;
			mat4param[6] = layerScale;
			mat4param[7] = layerAngle;
			mat4param[8] = viewOriginLeft;
			mat4param[9] = viewOriginTop;
			if (s.locSamplerBack)
			{
;
				b.texParam = backTex;
			}
			else
				b.texParam = null;
			if (params.length)
			{
				shaderParams = b.shaderParams;
				shaderParams.length = params.length;
				for (i = 0, len = params.length; i < len; i++)
					shaderParams[i] = params[i];
			}
			this.hasQuadBatchTop = false;
			this.hasPointBatchTop = false;
		}
	};
	GLWrap_.prototype.clear = function (r, g, b_, a)
	{
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 0;					// clear all mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = r;
		b.mat4param[1] = g;
		b.mat4param[2] = b_;
		b.mat4param[3] = a;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.clearRect = function (x, y, w, h)
	{
		if (w < 0 || h < 0)
			return;							// invalid clear area
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 1;					// clear rect mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = x;
		b.mat4param[1] = y;
		b.mat4param[2] = w;
		b.mat4param[3] = h;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.present = function ()
	{
		this.endBatch();
		this.gl.flush();
		/*
		if (debugBatch)
		{
;
			debugBatch = false;
		}
		*/
	};
	function nextHighestPowerOfTwo(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	var all_textures = [];
	var textures_by_src = {};
	GLWrap_.prototype.contextLost = function ()
	{
		all_textures.length = 0;
		textures_by_src = {};
	};
	var BF_RGBA8 = 0;
	var BF_RGB8 = 1;
	var BF_RGBA4 = 2;
	var BF_RGB5_A1 = 3;
	var BF_RGB565 = 4;
	GLWrap_.prototype.loadTexture = function (img, tiling, linearsampling, pixelformat, tiletype, nomip)
	{
		tiling = !!tiling;
		linearsampling = !!linearsampling;
		var tex_key = img.src + "," + tiling + "," + linearsampling + (tiling ? ("," + tiletype) : "");
		var webGL_texture = null;
		if (typeof img.src !== "undefined" && textures_by_src.hasOwnProperty(tex_key))
		{
			webGL_texture = textures_by_src[tex_key];
			webGL_texture.c2refcount++;
			return webGL_texture;
		}
		this.endBatch();
;
		var gl = this.gl;
		var isPOT = (cr.isPOT(img.width) && cr.isPOT(img.height));
		webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		var internalformat = gl.RGBA;
		var format = gl.RGBA;
		var type = gl.UNSIGNED_BYTE;
		if (pixelformat && !this.isIE)
		{
			switch (pixelformat) {
			case BF_RGB8:
				internalformat = gl.RGB;
				format = gl.RGB;
				break;
			case BF_RGBA4:
				type = gl.UNSIGNED_SHORT_4_4_4_4;
				break;
			case BF_RGB5_A1:
				type = gl.UNSIGNED_SHORT_5_5_5_1;
				break;
			case BF_RGB565:
				internalformat = gl.RGB;
				format = gl.RGB;
				type = gl.UNSIGNED_SHORT_5_6_5;
				break;
			}
		}
		if (!isPOT && tiling)
		{
			var canvas = document.createElement("canvas");
			canvas.width = cr.nextHighestPowerOfTwo(img.width);
			canvas.height = cr.nextHighestPowerOfTwo(img.height);
			var ctx = canvas.getContext("2d");
			ctx["webkitImageSmoothingEnabled"] = linearsampling;
			ctx["mozImageSmoothingEnabled"] = linearsampling;
			ctx["msImageSmoothingEnabled"] = linearsampling;
			ctx["imageSmoothingEnabled"] = linearsampling;
			ctx.drawImage(img,
						  0, 0, img.width, img.height,
						  0, 0, canvas.width, canvas.height);
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, canvas);
		}
		else
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, img);
		if (tiling)
		{
			if (tiletype === "repeat-x")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
			}
			else if (tiletype === "repeat-y")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
			else
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		if (linearsampling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
			if (isPOT && this.enable_mipmaps && !nomip)
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_LINEAR);
				gl.generateMipmap(gl.TEXTURE_2D);
			}
			else
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
		}
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = img.width;
		webGL_texture.c2height = img.height;
		webGL_texture.c2refcount = 1;
		webGL_texture.c2texkey = tex_key;
		all_textures.push(webGL_texture);
		textures_by_src[tex_key] = webGL_texture;
		return webGL_texture;
	};
	GLWrap_.prototype.createEmptyTexture = function (w, h, linearsampling, _16bit, tiling)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		var webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, w, h, 0, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, null);
		if (tiling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = w;
		webGL_texture.c2height = h;
		all_textures.push(webGL_texture);
		return webGL_texture;
	};
	GLWrap_.prototype.videoToTexture = function (video_, texture_, _16bit)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		gl.bindTexture(gl.TEXTURE_2D, texture_);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		try {
			gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, video_);
		}
		catch (e)
		{
			if (console && console.error)
				console.error("Error updating WebGL texture: ", e);
		}
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
	};
	GLWrap_.prototype.deleteTexture = function (tex)
	{
		if (!tex)
			return;
		if (typeof tex.c2refcount !== "undefined" && tex.c2refcount > 1)
		{
			tex.c2refcount--;
			return;
		}
		this.endBatch();
		if (tex === this.lastTexture0)
		{
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.lastTexture0 = null;
		}
		if (tex === this.lastTexture1)
		{
			this.gl.activeTexture(this.gl.TEXTURE1);
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.gl.activeTexture(this.gl.TEXTURE0);
			this.lastTexture1 = null;
		}
		cr.arrayFindRemove(all_textures, tex);
		if (typeof tex.c2texkey !== "undefined")
			delete textures_by_src[tex.c2texkey];
		this.gl.deleteTexture(tex);
	};
	GLWrap_.prototype.estimateVRAM = function ()
	{
		var total = this.width * this.height * 4 * 2;
		var i, len, t;
		for (i = 0, len = all_textures.length; i < len; i++)
		{
			t = all_textures[i];
			total += (t.c2width * t.c2height * 4);
		}
		return total;
	};
	GLWrap_.prototype.textureCount = function ()
	{
		return all_textures.length;
	};
	GLWrap_.prototype.setRenderingToTexture = function (tex)
	{
		if (tex === this.renderToTex)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_RENDERTOTEXTURE;
		b.texParam = tex;
		this.renderToTex = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	cr.GLWrap = GLWrap_;
}());
;
(function()
{
	function window_innerWidth()
	{
		if (typeof jQuery !== "undefined")
			return jQuery(window).width();
		else
			return window.innerWidth;
	};
	function window_innerHeight()
	{
		if (typeof jQuery !== "undefined")
			return jQuery(window).height();
		else
			return window.innerHeight;
	};
	function Runtime(canvas)
	{
		if (!canvas || (!canvas.getContext && !canvas["dc"]))
			return;
		if (canvas["c2runtime"])
			return;
		else
			canvas["c2runtime"] = this;
		var self = this;
		this.isCrosswalk = /crosswalk/i.test(navigator.userAgent) || /xwalk/i.test(navigator.userAgent) || !!(typeof window["c2isCrosswalk"] !== "undefined" && window["c2isCrosswalk"]);
		this.isPhoneGap = this.isCrosswalk || (typeof window["device"] !== "undefined" && (typeof window["device"]["cordova"] !== "undefined" || typeof window["device"]["phonegap"] !== "undefined")) || (typeof window["c2isphonegap"] !== "undefined" && window["c2isphonegap"]);
		this.isDirectCanvas = !!canvas["dc"];
		this.isAppMobi = (typeof window["AppMobi"] !== "undefined" || this.isDirectCanvas);
		this.isCocoonJs = !!window["c2cocoonjs"];
		this.isEjecta = !!window["c2ejecta"];
		if (this.isCocoonJs)
		{
			CocoonJS["App"]["onSuspended"].addEventListener(function() {
				self["setSuspended"](true);
			});
			CocoonJS["App"]["onActivated"].addEventListener(function () {
				self["setSuspended"](false);
			});
		}
		if (this.isEjecta)
		{
			document.addEventListener("pagehide", function() {
				self["setSuspended"](true);
			});
			document.addEventListener("pageshow", function() {
				self["setSuspended"](false);
			});
			document.addEventListener("resize", function () {
				self["setSize"](window.innerWidth, window.innerHeight);
			});
		}
		this.isDomFree = (this.isDirectCanvas || this.isCocoonJs || this.isEjecta);
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent) || /iemobile/i.test(navigator.userAgent);
		this.isTizen = /tizen/i.test(navigator.userAgent);
		this.isAndroid = /android/i.test(navigator.userAgent) && !this.isTizen && !this.isIE;		// IE mobile and Tizen masquerade as Android
		this.isiPhone = (/iphone/i.test(navigator.userAgent) || /ipod/i.test(navigator.userAgent)) && !this.isIE;	// treat ipod as an iphone; IE mobile masquerades as iPhone
		this.isiPad = /ipad/i.test(navigator.userAgent);
		this.isiOS = this.isiPhone || this.isiPad || this.isEjecta;
		this.isiPhoneiOS6 = (this.isiPhone && /os\s6/i.test(navigator.userAgent));
		this.isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);	// note true on Chromium-based webview on Android 4.4+
		this.isAmazonWebApp = /amazonwebappplatform/i.test(navigator.userAgent);
		this.isFirefox = /firefox/i.test(navigator.userAgent);
		this.isSafari = /safari/i.test(navigator.userAgent) && !this.isChrome && !this.isIE;		// Chrome and IE Mobile masquerade as Safari
		this.isWindows = /windows/i.test(navigator.userAgent);
		this.isNodeWebkit = (typeof window["c2nodewebkit"] !== "undefined" || /nodewebkit/i.test(navigator.userAgent));
		this.isArcade = (typeof window["is_scirra_arcade"] !== "undefined");
		this.isWindows8App = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.isWindows8Capable = !!(typeof window["c2isWindows8Capable"] !== "undefined" && window["c2isWindows8Capable"]);
		this.isWindowsPhone8 = !!(typeof window["c2isWindowsPhone8"] !== "undefined" && window["c2isWindowsPhone8"]);
		this.isWindowsPhone81 = !!(typeof window["c2isWindowsPhone81"] !== "undefined" && window["c2isWindowsPhone81"]);
		this.isWinJS = (this.isWindows8App || this.isWindows8Capable || this.isWindowsPhone81);	// note not WP8.0
		this.isBlackberry10 = !!(typeof window["c2isBlackberry10"] !== "undefined" && window["c2isBlackberry10"]);
		this.isAndroidStockBrowser = (this.isAndroid && !this.isChrome && !this.isCrosswalk && !this.isFirefox && !this.isAmazonWebApp && !this.isDomFree);
		this.devicePixelRatio = 1;
		this.isMobile = (this.isPhoneGap || this.isCrosswalk || this.isAppMobi || this.isCocoonJs || this.isAndroid || this.isiOS || this.isWindowsPhone8 || this.isWindowsPhone81 || this.isBlackberry10 || this.isTizen || this.isEjecta);
		if (!this.isMobile)
		{
			this.isMobile = /(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent);
		}
		if (typeof cr_is_preview !== "undefined" && !this.isNodeWebkit && (window.location.search === "?nw" || /nodewebkit/i.test(navigator.userAgent)))
		{
			this.isNodeWebkit = true;
		}
		this.isDebug = (typeof cr_is_preview !== "undefined" && window.location.search.indexOf("debug") > -1);
		this.canvas = canvas;
		this.canvasdiv = document.getElementById("c2canvasdiv");
		this.gl = null;
		this.glwrap = null;
		this.ctx = null;
		this.fullscreenOldMarginCss = "";
		this.firstInFullscreen = false;
		this.oldWidth = 0;		// for restoring non-fullscreen canvas after fullscreen
		this.oldHeight = 0;
		this.canvas.oncontextmenu = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		this.canvas.onselectstart = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		if (this.isDirectCanvas)
			window["c2runtime"] = this;
		if (this.isNodeWebkit)
		{
			window["ondragover"] = function(e) { e.preventDefault(); return false; };
			window["ondrop"] = function(e) { e.preventDefault(); return false; };
			require("nw.gui")["App"]["clearCache"]();
		}
		if (this.isAndroidStockBrowser && typeof jQuery !== "undefined")
		{
			jQuery("canvas").parents("*").css("overflow", "visible");
		}
		this.width = canvas.width;
		this.height = canvas.height;
		this.draw_width = this.width;
		this.draw_height = this.height;
		this.cssWidth = this.width;
		this.cssHeight = this.height;
		this.lastWindowWidth = window.innerWidth;
		this.lastWindowHeight = window.innerHeight;
		this.redraw = true;
		this.isSuspended = false;
		if (!Date.now) {
		  Date.now = function now() {
			return +new Date();
		  };
		}
		this.plugins = [];
		this.types = {};
		this.types_by_index = [];
		this.behaviors = [];
		this.layouts = {};
		this.layouts_by_index = [];
		this.eventsheets = {};
		this.eventsheets_by_index = [];
		this.wait_for_textures = [];        // for blocking until textures loaded
		this.triggers_to_postinit = [];
		this.all_global_vars = [];
		this.all_local_vars = [];
		this.solidBehavior = null;
		this.jumpthruBehavior = null;
		this.shadowcasterBehavior = null;
		this.deathRow = new cr.ObjectSet();
		this.isInClearDeathRow = false;
		this.isInOnDestroy = 0;					// needs to support recursion so increments and decrements and is true if > 0
		this.isRunningEvents = false;
		this.createRow = [];
		this.isLoadingState = false;
		this.saveToSlot = "";
		this.loadFromSlot = "";
		this.loadFromJson = "";
		this.lastSaveJson = "";
		this.signalledContinuousPreview = false;
		this.suspendDrawing = false;		// for hiding display until continuous preview loads
		this.dt = 0;
        this.dt1 = 0;
		this.logictime = 0;			// used to calculate CPUUtilisation
		this.cpuutilisation = 0;
		this.zeroDtCount = 0;
        this.timescale = 1.0;
        this.kahanTime = new cr.KahanAdder();
		this.wallTime = new cr.KahanAdder();
		this.last_tick_time = 0;
		this.measuring_dt = true;
		this.fps = 0;
		this.last_fps_time = 0;
		this.tickcount = 0;
		this.execcount = 0;
		this.framecount = 0;        // for fps
		this.objectcount = 0;
		this.changelayout = null;
		this.destroycallbacks = [];
		this.event_stack = [];
		this.event_stack_index = -1;
		this.localvar_stack = [[]];
		this.localvar_stack_index = 0;
		this.trigger_depth = 0;		// recursion depth for triggers
		this.pushEventStack(null);
		this.loop_stack = [];
		this.loop_stack_index = -1;
		this.next_uid = 0;
		this.next_puid = 0;		// permanent unique ids
		this.layout_first_tick = true;
		this.family_count = 0;
		this.suspend_events = [];
		this.raf_id = -1;
		this.timeout_id = -1;
		this.isloading = true;
		this.loadingprogress = 0;
		this.isNodeFullscreen = false;
		this.stackLocalCount = 0;	// number of stack-based local vars for recursion
		this.audioInstance = null;
		this.halfFramerateMode = false;
		this.lastRafTime = 0;		// time of last requestAnimationFrame call
		this.ranLastRaf = false;	// false if last requestAnimationFrame was skipped for half framerate mode
		this.had_a_click = false;
		this.isInUserInputEvent = false;
		this.objects_to_pretick = new cr.ObjectSet();
        this.objects_to_tick = new cr.ObjectSet();
		this.objects_to_tick2 = new cr.ObjectSet();
		this.registered_collisions = [];
		this.temp_poly = new cr.CollisionPoly([]);
		this.temp_poly2 = new cr.CollisionPoly([]);
		this.allGroups = [];				// array of all event groups
        this.groups_by_name = {};
		this.cndsBySid = {};
		this.actsBySid = {};
		this.varsBySid = {};
		this.blocksBySid = {};
		this.running_layout = null;			// currently running layout
		this.layer_canvas = null;			// for layers "render-to-texture"
		this.layer_ctx = null;
		this.layer_tex = null;
		this.layout_tex = null;
		this.layout_canvas = null;
		this.layout_ctx = null;
		this.is_WebGL_context_lost = false;
		this.uses_background_blending = false;	// if any shader uses background blending, so entire layout renders to texture
		this.fx_tex = [null, null];
		this.fullscreen_scaling = 0;
		this.files_subfolder = "";			// path with project files
		this.objectsByUid = {};				// maps every in-use UID (as a string) to its instance
		this.loaderlogo = null;
		this.snapshotCanvas = null;
		this.snapshotData = "";
		this.load();
		this.isRetina = ((!this.isDomFree || this.isEjecta) && this.useHighDpi && !this.isAndroidStockBrowser);
		this.devicePixelRatio = (this.isRetina ? (window["devicePixelRatio"] || window["webkitDevicePixelRatio"] || window["mozDevicePixelRatio"] || window["msDevicePixelRatio"] || 1) : 1);
		this.ClearDeathRow();
		var attribs;
		var alpha_canvas = this.alphaBackground && !(this.isNodeWebkit || this.isWinJS || this.isWindowsPhone8 || this.isCrosswalk || this.isPhoneGap);
		if (this.fullscreen_mode > 0)
			this["setSize"](window_innerWidth(), window_innerHeight(), true);
		try {
			if (this.enableWebGL && (this.isCocoonJs || this.isEjecta || !this.isDomFree))
			{
				attribs = {
					"alpha": alpha_canvas,
					"depth": false,
					"antialias": false,
					"failIfMajorPerformanceCaveat": true
				};
				this.gl = (canvas.getContext("webgl", attribs) || canvas.getContext("experimental-webgl", attribs));
			}
		}
		catch (e) {
		}
		if (this.gl)
		{
			if (!this.isDomFree)
			{
				this.overlay_canvas = document.createElement("canvas");
				jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode);
				this.overlay_canvas.oncontextmenu = function (e) { return false; };
				this.overlay_canvas.onselectstart = function (e) { return false; };
				this.overlay_canvas.width = this.cssWidth;
				this.overlay_canvas.height = this.cssHeight;
				jQuery(this.overlay_canvas).css({"width": this.cssWidth + "px",
												"height": this.cssHeight + "px"});
				this.positionOverlayCanvas();
				this.overlay_ctx = this.overlay_canvas.getContext("2d");
			}
			this.glwrap = new cr.GLWrap(this.gl, this.isMobile);
			this.glwrap.setSize(canvas.width, canvas.height);
			this.glwrap.enable_mipmaps = (this.downscalingQuality !== 0);
			this.ctx = null;
			this.canvas.addEventListener("webglcontextlost", function (ev) {
				ev.preventDefault();
				self.onContextLost();
				console.log("[Construct 2] WebGL context lost");
				window["cr_setSuspended"](true);		// stop rendering
			}, false);
			this.canvas.addEventListener("webglcontextrestored", function (ev) {
				self.glwrap.initState();
				self.glwrap.setSize(self.glwrap.width, self.glwrap.height, true);
				self.layer_tex = null;
				self.layout_tex = null;
				self.fx_tex[0] = null;
				self.fx_tex[1] = null;
				self.onContextRestored();
				self.redraw = true;
				console.log("[Construct 2] WebGL context restored");
				window["cr_setSuspended"](false);		// resume rendering
			}, false);
			var i, len, j, lenj, k, lenk, t, s, l, y;
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
				{
					s = t.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
					this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
				}
			}
			for (i = 0, len = this.layouts_by_index.length; i < len; i++)
			{
				l = this.layouts_by_index[i];
				for (j = 0, lenj = l.effect_types.length; j < lenj; j++)
				{
					s = l.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
				}
				for (j = 0, lenj = l.layers.length; j < lenj; j++)
				{
					y = l.layers[j];
					for (k = 0, lenk = y.effect_types.length; k < lenk; k++)
					{
						s = y.effect_types[k];
						s.shaderindex = this.glwrap.getShaderIndex(s.id);
						this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
					}
				}
			}
		}
		else
		{
			if (this.fullscreen_mode > 0 && this.isDirectCanvas)
			{
;
				this.canvas = null;
				document.oncontextmenu = function (e) { return false; };
				document.onselectstart = function (e) { return false; };
				this.ctx = AppMobi["canvas"]["getContext"]("2d");
				try {
					this.ctx["samplingMode"] = this.linearSampling ? "smooth" : "sharp";
					this.ctx["globalScale"] = 1;
					this.ctx["HTML5CompatibilityMode"] = true;
					this.ctx["imageSmoothingEnabled"] = this.linearSampling;
				} catch(e){}
				if (this.width !== 0 && this.height !== 0)
				{
					this.ctx.width = this.width;
					this.ctx.height = this.height;
				}
			}
			if (!this.ctx)
			{
;
				if (this.isCocoonJs)
				{
					attribs = {
						"antialias": !!this.linearSampling,
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				else
				{
					attribs = {
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["imageSmoothingEnabled"] = this.linearSampling;
			}
			this.overlay_canvas = null;
			this.overlay_ctx = null;
		}
		this.tickFunc = function () { self.tick(false); };
		if (window != window.top && !this.isDomFree && !this.isWinJS && !this.isWindowsPhone8)
		{
			document.addEventListener("mousedown", function () {
				window.focus();
			}, true);
			document.addEventListener("touchstart", function () {
				window.focus();
			}, true);
		}
		if (typeof cr_is_preview !== "undefined")
		{
			if (this.isCocoonJs)
				console.log("[Construct 2] In preview-over-wifi via CocoonJS mode");
			if (window.location.search.indexOf("continuous") > -1)
			{
				cr.logexport("Reloading for continuous preview");
				this.loadFromSlot = "__c2_continuouspreview";
				this.suspendDrawing = true;
			}
			if (this.pauseOnBlur && !this.isMobile)
			{
				jQuery(window).focus(function ()
				{
					self["setSuspended"](false);
				});
				jQuery(window).blur(function ()
				{
					self["setSuspended"](true);
				});
			}
		}
		var unfocusFormControlFunc = function (e) {
			if (cr.isCanvasInputEvent(e) && document["activeElement"] && document["activeElement"].blur)
			{
				document["activeElement"].blur();
			}
		}
		if (window.navigator["pointerEnabled"])
		{
			document.addEventListener("pointerdown", unfocusFormControlFunc);
		}
		else if (window.navigator["msPointerEnabled"])
		{
			document.addEventListener("MSPointerDown", unfocusFormControlFunc);
		}
		else
		{
			document.addEventListener("touchstart", unfocusFormControlFunc);
		}
		document.addEventListener("mousedown", unfocusFormControlFunc);
		if (this.fullscreen_mode === 0 && this.isRetina && this.devicePixelRatio > 1)
		{
			this["setSize"](this.original_width, this.original_height, true);
		}
		this.tryLockOrientation();
		this.getready();	// determine things to preload
		this.go();			// run loading screen
		this.extra = {};
		cr.seal(this);
	};
	var webkitRepaintFlag = false;
	Runtime.prototype["setSize"] = function (w, h, force)
	{
		var offx = 0, offy = 0;
		var neww = 0, newh = 0, intscale = 0;
		var tryHideAddressBar = (this.isiPhoneiOS6 && this.isSafari && !navigator["standalone"] && !this.isDomFree && !this.isPhoneGap);
		if (tryHideAddressBar)
			h += 60;		// height of Safari iPhone iOS 6 address bar
		if (this.lastWindowWidth === w && this.lastWindowHeight === h && !force)
			return;
		this.lastWindowWidth = w;
		this.lastWindowHeight = h;
		var mode = this.fullscreen_mode;
		var orig_aspect, cur_aspect;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen) && !this.isPhoneGap;
		if (!isfullscreen && this.fullscreen_mode === 0 && !force)
			return;			// ignore size events when not fullscreen and not using a fullscreen-in-browser mode
		if (isfullscreen && this.fullscreen_scaling > 0)
			mode = this.fullscreen_scaling;
		var dpr = this.devicePixelRatio;
		if (mode >= 4)
		{
			orig_aspect = this.original_width / this.original_height;
			cur_aspect = w / h;
			if (cur_aspect > orig_aspect)
			{
				neww = h * orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = (neww * dpr) / this.original_width;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale / dpr;
					newh = this.original_height * intscale / dpr;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offx = (w - neww) / 2;
					w = neww;
				}
			}
			else
			{
				newh = w / orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = (newh * dpr) / this.original_height;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale / dpr;
					newh = this.original_height * intscale / dpr;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offy = (h - newh) / 2;
					h = newh;
				}
			}
			if (isfullscreen && !this.isNodeWebkit)
			{
				offx = 0;
				offy = 0;
			}
		}
		else if (this.isNodeWebkit && this.isNodeFullscreen && this.fullscreen_mode_set === 0)
		{
			offx = Math.floor((w - this.original_width) / 2);
			offy = Math.floor((h - this.original_height) / 2);
			w = this.original_width;
			h = this.original_height;
		}
		if (mode < 2)
			this.aspect_scale = dpr;
		if (this.isRetina && this.isiPad && dpr > 1)	// don't apply to iPad 1-2
		{
			if (w >= 1024)
				w = 1023;		// 2046 retina pixels
			if (h >= 1024)
				h = 1023;
		}
		this.cssWidth = Math.round(w);
		this.cssHeight = Math.round(h);
		this.width = Math.round(w * dpr);
		this.height = Math.round(h * dpr);
		this.redraw = true;
		if (this.wantFullscreenScalingQuality)
		{
			this.draw_width = this.width;
			this.draw_height = this.height;
			this.fullscreenScalingQuality = true;
		}
		else
		{
			if ((this.width < this.original_width && this.height < this.original_height) || mode === 1)
			{
				this.draw_width = this.width;
				this.draw_height = this.height;
				this.fullscreenScalingQuality = true;
			}
			else
			{
				this.draw_width = this.original_width;
				this.draw_height = this.original_height;
				this.fullscreenScalingQuality = false;
				/*var orig_aspect = this.original_width / this.original_height;
				var cur_aspect = this.width / this.height;
				if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
					this.aspect_scale = this.height / this.original_height;
				else
					this.aspect_scale = this.width / this.original_width;*/
				if (mode === 2)		// scale inner
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect < orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect > orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
				else if (mode === 3)
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect > orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect < orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
			}
		}
		if (this.canvasdiv && !this.isDomFree)
		{
			jQuery(this.canvasdiv).css({"width": Math.round(w) + "px",
										"height": Math.round(h) + "px",
										"margin-left": Math.floor(offx) + "px",
										"margin-top": Math.floor(offy) + "px"});
			if (typeof cr_is_preview !== "undefined")
			{
				jQuery("#borderwrap").css({"width": Math.round(w) + "px",
											"height": Math.round(h) + "px"});
			}
		}
		if (this.canvas)
		{
			this.canvas.width = Math.round(w * dpr);
			this.canvas.height = Math.round(h * dpr);
			if (this.isEjecta)
			{
				this.canvas.style.left = Math.floor(offx) + "px";
				this.canvas.style.top = Math.floor(offy) + "px";
				this.canvas.style.width = Math.round(w) + "px";
				this.canvas.style.height = Math.round(h) + "px";
			}
			else if (this.isRetina && !this.isDomFree)
			{
				jQuery(this.canvas).css({"width": Math.round(w) + "px",
										"height": Math.round(h) + "px"});
			}
		}
		if (this.overlay_canvas)
		{
			this.overlay_canvas.width = Math.round(w);
			this.overlay_canvas.height = Math.round(h);
			jQuery(this.overlay_canvas).css({"width": Math.round(w) + "px",
											"height": Math.round(h) + "px"});
		}
		if (this.glwrap)
		{
			this.glwrap.setSize(Math.round(w * dpr), Math.round(h * dpr));
		}
		if (this.isDirectCanvas && this.ctx)
		{
			this.ctx.width = Math.round(w);
			this.ctx.height = Math.round(h);
		}
		if (this.ctx)
		{
			this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["imageSmoothingEnabled"] = this.linearSampling;
		}
		this.tryLockOrientation();
		if (!this.isDomFree && (tryHideAddressBar || this.isiPhone))
		{
			window.setTimeout(function () {
				window.scrollTo(0, 1);
			}, 100);
		}
	};
	Runtime.prototype.tryLockOrientation = function ()
	{
		if (!this.autoLockOrientation || this.orientations === 0)
			return;
		var orientation = "portrait";
		if (this.orientations === 2)
			orientation = "landscape";
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Runtime.prototype.onContextLost = function ()
	{
		this.glwrap.contextLost();
		this.is_WebGL_context_lost = true;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onLostWebGLContext)
				t.onLostWebGLContext();
		}
	};
	Runtime.prototype.onContextRestored = function ()
	{
		this.is_WebGL_context_lost = false;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onRestoreWebGLContext)
				t.onRestoreWebGLContext();
		}
	};
	Runtime.prototype.positionOverlayCanvas = function()
	{
		if (this.isDomFree)
			return;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen) && !this.isPhoneGap;
		var overlay_position = isfullscreen ? jQuery(this.canvas).offset() : jQuery(this.canvas).position();
		overlay_position.position = "absolute";
		jQuery(this.overlay_canvas).css(overlay_position);
	};
	var caf = window["cancelAnimationFrame"] ||
	  window["mozCancelAnimationFrame"]    ||
	  window["webkitCancelAnimationFrame"] ||
	  window["msCancelAnimationFrame"]     ||
	  window["oCancelAnimationFrame"];
	Runtime.prototype["setSuspended"] = function (s)
	{
		var i, len;
		if (s && !this.isSuspended)
		{
			cr.logexport("[Construct 2] Suspending");
			this.isSuspended = true;			// next tick will be last
			if (this.raf_id !== -1 && caf)		// note: CocoonJS does not implement cancelAnimationFrame
				caf(this.raf_id);
			if (this.timeout_id !== -1)
				clearTimeout(this.timeout_id);
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](true);
		}
		else if (!s && this.isSuspended)
		{
			cr.logexport("[Construct 2] Resuming");
			this.isSuspended = false;
			this.last_tick_time = cr.performance_now();	// ensure first tick is a zero-dt one
			this.last_fps_time = cr.performance_now();	// reset FPS counter
			this.framecount = 0;
			this.logictime = 0;
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](false);
			this.tick(false);						// kick off runtime again
		}
	};
	Runtime.prototype.addSuspendCallback = function (f)
	{
		this.suspend_events.push(f);
	};
	Runtime.prototype.load = function ()
	{
;
		var pm = cr.getProjectModel();
		this.name = pm[0];
		this.first_layout = pm[1];
		this.fullscreen_mode = pm[12];	// 0 = off, 1 = crop, 2 = scale inner, 3 = scale outer, 4 = letterbox scale, 5 = integer letterbox scale
		this.fullscreen_mode_set = pm[12];
		this.original_width = pm[10];
		this.original_height = pm[11];
		this.parallax_x_origin = this.original_width / 2;
		this.parallax_y_origin = this.original_height / 2;
		if (this.isDomFree && !this.isEjecta && (pm[12] >= 4 || pm[12] === 0))
		{
			cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'");
			this.fullscreen_mode = 3;
			this.fullscreen_mode_set = 3;
		}
		this.uses_loader_layout = pm[18];
		this.loaderstyle = pm[19];
		if (this.loaderstyle === 0)
		{
			this.loaderlogo = new Image();
			this.loaderlogo.src = "loading-logo.png";
		}
		this.next_uid = pm[21];
		this.system = new cr.system_object(this);
		var i, len, j, lenj, k, lenk, idstr, m, b, t, f;
		var plugin, plugin_ctor;
		for (i = 0, len = pm[2].length; i < len; i++)
		{
			m = pm[2][i];
;
			cr.add_common_aces(m);
			plugin = new m[0](this);
			plugin.singleglobal = m[1];
			plugin.is_world = m[2];
			plugin.must_predraw = m[9];
			if (plugin.onCreate)
				plugin.onCreate();  // opportunity to override default ACEs
			cr.seal(plugin);
			this.plugins.push(plugin);
		}
		pm = cr.getProjectModel();
		for (i = 0, len = pm[3].length; i < len; i++)
		{
			m = pm[3][i];
			plugin_ctor = m[1];
;
			plugin = null;
			for (j = 0, lenj = this.plugins.length; j < lenj; j++)
			{
				if (this.plugins[j] instanceof plugin_ctor)
				{
					plugin = this.plugins[j];
					break;
				}
			}
;
;
			var type_inst = new plugin.Type(plugin);
;
			type_inst.name = m[0];
			type_inst.is_family = m[2];
			type_inst.instvar_sids = m[3].slice(0);
			type_inst.vars_count = m[3].length;
			type_inst.behs_count = m[4];
			type_inst.fx_count = m[5];
			type_inst.sid = m[11];
			if (type_inst.is_family)
			{
				type_inst.members = [];				// types in this family
				type_inst.family_index = this.family_count++;
				type_inst.families = null;
			}
			else
			{
				type_inst.members = null;
				type_inst.family_index = -1;
				type_inst.families = [];			// families this type belongs to
			}
			type_inst.family_var_map = null;
			type_inst.family_beh_map = null;
			type_inst.family_fx_map = null;
			type_inst.is_contained = false;
			type_inst.container = null;
			if (m[6])
			{
				type_inst.texture_file = m[6][0];
				type_inst.texture_filesize = m[6][1];
				type_inst.texture_pixelformat = m[6][2];
			}
			else
			{
				type_inst.texture_file = null;
				type_inst.texture_filesize = 0;
				type_inst.texture_pixelformat = 0;		// rgba8
			}
			if (m[7])
			{
				type_inst.animations = m[7];
			}
			else
			{
				type_inst.animations = null;
			}
			type_inst.index = i;                                // save index in to types array in type
			type_inst.instances = [];                           // all instances of this type
			type_inst.deadCache = [];							// destroyed instances to recycle next create
			type_inst.solstack = [new cr.selection(type_inst)]; // initialise SOL stack with one empty SOL
			type_inst.cur_sol = 0;
			type_inst.default_instance = null;
			type_inst.default_layerindex = 0;
			type_inst.stale_iids = true;
			type_inst.updateIIDs = cr.type_updateIIDs;
			type_inst.getFirstPicked = cr.type_getFirstPicked;
			type_inst.getPairedInstance = cr.type_getPairedInstance;
			type_inst.getCurrentSol = cr.type_getCurrentSol;
			type_inst.pushCleanSol = cr.type_pushCleanSol;
			type_inst.pushCopySol = cr.type_pushCopySol;
			type_inst.popSol = cr.type_popSol;
			type_inst.getBehaviorByName = cr.type_getBehaviorByName;
			type_inst.getBehaviorIndexByName = cr.type_getBehaviorIndexByName;
			type_inst.getEffectIndexByName = cr.type_getEffectIndexByName;
			type_inst.applySolToContainer = cr.type_applySolToContainer;
			type_inst.getInstanceByIID = cr.type_getInstanceByIID;
			type_inst.collision_grid = new cr.SparseGrid(this.original_width, this.original_height);
			type_inst.any_cell_changed = true;
			type_inst.any_instance_parallaxed = false;
			type_inst.extra = {};
			type_inst.toString = cr.type_toString;
			type_inst.behaviors = [];
			for (j = 0, lenj = m[8].length; j < lenj; j++)
			{
				b = m[8][j];
				var behavior_ctor = b[1];
				var behavior_plugin = null;
				for (k = 0, lenk = this.behaviors.length; k < lenk; k++)
				{
					if (this.behaviors[k] instanceof behavior_ctor)
					{
						behavior_plugin = this.behaviors[k];
						break;
					}
				}
				if (!behavior_plugin)
				{
					behavior_plugin = new behavior_ctor(this);
					behavior_plugin.my_types = [];						// types using this behavior
					behavior_plugin.my_instances = new cr.ObjectSet(); 	// instances of this behavior
					if (behavior_plugin.onCreate)
						behavior_plugin.onCreate();
					cr.seal(behavior_plugin);
					this.behaviors.push(behavior_plugin);
					if (cr.behaviors.solid && behavior_plugin instanceof cr.behaviors.solid)
						this.solidBehavior = behavior_plugin;
					if (cr.behaviors.jumpthru && behavior_plugin instanceof cr.behaviors.jumpthru)
						this.jumpthruBehavior = behavior_plugin;
					if (cr.behaviors.shadowcaster && behavior_plugin instanceof cr.behaviors.shadowcaster)
						this.shadowcasterBehavior = behavior_plugin;
				}
				if (behavior_plugin.my_types.indexOf(type_inst) === -1)
					behavior_plugin.my_types.push(type_inst);
				var behavior_type = new behavior_plugin.Type(behavior_plugin, type_inst);
				behavior_type.name = b[0];
				behavior_type.sid = b[2];
				behavior_type.onCreate();
				cr.seal(behavior_type);
				type_inst.behaviors.push(behavior_type);
			}
			type_inst.global = m[9];
			type_inst.isOnLoaderLayout = m[10];
			type_inst.effect_types = [];
			for (j = 0, lenj = m[12].length; j < lenj; j++)
			{
				type_inst.effect_types.push({
					id: m[12][j][0],
					name: m[12][j][1],
					shaderindex: -1,
					active: true,
					index: j
				});
			}
			type_inst.tile_poly_data = m[13];
			if (!this.uses_loader_layout || type_inst.is_family || type_inst.isOnLoaderLayout || !plugin.is_world)
			{
				type_inst.onCreate();
				cr.seal(type_inst);
			}
			if (type_inst.name)
				this.types[type_inst.name] = type_inst;
			this.types_by_index.push(type_inst);
			if (plugin.singleglobal)
			{
				var instance = new plugin.Instance(type_inst);
				instance.uid = this.next_uid++;
				instance.puid = this.next_puid++;
				instance.iid = 0;
				instance.get_iid = cr.inst_get_iid;
				instance.toString = cr.inst_toString;
				instance.properties = m[14];
				instance.onCreate();
				cr.seal(instance);
				type_inst.instances.push(instance);
				this.objectsByUid[instance.uid.toString()] = instance;
			}
		}
		for (i = 0, len = pm[4].length; i < len; i++)
		{
			var familydata = pm[4][i];
			var familytype = this.types_by_index[familydata[0]];
			var familymember;
			for (j = 1, lenj = familydata.length; j < lenj; j++)
			{
				familymember = this.types_by_index[familydata[j]];
				familymember.families.push(familytype);
				familytype.members.push(familymember);
			}
		}
		for (i = 0, len = pm[27].length; i < len; i++)
		{
			var containerdata = pm[27][i];
			var containertypes = [];
			for (j = 0, lenj = containerdata.length; j < lenj; j++)
				containertypes.push(this.types_by_index[containerdata[j]]);
			for (j = 0, lenj = containertypes.length; j < lenj; j++)
			{
				containertypes[j].is_contained = true;
				containertypes[j].container = containertypes;
			}
		}
		if (this.family_count > 0)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (t.is_family || !t.families.length)
					continue;
				t.family_var_map = new Array(this.family_count);
				t.family_beh_map = new Array(this.family_count);
				t.family_fx_map = new Array(this.family_count);
				var all_fx = [];
				var varsum = 0;
				var behsum = 0;
				var fxsum = 0;
				for (j = 0, lenj = t.families.length; j < lenj; j++)
				{
					f = t.families[j];
					t.family_var_map[f.family_index] = varsum;
					varsum += f.vars_count;
					t.family_beh_map[f.family_index] = behsum;
					behsum += f.behs_count;
					t.family_fx_map[f.family_index] = fxsum;
					fxsum += f.fx_count;
					for (k = 0, lenk = f.effect_types.length; k < lenk; k++)
						all_fx.push(cr.shallowCopy({}, f.effect_types[k]));
				}
				t.effect_types = all_fx.concat(t.effect_types);
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
					t.effect_types[j].index = j;
			}
		}
		for (i = 0, len = pm[5].length; i < len; i++)
		{
			m = pm[5][i];
			var layout = new cr.layout(this, m);
			cr.seal(layout);
			this.layouts[layout.name] = layout;
			this.layouts_by_index.push(layout);
		}
		for (i = 0, len = pm[6].length; i < len; i++)
		{
			m = pm[6][i];
			var sheet = new cr.eventsheet(this, m);
			cr.seal(sheet);
			this.eventsheets[sheet.name] = sheet;
			this.eventsheets_by_index.push(sheet);
		}
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].postInit();
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].updateDeepIncludes();
		for (i = 0, len = this.triggers_to_postinit.length; i < len; i++)
			this.triggers_to_postinit[i].postInit();
		this.triggers_to_postinit.length = 0;
		this.audio_to_preload = pm[7];
		this.files_subfolder = pm[8];
		this.pixel_rounding = pm[9];
		this.aspect_scale = 1.0;
		this.enableWebGL = pm[13];
		this.linearSampling = pm[14];
		this.alphaBackground = pm[15];
		this.versionstr = pm[16];
		this.useHighDpi = pm[17];
		this.orientations = pm[20];		// 0 = any, 1 = portrait, 2 = landscape
		this.autoLockOrientation = (this.orientations > 0);
		this.pauseOnBlur = pm[22];
		this.wantFullscreenScalingQuality = pm[23];		// false = low quality, true = high quality
		this.fullscreenScalingQuality = this.wantFullscreenScalingQuality;
		this.downscalingQuality = pm[24];	// 0 = low (mips off), 1 = medium (mips on, dense spritesheet), 2 = high (mips on, sparse spritesheet)
		this.preloadSounds = pm[25];		// 0 = no, 1 = yes
		this.projectName = pm[26];
		this.start_time = Date.now();
	};
	var anyImageHadError = false;
	Runtime.prototype.waitForImageLoad = function (img_)
	{
		img_.onerror = function (e)
		{
			img_.c2error = true;
			anyImageHadError = true;
			if (console && console.error)
				console.error("Error loading image '" + img_.src + "': ", e);
		};
		this.wait_for_textures.push(img_);
	};
	Runtime.prototype.findWaitingTexture = function (src_)
	{
		var i, len;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			if (this.wait_for_textures[i].cr_src === src_)
				return this.wait_for_textures[i];
		}
		return null;
	};
	var audio_preload_totalsize = 0;
	var audio_preload_started = false;
	Runtime.prototype.getready = function ()
	{
		if (!this.audioInstance)
			return;
		audio_preload_totalsize = this.audioInstance.setPreloadList(this.audio_to_preload);
	};
	Runtime.prototype.areAllTexturesAndSoundsLoaded = function ()
	{
		var totalsize = audio_preload_totalsize;
		var completedsize = 0;
		var audiocompletedsize = 0;
		var ret = true;
		var i, len, img;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			img = this.wait_for_textures[i];
			var filesize = img.cr_filesize;
			if (!filesize || filesize <= 0)
				filesize = 50000;
			totalsize += filesize;
			if ((img.complete || img["loaded"]) && !img.c2error)
				completedsize += filesize;
			else
				ret = false;    // not all textures loaded
		}
		if (ret && this.preloadSounds && this.audioInstance)
		{
			if (!audio_preload_started)
			{
				this.audioInstance.startPreloads();
				audio_preload_started = true;
			}
			audiocompletedsize = this.audioInstance.getPreloadedSize();
			completedsize += audiocompletedsize;
			if (audiocompletedsize < audio_preload_totalsize)
				ret = false;		// not done yet
		}
		if (totalsize == 0)
			this.progress = 0;
		else
			this.progress = (completedsize / totalsize);
		return ret;
	};
	Runtime.prototype.go = function ()
	{
		if (!this.ctx && !this.glwrap)
			return;
		var ctx = this.ctx || this.overlay_ctx;
		if (this.overlay_canvas)
			this.positionOverlayCanvas();
		this.progress = 0;
		this.last_progress = -1;
		if (this.areAllTexturesAndSoundsLoaded())
			this.go_loading_finished();
		else
		{
			var ms_elapsed = Date.now() - this.start_time;
			if (ctx)
			{
				var overlay_width = this.width;
				var overlay_height = this.height;
				var multiplier = this.devicePixelRatio;
				if (this.overlay_canvas)
				{
					overlay_width = this.cssWidth;
					overlay_height = this.cssHeight;
					multiplier = 1;
				}
				if (this.loaderstyle !== 3 && (this.isCocoonJs || (ms_elapsed >= 500 && this.last_progress != this.progress)))
				{
					ctx.clearRect(0, 0, overlay_width, overlay_height);
					var mx = overlay_width / 2;
					var my = overlay_height / 2;
					var haslogo = (this.loaderstyle === 0 && this.loaderlogo.complete);
					var hlw = 40 * multiplier;
					var hlh = 0;
					var logowidth = 80 * multiplier;
					var logoheight;
					if (haslogo)
					{
						logowidth = this.loaderlogo.width * multiplier;
						logoheight = this.loaderlogo.height * multiplier;
						hlw = logowidth / 2;
						hlh = logoheight / 2;
						ctx.drawImage(this.loaderlogo, cr.floor(mx - hlw), cr.floor(my - hlh), logowidth, logoheight);
					}
					if (this.loaderstyle <= 1)
					{
						my += hlh + (haslogo ? 12 * multiplier : 0);
						mx -= hlw;
						mx = cr.floor(mx) + 0.5;
						my = cr.floor(my) + 0.5;
						ctx.fillStyle = anyImageHadError ? "red" : "DodgerBlue";
						ctx.fillRect(mx, my, Math.floor(logowidth * this.progress), 6 * multiplier);
						ctx.strokeStyle = "black";
						ctx.strokeRect(mx, my, logowidth, 6 * multiplier);
						ctx.strokeStyle = "white";
						ctx.strokeRect(mx - 1 * multiplier, my - 1 * multiplier, logowidth + 2 * multiplier, 8 * multiplier);
					}
					else if (this.loaderstyle === 2)
					{
						ctx.font = (this.isEjecta ? "12pt ArialMT" : "12pt Arial");
						ctx.fillStyle = anyImageHadError ? "#f00" : "#999";
						ctx.textBaseLine = "middle";
						var percent_text = Math.round(this.progress * 100) + "%";
						var text_dim = ctx.measureText ? ctx.measureText(percent_text) : null;
						var text_width = text_dim ? text_dim.width : 0;
						ctx.fillText(percent_text, mx - (text_width / 2), my);
					}
				}
				this.last_progress = this.progress;
			}
			setTimeout((function (self) { return function () { self.go(); }; })(this), (this.isCocoonJs ? 10 : 100));
		}
	};
	Runtime.prototype.go_loading_finished = function ()
	{
		if (this.overlay_canvas)
		{
			this.canvas.parentNode.removeChild(this.overlay_canvas);
			this.overlay_ctx = null;
			this.overlay_canvas = null;
		}
		this.start_time = Date.now();
		this.last_fps_time = cr.performance_now();       // for counting framerate
		var i, len, t;
		if (this.uses_loader_layout)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (!t.is_family && !t.isOnLoaderLayout && t.plugin.is_world)
				{
					t.onCreate();
					cr.seal(t);
				}
			}
		}
		else
			this.isloading = false;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			this.layouts_by_index[i].createGlobalNonWorlds();
		}
		if (this.fullscreen_mode >= 2)
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
				this.aspect_scale = this.height / this.original_height;
			else
				this.aspect_scale = this.width / this.original_width;
		}
		if (this.first_layout)
			this.layouts[this.first_layout].startRunning();
		else
			this.layouts_by_index[0].startRunning();
;
		if (!this.uses_loader_layout)
		{
			this.loadingprogress = 1;
			this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
		}
		if (navigator["splashscreen"] && navigator["splashscreen"]["hide"])
			navigator["splashscreen"]["hide"]();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onAppBegin)
				t.onAppBegin();
		}
		this.tick(false);
		if (this.isDirectCanvas)
			AppMobi["webview"]["execute"]("onGameReady();");
	};
	var raf = window["requestAnimationFrame"] ||
	  window["mozRequestAnimationFrame"]    ||
	  window["webkitRequestAnimationFrame"] ||
	  window["msRequestAnimationFrame"]     ||
	  window["oRequestAnimationFrame"];
	Runtime.prototype.tick = function (background_wake)
	{
		if (!this.running_layout)
			return;
		var logic_start = cr.performance_now();
		if (this.halfFramerateMode && this.ranLastRaf)
		{
			if (logic_start - this.lastRafTime < 29)
			{
				this.ranLastRaf = false;
				this.lastRafTime = logic_start;
				if (raf)
					this.raf_id = raf(this.tickFunc, this.canvas);
				else	// no idea if this works without raf/hi res timers but let's hope for the best
					this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
				return;		// skipped this frame
			}
		}
		this.ranLastRaf = true;
		this.lastRafTime = logic_start;
		var fsmode = this.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"]) && !this.isPhoneGap;
		if ((isfullscreen || this.isNodeFullscreen) && this.fullscreen_scaling > 0)
			fsmode = this.fullscreen_scaling;
		if (fsmode > 0 && (!this.isiOS || window.self !== window.top))
		{
			var curwidth = window.innerWidth;
			var curheight = window.innerHeight;
			if (this.lastWindowWidth !== curwidth || this.lastWindowHeight !== curheight)
			{
				this["setSize"](window_innerWidth(), window_innerHeight());
			}
		}
		if (!this.isDomFree)
		{
			if (isfullscreen)
			{
				if (!this.firstInFullscreen)
				{
					this.fullscreenOldMarginCss = jQuery(this.canvas).css("margin") || "0";
					this.firstInFullscreen = true;
				}
				if (!this.isChrome && !this.isNodeWebkit)
				{
					jQuery(this.canvas).css({
						"margin-left": "" + Math.floor((screen.width - (this.width / this.devicePixelRatio)) / 2) + "px",
						"margin-top": "" + Math.floor((screen.height - (this.height / this.devicePixelRatio)) / 2) + "px"
					});
				}
			}
			else
			{
				if (this.firstInFullscreen)
				{
					if (!this.isChrome && !this.isNodeWebkit)
					{
						jQuery(this.canvas).css("margin", this.fullscreenOldMarginCss);
					}
					this.fullscreenOldMarginCss = "";
					this.firstInFullscreen = false;
					if (this.fullscreen_mode === 0)
					{
						this["setSize"](Math.round(this.oldWidth / this.devicePixelRatio), Math.round(this.oldHeight / this.devicePixelRatio), true);
					}
				}
				else
				{
					this.oldWidth = this.width;
					this.oldHeight = this.height;
				}
			}
		}
		if (this.isloading)
		{
			var done = this.areAllTexturesAndSoundsLoaded();		// updates this.progress
			this.loadingprogress = this.progress;
			if (done)
			{
				this.isloading = false;
				this.progress = 1;
				this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
			}
		}
		this.logic();
		if ((this.redraw || this.isCocoonJs) && !this.is_WebGL_context_lost && !this.suspendDrawing && !background_wake)
		{
			this.redraw = false;
			if (this.glwrap)
				this.drawGL();
			else
				this.draw();
			if (this.snapshotCanvas)
			{
				if (this.canvas && this.canvas.toDataURL)
				{
					this.snapshotData = this.canvas.toDataURL(this.snapshotCanvas[0], this.snapshotCanvas[1]);
					this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot, null);
				}
				this.snapshotCanvas = null;
			}
		}
		if (!this.hit_breakpoint)
		{
			this.tickcount++;
			this.execcount++;
			this.framecount++;
		}
		this.logictime += cr.performance_now() - logic_start;
		if (this.isSuspended || background_wake)
			return;
		if (raf)
			this.raf_id = raf(this.tickFunc, this.canvas);
		else
		{
			this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
		}
	};
	Runtime.prototype.logic = function ()
	{
		var i, leni, j, lenj, k, lenk, type, inst, binst;
		var cur_time = cr.performance_now();
		if (cur_time - this.last_fps_time >= 1000)  // every 1 second
		{
			this.last_fps_time += 1000;
			this.fps = this.framecount;
			this.framecount = 0;
			this.cpuutilisation = this.logictime;
			this.logictime = 0;
		}
		if (this.measuring_dt)
		{
			if (this.last_tick_time !== 0)
			{
				var ms_diff = cur_time - this.last_tick_time;
				if (ms_diff === 0 && !this.isDebug)
				{
					this.zeroDtCount++;
					if (this.zeroDtCout >= 10)
						this.measuring_dt = false;
					this.dt1 = 1.0 / 60.0;            // 60fps assumed (0.01666...)
				}
				else
				{
					this.dt1 = ms_diff / 1000.0; // dt measured in seconds
					if (this.dt1 > 0.5)
						this.dt1 = 0;
					else if (this.dt1 > 0.1)
						this.dt1 = 0.1;
				}
			}
			this.last_tick_time = cur_time;
		}
        this.dt = this.dt1 * this.timescale;
        this.kahanTime.add(this.dt);
		this.wallTime.add(this.dt1);
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen) && !this.isPhoneGap;
		if (this.fullscreen_mode >= 2 /* scale */ || (isfullscreen && this.fullscreen_scaling > 0))
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			var mode = this.fullscreen_mode;
			if (isfullscreen && this.fullscreen_scaling > 0)
				mode = this.fullscreen_scaling;
			if ((mode !== 2 && cur_aspect > orig_aspect) || (mode === 2 && cur_aspect < orig_aspect))
			{
				this.aspect_scale = this.height / this.original_height;
			}
			else
			{
				this.aspect_scale = this.width / this.original_width;
			}
			if (this.running_layout)
			{
				this.running_layout.scrollToX(this.running_layout.scrollX);
				this.running_layout.scrollToY(this.running_layout.scrollY);
			}
		}
		else
			this.aspect_scale = (this.isRetina ? this.devicePixelRatio : 1);
		this.ClearDeathRow();
		this.isInOnDestroy++;
		this.system.runWaits();		// prevent instance list changing
		this.isInOnDestroy--;
		this.ClearDeathRow();		// allow instance list changing
		this.isInOnDestroy++;
        var tickarr = this.objects_to_pretick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].pretick();
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					inst.behavior_insts[k].tick();
				}
			}
		}
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.posttick)
						binst.posttick();
				}
			}
		}
        tickarr = this.objects_to_tick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
		this.handleSaveLoad();		// save/load now if queued
		i = 0;
		while (this.changelayout && i++ < 10)
		{
			this.doChangeLayout(this.changelayout);
		}
        for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
            this.eventsheets_by_index[i].hasRun = false;
		if (this.running_layout.event_sheet)
			this.running_layout.event_sheet.run();
		this.registered_collisions.length = 0;
		this.layout_first_tick = false;
		this.isInOnDestroy++;		// prevent instance lists from being changed
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				var inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.tick2)
						binst.tick2();
				}
			}
		}
        tickarr = this.objects_to_tick2.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick2();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
	};
	Runtime.prototype.doChangeLayout = function (changeToLayout)
	{
;
		var prev_layout = this.running_layout;
		this.running_layout.stopRunning();
		var i, len, j, lenj, k, lenk, type, inst, binst;
		if (this.glwrap)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				type = this.types_by_index[i];
				if (type.is_family)
					continue;
				if (type.unloadTextures && (!type.global || type.instances.length === 0) && changeToLayout.initial_types.indexOf(type) === -1)
				{
					type.unloadTextures();
				}
			}
		}
		if (prev_layout == changeToLayout)
			this.system.waits.length = 0;
		changeToLayout.startRunning();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (!type.global && !type.plugin.singleglobal)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (inst.onLayoutChange)
					inst.onLayoutChange();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.onLayoutChange)
							binst.onLayoutChange();
					}
				}
			}
		}
		this.redraw = true;
		this.layout_first_tick = true;
		this.ClearDeathRow();
	};
	Runtime.prototype.pretickMe = function (inst)
    {
        this.objects_to_pretick.add(inst);
    };
	Runtime.prototype.unpretickMe = function (inst)
	{
		this.objects_to_pretick.remove(inst);
	};
    Runtime.prototype.tickMe = function (inst)
    {
        this.objects_to_tick.add(inst);
    };
	Runtime.prototype.untickMe = function (inst)
	{
		this.objects_to_tick.remove(inst);
	};
	Runtime.prototype.tick2Me = function (inst)
    {
        this.objects_to_tick2.add(inst);
    };
	Runtime.prototype.untick2Me = function (inst)
	{
		this.objects_to_tick2.remove(inst);
	};
    Runtime.prototype.getDt = function (inst)
    {
        if (!inst || inst.my_timescale === -1.0)
            return this.dt;
        return this.dt1 * inst.my_timescale;
    };
	Runtime.prototype.draw = function ()
	{
		this.running_layout.draw(this.ctx);
		if (this.isDirectCanvas)
			this.ctx["present"]();
	};
	Runtime.prototype.drawGL = function ()
	{
		this.running_layout.drawGL(this.glwrap);
		this.glwrap.present();
	};
	Runtime.prototype.addDestroyCallback = function (f)
	{
		if (f)
			this.destroycallbacks.push(f);
	};
	Runtime.prototype.removeDestroyCallback = function (f)
	{
		cr.arrayFindRemove(this.destroycallbacks, f);
	};
	Runtime.prototype.getObjectByUID = function (uid_)
	{
;
		var uidstr = uid_.toString();
		if (this.objectsByUid.hasOwnProperty(uidstr))
			return this.objectsByUid[uidstr];
		else
			return null;
	};
	Runtime.prototype.DestroyInstance = function (inst)
	{
		var i, len;
		if (!this.deathRow.contains(inst))
		{
			this.deathRow.add(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					this.DestroyInstance(inst.siblings[i]);
				}
			}
			if (this.isInClearDeathRow)
				this.deathRow.values_cache.push(inst);
			this.isInOnDestroy++;		// support recursion
			this.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnDestroyed, inst);
			this.isInOnDestroy--;
		}
	};
	Runtime.prototype.ClearDeathRow = function ()
	{
		var inst, index, type, instances, binst;
		var i, j, k, leni, lenj, lenk;
		var w, f;
		this.isInClearDeathRow = true;
		for (i = 0, leni = this.createRow.length; i < leni; i++)
		{
			inst = this.createRow[i];
			type = inst.type;
			type.instances.push(inst);
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				type.families[j].instances.push(inst);
				type.families[j].stale_iids = true;
			}
		}
		this.createRow.length = 0;
		var arr = this.deathRow.valuesRef();	// get array of items from set
		for (i = 0; i < arr.length; i++)		// check array length every time in case it changes
		{
			inst = arr[i];
			type = inst.type;
			instances = type.instances;
			for (j = 0, lenj = this.destroycallbacks.length; j < lenj; j++)
				this.destroycallbacks[j](inst);
			cr.arrayFindRemove(instances, inst);
			if (instances.length === 0)
				type.any_instance_parallaxed = false;
			if (inst.collcells)
			{
				type.collision_grid.update(inst, inst.collcells, null);
			}
			if (inst.layer)
			{
				cr.arrayRemove(inst.layer.instances, inst.get_zindex());
				inst.layer.zindices_stale = true;
			}
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				cr.arrayFindRemove(type.families[j].instances, inst);
				type.families[j].stale_iids = true;
			}
			if (inst.behavior_insts)
			{
				for (j = 0, lenj = inst.behavior_insts.length; j < lenj; j++)
				{
					binst = inst.behavior_insts[j];
					if (binst.onDestroy)
						binst.onDestroy();
					binst.behavior.my_instances.remove(inst);
				}
			}
			this.objects_to_pretick.remove(inst);
            this.objects_to_tick.remove(inst);
			this.objects_to_tick2.remove(inst);
			for (j = 0, lenj = this.system.waits.length; j < lenj; j++)
			{
				w = this.system.waits[j];
				if (w.sols.hasOwnProperty(type.index))
					cr.arrayFindRemove(w.sols[type.index].insts, inst);
				if (!type.is_family)
				{
					for (k = 0, lenk = type.families.length; k < lenk; k++)
					{
						f = type.families[k];
						if (w.sols.hasOwnProperty(f.index))
							cr.arrayFindRemove(w.sols[f.index].insts, inst);
					}
				}
			}
			if (inst.onDestroy)
				inst.onDestroy();
			if (this.objectsByUid.hasOwnProperty(inst.uid.toString()))
				delete this.objectsByUid[inst.uid.toString()];
			this.objectcount--;
			if (type.deadCache.length < 64)
				type.deadCache.push(inst);
			type.stale_iids = true;
		}
		if (!this.deathRow.isEmpty())
			this.redraw = true;
		this.deathRow.clear();
		this.isInClearDeathRow = false;
	};
	Runtime.prototype.createInstance = function (type, layer, sx, sy)
	{
		if (type.is_family)
		{
			var i = cr.floor(Math.random() * type.members.length);
			return this.createInstance(type.members[i], layer, sx, sy);
		}
		if (!type.default_instance)
		{
			return null;
		}
		return this.createInstanceFromInit(type.default_instance, layer, false, sx, sy, false);
	};
	var all_behaviors = [];
	Runtime.prototype.createInstanceFromInit = function (initial_inst, layer, is_startup_instance, sx, sy, skip_siblings)
	{
		var i, len, j, lenj, p, effect_fallback, x, y;
		if (!initial_inst)
			return null;
		var type = this.types_by_index[initial_inst[1]];
;
;
		var is_world = type.plugin.is_world;
;
		if (this.isloading && is_world && !type.isOnLoaderLayout)
			return null;
		if (is_world && !this.glwrap && initial_inst[0][11] === 11)
			return null;
		var original_layer = layer;
		if (!is_world)
			layer = null;
		var inst;
		if (type.deadCache.length)
		{
			inst = type.deadCache.pop();
			inst.recycled = true;
			type.plugin.Instance.call(inst, type);
		}
		else
		{
			inst = new type.plugin.Instance(type);
			inst.recycled = false;
		}
		if (is_startup_instance && !skip_siblings)
			inst.uid = initial_inst[2];
		else
			inst.uid = this.next_uid++;
		this.objectsByUid[inst.uid.toString()] = inst;
		inst.puid = this.next_puid++;
		inst.iid = type.instances.length;
		for (i = 0, len = this.createRow.length; i < len; ++i)
		{
			if (this.createRow[i].type === type)
				inst.iid++;
		}
		inst.get_iid = cr.inst_get_iid;
		var initial_vars = initial_inst[3];
		if (inst.recycled)
		{
			cr.wipe(inst.extra);
		}
		else
		{
			inst.extra = {};
			if (typeof cr_is_preview !== "undefined")
			{
				inst.instance_var_names = [];
				inst.instance_var_names.length = initial_vars.length;
				for (i = 0, len = initial_vars.length; i < len; i++)
					inst.instance_var_names[i] = initial_vars[i][1];
			}
			inst.instance_vars = [];
			inst.instance_vars.length = initial_vars.length;
		}
		for (i = 0, len = initial_vars.length; i < len; i++)
			inst.instance_vars[i] = initial_vars[i][0];
		if (is_world)
		{
			var wm = initial_inst[0];
;
			inst.x = cr.is_undefined(sx) ? wm[0] : sx;
			inst.y = cr.is_undefined(sy) ? wm[1] : sy;
			inst.z = wm[2];
			inst.width = wm[3];
			inst.height = wm[4];
			inst.depth = wm[5];
			inst.angle = wm[6];
			inst.opacity = wm[7];
			inst.hotspotX = wm[8];
			inst.hotspotY = wm[9];
			inst.blend_mode = wm[10];
			effect_fallback = wm[11];
			if (!this.glwrap && type.effect_types.length)	// no WebGL renderer and shaders used
				inst.blend_mode = effect_fallback;			// use fallback blend mode - destroy mode was handled above
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			if (inst.recycled)
			{
				for (i = 0, len = wm[12].length; i < len; i++)
				{
					for (j = 0, lenj = wm[12][i].length; j < lenj; j++)
						inst.effect_params[i][j] = wm[12][i][j];
				}
				inst.bbox.set(0, 0, 0, 0);
				inst.collcells.set(0, 0, -1, -1);
				inst.bquad.set_from_rect(inst.bbox);
				inst.bbox_changed_callbacks.length = 0;
			}
			else
			{
				inst.effect_params = wm[12].slice(0);
				for (i = 0, len = inst.effect_params.length; i < len; i++)
					inst.effect_params[i] = wm[12][i].slice(0);
				inst.active_effect_types = [];
				inst.active_effect_flags = [];
				inst.active_effect_flags.length = type.effect_types.length;
				inst.bbox = new cr.rect(0, 0, 0, 0);
				inst.collcells = new cr.rect(0, 0, -1, -1);
				inst.bquad = new cr.quad();
				inst.bbox_changed_callbacks = [];
				inst.set_bbox_changed = cr.set_bbox_changed;
				inst.add_bbox_changed_callback = cr.add_bbox_changed_callback;
				inst.contains_pt = cr.inst_contains_pt;
				inst.update_bbox = cr.update_bbox;
				inst.update_collision_cell = cr.update_collision_cell;
				inst.get_zindex = cr.inst_get_zindex;
			}
			inst.tilemap_exists = false;
			inst.tilemap_width = 0;
			inst.tilemap_height = 0;
			inst.tilemap_data = null;
			if (wm.length === 14)
			{
				inst.tilemap_exists = true;
				inst.tilemap_width = wm[13][0];
				inst.tilemap_height = wm[13][1];
				inst.tilemap_data = wm[13][2];
			}
			for (i = 0, len = type.effect_types.length; i < len; i++)
				inst.active_effect_flags[i] = true;
			inst.updateActiveEffects = cr.inst_updateActiveEffects;
			inst.updateActiveEffects();
			inst.uses_shaders = !!inst.active_effect_types.length;
			inst.bbox_changed = true;
			inst.cell_changed = true;
			type.any_cell_changed = true;
			inst.visible = true;
            inst.my_timescale = -1.0;
			inst.layer = layer;
			inst.zindex = layer.instances.length;	// will be placed at top of current layer
			if (typeof inst.collision_poly === "undefined")
				inst.collision_poly = null;
			inst.collisionsEnabled = true;
			this.redraw = true;
		}
		inst.toString = cr.inst_toString;
		var initial_props, binst;
		all_behaviors.length = 0;
		for (i = 0, len = type.families.length; i < len; i++)
		{
			all_behaviors.push.apply(all_behaviors, type.families[i].behaviors);
		}
		all_behaviors.push.apply(all_behaviors, type.behaviors);
		if (inst.recycled)
		{
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				binst = inst.behavior_insts[i];
				binst.recycled = true;
				btype.behavior.Instance.call(binst, btype, inst);
				initial_props = initial_inst[4][i];
				for (j = 0, lenj = initial_props.length; j < lenj; j++)
					binst.properties[j] = initial_props[j];
				binst.onCreate();
				btype.behavior.my_instances.add(inst);
			}
		}
		else
		{
			inst.behavior_insts = [];
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				var binst = new btype.behavior.Instance(btype, inst);
				binst.recycled = false;
				binst.properties = initial_inst[4][i].slice(0);
				binst.onCreate();
				cr.seal(binst);
				inst.behavior_insts.push(binst);
				btype.behavior.my_instances.add(inst);
			}
		}
		initial_props = initial_inst[5];
		if (inst.recycled)
		{
			for (i = 0, len = initial_props.length; i < len; i++)
				inst.properties[i] = initial_props[i];
		}
		else
			inst.properties = initial_props.slice(0);
		this.createRow.push(inst);
		if (layer)
		{
;
			layer.instances.push(inst);
			if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
				type.any_instance_parallaxed = true;
		}
		this.objectcount++;
		if (type.is_contained)
		{
			inst.is_contained = true;
			if (inst.recycled)
				inst.siblings.length = 0;
			else
				inst.siblings = [];			// note: should not include self in siblings
			if (!is_startup_instance && !skip_siblings)	// layout links initial instances
			{
				for (i = 0, len = type.container.length; i < len; i++)
				{
					if (type.container[i] === type)
						continue;
					if (!type.container[i].default_instance)
					{
						return null;
					}
					inst.siblings.push(this.createInstanceFromInit(type.container[i].default_instance, original_layer, false, is_world ? inst.x : sx, is_world ? inst.y : sy, true));
				}
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					inst.siblings[i].siblings.push(inst);
					for (j = 0; j < len; j++)
					{
						if (i !== j)
							inst.siblings[i].siblings.push(inst.siblings[j]);
					}
				}
			}
		}
		else
		{
			inst.is_contained = false;
			inst.siblings = null;
		}
		inst.onCreate();
		if (!inst.recycled)
			cr.seal(inst);
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].postCreate)
				inst.behavior_insts[i].postCreate();
		}
		return inst;
	};
	Runtime.prototype.getLayerByName = function (layer_name)
	{
		var i, len;
		for (i = 0, len = this.running_layout.layers.length; i < len; i++)
		{
			var layer = this.running_layout.layers[i];
			if (cr.equals_nocase(layer.name, layer_name))
				return layer;
		}
		return null;
	};
	Runtime.prototype.getLayerByNumber = function (index)
	{
		index = cr.floor(index);
		if (index < 0)
			index = 0;
		if (index >= this.running_layout.layers.length)
			index = this.running_layout.layers.length - 1;
		return this.running_layout.layers[index];
	};
	Runtime.prototype.getLayer = function (l)
	{
		if (cr.is_number(l))
			return this.getLayerByNumber(l);
		else
			return this.getLayerByName(l.toString());
	};
	Runtime.prototype.clearSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].getCurrentSol().select_all = true;
		}
	};
	Runtime.prototype.pushCleanSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCleanSol();
		}
	};
	Runtime.prototype.pushCopySol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCopySol();
		}
	};
	Runtime.prototype.popSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].popSol();
		}
	};
	Runtime.prototype.updateAllCells = function (type)
	{
		if (!type.any_cell_changed)
			return;		// all instances must already be up-to-date
		var i, len, instances = type.instances;
		for (i = 0, len = instances.length; i < len; ++i)
		{
			instances[i].update_collision_cell();
		}
		var createRow = this.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === type)
				createRow[i].update_collision_cell();
		}
		type.any_cell_changed = false;
	};
	Runtime.prototype.getCollisionCandidates = function (layer, rtype, bbox, candidates)
	{
		var i, len, t;
		var is_parallaxed = (layer ? (layer.parallaxX !== 1 || layer.parallaxY !== 1) : false);
		if (rtype.is_family)
		{
			for (i = 0, len = rtype.members.length; i < len; ++i)
			{
				t = rtype.members[i];
				if (is_parallaxed || t.any_instance_parallaxed)
				{
					cr.appendArray(candidates, t.instances);
				}
				else
				{
					this.updateAllCells(t);
					t.collision_grid.queryRange(bbox, candidates);
				}
			}
		}
		else
		{
			if (is_parallaxed || rtype.any_instance_parallaxed)
			{
				cr.appendArray(candidates, rtype.instances);
			}
			else
			{
				this.updateAllCells(rtype);
				rtype.collision_grid.queryRange(bbox, candidates);
			}
		}
	};
	Runtime.prototype.getTypesCollisionCandidates = function (layer, types, bbox, candidates)
	{
		var i, len;
		for (i = 0, len = types.length; i < len; ++i)
		{
			this.getCollisionCandidates(layer, types[i], bbox, candidates);
		}
	};
	Runtime.prototype.getSolidCollisionCandidates = function (layer, bbox, candidates)
	{
		var solid = this.getSolidBehavior();
		if (!solid)
			return null;
		this.getTypesCollisionCandidates(layer, solid.my_types, bbox, candidates);
	};
	Runtime.prototype.getJumpthruCollisionCandidates = function (layer, bbox, candidates)
	{
		var jumpthru = this.getJumpthruBehavior();
		if (!jumpthru)
			return null;
		this.getTypesCollisionCandidates(layer, jumpthru.my_types, bbox, candidates);
	};
	Runtime.prototype.testAndSelectCanvasPointOverlap = function (type, ptx, pty, inverted)
	{
		var sol = type.getCurrentSol();
		var i, j, inst, len;
		var lx, ly;
		if (sol.select_all)
		{
			if (!inverted)
			{
				sol.select_all = false;
				sol.instances.length = 0;   // clear contents
			}
			for (i = 0, len = type.instances.length; i < len; i++)
			{
				inst = type.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
						sol.instances.push(inst);
				}
			}
		}
		else
		{
			j = 0;
			for (i = 0, len = sol.instances.length; i < len; i++)
			{
				inst = sol.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
					{
						sol.instances[j] = sol.instances[i];
						j++;
					}
				}
			}
			if (!inverted)
				sol.instances.length = j;
		}
		type.applySolToContainer();
		if (inverted)
			return true;		// did not find anything overlapping
		else
			return sol.hasObjects();
	};
	Runtime.prototype.testOverlap = function (a, b)
	{
		if (!a || !b || a === b || !a.collisionsEnabled || !b.collisionsEnabled)
			return false;
		a.update_bbox();
		b.update_bbox();
		var layera = a.layer;
		var layerb = b.layer;
		var different_layers = (layera !== layerb && (layera.parallaxX !== layerb.parallaxX || layerb.parallaxY !== layerb.parallaxY || layera.scale !== layerb.scale || layera.angle !== layerb.angle || layera.zoomRate !== layerb.zoomRate));
		var i, len, i2, i21, x, y, haspolya, haspolyb, polya, polyb;
		if (!different_layers)	// same layers: easy check
		{
			if (!a.bbox.intersects_rect(b.bbox))
				return false;
			if (!a.bquad.intersects_quad(b.bquad))
				return false;
			if (a.tilemap_exists && b.tilemap_exists)
				return false;
			if (a.tilemap_exists)
				return this.testTilemapOverlap(a, b);
			if (b.tilemap_exists)
				return this.testTilemapOverlap(b, a);
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolya && !haspolyb)
				return true;
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				polya = a.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
				polya = this.temp_poly;
			}
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				polyb = b.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
				polyb = this.temp_poly;
			}
			return polya.intersects_poly(polyb, b.x - a.x, b.y - a.y);
		}
		else	// different layers: need to do full translated check
		{
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				this.temp_poly.set_from_poly(a.collision_poly);
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
			}
			polya = this.temp_poly;
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				this.temp_poly2.set_from_poly(b.collision_poly);
			}
			else
			{
				this.temp_poly2.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
			}
			polyb = this.temp_poly2;
			for (i = 0, len = polya.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polya.pts_cache[i2];
				y = polya.pts_cache[i21];
				polya.pts_cache[i2] = layera.layerToCanvas(x + a.x, y + a.y, true);
				polya.pts_cache[i21] = layera.layerToCanvas(x + a.x, y + a.y, false);
			}
			polya.update_bbox();
			for (i = 0, len = polyb.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polyb.pts_cache[i2];
				y = polyb.pts_cache[i21];
				polyb.pts_cache[i2] = layerb.layerToCanvas(x + b.x, y + b.y, true);
				polyb.pts_cache[i21] = layerb.layerToCanvas(x + b.x, y + b.y, false);
			}
			polyb.update_bbox();
			return polya.intersects_poly(polyb, 0, 0);
		}
	};
	var tmpQuad = new cr.quad();
	var tmpRect = new cr.rect(0, 0, 0, 0);
	var collrect_candidates = [];
	Runtime.prototype.testTilemapOverlap = function (tm, a)
	{
		var i, len, c, rc;
		var bbox = a.bbox;
		var tmx = tm.x;
		var tmy = tm.y;
		tm.getCollisionRectCandidates(bbox, collrect_candidates);
		var collrects = collrect_candidates;
		var haspolya = (a.collision_poly && !a.collision_poly.is_empty());
		for (i = 0, len = collrects.length; i < len; ++i)
		{
			c = collrects[i];
			rc = c.rc;
			if (bbox.intersects_rect_off(rc, tmx, tmy))
			{
				tmpQuad.set_from_rect(rc);
				tmpQuad.offset(tmx, tmy);
				if (tmpQuad.intersects_quad(a.bquad))
				{
					if (haspolya)
					{
						a.collision_poly.cache_poly(a.width, a.height, a.angle);
						if (c.poly)
						{
							if (c.poly.intersects_poly(a.collision_poly, a.x - (tmx + rc.left), a.y - (tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							this.temp_poly.set_from_quad(tmpQuad, 0, 0, rc.right - rc.left, rc.bottom - rc.top);
							if (this.temp_poly.intersects_poly(a.collision_poly, a.x, a.y))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
					}
					else
					{
						if (c.poly)
						{
							this.temp_poly.set_from_quad(a.bquad, 0, 0, a.width, a.height);
							if (c.poly.intersects_poly(this.temp_poly, -(tmx + rc.left), -(tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
		}
		collrect_candidates.length = 0;
		return false;
	};
	Runtime.prototype.testRectOverlap = function (r, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		if (!b.bbox.intersects_rect(r))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(r, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (r.intersects_rect_off(tilerc, tmx, tmy))
				{
					if (c.poly)
					{
						this.temp_poly.set_from_rect(r, 0, 0);
						if (c.poly.intersects_poly(this.temp_poly, -(tmx + tilerc.left), -(tmy + tilerc.top)))
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
					else
					{
						collrect_candidates.length = 0;
						return true;
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			tmpQuad.set_from_rect(r);
			if (!b.bquad.intersects_quad(tmpQuad))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			tmpQuad.offset(-r.left, -r.top);
			this.temp_poly.set_from_quad(tmpQuad, 0, 0, 1, 1);
			return b.collision_poly.intersects_poly(this.temp_poly, r.left - b.x, r.top - b.y);
		}
	};
	Runtime.prototype.testSegmentOverlap = function (x1, y1, x2, y2, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		tmpRect.set(cr.min(x1, x2), cr.min(y1, y2), cr.max(x1, x2), cr.max(y1, y2));
		if (!b.bbox.intersects_rect(tmpRect))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(tmpRect, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (tmpRect.intersects_rect_off(tilerc, tmx, tmy))
				{
					tmpQuad.set_from_rect(tilerc);
					tmpQuad.offset(tmx, tmy);
					if (tmpQuad.intersects_segment(x1, y1, x2, y2))
					{
						if (c.poly)
						{
							if (c.poly.intersects_segment(tmx + tilerc.left, tmy + tilerc.top, x1, y1, x2, y2))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			if (!b.bquad.intersects_segment(x1, y1, x2, y2))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			return b.collision_poly.intersects_segment(b.x, b.y, x1, y1, x2, y2);
		}
	};
	Runtime.prototype.typeHasBehavior = function (t, b)
	{
		if (!b)
			return false;
		var i, len, j, lenj, f;
		for (i = 0, len = t.behaviors.length; i < len; i++)
		{
			if (t.behaviors[i].behavior instanceof b)
				return true;
		}
		if (!t.is_family)
		{
			for (i = 0, len = t.families.length; i < len; i++)
			{
				f = t.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (f.behaviors[j].behavior instanceof b)
						return true;
				}
			}
		}
		return false;
	};
	Runtime.prototype.typeHasNoSaveBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.NoSave);
	};
	Runtime.prototype.typeHasPersistBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.Persist);
	};
	Runtime.prototype.getSolidBehavior = function ()
	{
		return this.solidBehavior;
	};
	Runtime.prototype.getJumpthruBehavior = function ()
	{
		return this.jumpthruBehavior;
	};
	var candidates = [];
	Runtime.prototype.testOverlapSolid = function (inst)
	{
		var i, len, s;
		inst.update_bbox();
		this.getSolidCollisionCandidates(inst.layer, inst.bbox, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra["solidEnabled"])
				continue;
			if (this.testOverlap(inst, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	Runtime.prototype.testRectOverlapSolid = function (r)
	{
		var i, len, s;
		this.getSolidCollisionCandidates(null, r, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra["solidEnabled"])
				continue;
			if (this.testRectOverlap(r, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	var jumpthru_array_ret = [];
	Runtime.prototype.testOverlapJumpThru = function (inst, all)
	{
		var ret = null;
		if (all)
		{
			ret = jumpthru_array_ret;
			ret.length = 0;
		}
		inst.update_bbox();
		this.getJumpthruCollisionCandidates(inst.layer, inst.bbox, candidates);
		var i, len, j;
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			j = candidates[i];
			if (!j.extra["jumpthruEnabled"])
				continue;
			if (this.testOverlap(inst, j))
			{
				if (all)
					ret.push(j);
				else
				{
					candidates.length = 0;
					return j;
				}
			}
		}
		candidates.length = 0;
		return ret;
	};
	Runtime.prototype.pushOutSolid = function (inst, xdir, ydir, dist, include_jumpthrus, specific_jumpthru)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		var last_overlapped = null, secondlast_overlapped = null;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (last_overlapped)
					secondlast_overlapped = last_overlapped;
				if (!last_overlapped)
				{
					if (include_jumpthrus)
					{
						if (specific_jumpthru)
							last_overlapped = (this.testOverlap(inst, specific_jumpthru) ? specific_jumpthru : null);
						else
							last_overlapped = this.testOverlapJumpThru(inst);
						if (last_overlapped)
							secondlast_overlapped = last_overlapped;
					}
					if (!last_overlapped)
					{
						if (secondlast_overlapped)
							this.pushInFractional(inst, xdir, ydir, secondlast_overlapped, 16);
						return true;
					}
				}
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushOut = function (inst, xdir, ydir, dist, otherinst)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, otherinst))
				return true;
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushInFractional = function (inst, xdir, ydir, obj, limit)
	{
		var divisor = 2;
		var frac;
		var forward = false;
		var overlapping = false;
		var bestx = inst.x;
		var besty = inst.y;
		while (divisor <= limit)
		{
			frac = 1 / divisor;
			divisor *= 2;
			inst.x += xdir * frac * (forward ? 1 : -1);
			inst.y += ydir * frac * (forward ? 1 : -1);
			inst.set_bbox_changed();
			if (this.testOverlap(inst, obj))
			{
				forward = true;
				overlapping = true;
			}
			else
			{
				forward = false;
				overlapping = false;
				bestx = inst.x;
				besty = inst.y;
			}
		}
		if (overlapping)
		{
			inst.x = bestx;
			inst.y = besty;
			inst.set_bbox_changed();
		}
	};
	Runtime.prototype.pushOutSolidNearest = function (inst, max_dist_)
	{
		var max_dist = (cr.is_undefined(max_dist_) ? 100 : max_dist_);
		var dist = 0;
		var oldx = inst.x
		var oldy = inst.y;
		var dir = 0;
		var dx = 0, dy = 0;
		var last_overlapped = this.testOverlapSolid(inst);
		if (!last_overlapped)
			return true;		// already clear of solids
		while (dist <= max_dist)
		{
			switch (dir) {
			case 0:		dx = 0; dy = -1; dist++; break;
			case 1:		dx = 1; dy = -1; break;
			case 2:		dx = 1; dy = 0; break;
			case 3:		dx = 1; dy = 1; break;
			case 4:		dx = 0; dy = 1; break;
			case 5:		dx = -1; dy = 1; break;
			case 6:		dx = -1; dy = 0; break;
			case 7:		dx = -1; dy = -1; break;
			}
			dir = (dir + 1) % 8;
			inst.x = cr.floor(oldx + (dx * dist));
			inst.y = cr.floor(oldy + (dy * dist));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (!last_overlapped)
					return true;
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.registerCollision = function (a, b)
	{
		if (!a.collisionsEnabled || !b.collisionsEnabled)
			return;
		this.registered_collisions.push([a, b]);
	};
	Runtime.prototype.checkRegisteredCollision = function (a, b)
	{
		var i, len, x;
		for (i = 0, len = this.registered_collisions.length; i < len; i++)
		{
			x = this.registered_collisions[i];
			if ((x[0] == a && x[1] == b) || (x[0] == b && x[1] == a))
				return true;
		}
		return false;
	};
	Runtime.prototype.calculateSolidBounceAngle = function(inst, startx, starty, obj)
	{
		var objx = inst.x;
		var objy = inst.y;
		var radius = cr.max(10, cr.distanceTo(startx, starty, objx, objy));
		var startangle = cr.angleTo(startx, starty, objx, objy);
		var firstsolid = obj || this.testOverlapSolid(inst);
		if (!firstsolid)
			return cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		var i, curangle, anticlockwise_free_angle, clockwise_free_angle;
		var increment = cr.to_radians(5);	// 5 degree increments
		for (i = 1; i < 36; i++)
		{
			curangle = startangle - i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					anticlockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			anticlockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		for (i = 1; i < 36; i++)
		{
			curangle = startangle + i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					clockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			clockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		inst.x = objx;
		inst.y = objy;
		inst.set_bbox_changed();
		if (clockwise_free_angle === anticlockwise_free_angle)
			return clockwise_free_angle;
		var half_diff = cr.angleDiff(clockwise_free_angle, anticlockwise_free_angle) / 2;
		var normal;
		if (cr.angleClockwise(clockwise_free_angle, anticlockwise_free_angle))
		{
			normal = cr.clamp_angle(anticlockwise_free_angle + half_diff + cr.PI);
		}
		else
		{
			normal = cr.clamp_angle(clockwise_free_angle + half_diff);
		}
;
		var vx = Math.cos(startangle);
		var vy = Math.sin(startangle);
		var nx = Math.cos(normal);
		var ny = Math.sin(normal);
		var v_dot_n = vx * nx + vy * ny;
		var rx = vx - 2 * v_dot_n * nx;
		var ry = vy - 2 * v_dot_n * ny;
		return cr.angleTo(0, 0, rx, ry);
	};
	var triggerSheetIndex = -1;
	Runtime.prototype.trigger = function (method, inst, value /* for fast triggers */)
	{
;
		if (!this.running_layout)
			return false;
		var sheet = this.running_layout.event_sheet;
		if (!sheet)
			return false;     // no event sheet active; nothing to trigger
		var ret = false;
		var r, i, len;
		triggerSheetIndex++;
		var deep_includes = sheet.deep_includes;
		for (i = 0, len = deep_includes.length; i < len; ++i)
		{
			r = this.triggerOnSheet(method, inst, deep_includes[i], value);
			ret = ret || r;
		}
		r = this.triggerOnSheet(method, inst, sheet, value);
		ret = ret || r;
		triggerSheetIndex--;
		return ret;
    };
    Runtime.prototype.triggerOnSheet = function (method, inst, sheet, value)
    {
        var ret = false;
		var i, leni, r, families;
		if (!inst)
		{
			r = this.triggerOnSheetForTypeName(method, inst, "system", sheet, value);
			ret = ret || r;
		}
		else
		{
			r = this.triggerOnSheetForTypeName(method, inst, inst.type.name, sheet, value);
			ret = ret || r;
			families = inst.type.families;
			for (i = 0, leni = families.length; i < leni; ++i)
			{
				r = this.triggerOnSheetForTypeName(method, inst, families[i].name, sheet, value);
				ret = ret || r;
			}
		}
		return ret;             // true if anything got triggered
	};
	Runtime.prototype.triggerOnSheetForTypeName = function (method, inst, type_name, sheet, value)
	{
		var i, leni;
		var ret = false, ret2 = false;
		var trig, index;
		var fasttrigger = (typeof value !== "undefined");
		var triggers = (fasttrigger ? sheet.fasttriggers : sheet.triggers);
		var obj_entry = triggers[type_name];
		if (!obj_entry)
			return ret;
		var triggers_list = null;
		for (i = 0, leni = obj_entry.length; i < leni; ++i)
		{
			if (obj_entry[i].method == method)
			{
				triggers_list = obj_entry[i].evs;
				break;
			}
		}
		if (!triggers_list)
			return ret;
		var triggers_to_fire;
		if (fasttrigger)
		{
			triggers_to_fire = triggers_list[value];
		}
		else
		{
			triggers_to_fire = triggers_list;
		}
		if (!triggers_to_fire)
			return null;
		for (i = 0, leni = triggers_to_fire.length; i < leni; i++)
		{
			trig = triggers_to_fire[i][0];
			index = triggers_to_fire[i][1];
			ret2 = this.executeSingleTrigger(inst, type_name, trig, index);
			ret = ret || ret2;
		}
		return ret;
	};
	Runtime.prototype.executeSingleTrigger = function (inst, type_name, trig, index)
	{
		var i, leni;
		var ret = false;
		this.trigger_depth++;
		var current_event = this.getCurrentEventStack().current_event;
		if (current_event)
			this.pushCleanSol(current_event.solModifiersIncludingParents);
		var isrecursive = (this.trigger_depth > 1);		// calling trigger from inside another trigger
		this.pushCleanSol(trig.solModifiersIncludingParents);
		if (isrecursive)
			this.pushLocalVarStack();
		var event_stack = this.pushEventStack(trig);
		event_stack.current_event = trig;
		if (inst)
		{
			var sol = this.types[type_name].getCurrentSol();
			sol.select_all = false;
			sol.instances.length = 1;
			sol.instances[0] = inst;
			this.types[type_name].applySolToContainer();
		}
		var ok_to_run = true;
		if (trig.parent)
		{
			var temp_parents_arr = event_stack.temp_parents_arr;
			var cur_parent = trig.parent;
			while (cur_parent)
			{
				temp_parents_arr.push(cur_parent);
				cur_parent = cur_parent.parent;
			}
			temp_parents_arr.reverse();
			for (i = 0, leni = temp_parents_arr.length; i < leni; i++)
			{
				if (!temp_parents_arr[i].run_pretrigger())   // parent event failed
				{
					ok_to_run = false;
					break;
				}
			}
		}
		if (ok_to_run)
		{
			this.execcount++;
			if (trig.orblock)
				trig.run_orblocktrigger(index);
			else
				trig.run();
			ret = ret || event_stack.last_event_true;
		}
		this.popEventStack();
		if (isrecursive)
			this.popLocalVarStack();
		this.popSol(trig.solModifiersIncludingParents);
		if (current_event)
			this.popSol(current_event.solModifiersIncludingParents);
		if (this.isInOnDestroy === 0 && triggerSheetIndex === 0 && !this.isRunningEvents && (!this.deathRow.isEmpty() || this.createRow.length))
		{
			this.ClearDeathRow();
		}
		this.trigger_depth--;
		return ret;
	};
	Runtime.prototype.getCurrentCondition = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.conditions[evinfo.cndindex];
	};
	Runtime.prototype.getCurrentAction = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.actions[evinfo.actindex];
	};
	Runtime.prototype.pushLocalVarStack = function ()
	{
		this.localvar_stack_index++;
		if (this.localvar_stack_index >= this.localvar_stack.length)
			this.localvar_stack.push([]);
	};
	Runtime.prototype.popLocalVarStack = function ()
	{
;
		this.localvar_stack_index--;
	};
	Runtime.prototype.getCurrentLocalVarStack = function ()
	{
		return this.localvar_stack[this.localvar_stack_index];
	};
	Runtime.prototype.pushEventStack = function (cur_event)
	{
		this.event_stack_index++;
		if (this.event_stack_index >= this.event_stack.length)
			this.event_stack.push(new cr.eventStackFrame());
		var ret = this.getCurrentEventStack();
		ret.reset(cur_event);
		return ret;
	};
	Runtime.prototype.popEventStack = function ()
	{
;
		this.event_stack_index--;
	};
	Runtime.prototype.getCurrentEventStack = function ()
	{
		return this.event_stack[this.event_stack_index];
	};
	Runtime.prototype.pushLoopStack = function (name_)
	{
		this.loop_stack_index++;
		if (this.loop_stack_index >= this.loop_stack.length)
		{
			this.loop_stack.push(cr.seal({ name: name_, index: 0, stopped: false }));
		}
		var ret = this.getCurrentLoop();
		ret.name = name_;
		ret.index = 0;
		ret.stopped = false;
		return ret;
	};
	Runtime.prototype.popLoopStack = function ()
	{
;
		this.loop_stack_index--;
	};
	Runtime.prototype.getCurrentLoop = function ()
	{
		return this.loop_stack[this.loop_stack_index];
	};
	Runtime.prototype.getEventVariableByName = function (name, scope)
	{
		var i, leni, j, lenj, sheet, e;
		while (scope)
		{
			for (i = 0, leni = scope.subevents.length; i < leni; i++)
			{
				e = scope.subevents[i];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
			scope = scope.parent;
		}
		for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
		{
			sheet = this.eventsheets_by_index[i];
			for (j = 0, lenj = sheet.events.length; j < lenj; j++)
			{
				e = sheet.events[j];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
		}
		return null;
	};
	Runtime.prototype.getLayoutBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			if (this.layouts_by_index[i].sid === sid_)
				return this.layouts_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getObjectTypeBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			if (this.types_by_index[i].sid === sid_)
				return this.types_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getGroupBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			if (this.allGroups[i].sid === sid_)
				return this.allGroups[i];
		}
		return null;
	};
	function makeSaveDb(e)
	{
		var db = e.target.result;
		db.createObjectStore("saves", { keyPath: "slot" });
	};
	function IndexedDB_WriteSlot(slot_, data_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"], "readwrite");
			var objectStore = transaction.objectStore("saves");
			var putReq = objectStore.put({"slot": slot_, "data": data_ });
			putReq.onsuccess = oncomplete_;
		};
	};
	function IndexedDB_ReadSlot(slot_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"]);
			var objectStore = transaction.objectStore("saves");
			var readReq = objectStore.get(slot_);
			readReq.onsuccess = function (e)
			{
				if (readReq.result)
					oncomplete_(readReq.result["data"]);
				else
					oncomplete_(null);
			};
		};
	};
	Runtime.prototype.signalContinuousPreview = function ()
	{
		this.signalledContinuousPreview = true;
	};
	function doContinuousPreviewReload()
	{
		cr.logexport("Reloading for continuous preview");
		if (!!window["c2cocoonjs"])
		{
			CocoonJS["App"]["reload"]();
		}
		else
		{
			if (window.location.search.indexOf("continuous") > -1)
				window.location.reload(true);
			else
				window.location = window.location + "?continuous";
		}
	};
	Runtime.prototype.handleSaveLoad = function ()
	{
		var self = this;
		var savingToSlot = this.saveToSlot;
		var savingJson = this.lastSaveJson;
		var loadingFromSlot = this.loadFromSlot;
		var continuous = false;
		if (this.signalledContinuousPreview)
		{
			continuous = true;
			savingToSlot = "__c2_continuouspreview";
			this.signalledContinuousPreview = false;
		}
		if (savingToSlot.length)
		{
			this.ClearDeathRow();
			savingJson = this.saveToJSONString();
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_WriteSlot(savingToSlot, savingJson, function ()
				{
					cr.logexport("Saved state to IndexedDB storage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}, function (e)
				{
					try {
						localStorage.setItem("__c2save_" + savingToSlot, savingJson);
						cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
						self.lastSaveJson = savingJson;
						self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
						self.lastSaveJson = "";
						if (continuous)
							doContinuousPreviewReload();
					}
					catch (f)
					{
						cr.logexport("Failed to save game state: " + e + "; " + f);
					}
				});
			}
			else
			{
				try {
					localStorage.setItem("__c2save_" + savingToSlot, savingJson);
					cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					this.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}
				catch (e)
				{
					cr.logexport("Error saving to WebStorage: " + e);
				}
			}
			this.saveToSlot = "";
			this.loadFromSlot = "";
			this.loadFromJson = "";
		}
		if (loadingFromSlot.length)
		{
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_ReadSlot(loadingFromSlot, function (result_)
				{
					if (result_)
					{
						self.loadFromJson = result_;
						cr.logexport("Loaded state from IndexedDB storage (" + self.loadFromJson.length + " bytes)");
					}
					else
					{
						self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
						cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					}
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				}, function (e)
				{
					self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
					cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				});
			}
			else
			{
				this.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
				cr.logexport("Loaded state from WebStorage (" + this.loadFromJson.length + " bytes)");
				this.suspendDrawing = false;
				if (!self.loadFromJson.length)
					self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
			}
			this.loadFromSlot = "";
			this.saveToSlot = "";
		}
		if (this.loadFromJson.length)
		{
			this.ClearDeathRow();
			this.loadFromJSONString(this.loadFromJson);
			this.lastSaveJson = this.loadFromJson;
			this.trigger(cr.system_object.prototype.cnds.OnLoadComplete, null);
			this.lastSaveJson = "";
			this.loadFromJson = "";
		}
	};
	function CopyExtraObject(extra)
	{
		var p, ret = {};
		for (p in extra)
		{
			if (extra.hasOwnProperty(p))
			{
				if (extra[p] instanceof cr.ObjectSet)
					continue;
				if (extra[p] && typeof extra[p].c2userdata !== "undefined")
					continue;
				ret[p] = extra[p];
			}
		}
		return ret;
	};
	Runtime.prototype.saveToJSONString = function()
	{
		var i, len, j, lenj, type, layout, typeobj, g, c, a, v, p;
		var o = {
			"c2save":				true,
			"version":				1,
			"rt": {
				"time":				this.kahanTime.sum,
				"walltime":			this.wallTime.sum,
				"timescale":		this.timescale,
				"tickcount":		this.tickcount,
				"execcount":		this.execcount,
				"next_uid":			this.next_uid,
				"running_layout":	this.running_layout.sid,
				"start_time_offset": (Date.now() - this.start_time)
			},
			"types": {},
			"layouts": {},
			"events": {
				"groups": {},
				"cnds": {},
				"acts": {},
				"vars": {}
			}
		};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || this.typeHasNoSaveBehavior(type))
				continue;
			typeobj = {
				"instances": []
			};
			if (cr.hasAnyOwnProperty(type.extra))
				typeobj["ex"] = CopyExtraObject(type.extra);
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				typeobj["instances"].push(this.saveInstanceToJSON(type.instances[j]));
			}
			o["types"][type.sid.toString()] = typeobj;
		}
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			layout = this.layouts_by_index[i];
			o["layouts"][layout.sid.toString()] = layout.saveToJSON();
		}
		var ogroups = o["events"]["groups"];
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			g = this.allGroups[i];
			ogroups[g.sid.toString()] = this.groups_by_name[g.group_name].group_active;
		}
		var ocnds = o["events"]["cnds"];
		for (p in this.cndsBySid)
		{
			if (this.cndsBySid.hasOwnProperty(p))
			{
				c = this.cndsBySid[p];
				if (cr.hasAnyOwnProperty(c.extra))
					ocnds[p] = { "ex": CopyExtraObject(c.extra) };
			}
		}
		var oacts = o["events"]["acts"];
		for (p in this.actsBySid)
		{
			if (this.actsBySid.hasOwnProperty(p))
			{
				a = this.actsBySid[p];
				if (cr.hasAnyOwnProperty(a.extra))
					oacts[p] = { "ex": a.extra };
			}
		}
		var ovars = o["events"]["vars"];
		for (p in this.varsBySid)
		{
			if (this.varsBySid.hasOwnProperty(p))
			{
				v = this.varsBySid[p];
				if (!v.is_constant && (!v.parent || v.is_static))
					ovars[p] = v.data;
			}
		}
		o["system"] = this.system.saveToJSON();
		return JSON.stringify(o);
	};
	Runtime.prototype.refreshUidMap = function ()
	{
		var i, len, type, j, lenj, inst;
		this.objectsByUid = {};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				this.objectsByUid[inst.uid.toString()] = inst;
			}
		}
	};
	Runtime.prototype.loadFromJSONString = function (str)
	{
		var o = JSON.parse(str);
		if (!o["c2save"])
			return;		// probably not a c2 save state
		if (o["version"] > 1)
			return;		// from future version of c2; assume not compatible
		var rt = o["rt"];
		this.kahanTime.reset();
		this.kahanTime.sum = rt["time"];
		this.wallTime.reset();
		this.wallTime.sum = rt["walltime"] || 0;
		this.timescale = rt["timescale"];
		this.tickcount = rt["tickcount"];
		this.start_time = Date.now() - rt["start_time_offset"];
		var layout_sid = rt["running_layout"];
		if (layout_sid !== this.running_layout.sid)
		{
			var changeToLayout = this.getLayoutBySid(layout_sid);
			if (changeToLayout)
				this.doChangeLayout(changeToLayout);
			else
				return;		// layout that was saved on has gone missing (deleted?)
		}
		this.isLoadingState = true;
		var i, len, j, lenj, k, lenk, p, type, existing_insts, load_insts, inst, binst, layout, layer, g, iid, t;
		var otypes = o["types"];
		for (p in otypes)
		{
			if (otypes.hasOwnProperty(p))
			{
				type = this.getObjectTypeBySid(parseInt(p, 10));
				if (!type || type.is_family || this.typeHasNoSaveBehavior(type))
					continue;
				if (otypes[p]["ex"])
					type.extra = otypes[p]["ex"];
				else
					cr.wipe(type.extra);
				existing_insts = type.instances;
				load_insts = otypes[p]["instances"];
				for (i = 0, len = cr.min(existing_insts.length, load_insts.length); i < len; i++)
				{
					this.loadInstanceFromJSON(existing_insts[i], load_insts[i]);
				}
				for (i = load_insts.length, len = existing_insts.length; i < len; i++)
					this.DestroyInstance(existing_insts[i]);
				for (i = existing_insts.length, len = load_insts.length; i < len; i++)
				{
					layer = null;
					if (type.plugin.is_world)
					{
						layer = this.running_layout.getLayerBySid(load_insts[i]["w"]["l"]);
						if (!layer)
							continue;
					}
					inst = this.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
					this.loadInstanceFromJSON(inst, load_insts[i]);
				}
				type.stale_iids = true;
			}
		}
		this.ClearDeathRow();
		this.refreshUidMap();
		var olayouts = o["layouts"];
		for (p in olayouts)
		{
			if (olayouts.hasOwnProperty(p))
			{
				layout = this.getLayoutBySid(parseInt(p, 10));
				if (!layout)
					continue;		// must've gone missing
				layout.loadFromJSON(olayouts[p]);
			}
		}
		var ogroups = o["events"]["groups"];
		for (p in ogroups)
		{
			if (ogroups.hasOwnProperty(p))
			{
				g = this.getGroupBySid(parseInt(p, 10));
				if (g && this.groups_by_name[g.group_name])
					this.groups_by_name[g.group_name].group_active = ogroups[p];
			}
		}
		var ocnds = o["events"]["cnds"];
		for (p in ocnds)
		{
			if (ocnds.hasOwnProperty(p) && this.cndsBySid.hasOwnProperty(p))
			{
				this.cndsBySid[p].extra = ocnds[p]["ex"];
			}
		}
		var oacts = o["events"]["acts"];
		for (p in oacts)
		{
			if (oacts.hasOwnProperty(p) && this.actsBySid.hasOwnProperty(p))
			{
				this.actsBySid[p].extra = oacts[p]["ex"];
			}
		}
		var ovars = o["events"]["vars"];
		for (p in ovars)
		{
			if (ovars.hasOwnProperty(p) && this.varsBySid.hasOwnProperty(p))
			{
				this.varsBySid[p].data = ovars[p];
			}
		}
		this.next_uid = rt["next_uid"];
		this.isLoadingState = false;
		this.system.loadFromJSON(o["system"]);
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (type.is_contained)
				{
					iid = inst.get_iid();
					inst.siblings.length = 0;
					for (k = 0, lenk = type.container.length; k < lenk; k++)
					{
						t = type.container[k];
						if (type === t)
							continue;
;
						inst.siblings.push(t.instances[iid]);
					}
				}
				if (inst.afterLoad)
					inst.afterLoad();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.afterLoad)
							binst.afterLoad();
					}
				}
			}
		}
		this.redraw = true;
	};
	Runtime.prototype.saveInstanceToJSON = function(inst, state_only)
	{
		var i, len, world, behinst, et;
		var type = inst.type;
		var plugin = type.plugin;
		var o = {};
		if (state_only)
			o["c2"] = true;		// mark as known json data from Construct 2
		else
			o["uid"] = inst.uid;
		if (cr.hasAnyOwnProperty(inst.extra))
			o["ex"] = CopyExtraObject(inst.extra);
		if (inst.instance_vars && inst.instance_vars.length)
		{
			o["ivs"] = {};
			for (i = 0, len = inst.instance_vars.length; i < len; i++)
			{
				o["ivs"][inst.type.instvar_sids[i].toString()] = inst.instance_vars[i];
			}
		}
		if (plugin.is_world)
		{
			world = {
				"x": inst.x,
				"y": inst.y,
				"w": inst.width,
				"h": inst.height,
				"l": inst.layer.sid,
				"zi": inst.get_zindex()
			};
			if (inst.angle !== 0)
				world["a"] = inst.angle;
			if (inst.opacity !== 1)
				world["o"] = inst.opacity;
			if (inst.hotspotX !== 0.5)
				world["hX"] = inst.hotspotX;
			if (inst.hotspotY !== 0.5)
				world["hY"] = inst.hotspotY;
			if (inst.blend_mode !== 0)
				world["bm"] = inst.blend_mode;
			if (!inst.visible)
				world["v"] = inst.visible;
			if (!inst.collisionsEnabled)
				world["ce"] = inst.collisionsEnabled;
			if (inst.my_timescale !== -1)
				world["mts"] = inst.my_timescale;
			if (type.effect_types.length)
			{
				world["fx"] = [];
				for (i = 0, len = type.effect_types.length; i < len; i++)
				{
					et = type.effect_types[i];
					world["fx"].push({"name": et.name,
									  "active": inst.active_effect_flags[et.index],
									  "params": inst.effect_params[et.index] });
				}
			}
			o["w"] = world;
		}
		if (inst.behavior_insts && inst.behavior_insts.length)
		{
			o["behs"] = {};
			for (i = 0, len = inst.behavior_insts.length; i < len; i++)
			{
				behinst = inst.behavior_insts[i];
				if (behinst.saveToJSON)
					o["behs"][behinst.type.sid.toString()] = behinst.saveToJSON();
			}
		}
		if (inst.saveToJSON)
			o["data"] = inst.saveToJSON();
		return o;
	};
	Runtime.prototype.getInstanceVarIndexBySid = function (type, sid_)
	{
		var i, len;
		for (i = 0, len = type.instvar_sids.length; i < len; i++)
		{
			if (type.instvar_sids[i] === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.getBehaviorIndexBySid = function (inst, sid_)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].type.sid === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.loadInstanceFromJSON = function(inst, o, state_only)
	{
		var p, i, len, iv, oivs, world, fxindex, obehs, behindex;
		var oldlayer;
		var type = inst.type;
		var plugin = type.plugin;
		if (state_only)
		{
			if (!o["c2"])
				return;
		}
		else
			inst.uid = o["uid"];
		if (o["ex"])
			inst.extra = o["ex"];
		else
			cr.wipe(inst.extra);
		oivs = o["ivs"];
		if (oivs)
		{
			for (p in oivs)
			{
				if (oivs.hasOwnProperty(p))
				{
					iv = this.getInstanceVarIndexBySid(type, parseInt(p, 10));
					if (iv < 0 || iv >= inst.instance_vars.length)
						continue;		// must've gone missing
					inst.instance_vars[iv] = oivs[p];
				}
			}
		}
		if (plugin.is_world)
		{
			world = o["w"];
			if (inst.layer.sid !== world["l"])
			{
				oldlayer = inst.layer;
				inst.layer = this.running_layout.getLayerBySid(world["l"]);
				if (inst.layer)
				{
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
					cr.arrayFindRemove(oldlayer.instances, inst);
					oldlayer.zindices_stale = true;
				}
				else
				{
					inst.layer = oldlayer;
					this.DestroyInstance(inst);
				}
			}
			inst.x = world["x"];
			inst.y = world["y"];
			inst.width = world["w"];
			inst.height = world["h"];
			inst.zindex = world["zi"];
			inst.angle = world.hasOwnProperty("a") ? world["a"] : 0;
			inst.opacity = world.hasOwnProperty("o") ? world["o"] : 1;
			inst.hotspotX = world.hasOwnProperty("hX") ? world["hX"] : 0.5;
			inst.hotspotY = world.hasOwnProperty("hY") ? world["hY"] : 0.5;
			inst.visible = world.hasOwnProperty("v") ? world["v"] : true;
			inst.collisionsEnabled = world.hasOwnProperty("ce") ? world["ce"] : true;
			inst.my_timescale = world.hasOwnProperty("mts") ? world["mts"] : -1;
			inst.blend_mode = world.hasOwnProperty("bm") ? world["bm"] : 0;;
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			inst.set_bbox_changed();
			if (world.hasOwnProperty("fx"))
			{
				for (i = 0, len = world["fx"].length; i < len; i++)
				{
					fxindex = type.getEffectIndexByName(world["fx"][i]["name"]);
					if (fxindex < 0)
						continue;		// must've gone missing
					inst.active_effect_flags[fxindex] = world["fx"][i]["active"];
					inst.effect_params[fxindex] = world["fx"][i]["params"];
				}
			}
			inst.updateActiveEffects();
		}
		obehs = o["behs"];
		if (obehs)
		{
			for (p in obehs)
			{
				if (obehs.hasOwnProperty(p))
				{
					behindex = this.getBehaviorIndexBySid(inst, parseInt(p, 10));
					if (behindex < 0)
						continue;		// must've gone missing
					inst.behavior_insts[behindex].loadFromJSON(obehs[p]);
				}
			}
		}
		if (o["data"])
			inst.loadFromJSON(o["data"]);
	};
	cr.runtime = Runtime;
	cr.createRuntime = function (canvasid)
	{
		return new Runtime(document.getElementById(canvasid));
	};
	cr.createDCRuntime = function (w, h)
	{
		return new Runtime({ "dc": true, "width": w, "height": h });
	};
	window["cr_createRuntime"] = cr.createRuntime;
	window["cr_createDCRuntime"] = cr.createDCRuntime;
	window["createCocoonJSRuntime"] = function ()
	{
		window["c2cocoonjs"] = true;
		var canvas = document.createElement("screencanvas") || document.createElement("canvas");
		canvas.screencanvas = true;
		document.body.appendChild(canvas);
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window.addEventListener("orientationchange", function () {
			window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		});
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
	window["createEjectaRuntime"] = function ()
	{
		var canvas = document.getElementById("canvas");
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
}());
window["cr_getC2Runtime"] = function()
{
	var canvas = document.getElementById("c2canvas");
	if (canvas)
		return canvas["c2runtime"];
	else if (window["c2runtime"])
		return window["c2runtime"];
	else
		return null;
}
window["cr_sizeCanvas"] = function(w, h)
{
	if (w === 0 || h === 0)
		return;
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSize"](w, h);
}
window["cr_setSuspended"] = function(s)
{
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSuspended"](s);
}
;
(function()
{
	function Layout(runtime, m)
	{
		this.runtime = runtime;
		this.event_sheet = null;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		this.scale = 1.0;
		this.angle = 0;
		this.first_visit = true;
		this.name = m[0];
		this.width = m[1];
		this.height = m[2];
		this.unbounded_scrolling = m[3];
		this.sheetname = m[4];
		this.sid = m[5];
		var lm = m[6];
		var i, len;
		this.layers = [];
		this.initial_types = [];
		for (i = 0, len = lm.length; i < len; i++)
		{
			var layer = new cr.layer(this, lm[i]);
			layer.number = i;
			cr.seal(layer);
			this.layers.push(layer);
		}
		var im = m[7];
		this.initial_nonworld = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
				type.default_instance = inst;
			this.initial_nonworld.push(inst);
			if (this.initial_types.indexOf(type) === -1)
				this.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[8].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[8][i][0],
				name: m[8][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[8][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
		this.persist_data = {};
	};
	Layout.prototype.saveObjectToPersist = function (inst)
	{
		var sidStr = inst.type.sid.toString();
		if (!this.persist_data.hasOwnProperty(sidStr))
			this.persist_data[sidStr] = [];
		var type_persist = this.persist_data[sidStr];
		type_persist.push(this.runtime.saveInstanceToJSON(inst));
	};
	Layout.prototype.hasOpaqueBottomLayer = function ()
	{
		var layer = this.layers[0];
		return !layer.transparent && layer.opacity === 1.0 && !layer.forceOwnTexture && layer.visible;
	};
	Layout.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layout.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	var created_instances = [];
	function sort_by_zindex(a, b)
	{
		return a.zindex - b.zindex;
	};
	var first_layout = true;
	Layout.prototype.startRunning = function ()
	{
		if (this.sheetname)
		{
			this.event_sheet = this.runtime.eventsheets[this.sheetname];
;
			this.event_sheet.updateDeepIncludes();
		}
		this.runtime.running_layout = this;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		var i, k, len, lenk, type, type_instances, inst, iid, t, s, p, q, type_data, layer;
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.is_family)
				continue;		// instances are only transferred for their real type
			type_instances = type.instances;
			for (k = 0, lenk = type_instances.length; k < lenk; k++)
			{
				inst = type_instances[k];
				if (inst.layer)
				{
					var num = inst.layer.number;
					if (num >= this.layers.length)
						num = this.layers.length - 1;
					inst.layer = this.layers[num];
					if (inst.layer.instances.indexOf(inst) === -1)
						inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
				}
			}
		}
		if (!first_layout)
		{
			for (i = 0, len = this.layers.length; i < len; ++i)
			{
				this.layers[i].instances.sort(sort_by_zindex);
			}
		}
		var layer;
		created_instances.length = 0;
		this.boundScrolling();
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			layer.createInitialInstances();		// fills created_instances
			layer.disableAngle = true;
			var px = layer.canvasToLayer(0, 0, true, true);
			var py = layer.canvasToLayer(0, 0, false, true);
			layer.disableAngle = false;
			if (this.runtime.pixel_rounding)
			{
				px = Math.round(px);
				py = Math.round(py);
			}
			layer.rotateViewport(px, py, null);
		}
		var uids_changed = false;
		if (!this.first_visit)
		{
			for (p in this.persist_data)
			{
				if (this.persist_data.hasOwnProperty(p))
				{
					type = this.runtime.getObjectTypeBySid(parseInt(p, 10));
					if (!type || type.is_family || !this.runtime.typeHasPersistBehavior(type))
						continue;
					type_data = this.persist_data[p];
					for (i = 0, len = type_data.length; i < len; i++)
					{
						layer = null;
						if (type.plugin.is_world)
						{
							layer = this.getLayerBySid(type_data[i]["w"]["l"]);
							if (!layer)
								continue;
						}
						inst = this.runtime.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
						this.runtime.loadInstanceFromJSON(inst, type_data[i]);
						uids_changed = true;
						created_instances.push(inst);
					}
					type_data.length = 0;
				}
			}
			for (i = 0, len = this.layers.length; i < len; i++)
			{
				this.layers[i].instances.sort(sort_by_zindex);
				this.layers[i].zindices_stale = true;		// in case of duplicates/holes
			}
		}
		if (uids_changed)
		{
			this.runtime.ClearDeathRow();
			this.runtime.refreshUidMap();
		}
		for (i = 0; i < created_instances.length; i++)
		{
			inst = created_instances[i];
			if (!inst.type.is_contained)
				continue;
			iid = inst.get_iid();
			for (k = 0, lenk = inst.type.container.length; k < lenk; k++)
			{
				t = inst.type.container[k];
				if (inst.type === t)
					continue;
				if (t.instances.length > iid)
					inst.siblings.push(t.instances[iid]);
				else
				{
					if (!t.default_instance)
					{
					}
					else
					{
						s = this.runtime.createInstanceFromInit(t.default_instance, inst.layer, true, inst.x, inst.y, true);
						this.runtime.ClearDeathRow();
						t.updateIIDs();
						inst.siblings.push(s);
						created_instances.push(s);		// come back around and link up its own instances too
					}
				}
			}
		}
		for (i = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			inst = this.runtime.createInstanceFromInit(this.initial_nonworld[i], null, true);
;
		}
		this.runtime.changelayout = null;
		this.runtime.ClearDeathRow();
		if (this.runtime.ctx && !this.runtime.isDomFree)
		{
			for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
			{
				t = this.runtime.types_by_index[i];
				if (t.is_family || !t.instances.length || !t.preloadCanvas2D)
					continue;
				t.preloadCanvas2D(this.runtime.ctx);
			}
		}
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout start: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		for (i = 0, len = created_instances.length; i < len; i++)
		{
			inst = created_instances[i];
			this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		}
		created_instances.length = 0;
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart, null);
		this.first_visit = false;
	};
	Layout.prototype.createGlobalNonWorlds = function ()
	{
		var i, k, len, initial_inst, inst, type;
		for (i = 0, k = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			initial_inst = this.initial_nonworld[i];
			type = this.runtime.types_by_index[initial_inst[1]];
			if (type.global)
				inst = this.runtime.createInstanceFromInit(initial_inst, null, true);
			else
			{
				this.initial_nonworld[k] = initial_inst;
				k++;
			}
		}
		this.initial_nonworld.length = k;
	};
	Layout.prototype.stopRunning = function ()
	{
;
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout end: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd, null);
		this.runtime.system.waits.length = 0;
		var i, leni, j, lenj;
		var layer_instances, inst, type;
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			this.layers[i].updateZIndices();
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					if (this.runtime.typeHasPersistBehavior(inst.type))
						this.saveObjectToPersist(inst);
				}
			}
		}
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					this.runtime.DestroyInstance(inst);
				}
			}
			this.runtime.ClearDeathRow();
			layer_instances.length = 0;
			this.layers[i].zindices_stale = true;
		}
		for (i = 0, leni = this.runtime.types_by_index.length; i < leni; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.global || type.plugin.is_world || type.plugin.singleglobal || type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
				this.runtime.DestroyInstance(type.instances[j]);
			this.runtime.ClearDeathRow();
		}
		first_layout = false;
	};
	Layout.prototype.draw = function (ctx)
	{
		var layout_canvas;
		var layout_ctx = ctx;
		var ctx_changed = false;
		var render_offscreen = !this.runtime.fullscreenScalingQuality;
		if (render_offscreen)
		{
			if (!this.runtime.layout_canvas)
			{
				this.runtime.layout_canvas = document.createElement("canvas");
				layout_canvas = this.runtime.layout_canvas;
				layout_canvas.width = this.runtime.draw_width;
				layout_canvas.height = this.runtime.draw_height;
				this.runtime.layout_ctx = layout_canvas.getContext("2d");
				ctx_changed = true;
			}
			layout_canvas = this.runtime.layout_canvas;
			layout_ctx = this.runtime.layout_ctx;
			if (layout_canvas.width !== this.runtime.draw_width)
			{
				layout_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layout_canvas.height !== this.runtime.draw_height)
			{
				layout_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layout_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
		}
		layout_ctx.globalAlpha = 1;
		layout_ctx.globalCompositeOperation = "source-over";
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			layout_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		var i, len, l;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.visible && l.opacity > 0 && l.blend_mode !== 11)
				l.draw(layout_ctx);
		}
		if (render_offscreen)
		{
			ctx.drawImage(layout_canvas, 0, 0, this.runtime.width, this.runtime.height);
		}
	};
	Layout.prototype.drawGL = function (glw)
	{
		var render_to_texture = (this.active_effect_types.length > 0 ||
								 this.runtime.uses_background_blending ||
								 !this.runtime.fullscreenScalingQuality);
		if (render_to_texture)
		{
			if (!this.runtime.layout_tex)
			{
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layout_tex.c2width !== this.runtime.draw_width || this.runtime.layout_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layout_tex);
			if (!this.runtime.fullscreenScalingQuality)
			{
				glw.setSize(this.runtime.draw_width, this.runtime.draw_height);
			}
		}
		else
		{
			if (this.runtime.layout_tex)
			{
				glw.setRenderingToTexture(null);
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = null;
			}
		}
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			glw.clear(0, 0, 0, 0);
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].visible && this.layers[i].opacity > 0)
				this.layers[i].drawGL(glw);
		}
		if (render_to_texture)
		{
			if (this.active_effect_types.length === 0 ||
				(this.active_effect_types.length === 1 && this.runtime.fullscreenScalingQuality))
			{
				if (this.active_effect_types.length === 1)
				{
					var etindex = this.active_effect_types[0].index;
					glw.switchProgram(this.active_effect_types[0].shaderindex);
					glw.setProgramParameters(null,								// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.scale,						// layerScale
											 this.angle,						// layerAngle
											 0.0, 0.0,							// viewOrigin
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(this.active_effect_types[0].shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
				}
				glw.setRenderingToTexture(null);				// to backbuffer
				glw.setOpacity(1);
				glw.setTexture(this.runtime.layout_tex);
				glw.setAlphaBlend();
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.width / 2;
				var halfh = this.runtime.height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.renderEffectChain(glw, null, null, null);
			}
		}
	};
	Layout.prototype.getRenderTarget = function()
	{
		return (this.active_effect_types.length > 0 ||
				this.runtime.uses_background_blending ||
				!this.runtime.fullscreenScalingQuality) ? this.runtime.layout_tex : null;
	};
	Layout.prototype.getMinLayerScale = function ()
	{
		var m = this.layers[0].getScale();
		var i, len, l;
		for (i = 1, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.parallaxX === 0 && l.parallaxY === 0)
				continue;
			if (l.getScale() < m)
				m = l.getScale();
		}
		return m;
	};
	Layout.prototype.scrollToX = function (x)
	{
		if (!this.unbounded_scrolling)
		{
			var widthBoundary = (this.runtime.draw_width * (1 / this.getMinLayerScale()) / 2);
			if (x > this.width - widthBoundary)
				x = this.width - widthBoundary;
			if (x < widthBoundary)
				x = widthBoundary;
		}
		if (this.scrollX !== x)
		{
			this.scrollX = x;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.scrollToY = function (y)
	{
		if (!this.unbounded_scrolling)
		{
			var heightBoundary = (this.runtime.draw_height * (1 / this.getMinLayerScale()) / 2);
			if (y > this.height - heightBoundary)
				y = this.height - heightBoundary;
			if (y < heightBoundary)
				y = heightBoundary;
		}
		if (this.scrollY !== y)
		{
			this.scrollY = y;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.boundScrolling = function ()
	{
		this.scrollToX(this.scrollX);
		this.scrollToY(this.scrollY);
	};
	Layout.prototype.renderEffectChain = function (glw, layer, inst, rendertarget)
	{
		var active_effect_types = inst ?
							inst.active_effect_types :
							layer ?
								layer.active_effect_types :
								this.active_effect_types;
		var layerScale = 1, layerAngle = 0, viewOriginLeft = 0, viewOriginTop = 0;
		if (inst)
		{
			layerScale = inst.layer.getScale();
			layerAngle = inst.layer.getAngle();
			viewOriginLeft = inst.layer.viewLeft;
			viewOriginTop = inst.layer.viewTop;
		}
		else if (layer)
		{
			layerScale = layer.getScale();
			layerAngle = layer.getAngle();
			viewOriginLeft = layer.viewLeft;
			viewOriginTop = layer.viewTop;
		}
		var fx_tex = this.runtime.fx_tex;
		var i, len, last, temp, fx_index = 0, other_fx_index = 1;
		var y, h;
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var halfw = windowWidth / 2;
		var halfh = windowHeight / 2;
		var rcTex = layer ? layer.rcTex : this.rcTex;
		var rcTex2 = layer ? layer.rcTex2 : this.rcTex2;
		var screenleft = 0, clearleft = 0;
		var screentop = 0, cleartop = 0;
		var screenright = windowWidth, clearright = windowWidth;
		var screenbottom = windowHeight, clearbottom = windowHeight;
		var boxExtendHorizontal = 0;
		var boxExtendVertical = 0;
		var inst_layer_angle = inst ? inst.layer.getAngle() : 0;
		if (inst)
		{
			for (i = 0, len = active_effect_types.length; i < len; i++)
			{
				boxExtendHorizontal += glw.getProgramBoxExtendHorizontal(active_effect_types[i].shaderindex);
				boxExtendVertical += glw.getProgramBoxExtendVertical(active_effect_types[i].shaderindex);
			}
			var bbox = inst.bbox;
			screenleft = layer.layerToCanvas(bbox.left, bbox.top, true, true);
			screentop = layer.layerToCanvas(bbox.left, bbox.top, false, true);
			screenright = layer.layerToCanvas(bbox.right, bbox.bottom, true, true);
			screenbottom = layer.layerToCanvas(bbox.right, bbox.bottom, false, true);
			if (inst_layer_angle !== 0)
			{
				var screentrx = layer.layerToCanvas(bbox.right, bbox.top, true, true);
				var screentry = layer.layerToCanvas(bbox.right, bbox.top, false, true);
				var screenblx = layer.layerToCanvas(bbox.left, bbox.bottom, true, true);
				var screenbly = layer.layerToCanvas(bbox.left, bbox.bottom, false, true);
				temp = Math.min(screenleft, screenright, screentrx, screenblx);
				screenright = Math.max(screenleft, screenright, screentrx, screenblx);
				screenleft = temp;
				temp = Math.min(screentop, screenbottom, screentry, screenbly);
				screenbottom = Math.max(screentop, screenbottom, screentry, screenbly);
				screentop = temp;
			}
			screenleft -= boxExtendHorizontal;
			screentop -= boxExtendVertical;
			screenright += boxExtendHorizontal;
			screenbottom += boxExtendVertical;
			rcTex2.left = screenleft / windowWidth;
			rcTex2.top = 1 - screentop / windowHeight;
			rcTex2.right = screenright / windowWidth;
			rcTex2.bottom = 1 - screenbottom / windowHeight;
			clearleft = screenleft = cr.floor(screenleft);
			cleartop = screentop = cr.floor(screentop);
			clearright = screenright = cr.ceil(screenright);
			clearbottom = screenbottom = cr.ceil(screenbottom);
			clearleft -= boxExtendHorizontal;
			cleartop -= boxExtendVertical;
			clearright += boxExtendHorizontal;
			clearbottom += boxExtendVertical;
			if (screenleft < 0)					screenleft = 0;
			if (screentop < 0)					screentop = 0;
			if (screenright > windowWidth)		screenright = windowWidth;
			if (screenbottom > windowHeight)	screenbottom = windowHeight;
			if (clearleft < 0)					clearleft = 0;
			if (cleartop < 0)					cleartop = 0;
			if (clearright > windowWidth)		clearright = windowWidth;
			if (clearbottom > windowHeight)		clearbottom = windowHeight;
			rcTex.left = screenleft / windowWidth;
			rcTex.top = 1 - screentop / windowHeight;
			rcTex.right = screenright / windowWidth;
			rcTex.bottom = 1 - screenbottom / windowHeight;
		}
		else
		{
			rcTex.left = rcTex2.left = 0;
			rcTex.top = rcTex2.top = 0;
			rcTex.right = rcTex2.right = 1;
			rcTex.bottom = rcTex2.bottom = 1;
		}
		var pre_draw = (inst && (((inst.angle || inst_layer_angle) && glw.programUsesDest(active_effect_types[0].shaderindex)) || boxExtendHorizontal !== 0 || boxExtendVertical !== 0 || inst.opacity !== 1 || inst.type.plugin.must_predraw)) || (layer && !inst && layer.opacity !== 1);
		glw.setAlphaBlend();
		if (pre_draw)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(0);
			glw.setRenderingToTexture(fx_tex[fx_index]);
			h = clearbottom - cleartop;
			y = (windowHeight - cleartop) - h;
			glw.clearRect(clearleft, y, clearright - clearleft, h);
			if (inst)
			{
				inst.drawGL(glw);
			}
			else
			{
				glw.setTexture(this.runtime.layer_tex);
				glw.setOpacity(layer.opacity);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			}
			rcTex2.left = rcTex2.top = 0;
			rcTex2.right = rcTex2.bottom = 1;
			if (inst)
			{
				temp = rcTex.top;
				rcTex.top = rcTex.bottom;
				rcTex.bottom = temp;
			}
			fx_index = 1;
			other_fx_index = 0;
		}
		glw.setOpacity(1);
		var last = active_effect_types.length - 1;
		var post_draw = glw.programUsesCrossSampling(active_effect_types[last].shaderindex) ||
						(!layer && !inst && !this.runtime.fullscreenScalingQuality);
		var etindex = 0;
		for (i = 0, len = active_effect_types.length; i < len; i++)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(active_effect_types[i].shaderindex);
			etindex = active_effect_types[i].index;
			if (glw.programIsAnimated(active_effect_types[i].shaderindex))
				this.runtime.redraw = true;
			if (i == 0 && !pre_draw)
			{
				glw.setRenderingToTexture(fx_tex[fx_index]);
				h = clearbottom - cleartop;
				y = (windowHeight - cleartop) - h;
				glw.clearRect(clearleft, y, clearright - clearleft, h);
				if (inst)
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / inst.width,				// pixelWidth
											 1.0 / inst.height,				// pixelHeight
											 rcTex2.left, rcTex2.top,		// destStart
											 rcTex2.right, rcTex2.bottom,	// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 inst.effect_params[etindex]);	// fx params
					inst.drawGL(glw);
				}
				else
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / windowWidth,				// pixelWidth
											 1.0 / windowHeight,			// pixelHeight
											 0.0, 0.0,						// destStart
											 1.0, 1.0,						// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 layer ?						// fx params
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
					glw.setTexture(layer ? this.runtime.layer_tex : this.runtime.layout_tex);
					glw.resetModelView();
					glw.translate(-halfw, -halfh);
					glw.updateModelView();
					glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				}
				rcTex2.left = rcTex2.top = 0;
				rcTex2.right = rcTex2.bottom = 1;
				if (inst && !post_draw)
				{
					temp = screenbottom;
					screenbottom = screentop;
					screentop = temp;
				}
			}
			else
			{
				glw.setProgramParameters(rendertarget,						// backTex
										 1.0 / windowWidth,					// pixelWidth
										 1.0 / windowHeight,				// pixelHeight
										 rcTex2.left, rcTex2.top,			// destStart
										 rcTex2.right, rcTex2.bottom,		// destEnd
										 layerScale,
										 layerAngle,
										 viewOriginLeft, viewOriginTop,
										 inst ?								// fx params
											inst.effect_params[etindex] :
											layer ?
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
				glw.setTexture(null);
				if (i === last && !post_draw)
				{
					if (inst)
						glw.setBlend(inst.srcBlend, inst.destBlend);
					else if (layer)
						glw.setBlend(layer.srcBlend, layer.destBlend);
					glw.setRenderingToTexture(rendertarget);
				}
				else
				{
					glw.setRenderingToTexture(fx_tex[fx_index]);
					h = clearbottom - cleartop;
					y = (windowHeight - cleartop) - h;
					glw.clearRect(clearleft, y, clearright - clearleft, h);
				}
				glw.setTexture(fx_tex[other_fx_index]);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				if (i === last && !post_draw)
					glw.setTexture(null);
			}
			fx_index = (fx_index === 0 ? 1 : 0);
			other_fx_index = (fx_index === 0 ? 1 : 0);		// will be opposite to fx_index since it was just assigned
		}
		if (post_draw)
		{
			glw.switchProgram(0);
			if (inst)
				glw.setBlend(inst.srcBlend, inst.destBlend);
			else if (layer)
				glw.setBlend(layer.srcBlend, layer.destBlend);
			else
			{
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
					halfw = this.runtime.width / 2;
					halfh = this.runtime.height / 2;
					screenleft = 0;
					screentop = 0;
					screenright = this.runtime.width;
					screenbottom = this.runtime.height;
				}
			}
			glw.setRenderingToTexture(rendertarget);
			glw.setTexture(fx_tex[other_fx_index]);
			glw.resetModelView();
			glw.translate(-halfw, -halfh);
			glw.updateModelView();
			if (inst && active_effect_types.length === 1 && !pre_draw)
				glw.quadTex(screenleft, screentop, screenright, screentop, screenright, screenbottom, screenleft, screenbottom, rcTex);
			else
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			glw.setTexture(null);
		}
	};
	Layout.prototype.getLayerBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].sid === sid_)
				return this.layers[i];
		}
		return null;
	};
	Layout.prototype.saveToJSON = function ()
	{
		var i, len, layer, et;
		var o = {
			"sx": this.scrollX,
			"sy": this.scrollY,
			"s": this.scale,
			"a": this.angle,
			"w": this.width,
			"h": this.height,
			"fv": this.first_visit,			// added r127
			"persist": this.persist_data,
			"fx": [],
			"layers": {}
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			o["layers"][layer.sid.toString()] = layer.saveToJSON();
		}
		return o;
	};
	Layout.prototype.loadFromJSON = function (o)
	{
		var i, len, fx, p, layer;
		this.scrollX = o["sx"];
		this.scrollY = o["sy"];
		this.scale = o["s"];
		this.angle = o["a"];
		this.width = o["w"];
		this.height = o["h"];
		this.persist_data = o["persist"];
		if (typeof o["fv"] !== "undefined")
			this.first_visit = o["fv"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		var olayers = o["layers"];
		for (p in olayers)
		{
			if (olayers.hasOwnProperty(p))
			{
				layer = this.getLayerBySid(parseInt(p, 10));
				if (!layer)
					continue;		// must've gone missing
				layer.loadFromJSON(olayers[p]);
			}
		}
	};
	cr.layout = Layout;
	function Layer(layout, m)
	{
		this.layout = layout;
		this.runtime = layout.runtime;
		this.instances = [];        // running instances
		this.scale = 1.0;
		this.angle = 0;
		this.disableAngle = false;
		this.tmprect = new cr.rect(0, 0, 0, 0);
		this.tmpquad = new cr.quad();
		this.viewLeft = 0;
		this.viewRight = 0;
		this.viewTop = 0;
		this.viewBottom = 0;
		this.zindices_stale = false;
		this.name = m[0];
		this.index = m[1];
		this.sid = m[2];
		this.visible = m[3];		// initially visible
		this.background_color = m[4];
		this.transparent = m[5];
		this.parallaxX = m[6];
		this.parallaxY = m[7];
		this.opacity = m[8];
		this.forceOwnTexture = m[9];
		this.zoomRate = m[10];
		this.blend_mode = m[11];
		this.effect_fallback = m[12];
		this.compositeOp = "source-over";
		this.srcBlend = 0;
		this.destBlend = 0;
		this.render_offscreen = false;
		var im = m[13];
		var i, len;
		this.initial_instances = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
			{
				type.default_instance = inst;
				type.default_layerindex = this.index;
			}
			this.initial_instances.push(inst);
			if (this.layout.initial_types.indexOf(type) === -1)
				this.layout.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[14].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[14][i][0],
				name: m[14][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[14][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
	};
	Layer.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layer.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	Layer.prototype.createInitialInstances = function ()
	{
		var i, k, len, inst, initial_inst, type, keep, hasPersistBehavior;
		for (i = 0, k = 0, len = this.initial_instances.length; i < len; i++)
		{
			initial_inst = this.initial_instances[i];
			type = this.runtime.types_by_index[initial_inst[1]];
;
			hasPersistBehavior = this.runtime.typeHasPersistBehavior(type);
			keep = true;
			if (!hasPersistBehavior || this.layout.first_visit)
			{
				inst = this.runtime.createInstanceFromInit(initial_inst, this, true);
;
				created_instances.push(inst);
				if (inst.type.global)
					keep = false;
			}
			if (keep)
			{
				this.initial_instances[k] = this.initial_instances[i];
				k++;
			}
		}
		this.initial_instances.length = k;
		this.runtime.ClearDeathRow();		// flushes creation row so IIDs will be correct
		if (!this.runtime.glwrap && this.effect_types.length)	// no WebGL renderer and shaders used
			this.blend_mode = this.effect_fallback;				// use fallback blend mode
		this.compositeOp = cr.effectToCompositeOp(this.blend_mode);
		if (this.runtime.gl)
			cr.setGLBlend(this, this.blend_mode, this.runtime.gl);
	};
	Layer.prototype.updateZIndices = function ()
	{
		if (!this.zindices_stale)
			return;
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
;
;
			this.instances[i].zindex = i;
		}
		this.zindices_stale = false;
	};
	Layer.prototype.getScale = function (include_aspect)
	{
		return this.getNormalScale() * (this.runtime.fullscreenScalingQuality || include_aspect ? this.runtime.aspect_scale : 1);
	};
	Layer.prototype.getNormalScale = function ()
	{
		return ((this.scale * this.layout.scale) - 1) * this.zoomRate + 1;
	};
	Layer.prototype.getAngle = function ()
	{
		if (this.disableAngle)
			return 0;
		return cr.clamp_angle(this.layout.angle + this.angle);
	};
	Layer.prototype.draw = function (ctx)
	{
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.blend_mode !== 0);
		var layer_canvas = this.runtime.canvas;
		var layer_ctx = ctx;
		var ctx_changed = false;
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_canvas)
			{
				this.runtime.layer_canvas = document.createElement("canvas");
;
				layer_canvas = this.runtime.layer_canvas;
				layer_canvas.width = this.runtime.draw_width;
				layer_canvas.height = this.runtime.draw_height;
				this.runtime.layer_ctx = layer_canvas.getContext("2d");
;
				ctx_changed = true;
			}
			layer_canvas = this.runtime.layer_canvas;
			layer_ctx = this.runtime.layer_ctx;
			if (layer_canvas.width !== this.runtime.draw_width)
			{
				layer_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layer_canvas.height !== this.runtime.draw_height)
			{
				layer_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layer_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
			if (this.transparent)
				layer_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.globalAlpha = 1;
		layer_ctx.globalCompositeOperation = "source-over";
		if (!this.transparent)
		{
			layer_ctx.fillStyle = "rgb(" + this.background_color[0] + "," + this.background_color[1] + "," + this.background_color[2] + ")";
			layer_ctx.fillRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.save();
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = Math.round(px);
			py = Math.round(py);
		}
		this.rotateViewport(px, py, layer_ctx);
		var myscale = this.getScale();
		layer_ctx.scale(myscale, myscale);
		layer_ctx.translate(-px, -py);
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			layer_ctx.globalCompositeOperation = inst.compositeOp;
			inst.draw(layer_ctx);
		}
		layer_ctx.restore();
		if (this.render_offscreen)
		{
			ctx.globalCompositeOperation = this.compositeOp;
			ctx.globalAlpha = this.opacity;
			ctx.drawImage(layer_canvas, 0, 0);
		}
	};
	Layer.prototype.rotateViewport = function (px, py, ctx)
	{
		var myscale = this.getScale();
		this.viewLeft = px;
		this.viewTop = py;
		this.viewRight = px + (this.runtime.draw_width * (1 / myscale));
		this.viewBottom = py + (this.runtime.draw_height * (1 / myscale));
		var myAngle = this.getAngle();
		if (myAngle !== 0)
		{
			if (ctx)
			{
				ctx.translate(this.runtime.draw_width / 2, this.runtime.draw_height / 2);
				ctx.rotate(-myAngle);
				ctx.translate(this.runtime.draw_width / -2, this.runtime.draw_height / -2);
			}
			this.tmprect.set(this.viewLeft, this.viewTop, this.viewRight, this.viewBottom);
			this.tmprect.offset((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
			this.tmpquad.set_from_rotated_rect(this.tmprect, myAngle);
			this.tmpquad.bounding_box(this.tmprect);
			this.tmprect.offset((this.viewLeft + this.viewRight) / 2, (this.viewTop + this.viewBottom) / 2);
			this.viewLeft = this.tmprect.left;
			this.viewTop = this.tmprect.top;
			this.viewRight = this.tmprect.right;
			this.viewBottom = this.tmprect.bottom;
		}
	}
	Layer.prototype.drawGL = function (glw)
	{
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var shaderindex = 0;
		var etindex = 0;
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.active_effect_types.length > 0 || this.blend_mode !== 0);
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_tex)
			{
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layer_tex.c2width !== this.runtime.draw_width || this.runtime.layer_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layer_tex);
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layer_tex);
			if (this.transparent)
				glw.clear(0, 0, 0, 0);
		}
		if (!this.transparent)
		{
			glw.clear(this.background_color[0] / 255, this.background_color[1] / 255, this.background_color[2] / 255, 1);
		}
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = Math.round(px);
			py = Math.round(py);
		}
		this.rotateViewport(px, py, null);
		var myscale = this.getScale();
		glw.resetModelView();
		glw.scale(myscale, myscale);
		glw.rotateZ(-this.getAngle());
		glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
		glw.updateModelView();
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			if (inst.uses_shaders)
			{
				shaderindex = inst.active_effect_types[0].shaderindex;
				etindex = inst.active_effect_types[0].index;
				if (inst.active_effect_types.length === 1 && !glw.programUsesCrossSampling(shaderindex) &&
					!glw.programExtendsBox(shaderindex) && ((!inst.angle && !inst.layer.getAngle()) || !glw.programUsesDest(shaderindex)) &&
					inst.opacity === 1 && !inst.type.plugin.must_predraw)
				{
					glw.switchProgram(shaderindex);
					glw.setBlend(inst.srcBlend, inst.destBlend);
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
					var destStartX = 0, destStartY = 0, destEndX = 0, destEndY = 0;
					if (glw.programUsesDest(shaderindex))
					{
						var bbox = inst.bbox;
						var screenleft = this.layerToCanvas(bbox.left, bbox.top, true, true);
						var screentop = this.layerToCanvas(bbox.left, bbox.top, false, true);
						var screenright = this.layerToCanvas(bbox.right, bbox.bottom, true, true);
						var screenbottom = this.layerToCanvas(bbox.right, bbox.bottom, false, true);
						destStartX = screenleft / windowWidth;
						destStartY = 1 - screentop / windowHeight;
						destEndX = screenright / windowWidth;
						destEndY = 1 - screenbottom / windowHeight;
					}
					glw.setProgramParameters(this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget(), // backTex
											 1.0 / inst.width,			// pixelWidth
											 1.0 / inst.height,			// pixelHeight
											 destStartX, destStartY,
											 destEndX, destEndY,
											 this.getScale(),
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 inst.effect_params[etindex]);
					inst.drawGL(glw);
				}
				else
				{
					this.layout.renderEffectChain(glw, this, inst, this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget());
					glw.resetModelView();
					glw.scale(myscale, myscale);
					glw.rotateZ(-this.getAngle());
					glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
					glw.updateModelView();
				}
			}
			else
			{
				glw.switchProgram(0);		// un-set any previously set shader
				glw.setBlend(inst.srcBlend, inst.destBlend);
				inst.drawGL(glw);
			}
		}
		if (this.render_offscreen)
		{
			shaderindex = this.active_effect_types.length ? this.active_effect_types[0].shaderindex : 0;
			etindex = this.active_effect_types.length ? this.active_effect_types[0].index : 0;
			if (this.active_effect_types.length === 0 || (this.active_effect_types.length === 1 &&
				!glw.programUsesCrossSampling(shaderindex) && this.opacity === 1))
			{
				if (this.active_effect_types.length === 1)
				{
					glw.switchProgram(shaderindex);
					glw.setProgramParameters(this.layout.getRenderTarget(),		// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.getScale(),					// layerScale
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				glw.setRenderingToTexture(this.layout.getRenderTarget());
				glw.setOpacity(this.opacity);
				glw.setTexture(this.runtime.layer_tex);
				glw.setBlend(this.srcBlend, this.destBlend);
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.draw_width / 2;
				var halfh = this.runtime.draw_height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.layout.renderEffectChain(glw, this, null, this.layout.getRenderTarget());
			}
		}
	};
	Layer.prototype.canvasToLayer = function (ptx, pty, getx, using_draw_area)
	{
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			ptx *= multiplier;
			pty *= multiplier;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x += ptx * invScale;
		y += pty * invScale;
		var a = this.getAngle();
		if (a !== 0)
		{
			x -= this.layout.scrollX;
			y -= this.layout.scrollY;
			var cosa = Math.cos(a);
			var sina = Math.sin(a);
			var x_temp = (x * cosa) - (y * sina);
			y = (y * cosa) + (x * sina);
			x = x_temp;
			x += this.layout.scrollX;
			y += this.layout.scrollY;
		}
		return getx ? x : y;
	};
	Layer.prototype.layerToCanvas = function (ptx, pty, getx, using_draw_area)
	{
		var a = this.getAngle();
		if (a !== 0)
		{
			ptx -= this.layout.scrollX;
			pty -= this.layout.scrollY;
			var cosa = Math.cos(-a);
			var sina = Math.sin(-a);
			var x_temp = (ptx * cosa) - (pty * sina);
			pty = (pty * cosa) + (ptx * sina);
			ptx = x_temp;
			ptx += this.layout.scrollX;
			pty += this.layout.scrollY;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x = (ptx - x) / invScale;
		y = (pty - y) / invScale;
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina && !using_draw_area)
		{
			x /= multiplier;
			y /= multiplier;
		}
		return getx ? x : y;
	};
	Layer.prototype.rotatePt = function (x_, y_, getx)
	{
		if (this.getAngle() === 0)
			return getx ? x_ : y_;
		var nx = this.layerToCanvas(x_, y_, true);
		var ny = this.layerToCanvas(x_, y_, false);
		this.disableAngle = true;
		var px = this.canvasToLayer(nx, ny, true);
		var py = this.canvasToLayer(nx, ny, true);
		this.disableAngle = false;
		return getx ? px : py;
	};
	Layer.prototype.saveToJSON = function ()
	{
		var i, len, et;
		var o = {
			"s": this.scale,
			"a": this.angle,
			"vl": this.viewLeft,
			"vt": this.viewTop,
			"vr": this.viewRight,
			"vb": this.viewBottom,
			"v": this.visible,
			"bc": this.background_color,
			"t": this.transparent,
			"px": this.parallaxX,
			"py": this.parallaxY,
			"o": this.opacity,
			"zr": this.zoomRate,
			"fx": [],
			"instances": []
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		return o;
	};
	Layer.prototype.loadFromJSON = function (o)
	{
		var i, len, p, inst, fx;
		this.scale = o["s"];
		this.angle = o["a"];
		this.viewLeft = o["vl"];
		this.viewTop = o["vt"];
		this.viewRight = o["vr"];
		this.viewBottom = o["vb"];
		this.visible = o["v"];
		this.background_color = o["bc"];
		this.transparent = o["t"];
		this.parallaxX = o["px"];
		this.parallaxY = o["py"];
		this.opacity = o["o"];
		this.zoomRate = o["zr"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		this.instances.sort(sort_by_zindex);
		this.zindices_stale = true;
	};
	cr.layer = Layer;
}());
;
(function()
{
	var allUniqueSolModifiers = [];
	function testSolsMatch(arr1, arr2)
	{
		var i, len = arr1.length;
		switch (len) {
		case 0:
			return true;
		case 1:
			return arr1[0] === arr2[0];
		case 2:
			return arr1[0] === arr2[0] && arr1[1] === arr2[1];
		default:
			for (i = 0; i < len; i++)
			{
				if (arr1[i] !== arr2[i])
					return false;
			}
			return true;
		}
	};
	function solArraySorter(t1, t2)
	{
		return t1.index - t2.index;
	};
	function findMatchingSolModifier(arr)
	{
		var i, len, u, temp, subarr;
		if (arr.length === 2)
		{
			if (arr[0].index > arr[1].index)
			{
				temp = arr[0];
				arr[0] = arr[1];
				arr[1] = temp;
			}
		}
		else if (arr.length > 2)
			arr.sort(solArraySorter);		// so testSolsMatch compares in same order
		if (arr.length >= allUniqueSolModifiers.length)
			allUniqueSolModifiers.length = arr.length + 1;
		if (!allUniqueSolModifiers[arr.length])
			allUniqueSolModifiers[arr.length] = [];
		subarr = allUniqueSolModifiers[arr.length];
		for (i = 0, len = subarr.length; i < len; i++)
		{
			u = subarr[i];
			if (testSolsMatch(arr, u))
				return u;
		}
		subarr.push(arr);
		return arr;
	};
	function EventSheet(runtime, m)
	{
		this.runtime = runtime;
		this.triggers = {};
		this.fasttriggers = {};
        this.hasRun = false;
        this.includes = new cr.ObjectSet(); 	// all event sheets included by this sheet, at first-level indirection only
		this.deep_includes = [];				// all includes from this sheet recursively, in trigger order
		this.already_included_sheets = [];		// used while building deep_includes
		this.name = m[0];
		var em = m[1];		// events model
		this.events = [];       // triggers won't make it to this array
		var i, len;
		for (i = 0, len = em.length; i < len; i++)
			this.init_event(em[i], null, this.events);
	};
    EventSheet.prototype.toString = function ()
    {
        return this.name;
    };
	EventSheet.prototype.init_event = function (m, parent, nontriggers)
	{
		switch (m[0]) {
		case 0:	// event block
		{
			var block = new cr.eventblock(this, parent, m);
			cr.seal(block);
			if (block.orblock)
			{
				nontriggers.push(block);
				var i, len;
				for (i = 0, len = block.conditions.length; i < len; i++)
				{
					if (block.conditions[i].trigger)
						this.init_trigger(block, i);
				}
			}
			else
			{
				if (block.is_trigger())
					this.init_trigger(block, 0);
				else
					nontriggers.push(block);
			}
			break;
		}
		case 1: // variable
		{
			var v = new cr.eventvariable(this, parent, m);
			cr.seal(v);
			nontriggers.push(v);
			break;
		}
        case 2:	// include
        {
            var inc = new cr.eventinclude(this, parent, m);
			cr.seal(inc);
            nontriggers.push(inc);
			break;
        }
		default:
;
		}
	};
	EventSheet.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			this.events[i].postInit(i < len - 1 && this.events[i + 1].is_else_block);
		}
	};
	EventSheet.prototype.updateDeepIncludes = function ()
	{
		this.deep_includes.length = 0;
		this.already_included_sheets.length = 0;
		this.addDeepIncludes(this);
		this.already_included_sheets.length = 0;
	};
	EventSheet.prototype.addDeepIncludes = function (root_sheet)
	{
		var i, len, inc, sheet;
		var deep_includes = root_sheet.deep_includes;
		var already_included_sheets = root_sheet.already_included_sheets;
		var arr = this.includes.valuesRef();
		for (i = 0, len = arr.length; i < len; ++i)
		{
			inc = arr[i];
			sheet = inc.include_sheet;
			if (!inc.isActive() || root_sheet === sheet || already_included_sheets.indexOf(sheet) > -1)
				continue;
			already_included_sheets.push(sheet);
			sheet.addDeepIncludes(root_sheet);
			deep_includes.push(sheet);
		}
	};
	EventSheet.prototype.run = function (from_include)
	{
		if (!this.runtime.resuming_breakpoint)
		{
			this.hasRun = true;
			if (!from_include)
				this.runtime.isRunningEvents = true;
		}
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			var ev = this.events[i];
			ev.run();
				this.runtime.clearSol(ev.solModifiers);
				if (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length)
					this.runtime.ClearDeathRow();
		}
			if (!from_include)
				this.runtime.isRunningEvents = false;
	};
	function isPerformanceSensitiveTrigger(method)
	{
		if (cr.plugins_.Sprite && method === cr.plugins_.Sprite.prototype.cnds.OnFrameChanged)
		{
			return true;
		}
		return false;
	};
	EventSheet.prototype.init_trigger = function (trig, index)
	{
		if (!trig.orblock)
			this.runtime.triggers_to_postinit.push(trig);	// needs to be postInit'd later
		var i, len;
		var cnd = trig.conditions[index];
		var type_name;
		if (cnd.type)
			type_name = cnd.type.name;
		else
			type_name = "system";
		var fasttrigger = cnd.fasttrigger;
		var triggers = (fasttrigger ? this.fasttriggers : this.triggers);
		if (!triggers[type_name])
			triggers[type_name] = [];
		var obj_entry = triggers[type_name];
		var method = cnd.func;
		if (fasttrigger)
		{
			if (!cnd.parameters.length)				// no parameters
				return;
			var firstparam = cnd.parameters[0];
			if (firstparam.type !== 1 ||			// not a string param
				firstparam.expression.type !== 2)	// not a string literal node
			{
				return;
			}
			var fastevs;
			var firstvalue = firstparam.expression.value.toLowerCase();
			var i, len;
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					fastevs = obj_entry[i].evs;
					if (!fastevs[firstvalue])
						fastevs[firstvalue] = [[trig, index]];
					else
						fastevs[firstvalue].push([trig, index]);
					return;
				}
			}
			fastevs = {};
			fastevs[firstvalue] = [[trig, index]];
			obj_entry.push({ method: method, evs: fastevs });
		}
		else
		{
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					obj_entry[i].evs.push([trig, index]);
					return;
				}
			}
			if (isPerformanceSensitiveTrigger(method))
				obj_entry.unshift({ method: method, evs: [[trig, index]]});
			else
				obj_entry.push({ method: method, evs: [[trig, index]]});
		}
	};
	cr.eventsheet = EventSheet;
	function Selection(type)
	{
		this.type = type;
		this.instances = [];        // subset of picked instances
		this.else_instances = [];	// subset of unpicked instances
		this.select_all = true;
	};
	Selection.prototype.hasObjects = function ()
	{
		if (this.select_all)
			return this.type.instances.length;
		else
			return this.instances.length;
	};
	Selection.prototype.getObjects = function ()
	{
		if (this.select_all)
			return this.type.instances;
		else
			return this.instances;
	};
	/*
	Selection.prototype.ensure_picked = function (inst, skip_siblings)
	{
		var i, len;
		var orblock = inst.runtime.getCurrentEventStack().current_event.orblock;
		if (this.select_all)
		{
			this.select_all = false;
			if (orblock)
			{
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				cr.arrayFindRemove(this.else_instances, inst);
			}
			this.instances.length = 1;
			this.instances[0] = inst;
		}
		else
		{
			if (orblock)
			{
				i = this.else_instances.indexOf(inst);
				if (i !== -1)
				{
					this.instances.push(this.else_instances[i]);
					this.else_instances.splice(i, 1);
				}
			}
			else
			{
				if (this.instances.indexOf(inst) === -1)
					this.instances.push(inst);
			}
		}
		if (!skip_siblings)
		{
		}
	};
	*/
	Selection.prototype.pick_one = function (inst)
	{
		if (!inst)
			return;
		if (inst.runtime.getCurrentEventStack().current_event.orblock)
		{
			if (this.select_all)
			{
				this.instances.length = 0;
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				this.select_all = false;
			}
			var i = this.else_instances.indexOf(inst);
			if (i !== -1)
			{
				this.instances.push(this.else_instances[i]);
				this.else_instances.splice(i, 1);
			}
		}
		else
		{
			this.select_all = false;
			this.instances.length = 1;
			this.instances[0] = inst;
		}
	};
	cr.selection = Selection;
	function EventBlock(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.solModifiersIncludingParents = [];
		this.solWriterAfterCnds = false;	// block does not change SOL after running its conditions
		this.group = false;					// is group of events
		this.initially_activated = false;	// if a group, is active on startup
		this.toplevelevent = false;			// is an event block parented only by a top-level group
		this.toplevelgroup = false;			// is parented only by other groups or is top-level (i.e. not in a subevent)
		this.has_else_block = false;		// is followed by else
;
		this.conditions = [];
		this.actions = [];
		this.subevents = [];
		this.group_name = "";
		this.group = false;
		this.initially_activated = false;
		this.group_active = false;
		this.contained_includes = null;
        if (m[1])
        {
			this.group_name = m[1][1].toLowerCase();
			this.group = true;
			this.initially_activated = !!m[1][0];
			this.contained_includes = [];
			this.group_active = this.initially_activated;
			this.runtime.allGroups.push(this);
            this.runtime.groups_by_name[this.group_name] = this;
        }
		this.orblock = m[2];
		this.sid = m[4];
		if (!this.group)
			this.runtime.blocksBySid[this.sid.toString()] = this;
		var i, len;
		var cm = m[5];
		for (i = 0, len = cm.length; i < len; i++)
		{
			var cnd = new cr.condition(this, cm[i]);
			cnd.index = i;
			cr.seal(cnd);
			this.conditions.push(cnd);
			/*
			if (cnd.is_logical())
				this.is_logical = true;
			if (cnd.type && !cnd.type.plugin.singleglobal && this.cndReferences.indexOf(cnd.type) === -1)
				this.cndReferences.push(cnd.type);
			*/
			this.addSolModifier(cnd.type);
		}
		var am = m[6];
		for (i = 0, len = am.length; i < len; i++)
		{
			var act = new cr.action(this, am[i]);
			act.index = i;
			cr.seal(act);
			this.actions.push(act);
		}
		if (m.length === 8)
		{
			var em = m[7];
			for (i = 0, len = em.length; i < len; i++)
				this.sheet.init_event(em[i], this, this.subevents);
		}
		this.is_else_block = false;
		if (this.conditions.length)
		{
			this.is_else_block = (this.conditions[0].type == null && this.conditions[0].func == cr.system_object.prototype.cnds.Else);
		}
	};
	window["_c2hh_"] = "04DE9364CC615C6FDD5A68F81A1ADB0BAE221F02";
	EventBlock.prototype.postInit = function (hasElse/*, prevBlock_*/)
	{
		var i, len;
		var p = this.parent;
		if (this.group)
		{
			this.toplevelgroup = true;
			while (p)
			{
				if (!p.group)
				{
					this.toplevelgroup = false;
					break;
				}
				p = p.parent;
			}
		}
		this.toplevelevent = !this.is_trigger() && (!this.parent || (this.parent.group && this.parent.toplevelgroup));
		this.has_else_block = !!hasElse;
		this.solModifiersIncludingParents = this.solModifiers.slice(0);
		p = this.parent;
		while (p)
		{
			for (i = 0, len = p.solModifiers.length; i < len; i++)
				this.addParentSolModifier(p.solModifiers[i]);
			p = p.parent;
		}
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		this.solModifiersIncludingParents = findMatchingSolModifier(this.solModifiersIncludingParents);
		var i, len/*, s*/;
		for (i = 0, len = this.conditions.length; i < len; i++)
			this.conditions[i].postInit();
		for (i = 0, len = this.actions.length; i < len; i++)
			this.actions[i].postInit();
		for (i = 0, len = this.subevents.length; i < len; i++)
		{
			this.subevents[i].postInit(i < len - 1 && this.subevents[i + 1].is_else_block);
		}
		/*
		if (this.is_else_block && this.prev_block)
		{
			for (i = 0, len = this.prev_block.solModifiers.length; i < len; i++)
			{
				s = this.prev_block.solModifiers[i];
				if (this.solModifiers.indexOf(s) === -1)
					this.solModifiers.push(s);
			}
		}
		*/
	};
	EventBlock.prototype.setGroupActive = function (a)
	{
		if (this.group_active === !!a)
			return;		// same state
		this.group_active = !!a;
		var i, len;
		for (i = 0, len = this.contained_includes.length; i < len; ++i)
		{
			this.contained_includes[i].updateActive();
		}
		if (len > 0 && this.runtime.running_layout.event_sheet)
			this.runtime.running_layout.event_sheet.updateDeepIncludes();
	};
	function addSolModifierToList(type, arr)
	{
		var i, len, t;
		if (!type)
			return;
		if (arr.indexOf(type) === -1)
			arr.push(type);
		if (type.is_contained)
		{
			for (i = 0, len = type.container.length; i < len; i++)
			{
				t = type.container[i];
				if (type === t)
					continue;		// already handled
				if (arr.indexOf(t) === -1)
					arr.push(t);
			}
		}
	};
	EventBlock.prototype.addSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiers);
	};
	EventBlock.prototype.addParentSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiersIncludingParents);
	};
	EventBlock.prototype.setSolWriterAfterCnds = function ()
	{
		this.solWriterAfterCnds = true;
		if (this.parent)
			this.parent.setSolWriterAfterCnds();
	};
	EventBlock.prototype.is_trigger = function ()
	{
		if (!this.conditions.length)    // no conditions
			return false;
		else
			return this.conditions[0].trigger;
	};
	EventBlock.prototype.run = function ()
	{
		var i, len, any_true = false, cnd_result;
		var runtime = this.runtime;
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var conditions = this.conditions;
			if (!this.is_else_block)
				evinfo.else_branch_ran = false;
		if (this.orblock)
		{
			if (conditions.length === 0)
				any_true = true;		// be sure to run if empty block
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (conditions[evinfo.cndindex].trigger)		// skip triggers when running OR block
					continue;
				cnd_result = conditions[evinfo.cndindex].run();
				if (cnd_result)			// make sure all conditions run and run if any were true
					any_true = true;
			}
			evinfo.last_event_true = any_true;
			if (any_true)
				this.run_actions_and_subevents();
		}
		else
		{
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				cnd_result = conditions[evinfo.cndindex].run();
				if (!cnd_result)    // condition failed
				{
					evinfo.last_event_true = false;
					if (this.toplevelevent && (!runtime.deathRow.isEmpty() || runtime.createRow.length))
						runtime.ClearDeathRow();
					return;		// bail out now
				}
			}
			evinfo.last_event_true = true;
			this.run_actions_and_subevents();
		}
		this.end_run(evinfo);
	};
	EventBlock.prototype.end_run = function (evinfo)
	{
		if (evinfo.last_event_true && this.has_else_block)
			evinfo.else_branch_ran = true;
		if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
			this.runtime.ClearDeathRow();
	};
	EventBlock.prototype.run_orblocktrigger = function (index)
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		if (this.conditions[index].run())
		{
			this.run_actions_and_subevents();
			this.runtime.getCurrentEventStack().last_event_true = true;
		}
	};
	EventBlock.prototype.run_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (evinfo.actindex = 0, len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.resume_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.run_subevents = function ()
	{
		if (!this.subevents.length)
			return;
		var i, len, subev, pushpop/*, skipped_pop = false, pop_modifiers = null*/;
		var last = this.subevents.length - 1;
			this.runtime.pushEventStack(this);
		if (this.solWriterAfterCnds)
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				subev = this.subevents[i];
					pushpop = (!this.toplevelgroup || (!this.group && i < last));
					if (pushpop)
						this.runtime.pushCopySol(subev.solModifiers);
				subev.run();
					if (pushpop)
						this.runtime.popSol(subev.solModifiers);
					else
						this.runtime.clearSol(subev.solModifiers);
			}
		}
		else
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				this.subevents[i].run();
			}
		}
			this.runtime.popEventStack();
	};
	EventBlock.prototype.run_pretrigger = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var any_true = false;
		var i, len;
		for (evinfo.cndindex = 0, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
		{
;
			if (this.conditions[evinfo.cndindex].run())
				any_true = true;
			else if (!this.orblock)			// condition failed (let OR blocks run all conditions anyway)
				return false;               // bail out
		}
		return this.orblock ? any_true : true;
	};
	EventBlock.prototype.retrigger = function ()
	{
		this.runtime.execcount++;
		var prevcndindex = this.runtime.getCurrentEventStack().cndindex;
		var len;
		var evinfo = this.runtime.pushEventStack(this);
		if (!this.orblock)
		{
			for (evinfo.cndindex = prevcndindex + 1, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (!this.conditions[evinfo.cndindex].run())    // condition failed
				{
					this.runtime.popEventStack();               // moving up level of recursion
					return false;                               // bail out
				}
			}
		}
		this.run_actions_and_subevents();
		this.runtime.popEventStack();
		return true;		// ran an iteration
	};
	EventBlock.prototype.isFirstConditionOfType = function (cnd)
	{
		var cndindex = cnd.index;
		if (cndindex === 0)
			return true;
		--cndindex;
		for ( ; cndindex >= 0; --cndindex)
		{
			if (this.conditions[cndindex].type === cnd.type)
				return false;
		}
		return true;
	};
	cr.eventblock = EventBlock;
	function Condition(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		this.trigger = (m[3] > 0);
		this.fasttrigger = (m[3] === 2);
		this.looping = m[4];
		this.inverted = m[5];
		this.isstatic = m[6];
		this.sid = m[7];
		this.runtime.cndsBySid[this.sid.toString()] = this;
		if (m[0] === -1)		// system object
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			if (this.isstatic)
				this.run = this.run_static;
			else
				this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
			if (this.block.parent)
				this.block.parent.setSolWriterAfterCnds();
		}
		if (this.fasttrigger)
			this.run = this.run_true;
		if (m.length === 10)
		{
			var i, len;
			var em = m[9];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Condition.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	/*
	Condition.prototype.is_logical = function ()
	{
		return !this.type || this.type.plugin.singleglobal;
	};
	*/
	Condition.prototype.run_true = function ()
	{
		return true;
	};
	Condition.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return cr.xor(this.func.apply(this.runtime.system, this.results), this.inverted);
	};
	Condition.prototype.run_static = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		var ret = this.func.apply(this.behaviortype ? this.behaviortype : this.type, this.results);
		this.type.applySolToContainer();
		return ret;
	};
	Condition.prototype.run_object = function ()
	{
		var i, j, k, leni, lenj, p, ret, met, inst, s, sol2;
		var type = this.type;
		var sol = type.getCurrentSol();
		var is_orblock = this.block.orblock && !this.trigger;		// triggers in OR blocks need to work normally
		var offset = 0;
		var is_contained = type.is_contained;
		var is_family = type.is_family;
		var family_index = type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var inverted = this.inverted;
		var func = this.func;
		var arr, container;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		if (sol.select_all) {
			sol.instances.length = 0;       // clear contents
			sol.else_instances.length = 0;
			arr = type.instances;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				met = cr.xor(ret, inverted);
				if (met)
					sol.instances.push(inst);
				else if (is_orblock)					// in OR blocks, keep the instances not meeting the condition for subsequent testing
					sol.else_instances.push(inst);
			}
			if (type.finish)
				type.finish(true);
			sol.select_all = false;
			type.applySolToContainer();
			return sol.hasObjects();
		}
		else {
			k = 0;
			var using_else_instances = (is_orblock && !this.block.isFirstConditionOfType(this));
			arr = (using_else_instances ? sol.else_instances : sol.instances);
			var any_true = false;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				if (cr.xor(ret, inverted))
				{
					any_true = true;
					if (using_else_instances)
					{
						sol.instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances.push(s);
							}
						}
					}
					else
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances[k] = s;
							}
						}
						k++;
					}
				}
				else
				{
					if (using_else_instances)
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances[k] = s;
							}
						}
						k++;
					}
					else if (is_orblock)
					{
						sol.else_instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances.push(s);
							}
						}
					}
				}
			}
			arr.length = k;
			if (is_contained)
			{
				container = type.container;
				for (i = 0, leni = container.length; i < leni; i++)
				{
					sol2 = container[i].getCurrentSol();
					if (using_else_instances)
						sol2.else_instances.length = k;
					else
						sol2.instances.length = k;
				}
			}
			var pick_in_finish = any_true;		// don't pick in finish() if we're only doing the logic test below
			if (using_else_instances && !any_true)
			{
				for (i = 0, leni = sol.instances.length; i < leni; i++)
				{
					inst = sol.instances[i];
					if (params_vary)
					{
						for (j = 0, lenj = parameters.length; j < lenj; j++)
						{
							p = parameters[j];
							if (p.variesPerInstance)
								results[j] = p.get(i);
						}
					}
					if (is_beh)
						ret = func.apply(inst.behavior_insts[beh_index], results);
					else
						ret = func.apply(inst, results);
					if (cr.xor(ret, inverted))
					{
						any_true = true;
						break;		// got our flag, don't need to test any more
					}
				}
			}
			if (type.finish)
				type.finish(pick_in_finish || is_orblock);
			return is_orblock ? any_true : sol.hasObjects();
		}
	};
	cr.condition = Condition;
	function Action(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		if (m[0] === -1)	// system
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
		}
		this.sid = m[3];
		this.runtime.actsBySid[this.sid.toString()] = this;
		if (m.length === 6)
		{
			var i, len;
			var em = m[5];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Action.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	Action.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return this.func.apply(this.runtime.system, this.results);
	};
	Action.prototype.run_object = function ()
	{
		var instances = this.type.getCurrentSol().getObjects();
		var is_family = this.type.is_family;
		var family_index = this.type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var func = this.func;
		var i, j, leni, lenj, p, inst, offset;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		for (i = 0, leni = instances.length; i < leni; ++i)
		{
			inst = instances[i];
			if (params_vary)
			{
				for (j = 0, lenj = parameters.length; j < lenj; ++j)
				{
					p = parameters[j];
					if (p.variesPerInstance)
						results[j] = p.get(i);    // pass i to use as default SOL index
				}
			}
			if (is_beh)
			{
				offset = 0;
				if (is_family)
				{
					offset = inst.type.family_beh_map[family_index];
				}
				func.apply(inst.behavior_insts[beh_index + offset], results);
			}
			else
				func.apply(inst, results);
		}
		return false;
	};
	cr.action = Action;
	var tempValues = [];
	var tempValuesPtr = -1;
	function Parameter(owner, m)
	{
		this.owner = owner;
		this.block = owner.block;
		this.sheet = owner.sheet;
		this.runtime = owner.runtime;
		this.type = m[0];
		this.expression = null;
		this.solindex = 0;
		this.get = null;
		this.combosel = 0;
		this.layout = null;
		this.key = 0;
		this.object = null;
		this.index = 0;
		this.varname = null;
		this.eventvar = null;
		this.fileinfo = null;
		this.subparams = null;
		this.variadicret = null;
		this.subparams = null;
		this.variadicret = null;
		this.variesPerInstance = false;
		var i, len, param;
		switch (m[0])
		{
			case 0:		// number
			case 7:		// any
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp;
				break;
			case 1:		// string
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp_str;
				break;
			case 5:		// layer
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_layer;
				break;
			case 3:		// combo
			case 8:		// cmp
				this.combosel = m[1];
				this.get = this.get_combosel;
				break;
			case 6:		// layout
				this.layout = this.runtime.layouts[m[1]];
;
				this.get = this.get_layout;
				break;
			case 9:		// keyb
				this.key = m[1];
				this.get = this.get_key;
				break;
			case 4:		// object
				this.object = this.runtime.types_by_index[m[1]];
;
				this.get = this.get_object;
				this.block.addSolModifier(this.object);
				if (this.owner instanceof cr.action)
					this.block.setSolWriterAfterCnds();
				else if (this.block.parent)
					this.block.parent.setSolWriterAfterCnds();
				break;
			case 10:	// instvar
				this.index = m[1];
				if (owner.type.is_family)
				{
					this.get = this.get_familyvar;
					this.variesPerInstance = true;
				}
				else
					this.get = this.get_instvar;
				break;
			case 11:	// eventvar
				this.varname = m[1];
				this.eventvar = null;
				this.get = this.get_eventvar;
				break;
			case 2:		// audiofile	["name", ismusic]
			case 12:	// fileinfo		"name"
				this.fileinfo = m[1];
				this.get = this.get_audiofile;
				break;
			case 13:	// variadic
				this.get = this.get_variadic;
				this.subparams = [];
				this.variadicret = [];
				for (i = 1, len = m.length; i < len; i++)
				{
					param = new cr.parameter(this.owner, m[i]);
					cr.seal(param);
					this.subparams.push(param);
					this.variadicret.push(0);
				}
				break;
			default:
;
		}
	};
	Parameter.prototype.postInit = function ()
	{
		var i, len;
		if (this.type === 11)		// eventvar
		{
			this.eventvar = this.runtime.getEventVariableByName(this.varname, this.block.parent);
;
		}
		else if (this.type === 13)	// variadic, postInit all sub-params
		{
			for (i = 0, len = this.subparams.length; i < len; i++)
				this.subparams[i].postInit();
		}
		if (this.expression)
			this.expression.postInit();
	};
	Parameter.prototype.maybeVaryForType = function (t)
	{
		if (this.variesPerInstance)
			return;				// already varies per instance, no need to check again
		if (!t)
			return;				// never vary for system type
		if (!t.plugin.singleglobal)
		{
			this.variesPerInstance = true;
			return;
		}
	};
	Parameter.prototype.setVaries = function ()
	{
		this.variesPerInstance = true;
	};
	Parameter.prototype.pushTempValue = function ()
	{
		tempValuesPtr++;
		if (tempValues.length === tempValuesPtr)
			tempValues.push(new cr.expvalue());
		return tempValues[tempValuesPtr];
	};
	Parameter.prototype.popTempValue = function ()
	{
		tempValuesPtr--;
	};
	Parameter.prototype.get_exp = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		return temp.data;      			// return actual JS value, not expvalue
	};
	Parameter.prototype.get_exp_str = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (cr.is_string(temp.data))
			return temp.data;
		else
			return "";
	};
	Parameter.prototype.get_object = function ()
	{
		return this.object;
	};
	Parameter.prototype.get_combosel = function ()
	{
		return this.combosel;
	};
	Parameter.prototype.get_layer = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (temp.is_number())
			return this.runtime.getLayerByNumber(temp.data);
		else
			return this.runtime.getLayerByName(temp.data);
	}
	Parameter.prototype.get_layout = function ()
	{
		return this.layout;
	};
	Parameter.prototype.get_key = function ()
	{
		return this.key;
	};
	Parameter.prototype.get_instvar = function ()
	{
		return this.index;
	};
	Parameter.prototype.get_familyvar = function (solindex_)
	{
		var solindex = solindex_ || 0;
		var familytype = this.owner.type;
		var realtype = null;
		var sol = familytype.getCurrentSol();
		var objs = sol.getObjects();
		if (objs.length)
			realtype = objs[solindex % objs.length].type;
		else if (sol.else_instances.length)
			realtype = sol.else_instances[solindex % sol.else_instances.length].type;
		else if (familytype.instances.length)
			realtype = familytype.instances[solindex % familytype.instances.length].type;
		else
			return 0;
		return this.index + realtype.family_var_map[familytype.family_index];
	};
	Parameter.prototype.get_eventvar = function ()
	{
		return this.eventvar;
	};
	Parameter.prototype.get_audiofile = function ()
	{
		return this.fileinfo;
	};
	Parameter.prototype.get_variadic = function ()
	{
		var i, len;
		for (i = 0, len = this.subparams.length; i < len; i++)
		{
			this.variadicret[i] = this.subparams[i].get();
		}
		return this.variadicret;
	};
	cr.parameter = Parameter;
	function EventVariable(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.name = m[1];
		this.vartype = m[2];
		this.initial = m[3];
		this.is_static = !!m[4];
		this.is_constant = !!m[5];
		this.sid = m[6];
		this.runtime.varsBySid[this.sid.toString()] = this;
		this.data = this.initial;	// note: also stored in event stack frame for local nonstatic nonconst vars
		if (this.parent)			// local var
		{
			if (this.is_static || this.is_constant)
				this.localIndex = -1;
			else
				this.localIndex = this.runtime.stackLocalCount++;
			this.runtime.all_local_vars.push(this);
		}
		else						// global var
		{
			this.localIndex = -1;
			this.runtime.all_global_vars.push(this);
		}
	};
	EventVariable.prototype.postInit = function ()
	{
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventVariable.prototype.setValue = function (x)
	{
;
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs)
			this.data = x;
		else	// local nonstatic variable: use event stack to keep value at this level of recursion
		{
			if (this.localIndex >= lvs.length)
				lvs.length = this.localIndex + 1;
			lvs[this.localIndex] = x;
		}
	};
	EventVariable.prototype.getValue = function ()
	{
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs || this.is_constant)
			return this.data;
		else	// local nonstatic variable
		{
			if (this.localIndex >= lvs.length)
			{
;
				return this.initial;
			}
			if (typeof lvs[this.localIndex] === "undefined")
			{
;
				return this.initial;
			}
			return lvs[this.localIndex];
		}
	};
	EventVariable.prototype.run = function ()
	{
			if (this.parent && !this.is_static && !this.is_constant)
				this.setValue(this.initial);
	};
	cr.eventvariable = EventVariable;
	function EventInclude(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.include_sheet = null;		// determined in postInit
		this.include_sheet_name = m[1];
		this.active = true;
	};
	EventInclude.prototype.toString = function ()
	{
		return "include:" + this.include_sheet.toString();
	};
	EventInclude.prototype.postInit = function ()
	{
        this.include_sheet = this.runtime.eventsheets[this.include_sheet_name];
;
;
        this.sheet.includes.add(this);
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		var p = this.parent;
		while (p)
		{
			if (p.group)
				p.contained_includes.push(this);
			p = p.parent;
		}
		this.updateActive();
	};
	EventInclude.prototype.run = function ()
	{
			if (this.parent)
				this.runtime.pushCleanSol(this.runtime.types_by_index);
        if (!this.include_sheet.hasRun)
            this.include_sheet.run(true);			// from include
			if (this.parent)
				this.runtime.popSol(this.runtime.types_by_index);
	};
	EventInclude.prototype.updateActive = function ()
	{
		var p = this.parent;
		while (p)
		{
			if (p.group && !p.group_active)
			{
				this.active = false;
				return;
			}
			p = p.parent;
		}
		this.active = true;
	};
	EventInclude.prototype.isActive = function ()
	{
		return this.active;
	};
	cr.eventinclude = EventInclude;
	function EventStackFrame()
	{
		this.temp_parents_arr = [];
		this.reset(null);
		cr.seal(this);
	};
	EventStackFrame.prototype.reset = function (cur_event)
	{
		this.current_event = cur_event;
		this.cndindex = 0;
		this.actindex = 0;
		this.temp_parents_arr.length = 0;
		this.last_event_true = false;
		this.else_branch_ran = false;
		this.any_true_state = false;
	};
	EventStackFrame.prototype.isModifierAfterCnds = function ()
	{
		if (this.current_event.solWriterAfterCnds)
			return true;
		if (this.cndindex < this.current_event.conditions.length - 1)
			return !!this.current_event.solModifiers.length;
		return false;
	};
	cr.eventStackFrame = EventStackFrame;
}());
(function()
{
	function ExpNode(owner_, m)
	{
		this.owner = owner_;
		this.runtime = owner_.runtime;
		this.type = m[0];
;
		this.get = [this.eval_int,
					this.eval_float,
					this.eval_string,
					this.eval_unaryminus,
					this.eval_add,
					this.eval_subtract,
					this.eval_multiply,
					this.eval_divide,
					this.eval_mod,
					this.eval_power,
					this.eval_and,
					this.eval_or,
					this.eval_equal,
					this.eval_notequal,
					this.eval_less,
					this.eval_lessequal,
					this.eval_greater,
					this.eval_greaterequal,
					this.eval_conditional,
					this.eval_system_exp,
					this.eval_object_behavior_exp,
					this.eval_instvar_exp,
					this.eval_object_behavior_exp,
					this.eval_eventvar_exp][this.type];
		var paramsModel = null;
		this.value = null;
		this.first = null;
		this.second = null;
		this.third = null;
		this.func = null;
		this.results = null;
		this.parameters = null;
		this.object_type = null;
		this.beh_index = -1;
		this.instance_expr = null;
		this.varindex = -1;
		this.behavior_type = null;
		this.varname = null;
		this.eventvar = null;
		this.return_string = false;
		switch (this.type) {
		case 0:		// int
		case 1:		// float
		case 2:		// string
			this.value = m[1];
			break;
		case 3:		// unaryminus
			this.first = new cr.expNode(owner_, m[1]);
			break;
		case 18:	// conditional
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
			this.third = new cr.expNode(owner_, m[3]);
			break;
		case 19:	// system_exp
			this.func = m[1];
;
			if (this.func === cr.system_object.prototype.exps.random
			 || this.func === cr.system_object.prototype.exps.choose)
			{
				this.owner.setVaries();
			}
			this.results = [];
			this.parameters = [];
			if (m.length === 3)
			{
				paramsModel = m[2];
				this.results.length = paramsModel.length + 1;	// must also fit 'ret'
			}
			else
				this.results.length = 1;      // to fit 'ret'
			break;
		case 20:	// object_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.beh_index = -1;
			this.func = m[2];
			this.return_string = m[3];
			if (cr.plugins_.Function && this.func === cr.plugins_.Function.prototype.exps.Call)
			{
				this.owner.setVaries();
			}
			if (m[4])
				this.instance_expr = new cr.expNode(owner_, m[4]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 6)
			{
				paramsModel = m[5];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 21:		// instvar_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.return_string = m[2];
			if (m[3])
				this.instance_expr = new cr.expNode(owner_, m[3]);
			else
				this.instance_expr = null;
			this.varindex = m[4];
			break;
		case 22:		// behavior_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.behavior_type = this.object_type.getBehaviorByName(m[2]);
;
			this.beh_index = this.object_type.getBehaviorIndexByName(m[2]);
			this.func = m[3];
			this.return_string = m[4];
			if (m[5])
				this.instance_expr = new cr.expNode(owner_, m[5]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 7)
			{
				paramsModel = m[6];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 23:		// eventvar_exp
			this.varname = m[1];
			this.eventvar = null;	// assigned in postInit
			break;
		}
		this.owner.maybeVaryForType(this.object_type);
		if (this.type >= 4 && this.type <= 17)
		{
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
		}
		if (paramsModel)
		{
			var i, len;
			for (i = 0, len = paramsModel.length; i < len; i++)
				this.parameters.push(new cr.expNode(owner_, paramsModel[i]));
		}
		cr.seal(this);
	};
	ExpNode.prototype.postInit = function ()
	{
		if (this.type === 23)	// eventvar_exp
		{
			this.eventvar = this.owner.runtime.getEventVariableByName(this.varname, this.owner.block.parent);
;
		}
		if (this.first)
			this.first.postInit();
		if (this.second)
			this.second.postInit();
		if (this.third)
			this.third.postInit();
		if (this.instance_expr)
			this.instance_expr.postInit();
		if (this.parameters)
		{
			var i, len;
			for (i = 0, len = this.parameters.length; i < len; i++)
				this.parameters[i].postInit();
		}
	};
	ExpNode.prototype.eval_system_exp = function (ret)
	{
		this.results[0] = ret;
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		this.owner.popTempValue();
		this.func.apply(this.runtime.system, this.results);
	};
	ExpNode.prototype.eval_object_behavior_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		this.results[0] = ret;
		ret.object_class = this.object_type;		// so expression can access family type if need be
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++) {
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		var index = this.owner.solindex;
		if (this.instance_expr) {
			this.instance_expr.get(temp);
			if (temp.is_number()) {
				index = temp.data;
				instances = this.object_type.instances;    // pick from all instances, not SOL
			}
		}
		this.owner.popTempValue();
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var returned_val;
		var inst = instances[index];
		if (this.beh_index > -1)
		{
			var offset = 0;
			if (this.object_type.is_family)
			{
				offset = inst.type.family_beh_map[this.object_type.family_index];
			}
			returned_val = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
		}
		else
			returned_val = this.func.apply(inst, this.results);
;
	};
	ExpNode.prototype.eval_instvar_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		var index = this.owner.solindex;
		if (this.instance_expr)
		{
			var temp = this.owner.pushTempValue();
			this.instance_expr.get(temp);
			if (temp.is_number())
			{
				index = temp.data;
				var type_instances = this.object_type.instances;
				index %= type_instances.length;     // wraparound
				if (index < 0)                      // offset
					index += type_instances.length;
				var to_ret = type_instances[index].instance_vars[this.varindex];
				if (cr.is_string(to_ret))
					ret.set_string(to_ret);
				else
					ret.set_float(to_ret);
				this.owner.popTempValue();
				return;         // done
			}
			this.owner.popTempValue();
		}
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var inst = instances[index];
		var offset = 0;
		if (this.object_type.is_family)
		{
			offset = inst.type.family_var_map[this.object_type.family_index];
		}
		var to_ret = inst.instance_vars[this.varindex + offset];
		if (cr.is_string(to_ret))
			ret.set_string(to_ret);
		else
			ret.set_float(to_ret);
	};
	ExpNode.prototype.eval_int = function (ret)
	{
		ret.type = cr.exptype.Integer;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_float = function (ret)
	{
		ret.type = cr.exptype.Float;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_string = function (ret)
	{
		ret.type = cr.exptype.String;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_unaryminus = function (ret)
	{
		this.first.get(ret);                // retrieve operand
		if (ret.is_number())
			ret.data = -ret.data;
	};
	ExpNode.prototype.eval_add = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data += temp.data;          // both operands numbers: add
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_subtract = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data -= temp.data;          // both operands numbers: subtract
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_multiply = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data *= temp.data;          // both operands numbers: multiply
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_divide = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data /= temp.data;          // both operands numbers: divide
			ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_mod = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data %= temp.data;          // both operands numbers: modulo
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_power = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data = Math.pow(ret.data, temp.data);   // both operands numbers: raise to power
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_and = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number())
		{
			if (temp.is_string())
			{
				ret.set_string(ret.data.toString() + temp.data);
			}
			else
			{
				if (ret.data && temp.data)
					ret.set_int(1);
				else
					ret.set_int(0);
			}
		}
		else if (ret.is_string())
		{
			if (temp.is_string())
				ret.data += temp.data;
			else
			{
				ret.data += (Math.round(temp.data * 1e10) / 1e10).toString();
			}
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_or = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			if (ret.data || temp.data)
				ret.set_int(1);
			else
				ret.set_int(0);
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_conditional = function (ret)
	{
		this.first.get(ret);                // condition operand
		if (ret.data)                       // is true
			this.second.get(ret);           // evaluate second operand to ret
		else
			this.third.get(ret);            // evaluate third operand to ret
	};
	ExpNode.prototype.eval_equal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data === temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_notequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data !== temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_less = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data < temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_lessequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data <= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greater = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data > temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greaterequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data >= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_eventvar_exp = function (ret)
	{
		var val = this.eventvar.getValue();
		if (cr.is_number(val))
			ret.set_float(val);
		else
			ret.set_string(val);
	};
	cr.expNode = ExpNode;
	function ExpValue(type, data)
	{
		this.type = type || cr.exptype.Integer;
		this.data = data || 0;
		this.object_class = null;
;
;
;
		if (this.type == cr.exptype.Integer)
			this.data = Math.floor(this.data);
		cr.seal(this);
	};
	ExpValue.prototype.is_int = function ()
	{
		return this.type === cr.exptype.Integer;
	};
	ExpValue.prototype.is_float = function ()
	{
		return this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_number = function ()
	{
		return this.type === cr.exptype.Integer || this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_string = function ()
	{
		return this.type === cr.exptype.String;
	};
	ExpValue.prototype.make_int = function ()
	{
		if (!this.is_int())
		{
			if (this.is_float())
				this.data = Math.floor(this.data);      // truncate float
			else if (this.is_string())
				this.data = parseInt(this.data, 10);
			this.type = cr.exptype.Integer;
		}
	};
	ExpValue.prototype.make_float = function ()
	{
		if (!this.is_float())
		{
			if (this.is_string())
				this.data = parseFloat(this.data);
			this.type = cr.exptype.Float;
		}
	};
	ExpValue.prototype.make_string = function ()
	{
		if (!this.is_string())
		{
			this.data = this.data.toString();
			this.type = cr.exptype.String;
		}
	};
	ExpValue.prototype.set_int = function (val)
	{
;
		this.type = cr.exptype.Integer;
		this.data = Math.floor(val);
	};
	ExpValue.prototype.set_float = function (val)
	{
;
		this.type = cr.exptype.Float;
		this.data = val;
	};
	ExpValue.prototype.set_string = function (val)
	{
;
		this.type = cr.exptype.String;
		this.data = val;
	};
	ExpValue.prototype.set_any = function (val)
	{
		if (cr.is_number(val))
		{
			this.type = cr.exptype.Float;
			this.data = val;
		}
		else if (cr.is_string(val))
		{
			this.type = cr.exptype.String;
			this.data = val.toString();
		}
		else
		{
			this.type = cr.exptype.Integer;
			this.data = 0;
		}
	};
	cr.expvalue = ExpValue;
	cr.exptype = {
		Integer: 0,     // emulated; no native integer support in javascript
		Float: 1,
		String: 2
	};
}());
;
cr.system_object = function (runtime)
{
    this.runtime = runtime;
	this.waits = [];
};
cr.system_object.prototype.saveToJSON = function ()
{
	var o = {};
	var i, len, j, lenj, p, w, t, sobj;
	o["waits"] = [];
	var owaits = o["waits"];
	var waitobj;
	for (i = 0, len = this.waits.length; i < len; i++)
	{
		w = this.waits[i];
		waitobj = {
			"t": w.time,
			"st": w.signaltag,
			"s": w.signalled,
			"ev": w.ev.sid,
			"sm": [],
			"sols": {}
		};
		if (w.ev.actions[w.actindex])
			waitobj["act"] = w.ev.actions[w.actindex].sid;
		for (j = 0, lenj = w.solModifiers.length; j < lenj; j++)
			waitobj["sm"].push(w.solModifiers[j].sid);
		for (p in w.sols)
		{
			if (w.sols.hasOwnProperty(p))
			{
				t = this.runtime.types_by_index[parseInt(p, 10)];
;
				sobj = {
					"sa": w.sols[p].sa,
					"insts": []
				};
				for (j = 0, lenj = w.sols[p].insts.length; j < lenj; j++)
					sobj["insts"].push(w.sols[p].insts[j].uid);
				waitobj["sols"][t.sid.toString()] = sobj;
			}
		}
		owaits.push(waitobj);
	}
	return o;
};
cr.system_object.prototype.loadFromJSON = function (o)
{
	var owaits = o["waits"];
	var i, len, j, lenj, p, w, addWait, e, aindex, t, savedsol, nusol, inst;
	this.waits.length = 0;
	for (i = 0, len = owaits.length; i < len; i++)
	{
		w = owaits[i];
		e = this.runtime.blocksBySid[w["ev"].toString()];
		if (!e)
			continue;	// event must've gone missing
		aindex = -1;
		for (j = 0, lenj = e.actions.length; j < lenj; j++)
		{
			if (e.actions[j].sid === w["act"])
			{
				aindex = j;
				break;
			}
		}
		if (aindex === -1)
			continue;	// action must've gone missing
		addWait = {};
		addWait.sols = {};
		addWait.solModifiers = [];
		addWait.deleteme = false;
		addWait.time = w["t"];
		addWait.signaltag = w["st"] || "";
		addWait.signalled = !!w["s"];
		addWait.ev = e;
		addWait.actindex = aindex;
		for (j = 0, lenj = w["sm"].length; j < lenj; j++)
		{
			t = this.runtime.getObjectTypeBySid(w["sm"][j]);
			if (t)
				addWait.solModifiers.push(t);
		}
		for (p in w["sols"])
		{
			if (w["sols"].hasOwnProperty(p))
			{
				t = this.runtime.getObjectTypeBySid(parseInt(p, 10));
				if (!t)
					continue;		// type must've been deleted
				savedsol = w["sols"][p];
				nusol = {
					sa: savedsol["sa"],
					insts: []
				};
				for (j = 0, lenj = savedsol["insts"].length; j < lenj; j++)
				{
					inst = this.runtime.getObjectByUID(savedsol["insts"][j]);
					if (inst)
						nusol.insts.push(inst);
				}
				addWait.sols[t.index.toString()] = nusol;
			}
		}
		this.waits.push(addWait);
	}
};
(function ()
{
	var sysProto = cr.system_object.prototype;
	function SysCnds() {};
    SysCnds.prototype.EveryTick = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutStart = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutEnd = function()
    {
        return true;
    };
    SysCnds.prototype.Compare = function(x, cmp, y)
    {
        return cr.do_cmp(x, cmp, y);
    };
    SysCnds.prototype.CompareTime = function (cmp, t)
    {
        var elapsed = this.runtime.kahanTime.sum;
        if (cmp === 0)
        {
            var cnd = this.runtime.getCurrentCondition();
            if (!cnd.extra["CompareTime_executed"])
            {
                if (elapsed >= t)
                {
                    cnd.extra["CompareTime_executed"] = true;
                    return true;
                }
            }
            return false;
        }
        return cr.do_cmp(elapsed, cmp, t);
    };
    SysCnds.prototype.LayerVisible = function (layer)
    {
        if (!layer)
            return false;
        else
            return layer.visible;
    };
	SysCnds.prototype.LayerCmpOpacity = function (layer, cmp, opacity_)
	{
		if (!layer)
			return false;
		return cr.do_cmp(layer.opacity * 100, cmp, opacity_);
	};
    SysCnds.prototype.Repeat = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				current_loop.index = i;
				current_event.retrigger();
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	SysCnds.prototype.While = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				if (!current_event.retrigger())		// one of the other conditions returned false
					current_loop.stopped = true;	// break
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				current_loop.index = i;
				if (!current_event.retrigger())
					current_loop.stopped = true;
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
    SysCnds.prototype.For = function (name, start, end)
    {
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack(name);
        var i;
		if (end < start)
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
		else
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	var foreach_instancestack = [];
	var foreach_instanceptr = -1;
    SysCnds.prototype.ForEach = function (obj)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i, len, j, lenj, inst, s, sol2;
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	function foreach_sortinstances(a, b)
	{
		var va = a.extra["c2_feo_val"];
		var vb = b.extra["c2_feo_val"];
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			va = "" + va;
			vb = "" + vb;
			if (va < vb)
				return -1;
			else if (va > vb)
				return 1;
			else
				return 0;
		}
	};
	SysCnds.prototype.ForEachOrdered = function (obj, exp, order)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var current_condition = this.runtime.getCurrentCondition();
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
		var i, len, j, lenj, inst, s, sol2;
		for (i = 0, len = instances.length; i < len; i++)
		{
			instances[i].extra["c2_feo_val"] = current_condition.parameters[1].get(i);
		}
		instances.sort(foreach_sortinstances);
		if (order === 1)
			instances.reverse();
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	SysCnds.prototype.PickByComparison = function (obj_, exp_, cmp_, val_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			val_ = current_condition.parameters[3].get(i);
			if (cr.do_cmp(exp_, cmp_, val_))
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
	SysCnds.prototype.PickByEvaluate = function (obj_, exp_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			if (exp_)
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
    SysCnds.prototype.TriggerOnce = function ()
    {
        var cndextra = this.runtime.getCurrentCondition().extra;
		if (typeof cndextra["TriggerOnce_lastTick"] === "undefined")
			cndextra["TriggerOnce_lastTick"] = -1;
        var last_tick = cndextra["TriggerOnce_lastTick"];
        var cur_tick = this.runtime.tickcount;
        cndextra["TriggerOnce_lastTick"] = cur_tick;
        return this.runtime.layout_first_tick || last_tick !== cur_tick - 1;
    };
    SysCnds.prototype.Every = function (seconds)
    {
        var cnd = this.runtime.getCurrentCondition();
        var last_time = cnd.extra["Every_lastTime"] || 0;
        var cur_time = this.runtime.kahanTime.sum;
		if (typeof cnd.extra["Every_seconds"] === "undefined")
			cnd.extra["Every_seconds"] = seconds;
		var this_seconds = cnd.extra["Every_seconds"];
        if (cur_time >= last_time + this_seconds)
        {
            cnd.extra["Every_lastTime"] = last_time + this_seconds;
			if (cur_time >= cnd.extra["Every_lastTime"] + 0.04)
			{
				cnd.extra["Every_lastTime"] = cur_time;
			}
			cnd.extra["Every_seconds"] = seconds;
            return true;
        }
		else if (cur_time < last_time - 0.1)
		{
			cnd.extra["Every_lastTime"] = cur_time;
		}
		return false;
    };
    SysCnds.prototype.PickNth = function (obj, index)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		index = cr.floor(index);
        if (index < 0 || index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.PickRandom = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		var index = cr.floor(Math.random() * instances.length);
        if (index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.CompareVar = function (v, cmp, val)
    {
        return cr.do_cmp(v.getValue(), cmp, val);
    };
    SysCnds.prototype.IsGroupActive = function (group)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
        return g && g.group_active;
    };
	SysCnds.prototype.IsPreview = function ()
	{
		return typeof cr_is_preview !== "undefined";
	};
	SysCnds.prototype.PickAll = function (obj)
    {
        if (!obj)
            return false;
		if (!obj.instances.length)
			return false;
        var sol = obj.getCurrentSol();
        sol.select_all = true;
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.IsMobile = function ()
	{
		return this.runtime.isMobile;
	};
	SysCnds.prototype.CompareBetween = function (x, a, b)
	{
		return x >= a && x <= b;
	};
	SysCnds.prototype.Else = function ()
	{
		var current_frame = this.runtime.getCurrentEventStack();
		if (current_frame.else_branch_ran)
			return false;		// another event in this else-if chain has run
		else
			return !current_frame.last_event_true;
		/*
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var prev_event = current_event.prev_block;
		if (!prev_event)
			return false;
		if (prev_event.is_logical)
			return !this.runtime.last_event_true;
		var i, len, j, lenj, s, sol, temp, inst, any_picked = false;
		for (i = 0, len = prev_event.cndReferences.length; i < len; i++)
		{
			s = prev_event.cndReferences[i];
			sol = s.getCurrentSol();
			if (sol.select_all || sol.instances.length === s.instances.length)
			{
				sol.select_all = false;
				sol.instances.length = 0;
			}
			else
			{
				if (sol.instances.length === 1 && sol.else_instances.length === 0 && s.instances.length >= 2)
				{
					inst = sol.instances[0];
					sol.instances.length = 0;
					for (j = 0, lenj = s.instances.length; j < lenj; j++)
					{
						if (s.instances[j] != inst)
							sol.instances.push(s.instances[j]);
					}
					any_picked = true;
				}
				else
				{
					temp = sol.instances;
					sol.instances = sol.else_instances;
					sol.else_instances = temp;
					any_picked = true;
				}
			}
		}
		return any_picked;
		*/
	};
	SysCnds.prototype.OnLoadFinished = function ()
	{
		return true;
	};
	SysCnds.prototype.OnCanvasSnapshot = function ()
	{
		return true;
	};
	SysCnds.prototype.EffectsSupported = function ()
	{
		return !!this.runtime.glwrap;
	};
	SysCnds.prototype.OnSaveComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadFailed = function ()
	{
		return true;
	};
	SysCnds.prototype.ObjectUIDExists = function (u)
	{
		return !!this.runtime.getObjectByUID(u);
	};
	SysCnds.prototype.IsOnPlatform = function (p)
	{
		var rt = this.runtime;
		switch (p) {
		case 0:		// HTML5 website
			return !rt.isDomFree && !rt.isNodeWebkit && !rt.isPhoneGap && !rt.isCrosswalk && !rt.isWinJS && !rt.isWindowsPhone8 && !rt.isBlackberry10 && !rt.isAmazonWebApp;
		case 1:		// iOS
			return rt.isiOS;
		case 2:		// Android
			return rt.isAndroid;
		case 3:		// Windows 8
			return rt.isWindows8App;
		case 4:		// Windows Phone 8
			return rt.isWindowsPhone8;
		case 5:		// Blackberry 10
			return rt.isBlackberry10;
		case 6:		// Tizen
			return rt.isTizen;
		case 7:		// CocoonJS
			return rt.isCocoonJs;
		case 8:		// PhoneGap
			return rt.isPhoneGap;
		case 9:	// Scirra Arcade
			return rt.isArcade;
		case 10:	// node-webkit
			return rt.isNodeWebkit;
		case 11:	// crosswalk
			return rt.isCrosswalk;
		case 12:	// amazon webapp
			return rt.isAmazonWebApp;
		default:	// should not be possible
			return false;
		}
	};
	var cacheRegex = null;
	var lastRegex = "";
	var lastFlags = "";
	function getRegex(regex_, flags_)
	{
		if (!cacheRegex || regex_ !== lastRegex || flags_ !== lastFlags)
		{
			cacheRegex = new RegExp(regex_, flags_);
			lastRegex = regex_;
			lastFlags = flags_;
		}
		cacheRegex.lastIndex = 0;		// reset
		return cacheRegex;
	};
	SysCnds.prototype.RegexTest = function (str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		return regex.test(str_);
	};
	var tmp_arr = [];
	SysCnds.prototype.PickOverlappingPoint = function (obj_, x_, y_)
	{
		if (!obj_)
            return false;
        var sol = obj_.getCurrentSol();
        var instances = sol.getObjects();
		var current_event = this.runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		var cnd = this.runtime.getCurrentCondition();
		var i, len, inst, pick;
		if (sol.select_all)
		{
			cr.shallowAssignArray(tmp_arr, instances);
			sol.else_instances.length = 0;
			sol.select_all = false;
			sol.instances.length = 0;
		}
		else
		{
			if (orblock)
			{
				cr.shallowAssignArray(tmp_arr, sol.else_instances);
				sol.else_instances.length = 0;
			}
			else
			{
				cr.shallowAssignArray(tmp_arr, instances);
				sol.instances.length = 0;
			}
		}
		for (i = 0, len = tmp_arr.length; i < len; ++i)
		{
			inst = tmp_arr[i];
			inst.update_bbox();
			pick = cr.xor(inst.contains_pt(x_, y_), cnd.inverted);
			if (pick)
				sol.instances.push(inst);
			else
				sol.else_instances.push(inst);
		}
		obj_.applySolToContainer();
		return cr.xor(!!sol.instances.length, cnd.inverted);
	};
	sysProto.cnds = new SysCnds();
    function SysActs() {};
    SysActs.prototype.GoToLayout = function (to)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
        this.runtime.changelayout = to;
    };
	SysActs.prototype.NextPrevLayout = function (prev)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
		var index = this.runtime.layouts_by_index.indexOf(this.runtime.running_layout);
		if (prev && index === 0)
			return;		// cannot go to previous layout from first layout
		if (!prev && index === this.runtime.layouts_by_index.length - 1)
			return;		// cannot go to next layout from last layout
		var to = this.runtime.layouts_by_index[index + (prev ? -1 : 1)];
;
        this.runtime.changelayout = to;
    };
    SysActs.prototype.CreateObject = function (obj, layer, x, y)
    {
        if (!layer || !obj)
            return;
        var inst = this.runtime.createInstance(obj, layer, x, y);
		if (!inst)
			return;
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
        var sol = obj.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
    };
    SysActs.prototype.SetLayerVisible = function (layer, visible_)
    {
        if (!layer)
            return;
		if (layer.visible !== visible_)
		{
			layer.visible = visible_;
			this.runtime.redraw = true;
		}
    };
	SysActs.prototype.SetLayerOpacity = function (layer, opacity_)
	{
		if (!layer)
			return;
		opacity_ = cr.clamp(opacity_ / 100, 0, 1);
		if (layer.opacity !== opacity_)
		{
			layer.opacity = opacity_;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayerScaleRate = function (layer, sr)
	{
		if (!layer)
			return;
		if (layer.zoomRate !== sr)
		{
			layer.zoomRate = sr;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayoutScale = function (s)
	{
		if (!this.runtime.running_layout)
			return;
		if (this.runtime.running_layout.scale !== s)
		{
			this.runtime.running_layout.scale = s;
			this.runtime.running_layout.boundScrolling();
			this.runtime.redraw = true;
		}
	};
    SysActs.prototype.ScrollX = function(x)
    {
        this.runtime.running_layout.scrollToX(x);
    };
    SysActs.prototype.ScrollY = function(y)
    {
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.Scroll = function(x, y)
    {
        this.runtime.running_layout.scrollToX(x);
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.ScrollToObject = function(obj)
    {
        var inst = obj.getFirstPicked();
        if (inst)
        {
            this.runtime.running_layout.scrollToX(inst.x);
            this.runtime.running_layout.scrollToY(inst.y);
        }
    };
	SysActs.prototype.SetVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(x);
			else
				v.setValue(parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(x.toString());
	};
	SysActs.prototype.AddVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() + x);
			else
				v.setValue(v.getValue() + parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(v.getValue() + x.toString());
	};
	SysActs.prototype.SubVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() - x);
			else
				v.setValue(v.getValue() - parseFloat(x));
		}
	};
    SysActs.prototype.SetGroupActive = function (group, active)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
		if (!g)
			return;
		switch (active) {
		case 0:
			g.setGroupActive(false);
			break;
		case 1:
			g.setGroupActive(true);
			break;
		case 2:
			g.setGroupActive(!g.group_active);
			break;
		}
    };
    SysActs.prototype.SetTimescale = function (ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        this.runtime.timescale = ts;
    };
    SysActs.prototype.SetObjectTimescale = function (obj, ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        if (!obj)
            return;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = ts;
        }
    };
    SysActs.prototype.RestoreObjectTimescale = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = -1.0;
        }
    };
	var waitobjrecycle = [];
	function allocWaitObject()
	{
		var w;
		if (waitobjrecycle.length)
			w = waitobjrecycle.pop();
		else
		{
			w = {};
			w.sols = {};
			w.solModifiers = [];
		}
		w.deleteme = false;
		return w;
	};
	function freeWaitObject(w)
	{
		cr.wipe(w.sols);
		w.solModifiers.length = 0;
		waitobjrecycle.push(w);
	};
	var solstateobjects = [];
	function allocSolStateObject()
	{
		var s;
		if (solstateobjects.length)
			s = solstateobjects.pop();
		else
		{
			s = {};
			s.insts = [];
		}
		s.sa = false;
		return s;
	};
	function freeSolStateObject(s)
	{
		s.insts.length = 0;
		solstateobjects.push(s);
	};
	SysActs.prototype.Wait = function (seconds)
	{
		if (seconds < 0)
			return;
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = this.runtime.kahanTime.sum + seconds;
		waitobj.signaltag = "";
		waitobj.signalled = false;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.WaitForSignal = function (tag)
	{
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = -1;
		waitobj.signaltag = tag.toLowerCase();
		waitobj.signalled = false;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.Signal = function (tag)
	{
		var lowertag = tag.toLowerCase();
		var i, len, w;
		for (i = 0, len = this.waits.length; i < len; ++i)
		{
			w = this.waits[i];
			if (w.time !== -1)
				continue;					// timer wait, ignore
			if (w.signaltag === lowertag)	// waiting for this signal
				w.signalled = true;			// will run on next check
		}
	};
	SysActs.prototype.SetLayerScale = function (layer, scale)
    {
        if (!layer)
            return;
		if (layer.scale === scale)
			return;
        layer.scale = scale;
        this.runtime.redraw = true;
    };
	SysActs.prototype.ResetGlobals = function ()
	{
		var i, len, g;
		for (i = 0, len = this.runtime.all_global_vars.length; i < len; i++)
		{
			g = this.runtime.all_global_vars[i];
			g.data = g.initial;
		}
	};
	SysActs.prototype.SetLayoutAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.runtime.running_layout)
		{
			if (this.runtime.running_layout.angle !== a)
			{
				this.runtime.running_layout.angle = a;
				this.runtime.redraw = true;
			}
		}
	};
	SysActs.prototype.SetLayerAngle = function (layer, a)
    {
        if (!layer)
            return;
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (layer.angle === a)
			return;
        layer.angle = a;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerParallax = function (layer, px, py)
    {
        if (!layer)
            return;
		if (layer.parallaxX === px / 100 && layer.parallaxY === py / 100)
			return;
        layer.parallaxX = px / 100;
		layer.parallaxY = py / 100;
		if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
		{
			var i, len, instances = layer.instances;
			for (i = 0, len = instances.length; i < len; ++i)
			{
				instances[i].type.any_instance_parallaxed = true;
			}
		}
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerBackground = function (layer, c)
    {
        if (!layer)
            return;
		var r = cr.GetRValue(c);
		var g = cr.GetGValue(c);
		var b = cr.GetBValue(c);
		if (layer.background_color[0] === r && layer.background_color[1] === g && layer.background_color[2] === b)
			return;
        layer.background_color[0] = r;
		layer.background_color[1] = g;
		layer.background_color[2] = b;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerTransparent = function (layer, t)
    {
        if (!layer)
            return;
		if (!!t === !!layer.transparent)
			return;
		layer.transparent = !!t;
        this.runtime.redraw = true;
    };
	SysActs.prototype.StopLoop = function ()
	{
		if (this.runtime.loop_stack_index < 0)
			return;		// no loop currently running
		this.runtime.getCurrentLoop().stopped = true;
	};
	SysActs.prototype.GoToLayoutByName = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to different layout
;
		var l;
		for (l in this.runtime.layouts)
		{
			if (this.runtime.layouts.hasOwnProperty(l) && cr.equals_nocase(l, layoutname))
			{
				this.runtime.changelayout = this.runtime.layouts[l];
				return;
			}
		}
	};
	SysActs.prototype.RestartLayout = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot restart loader layouts
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
		if (!this.runtime.running_layout)
			return;
		this.runtime.changelayout = this.runtime.running_layout;
		var i, len, g;
		for (i = 0, len = this.runtime.allGroups.length; i < len; i++)
		{
			g = this.runtime.allGroups[i];
			g.setGroupActive(g.initially_activated);
		}
	};
	SysActs.prototype.SnapshotCanvas = function (format_, quality_)
	{
		this.runtime.snapshotCanvas = [format_ === 0 ? "image/png" : "image/jpeg", quality_ / 100];
		this.runtime.redraw = true;		// force redraw so snapshot is always taken
	};
	SysActs.prototype.SetCanvasSize = function (w, h)
	{
		if (w <= 0 || h <= 0)
			return;
		var mode = this.runtime.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
		if (isfullscreen && this.runtime.fullscreen_scaling > 0)
			mode = this.runtime.fullscreen_scaling;
		if (mode === 0)
		{
			this.runtime["setSize"](w, h, true);
		}
		else
		{
			this.runtime.original_width = w;
			this.runtime.original_height = h;
			this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
		}
	};
	SysActs.prototype.SetLayoutEffectEnabled = function (enable_, effectname_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		this.runtime.running_layout.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectEnabled = function (layer, enable_, effectname_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		layer.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayoutEffectParam = function (effectname_, index_, value_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = this.runtime.running_layout.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectParam = function (layer, effectname_, index_, value_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = layer.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SaveState = function (slot_)
	{
		this.runtime.saveToSlot = slot_;
	};
	SysActs.prototype.LoadState = function (slot_)
	{
		this.runtime.loadFromSlot = slot_;
	};
	SysActs.prototype.LoadStateJSON = function (jsonstr_)
	{
		this.runtime.loadFromJson = jsonstr_;
	};
	SysActs.prototype.SetHalfFramerateMode = function (set_)
	{
		this.runtime.halfFramerateMode = (set_ !== 0);
	};
	SysActs.prototype.SetFullscreenQuality = function (q)
	{
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.runtime.fullscreen_mode === 0)
			return;
		this.runtime.wantFullscreenScalingQuality = (q !== 0);
		this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
	};
	sysProto.acts = new SysActs();
    function SysExps() {};
    SysExps.prototype["int"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_int(parseInt(x, 10));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_int(x);
    };
    SysExps.prototype["float"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_float(parseFloat(x));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_float(x);
    };
    SysExps.prototype.str = function(ret, x)
    {
        if (cr.is_string(x))
            ret.set_string(x);
        else
            ret.set_string(x.toString());
    };
    SysExps.prototype.len = function(ret, x)
    {
        ret.set_int(x.length || 0);
    };
    SysExps.prototype.random = function (ret, a, b)
    {
        if (b === undefined)
        {
            ret.set_float(Math.random() * a);
        }
        else
        {
            ret.set_float(Math.random() * (b - a) + a);
        }
    };
    SysExps.prototype.sqrt = function(ret, x)
    {
        ret.set_float(Math.sqrt(x));
    };
    SysExps.prototype.abs = function(ret, x)
    {
        ret.set_float(Math.abs(x));
    };
    SysExps.prototype.round = function(ret, x)
    {
        ret.set_int(Math.round(x));
    };
    SysExps.prototype.floor = function(ret, x)
    {
        ret.set_int(Math.floor(x));
    };
    SysExps.prototype.ceil = function(ret, x)
    {
        ret.set_int(Math.ceil(x));
    };
    SysExps.prototype.sin = function(ret, x)
    {
        ret.set_float(Math.sin(cr.to_radians(x)));
    };
    SysExps.prototype.cos = function(ret, x)
    {
        ret.set_float(Math.cos(cr.to_radians(x)));
    };
    SysExps.prototype.tan = function(ret, x)
    {
        ret.set_float(Math.tan(cr.to_radians(x)));
    };
    SysExps.prototype.asin = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.asin(x)));
    };
    SysExps.prototype.acos = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.acos(x)));
    };
    SysExps.prototype.atan = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.atan(x)));
    };
    SysExps.prototype.exp = function(ret, x)
    {
        ret.set_float(Math.exp(x));
    };
    SysExps.prototype.ln = function(ret, x)
    {
        ret.set_float(Math.log(x));
    };
    SysExps.prototype.log10 = function(ret, x)
    {
        ret.set_float(Math.log(x) / Math.LN10);
    };
    SysExps.prototype.max = function(ret)
    {
		var max_ = arguments[1];
		if (typeof max_ !== "number")
			max_ = 0;
		var i, len, a;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			a = arguments[i];
			if (typeof a !== "number")
				continue;		// ignore non-numeric types
			if (max_ < a)
				max_ = a;
		}
		ret.set_float(max_);
    };
    SysExps.prototype.min = function(ret)
    {
        var min_ = arguments[1];
		if (typeof min_ !== "number")
			min_ = 0;
		var i, len, a;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			a = arguments[i];
			if (typeof a !== "number")
				continue;		// ignore non-numeric types
			if (min_ > a)
				min_ = a;
		}
		ret.set_float(min_);
    };
    SysExps.prototype.dt = function(ret)
    {
        ret.set_float(this.runtime.dt);
    };
    SysExps.prototype.timescale = function(ret)
    {
        ret.set_float(this.runtime.timescale);
    };
    SysExps.prototype.wallclocktime = function(ret)
    {
        ret.set_float((Date.now() - this.runtime.start_time) / 1000.0);
    };
    SysExps.prototype.time = function(ret)
    {
        ret.set_float(this.runtime.kahanTime.sum);
    };
    SysExps.prototype.tickcount = function(ret)
    {
        ret.set_int(this.runtime.tickcount);
    };
    SysExps.prototype.objectcount = function(ret)
    {
        ret.set_int(this.runtime.objectcount);
    };
    SysExps.prototype.fps = function(ret)
    {
        ret.set_int(this.runtime.fps);
    };
    SysExps.prototype.loopindex = function(ret, name_)
    {
		var loop, i, len;
        if (!this.runtime.loop_stack.length)
        {
            ret.set_int(0);
            return;
        }
        if (name_)
        {
            for (i = 0, len = this.runtime.loop_stack.length; i < len; i++)
            {
                loop = this.runtime.loop_stack[i];
                if (loop.name === name_)
                {
                    ret.set_int(loop.index);
                    return;
                }
            }
            ret.set_int(0);
        }
        else
        {
			loop = this.runtime.getCurrentLoop();
			ret.set_int(loop ? loop.index : -1);
        }
    };
    SysExps.prototype.distance = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.distanceTo(x1, y1, x2, y2));
    };
    SysExps.prototype.angle = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.to_degrees(cr.angleTo(x1, y1, x2, y2)));
    };
    SysExps.prototype.scrollx = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollX);
    };
    SysExps.prototype.scrolly = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollY);
    };
    SysExps.prototype.newline = function(ret)
    {
        ret.set_string("\n");
    };
    SysExps.prototype.lerp = function(ret, a, b, x)
    {
        ret.set_float(cr.lerp(a, b, x));
    };
	SysExps.prototype.qarp = function(ret, a, b, c, x)
    {
        ret.set_float(cr.qarp(a, b, c, x));
    };
	SysExps.prototype.cubic = function(ret, a, b, c, d, x)
    {
        ret.set_float(cr.cubic(a, b, c, d, x));
    };
	SysExps.prototype.cosp = function(ret, a, b, x)
    {
        ret.set_float(cr.cosp(a, b, x));
    };
    SysExps.prototype.windowwidth = function(ret)
    {
        ret.set_int(this.runtime.width);
    };
    SysExps.prototype.windowheight = function(ret)
    {
        ret.set_int(this.runtime.height);
    };
	SysExps.prototype.uppercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toUpperCase() : "");
	};
	SysExps.prototype.lowercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toLowerCase() : "");
	};
	SysExps.prototype.clamp = function(ret, x, l, u)
	{
		if (x < l)
			ret.set_float(l);
		else if (x > u)
			ret.set_float(u);
		else
			ret.set_float(x);
	};
	SysExps.prototype.layerscale = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.scale);
	};
	SysExps.prototype.layeropacity = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.opacity * 100);
	};
	SysExps.prototype.layerscalerate = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.zoomRate);
	};
	SysExps.prototype.layerparallaxx = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxX * 100);
	};
	SysExps.prototype.layerparallaxy = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxY * 100);
	};
	SysExps.prototype.layoutscale = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_float(this.runtime.running_layout.scale);
		else
			ret.set_float(0);
	};
	SysExps.prototype.layoutangle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.runtime.running_layout.angle));
	};
	SysExps.prototype.layerangle = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(cr.to_degrees(layer.angle));
	};
	SysExps.prototype.layoutwidth = function (ret)
	{
		ret.set_int(this.runtime.running_layout.width);
	};
	SysExps.prototype.layoutheight = function (ret)
	{
		ret.set_int(this.runtime.running_layout.height);
	};
	SysExps.prototype.find = function (ret, text, searchstr)
	{
		if (cr.is_string(text) && cr.is_string(searchstr))
			ret.set_int(text.search(new RegExp(cr.regexp_escape(searchstr), "i")));
		else
			ret.set_int(-1);
	};
	SysExps.prototype.left = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(0, n) : "");
	};
	SysExps.prototype.right = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(text.length - n) : "");
	};
	SysExps.prototype.mid = function (ret, text, index_, length_)
	{
		ret.set_string(cr.is_string(text) ? text.substr(index_, length_) : "");
	};
	SysExps.prototype.tokenat = function (ret, text, index_, sep)
	{
		if (cr.is_string(text) && cr.is_string(sep))
		{
			var arr = text.split(sep);
			var i = cr.floor(index_);
			if (i < 0 || i >= arr.length)
				ret.set_string("");
			else
				ret.set_string(arr[i]);
		}
		else
			ret.set_string("");
	};
	SysExps.prototype.tokencount = function (ret, text, sep)
	{
		if (cr.is_string(text) && text.length)
			ret.set_int(text.split(sep).length);
		else
			ret.set_int(0);
	};
	SysExps.prototype.replace = function (ret, text, find_, replace_)
	{
		if (cr.is_string(text) && cr.is_string(find_) && cr.is_string(replace_))
			ret.set_string(text.replace(new RegExp(cr.regexp_escape(find_), "gi"), replace_));
		else
			ret.set_string(cr.is_string(text) ? text : "");
	};
	SysExps.prototype.trim = function (ret, text)
	{
		ret.set_string(cr.is_string(text) ? text.trim() : "");
	};
	SysExps.prototype.pi = function (ret)
	{
		ret.set_float(cr.PI);
	};
	SysExps.prototype.layoutname = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_string(this.runtime.running_layout.name);
		else
			ret.set_string("");
	};
	SysExps.prototype.renderer = function (ret)
	{
		ret.set_string(this.runtime.gl ? "webgl" : "canvas2d");
	};
	SysExps.prototype.anglediff = function (ret, a, b)
	{
		ret.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(a), cr.to_radians(b))));
	};
	SysExps.prototype.choose = function (ret)
	{
		var index = cr.floor(Math.random() * (arguments.length - 1));
		ret.set_any(arguments[index + 1]);
	};
	SysExps.prototype.rgb = function (ret, r, g, b)
	{
		ret.set_int(cr.RGB(r, g, b));
	};
	SysExps.prototype.projectversion = function (ret)
	{
		ret.set_string(this.runtime.versionstr);
	};
	SysExps.prototype.projectname = function (ret)
	{
		ret.set_string(this.runtime.projectName);
	};
	SysExps.prototype.anglelerp = function (ret, a, b, x)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			ret.set_float(cr.to_clamped_degrees(a + diff * x));
		}
		else
		{
			ret.set_float(cr.to_clamped_degrees(a - diff * x));
		}
	};
	SysExps.prototype.anglerotate = function (ret, a, b, c)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		c = cr.to_radians(c);
		ret.set_float(cr.to_clamped_degrees(cr.angleRotate(a, b, c)));
	};
	SysExps.prototype.zeropad = function (ret, n, d)
	{
		var s = (n < 0 ? "-" : "");
		if (n < 0) n = -n;
		var zeroes = d - n.toString().length;
		for (var i = 0; i < zeroes; i++)
			s += "0";
		ret.set_string(s + n.toString());
	};
	SysExps.prototype.cpuutilisation = function (ret)
	{
		ret.set_float(this.runtime.cpuutilisation / 1000);
	};
	SysExps.prototype.viewportleft = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewLeft : 0);
	};
	SysExps.prototype.viewporttop = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewTop : 0);
	};
	SysExps.prototype.viewportright = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewRight : 0);
	};
	SysExps.prototype.viewportbottom = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewBottom : 0);
	};
	SysExps.prototype.loadingprogress = function (ret)
	{
		ret.set_float(this.runtime.loadingprogress);
	};
	SysExps.prototype.unlerp = function(ret, a, b, y)
    {
        ret.set_float(cr.unlerp(a, b, y));
    };
	SysExps.prototype.canvassnapshot = function (ret)
	{
		ret.set_string(this.runtime.snapshotData);
	};
	SysExps.prototype.urlencode = function (ret, s)
	{
		ret.set_string(encodeURIComponent(s));
	};
	SysExps.prototype.urldecode = function (ret, s)
	{
		ret.set_string(decodeURIComponent(s));
	};
	SysExps.prototype.canvastolayerx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, true) : 0);
	};
	SysExps.prototype.canvastolayery = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, false) : 0);
	};
	SysExps.prototype.layertocanvasx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, true) : 0);
	};
	SysExps.prototype.layertocanvasy = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, false) : 0);
	};
	SysExps.prototype.savestatejson = function (ret)
	{
		ret.set_string(this.runtime.lastSaveJson);
	};
	SysExps.prototype.imagememoryusage = function (ret)
	{
		if (this.runtime.glwrap)
			ret.set_float(Math.round(100 * this.runtime.glwrap.estimateVRAM() / (1024 * 1024)) / 100);
		else
			ret.set_float(0);
	};
	SysExps.prototype.regexsearch = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_int(str_ ? str_.search(regex) : -1);
	};
	SysExps.prototype.regexreplace = function (ret, str_, regex_, flags_, replace_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_string(str_ ? str_.replace(regex, replace_) : "");
	};
	var regexMatches = [];
	var lastMatchesStr = "";
	var lastMatchesRegex = "";
	var lastMatchesFlags = "";
	function updateRegexMatches(str_, regex_, flags_)
	{
		if (str_ === lastMatchesStr && regex_ === lastMatchesRegex && flags_ === lastMatchesFlags)
			return;
		var regex = getRegex(regex_, flags_);
		regexMatches = str_.match(regex);
		lastMatchesStr = str_;
		lastMatchesRegex = regex_;
		lastMatchesFlags = flags_;
	};
	SysExps.prototype.regexmatchcount = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		ret.set_int(regexMatches ? regexMatches.length : 0);
	};
	SysExps.prototype.regexmatchat = function (ret, str_, regex_, flags_, index_)
	{
		index_ = Math.floor(index_);
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		if (!regexMatches || index_ < 0 || index_ >= regexMatches.length)
			ret.set_string("");
		else
			ret.set_string(regexMatches[index_]);
	};
	SysExps.prototype.infinity = function (ret)
	{
		ret.set_float(Infinity);
	};
	SysExps.prototype.setbit = function (ret, n, b, v)
	{
		n = n | 0;
		b = b | 0;
		v = (v !== 0 ? 1 : 0);
		ret.set_int((n & ~(1 << b)) | (v << b));
	};
	SysExps.prototype.togglebit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int(n ^ (1 << b));
	};
	SysExps.prototype.getbit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int((n & (1 << b)) ? 1 : 0);
	};
	SysExps.prototype.originalwindowwidth = function (ret)
	{
		ret.set_int(this.runtime.original_width);
	};
	SysExps.prototype.originalwindowheight = function (ret)
	{
		ret.set_int(this.runtime.original_height);
	};
	sysProto.exps = new SysExps();
	sysProto.runWaits = function ()
	{
		var i, j, len, w, k, s, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		for (i = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			if (w.time === -1)		// signalled wait
			{
				if (!w.signalled)
					continue;		// not yet signalled
			}
			else					// timer wait
			{
				if (w.time > this.runtime.kahanTime.sum)
					continue;		// timer not yet expired
			}
			evinfo.current_event = w.ev;
			evinfo.actindex = w.actindex;
			evinfo.cndindex = 0;
			for (k in w.sols)
			{
				if (w.sols.hasOwnProperty(k))
				{
					s = this.runtime.types_by_index[parseInt(k, 10)].getCurrentSol();
					ss = w.sols[k];
					s.select_all = ss.sa;
					cr.shallowAssignArray(s.instances, ss.insts);
					freeSolStateObject(ss);
				}
			}
			w.ev.resume_actions_and_subevents();
			this.runtime.clearSol(w.solModifiers);
			w.deleteme = true;
		}
		for (i = 0, j = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			this.waits[j] = w;
			if (w.deleteme)
				freeWaitObject(w);
			else
				j++;
		}
		this.waits.length = j;
	};
}());
;
(function () {
	cr.add_common_aces = function (m)
	{
		var pluginProto = m[0].prototype;
		var singleglobal_ = m[1];
		var position_aces = m[3];
		var size_aces = m[4];
		var angle_aces = m[5];
		var appearance_aces = m[6];
		var zorder_aces = m[7];
		var effects_aces = m[8];
		if (!pluginProto.cnds)
			pluginProto.cnds = {};
		if (!pluginProto.acts)
			pluginProto.acts = {};
		if (!pluginProto.exps)
			pluginProto.exps = {};
		var cnds = pluginProto.cnds;
		var acts = pluginProto.acts;
		var exps = pluginProto.exps;
		if (position_aces)
		{
			cnds.CompareX = function (cmp, x)
			{
				return cr.do_cmp(this.x, cmp, x);
			};
			cnds.CompareY = function (cmp, y)
			{
				return cr.do_cmp(this.y, cmp, y);
			};
			cnds.IsOnScreen = function ()
			{
				var layer = this.layer;
				this.update_bbox();
				var bbox = this.bbox;
				return !(bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom);
			};
			cnds.IsOutsideLayout = function ()
			{
				this.update_bbox();
				var bbox = this.bbox;
				var layout = this.runtime.running_layout;
				return (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height);
			};
			cnds.PickDistance = function (which, x, y)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var dist = cr.distanceTo(inst.x, inst.y, x, y);
				var i, len, d;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					d = cr.distanceTo(inst.x, inst.y, x, y);
					if ((which === 0 && d < dist) || (which === 1 && d > dist))
					{
						dist = d;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.SetX = function (x)
			{
				if (this.x !== x)
				{
					this.x = x;
					this.set_bbox_changed();
				}
			};
			acts.SetY = function (y)
			{
				if (this.y !== y)
				{
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPos = function (x, y)
			{
				if (this.x !== x || this.y !== y)
				{
					this.x = x;
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPosToObject = function (obj, imgpt)
			{
				var inst = obj.getPairedInstance(this);
				if (!inst)
					return;
				var newx, newy;
				if (inst.getImagePoint)
				{
					newx = inst.getImagePoint(imgpt, true);
					newy = inst.getImagePoint(imgpt, false);
				}
				else
				{
					newx = inst.x;
					newy = inst.y;
				}
				if (this.x !== newx || this.y !== newy)
				{
					this.x = newx;
					this.y = newy;
					this.set_bbox_changed();
				}
			};
			acts.MoveForward = function (dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(this.angle) * dist;
					this.y += Math.sin(this.angle) * dist;
					this.set_bbox_changed();
				}
			};
			acts.MoveAtAngle = function (a, dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(cr.to_radians(a)) * dist;
					this.y += Math.sin(cr.to_radians(a)) * dist;
					this.set_bbox_changed();
				}
			};
			exps.X = function (ret)
			{
				ret.set_float(this.x);
			};
			exps.Y = function (ret)
			{
				ret.set_float(this.y);
			};
			exps.dt = function (ret)
			{
				ret.set_float(this.runtime.getDt(this));
			};
		}
		if (size_aces)
		{
			cnds.CompareWidth = function (cmp, w)
			{
				return cr.do_cmp(this.width, cmp, w);
			};
			cnds.CompareHeight = function (cmp, h)
			{
				return cr.do_cmp(this.height, cmp, h);
			};
			acts.SetWidth = function (w)
			{
				if (this.width !== w)
				{
					this.width = w;
					this.set_bbox_changed();
				}
			};
			acts.SetHeight = function (h)
			{
				if (this.height !== h)
				{
					this.height = h;
					this.set_bbox_changed();
				}
			};
			acts.SetSize = function (w, h)
			{
				if (this.width !== w || this.height !== h)
				{
					this.width = w;
					this.height = h;
					this.set_bbox_changed();
				}
			};
			exps.Width = function (ret)
			{
				ret.set_float(this.width);
			};
			exps.Height = function (ret)
			{
				ret.set_float(this.height);
			};
			exps.BBoxLeft = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.left);
			};
			exps.BBoxTop = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.top);
			};
			exps.BBoxRight = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.right);
			};
			exps.BBoxBottom = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.bottom);
			};
		}
		if (angle_aces)
		{
			cnds.AngleWithin = function (within, a)
			{
				return cr.angleDiff(this.angle, cr.to_radians(a)) <= cr.to_radians(within);
			};
			cnds.IsClockwiseFrom = function (a)
			{
				return cr.angleClockwise(this.angle, cr.to_radians(a));
			};
			cnds.IsBetweenAngles = function (a, b)
			{
				var lower = cr.to_clamped_radians(a);
				var upper = cr.to_clamped_radians(b);
				var angle = cr.clamp_angle(this.angle);
				var obtuse = (!cr.angleClockwise(upper, lower));
				if (obtuse)
					return !(!cr.angleClockwise(angle, lower) && cr.angleClockwise(angle, upper));
				else
					return cr.angleClockwise(angle, lower) && !cr.angleClockwise(angle, upper);
			};
			acts.SetAngle = function (a)
			{
				var newangle = cr.to_radians(cr.clamp_angle_degrees(a));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateClockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle += cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateCounterclockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle -= cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardAngle = function (amt, target)
			{
				var newangle = cr.angleRotate(this.angle, cr.to_radians(target), cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardPosition = function (amt, x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var target = Math.atan2(dy, dx);
				var newangle = cr.angleRotate(this.angle, target, cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.SetTowardPosition = function (x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var newangle = Math.atan2(dy, dx);
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			exps.Angle = function (ret)
			{
				ret.set_float(cr.to_clamped_degrees(this.angle));
			};
		}
		if (!singleglobal_)
		{
			cnds.CompareInstanceVar = function (iv, cmp, val)
			{
				return cr.do_cmp(this.instance_vars[iv], cmp, val);
			};
			cnds.IsBoolInstanceVarSet = function (iv)
			{
				return this.instance_vars[iv];
			};
			cnds.PickInstVarHiLow = function (which, iv)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var val = inst.instance_vars[iv];
				var i, len, v;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					v = inst.instance_vars[iv];
					if ((which === 0 && v < val) || (which === 1 && v > val))
					{
						val = v;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			cnds.PickByUID = function (u)
			{
				var i, len, j, inst, families, instances, sol;
				var cnd = this.runtime.getCurrentCondition();
				if (cnd.inverted)
				{
					sol = this.getCurrentSol();
					if (sol.select_all)
					{
						sol.select_all = false;
						sol.instances.length = 0;
						sol.else_instances.length = 0;
						instances = this.instances;
						for (i = 0, len = instances.length; i < len; i++)
						{
							inst = instances[i];
							if (inst.uid === u)
								sol.else_instances.push(inst);
							else
								sol.instances.push(inst);
						}
						this.applySolToContainer();
						return !!sol.instances.length;
					}
					else
					{
						for (i = 0, j = 0, len = sol.instances.length; i < len; i++)
						{
							inst = sol.instances[i];
							sol.instances[j] = inst;
							if (inst.uid === u)
							{
								sol.else_instances.push(inst);
							}
							else
								j++;
						}
						sol.instances.length = j;
						this.applySolToContainer();
						return !!sol.instances.length;
					}
				}
				else
				{
					inst = this.runtime.getObjectByUID(u);
					if (!inst)
						return false;
					sol = this.getCurrentSol();
					if (!sol.select_all && sol.instances.indexOf(inst) === -1)
						return false;		// not picked
					if (this.is_family)
					{
						families = inst.type.families;
						for (i = 0, len = families.length; i < len; i++)
						{
							if (families[i] === this)
							{
								sol.pick_one(inst);
								this.applySolToContainer();
								return true;
							}
						}
					}
					else if (inst.type === this)
					{
						sol.pick_one(inst);
						this.applySolToContainer();
						return true;
					}
					return false;
				}
			};
			cnds.OnCreated = function ()
			{
				return true;
			};
			cnds.OnDestroyed = function ()
			{
				return true;
			};
			acts.SetInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = val.toString();
				}
				else
;
			};
			acts.AddInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += val.toString();
				}
				else
;
			};
			acts.SubInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] -= val;
					else
						myinstvars[iv] -= parseFloat(val);
				}
				else
;
			};
			acts.SetBoolInstanceVar = function (iv, val)
			{
				this.instance_vars[iv] = val ? 1 : 0;
			};
			acts.ToggleBoolInstanceVar = function (iv)
			{
				this.instance_vars[iv] = 1 - this.instance_vars[iv];
			};
			acts.Destroy = function ()
			{
				this.runtime.DestroyInstance(this);
			};
			if (!acts.LoadFromJsonString)
			{
				acts.LoadFromJsonString = function (str_)
				{
					var o, i, len, binst;
					try {
						o = JSON.parse(str_);
					}
					catch (e) {
						return;
					}
					this.runtime.loadInstanceFromJSON(this, o, true);
					if (this.afterLoad)
						this.afterLoad();
					if (this.behavior_insts)
					{
						for (i = 0, len = this.behavior_insts.length; i < len; ++i)
						{
							binst = this.behavior_insts[i];
							if (binst.afterLoad)
								binst.afterLoad();
						}
					}
				};
			}
			exps.Count = function (ret)
			{
				var count = ret.object_class.instances.length;
				var i, len, inst;
				for (i = 0, len = this.runtime.createRow.length; i < len; i++)
				{
					inst = this.runtime.createRow[i];
					if (ret.object_class.is_family)
					{
						if (inst.type.families.indexOf(ret.object_class) >= 0)
							count++;
					}
					else
					{
						if (inst.type === ret.object_class)
							count++;
					}
				}
				ret.set_int(count);
			};
			exps.PickedCount = function (ret)
			{
				ret.set_int(ret.object_class.getCurrentSol().getObjects().length);
			};
			exps.UID = function (ret)
			{
				ret.set_int(this.uid);
			};
			exps.IID = function (ret)
			{
				ret.set_int(this.get_iid());
			};
			if (!exps.AsJSON)
			{
				exps.AsJSON = function (ret)
				{
					ret.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this, true)));
				};
			}
		}
		if (appearance_aces)
		{
			cnds.IsVisible = function ()
			{
				return this.visible;
			};
			acts.SetVisible = function (v)
			{
				if (!v !== !this.visible)
				{
					this.visible = v;
					this.runtime.redraw = true;
				}
			};
			cnds.CompareOpacity = function (cmp, x)
			{
				return cr.do_cmp(cr.round6dp(this.opacity * 100), cmp, x);
			};
			acts.SetOpacity = function (x)
			{
				var new_opacity = x / 100.0;
				if (new_opacity < 0)
					new_opacity = 0;
				else if (new_opacity > 1)
					new_opacity = 1;
				if (new_opacity !== this.opacity)
				{
					this.opacity = new_opacity;
					this.runtime.redraw = true;
				}
			};
			exps.Opacity = function (ret)
			{
				ret.set_float(cr.round6dp(this.opacity * 100.0));
			};
		}
		if (zorder_aces)
		{
			cnds.IsOnLayer = function (layer_)
			{
				if (!layer_)
					return false;
				return this.layer === layer_;
			};
			cnds.PickTopBottom = function (which_)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var i, len;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					if (which_ === 0)
					{
						if (inst.layer.index > pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() > pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
					else
					{
						if (inst.layer.index < pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() < pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.MoveToTop = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === this.layer.instances.length - 1)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.push(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToBottom = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === 0)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.unshift(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToLayer = function (layerMove)
			{
				if (!layerMove || layerMove == this.layer)
					return;
				cr.arrayRemove(this.layer.instances, this.get_zindex());
				this.layer.zindices_stale = true;
				this.layer = layerMove;
				this.zindex = layerMove.instances.length;
				layerMove.instances.push(this);
				this.runtime.redraw = true;
			};
			acts.ZMoveToObject = function (where_, obj_)
			{
				var isafter = (where_ === 0);
				if (!obj_)
					return;
				var other = obj_.getFirstPicked(this);
				if (!other || other.uid === this.uid)
					return;
				if (this.layer.index !== other.layer.index)
				{
					cr.arrayRemove(this.layer.instances, this.get_zindex());
					this.layer.zindices_stale = true;
					this.layer = other.layer;
					this.zindex = other.layer.instances.length;
					other.layer.instances.push(this);
				}
				var myZ = this.get_zindex();
				var insertZ = other.get_zindex();
				cr.arrayRemove(this.layer.instances, myZ);
				if (myZ < insertZ)
					insertZ--;
				if (isafter)
					insertZ++;
				if (insertZ === this.layer.instances.length)
					this.layer.instances.push(this);
				else
					this.layer.instances.splice(insertZ, 0, this);
				this.layer.zindices_stale = true;
				this.runtime.redraw = true;
			};
			exps.LayerNumber = function (ret)
			{
				ret.set_int(this.layer.number);
			};
			exps.LayerName = function (ret)
			{
				ret.set_string(this.layer.name);
			};
			exps.ZIndex = function (ret)
			{
				ret.set_int(this.get_zindex());
			};
		}
		if (effects_aces)
		{
			acts.SetEffectEnabled = function (enable_, effectname_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var enable = (enable_ === 1);
				if (this.active_effect_flags[i] === enable)
					return;		// no change
				this.active_effect_flags[i] = enable;
				this.updateActiveEffects();
				this.runtime.redraw = true;
			};
			acts.SetEffectParam = function (effectname_, index_, value_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var et = this.type.effect_types[i];
				var params = this.effect_params[i];
				index_ = Math.floor(index_);
				if (index_ < 0 || index_ >= params.length)
					return;		// effect index out of bounds
				if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
					value_ /= 100.0;
				if (params[index_] === value_)
					return;		// no change
				params[index_] = value_;
				if (et.active)
					this.runtime.redraw = true;
			};
		}
	};
	cr.set_bbox_changed = function ()
	{
		this.bbox_changed = true;      		// will recreate next time box requested
		this.cell_changed = true;
		this.type.any_cell_changed = true;	// avoid unnecessary updateAllBBox() calls
		this.runtime.redraw = true;     	// assume runtime needs to redraw
		var i, len, callbacks = this.bbox_changed_callbacks;
		for (i = 0, len = callbacks.length; i < len; ++i)
		{
			callbacks[i](this);
		}
	};
	cr.add_bbox_changed_callback = function (f)
	{
		if (f)
		{
			this.bbox_changed_callbacks.push(f);
		}
	};
	cr.update_bbox = function ()
	{
		if (!this.bbox_changed)
			return;                 // bounding box not changed
		var bbox = this.bbox;
		var bquad = this.bquad;
		bbox.set(this.x, this.y, this.x + this.width, this.y + this.height);
		bbox.offset(-this.hotspotX * this.width, -this.hotspotY * this.height);
		if (!this.angle)
		{
			bquad.set_from_rect(bbox);    // make bounding quad from box
		}
		else
		{
			bbox.offset(-this.x, -this.y);       			// translate to origin
			bquad.set_from_rotated_rect(bbox, this.angle);	// rotate around origin
			bquad.offset(this.x, this.y);      				// translate back to original position
			bquad.bounding_box(bbox);
		}
		bbox.normalize();
		this.bbox_changed = false;  // bounding box up to date
	};
	var tmprc = new cr.rect(0, 0, 0, 0);
	cr.update_collision_cell = function ()
	{
		if (!this.cell_changed || !this.collisionsEnabled)
			return;
		this.update_bbox();
		var mygrid = this.type.collision_grid;
		var collcells = this.collcells;
		var bbox = this.bbox;
		tmprc.set(mygrid.XToCell(bbox.left), mygrid.YToCell(bbox.top), mygrid.XToCell(bbox.right), mygrid.YToCell(bbox.bottom));
		if (collcells.equals(tmprc))
			return;
		if (collcells.right < collcells.left)
			mygrid.update(this, null, tmprc);		// first insertion with invalid rect: don't provide old range
		else
			mygrid.update(this, collcells, tmprc);
		collcells.copy(tmprc);
		this.cell_changed = false;
	};
	cr.inst_contains_pt = function (x, y)
	{
		if (!this.bbox.contains_pt(x, y))
			return false;
		if (!this.bquad.contains_pt(x, y))
			return false;
		if (this.collision_poly && !this.collision_poly.is_empty())
		{
			this.collision_poly.cache_poly(this.width, this.height, this.angle);
			return this.collision_poly.contains_pt(x - this.x, y - this.y);
		}
		else
			return true;
	};
	cr.inst_get_iid = function ()
	{
		this.type.updateIIDs();
		return this.iid;
	};
	cr.inst_get_zindex = function ()
	{
		this.layer.updateZIndices();
		return this.zindex;
	};
	cr.inst_updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et, inst;
		for (i = 0, len = this.active_effect_flags.length; i < len; i++)
		{
			if (this.active_effect_flags[i])
				this.active_effect_types.push(this.type.effect_types[i]);
		}
		this.uses_shaders = !!this.active_effect_types.length;
	};
	cr.inst_toString = function ()
	{
		return "Inst" + this.puid;
	};
	cr.type_getFirstPicked = function (frominst)
	{
		if (frominst && frominst.is_contained && frominst.type != this)
		{
			var i, len, s;
			for (i = 0, len = frominst.siblings.length; i < len; i++)
			{
				s = frominst.siblings[i];
				if (s.type == this)
					return s;
			}
		}
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[0];
		else
			return null;
	};
	cr.type_getPairedInstance = function (inst)
	{
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[inst.get_iid() % instances.length];
		else
			return null;
	};
	cr.type_updateIIDs = function ()
	{
		if (!this.stale_iids || this.is_family)
			return;		// up to date or is family - don't want family to overwrite IIDs
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].iid = i;
		var next_iid = i;
		var createRow = this.runtime.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === this)
				createRow[i].iid = next_iid++;
		}
		this.stale_iids = false;
	};
	cr.type_getInstanceByIID = function (i)
	{
		if (i < this.instances.length)
			return this.instances[i];
		i -= this.instances.length;
		var createRow = this.runtime.createRow;
		var j, lenj;
		for (j = 0, lenj = createRow.length; j < lenj; ++j)
		{
			if (createRow[j].type === this)
			{
				if (i === 0)
					return createRow[j];
				--i;
			}
		}
;
		return null;
	};
	cr.type_getCurrentSol = function ()
	{
		return this.solstack[this.cur_sol];
	};
	cr.type_pushCleanSol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		else
			this.solstack[this.cur_sol].select_all = true;  // else clear next SOL
	};
	cr.type_pushCopySol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		var clonesol = this.solstack[this.cur_sol];
		var prevsol = this.solstack[this.cur_sol - 1];
		if (prevsol.select_all)
			clonesol.select_all = true;
		else
		{
			clonesol.select_all = false;
			cr.shallowAssignArray(clonesol.instances, prevsol.instances);
			cr.shallowAssignArray(clonesol.else_instances, prevsol.else_instances);
		}
	};
	cr.type_popSol = function ()
	{
;
		this.cur_sol--;
	};
	cr.type_getBehaviorByName = function (behname)
	{
		var i, len, j, lenj, f, index = 0;
		if (!this.is_family)
		{
			for (i = 0, len = this.families.length; i < len; i++)
			{
				f = this.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (behname === f.behaviors[j].name)
					{
						this.extra["lastBehIndex"] = index;
						return f.behaviors[j];
					}
					index++;
				}
			}
		}
		for (i = 0, len = this.behaviors.length; i < len; i++) {
			if (behname === this.behaviors[i].name)
			{
				this.extra["lastBehIndex"] = index;
				return this.behaviors[i];
			}
			index++;
		}
		return null;
	};
	cr.type_getBehaviorIndexByName = function (behname)
	{
		var b = this.getBehaviorByName(behname);
		if (b)
			return this.extra["lastBehIndex"];
		else
			return -1;
	};
	cr.type_getEffectIndexByName = function (name_)
	{
		var i, len;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			if (this.effect_types[i].name === name_)
				return i;
		}
		return -1;
	};
	cr.type_applySolToContainer = function ()
	{
		if (!this.is_contained || this.is_family)
			return;
		var i, len, j, lenj, t, sol, sol2;
		this.updateIIDs();
		sol = this.getCurrentSol();
		var select_all = sol.select_all;
		var es = this.runtime.getCurrentEventStack();
		var orblock = es && es.current_event && es.current_event.orblock;
		for (i = 0, len = this.container.length; i < len; i++)
		{
			t = this.container[i];
			if (t === this)
				continue;
			t.updateIIDs();
			sol2 = t.getCurrentSol();
			sol2.select_all = select_all;
			if (!select_all)
			{
				sol2.instances.length = sol.instances.length;
				for (j = 0, lenj = sol.instances.length; j < lenj; j++)
					sol2.instances[j] = t.getInstanceByIID(sol.instances[j].iid);
				if (orblock)
				{
					sol2.else_instances.length = sol.else_instances.length;
					for (j = 0, lenj = sol.else_instances.length; j < lenj; j++)
						sol2.else_instances[j] = t.getInstanceByIID(sol.else_instances[j].iid);
				}
			}
		}
	};
	cr.type_toString = function ()
	{
		return "Type" + this.sid;
	};
	cr.do_cmp = function (x, cmp, y)
	{
		if (typeof x === "undefined" || typeof y === "undefined")
			return false;
		switch (cmp)
		{
			case 0:     // equal
				return x === y;
			case 1:     // not equal
				return x !== y;
			case 2:     // less
				return x < y;
			case 3:     // less/equal
				return x <= y;
			case 4:     // greater
				return x > y;
			case 5:     // greater/equal
				return x >= y;
			default:
;
				return false;
		}
	};
})();
cr.shaders = {};
cr.shaders["tint"] = {src: ["varying mediump vec2 vTex;",
"uniform lowp sampler2D samplerFront;",
"uniform lowp float red;",
"uniform lowp float green;",
"uniform lowp float blue;",
"void main(void)",
"{",
"lowp vec4 front = texture2D(samplerFront, vTex);",
"gl_FragColor = front * vec4(red, green, blue, 1.0);",
"}"
].join("\n"),
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	animated: false,
	parameters: [["red", 0, 1], ["green", 0, 1], ["blue", 0, 1]] }
;
;
cr.plugins_.Arr = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Arr.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var arrCache = [];
	function allocArray()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [];
	};
	if (!Array.isArray)
	{
		Array.isArray = function (vArg) {
			return Object.prototype.toString.call(vArg) === "[object Array]";
		};
	}
	function freeArray(a)
	{
		var i, len;
		for (i = 0, len = a.length; i < len; i++)
		{
			if (Array.isArray(a[i]))
				freeArray(a[i]);
		}
		a.length = 0;
		arrCache.push(a);
	};
	instanceProto.onCreate = function()
	{
		this.cx = this.properties[0];
		this.cy = this.properties[1];
		this.cz = this.properties[2];
		if (!this.recycled)
			this.arr = allocArray();
		var a = this.arr;
		a.length = this.cx;
		var x, y, z;
		for (x = 0; x < this.cx; x++)
		{
			if (!a[x])
				a[x] = allocArray();
			a[x].length = this.cy;
			for (y = 0; y < this.cy; y++)
			{
				if (!a[x][y])
					a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = 0;
			}
		}
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
	};
	instanceProto.onDestroy = function ()
	{
		var x;
		for (x = 0; x < this.cx; x++)
			freeArray(this.arr[x]);		// will recurse down and recycle other arrays
		this.arr.length = 0;
	};
	instanceProto.at = function (x, y, z)
	{
		x = Math.floor(x);
		y = Math.floor(y);
		z = Math.floor(z);
		if (isNaN(x) || x < 0 || x > this.cx - 1)
			return 0;
		if (isNaN(y) || y < 0 || y > this.cy - 1)
			return 0;
		if (isNaN(z) || z < 0 || z > this.cz - 1)
			return 0;
		return this.arr[x][y][z];
	};
	instanceProto.set = function (x, y, z, val)
	{
		x = Math.floor(x);
		y = Math.floor(y);
		z = Math.floor(z);
		if (isNaN(x) || x < 0 || x > this.cx - 1)
			return;
		if (isNaN(y) || y < 0 || y > this.cy - 1)
			return;
		if (isNaN(z) || z < 0 || z > this.cz - 1)
			return;
		this.arr[x][y][z] = val;
	};
	instanceProto.getAsJSON = function ()
	{
		return JSON.stringify({
			"c2array": true,
			"size": [this.cx, this.cy, this.cz],
			"data": this.arr
		});
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"size": [this.cx, this.cy, this.cz],
			"data": this.arr
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		var sz = o["size"];
		this.cx = sz[0];
		this.cy = sz[1];
		this.cz = sz[2];
		this.arr = o["data"];
	};
	instanceProto.setSize = function (w, h, d)
	{
		if (w < 0) w = 0;
		if (h < 0) h = 0;
		if (d < 0) d = 0;
		if (this.cx === w && this.cy === h && this.cz === d)
			return;		// no change
		this.cx = w;
		this.cy = h;
		this.cz = d;
		var x, y, z;
		var a = this.arr;
		a.length = w;
		for (x = 0; x < this.cx; x++)
		{
			if (cr.is_undefined(a[x]))
				a[x] = allocArray();
			a[x].length = h;
			for (y = 0; y < this.cy; y++)
			{
				if (cr.is_undefined(a[x][y]))
					a[x][y] = allocArray();
				a[x][y].length = d;
				for (z = 0; z < this.cz; z++)
				{
					if (cr.is_undefined(a[x][y][z]))
						a[x][y][z] = 0;
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareX = function (x, cmp, val)
	{
		return cr.do_cmp(this.at(x, 0, 0), cmp, val);
	};
	Cnds.prototype.CompareXY = function (x, y, cmp, val)
	{
		return cr.do_cmp(this.at(x, y, 0), cmp, val);
	};
	Cnds.prototype.CompareXYZ = function (x, y, z, cmp, val)
	{
		return cr.do_cmp(this.at(x, y, z), cmp, val);
	};
	instanceProto.doForEachTrigger = function (current_event)
	{
		this.runtime.pushCopySol(current_event.solModifiers);
		current_event.retrigger();
		this.runtime.popSol(current_event.solModifiers);
	};
	Cnds.prototype.ArrForEach = function (dims)
	{
        var current_event = this.runtime.getCurrentEventStack().current_event;
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
		switch (dims) {
		case 0:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				for (this.forY = 0; this.forY < this.cy; this.forY++)
				{
					for (this.forZ = 0; this.forZ < this.cz; this.forZ++)
					{
						this.doForEachTrigger(current_event);
					}
				}
			}
			break;
		case 1:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				for (this.forY = 0; this.forY < this.cy; this.forY++)
				{
					this.doForEachTrigger(current_event);
				}
			}
			break;
		case 2:
			for (this.forX = 0; this.forX < this.cx; this.forX++)
			{
				this.doForEachTrigger(current_event);
			}
			break;
		}
		this.forX = 0;
		this.forY = 0;
		this.forZ = 0;
		return false;
	};
	Cnds.prototype.CompareCurrent = function (cmp, val)
	{
		return cr.do_cmp(this.at(this.forX, this.forY, this.forZ), cmp, val);
	};
	Cnds.prototype.Contains = function(val)
	{
		var x, y, z;
		for (x = 0; x < this.cx; x++)
		{
			for (y = 0; y < this.cy; y++)
			{
				for (z = 0; z < this.cz; z++)
				{
					if (this.arr[x][y][z] === val)
						return true;
				}
			}
		}
		return false;
	};
	Cnds.prototype.IsEmpty = function ()
	{
		return this.cx === 0 || this.cy === 0 || this.cz === 0;
	};
	Cnds.prototype.CompareSize = function (axis, cmp, value)
	{
		var s = 0;
		switch (axis) {
		case 0:
			s = this.cx;
			break;
		case 1:
			s = this.cy;
			break;
		case 2:
			s = this.cz;
			break;
		}
		return cr.do_cmp(s, cmp, value);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Clear = function ()
	{
		var x, y, z;
		for (x = 0; x < this.cx; x++)
			for (y = 0; y < this.cy; y++)
				for (z = 0; z < this.cz; z++)
					this.arr[x][y][z] = 0;
	};
	Acts.prototype.SetSize = function (w, h, d)
	{
		this.setSize(w, h, d);
	};
	Acts.prototype.SetX = function (x, val)
	{
		this.set(x, 0, 0, val);
	};
	Acts.prototype.SetXY = function (x, y, val)
	{
		this.set(x, y, 0, val);
	};
	Acts.prototype.SetXYZ = function (x, y, z, val)
	{
		this.set(x, y, z, val);
	};
	Acts.prototype.Push = function (where, value, axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		switch (axis) {
		case 0:	// X axis
			if (where === 0)	// back
			{
				x = a.length;
				a.push(allocArray());
			}
			else				// front
			{
				x = 0;
				a.unshift(allocArray());
			}
			a[x].length = this.cy;
			for ( ; y < this.cy; y++)
			{
				a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cx++;
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
			{
				if (where === 0)	// back
				{
					y = a[x].length;
					a[x].push(allocArray());
				}
				else				// front
				{
					y = 0;
					a[x].unshift(allocArray());
				}
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cy++;
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					if (where === 0)	// back
					{
						a[x][y].push(value);
					}
					else				// front
					{
						a[x][y].unshift(value);
					}
				}
			}
			this.cz++;
			break;
		}
	};
	Acts.prototype.Pop = function (where, axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		switch (axis) {
		case 0:	// X axis
			if (this.cx === 0)
				break;
			if (where === 0)	// back
			{
				freeArray(a.pop());
			}
			else				// front
			{
				freeArray(a.shift());
			}
			this.cx--;
			break;
		case 1: // Y axis
			if (this.cy === 0)
				break;
			for ( ; x < this.cx; x++)
			{
				if (where === 0)	// back
				{
					freeArray(a[x].pop());
				}
				else				// front
				{
					freeArray(a[x].shift());
				}
			}
			this.cy--;
			break;
		case 2:	// Z axis
			if (this.cz === 0)
				break;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					if (where === 0)	// back
					{
						a[x][y].pop();
					}
					else				// front
					{
						a[x][y].shift();
					}
				}
			}
			this.cz--;
			break;
		}
	};
	Acts.prototype.Reverse = function (axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		if (this.cx === 0 || this.cy === 0 || this.cz === 0)
			return;		// no point reversing empty array
		switch (axis) {
		case 0:	// X axis
			a.reverse();
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
				a[x].reverse();
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
				for (y = 0; y < this.cy; y++)
					a[x][y].reverse();
			this.cz--;
			break;
		}
	};
	function compareValues(va, vb)
	{
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			var sa = "" + va;
			var sb = "" + vb;
			if (sa < sb)
				return -1;
			else if (sa > sb)
				return 1;
			else
				return 0;
		}
	}
	Acts.prototype.Sort = function (axis)
	{
		var x = 0, y = 0, z = 0;
		var a = this.arr;
		if (this.cx === 0 || this.cy === 0 || this.cz === 0)
			return;		// no point sorting empty array
		switch (axis) {
		case 0:	// X axis
			a.sort(function (a, b) {
				return compareValues(a[0][0], b[0][0]);
			});
			break;
		case 1: // Y axis
			for ( ; x < this.cx; x++)
			{
				a[x].sort(function (a, b) {
					return compareValues(a[0], b[0]);
				});
			}
			break;
		case 2:	// Z axis
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].sort(compareValues);
				}
			}
			break;
		}
	};
	Acts.prototype.Delete = function (index, axis)
	{
		var x = 0, y = 0, z = 0;
		index = Math.floor(index);
		var a = this.arr;
		if (index < 0)
			return;
		switch (axis) {
		case 0:	// X axis
			if (index >= this.cx)
				break;
			freeArray(a[index]);
			a.splice(index, 1);
			this.cx--;
			break;
		case 1: // Y axis
			if (index >= this.cy)
				break;
			for ( ; x < this.cx; x++)
			{
				freeArray(a[x][index]);
				a[x].splice(index, 1);
			}
			this.cy--;
			break;
		case 2:	// Z axis
			if (index >= this.cz)
				break;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].splice(index, 1);
				}
			}
			this.cz--;
			break;
		}
	};
	Acts.prototype.Insert = function (value, index, axis)
	{
		var x = 0, y = 0, z = 0;
		index = Math.floor(index);
		var a = this.arr;
		if (index < 0)
			return;
		switch (axis) {
		case 0:	// X axis
			if (index > this.cx)
				return;
			x = index;
			a.splice(x, 0, allocArray());
			a[x].length = this.cy;
			for ( ; y < this.cy; y++)
			{
				a[x][y] = allocArray();
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cx++;
			break;
		case 1: // Y axis
			if (index > this.cy)
				return;
			for ( ; x < this.cx; x++)
			{
				y = index;
				a[x].splice(y, 0, allocArray());
				a[x][y].length = this.cz;
				for (z = 0; z < this.cz; z++)
					a[x][y][z] = value;
			}
			this.cy++;
			break;
		case 2:	// Z axis
			if (index > this.cz)
				return;
			for ( ; x < this.cx; x++)
			{
				for (y = 0; y < this.cy; y++)
				{
					a[x][y].splice(index, 0, value);
				}
			}
			this.cz++;
			break;
		}
	};
	Acts.prototype.JSONLoad = function (json_)
	{
		var o;
		try {
			o = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!o["c2array"])		// presumably not a c2array object
			return;
		var sz = o["size"];
		this.cx = sz[0];
		this.cy = sz[1];
		this.cz = sz[2];
		this.arr = o["data"];
	};
	Acts.prototype.JSONDownload = function (filename)
	{
		var a = document.createElement("a");
		if (typeof a.download === "undefined")
		{
			var str = 'data:text/html,' + encodeURIComponent("<p><a download='" + filename + "' href=\"data:application/json,"
				+ encodeURIComponent(this.getAsJSON())
				+ "\">Download link</a></p>");
			window.open(str);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename;
			a.href = "data:application/json," + encodeURIComponent(this.getAsJSON());
			a.download = filename;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.At = function (ret, x, y_, z_)
	{
		var y = y_ || 0;
		var z = z_ || 0;
		ret.set_any(this.at(x, y, z));
	};
	Exps.prototype.Width = function (ret)
	{
		ret.set_int(this.cx);
	};
	Exps.prototype.Height = function (ret)
	{
		ret.set_int(this.cy);
	};
	Exps.prototype.Depth = function (ret)
	{
		ret.set_int(this.cz);
	};
	Exps.prototype.CurX = function (ret)
	{
		ret.set_int(this.forX);
	};
	Exps.prototype.CurY = function (ret)
	{
		ret.set_int(this.forY);
	};
	Exps.prototype.CurZ = function (ret)
	{
		ret.set_int(this.forZ);
	};
	Exps.prototype.CurValue = function (ret)
	{
		ret.set_any(this.at(this.forX, this.forY, this.forZ));
	};
	Exps.prototype.Front = function (ret)
	{
		ret.set_any(this.at(0, 0, 0));
	};
	Exps.prototype.Back = function (ret)
	{
		ret.set_any(this.at(this.cx - 1, 0, 0));
	};
	Exps.prototype.IndexOf = function (ret, v)
	{
		for (var i = 0; i < this.cx; i++)
		{
			if (this.arr[i][0][0] === v)
			{
				ret.set_int(i);
				return;
			}
		}
		ret.set_int(-1);
	};
	Exps.prototype.LastIndexOf = function (ret, v)
	{
		for (var i = this.cx - 1; i >= 0; i--)
		{
			if (this.arr[i][0][0] === v)
			{
				ret.set_int(i);
				return;
			}
		}
		ret.set_int(-1);
	};
	Exps.prototype.AsJSON = function (ret)
	{
		ret.set_string(this.getAsJSON());
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Audio = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Audio.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	var audRuntime = null;
	var audInst = null;
	var audTag = "";
	var appPath = "";			// for PhoneGap only
	var API_HTML5 = 0;
	var API_WEBAUDIO = 1;
	var API_PHONEGAP = 2;
	var API_APPMOBI = 3;
	var api = API_HTML5;
	var context = null;
	var audioBuffers = [];		// cache of buffers
	var audioInstances = [];	// cache of instances
	var lastAudio = null;
	var useOgg = false;			// determined at create time
	var timescale_mode = 0;
	var silent = false;
	var masterVolume = 1;
	var listenerX = 0;
	var listenerY = 0;
	var panningModel = 1;		// HRTF
	var distanceModel = 1;		// Inverse
	var refDistance = 10;
	var maxDistance = 10000;
	var rolloffFactor = 1;
	var micSource = null;
	var micTag = "";
	var isMusicWorkaround = false;
	var musicPlayNextTouch = [];
	function dbToLinear(x)
	{
		var v = dbToLinear_nocap(x);
		if (v < 0)
			v = 0;
		if (v > 1)
			v = 1;
		return v;
	};
	function linearToDb(x)
	{
		if (x < 0)
			x = 0;
		if (x > 1)
			x = 1;
		return linearToDb_nocap(x);
	};
	function dbToLinear_nocap(x)
	{
		return Math.pow(10, x / 20);
	};
	function linearToDb_nocap(x)
	{
		return (Math.log(x) / Math.log(10)) * 20;
	};
	var effects = {};
	function getDestinationForTag(tag)
	{
		tag = tag.toLowerCase();
		if (effects.hasOwnProperty(tag))
		{
			if (effects[tag].length)
				return effects[tag][0].getInputNode();
		}
		return context["destination"];
	};
	function createGain()
	{
		if (context["createGain"])
			return context["createGain"]();
		else
			return context["createGainNode"]();
	};
	function createDelay(d)
	{
		if (context["createDelay"])
			return context["createDelay"](d);
		else
			return context["createDelayNode"](d);
	};
	function startSource(s)
	{
		if (s["start"])
			s["start"](0);
		else
			s["noteOn"](0);
	};
	function startSourceAt(s, x, d)
	{
		if (s["start"])
			s["start"](0, x);
		else
			s["noteGrainOn"](0, x, d - x);
	};
	function stopSource(s)
	{
		try {
			if (s["stop"])
				s["stop"](0);
			else
				s["noteOff"](0);
		}
		catch (e) {}
	};
	function setAudioParam(ap, value, ramp, time)
	{
		if (!ap)
			return;		// iOS is missing some parameters
		ap["cancelScheduledValues"](0);
		if (time === 0)
		{
			ap["value"] = value;
			return;
		}
		var curTime = context["currentTime"];
		time += curTime;
		switch (ramp) {
		case 0:		// step
			ap["setValueAtTime"](value, time);
			break;
		case 1:		// linear
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["linearRampToValueAtTime"](value, time);
			break;
		case 2:		// exponential
			ap["setValueAtTime"](ap["value"], curTime);		// to set what to ramp from
			ap["exponentialRampToValueAtTime"](value, time);
			break;
		}
	};
	var filterTypes = ["lowpass", "highpass", "bandpass", "lowshelf", "highshelf", "peaking", "notch", "allpass"];
	function FilterEffect(type, freq, detune, q, gain, mix)
	{
		this.type = "filter";
		this.params = [type, freq, detune, q, gain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = type;
		else
			this.filterNode["type"] = filterTypes[type];
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.filterNode["gain"]["value"] = gain;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
	};
	FilterEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	FilterEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	FilterEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FilterEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 1:		// filter frequency
			this.params[1] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[2] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[3] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is in dB here)
			this.params[4] = value;
			setAudioParam(this.filterNode["gain"], value, ramp, time);
			break;
		}
	};
	function DelayEffect(delayTime, delayGain, mix)
	{
		this.type = "delay";
		this.params = [delayTime, delayGain, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.mainNode = createGain();
		this.delayNode = createDelay(delayTime);
		this.delayNode["delayTime"]["value"] = delayTime;
		this.delayGainNode = createGain();
		this.delayGainNode["gain"]["value"] = delayGain;
		this.inputNode["connect"](this.mainNode);
		this.inputNode["connect"](this.dryNode);
		this.mainNode["connect"](this.wetNode);
		this.mainNode["connect"](this.delayNode);
		this.delayNode["connect"](this.delayGainNode);
		this.delayGainNode["connect"](this.mainNode);
	};
	DelayEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DelayEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.mainNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.delayGainNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DelayEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DelayEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[2] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 4:		// filter/delay gain (note value is passed in dB but needs to be linear here)
			this.params[1] = dbToLinear(value);
			setAudioParam(this.delayGainNode["gain"], dbToLinear(value), ramp, time);
			break;
		case 5:		// delay time
			this.params[0] = value;
			setAudioParam(this.delayNode["delayTime"], value, ramp, time);
			break;
		}
	};
	function ConvolveEffect(buffer, normalize, mix, src)
	{
		this.type = "convolve";
		this.params = [normalize, mix, src];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.convolveNode = context["createConvolver"]();
		if (buffer)
		{
			this.convolveNode["normalize"] = normalize;
			this.convolveNode["buffer"] = buffer;
		}
		this.inputNode["connect"](this.convolveNode);
		this.inputNode["connect"](this.dryNode);
		this.convolveNode["connect"](this.wetNode);
	};
	ConvolveEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	ConvolveEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.convolveNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	ConvolveEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	ConvolveEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function FlangerEffect(delay, modulation, freq, feedback, mix)
	{
		this.type = "flanger";
		this.params = [delay, modulation, freq, feedback, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.feedbackNode = createGain();
		this.feedbackNode["gain"]["value"] = feedback;
		this.delayNode = createDelay(delay + modulation);
		this.delayNode["delayTime"]["value"] = delay;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.delayNode);
		this.inputNode["connect"](this.dryNode);
		this.delayNode["connect"](this.wetNode);
		this.delayNode["connect"](this.feedbackNode);
		this.feedbackNode["connect"](this.delayNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.delayNode["delayTime"]);
		startSource(this.oscNode);
	};
	FlangerEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	FlangerEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.delayNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.feedbackNode["disconnect"]();
	};
	FlangerEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	FlangerEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 6:		// modulation
			this.params[1] = value / 1000;
			setAudioParam(this.oscGainNode["gain"], value / 1000, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[2] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		case 8:		// feedback
			this.params[3] = value / 100;
			setAudioParam(this.feedbackNode["gain"], value / 100, ramp, time);
			break;
		}
	};
	function PhaserEffect(freq, detune, q, modulation, modfreq, mix)
	{
		this.type = "phaser";
		this.params = [freq, detune, q, modulation, modfreq, mix];
		this.inputNode = createGain();
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - (mix / 2);
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix / 2;
		this.filterNode = context["createBiquadFilter"]();
		if (typeof this.filterNode["type"] === "number")
			this.filterNode["type"] = 7;	// all-pass
		else
			this.filterNode["type"] = "allpass";
		this.filterNode["frequency"]["value"] = freq;
		if (this.filterNode["detune"])		// iOS 6 doesn't have detune yet
			this.filterNode["detune"]["value"] = detune;
		this.filterNode["Q"]["value"] = q;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = modfreq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = modulation;
		this.inputNode["connect"](this.filterNode);
		this.inputNode["connect"](this.dryNode);
		this.filterNode["connect"](this.wetNode);
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.filterNode["frequency"]);
		startSource(this.oscNode);
	};
	PhaserEffect.prototype.connectTo = function (node)
	{
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
	};
	PhaserEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.filterNode["disconnect"]();
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.dryNode["disconnect"]();
		this.wetNode["disconnect"]();
	};
	PhaserEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	PhaserEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[5] = value;
			setAudioParam(this.wetNode["gain"], value / 2, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - (value / 2), ramp, time);
			break;
		case 1:		// filter frequency
			this.params[0] = value;
			setAudioParam(this.filterNode["frequency"], value, ramp, time);
			break;
		case 2:		// filter detune
			this.params[1] = value;
			setAudioParam(this.filterNode["detune"], value, ramp, time);
			break;
		case 3:		// filter Q
			this.params[2] = value;
			setAudioParam(this.filterNode["Q"], value, ramp, time);
			break;
		case 6:		// modulation
			this.params[3] = value;
			setAudioParam(this.oscGainNode["gain"], value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[4] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function GainEffect(g)
	{
		this.type = "gain";
		this.params = [g];
		this.node = createGain();
		this.node["gain"]["value"] = g;
	};
	GainEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	GainEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	GainEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	GainEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 4:		// gain
			this.params[0] = dbToLinear(value);
			setAudioParam(this.node["gain"], dbToLinear(value), ramp, time);
			break;
		}
	};
	function TremoloEffect(freq, mix)
	{
		this.type = "tremolo";
		this.params = [freq, mix];
		this.node = createGain();
		this.node["gain"]["value"] = 1 - (mix / 2);
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscGainNode = createGain();
		this.oscGainNode["gain"]["value"] = mix / 2;
		this.oscNode["connect"](this.oscGainNode);
		this.oscGainNode["connect"](this.node["gain"]);
		startSource(this.oscNode);
	};
	TremoloEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	TremoloEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.oscGainNode["disconnect"]();
		this.node["disconnect"]();
	};
	TremoloEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	TremoloEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.node["gain"]["value"], 1 - (value / 2), ramp, time);
			setAudioParam(this.oscGainNode["gain"]["value"], value / 2, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function RingModulatorEffect(freq, mix)
	{
		this.type = "ringmod";
		this.params = [freq, mix];
		this.inputNode = createGain();
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.ringNode = createGain();
		this.ringNode["gain"]["value"] = 0;
		this.oscNode = context["createOscillator"]();
		this.oscNode["frequency"]["value"] = freq;
		this.oscNode["connect"](this.ringNode["gain"]);
		startSource(this.oscNode);
		this.inputNode["connect"](this.ringNode);
		this.inputNode["connect"](this.dryNode);
		this.ringNode["connect"](this.wetNode);
	};
	RingModulatorEffect.prototype.connectTo = function (node_)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node_);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node_);
	};
	RingModulatorEffect.prototype.remove = function ()
	{
		this.oscNode["disconnect"]();
		this.ringNode["disconnect"]();
		this.inputNode["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	RingModulatorEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	RingModulatorEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[1] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		case 7:		// modulation frequency
			this.params[0] = value;
			setAudioParam(this.oscNode["frequency"], value, ramp, time);
			break;
		}
	};
	function DistortionEffect(threshold, headroom, drive, makeupgain, mix)
	{
		this.type = "distortion";
		this.params = [threshold, headroom, drive, makeupgain, mix];
		this.inputNode = createGain();
		this.preGain = createGain();
		this.postGain = createGain();
		this.setDrive(drive, dbToLinear_nocap(makeupgain));
		this.wetNode = createGain();
		this.wetNode["gain"]["value"] = mix;
		this.dryNode = createGain();
		this.dryNode["gain"]["value"] = 1 - mix;
		this.waveShaper = context["createWaveShaper"]();
		this.curve = new Float32Array(65536);
		this.generateColortouchCurve(threshold, headroom);
		this.waveShaper.curve = this.curve;
		this.inputNode["connect"](this.preGain);
		this.inputNode["connect"](this.dryNode);
		this.preGain["connect"](this.waveShaper);
		this.waveShaper["connect"](this.postGain);
		this.postGain["connect"](this.wetNode);
	};
	DistortionEffect.prototype.setDrive = function (drive, makeupgain)
	{
		if (drive < 0.01)
			drive = 0.01;
		this.preGain["gain"]["value"] = drive;
		this.postGain["gain"]["value"] = Math.pow(1 / drive, 0.6) * makeupgain;
	};
	function e4(x, k)
	{
		return 1.0 - Math.exp(-k * x);
	}
	DistortionEffect.prototype.shape = function (x, linearThreshold, linearHeadroom)
	{
		var maximum = 1.05 * linearHeadroom * linearThreshold;
		var kk = (maximum - linearThreshold);
		var sign = x < 0 ? -1 : +1;
		var absx = x < 0 ? -x : x;
		var shapedInput = absx < linearThreshold ? absx : linearThreshold + kk * e4(absx - linearThreshold, 1.0 / kk);
		shapedInput *= sign;
		return shapedInput;
	};
	DistortionEffect.prototype.generateColortouchCurve = function (threshold, headroom)
	{
		var linearThreshold = dbToLinear_nocap(threshold);
		var linearHeadroom = dbToLinear_nocap(headroom);
		var n = 65536;
		var n2 = n / 2;
		var x = 0;
		for (var i = 0; i < n2; ++i) {
			x = i / n2;
			x = this.shape(x, linearThreshold, linearHeadroom);
			this.curve[n2 + i] = x;
			this.curve[n2 - i - 1] = -x;
		}
	};
	DistortionEffect.prototype.connectTo = function (node)
	{
		this.wetNode["disconnect"]();
		this.wetNode["connect"](node);
		this.dryNode["disconnect"]();
		this.dryNode["connect"](node);
	};
	DistortionEffect.prototype.remove = function ()
	{
		this.inputNode["disconnect"]();
		this.preGain["disconnect"]();
		this.waveShaper["disconnect"]();
		this.postGain["disconnect"]();
		this.wetNode["disconnect"]();
		this.dryNode["disconnect"]();
	};
	DistortionEffect.prototype.getInputNode = function ()
	{
		return this.inputNode;
	};
	DistortionEffect.prototype.setParam = function(param, value, ramp, time)
	{
		switch (param) {
		case 0:		// mix
			value = value / 100;
			if (value < 0) value = 0;
			if (value > 1) value = 1;
			this.params[4] = value;
			setAudioParam(this.wetNode["gain"], value, ramp, time);
			setAudioParam(this.dryNode["gain"], 1 - value, ramp, time);
			break;
		}
	};
	function CompressorEffect(threshold, knee, ratio, attack, release)
	{
		this.type = "compressor";
		this.params = [threshold, knee, ratio, attack, release];
		this.node = context["createDynamicsCompressor"]();
		try {
			this.node["threshold"]["value"] = threshold;
			this.node["knee"]["value"] = knee;
			this.node["ratio"]["value"] = ratio;
			this.node["attack"]["value"] = attack;
			this.node["release"]["value"] = release;
		}
		catch (e) {}
	};
	CompressorEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	CompressorEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	CompressorEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	CompressorEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	function AnalyserEffect(fftSize, smoothing)
	{
		this.type = "analyser";
		this.params = [fftSize, smoothing];
		this.node = context["createAnalyser"]();
		this.node["fftSize"] = fftSize;
		this.node["smoothingTimeConstant"] = smoothing;
		this.freqBins = new Float32Array(this.node["frequencyBinCount"]);
		this.signal = new Uint8Array(fftSize);
		this.peak = 0;
		this.rms = 0;
	};
	AnalyserEffect.prototype.tick = function ()
	{
		this.node["getFloatFrequencyData"](this.freqBins);
		this.node["getByteTimeDomainData"](this.signal);
		var fftSize = this.node["fftSize"];
		var i = 0;
		this.peak = 0;
		var rmsSquaredSum = 0;
		var s = 0;
		for ( ; i < fftSize; i++)
		{
			s = (this.signal[i] - 128) / 128;
			if (s < 0)
				s = -s;
			if (this.peak < s)
				this.peak = s;
			rmsSquaredSum += s * s;
		}
		this.peak = linearToDb(this.peak);
		this.rms = linearToDb(Math.sqrt(rmsSquaredSum / fftSize));
	};
	AnalyserEffect.prototype.connectTo = function (node_)
	{
		this.node["disconnect"]();
		this.node["connect"](node_);
	};
	AnalyserEffect.prototype.remove = function ()
	{
		this.node["disconnect"]();
	};
	AnalyserEffect.prototype.getInputNode = function ()
	{
		return this.node;
	};
	AnalyserEffect.prototype.setParam = function(param, value, ramp, time)
	{
	};
	var OT_POS_SAMPLES = 4;
	function ObjectTracker()
	{
		this.obj = null;
		this.loadUid = 0;
		this.speeds = [];
		this.lastX = 0;
		this.lastY = 0;
		this.moveAngle = 0;
	};
	ObjectTracker.prototype.setObject = function (obj_)
	{
		this.obj = obj_;
		if (this.obj)
		{
			this.lastX = this.obj.x;
			this.lastY = this.obj.y;
		}
		this.speeds.length = 0;
	};
	ObjectTracker.prototype.hasObject = function ()
	{
		return !!this.obj;
	};
	ObjectTracker.prototype.tick = function (dt)
	{
		if (!this.obj || dt === 0)
			return;
		this.moveAngle = cr.angleTo(this.lastX, this.lastY, this.obj.x, this.obj.y);
		var s = cr.distanceTo(this.lastX, this.lastY, this.obj.x, this.obj.y) / dt;
		if (this.speeds.length < OT_POS_SAMPLES)
			this.speeds.push(s);
		else
		{
			this.speeds.shift();
			this.speeds.push(s);
		}
		this.lastX = this.obj.x;
		this.lastY = this.obj.y;
	};
	ObjectTracker.prototype.getSpeed = function ()
	{
		if (!this.speeds.length)
			return 0;
		var i, len, sum = 0;
		for (i = 0, len = this.speeds.length; i < len; i++)
		{
			sum += this.speeds[i];
		}
		return sum / this.speeds.length;
	};
	ObjectTracker.prototype.getVelocityX = function ()
	{
		return Math.cos(this.moveAngle) * this.getSpeed();
	};
	ObjectTracker.prototype.getVelocityY = function ()
	{
		return Math.sin(this.moveAngle) * this.getSpeed();
	};
	var iOShadtouch = false;	// has had touch input on iOS to work around web audio API muting
	function C2AudioBuffer(src_, is_music)
	{
		this.src = src_;
		this.myapi = api;
		this.is_music = is_music;
		this.added_end_listener = false;
		var self = this;
		this.outNode = null;
		this.mediaSourceNode = null;
		this.panWhenReady = [];		// for web audio API positioned sounds
		this.seekWhenReady = 0;
		this.pauseWhenReady = false;
		this.supportWebAudioAPI = false;
		this.failedToLoad = false;
		this.wasEverReady = false;	// if a buffer is ever marked as ready, it's permanently considered ready after then.
		if (api === API_WEBAUDIO && is_music)
		{
			this.myapi = API_HTML5;
			this.outNode = createGain();
		}
		this.bufferObject = null;			// actual audio object
		this.audioData = null;				// web audio api: ajax request result (compressed audio that needs decoding)
		var request;
		switch (this.myapi) {
		case API_HTML5:
			this.bufferObject = new Audio();
			this.bufferObject.addEventListener("canplaythrough", function () {
				self.wasEverReady = true;	// update loaded state so preload is considered complete
			});
			if (api === API_WEBAUDIO && context["createMediaElementSource"] && !audRuntime.isFirefox && !/wiiu/i.test(navigator.userAgent))
			{
				this.supportWebAudioAPI = true;		// can be routed through web audio api
				this.bufferObject.addEventListener("canplay", function ()
				{
					if (!self.mediaSourceNode)		// protect against this event firing twice
					{
						self.mediaSourceNode = context["createMediaElementSource"](self.bufferObject);
						self.mediaSourceNode["connect"](self.outNode);
					}
				});
			}
			this.bufferObject.autoplay = false;	// this is only a source buffer, not an instance
			this.bufferObject.preload = "auto";
			this.bufferObject.src = src_;
			break;
		case API_WEBAUDIO:
			request = new XMLHttpRequest();
			request.open("GET", src_, true);
			request.responseType = "arraybuffer";
			request.onload = function () {
				self.audioData = request.response;
				self.decodeAudioBuffer();
			};
			request.onerror = function () {
				self.failedToLoad = true;
			};
			request.send();
			break;
		case API_PHONEGAP:
			this.bufferObject = true;
			break;
		case API_APPMOBI:
			this.bufferObject = true;
			break;
		}
	};
	C2AudioBuffer.prototype.decodeAudioBuffer = function ()
	{
		if (this.bufferObject || !this.audioData)
			return;		// audio already decoded or AJAX request not yet complete
		var self = this;
		if (context["decodeAudioData"])
		{
			context["decodeAudioData"](this.audioData, function (buffer) {
					self.bufferObject = buffer;
					self.audioData = null;		// clear AJAX response to allow GC and save memory, only need the bufferObject now
					var p, i, len, a;
					if (!cr.is_undefined(self.playTagWhenReady) && !silent)
					{
						if (self.panWhenReady.length)
						{
							for (i = 0, len = self.panWhenReady.length; i < len; i++)
							{
								p = self.panWhenReady[i];
								a = new C2AudioInstance(self, p.thistag);
								a.setPannerEnabled(true);
								if (typeof p.objUid !== "undefined")
								{
									p.obj = audRuntime.getObjectByUID(p.objUid);
									if (!p.obj)
										continue;
								}
								if (p.obj)
								{
									var px = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, true);
									var py = cr.rotatePtAround(p.obj.x, p.obj.y, -p.obj.layer.getAngle(), listenerX, listenerY, false);
									a.setPan(px, py, cr.to_degrees(p.obj.angle - p.obj.layer.getAngle()), p.ia, p.oa, p.og);
									a.setObject(p.obj);
								}
								else
								{
									a.setPan(p.x, p.y, p.a, p.ia, p.oa, p.og);
								}
								a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
								if (self.pauseWhenReady)
									a.pause();
								audioInstances.push(a);
							}
							self.panWhenReady.length = 0;
						}
						else
						{
							a = new C2AudioInstance(self, self.playTagWhenReady);
							a.play(self.loopWhenReady, self.volumeWhenReady, self.seekWhenReady);
							if (self.pauseWhenReady)
								a.pause();
							audioInstances.push(a);
						}
					}
					else if (!cr.is_undefined(self.convolveWhenReady))
					{
						var convolveNode = self.convolveWhenReady.convolveNode;
						convolveNode["normalize"] = self.normalizeWhenReady;
						convolveNode["buffer"] = buffer;
					}
			}, function (e) {
				self.failedToLoad = true;
			});
		}
		else
		{
			this.bufferObject = context["createBuffer"](this.audioData, false);
			this.audioData = null;		// clear AJAX response to allow GC and save memory, only need the bufferObject now
			if (!cr.is_undefined(this.playTagWhenReady) && !silent)
			{
				var a = new C2AudioInstance(this, this.playTagWhenReady);
				a.play(this.loopWhenReady, this.volumeWhenReady, this.seekWhenReady);
				if (this.pauseWhenReady)
					a.pause();
				audioInstances.push(a);
			}
			else if (!cr.is_undefined(this.convolveWhenReady))
			{
				var convolveNode = this.convolveWhenReady.convolveNode;
				convolveNode["normalize"] = this.normalizeWhenReady;
				convolveNode["buffer"] = this.bufferObject;
			}
		}
	};
	C2AudioBuffer.prototype.isLoaded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			var ret = this.bufferObject["readyState"] >= 4;	// HAVE_ENOUGH_DATA
			if (ret)
				this.wasEverReady = true;
			return ret || this.wasEverReady;
		case API_WEBAUDIO:
			return !!this.audioData || !!this.bufferObject;
		case API_PHONEGAP:
			return true;
		case API_APPMOBI:
			return true;
		}
		return false;
	};
	C2AudioBuffer.prototype.isLoadedAndDecoded = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return this.isLoaded();		// no distinction between loaded and decoded in HTML5 audio, just rely on ready state
		case API_WEBAUDIO:
			return !!this.bufferObject;
		case API_PHONEGAP:
			return true;
		case API_APPMOBI:
			return true;
		}
		return false;
	};
	C2AudioBuffer.prototype.hasFailedToLoad = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			return !!this.bufferObject["error"];
		case API_WEBAUDIO:
			return this.failedToLoad;
		}
		return false;
	};
	function C2AudioInstance(buffer_, tag_)
	{
		var self = this;
		this.tag = tag_;
		this.fresh = true;
		this.stopped = true;
		this.src = buffer_.src;
		this.buffer = buffer_;
		this.myapi = api;
		this.is_music = buffer_.is_music;
		this.playbackRate = 1;
		this.pgended = true;			// for PhoneGap only: ended flag
		this.resume_me = false;			// make sure resumes when leaving suspend
		this.is_paused = false;
		this.resume_position = 0;		// for web audio api to resume from correct playback position
		this.looping = false;
		this.is_muted = false;
		this.is_silent = false;
		this.volume = 1;
		this.isTimescaled = ((timescale_mode === 1 && !this.is_music) || timescale_mode === 2);
		this.mutevol = 1;
		this.startTime = (this.isTimescaled ? audRuntime.kahanTime.sum : audRuntime.wallTime.sum);
		this.gainNode = null;
		this.pannerNode = null;
		this.pannerEnabled = false;
		this.objectTracker = null;
		this.panX = 0;
		this.panY = 0;
		this.panAngle = 0;
		this.panConeInner = 0;
		this.panConeOuter = 0;
		this.panConeOuterGain = 0;
		this.instanceObject = null;
		var add_end_listener = false;
		if (this.myapi === API_WEBAUDIO && this.buffer.myapi === API_HTML5 && !this.buffer.supportWebAudioAPI)
			this.myapi = API_HTML5;
		switch (this.myapi) {
		case API_HTML5:
			if (this.is_music)
			{
				this.instanceObject = buffer_.bufferObject;
				add_end_listener = !buffer_.added_end_listener;
				buffer_.added_end_listener = true;
			}
			else
			{
				this.instanceObject = new Audio();
				this.instanceObject.autoplay = false;
				this.instanceObject.src = buffer_.bufferObject.src;
				add_end_listener = true;
			}
			if (add_end_listener)
			{
				this.instanceObject.addEventListener('ended', function () {
						audTag = self.tag;
						self.stopped = true;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				});
			}
			break;
		case API_WEBAUDIO:
			this.gainNode = createGain();
			this.gainNode["connect"](getDestinationForTag(tag_));
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (buffer_.bufferObject)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = buffer_.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
			}
			else
			{
				this.instanceObject = this.buffer.bufferObject;		// reference the audio element
				this.buffer.outNode["connect"](this.gainNode);
			}
			break;
		case API_PHONEGAP:
			this.instanceObject = new window["Media"](appPath + this.src, null, null, function (status) {
					if (status === window["Media"]["MEDIA_STOPPED"])
					{
						self.pgended = true;
						self.stopped = true;
						audTag = self.tag;
						audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
					}
			});
			break;
		case API_APPMOBI:
			this.instanceObject = true;
			break;
		}
	};
	C2AudioInstance.prototype.hasEnded = function ()
	{
		var time;
		switch (this.myapi) {
		case API_HTML5:
			return this.instanceObject.ended;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh && !this.stopped && this.instanceObject["loop"])
					return false;
				if (this.is_paused)
					return false;
				if (this.isTimescaled)
					time = audRuntime.kahanTime.sum;
				else
					time = audRuntime.wallTime.sum;
				return (time - this.startTime) > this.buffer.bufferObject["duration"];
			}
			else
				return this.instanceObject.ended;
		case API_PHONEGAP:
			return this.pgended;
		case API_APPMOBI:
			true;	// recycling an AppMobi sound does not matter because it will just do another throwaway playSound
		}
		return true;
	};
	C2AudioInstance.prototype.canBeRecycled = function ()
	{
		if (this.fresh || this.stopped)
			return true;		// not yet used or is not playing
		return this.hasEnded();
	};
	C2AudioInstance.prototype.setPannerEnabled = function (enable_)
	{
		if (api !== API_WEBAUDIO)
			return;
		if (!this.pannerEnabled && enable_)
		{
			if (!this.gainNode)
				return;
			if (!this.pannerNode)
			{
				this.pannerNode = context["createPanner"]();
				if (typeof this.pannerNode["panningModel"] === "number")
					this.pannerNode["panningModel"] = panningModel;
				else
					this.pannerNode["panningModel"] = ["equalpower", "HRTF", "soundfield"][panningModel];
				if (typeof this.pannerNode["distanceModel"] === "number")
					this.pannerNode["distanceModel"] = distanceModel;
				else
					this.pannerNode["distanceModel"] = ["linear", "inverse", "exponential"][distanceModel];
				this.pannerNode["refDistance"] = refDistance;
				this.pannerNode["maxDistance"] = maxDistance;
				this.pannerNode["rolloffFactor"] = rolloffFactor;
			}
			this.gainNode["disconnect"]();
			this.gainNode["connect"](this.pannerNode);
			this.pannerNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = true;
		}
		else if (this.pannerEnabled && !enable_)
		{
			if (!this.gainNode)
				return;
			this.pannerNode["disconnect"]();
			this.gainNode["disconnect"]();
			this.gainNode["connect"](getDestinationForTag(this.tag));
			this.pannerEnabled = false;
		}
	};
	C2AudioInstance.prototype.setPan = function (x, y, angle, innerangle, outerangle, outergain)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		this.pannerNode["setPosition"](x, y, 0);
		this.pannerNode["setOrientation"](Math.cos(cr.to_radians(angle)), Math.sin(cr.to_radians(angle)), 0);
		this.pannerNode["coneInnerAngle"] = innerangle;
		this.pannerNode["coneOuterAngle"] = outerangle;
		this.pannerNode["coneOuterGain"] = outergain;
		this.panX = x;
		this.panY = y;
		this.panAngle = angle;
		this.panConeInner = innerangle;
		this.panConeOuter = outerangle;
		this.panConeOuterGain = outergain;
	};
	C2AudioInstance.prototype.setObject = function (o)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO)
			return;
		if (!this.objectTracker)
			this.objectTracker = new ObjectTracker();
		this.objectTracker.setObject(o);
	};
	C2AudioInstance.prototype.tick = function (dt)
	{
		if (!this.pannerEnabled || api !== API_WEBAUDIO || !this.objectTracker || !this.objectTracker.hasObject() || !this.isPlaying())
		{
			return;
		}
		this.objectTracker.tick(dt);
		var inst = this.objectTracker.obj;
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		this.pannerNode["setPosition"](px, py, 0);
		var a = 0;
		if (typeof this.objectTracker.obj.angle !== "undefined")
		{
			a = inst.angle - inst.layer.getAngle();
			this.pannerNode["setOrientation"](Math.cos(a), Math.sin(a), 0);
		}
		px = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, true);
		py = cr.rotatePtAround(this.objectTracker.getVelocityX(), this.objectTracker.getVelocityY(), -inst.layer.getAngle(), 0, 0, false);
		this.pannerNode["setVelocity"](px, py, 0);
	};
	C2AudioInstance.prototype.play = function (looping, vol, fromPosition)
	{
		var instobj = this.instanceObject;
		this.looping = looping;
		this.volume = vol;
		var seekPos = fromPosition || 0;
		switch (this.myapi) {
		case API_HTML5:
			if (instobj.playbackRate !== 1.0)
				instobj.playbackRate = 1.0;
			if (instobj.volume !== vol * masterVolume)
				instobj.volume = vol * masterVolume;
			if (instobj.loop !== looping)
				instobj.loop = looping;
			if (instobj.muted)
				instobj.muted = false;
			if (instobj.currentTime !== seekPos)
			{
				try {
					instobj.currentTime = seekPos;
				}
				catch (err)
				{
;
				}
			}
			if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
				musicPlayNextTouch.push(this);
			else
			{
				try {
					this.instanceObject.play();
				}
				catch (e) {		// sometimes throws on WP8.1... try not to kill the app
					if (console && console.log)
						console.log("[C2] WARNING: exception trying to play audio '" + this.buffer.src + "': ", e);
				}
			}
			break;
		case API_WEBAUDIO:
			this.muted = false;
			this.mutevol = 1;
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (!this.fresh)
				{
					this.instanceObject = context["createBufferSource"]();
					this.instanceObject["buffer"] = this.buffer.bufferObject;
					this.instanceObject["connect"](this.gainNode);
				}
				this.instanceObject.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (seekPos === 0)
					startSource(this.instanceObject);
				else
					startSourceAt(this.instanceObject, seekPos, this.getDuration());
			}
			else
			{
				if (instobj.playbackRate !== 1.0)
					instobj.playbackRate = 1.0;
				if (instobj.loop !== looping)
					instobj.loop = looping;
				this.gainNode["gain"]["value"] = vol * masterVolume;
				if (instobj.currentTime !== seekPos)
				{
					try {
						instobj.currentTime = seekPos;
					}
					catch (err)
					{
;
					}
				}
				if (this.is_music && isMusicWorkaround && !audRuntime.isInUserInputEvent)
					musicPlayNextTouch.push(this);
				else
					instobj.play();
			}
			break;
		case API_PHONEGAP:
			if ((!this.fresh && this.stopped) || seekPos !== 0)
				instobj["seekTo"](seekPos);
			instobj["play"]();
			this.pgended = false;
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["playSound"](this.src, looping);
			else
				AppMobi["player"]["playSound"](this.src, looping);
			break;
		}
		this.playbackRate = 1;
		this.startTime = (this.isTimescaled ? audRuntime.kahanTime.sum : audRuntime.wallTime.sum) - seekPos;
		this.fresh = false;
		this.stopped = false;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.stop = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
				stopSource(this.instanceObject);
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["stop"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.stopped = true;
		this.is_paused = false;
	};
	C2AudioInstance.prototype.pause = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			if (!this.instanceObject.paused)
				this.instanceObject.pause();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.resume_position = this.getPlaybackTime();
				if (this.looping)
					this.resume_position = this.resume_position % this.getDuration();
				stopSource(this.instanceObject);
			}
			else
			{
				if (!this.instanceObject.paused)
					this.instanceObject.pause();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["pause"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["stopSound"](this.src);
			break;
		}
		this.is_paused = true;
	};
	C2AudioInstance.prototype.resume = function ()
	{
		if (this.fresh || this.stopped || this.hasEnded() || !this.is_paused)
			return;
		switch (this.myapi) {
		case API_HTML5:
			this.instanceObject.play();
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				this.instanceObject = context["createBufferSource"]();
				this.instanceObject["buffer"] = this.buffer.bufferObject;
				this.instanceObject["connect"](this.gainNode);
				this.instanceObject.loop = this.looping;
				this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
				this.startTime = (this.isTimescaled ? audRuntime.kahanTime.sum : audRuntime.wallTime.sum) - this.resume_position;
				startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
			}
			else
			{
				this.instanceObject.play();
			}
			break;
		case API_PHONEGAP:
			this.instanceObject["play"]();
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["resumeSound"](this.src);
			break;
		}
		this.is_paused = false;
	};
	C2AudioInstance.prototype.seek = function (pos)
	{
		if (this.fresh || this.stopped || this.hasEnded())
			return;
		switch (this.myapi) {
		case API_HTML5:
			try {
				this.instanceObject.currentTime = pos;
			}
			catch (e) {}
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					this.resume_position = pos;
				else
				{
					this.pause();
					this.resume_position = pos;
					this.resume();
				}
			}
			else
			{
				try {
					this.instanceObject.currentTime = pos;
				}
				catch (e) {}
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["seekSound"](this.src, pos);
			break;
		}
	};
	C2AudioInstance.prototype.reconnect = function (toNode)
	{
		if (this.myapi !== API_WEBAUDIO)
			return;
		if (this.pannerEnabled)
		{
			this.pannerNode["disconnect"]();
			this.pannerNode["connect"](toNode);
		}
		else
		{
			this.gainNode["disconnect"]();
			this.gainNode["connect"](toNode);
		}
	};
	C2AudioInstance.prototype.getDuration = function ()
	{
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.duration !== "undefined")
				return this.instanceObject.duration;
			else
				return 0;
		case API_WEBAUDIO:
			return this.buffer.bufferObject["duration"];
		case API_PHONEGAP:
			return this.instanceObject["getDuration"]();
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				return AppMobi["context"]["getDurationSound"](this.src);
			else
				return 0;
		}
		return 0;
	};
	C2AudioInstance.prototype.getPlaybackTime = function ()
	{
		var duration = this.getDuration();
		var ret = 0;
		switch (this.myapi) {
		case API_HTML5:
			if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.is_paused)
					return this.resume_position;
				else
					ret = (this.isTimescaled ? audRuntime.kahanTime.sum : audRuntime.wallTime.sum) - this.startTime;
			}
			else if (typeof this.instanceObject.currentTime !== "undefined")
				ret = this.instanceObject.currentTime;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				ret = AppMobi["context"]["getPlaybackTimeSound"](this.src);
			break;
		}
		if (!this.looping && ret > duration)
			ret = duration;
		return ret;
	};
	C2AudioInstance.prototype.isPlaying = function ()
	{
		return !this.is_paused && !this.fresh && !this.stopped && !this.hasEnded();
	};
	C2AudioInstance.prototype.setVolume = function (v)
	{
		this.volume = v;
		this.updateVolume();
	};
	C2AudioInstance.prototype.updateVolume = function ()
	{
		var volToSet = this.volume * masterVolume;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.volume && this.instanceObject.volume !== volToSet)
				this.instanceObject.volume = volToSet;
			break;
		case API_WEBAUDIO:
			this.gainNode["gain"]["value"] = volToSet * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.getVolume = function ()
	{
		return this.volume;
	};
	C2AudioInstance.prototype.doSetMuted = function (m)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.muted !== !!m)
				this.instanceObject.muted = !!m;
			break;
		case API_WEBAUDIO:
			this.mutevol = (m ? 0 : 1);
			this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setMuted = function (m)
	{
		this.is_muted = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setSilent = function (m)
	{
		this.is_silent = !!m;
		this.doSetMuted(this.is_muted || this.is_silent);
	};
	C2AudioInstance.prototype.setLooping = function (l)
	{
		this.looping = l;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_WEBAUDIO:
			if (this.instanceObject.loop !== !!l)
				this.instanceObject.loop = !!l;
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			if (audRuntime.isDirectCanvas)
				AppMobi["context"]["setLoopingSound"](this.src, l);
			break;
		}
	};
	C2AudioInstance.prototype.setPlaybackRate = function (r)
	{
		this.playbackRate = r;
		this.updatePlaybackRate();
	};
	C2AudioInstance.prototype.updatePlaybackRate = function ()
	{
		var r = this.playbackRate;
		if (this.isTimescaled)
			r *= audRuntime.timescale;
		switch (this.myapi) {
		case API_HTML5:
			if (this.instanceObject.playbackRate !== r)
				this.instanceObject.playbackRate = r;
			break;
		case API_WEBAUDIO:
			if (this.buffer.myapi === API_WEBAUDIO)
			{
				if (this.instanceObject["playbackRate"]["value"] !== r)
					this.instanceObject["playbackRate"]["value"] = r;
			}
			else
			{
				if (this.instanceObject.playbackRate !== r)
					this.instanceObject.playbackRate = r;
			}
			break;
		case API_PHONEGAP:
			break;
		case API_APPMOBI:
			break;
		}
	};
	C2AudioInstance.prototype.setSuspended = function (s)
	{
		switch (this.myapi) {
		case API_HTML5:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_WEBAUDIO:
			if (s)
			{
				if (this.isPlaying())
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.resume_position = this.getPlaybackTime();
						if (this.looping)
							this.resume_position = this.resume_position % this.getDuration();
						stopSource(this.instanceObject);
					}
					else
						this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
				{
					if (this.buffer.myapi === API_WEBAUDIO)
					{
						this.instanceObject = context["createBufferSource"]();
						this.instanceObject["buffer"] = this.buffer.bufferObject;
						this.instanceObject["connect"](this.gainNode);
						this.instanceObject.loop = this.looping;
						this.gainNode["gain"]["value"] = masterVolume * this.volume * this.mutevol;
						this.startTime = (this.isTimescaled ? audRuntime.kahanTime.sum : audRuntime.wallTime.sum) - this.resume_position;
						startSourceAt(this.instanceObject, this.resume_position, this.getDuration());
					}
					else
					{
						this.instanceObject["play"]();
					}
				}
			}
			break;
		case API_PHONEGAP:
			if (s)
			{
				if (this.isPlaying())
				{
					this.instanceObject["pause"]();
					this.resume_me = true;
				}
				else
					this.resume_me = false;
			}
			else
			{
				if (this.resume_me)
					this.instanceObject["play"]();
			}
			break;
		case API_APPMOBI:
			break;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		audRuntime = this.runtime;
		audInst = this;
		this.listenerTracker = null;
		this.listenerZ = -600;
		if ((this.runtime.isiOS || (this.runtime.isAndroid && (this.runtime.isChrome || this.runtime.isAndroidStockBrowser))) && !this.runtime.isCrosswalk && !this.runtime.isDomFree)
		{
			isMusicWorkaround = true;
		}
		context = null;
		if (typeof AudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new AudioContext();
		}
		else if (typeof webkitAudioContext !== "undefined")
		{
			api = API_WEBAUDIO;
			context = new webkitAudioContext();
		}
		if ((this.runtime.isiOS && api === API_WEBAUDIO) || isMusicWorkaround)
		{
			document.addEventListener("touchstart", function ()
			{
				var i, len, m;
				if (!iOShadtouch && context)
				{
					var buffer = context["createBuffer"](1, 1, 22050);
					var source = context["createBufferSource"]();
					source["buffer"] = buffer;
					source["connect"](context["destination"]);
					startSource(source);
					iOShadtouch = true;
				}
				if (isMusicWorkaround)
				{
					if (!silent)
					{
						for (i = 0, len = musicPlayNextTouch.length; i < len; ++i)
						{
							m = musicPlayNextTouch[i];
							if (!m.stopped && !m.is_paused)
								m.instanceObject.play();
						}
					}
					musicPlayNextTouch.length = 0;
				}
			}, true);
		}
		if (api !== API_WEBAUDIO)
		{
			if (this.runtime.isPhoneGap && typeof window["Media"] !== "undefined")
				api = API_PHONEGAP;
			else if (this.runtime.isAppMobi)
				api = API_APPMOBI;
		}
		if (api === API_PHONEGAP)
		{
			appPath = location.href;
			var i = appPath.lastIndexOf("/");
			if (i > -1)
				appPath = appPath.substr(0, i + 1);
			appPath = appPath.replace("file://", "");
		}
		if (this.runtime.isSafari && this.runtime.isWindows && typeof Audio === "undefined")
		{
			alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed.");
			this.runtime.DestroyInstance(this);
		}
		else
		{
			if (this.runtime.isDirectCanvas)
				useOgg = this.runtime.isAndroid;		// AAC on iOS, OGG on Android
			else
			{
				try {
					useOgg = !!(new Audio().canPlayType('audio/ogg; codecs="vorbis"'));
				}
				catch (e)
				{
					useOgg = false;
				}
			}
			switch (api) {
			case API_HTML5:
;
				break;
			case API_WEBAUDIO:
;
				break;
			case API_PHONEGAP:
;
				break;
			case API_APPMOBI:
;
				break;
			default:
;
			}
			this.runtime.tickMe(this);
		}
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function ()
	{
		this.runtime.audioInstance = this;
		timescale_mode = this.properties[0];	// 0 = off, 1 = sounds only, 2 = all
		this.saveload = this.properties[1];		// 0 = all, 1 = sounds only, 2 = music only, 3 = none
		this.playinbackground = (this.properties[2] !== 0);
		panningModel = this.properties[3];		// 0 = equalpower, 1 = hrtf, 3 = soundfield
		distanceModel = this.properties[4];		// 0 = linear, 1 = inverse, 2 = exponential
		this.listenerZ = -this.properties[5];
		refDistance = this.properties[6];
		maxDistance = this.properties[7];
		rolloffFactor = this.properties[8];
		this.listenerTracker = new ObjectTracker();
		if (api === API_WEBAUDIO)
		{
			context["listener"]["speedOfSound"] = this.properties[9];
			context["listener"]["dopplerFactor"] = this.properties[10];
			context["listener"]["setPosition"](this.runtime.draw_width / 2, this.runtime.draw_height / 2, this.listenerZ);
			context["listener"]["setOrientation"](0, 0, 1, 0, -1, 0);
			window["c2OnAudioMicStream"] = function (localMediaStream, tag)
			{
				if (micSource)
					micSource["disconnect"]();
				micTag = tag.toLowerCase();
				micSource = context["createMediaStreamSource"](localMediaStream);
				micSource["connect"](getDestinationForTag(micTag));
			};
		}
		this.runtime.addSuspendCallback(function(s)
		{
			audInst.onSuspend(s);
		});
		var self = this;
		this.runtime.addDestroyCallback(function (inst)
		{
			self.onInstanceDestroyed(inst);
		});
	};
	instanceProto.onInstanceDestroyed = function (inst)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.objectTracker)
			{
				if (a.objectTracker.obj === inst)
				{
					a.objectTracker.obj = null;
					if (a.pannerEnabled && a.isPlaying() && a.looping)
						a.stop();
				}
			}
		}
		if (this.listenerTracker.obj === inst)
			this.listenerTracker.obj = null;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"silent": silent,
			"masterVolume": masterVolume,
			"listenerZ": this.listenerZ,
			"listenerUid": this.listenerTracker.hasObject() ? this.listenerTracker.obj.uid : -1,
			"playing": [],
			"effects": {}
		};
		var playingarr = o["playing"];
		var i, len, a, d, p, panobj, playbackTime;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (!a.isPlaying())
				continue;				// no need to save stopped sounds
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			if (a.is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!a.is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			playbackTime = a.getPlaybackTime();
			if (a.looping)
				playbackTime = playbackTime % a.getDuration();
			d = {
				"tag": a.tag,
				"buffersrc": a.buffer.src,
				"is_music": a.is_music,
				"playbackTime": playbackTime,
				"volume": a.volume,
				"looping": a.looping,
				"muted": a.is_muted,
				"playbackRate": a.playbackRate,
				"paused": a.is_paused,
				"resume_position": a.resume_position
			};
			if (a.pannerEnabled)
			{
				d["pan"] = {};
				panobj = d["pan"];
				if (a.objectTracker && a.objectTracker.hasObject())
				{
					panobj["objUid"] = a.objectTracker.obj.uid;
				}
				else
				{
					panobj["x"] = a.panX;
					panobj["y"] = a.panY;
					panobj["a"] = a.panAngle;
				}
				panobj["ia"] = a.panConeInner;
				panobj["oa"] = a.panConeOuter;
				panobj["og"] = a.panConeOuterGain;
			}
			playingarr.push(d);
		}
		var fxobj = o["effects"];
		var fxarr;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				fxarr = [];
				for (i = 0, len = effects[p].length; i < len; i++)
				{
					fxarr.push({ "type": effects[p][i].type, "params": effects[p][i].params });
				}
				fxobj[p] = fxarr;
			}
		}
		return o;
	};
	var objectTrackerUidsToLoad = [];
	instanceProto.loadFromJSON = function (o)
	{
		var setSilent = o["silent"];
		masterVolume = o["masterVolume"];
		this.listenerZ = o["listenerZ"];
		this.listenerTracker.setObject(null);
		var listenerUid = o["listenerUid"];
		if (listenerUid !== -1)
		{
			this.listenerTracker.loadUid = listenerUid;
			objectTrackerUidsToLoad.push(this.listenerTracker);
		}
		var playingarr = o["playing"];
		var i, len, d, src, is_music, tag, playbackTime, looping, vol, b, a, p, pan, panObjUid;
		if (this.saveload !== 3)
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
			{
				a = audioInstances[i];
				if (a.is_music && this.saveload === 1)
					continue;		// only saving/loading sound: leave music playing
				if (!a.is_music && this.saveload === 2)
					continue;		// only saving/loading music: leave sound playing
				a.stop();
			}
		}
		var fxarr, fxtype, fxparams, fx;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				for (i = 0, len = effects[p].length; i < len; i++)
					effects[p][i].remove();
			}
		}
		cr.wipe(effects);
		for (p in o["effects"])
		{
			if (o["effects"].hasOwnProperty(p))
			{
				fxarr = o["effects"][p];
				for (i = 0, len = fxarr.length; i < len; i++)
				{
					fxtype = fxarr[i]["type"];
					fxparams = fxarr[i]["params"];
					switch (fxtype) {
					case "filter":
						addEffectForTag(p, new FilterEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "delay":
						addEffectForTag(p, new DelayEffect(fxparams[0], fxparams[1], fxparams[2]));
						break;
					case "convolve":
						src = fxparams[2];
						b = this.getAudioBuffer(src, false);
						if (b.bufferObject)
						{
							fx = new ConvolveEffect(b.bufferObject, fxparams[0], fxparams[1], src);
						}
						else
						{
							fx = new ConvolveEffect(null, fxparams[0], fxparams[1], src);
							b.normalizeWhenReady = fxparams[0];
							b.convolveWhenReady = fx;
						}
						addEffectForTag(p, fx);
						break;
					case "flanger":
						addEffectForTag(p, new FlangerEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "phaser":
						addEffectForTag(p, new PhaserEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4], fxparams[5]));
						break;
					case "gain":
						addEffectForTag(p, new GainEffect(fxparams[0]));
						break;
					case "tremolo":
						addEffectForTag(p, new TremoloEffect(fxparams[0], fxparams[1]));
						break;
					case "ringmod":
						addEffectForTag(p, new RingModulatorEffect(fxparams[0], fxparams[1]));
						break;
					case "distortion":
						addEffectForTag(p, new DistortionEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "compressor":
						addEffectForTag(p, new CompressorEffect(fxparams[0], fxparams[1], fxparams[2], fxparams[3], fxparams[4]));
						break;
					case "analyser":
						addEffectForTag(p, new AnalyserEffect(fxparams[0], fxparams[1]));
						break;
					}
				}
			}
		}
		for (i = 0, len = playingarr.length; i < len; i++)
		{
			if (this.saveload === 3)	// not saving/loading any sounds/music
				continue;
			d = playingarr[i];
			src = d["buffersrc"];
			is_music = d["is_music"];
			tag = d["tag"];
			playbackTime = d["playbackTime"];
			looping = d["looping"];
			vol = d["volume"];
			pan = d["pan"];
			panObjUid = (pan && pan.hasOwnProperty("objUid")) ? pan["objUid"] : -1;
			if (is_music && this.saveload === 1)	// not saving/loading music
				continue;
			if (!is_music && this.saveload === 2)	// not saving/loading sound
				continue;
			a = this.getAudioInstance(src, tag, is_music, looping, vol);
			if (!a)
			{
				b = this.getAudioBuffer(src, is_music);
				b.seekWhenReady = playbackTime;
				b.pauseWhenReady = d["paused"];
				if (pan)
				{
					if (panObjUid !== -1)
					{
						b.panWhenReady.push({ objUid: panObjUid, ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
					else
					{
						b.panWhenReady.push({ x: pan["x"], y: pan["y"], a: pan["a"], ia: pan["ia"], oa: pan["oa"], og: pan["og"], thistag: tag });
					}
				}
				continue;
			}
			a.resume_position = d["resume_position"];
			a.setPannerEnabled(!!pan);
			a.play(looping, vol, playbackTime);
			a.updatePlaybackRate();
			a.updateVolume();
			a.doSetMuted(a.is_muted || a.is_silent);
			if (d["paused"])
				a.pause();
			if (d["muted"])
				a.setMuted(true);
			a.doSetMuted(a.is_muted || a.is_silent);
			if (pan)
			{
				if (panObjUid !== -1)
				{
					a.objectTracker = a.objectTracker || new ObjectTracker();
					a.objectTracker.loadUid = panObjUid;
					objectTrackerUidsToLoad.push(a.objectTracker);
				}
				else
				{
					a.setPan(pan["x"], pan["y"], pan["a"], pan["ia"], pan["oa"], pan["og"]);
				}
			}
		}
		if (setSilent && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (!setSilent && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	instanceProto.afterLoad = function ()
	{
		var i, len, ot, inst;
		for (i = 0, len = objectTrackerUidsToLoad.length; i < len; i++)
		{
			ot = objectTrackerUidsToLoad[i];
			inst = this.runtime.getObjectByUID(ot.loadUid);
			ot.setObject(inst);
			ot.loadUid = -1;
			if (inst)
			{
				listenerX = inst.x;
				listenerY = inst.y;
			}
		}
		objectTrackerUidsToLoad.length = 0;
	};
	instanceProto.onSuspend = function (s)
	{
		if (this.playinbackground)
			return;
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].setSuspended(s);
	};
	instanceProto.tick = function ()
	{
		var dt = this.runtime.dt;
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			a.tick(dt);
			if (a.myapi !== API_HTML5 && a.myapi !== API_APPMOBI)
			{
				if (!a.fresh && !a.stopped && a.hasEnded())
				{
					a.stopped = true;
					audTag = a.tag;
					audRuntime.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded, audInst);
				}
			}
			if (timescale_mode !== 0)
				a.updatePlaybackRate();
		}
		var p, arr, f;
		for (p in effects)
		{
			if (effects.hasOwnProperty(p))
			{
				arr = effects[p];
				for (i = 0, len = arr.length; i < len; i++)
				{
					f = arr[i];
					if (f.tick)
						f.tick();
				}
			}
		}
		if (api === API_WEBAUDIO && this.listenerTracker.hasObject())
		{
			this.listenerTracker.tick(dt);
			listenerX = this.listenerTracker.obj.x;
			listenerY = this.listenerTracker.obj.y;
			context["listener"]["setPosition"](this.listenerTracker.obj.x, this.listenerTracker.obj.y, this.listenerZ);
			context["listener"]["setVelocity"](this.listenerTracker.getVelocityX(), this.listenerTracker.getVelocityY(), 0);
		}
	};
	var preload_list = [];
	instanceProto.setPreloadList = function (arr)
	{
		var i, len, p, filename, size, isOgg;
		var total_size = 0;
		for (i = 0, len = arr.length; i < len; ++i)
		{
			p = arr[i];
			filename = p[0];
			size = p[1] * 2;
			isOgg = (filename.length > 4 && filename.substr(filename.length - 4) === ".ogg");
			if ((isOgg && useOgg) || (!isOgg && !useOgg))
			{
				preload_list.push({
					filename: filename,
					size: size,
					obj: null
				});
				total_size += size;
			}
		}
		return total_size;
	};
	instanceProto.startPreloads = function ()
	{
		var i, len, p, src;
		for (i = 0, len = preload_list.length; i < len; ++i)
		{
			p = preload_list[i];
			src = this.runtime.files_subfolder + p.filename;
			p.obj = this.getAudioBuffer(src, false);
		}
	};
	instanceProto.getPreloadedSize = function ()
	{
		var completed = 0;
		var i, len, p;
		for (i = 0, len = preload_list.length; i < len; ++i)
		{
			p = preload_list[i];
			if (p.obj.isLoadedAndDecoded() || p.obj.hasFailedToLoad() || this.runtime.isDomFree || this.runtime.isAndroidStockBrowser)
			{
				completed += p.size;
			}
			else if (p.obj.isLoaded())	// downloaded but not decoded: only happens in Web Audio API, count as half-way progress
			{
				completed += Math.floor(p.size / 2);
			}
		};
		return completed;
	};
	instanceProto.getAudioBuffer = function (src_, is_music)
	{
		var i, len, a, ret = null, j, k, lenj, ai;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			a = audioBuffers[i];
			if (a.src === src_)
			{
				ret = a;
				break;
			}
		}
		if (!ret)
		{
			ret = new C2AudioBuffer(src_, is_music);
			audioBuffers.push(ret);
		}
		return ret;
	};
	instanceProto.getAudioInstance = function (src_, tag, is_music, looping, vol)
	{
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (a.src === src_ && (a.canBeRecycled() || is_music))
			{
				a.tag = tag;
				return a;
			}
		}
		var b = this.getAudioBuffer(src_, is_music);
		if (!b.bufferObject)
		{
			if (tag !== "<preload>")
			{
				b.playTagWhenReady = tag;
				b.loopWhenReady = looping;
				b.volumeWhenReady = vol;
			}
			return null;
		}
		a = new C2AudioInstance(b, tag);
		audioInstances.push(a);
		return a;
	};
	var taggedAudio = [];
	function SortByIsPlaying(a, b)
	{
		var an = a.isPlaying() ? 1 : 0;
		var bn = b.isPlaying() ? 1 : 0;
		if (an === bn)
			return 0;
		else if (an < bn)
			return 1;
		else
			return -1;
	};
	function getAudioByTag(tag, sort_by_playing)
	{
		taggedAudio.length = 0;
		if (!tag.length)
		{
			if (!lastAudio || lastAudio.hasEnded())
				return;
			else
			{
				taggedAudio.length = 1;
				taggedAudio[0] = lastAudio;
				return;
			}
		}
		var i, len, a;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			a = audioInstances[i];
			if (cr.equals_nocase(tag, a.tag))
				taggedAudio.push(a);
		}
		if (sort_by_playing)
			taggedAudio.sort(SortByIsPlaying);
	};
	function reconnectEffects(tag)
	{
		var i, len, arr, n, toNode = context["destination"];
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				toNode = arr[0].getInputNode();
				for (i = 0, len = arr.length; i < len; i++)
				{
					n = arr[i];
					if (i + 1 === len)
						n.connectTo(context["destination"]);
					else
						n.connectTo(arr[i + 1].getInputNode());
				}
			}
		}
		getAudioByTag(tag);
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].reconnect(toNode);
		if (micSource && micTag === tag)
		{
			micSource["disconnect"]();
			micSource["connect"](toNode);
		}
	};
	function addEffectForTag(tag, fx)
	{
		if (!effects.hasOwnProperty(tag))
			effects[tag] = [fx];
		else
			effects[tag].push(fx);
		reconnectEffects(tag);
	};
	function Cnds() {};
	Cnds.prototype.OnEnded = function (t)
	{
		return cr.equals_nocase(audTag, t);
	};
	Cnds.prototype.PreloadsComplete = function ()
	{
		var i, len;
		for (i = 0, len = audioBuffers.length; i < len; i++)
		{
			if (!audioBuffers[i].isLoadedAndDecoded() && !audioBuffers[i].hasFailedToLoad())
				return false;
		}
		return true;
	};
	Cnds.prototype.AdvancedAudioSupported = function ()
	{
		return api === API_WEBAUDIO;
	};
	Cnds.prototype.IsSilent = function ()
	{
		return silent;
	};
	Cnds.prototype.IsAnyPlaying = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
		{
			if (audioInstances[i].isPlaying())
				return true;
		}
		return false;
	};
	Cnds.prototype.IsTagPlaying = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (taggedAudio[i].isPlaying())
				return true;
		}
		return false;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Play = function (file, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPosition = function (file, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObject = function (file, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayByName = function (folder, filename, looping, vol, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
			return;
		lastAudio.setPannerEnabled(false);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtPositionByName = function (folder, filename, looping, vol, x_, y_, angle_, innerangle_, outerangle_, outergain_, tag)
	{
		if (silent)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ x: x_, y: y_, a: angle_, ia: innerangle_, oa: outerangle_, og: dbToLinear(outergain_), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		lastAudio.setPan(x_, y_, angle_, innerangle_, outerangle_, dbToLinear(outergain_));
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.PlayAtObjectByName = function (folder, filename, looping, vol, obj, innerangle, outerangle, outergain, tag)
	{
		if (silent || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst)
			return;
		var v = dbToLinear(vol);
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		lastAudio = this.getAudioInstance(src, tag, is_music, looping!==0, v);
		if (!lastAudio)
		{
			var b = this.getAudioBuffer(src, is_music);
			b.panWhenReady.push({ obj: inst, ia: innerangle, oa: outerangle, og: dbToLinear(outergain), thistag: tag });
			return;
		}
		lastAudio.setPannerEnabled(true);
		var px = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, true);
		var py = cr.rotatePtAround(inst.x, inst.y, -inst.layer.getAngle(), listenerX, listenerY, false);
		lastAudio.setPan(px, py, cr.to_degrees(inst.angle - inst.layer.getAngle()), innerangle, outerangle, dbToLinear(outergain));
		lastAudio.setObject(inst);
		lastAudio.play(looping!==0, v);
	};
	Acts.prototype.SetLooping = function (tag, looping)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setLooping(looping === 0);
	};
	Acts.prototype.SetMuted = function (tag, muted)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setMuted(muted === 0);
	};
	Acts.prototype.SetVolume = function (tag, vol)
	{
		getAudioByTag(tag);
		var v = dbToLinear(vol);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setVolume(v);
	};
	Acts.prototype.Preload = function (file)
	{
		if (silent)
			return;
		var is_music = file[1];
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.PreloadByName = function (folder, filename)
	{
		if (silent)
			return;
		var is_music = (folder === 1);
		var src = this.runtime.files_subfolder + filename.toLowerCase() + (useOgg ? ".ogg" : ".m4a");
		if (api === API_APPMOBI)
		{
			if (this.runtime.isDirectCanvas)
				AppMobi["context"]["loadSound"](src);
			else
				AppMobi["player"]["loadSound"](src);
			return;
		}
		else if (api === API_PHONEGAP)
		{
			return;
		}
		this.getAudioInstance(src, "<preload>", is_music, false);
	};
	Acts.prototype.SetPlaybackRate = function (tag, rate)
	{
		getAudioByTag(tag);
		if (rate < 0.0)
			rate = 0;
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].setPlaybackRate(rate);
	};
	Acts.prototype.Stop = function (tag)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
			taggedAudio[i].stop();
	};
	Acts.prototype.StopAll = function ()
	{
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].stop();
	};
	Acts.prototype.SetPaused = function (tag, state)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			if (state === 0)
				taggedAudio[i].pause();
			else
				taggedAudio[i].resume();
		}
	};
	Acts.prototype.Seek = function (tag, pos)
	{
		getAudioByTag(tag);
		var i, len;
		for (i = 0, len = taggedAudio.length; i < len; i++)
		{
			taggedAudio[i].seek(pos);
		}
	};
	Acts.prototype.SetSilent = function (s)
	{
		var i, len;
		if (s === 2)					// toggling
			s = (silent ? 1 : 0);		// choose opposite state
		if (s === 0 && !silent)			// setting silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(true);
			silent = true;
		}
		else if (s === 1 && silent)		// setting not silent
		{
			for (i = 0, len = audioInstances.length; i < len; i++)
				audioInstances[i].setSilent(false);
			silent = false;
		}
	};
	Acts.prototype.SetMasterVolume = function (vol)
	{
		masterVolume = dbToLinear(vol);
		var i, len;
		for (i = 0, len = audioInstances.length; i < len; i++)
			audioInstances[i].updateVolume();
	};
	Acts.prototype.AddFilterEffect = function (tag, type, freq, detune, q, gain, mix)
	{
		if (api !== API_WEBAUDIO || type < 0 || type >= filterTypes.length || !context["createBiquadFilter"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FilterEffect(type, freq, detune, q, gain, mix));
	};
	Acts.prototype.AddDelayEffect = function (tag, delay, gain, mix)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DelayEffect(delay, dbToLinear(gain), mix));
	};
	Acts.prototype.AddFlangerEffect = function (tag, delay, modulation, freq, feedback, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new FlangerEffect(delay / 1000, modulation / 1000, freq, feedback / 100, mix));
	};
	Acts.prototype.AddPhaserEffect = function (tag, freq, detune, q, mod, modfreq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new PhaserEffect(freq, detune, q, mod, modfreq, mix));
	};
	Acts.prototype.AddConvolutionEffect = function (tag, file, norm, mix)
	{
		if (api !== API_WEBAUDIO || !context["createConvolver"])
			return;
		var doNormalize = (norm === 0);
		var src = this.runtime.files_subfolder + file[0] + (useOgg ? ".ogg" : ".m4a");
		var b = this.getAudioBuffer(src, false);
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		var fx;
		if (b.bufferObject)
		{
			fx = new ConvolveEffect(b.bufferObject, doNormalize, mix, src);
		}
		else
		{
			fx = new ConvolveEffect(null, doNormalize, mix, src);
			b.normalizeWhenReady = doNormalize;
			b.convolveWhenReady = fx;
		}
		addEffectForTag(tag, fx);
	};
	Acts.prototype.AddGainEffect = function (tag, g)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(dbToLinear(g)));
	};
	Acts.prototype.AddMuteEffect = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new GainEffect(0));	// re-use gain effect with 0 gain
	};
	Acts.prototype.AddTremoloEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new TremoloEffect(freq, mix));
	};
	Acts.prototype.AddRingModEffect = function (tag, freq, mix)
	{
		if (api !== API_WEBAUDIO || !context["createOscillator"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new RingModulatorEffect(freq, mix));
	};
	Acts.prototype.AddDistortionEffect = function (tag, threshold, headroom, drive, makeupgain, mix)
	{
		if (api !== API_WEBAUDIO || !context["createWaveShaper"])
			return;
		tag = tag.toLowerCase();
		mix = mix / 100;
		if (mix < 0) mix = 0;
		if (mix > 1) mix = 1;
		addEffectForTag(tag, new DistortionEffect(threshold, headroom, drive, makeupgain, mix));
	};
	Acts.prototype.AddCompressorEffect = function (tag, threshold, knee, ratio, attack, release)
	{
		if (api !== API_WEBAUDIO || !context["createDynamicsCompressor"])
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new CompressorEffect(threshold, knee, ratio, attack / 1000, release / 1000));
	};
	Acts.prototype.AddAnalyserEffect = function (tag, fftSize, smoothing)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		addEffectForTag(tag, new AnalyserEffect(fftSize, smoothing));
	};
	Acts.prototype.RemoveEffects = function (tag)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		var i, len, arr;
		if (effects.hasOwnProperty(tag))
		{
			arr = effects[tag];
			if (arr.length)
			{
				for (i = 0, len = arr.length; i < len; i++)
					arr[i].remove();
				arr.length = 0;
				reconnectEffects(tag);
			}
		}
	};
	Acts.prototype.SetEffectParameter = function (tag, index, param, value, ramp, time)
	{
		if (api !== API_WEBAUDIO)
			return;
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var arr;
		if (!effects.hasOwnProperty(tag))
			return;
		arr = effects[tag];
		if (index < 0 || index >= arr.length)
			return;
		arr[index].setParam(param, value, ramp, time);
	};
	Acts.prototype.SetListenerObject = function (obj_)
	{
		if (!obj_ || api !== API_WEBAUDIO)
			return;
		var inst = obj_.getFirstPicked();
		if (!inst)
			return;
		this.listenerTracker.setObject(inst);
		listenerX = inst.x;
		listenerY = inst.y;
	};
	Acts.prototype.SetListenerZ = function (z)
	{
		this.listenerZ = z;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Duration = function (ret, tag)
	{
		getAudioByTag(tag, true);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getDuration());
		else
			ret.set_float(0);
	};
	Exps.prototype.PlaybackTime = function (ret, tag)
	{
		getAudioByTag(tag, true);
		if (taggedAudio.length)
			ret.set_float(taggedAudio[0].getPlaybackTime());
		else
			ret.set_float(0);
	};
	Exps.prototype.Volume = function (ret, tag)
	{
		getAudioByTag(tag, true);
		if (taggedAudio.length)
		{
			var v = taggedAudio[0].getVolume();
			ret.set_float(linearToDb(v));
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.MasterVolume = function (ret)
	{
		ret.set_float(masterVolume);
	};
	Exps.prototype.EffectCount = function (ret, tag)
	{
		tag = tag.toLowerCase();
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		ret.set_int(arr ? arr.length : 0);
	};
	function getAnalyser(tag, index)
	{
		var arr = null;
		if (effects.hasOwnProperty(tag))
			arr = effects[tag];
		if (arr && index >= 0 && index < arr.length && arr[index].freqBins)
			return arr[index];
		else
			return null;
	};
	Exps.prototype.AnalyserFreqBinCount = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		ret.set_int(analyser ? analyser.node["frequencyBinCount"] : 0);
	};
	Exps.prototype.AnalyserFreqBinAt = function (ret, tag, index, bin)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		bin = Math.floor(bin);
		var analyser = getAnalyser(tag, index);
		if (!analyser)
			ret.set_float(0);
		else if (bin < 0 || bin >= analyser.node["frequencyBinCount"])
			ret.set_float(0);
		else
			ret.set_float(analyser.freqBins[bin]);
	};
	Exps.prototype.AnalyserPeakLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.peak);
		else
			ret.set_float(0);
	};
	Exps.prototype.AnalyserRMSLevel = function (ret, tag, index)
	{
		tag = tag.toLowerCase();
		index = Math.floor(index);
		var analyser = getAnalyser(tag, index);
		if (analyser)
			ret.set_float(analyser.rms);
		else
			ret.set_float(0);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Browser = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Browser.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		window.addEventListener("resize", function () {
			self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize, self);
		});
		if (typeof navigator.onLine !== "undefined")
		{
			window.addEventListener("online", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline, self);
			});
			window.addEventListener("offline", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline, self);
			});
		}
		if (typeof window.applicationCache !== "undefined")
		{
			window.applicationCache.addEventListener('updateready', function() {
				self.runtime.loadingprogress = 1;
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			window.applicationCache.addEventListener('progress', function(e) {
				self.runtime.loadingprogress = e["loaded"] / e["total"];
			});
		}
		if (!this.runtime.isDirectCanvas)
		{
			document.addEventListener("appMobi.device.update.available", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			document.addEventListener("backbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			});
			document.addEventListener("menubutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
			});
			document.addEventListener("searchbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton, self);
			});
			document.addEventListener("tizenhwkey", function (e) {
				var ret;
				switch (e["keyName"]) {
				case "back":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
					if (!ret)
					{
						if (window["tizen"])
							window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
					}
					break;
				case "menu":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
					if (!ret)
						e.preventDefault();
					break;
				}
			});
		}
		if (this.runtime.isWindowsPhone81)
		{
			WinJS["Application"]["onbackclick"] = function (e)
			{
				return !!self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			};
		}
		this.runtime.addSuspendCallback(function(s) {
			if (s)
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden, self);
			}
			else
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible, self);
			}
		});
		this.is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.CookiesEnabled = function()
	{
		return navigator ? navigator.cookieEnabled : false;
	};
	Cnds.prototype.IsOnline = function()
	{
		return navigator ? navigator.onLine : false;
	};
	Cnds.prototype.HasJava = function()
	{
		return navigator ? navigator.javaEnabled() : false;
	};
	Cnds.prototype.OnOnline = function()
	{
		return true;
	};
	Cnds.prototype.OnOffline = function()
	{
		return true;
	};
	Cnds.prototype.IsDownloadingUpdate = function ()
	{
		if (typeof window["applicationCache"] === "undefined")
			return false;
		else
			return window["applicationCache"]["status"] === window["applicationCache"]["DOWNLOADING"];
	};
	Cnds.prototype.OnUpdateReady = function ()
	{
		return true;
	};
	Cnds.prototype.PageVisible = function ()
	{
		return !this.runtime.isSuspended;
	};
	Cnds.prototype.OnPageVisible = function ()
	{
		return true;
	};
	Cnds.prototype.OnPageHidden = function ()
	{
		return true;
	};
	Cnds.prototype.OnResize = function ()
	{
		return true;
	};
	Cnds.prototype.IsFullscreen = function ()
	{
		return !!(document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
	};
	Cnds.prototype.OnBackButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnMenuButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnSearchButton = function ()
	{
		return true;
	};
	Cnds.prototype.IsMetered = function ()
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			return false;
		return connection["metered"];
	};
	Cnds.prototype.IsCharging = function ()
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			return true;
		return battery["charging"];
	};
	Cnds.prototype.IsPortraitLandscape = function (p)
	{
		var current = (window.innerWidth <= window.innerHeight ? 0 : 1);
		return current === p;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Alert = function (msg)
	{
		if (!this.runtime.isDomFree)
			alert(msg.toString());
	};
	Acts.prototype.Close = function ()
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["forceToFinish"]();
		else if (window["tizen"])
			window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
		else if (navigator["app"] && navigator["app"]["exitApp"])
			navigator["app"]["exitApp"]();
		else if (navigator["device"] && navigator["device"]["exitApp"])
			navigator["device"]["exitApp"]();
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.close();
	};
	Acts.prototype.Focus = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["focus"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.focus();
	};
	Acts.prototype.Blur = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["blur"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.blur();
	};
	Acts.prototype.GoBack = function ()
	{
		if (navigator["app"] && navigator["app"]["backHistory"])
			navigator["app"]["backHistory"]();
		else if (!this.is_arcade && !this.runtime.isDomFree && window.back)
			window.back();
	};
	Acts.prototype.GoForward = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.forward)
			window.forward();
	};
	Acts.prototype.GoHome = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.home)
			window.home();
	};
	Acts.prototype.GoToURL = function (url, target)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (this.runtime.isPhoneGap)
			window.open(url, "_system");
		else if (!this.is_arcade && !this.runtime.isDomFree)
		{
			if (target === 2 && !this.is_arcade)		// top
				window.top.location = url;
			else if (target === 1 && !this.is_arcade)	// parent
				window.parent.location = url;
			else					// self
				window.location = url;
		}
	};
	Acts.prototype.GoToURLWindow = function (url, tag)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (this.runtime.isPhoneGap)
			window.open(url, "_system");
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.open(url, tag);
	};
	Acts.prototype.Reload = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree)
			window.location.reload();
	};
	var firstRequestFullscreen = true;
	var crruntime = null;
	function onFullscreenError(e)
	{
		if (console && console.warn)
			console.warn("Fullscreen request failed: ", e);
		crruntime["setSize"](window.innerWidth, window.innerHeight);
	};
	Acts.prototype.RequestFullScreen = function (stretchmode)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (stretchmode >= 2)
			stretchmode += 1;
		if (stretchmode === 6)
			stretchmode = 2;
		if (this.runtime.isNodeWebkit)
		{
			if (!this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["enterFullscreen"]();
				this.runtime.isNodeFullscreen = true;
				this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			}
		}
		else
		{
			if (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || document["fullScreenElement"])
			{
				return;
			}
			this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			var elem = this.runtime.canvasdiv || this.runtime.canvas;
			if (firstRequestFullscreen)
			{
				firstRequestFullscreen = false;
				crruntime = this.runtime;
				elem.addEventListener("mozfullscreenerror", onFullscreenError);
				elem.addEventListener("webkitfullscreenerror", onFullscreenError);
				elem.addEventListener("MSFullscreenError", onFullscreenError);
				elem.addEventListener("fullscreenerror", onFullscreenError);
			}
			if (elem["requestFullscreen"])
				elem["requestFullscreen"]();
			else if (elem["mozRequestFullScreen"])
				elem["mozRequestFullScreen"]();
			else if (elem["msRequestFullscreen"])
				elem["msRequestFullscreen"]();
			else if (elem["webkitRequestFullScreen"])
			{
				if (typeof Element !== "undefined" && typeof Element["ALLOW_KEYBOARD_INPUT"] !== "undefined")
					elem["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
				else
					elem["webkitRequestFullScreen"]();
			}
		}
	};
	Acts.prototype.CancelFullScreen = function ()
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (this.runtime.isNodeWebkit)
		{
			if (this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["leaveFullscreen"]();
				this.runtime.isNodeFullscreen = false;
			}
		}
		else
		{
			if (document["exitFullscreen"])
				document["exitFullscreen"]();
			else if (document["mozCancelFullScreen"])
				document["mozCancelFullScreen"]();
			else if (document["msExitFullscreen"])
				document["msExitFullscreen"]();
			else if (document["webkitCancelFullScreen"])
				document["webkitCancelFullScreen"]();
		}
	};
	Acts.prototype.Vibrate = function (pattern_)
	{
		try {
			var arr = pattern_.split(",");
			var i, len;
			for (i = 0, len = arr.length; i < len; i++)
			{
				arr[i] = parseInt(arr[i], 10);
			}
			if (navigator["vibrate"])
				navigator["vibrate"](arr);
			else if (navigator["mozVibrate"])
				navigator["mozVibrate"](arr);
			else if (navigator["webkitVibrate"])
				navigator["webkitVibrate"](arr);
			else if (navigator["msVibrate"])
				navigator["msVibrate"](arr);
		}
		catch (e) {}
	};
	Acts.prototype.InvokeDownload = function (url_, filename_)
	{
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(url_);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = url_;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.InvokeDownloadString = function (str_, mimetype_, filename_)
	{
		var datauri = "data:" + mimetype_ + "," + encodeURIComponent(str_);
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(datauri);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = datauri;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.ConsoleLog = function (type_, msg_)
	{
		if (typeof console === "undefined")
			return;
		if (type_ === 0 && console.log)
			console.log(msg_.toString());
		if (type_ === 1 && console.warn)
			console.warn(msg_.toString());
		if (type_ === 2 && console.error)
			console.error(msg_.toString());
	};
	Acts.prototype.ConsoleGroup = function (name_)
	{
		if (console && console.group)
			console.group(name_);
	};
	Acts.prototype.ConsoleGroupEnd = function ()
	{
		if (console && console.groupEnd)
			console.groupEnd();
	};
	Acts.prototype.ExecJs = function (js_)
	{
		try {
			if (eval)
				eval(js_);
		}
		catch (e)
		{
			if (console && console.error)
				console.error("Error executing Javascript: ", e);
		}
	};
	var orientations = [
		"portrait",
		"landscape",
		"portrait-primary",
		"portrait-secondary",
		"landscape-primary",
		"landscape-secondary"
	];
	Acts.prototype.LockOrientation = function (o)
	{
		o = Math.floor(o);
		if (o < 0 || o >= orientations.length)
			return;
		this.runtime.autoLockOrientation = false;
		var orientation = orientations[o];
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Acts.prototype.UnlockOrientation = function ()
	{
		this.runtime.autoLockOrientation = false;
		if (screen["unlockOrientation"])
			screen["unlockOrientation"]();
		else if (screen["webkitUnlockOrientation"])
			screen["webkitUnlockOrientation"]();
		else if (screen["mozUnlockOrientation"])
			screen["mozUnlockOrientation"]();
		else if (screen["msUnlockOrientation"])
			screen["msUnlockOrientation"]();
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.URL = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.toString());
	};
	Exps.prototype.Protocol = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.protocol);
	};
	Exps.prototype.Domain = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hostname);
	};
	Exps.prototype.PathName = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.pathname);
	};
	Exps.prototype.Hash = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hash);
	};
	Exps.prototype.Referrer = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.referrer);
	};
	Exps.prototype.Title = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.title);
	};
	Exps.prototype.Name = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appName);
	};
	Exps.prototype.Version = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appVersion);
	};
	Exps.prototype.Language = function (ret)
	{
		if (navigator && navigator.language)
			ret.set_string(navigator.language);
		else
			ret.set_string("");
	};
	Exps.prototype.Platform = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.platform);
	};
	Exps.prototype.Product = function (ret)
	{
		if (navigator && navigator.product)
			ret.set_string(navigator.product);
		else
			ret.set_string("");
	};
	Exps.prototype.Vendor = function (ret)
	{
		if (navigator && navigator.vendor)
			ret.set_string(navigator.vendor);
		else
			ret.set_string("");
	};
	Exps.prototype.UserAgent = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.userAgent);
	};
	Exps.prototype.QueryString = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.search);
	};
	Exps.prototype.QueryParam = function (ret, paramname)
	{
		if (this.runtime.isDomFree)
		{
			ret.set_string("");
			return;
		}
		var match = RegExp('[?&]' + paramname + '=([^&]*)').exec(window.location.search);
		if (match)
			ret.set_string(decodeURIComponent(match[1].replace(/\+/g, ' ')));
		else
			ret.set_string("");
	};
	Exps.prototype.Bandwidth = function (ret)
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(connection["bandwidth"]);
	};
	Exps.prototype.BatteryLevel = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(1);
		else
			ret.set_float(battery["level"]);
	};
	Exps.prototype.BatteryTimeLeft = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(battery["dischargingTime"]);
	};
	Exps.prototype.ExecJS = function (ret, js_)
	{
		if (!eval)
		{
			ret.set_any(0);
			return;
		}
		var result = 0;
		try {
			result = eval(js_);
		}
		catch (e)
		{
			if (console && console.error)
				console.error("Error executing Javascript: ", e);
		}
		if (typeof result === "number")
			ret.set_any(result);
		else if (typeof result === "string")
			ret.set_any(result);
		else if (typeof result === "boolean")
			ret.set_any(result ? 1 : 0);
		else
			ret.set_any(0);
	};
	Exps.prototype.ScreenWidth = function (ret)
	{
		ret.set_int(screen.width);
	};
	Exps.prototype.ScreenHeight = function (ret)
	{
		ret.set_int(screen.height);
	};
	Exps.prototype.DevicePixelRatio = function (ret)
	{
		ret.set_float(this.runtime.devicePixelRatio);
	};
	pluginProto.exps = new Exps();
}());
/**
* Object holder for the plugin
*/
cr.plugins_.CJSAds = function(runtime)
{
	this.runtime = runtime;
};
/**
* C2 plugin
*/
(function ()
{
	var input_text = "";
	var PurchaseTransactionId = "";
	var PurchaseProductId = "";
	var products_list = [];
	var requested_score = 0;
	var showBanner = true;
	var bannerPosition = 0;
	var bannerReady = false;
	var fullscreenReady = false;
	var pluginProto = cr.plugins_.CJSAds.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	/**
	* C2 specific behaviour
	*/
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var self;
	instanceProto.onCreate = function()
	{
		this.isShowingBanner  		= false;
		this.isShowingFullscreen 	= false;
		this.triggerProduct 		= "";
		this.socialService 			= null;
		this.socialServiceAvailable = false;
		this.socialServiceSelected 	= this.properties[2];
		this.storeServiceAvailable 	= (this.runtime.isCocoonJs && typeof CocoonJS["Store"]["nativeExtensionObjectAvailable"] !== "undefined");
		this.storeManaged 			= (this.properties[1] !== 1);
		this.storeSandboxed 		= (this.properties[3] !== 0);
		this.socialServiceClientID 	= this.properties[4];
		this.facebookAppID 			= this.properties[5];
		this.facebookChannel 		= this.properties[6];
		this.onConsumePurchaseFailedTransactionId 	= "";
		this.onConsumePurchaseCompleted 			= "";
		this.onPurchaseCompleteInfo 				= "";
		self = this;
		if (self.runtime.isCocoonJs)
		{
			CocoonJS["App"]["onTextDialogFinished"].addEventListener(function(text) {
				input_text = text;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK, self);
			});
			CocoonJS["App"]["onTextDialogCancelled"].addEventListener(function() {
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled, self);
			});
			CocoonJS["Ad"]["onBannerShown"].addEventListener(function ()
			{
				self.isShowingBanner = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown, self);
			});
			CocoonJS["Ad"]["onBannerReady"].addEventListener(function ()
			{
				bannerReady = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onBannerReady, self);
			});
			CocoonJS["Ad"]["onBannerHidden"].addEventListener(function ()
			{
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onBannerHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenShown"].addEventListener(function ()
			{
				self.isShowingFullscreen = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown, self);
			});
			CocoonJS["Ad"]["onFullScreenHidden"].addEventListener(function ()
			{
				self.isShowingFullscreen = false;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenReady"].addEventListener(function ()
			{
				fullscreenReady = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onFullScreenReady, self);
			});
			if (self.storeServiceAvailable)
			{
				CocoonJS["Store"]["onConsumePurchaseFailed"].addEventListener(function(transactionId, errorMessage)
				{
					self.onConsumePurchaseFailedTransactionId = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed, self);
				});
				CocoonJS["Store"]["onConsumePurchaseStarted"].addEventListener(function()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseStarted, self);
				});
				CocoonJS["Store"]["onConsumePurchaseCompleted"].addEventListener(function(transactionId)
				{
					self.onConsumePurchaseCompleted = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted, self);
				});
				CocoonJS["Store"]["onProductPurchaseCompleted"].addEventListener(function (purchase)
				{
					console.log("onProductPurchaseCompleted " + purchase["productId"]);
					self.triggerProduct = purchase["productId"];
					PurchaseTransactionId = purchase["transactionId"];
					PurchaseProductId = purchase["productId"];
					CocoonJS["Store"]["addPurchase"](purchase);
					CocoonJS["Store"]["finishPurchase"](purchase["transactionId"]);
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete, self);
				});
				CocoonJS["Store"]["onProductPurchaseFailed"].addEventListener(function (productId, errorMsg)
				{
					console.log("onProductPurchaseFailed " + productId);
					self.triggerProduct = productId;
					console.log(errorMsg);
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail, self);
				});
				CocoonJS["Store"]["onProductPurchaseStarted"].addEventListener(function (productId)
				{
					console.log("onProductPurchaseStarted " + productId);
					self.triggerProduct = productId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart, self);
				});
				CocoonJS["Store"]["onProductsFetchStarted"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted, self);
				});
				CocoonJS["Store"]["onProductsFetchFailed"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed, self);
				});
				CocoonJS["Store"]["onProductsFetchCompleted"].addEventListener(function (products)
				{
					for (var i = products.length - 1; i >= 0; i--) {
                        console.log("Product fetched: " + products[i].productId);
						CocoonJS["Store"]["addProduct"](products[i]);
					};
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted, self);
				});
				CocoonJS["Store"]["onRestorePurchasesStarted"].addEventListener(function ()
				{
					console.log("onRestorePurchasesStarted ");
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesStarted, self);
				});
				CocoonJS["Store"]["onRestorePurchasesCompleted"].addEventListener(function ()
				{
					console.log("onRestorePurchasesCompleted ");
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesCompleted, self);
				});
				CocoonJS["Store"]["onRestorePurchasesFailed"].addEventListener(function ()
				{
					console.log("onRestorePurchasesFailed ");
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onRestorePurchasesFailed, self);
				});
				CocoonJS["Store"]["requestInitialization"]({
					"managed": self.storeManaged,
					"sandbox": self.storeSandboxed
				});
				CocoonJS["Store"]["start"]();
			}
			/**
			* No social service selected, return.
			*/
			if(this.socialServiceSelected === 0) return;
			/**
			* Set the social interface for the selected service
			*/
			this.startGameCenter = function(){
				console.log("GameCenter selected as social service");
				this.socialService = CocoonJS["Social"]["GameCenter"];
				if(this.socialService){
					if(!!this.socialService["nativeExtensionObjectAvailable"])
					this.socialServiceInterface = this.socialService.getSocialInterface();
				}else{
					throw new Error("Cannot find GameCenter service, are you using the latest CocoonJS Extensions?");
				}
			}
			this.startGooglePlay = function(){
				console.log("GooglePlayGames selected as social service");
				this.socialService = CocoonJS["Social"]["GooglePlayGames"];
				if(this.socialService){
					var config = {};
					if(this.socialServiceClientID) config.clientId = this.socialServiceClientID;
					this.socialService.init(config);
					if(!!this.socialService["nativeExtensionObjectAvailable"]){
						this.socialServiceInterface = this.socialService.getSocialInterface();
					}
				}else{
					throw new Error("Cannot find GooglePlayGames service, are you using the latest CocoonJS Extensions?");
				}
			}
			this.startFacebook = function(){
				console.log("Facebook selected as social service");
				this.socialService = CocoonJS["Social"]["Facebook"];
				if(this.socialService){
					var config = {};
					if(this.facebookAppID && this.facebookChannel){
						config.appId = this.facebookAppID;
						config.channelUrl = this.facebookChannel;
					}
					this.socialService.init(config);
					if(!!this.socialService["nativeExtensionObjectAvailable"]){
						this.socialServiceInterface = this.socialService.getSocialInterface();
						this.socialServiceInterface.setTemplates("leaderboards.html", "achievements.html");
					}
				}else{
					throw new Error("Cannot find Facebook service, are you using the latest CocoonJS Extensions?");
				}
			}
			if(this.socialServiceSelected === 2) this.startGameCenter.apply(this,[]);
			if(this.socialServiceSelected === 3) this.startGooglePlay.apply(this,[]);
			if(this.socialServiceSelected === 4) this.startFacebook.apply(this,[]);
			if(this.socialServiceSelected === 1){
				if(CocoonJS["Social"]["GooglePlayGames"]["nativeExtensionObjectAvailable"]){
					this.startGooglePlay.apply(this,[]);
				}else if(CocoonJS["Social"]["GameCenter"]["nativeExtensionObjectAvailable"]){
					this.startGameCenter.apply(this,[]);
				}else{
					return;
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsShowingBanner = function ()
	{
		return this.isShowingBanner;
	};
	Cnds.prototype.IsCocoonJS = function ()
	{
		return this.runtime.isCocoonJs;
	};
	Cnds.prototype.OnBannerShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenHidden = function ()
	{
		return true;
	};
	Cnds.prototype.onFullScreenReady = function ()
	{
		return true;
	};
	Cnds.prototype.onBannerReady = function ()
	{
		return true;
	};
	Cnds.prototype.onBannerHidden = function ()
	{
		return true;
	};
	Cnds.prototype.IsShowingFullscreen = function ()
	{
		return this.isShowingFullscreen;
	};
	Cnds.prototype.PreloadFullscreen = function(){
		return true;
	}
	Cnds.prototype.IsStoreAvailable = function ()
	{
		if (this.runtime.isCocoonJs)
			return this.storeServiceAvailable && CocoonJS["Store"]["canPurchase"]();
		else
			return false;
	};
	Cnds.prototype.OnPurchaseStart = function (productid)
	{
		console.log("OnPurchaseStart");
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseComplete = function (productid)
	{
		console.log("OnPurchaseComplete");
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseFail = function (productid)
	{
		console.log("OnPurchaseFail");
		return this.triggerProduct === productid;
	};
	Cnds.prototype.onProductsFetchStarted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseFailed = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseCompleted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseStarted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchCompleted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchFailed = function(){
		return true;
	}
	Cnds.prototype.IsProductPurchased = function (productid)
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["isProductPurchased"](productid);
		else
			return false;
	};
	Cnds.prototype.OnKeyboardCancelled = function ()
	{
		return true;
	};
	Cnds.prototype.OnKeyboardOK = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLoginSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLoginFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLogoutSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceLogoutFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitScoreSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitScoreFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceRequestScoreSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceRequestScoreFailed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenLeaderBoardSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenLeaderBoardClosed = function ()
	{
		return true;
	};
	Cnds.prototype.onSocialServiceOpenAchievementsSuccess = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceOpenAchievementsClosed = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceResetAchievementsCompleted = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceResetAchievementsFailed = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitAchievementCompleted = function(){
		return true;
	};
	Cnds.prototype.onSocialServiceSubmitAchievementFailed = function(){
		return true;
	};
	Cnds.prototype.onRestorePurchasesStarted = function(){
		return true;
	};
	Cnds.prototype.onRestorePurchasesCompleted = function(){
		return true;
	};
	Cnds.prototype.onRestorePurchasesFailed = function(){
		return true;
	};
	pluginProto.cnds = new Cnds();
	/**
	* Plugin actions
	*/
	function Acts() {};
	Acts.prototype.ShowBanner = function (layout_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		bannerPosition = (layout_ === 0 ? CocoonJS["Ad"]["BannerLayout"]["TOP_CENTER"] : CocoonJS["Ad"]["BannerLayout"]["BOTTOM_CENTER"]);
		if (bannerReady)
		{
			showBanner = true;
			CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
			CocoonJS["Ad"]["showBanner"]();
		}
		else
		{
			CocoonJS["Ad"]["preloadBanner"]();
		}
	};
	Acts.prototype.ShowFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (fullscreenReady)
			CocoonJS["Ad"]["showFullScreen"]();
		else
			CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.HideBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		showBanner = false;
		CocoonJS["Ad"]["hideBanner"]();
		this.isShowingBanner = false;
	};
	Acts.prototype.PreloadBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["preloadBanner"]();
	};
	Acts.prototype.PreloadFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.RefreshBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshBanner"]();
	};
	Acts.prototype.RefreshFullScreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshFullScreen"]();
	};
	Acts.prototype.Purchase = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProduct"](productid);
	};
	Acts.prototype.ConsumePurchase = function (transactionId,productId)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["consumePurchase"](transactionId,productId);
	};
	Acts.prototype.fetchProductsFromStore = function (products)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["fetchProductsFromStore"](products.split(","));
	};
	Acts.prototype.PurchasePreview = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProductModalWithPreview"](productid);
	};
	Acts.prototype.RestorePurchases = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PromptKeyboard = function (title_, message_, initial_, type_, canceltext_, oktext_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		var typestr = ["text", "num", "phone", "email", "url"][type_];
		CocoonJS["App"]["showTextDialog"](title_, message_, initial_, typestr, canceltext_, oktext_);
	};
	Acts.prototype.UpdateProductsList = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (!CocoonJS["Store"]["canPurchase"]())
			return;
		products_list = CocoonJS["Store"]["getProducts"]();
	};
	/**
	* Social service actions
	*/
	function socialServiceRequestLoginCallback(isAuthenticated, error){
		if(isAuthenticated){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess, self);
		}else{
			console.log(JSON.stringify(error));
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginFailed, self);
		}
	};
	Acts.prototype.socialServiceRequestLogin = function ()
	{
		if(!this.socialServiceInterface) return;
		if(this.socialServiceInterface.isLoggedIn()){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLoginSuccess, self);
		}else{
			this.socialServiceInterface.login(socialServiceRequestLoginCallback);
		}
	};
	function socialServiceRequestLogoutCallback(error){
		if(!error){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLogoutSuccess, self);
		}else{
			console.log(JSON.stringify(error));
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceLogoutFailed, self);}
	};
	Acts.prototype.socialServiceRequestLogout = function ()
	{
		if(!this.socialServiceInterface) return;
			this.socialServiceInterface.logout(socialServiceRequestLogoutCallback);
	};
	Acts.prototype.socialServiceShare = function (textToShare)
	{
		CocoonJS.App.share(textToShare);
	};
	function socialServiceSubmitScoreCallback(err){
		if(!err){
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreSuccess, self);
		}else{
			console.log(err);
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitScoreFailed, self);
		}
	};
	Acts.prototype.socialServiceSubmitScore = function (score_, leaderboard_)
	{
		if(!this.socialServiceInterface) return;
		if(this.socialServiceInterface.isLoggedIn())
			this.socialServiceInterface.submitScore(
				score_,
				socialServiceSubmitScoreCallback,
				{ leaderboardID : leaderboard_ }
			);
	};
	function socialServiceRequestScoreCallback(loadedScore, err){
		if(!err){
			requested_score = loadedScore.score || 0;
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreSuccess, self);
		}else{
			console.log(err);
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceRequestScoreFailed, self);
		}
	};
	Acts.prototype.socialServiceRequestScore = function (leaderboard_)
	{
		if(!this.socialServiceInterface) return;
		if(this.socialServiceInterface.isLoggedIn())
			this.socialServiceInterface.requestScore(
				socialServiceRequestScoreCallback,
				{ leaderboardID : leaderboard_ } );
	};
	function socialServiceOpenLeaderboardCallback(err){
		if(err){
			console.log(err);
		}
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardClosed, self);
	};
	Acts.prototype.socialServiceOpenLeaderboard = function (leaderboard_)
	{
		if(!this.socialServiceInterface) return;
		if(!this.socialServiceInterface.isLoggedIn()) return;
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenLeaderBoardSuccess, self);
		this.socialServiceInterface.showLeaderboard(
			socialServiceOpenLeaderboardCallback,
			{ leaderboardID : leaderboard_}
		);
	};
	function socialServiceOpenAchievementsCallback(err){
		if(err){
			console.log(err);
		}
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsClosed, self);
	}
	Acts.prototype.socialServiceOpenAchievements = function(){
		if(!this.socialServiceInterface) return;
		if(!this.socialServiceInterface.isLoggedIn()) return;
		self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceOpenAchievementsSuccess, self);
		this.socialServiceInterface.showAchievements(socialServiceOpenAchievementsCallback);
	};
	function socialServiceResetAchievementsCallback(err){
		if(err){
			try{
				console.log(JSON.stringify(err));
			}catch(e){
				for(var prop in err){
					console.log(err[prop]);
				}
				console.log(e);
			}
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsFailed, self);
		}else{
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceResetAchievementsCompleted, self);
		}
	}
	Acts.prototype.socialServiceResetAchievements = function(){
		if(!this.socialServiceInterface) return;
		if(!this.socialServiceInterface.isLoggedIn()) return;
		this.socialServiceInterface.resetAchievements(socialServiceResetAchievementsCallback);
	};
	function socialServiceSubmitAchievementCallback(err){
		if(err){
			try{
				console.log(JSON.stringify(err));
			}catch(e){
				for(var prop in err){
					console.log(err[prop]);
				}
				console.log(e);
			}
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementFailed, self);
		}else{
			self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onSocialServiceSubmitAchievementCompleted, self);
		}
	}
	Acts.prototype.socialServiceSubmitAchievement = function(_achievementId){
		if(!this.socialServiceInterface) return;
		if(!this.socialServiceInterface.isLoggedIn()) return;
		this.socialServiceInterface.submitAchievement(_achievementId, socialServiceSubmitAchievementCallback);
	};
	pluginProto.acts = new Acts();
	/**
	* Expressions
	*/
	function Exps() {};
	Exps.prototype.InputText = function (ret)
	{
		ret.set_string(input_text);
	};
	Exps.prototype.PurchaseTransactionId = function (ret)
	{
		ret.set_string(PurchaseTransactionId);
	};
	Exps.prototype.PurchaseProductId = function (ret)
	{
		ret.set_string(PurchaseProductId);
	};
	Exps.prototype.ProductCount = function (ret)
	{
		ret.set_int(products_list.length);
	};
	Exps.prototype.ProductDescription = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["description"]);
	};
	Exps.prototype.ProductLocalizedPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["localizedPrice"]);
	};
	Exps.prototype.ProductPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["price"]);
	};
	Exps.prototype.ProductAlias = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productAlias"]);
	};
	Exps.prototype.ProductID = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productId"]);
	};
	Exps.prototype.ProductTitle = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["title"]);
	};
	Exps.prototype.PlayerScore = function (ret)
	{
		ret.set_float(requested_score);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Function = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Function.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var funcStack = [];
	var funcStackPtr = -1;
	var isInPreview = false;	// set in onCreate
	function FuncStackEntry()
	{
		this.name = "";
		this.retVal = 0;
		this.params = [];
	};
	function pushFuncStack()
	{
		funcStackPtr++;
		if (funcStackPtr === funcStack.length)
			funcStack.push(new FuncStackEntry());
		return funcStack[funcStackPtr];
	};
	function getCurrentFuncStack()
	{
		if (funcStackPtr < 0)
			return null;
		return funcStack[funcStackPtr];
	};
	function getOneAboveFuncStack()
	{
		if (!funcStack.length)
			return null;
		var i = funcStackPtr + 1;
		if (i >= funcStack.length)
			i = funcStack.length - 1;
		return funcStack[i];
	};
	function popFuncStack()
	{
;
		funcStackPtr--;
	};
	instanceProto.onCreate = function()
	{
		isInPreview = (typeof cr_is_preview !== "undefined");
		var self = this;
		window["c2_callFunction"] = function (name_, params_)
		{
			var i, len, v;
			var fs = pushFuncStack();
			fs.name = name_.toLowerCase();
			fs.retVal = 0;
			if (params_)
			{
				fs.params.length = params_.length;
				for (i = 0, len = params_.length; i < len; ++i)
				{
					v = params_[i];
					if (typeof v === "number" || typeof v === "string")
						fs.params[i] = v;
					else if (typeof v === "boolean")
						fs.params[i] = (v ? 1 : 0);
					else
						fs.params[i] = 0;
				}
			}
			else
			{
				fs.params.length = 0;
			}
			self.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, self, fs.name);
			popFuncStack();
			return fs.retVal;
		};
	};
	function Cnds() {};
	Cnds.prototype.OnFunction = function (name_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		return cr.equals_nocase(name_, fs.name);
	};
	Cnds.prototype.CompareParam = function (index_, cmp_, value_)
	{
		var fs = getCurrentFuncStack();
		if (!fs)
			return false;
		index_ = cr.floor(index_);
		if (index_ < 0 || index_ >= fs.params.length)
			return false;
		return cr.do_cmp(fs.params[index_], cmp_, value_);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.CallFunction = function (name_, params_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		cr.shallowAssignArray(fs.params, params_);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
	};
	Acts.prototype.SetReturnValue = function (value_)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			fs.retVal = value_;
		else
;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ReturnValue = function (ret)
	{
		var fs = getOneAboveFuncStack();
		if (fs)
			ret.set_any(fs.retVal);
		else
			ret.set_int(0);
	};
	Exps.prototype.ParamCount = function (ret)
	{
		var fs = getCurrentFuncStack();
		if (fs)
			ret.set_int(fs.params.length);
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Param = function (ret, index_)
	{
		index_ = cr.floor(index_);
		var fs = getCurrentFuncStack();
		if (fs)
		{
			if (index_ >= 0 && index_ < fs.params.length)
			{
				ret.set_any(fs.params[index_]);
			}
			else
			{
;
				ret.set_int(0);
			}
		}
		else
		{
;
			ret.set_int(0);
		}
	};
	Exps.prototype.Call = function (ret, name_)
	{
		var fs = pushFuncStack();
		fs.name = name_.toLowerCase();
		fs.retVal = 0;
		fs.params.length = 0;
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
			fs.params.push(arguments[i]);
		var ran = this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction, this, fs.name);
		if (isInPreview && !ran)
		{
;
		}
		popFuncStack();
		ret.set_any(fs.retVal);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Mouse = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Mouse.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.buttonMap = new Array(4);		// mouse down states
		this.mouseXcanvas = 0;				// mouse position relative to canvas
		this.mouseYcanvas = 0;
		this.triggerButton = 0;
		this.triggerType = 0;
		this.triggerDir = 0;
		this.handled = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		if (!this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
			jQuery(document).dblclick(
				function(info) {
					self.onDoubleClick(info);
				}
			);
			var wheelevent = function(info) {
								self.onWheel(info);
							};
			document.addEventListener("mousewheel", wheelevent, false);
			document.addEventListener("DOMMouseScroll", wheelevent, false);
		}
	};
	var dummyoffset = {left: 0, top: 0};
	instanceProto.onMouseMove = function(info)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		this.mouseXcanvas = info.pageX - offset.left;
		this.mouseYcanvas = info.pageY - offset.top;
	};
	instanceProto.mouseInGame = function ()
	{
		if (this.runtime.fullscreen_mode > 0)
			return true;
		return this.mouseXcanvas >= 0 && this.mouseYcanvas >= 0
		    && this.mouseXcanvas < this.runtime.width && this.mouseYcanvas < this.runtime.height;
	};
	instanceProto.onMouseDown = function(info)
	{
		if (!this.mouseInGame())
			return;
		if (this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.buttonMap[info.which] = true;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnAnyClick, this);
		this.triggerButton = info.which - 1;	// 1-based
		this.triggerType = 0;					// single click
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick, this);
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onMouseUp = function(info)
	{
		if (!this.buttonMap[info.which])
			return;
		if (this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		this.buttonMap[info.which] = false;
		this.runtime.isInUserInputEvent = true;
		this.triggerButton = info.which - 1;	// 1-based
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnRelease, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onDoubleClick = function(info)
	{
		if (!this.mouseInGame())
			return;
		info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		this.triggerButton = info.which - 1;	// 1-based
		this.triggerType = 1;					// double click
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick, this);
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onWheel = function (info)
	{
		var delta = info.wheelDelta ? info.wheelDelta : info.detail ? -info.detail : 0;
		this.triggerDir = (delta < 0 ? 0 : 1);
		this.handled = false;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnWheel, this);
		this.runtime.isInUserInputEvent = false;
		if (this.handled)
			info.preventDefault();
	};
	function Cnds() {};
	Cnds.prototype.OnClick = function (button, type)
	{
		return button === this.triggerButton && type === this.triggerType;
	};
	Cnds.prototype.OnAnyClick = function ()
	{
		return true;
	};
	Cnds.prototype.IsButtonDown = function (button)
	{
		return this.buttonMap[button + 1];	// jQuery uses 1-based buttons for some reason
	};
	Cnds.prototype.OnRelease = function (button)
	{
		return button === this.triggerButton;
	};
	Cnds.prototype.IsOverObject = function (obj)
	{
		var cnd = this.runtime.getCurrentCondition();
		var mx = this.mouseXcanvas;
		var my = this.mouseYcanvas;
		return cr.xor(this.runtime.testAndSelectCanvasPointOverlap(obj, mx, my, cnd.inverted), cnd.inverted);
	};
	Cnds.prototype.OnObjectClicked = function (button, type, obj)
	{
		if (button !== this.triggerButton || type !== this.triggerType)
			return false;	// wrong click type
		return this.runtime.testAndSelectCanvasPointOverlap(obj, this.mouseXcanvas, this.mouseYcanvas, false);
	};
	Cnds.prototype.OnWheel = function (dir)
	{
		this.handled = true;
		return dir === this.triggerDir;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetCursor = function (c)
	{
		var cursor_style = ["auto", "pointer", "text", "crosshair", "move", "help", "wait", "none"][c];
		if (this.runtime.canvas && this.runtime.canvas.style)
			this.runtime.canvas.style.cursor = cursor_style;
	};
	Acts.prototype.SetCursorSprite = function (obj)
	{
		if (this.runtime.isDomFree || this.runtime.isMobile || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst || !inst.curFrame)
			return;
		var frame = inst.curFrame;
		var datauri = frame.getDataUri();
		var cursor_style = "url(" + datauri + ") " + Math.round(frame.hotspotX * frame.width) + " " + Math.round(frame.hotspotY * frame.height) + ", auto";
		jQuery(this.runtime.canvas).css("cursor", cursor_style);
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.X = function (ret, layerparam)
	{
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		ret.set_float(this.mouseXcanvas);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		ret.set_float(this.mouseYcanvas);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Particles = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Particles.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.webGL_texture = null;
		this.runtime.waitForImageLoad(this.texture_img);
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
		}
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.webGL_texture || !this.runtime.glwrap)
			return;
		this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, true, this.runtime.linearSampling, this.texture_pixelformat);
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	function Particle(owner)
	{
		this.owner = owner;
		this.active = false;
		this.x = 0;
		this.y = 0;
		this.speed = 0;
		this.angle = 0;
		this.opacity = 1;
		this.grow = 0;
		this.size = 0;
		this.gs = 0;			// gravity speed
		this.age = 0;
		cr.seal(this);
	};
	Particle.prototype.init = function ()
	{
		var owner = this.owner;
		this.x = owner.x - (owner.xrandom / 2) + (Math.random() * owner.xrandom);
		this.y = owner.y - (owner.yrandom / 2) + (Math.random() * owner.yrandom);
		this.speed = owner.initspeed - (owner.speedrandom / 2) + (Math.random() * owner.speedrandom);
		this.angle = owner.angle - (owner.spraycone / 2) + (Math.random() * owner.spraycone);
		this.opacity = owner.initopacity;
		this.size = owner.initsize - (owner.sizerandom / 2) + (Math.random() * owner.sizerandom);
		this.grow = owner.growrate - (owner.growrandom / 2) + (Math.random() * owner.growrandom);
		this.gs = 0;
		this.age = 0;
	};
	Particle.prototype.tick = function (dt)
	{
		var owner = this.owner;
		this.x += Math.cos(this.angle) * this.speed * dt;
		this.y += Math.sin(this.angle) * this.speed * dt;
		this.y += this.gs * dt;
		this.speed += owner.acc * dt;
		this.size += this.grow * dt;
		this.gs += owner.g * dt;
		this.age += dt;
		if (this.size < 1)
		{
			this.active = false;
			return;
		}
		if (owner.lifeanglerandom !== 0)
			this.angle += (Math.random() * owner.lifeanglerandom * dt) - (owner.lifeanglerandom * dt / 2);
		if (owner.lifespeedrandom !== 0)
			this.speed += (Math.random() * owner.lifespeedrandom * dt) - (owner.lifespeedrandom * dt / 2);
		if (owner.lifeopacityrandom !== 0)
		{
			this.opacity += (Math.random() * owner.lifeopacityrandom * dt) - (owner.lifeopacityrandom * dt / 2);
			if (this.opacity < 0)
				this.opacity = 0;
			else if (this.opacity > 1)
				this.opacity = 1;
		}
		if (owner.destroymode <= 1 && this.age >= owner.timeout)
		{
			this.active = false;
		}
		if (owner.destroymode === 2 && this.speed <= 0)
		{
			this.active = false;
		}
	};
	Particle.prototype.draw = function (ctx)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (curopacity === 0)
			return;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		ctx.globalAlpha = curopacity;
		var drawx = this.x - this.size / 2;
		var drawy = this.y - this.size / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		ctx.drawImage(this.owner.type.texture_img, drawx, drawy, this.size, this.size);
	};
	Particle.prototype.drawGL = function (glw)
	{
		var curopacity = this.owner.opacity * this.opacity;
		if (this.owner.destroymode === 0)
			curopacity *= 1 - (this.age / this.owner.timeout);
		var drawsize = this.size;
		var scaleddrawsize = drawsize * this.owner.particlescale;
		var drawx = this.x - drawsize / 2;
		var drawy = this.y - drawsize / 2;
		if (this.owner.runtime.pixel_rounding)
		{
			drawx = (drawx + 0.5) | 0;
			drawy = (drawy + 0.5) | 0;
		}
		if (scaleddrawsize < 1 || curopacity === 0)
			return;
		if (scaleddrawsize < glw.minPointSize || scaleddrawsize > glw.maxPointSize)
		{
			glw.setOpacity(curopacity);
			glw.quad(drawx, drawy, drawx + drawsize, drawy, drawx + drawsize, drawy + drawsize, drawx, drawy + drawsize);
		}
		else
			glw.point(this.x, this.y, scaleddrawsize, curopacity);
	};
	Particle.prototype.left = function ()
	{
		return this.x - this.size / 2;
	};
	Particle.prototype.right = function ()
	{
		return this.x + this.size / 2;
	};
	Particle.prototype.top = function ()
	{
		return this.y - this.size / 2;
	};
	Particle.prototype.bottom = function ()
	{
		return this.y + this.size / 2;
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var deadparticles = [];
	instanceProto.onCreate = function()
	{
		var props = this.properties;
		this.rate = props[0];
		this.spraycone = cr.to_radians(props[1]);
		this.spraytype = props[2];			// 0 = continuous, 1 = one-shot
		this.spraying = true;				// for continuous mode only
		this.initspeed = props[3];
		this.initsize = props[4];
		this.initopacity = props[5] / 100.0;
		this.growrate = props[6];
		this.xrandom = props[7];
		this.yrandom = props[8];
		this.speedrandom = props[9];
		this.sizerandom = props[10];
		this.growrandom = props[11];
		this.acc = props[12];
		this.g = props[13];
		this.lifeanglerandom = props[14];
		this.lifespeedrandom = props[15];
		this.lifeopacityrandom = props[16];
		this.destroymode = props[17];		// 0 = fade, 1 = timeout, 2 = stopped
		this.timeout = props[18];
		this.particleCreateCounter = 0;
		this.particlescale = 1;
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		this.add_bbox_changed_callback(function (self) {
			self.bbox.set(self.particleBoxLeft, self.particleBoxTop, self.particleBoxRight, self.particleBoxBottom);
			self.bquad.set_from_rect(self.bbox);
			self.bbox_changed = false;
			self.update_collision_cell();
		});
		if (!this.recycled)
			this.particles = [];
		this.runtime.tickMe(this);
		this.type.loadTextures();
		if (this.spraytype === 1)
		{
			for (var i = 0; i < this.rate; i++)
				this.allocateParticle().opacity = 0;
		}
		this.first_tick = true;		// for re-init'ing one-shot particles on first tick so they assume any new angle/position
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"r": this.rate,
			"sc": this.spraycone,
			"st": this.spraytype,
			"s": this.spraying,
			"isp": this.initspeed,
			"isz": this.initsize,
			"io": this.initopacity,
			"gr": this.growrate,
			"xr": this.xrandom,
			"yr": this.yrandom,
			"spr": this.speedrandom,
			"szr": this.sizerandom,
			"grnd": this.growrandom,
			"acc": this.acc,
			"g": this.g,
			"lar": this.lifeanglerandom,
			"lsr": this.lifespeedrandom,
			"lor": this.lifeopacityrandom,
			"dm": this.destroymode,
			"to": this.timeout,
			"pcc": this.particleCreateCounter,
			"ft": this.first_tick,
			"p": []
		};
		var i, len, p;
		var arr = o["p"];
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			arr.push([p.x, p.y, p.speed, p.angle, p.opacity, p.grow, p.size, p.gs, p.age]);
		}
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.rate = o["r"];
		this.spraycone = o["sc"];
		this.spraytype = o["st"];
		this.spraying = o["s"];
		this.initspeed = o["isp"];
		this.initsize = o["isz"];
		this.initopacity = o["io"];
		this.growrate = o["gr"];
		this.xrandom = o["xr"];
		this.yrandom = o["yr"];
		this.speedrandom = o["spr"];
		this.sizerandom = o["szr"];
		this.growrandom = o["grnd"];
		this.acc = o["acc"];
		this.g = o["g"];
		this.lifeanglerandom = o["lar"];
		this.lifespeedrandom = o["lsr"];
		this.lifeopacityrandom = o["lor"];
		this.destroymode = o["dm"];
		this.timeout = o["to"];
		this.particleCreateCounter = o["pcc"];
		this.first_tick = o["ft"];
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
		var i, len, p, d;
		var arr = o["p"];
		for (i = 0, len = arr.length; i < len; i++)
		{
			p = this.allocateParticle();
			d = arr[i];
			p.x = d[0];
			p.y = d[1];
			p.speed = d[2];
			p.angle = d[3];
			p.opacity = d[4];
			p.grow = d[5];
			p.size = d[6];
			p.gs = d[7];
			p.age = d[8];
		}
	};
	instanceProto.onDestroy = function ()
	{
		deadparticles.push.apply(deadparticles, this.particles);
		this.particles.length = 0;
	};
	instanceProto.allocateParticle = function ()
	{
		var p;
		if (deadparticles.length)
		{
			p = deadparticles.pop();
			p.owner = this;
		}
		else
			p = new Particle(this);
		this.particles.push(p);
		p.active = true;
		return p;
	};
	instanceProto.tick = function()
	{
		var dt = this.runtime.getDt(this);
		var i, len, p, n, j;
		if (this.spraytype === 0 && this.spraying)
		{
			this.particleCreateCounter += dt * this.rate;
			n = cr.floor(this.particleCreateCounter);
			this.particleCreateCounter -= n;
			for (i = 0; i < n; i++)
			{
				p = this.allocateParticle();
				p.init();
			}
		}
		this.particleBoxLeft = this.x;
		this.particleBoxTop = this.y;
		this.particleBoxRight = this.x;
		this.particleBoxBottom = this.y;
		for (i = 0, j = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			this.particles[j] = p;
			this.runtime.redraw = true;
			if (this.spraytype === 1 && this.first_tick)
				p.init();
			p.tick(dt);
			if (!p.active)
			{
				deadparticles.push(p);
				continue;
			}
			if (p.left() < this.particleBoxLeft)
				this.particleBoxLeft = p.left();
			if (p.right() > this.particleBoxRight)
				this.particleBoxRight = p.right();
			if (p.top() < this.particleBoxTop)
				this.particleBoxTop = p.top();
			if (p.bottom() > this.particleBoxBottom)
				this.particleBoxBottom = p.bottom();
			j++;
		}
		this.particles.length = j;
		this.set_bbox_changed();
		this.first_tick = false;
		if (this.spraytype === 1 && this.particles.length === 0)
			this.runtime.DestroyInstance(this);
	};
	instanceProto.draw = function (ctx)
	{
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.draw(ctx);
			}
		}
	};
	instanceProto.drawGL = function (glw)
	{
		this.particlescale = this.layer.getScale();
		glw.setTexture(this.type.webGL_texture);
		var i, len, p, layer = this.layer;
		for (i = 0, len = this.particles.length; i < len; i++)
		{
			p = this.particles[i];
			if (p.right() >= layer.viewLeft && p.bottom() >= layer.viewTop && p.left() <= layer.viewRight && p.top() <= layer.viewBottom)
			{
				p.drawGL(glw);
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.IsSpraying = function ()
	{
		return this.spraying;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpraying = function (set_)
	{
		this.spraying = (set_ !== 0);
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetRate = function (x)
	{
		this.rate = x;
		var diff, i;
		if (this.spraytype === 1 && this.first_tick)
		{
			if (x < this.particles.length)
			{
				diff = this.particles.length - x;
				for (i = 0; i < diff; i++)
					deadparticles.push(this.particles.pop());
			}
			else if (x > this.particles.length)
			{
				diff = x - this.particles.length;
				for (i = 0; i < diff; i++)
					this.allocateParticle().opacity = 0;
			}
		}
	};
	Acts.prototype.SetSprayCone = function (x)
	{
		this.spraycone = cr.to_radians(x);
	};
	Acts.prototype.SetInitSpeed = function (x)
	{
		this.initspeed = x;
	};
	Acts.prototype.SetInitSize = function (x)
	{
		this.initsize = x;
	};
	Acts.prototype.SetInitOpacity = function (x)
	{
		this.initopacity = x / 100;
	};
	Acts.prototype.SetGrowRate = function (x)
	{
		this.growrate = x;
	};
	Acts.prototype.SetXRandomiser = function (x)
	{
		this.xrandom = x;
	};
	Acts.prototype.SetYRandomiser = function (x)
	{
		this.yrandom = x;
	};
	Acts.prototype.SetSpeedRandomiser = function (x)
	{
		this.speedrandom = x;
	};
	Acts.prototype.SetSizeRandomiser = function (x)
	{
		this.sizerandom = x;
	};
	Acts.prototype.SetGrowRateRandomiser = function (x)
	{
		this.growrandom = x;
	};
	Acts.prototype.SetParticleAcc = function (x)
	{
		this.acc = x;
	};
	Acts.prototype.SetGravity = function (x)
	{
		this.g = x;
	};
	Acts.prototype.SetAngleRandomiser = function (x)
	{
		this.lifeanglerandom = x;
	};
	Acts.prototype.SetLifeSpeedRandomiser = function (x)
	{
		this.lifespeedrandom = x;
	};
	Acts.prototype.SetOpacityRandomiser = function (x)
	{
		this.lifeopacityrandom = x;
	};
	Acts.prototype.SetTimeout = function (x)
	{
		this.timeout = x;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ParticleCount = function (ret)
	{
		ret.set_int(this.particles.length);
	};
	Exps.prototype.Rate = function (ret)
	{
		ret.set_float(this.rate);
	};
	Exps.prototype.SprayCone = function (ret)
	{
		ret.set_float(cr.to_degrees(this.spraycone));
	};
	Exps.prototype.InitSpeed = function (ret)
	{
		ret.set_float(this.initspeed);
	};
	Exps.prototype.InitSize = function (ret)
	{
		ret.set_float(this.initsize);
	};
	Exps.prototype.InitOpacity = function (ret)
	{
		ret.set_float(this.initopacity * 100);
	};
	Exps.prototype.InitGrowRate = function (ret)
	{
		ret.set_float(this.growrate);
	};
	Exps.prototype.XRandom = function (ret)
	{
		ret.set_float(this.xrandom);
	};
	Exps.prototype.YRandom = function (ret)
	{
		ret.set_float(this.yrandom);
	};
	Exps.prototype.InitSpeedRandom = function (ret)
	{
		ret.set_float(this.speedrandom);
	};
	Exps.prototype.InitSizeRandom = function (ret)
	{
		ret.set_float(this.sizerandom);
	};
	Exps.prototype.InitGrowRandom = function (ret)
	{
		ret.set_float(this.growrandom);
	};
	Exps.prototype.ParticleAcceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.Gravity = function (ret)
	{
		ret.set_float(this.g);
	};
	Exps.prototype.ParticleAngleRandom = function (ret)
	{
		ret.set_float(this.lifeanglerandom);
	};
	Exps.prototype.ParticleSpeedRandom = function (ret)
	{
		ret.set_float(this.lifespeedrandom);
	};
	Exps.prototype.ParticleOpacityRandom = function (ret)
	{
		ret.set_float(this.lifeopacityrandom);
	};
	Exps.prototype.Timeout = function (ret)
	{
		ret.set_float(this.timeout);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Rex_Nickname = function(runtime)
{
	this.runtime = runtime;
};
cr.plugins_.Rex_Nickname.nickname2objtype = {};  // {sid:_sid, index:types_by_index[_index]}
(function ()
{
	var pluginProto = cr.plugins_.Rex_Nickname.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
	    this.nickname2objtype = cr.plugins_.Rex_Nickname.nickname2objtype;
	};
	instanceProto._getObjectType = function (nickname)
	{
        var sid_info = this.nickname2objtype[nickname];
        if (sid_info == null)
            return null;
        var sid = sid_info.sid;
        var objtypes = this.runtime.types_by_index;
        var t = objtypes[sid_info.index];
        if ((t != null) && (t.sid === sid))
            return t;
		var i, len=objtypes.length;
		for (i=0; i<len; i++)
		{
            t = objtypes[i];
			if (t.sid === sid)
            {
                sid_info.index = i;
				return t;
            }
		}
		return null;
	};
	instanceProto.create_insts = function (nickname,x,y,_layer)
	{
	    var objtype = this._getObjectType(nickname);
        if (objtype == null)
            return;
        var layer = (typeof _layer == "number")?
                    this.runtime.getLayerByNumber(_layer):
                    this.runtime.getLayerByName(_layer);
        var inst = this.runtime.createInstance(objtype, layer, x, y );
		if (inst == null)
		    return null;
        var sol = inst.type.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		var i, len, s;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
		this.runtime.isInOnDestroy++;
		this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		this.runtime.isInOnDestroy--;
	    return inst;
	};
    instanceProto.PickAll = function (nickname, family_objtype)
	{
	    if (!family_objtype.is_family)
		    return;
	    var objtype = this._getObjectType(nickname);
        if (!objtype)
            return;
        if (family_objtype.members.indexOf(objtype) == -1)
            return;
        var sol = objtype.getCurrentSol();
        var sol_save = sol.select_all;
        sol.select_all = true;
        var all_insts = sol.getObjects();
        var sol_family = family_objtype.getCurrentSol();
        sol_family.instances = all_insts.slice();
        sol_family.select_all = false;
        sol.select_all = sol_save;
	};
	instanceProto.saveToJSON = function ()
	{
	    var sid2name = {};
	    var name, objtype;
	    for (name in this.nickname2objtype)
	        sid2name[this.nickname2objtype[name].sid] = name;
		return { "sid2name": sid2name,
		         };
	};
	instanceProto.loadFromJSON = function (o)
	{
	    var sid2name = o["sid2name"];
	    var sid, name, objtype;
	    for (sid in sid2name)
	    {
	        name = sid2name[sid];
            this.nickname2objtype[name] = {sid:parseInt(sid, 10), index:-1};
	    }
	};
	function Cnds() {};
	pluginProto.cnds = new Cnds();
	Cnds.prototype.PickAll = function (nickname, family_objtype)
	{
	    this.PickAll(nickname, family_objtype);
		return true;
	};
	function Acts() {};
	pluginProto.acts = new Acts();
	Acts.prototype.AssignNickname = function (nickname, objtype)
	{
        if (objtype == null)
            return;
        this.nickname2objtype[nickname] = {sid:objtype.sid, index:-1};
	};
	Acts.prototype.CreateInsts = function (nickname,x,y,_layer, family_objtype)
	{
        var inst = this.create_insts(nickname,x,y,_layer);
        if (inst == null)
            return;
        if (!family_objtype)
            return;
        if (family_objtype.members.indexOf(inst.type) == -1)
            return;
        family_objtype.getCurrentSol().pick_one(inst);
        family_objtype.applySolToContainer();
	};
    Acts.prototype.PickAll = function (nickname, family_objtype)
	{
	    this.PickAll(nickname, family_objtype);
	};
	function Exps() {};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Sprite = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Sprite.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	function frame_getDataUri()
	{
		if (this.datauri.length === 0)
		{
			var tmpcanvas = document.createElement("canvas");
			tmpcanvas.width = this.width;
			tmpcanvas.height = this.height;
			var tmpctx = tmpcanvas.getContext("2d");
			if (this.spritesheeted)
			{
				tmpctx.drawImage(this.texture_img, this.offx, this.offy, this.width, this.height,
										 0, 0, this.width, this.height);
			}
			else
			{
				tmpctx.drawImage(this.texture_img, 0, 0, this.width, this.height);
			}
			this.datauri = tmpcanvas.toDataURL("image/png");
		}
		return this.datauri;
	};
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		var i, leni, j, lenj;
		var anim, frame, animobj, frameobj, wt, uv;
		this.all_frames = [];
		this.has_loaded_textures = false;
		for (i = 0, leni = this.animations.length; i < leni; i++)
		{
			anim = this.animations[i];
			animobj = {};
			animobj.name = anim[0];
			animobj.speed = anim[1];
			animobj.loop = anim[2];
			animobj.repeatcount = anim[3];
			animobj.repeatto = anim[4];
			animobj.pingpong = anim[5];
			animobj.sid = anim[6];
			animobj.frames = [];
			for (j = 0, lenj = anim[7].length; j < lenj; j++)
			{
				frame = anim[7][j];
				frameobj = {};
				frameobj.texture_file = frame[0];
				frameobj.texture_filesize = frame[1];
				frameobj.offx = frame[2];
				frameobj.offy = frame[3];
				frameobj.width = frame[4];
				frameobj.height = frame[5];
				frameobj.duration = frame[6];
				frameobj.hotspotX = frame[7];
				frameobj.hotspotY = frame[8];
				frameobj.image_points = frame[9];
				frameobj.poly_pts = frame[10];
				frameobj.pixelformat = frame[11];
				frameobj.spritesheeted = (frameobj.width !== 0);
				frameobj.datauri = "";		// generated on demand and cached
				frameobj.getDataUri = frame_getDataUri;
				uv = {};
				uv.left = 0;
				uv.top = 0;
				uv.right = 1;
				uv.bottom = 1;
				frameobj.sheetTex = uv;
				frameobj.webGL_texture = null;
				wt = this.runtime.findWaitingTexture(frame[0]);
				if (wt)
				{
					frameobj.texture_img = wt;
				}
				else
				{
					frameobj.texture_img = new Image();
					frameobj.texture_img["idtkLoadDisposed"] = true;
					frameobj.texture_img.src = frame[0];
					frameobj.texture_img.cr_src = frame[0];
					frameobj.texture_img.cr_filesize = frame[1];
					frameobj.texture_img.c2webGL_texture = null;
					this.runtime.waitForImageLoad(frameobj.texture_img);
				}
				cr.seal(frameobj);
				animobj.frames.push(frameobj);
				this.all_frames.push(frameobj);
			}
			cr.seal(animobj);
			this.animations[i] = animobj;		// swap array data for object
		}
	};
	typeProto.updateAllCurrentTexture = function ()
	{
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.curWebGLTexture = inst.curFrame.webGL_texture;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.texture_img.c2webGL_texture = null;
			frame.webGL_texture = null;
		}
		this.has_loaded_textures = false;
		this.updateAllCurrentTexture();
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.updateAllCurrentTexture();
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.has_loaded_textures || !this.runtime.glwrap)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.has_loaded_textures = true;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.has_loaded_textures)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			this.runtime.glwrap.deleteTexture(frame.webGL_texture);
			frame.webGL_texture = null;
		}
		this.has_loaded_textures = false;
	};
	var already_drawn_images = [];
	typeProto.preloadCanvas2D = function (ctx)
	{
		var i, len, frameimg;
		already_drawn_images.length = 0;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frameimg = this.all_frames[i].texture_img;
			if (already_drawn_images.indexOf(frameimg) !== -1)
					continue;
			ctx.drawImage(frameimg, 0, 0);
			already_drawn_images.push(frameimg);
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		var poly_pts = this.type.animations[0].frames[0].poly_pts;
		if (this.recycled)
			this.collision_poly.set_pts(poly_pts);
		else
			this.collision_poly = new cr.CollisionPoly(poly_pts);
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);	// 0=visible, 1=invisible
		this.isTicking = false;
		this.inAnimTrigger = false;
		this.collisionsEnabled = (this.properties[3] !== 0);
		if (!(this.type.animations.length === 1 && this.type.animations[0].frames.length === 1) && this.type.animations[0].speed !== 0)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		this.cur_animation = this.getAnimationByName(this.properties[1]) || this.type.animations[0];
		this.cur_frame = this.properties[2];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		var curanimframe = this.cur_animation.frames[this.cur_frame];
		this.collision_poly.set_pts(curanimframe.poly_pts);
		this.hotspotX = curanimframe.hotspotX;
		this.hotspotY = curanimframe.hotspotY;
		this.cur_anim_speed = this.cur_animation.speed;
		if (this.recycled)
			this.animTimer.reset();
		else
			this.animTimer = new cr.KahanAdder();
		this.frameStart = this.getNowTime();
		this.animPlaying = true;
		this.animRepeats = 0;
		this.animForwards = true;
		this.animTriggerName = "";
		this.changeAnimName = "";
		this.changeAnimFrom = 0;
		this.changeAnimFrame = -1;
		this.type.loadTextures();
		var i, leni, j, lenj;
		var anim, frame, uv, maintex;
		for (i = 0, leni = this.type.animations.length; i < leni; i++)
		{
			anim = this.type.animations[i];
			for (j = 0, lenj = anim.frames.length; j < lenj; j++)
			{
				frame = anim.frames[j];
				if (frame.width === 0)
				{
					frame.width = frame.texture_img.width;
					frame.height = frame.texture_img.height;
				}
				if (frame.spritesheeted)
				{
					maintex = frame.texture_img;
					uv = frame.sheetTex;
					uv.left = frame.offx / maintex.width;
					uv.top = frame.offy / maintex.height;
					uv.right = (frame.offx + frame.width) / maintex.width;
					uv.bottom = (frame.offy + frame.height) / maintex.height;
					if (frame.offx === 0 && frame.offy === 0 && frame.width === maintex.width && frame.height === maintex.height)
					{
						frame.spritesheeted = false;
					}
				}
			}
		}
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"a": this.cur_animation.sid,
			"f": this.cur_frame,
			"cas": this.cur_anim_speed,
			"fs": this.frameStart,
			"ar": this.animRepeats,
			"at": this.animTimer.sum
		};
		if (!this.animPlaying)
			o["ap"] = this.animPlaying;
		if (!this.animForwards)
			o["af"] = this.animForwards;
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		var anim = this.getAnimationBySid(o["a"]);
		if (anim)
			this.cur_animation = anim;
		this.cur_frame = o["f"];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		this.cur_anim_speed = o["cas"];
		this.frameStart = o["fs"];
		this.animRepeats = o["ar"];
		this.animTimer.reset();
		this.animTimer.sum = o["at"];
		this.animPlaying = o.hasOwnProperty("ap") ? o["ap"] : true;
		this.animForwards = o.hasOwnProperty("af") ? o["af"] : true;
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
		this.collision_poly.set_pts(this.curFrame.poly_pts);
		this.hotspotX = this.curFrame.hotspotX;
		this.hotspotY = this.curFrame.hotspotY;
	};
	instanceProto.animationFinish = function (reverse)
	{
		this.cur_frame = reverse ? 0 : this.cur_animation.frames.length - 1;
		this.animPlaying = false;
		this.animTriggerName = this.cur_animation.name;
		this.inAnimTrigger = true;
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished, this);
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished, this);
		this.inAnimTrigger = false;
		this.animRepeats = 0;
	};
	instanceProto.getNowTime = function()
	{
		return this.animTimer.sum;
	};
	instanceProto.tick = function()
	{
		this.animTimer.add(this.runtime.getDt(this));
		if (this.changeAnimName.length)
			this.doChangeAnim();
		if (this.changeAnimFrame >= 0)
			this.doChangeAnimFrame();
		var now = this.getNowTime();
		var cur_animation = this.cur_animation;
		var prev_frame = cur_animation.frames[this.cur_frame];
		var next_frame;
		var cur_frame_time = prev_frame.duration / this.cur_anim_speed;
		if (this.animPlaying && now >= this.frameStart + cur_frame_time)
		{
			if (this.animForwards)
			{
				this.cur_frame++;
			}
			else
			{
				this.cur_frame--;
			}
			this.frameStart += cur_frame_time;
			if (this.cur_frame >= cur_animation.frames.length)
			{
				if (cur_animation.pingpong)
				{
					this.animForwards = false;
					this.cur_frame = cur_animation.frames.length - 2;
				}
				else if (cur_animation.loop)
				{
					this.cur_frame = cur_animation.repeatto;
				}
				else
				{
					this.animRepeats++;
					if (this.animRepeats >= cur_animation.repeatcount)
					{
						this.animationFinish(false);
					}
					else
					{
						this.cur_frame = cur_animation.repeatto;
					}
				}
			}
			if (this.cur_frame < 0)
			{
				if (cur_animation.pingpong)
				{
					this.cur_frame = 1;
					this.animForwards = true;
					if (!cur_animation.loop)
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
					}
				}
				else
				{
					if (cur_animation.loop)
					{
						this.cur_frame = cur_animation.repeatto;
					}
					else
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
						else
						{
							this.cur_frame = cur_animation.repeatto;
						}
					}
				}
			}
			if (this.cur_frame < 0)
				this.cur_frame = 0;
			else if (this.cur_frame >= cur_animation.frames.length)
				this.cur_frame = cur_animation.frames.length - 1;
			if (now > this.frameStart + (cur_animation.frames[this.cur_frame].duration / this.cur_anim_speed))
			{
				this.frameStart = now;
			}
			next_frame = cur_animation.frames[this.cur_frame];
			this.OnFrameChanged(prev_frame, next_frame);
			this.runtime.redraw = true;
		}
	};
	instanceProto.getAnimationByName = function (name_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (cr.equals_nocase(a.name, name_))
				return a;
		}
		return null;
	};
	instanceProto.getAnimationBySid = function (sid_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (a.sid === sid_)
				return a;
		}
		return null;
	};
	instanceProto.doChangeAnim = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var anim = this.getAnimationByName(this.changeAnimName);
		this.changeAnimName = "";
		if (!anim)
			return;
		if (cr.equals_nocase(anim.name, this.cur_animation.name) && this.animPlaying)
			return;
		this.cur_animation = anim;
		this.cur_anim_speed = anim.speed;
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (this.changeAnimFrom === 1)
			this.cur_frame = 0;
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		this.animForwards = true;
		this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
		this.runtime.redraw = true;
	};
	instanceProto.doChangeAnimFrame = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var prev_frame_number = this.cur_frame;
		this.cur_frame = cr.floor(this.changeAnimFrame);
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (prev_frame_number !== this.cur_frame)
		{
			this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
			this.frameStart = this.getNowTime();
			this.runtime.redraw = true;
		}
		this.changeAnimFrame = -1;
	};
	instanceProto.OnFrameChanged = function (prev_frame, next_frame)
	{
		var oldw = prev_frame.width;
		var oldh = prev_frame.height;
		var neww = next_frame.width;
		var newh = next_frame.height;
		if (oldw != neww)
			this.width *= (neww / oldw);
		if (oldh != newh)
			this.height *= (newh / oldh);
		this.hotspotX = next_frame.hotspotX;
		this.hotspotY = next_frame.hotspotY;
		this.collision_poly.set_pts(next_frame.poly_pts);
		this.set_bbox_changed();
		this.curFrame = next_frame;
		this.curWebGLTexture = next_frame.webGL_texture;
		var i, len, b;
		for (i = 0, len = this.behavior_insts.length; i < len; i++)
		{
			b = this.behavior_insts[i];
			if (b.onSpriteFrameChanged)
				b.onSpriteFrameChanged(prev_frame, next_frame);
		}
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged, this);
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		var cur_frame = this.curFrame;
		var spritesheeted = cur_frame.spritesheeted;
		var cur_image = cur_frame.texture_img;
		var myx = this.x;
		var myy = this.y;
		var w = this.width;
		var h = this.height;
		if (this.angle === 0 && w >= 0 && h >= 0)
		{
			myx -= this.hotspotX * w;
			myy -= this.hotspotY * h;
			if (this.runtime.pixel_rounding)
			{
				myx = Math.round(myx);
				myy = Math.round(myy);
			}
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 myx, myy, w, h);
			}
			else
			{
				ctx.drawImage(cur_image, myx, myy, w, h);
			}
		}
		else
		{
			if (this.runtime.pixel_rounding)
			{
				myx = Math.round(myx);
				myy = Math.round(myy);
			}
			ctx.save();
			var widthfactor = w > 0 ? 1 : -1;
			var heightfactor = h > 0 ? 1 : -1;
			ctx.translate(myx, myy);
			if (widthfactor !== 1 || heightfactor !== 1)
				ctx.scale(widthfactor, heightfactor);
			ctx.rotate(this.angle * widthfactor * heightfactor);
			var drawx = 0 - (this.hotspotX * cr.abs(w))
			var drawy = 0 - (this.hotspotY * cr.abs(h));
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 drawx, drawy, cr.abs(w), cr.abs(h));
			}
			else
			{
				ctx.drawImage(cur_image, drawx, drawy, cr.abs(w), cr.abs(h));
			}
			ctx.restore();
		}
		/*
		ctx.strokeStyle = "#f00";
		ctx.lineWidth = 3;
		ctx.beginPath();
		this.collision_poly.cache_poly(this.width, this.height, this.angle);
		var i, len, ax, ay, bx, by;
		for (i = 0, len = this.collision_poly.pts_count; i < len; i++)
		{
			ax = this.collision_poly.pts_cache[i*2] + this.x;
			ay = this.collision_poly.pts_cache[i*2+1] + this.y;
			bx = this.collision_poly.pts_cache[((i+1)%len)*2] + this.x;
			by = this.collision_poly.pts_cache[((i+1)%len)*2+1] + this.y;
			ctx.moveTo(ax, ay);
			ctx.lineTo(bx, by);
		}
		ctx.stroke();
		ctx.closePath();
		*/
		/*
		if (this.behavior_insts.length >= 1 && this.behavior_insts[0].draw)
		{
			this.behavior_insts[0].draw(ctx);
		}
		*/
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.curWebGLTexture);
		glw.setOpacity(this.opacity);
		var cur_frame = this.curFrame;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = Math.round(this.x) - this.x;
			var oy = Math.round(this.y) - this.y;
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, cur_frame.sheetTex);
			else
				glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
		{
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, cur_frame.sheetTex);
			else
				glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
		}
	};
	instanceProto.getImagePointIndexByName = function(name_)
	{
		var cur_frame = this.curFrame;
		var i, len;
		for (i = 0, len = cur_frame.image_points.length; i < len; i++)
		{
			if (cr.equals_nocase(name_, cur_frame.image_points[i][0]))
				return i;
		}
		return -1;
	};
	instanceProto.getImagePoint = function(imgpt, getX)
	{
		var cur_frame = this.curFrame;
		var image_points = cur_frame.image_points;
		var index;
		if (cr.is_string(imgpt))
			index = this.getImagePointIndexByName(imgpt);
		else
			index = imgpt - 1;	// 0 is origin
		index = cr.floor(index);
		if (index < 0 || index >= image_points.length)
			return getX ? this.x : this.y;	// return origin
		var x = (image_points[index][1] - cur_frame.hotspotX) * this.width;
		var y = image_points[index][2];
		y = (y - cur_frame.hotspotY) * this.height;
		var cosa = Math.cos(this.angle);
		var sina = Math.sin(this.angle);
		var x_temp = (x * cosa) - (y * sina);
		y = (y * cosa) + (x * sina);
		x = x_temp;
		x += this.x;
		y += this.y;
		return getX ? x : y;
	};
	function Cnds() {};
	var arrCache = [];
	function allocArr()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [0, 0, 0];
	};
	function freeArr(a)
	{
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
		arrCache.push(a);
	};
	function makeCollKey(a, b)
	{
		if (a < b)
			return "" + a + "," + b;
		else
			return "" + b + "," + a;
	};
	function collmemory_add(collmemory, a, b, tickcount)
	{
		var a_uid = a.uid;
		var b_uid = b.uid;
		var key = makeCollKey(a_uid, b_uid);
		if (collmemory.hasOwnProperty(key))
		{
			collmemory[key][2] = tickcount;
			return;
		}
		var arr = allocArr();
		arr[0] = a_uid;
		arr[1] = b_uid;
		arr[2] = tickcount;
		collmemory[key] = arr;
	};
	function collmemory_remove(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			freeArr(collmemory[key]);
			delete collmemory[key];
		}
	};
	function collmemory_removeInstance(collmemory, inst)
	{
		var uid = inst.uid;
		var p, entry;
		for (p in collmemory)
		{
			if (collmemory.hasOwnProperty(p))
			{
				entry = collmemory[p];
				if (entry[0] === uid || entry[1] === uid)
				{
					freeArr(collmemory[p]);
					delete collmemory[p];
				}
			}
		}
	};
	var last_coll_tickcount = -2;
	function collmemory_has(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			last_coll_tickcount = collmemory[key][2];
			return true;
		}
		else
		{
			last_coll_tickcount = -2;
			return false;
		}
	};
	var candidates1 = [];
	Cnds.prototype.OnCollision = function (rtype)
	{
		if (!rtype)
			return false;
		var runtime = this.runtime;
		var cnd = runtime.getCurrentCondition();
		var ltype = cnd.type;
		if (!cnd.extra["collmemory"])
		{
			cnd.extra["collmemory"] = {};
			runtime.addDestroyCallback((function (collmemory) {
				return function(inst) {
					collmemory_removeInstance(collmemory, inst);
				};
			})(cnd.extra["collmemory"]));
		}
		var collmemory = cnd.extra["collmemory"];
		var lsol = ltype.getCurrentSol();
		var rsol = rtype.getCurrentSol();
		var linstances = lsol.getObjects();
		var rinstances;
		var l, linst, r, rinst;
		var curlsol, currsol;
		var tickcount = this.runtime.tickcount;
		var lasttickcount = tickcount - 1;
		var exists, run;
		var current_event = runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		for (l = 0; l < linstances.length; l++)
		{
			linst = linstances[l];
			if (rsol.select_all)
			{
				linst.update_bbox();
				this.runtime.getCollisionCandidates(linst.layer, rtype, linst.bbox, candidates1);
				rinstances = candidates1;
			}
			else
				rinstances = rsol.getObjects();
			for (r = 0; r < rinstances.length; r++)
			{
				rinst = rinstances[r];
				if (runtime.testOverlap(linst, rinst) || runtime.checkRegisteredCollision(linst, rinst))
				{
					exists = collmemory_has(collmemory, linst, rinst);
					run = (!exists || (last_coll_tickcount < lasttickcount));
					collmemory_add(collmemory, linst, rinst, tickcount);
					if (run)
					{
						runtime.pushCopySol(current_event.solModifiers);
						curlsol = ltype.getCurrentSol();
						currsol = rtype.getCurrentSol();
						curlsol.select_all = false;
						currsol.select_all = false;
						if (ltype === rtype)
						{
							curlsol.instances.length = 2;	// just use lsol, is same reference as rsol
							curlsol.instances[0] = linst;
							curlsol.instances[1] = rinst;
							ltype.applySolToContainer();
						}
						else
						{
							curlsol.instances.length = 1;
							currsol.instances.length = 1;
							curlsol.instances[0] = linst;
							currsol.instances[0] = rinst;
							ltype.applySolToContainer();
							rtype.applySolToContainer();
						}
						current_event.retrigger();
						runtime.popSol(current_event.solModifiers);
					}
				}
				else
				{
					collmemory_remove(collmemory, linst, rinst);
				}
			}
			candidates1.length = 0;
		}
		return false;
	};
	var rpicktype = null;
	var rtopick = new cr.ObjectSet();
	var needscollisionfinish = false;
	var candidates2 = [];
	function DoOverlapCondition(rtype, offx, offy)
	{
		if (!rtype)
			return false;
		var do_offset = (offx !== 0 || offy !== 0);
		var oldx, oldy, ret = false, r, lenr, rinst;
		var cnd = this.runtime.getCurrentCondition();
		var ltype = cnd.type;
		var inverted = cnd.inverted;
		var rsol = rtype.getCurrentSol();
		var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
		var rinstances;
		if (rsol.select_all)
		{
			this.update_bbox();
			this.runtime.getCollisionCandidates(this.layer, rtype, this.bbox, candidates2);
			rinstances = candidates2;
		}
		else if (orblock)
			rinstances = rsol.else_instances;
		else
			rinstances = rsol.instances;
		rpicktype = rtype;
		needscollisionfinish = (ltype !== rtype && !inverted);
		if (do_offset)
		{
			oldx = this.x;
			oldy = this.y;
			this.x += offx;
			this.y += offy;
			this.set_bbox_changed();
		}
		for (r = 0, lenr = rinstances.length; r < lenr; r++)
		{
			rinst = rinstances[r];
			if (this.runtime.testOverlap(this, rinst))
			{
				ret = true;
				if (inverted)
					break;
				if (ltype !== rtype)
					rtopick.add(rinst);
			}
		}
		if (do_offset)
		{
			this.x = oldx;
			this.y = oldy;
			this.set_bbox_changed();
		}
		candidates2.length = 0;
		return ret;
	};
	typeProto.finish = function (do_pick)
	{
		if (!needscollisionfinish)
			return;
		if (do_pick)
		{
			var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
			var sol = rpicktype.getCurrentSol();
			var topick = rtopick.valuesRef();
			var i, len, inst;
			if (sol.select_all)
			{
				sol.select_all = false;
				sol.instances.length = topick.length;
				for (i = 0, len = topick.length; i < len; i++)
				{
					sol.instances[i] = topick[i];
				}
				if (orblock)
				{
					sol.else_instances.length = 0;
					for (i = 0, len = rpicktype.instances.length; i < len; i++)
					{
						inst = rpicktype.instances[i];
						if (!rtopick.contains(inst))
							sol.else_instances.push(inst);
					}
				}
			}
			else
			{
				if (orblock)
				{
					var initsize = sol.instances.length;
					sol.instances.length = initsize + topick.length;
					for (i = 0, len = topick.length; i < len; i++)
					{
						sol.instances[initsize + i] = topick[i];
						cr.arrayFindRemove(sol.else_instances, topick[i]);
					}
				}
				else
				{
					cr.shallowAssignArray(sol.instances, topick);
				}
			}
			rpicktype.applySolToContainer();
		}
		rtopick.clear();
		needscollisionfinish = false;
	};
	Cnds.prototype.IsOverlapping = function (rtype)
	{
		return DoOverlapCondition.call(this, rtype, 0, 0);
	};
	Cnds.prototype.IsOverlappingOffset = function (rtype, offx, offy)
	{
		return DoOverlapCondition.call(this, rtype, offx, offy);
	};
	Cnds.prototype.IsAnimPlaying = function (animname)
	{
		if (this.changeAnimName.length)
			return cr.equals_nocase(this.changeAnimName, animname);
		else
			return cr.equals_nocase(this.cur_animation.name, animname);
	};
	Cnds.prototype.CompareFrame = function (cmp, framenum)
	{
		return cr.do_cmp(this.cur_frame, cmp, framenum);
	};
	Cnds.prototype.CompareAnimSpeed = function (cmp, x)
	{
		var s = (this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
		return cr.do_cmp(s, cmp, x);
	};
	Cnds.prototype.OnAnimFinished = function (animname)
	{
		return cr.equals_nocase(this.animTriggerName, animname);
	};
	Cnds.prototype.OnAnyAnimFinished = function ()
	{
		return true;
	};
	Cnds.prototype.OnFrameChanged = function ()
	{
		return true;
	};
	Cnds.prototype.IsMirrored = function ()
	{
		return this.width < 0;
	};
	Cnds.prototype.IsFlipped = function ()
	{
		return this.height < 0;
	};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsCollisionEnabled = function ()
	{
		return this.collisionsEnabled;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Spawn = function (obj, layer, imgpt)
	{
		if (!obj || !layer)
			return;
		var inst = this.runtime.createInstance(obj, layer, this.getImagePoint(imgpt, true), this.getImagePoint(imgpt, false));
		if (!inst)
			return;
		if (typeof inst.angle !== "undefined")
		{
			inst.angle = this.angle;
			inst.set_bbox_changed();
		}
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
		var cur_act = this.runtime.getCurrentAction();
		var reset_sol = false;
		if (cr.is_undefined(cur_act.extra["Spawn_LastExec"]) || cur_act.extra["Spawn_LastExec"] < this.runtime.execcount)
		{
			reset_sol = true;
			cur_act.extra["Spawn_LastExec"] = this.runtime.execcount;
		}
		var sol;
		if (obj != this.type)
		{
			sol = obj.getCurrentSol();
			sol.select_all = false;
			if (reset_sol)
			{
				sol.instances.length = 1;
				sol.instances[0] = inst;
			}
			else
				sol.instances.push(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					s = inst.siblings[i];
					sol = s.type.getCurrentSol();
					sol.select_all = false;
					if (reset_sol)
					{
						sol.instances.length = 1;
						sol.instances[0] = s;
					}
					else
						sol.instances.push(s);
				}
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.StopAnim = function ()
	{
		this.animPlaying = false;
	};
	Acts.prototype.StartAnim = function (from)
	{
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		if (from === 1 && this.cur_frame !== 0)
		{
			this.changeAnimFrame = 0;
			if (!this.inAnimTrigger)
				this.doChangeAnimFrame();
		}
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetAnim = function (animname, from)
	{
		this.changeAnimName = animname;
		this.changeAnimFrom = from;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnim();
	};
	Acts.prototype.SetAnimFrame = function (framenumber)
	{
		this.changeAnimFrame = framenumber;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnimFrame();
	};
	Acts.prototype.SetAnimSpeed = function (s)
	{
		this.cur_anim_speed = cr.abs(s);
		this.animForwards = (s >= 0);
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetMirrored = function (m)
	{
		var neww = cr.abs(this.width) * (m === 0 ? -1 : 1);
		if (this.width === neww)
			return;
		this.width = neww;
		this.set_bbox_changed();
	};
	Acts.prototype.SetFlipped = function (f)
	{
		var newh = cr.abs(this.height) * (f === 0 ? -1 : 1);
		if (this.height === newh)
			return;
		this.height = newh;
		this.set_bbox_changed();
	};
	Acts.prototype.SetScale = function (s)
	{
		var cur_frame = this.curFrame;
		var mirror_factor = (this.width < 0 ? -1 : 1);
		var flip_factor = (this.height < 0 ? -1 : 1);
		var new_width = cur_frame.width * s * mirror_factor;
		var new_height = cur_frame.height * s * flip_factor;
		if (this.width !== new_width || this.height !== new_height)
		{
			this.width = new_width;
			this.height = new_height;
			this.set_bbox_changed();
		}
	};
	Acts.prototype.LoadURL = function (url_, resize_)
	{
		var img = new Image();
		var self = this;
		var curFrame_ = this.curFrame;
		img.onload = function ()
		{
			if (curFrame_.texture_img.src === img.src)
			{
				if (self.runtime.glwrap && self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.runtime.redraw = true;
				self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
				return;
			}
			curFrame_.texture_img = img;
			curFrame_.offx = 0;
			curFrame_.offy = 0;
			curFrame_.width = img.width;
			curFrame_.height = img.height;
			curFrame_.spritesheeted = false;
			curFrame_.datauri = "";
			curFrame_.pixelformat = 0;	// reset to RGBA, since we don't know what type of image will have come in
			if (self.runtime.glwrap)
			{
				if (curFrame_.webGL_texture)
					self.runtime.glwrap.deleteTexture(curFrame_.webGL_texture);
				curFrame_.webGL_texture = self.runtime.glwrap.loadTexture(img, false, self.runtime.linearSampling);
				if (self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.type.updateAllCurrentTexture();
			}
			if (resize_ === 0)		// resize to image size
			{
				self.width = img.width;
				self.height = img.height;
				self.set_bbox_changed();
			}
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img["crossOrigin"] = "anonymous";
		img.src = url_;
	};
	Acts.prototype.SetCollisions = function (set_)
	{
		if (this.collisionsEnabled === (set_ !== 0))
			return;		// no change
		this.collisionsEnabled = (set_ !== 0);
		if (this.collisionsEnabled)
			this.set_bbox_changed();		// needs to be added back to cells
		else
		{
			if (this.collcells.right >= this.collcells.left)
				this.type.collision_grid.update(this, this.collcells, null);
			this.collcells.set(0, 0, -1, -1);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.AnimationFrame = function (ret)
	{
		ret.set_int(this.cur_frame);
	};
	Exps.prototype.AnimationFrameCount = function (ret)
	{
		ret.set_int(this.cur_animation.frames.length);
	};
	Exps.prototype.AnimationName = function (ret)
	{
		ret.set_string(this.cur_animation.name);
	};
	Exps.prototype.AnimationSpeed = function (ret)
	{
		ret.set_float(this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
	};
	Exps.prototype.ImagePointX = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, true));
	};
	Exps.prototype.ImagePointY = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, false));
	};
	Exps.prototype.ImagePointCount = function (ret)
	{
		ret.set_int(this.curFrame.image_points.length);
	};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.curFrame.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.curFrame.height);
	};
	pluginProto.exps = new Exps();
}());
/* global cr,log,assert2 */
/* jshint globalstrict: true */
/* jshint strict: true */
;
;
cr.plugins_.Spritefont2 = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Spritefont2.prototype;
	pluginProto.onCreate = function ()
	{
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.runtime.waitForImageLoad(this.texture_img);
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, false, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onDestroy = function()
	{
		freeAllLines (this.lines);
		freeAllClip  (this.clipList);
		freeAllClipUV(this.clipUV);
		cr.wipe(this.characterWidthList);
	};
	instanceProto.onCreate = function()
	{
		this.texture_img      = this.type.texture_img;
		this.characterWidth   = this.properties[0];
		this.characterHeight  = this.properties[1];
		this.characterSet     = this.properties[2];
		this.text             = this.properties[3];
		this.characterScale   = this.properties[4];
		this.visible          = (this.properties[5] === 0);	// 0=visible, 1=invisible
		this.halign           = this.properties[6]/2.0;			// 0=left, 1=center, 2=right
		this.valign           = this.properties[7]/2.0;			// 0=top, 1=center, 2=bottom
		this.wrapbyword       = (this.properties[9] === 0);	// 0=word, 1=character
		this.characterSpacing = this.properties[10];
		this.lineHeight       = this.properties[11];
		this.textWidth  = 0;
		this.textHeight = 0;
		if (this.recycled)
		{
			this.lines.length = 0;
			cr.wipe(this.clipList);
			cr.wipe(this.clipUV);
			cr.wipe(this.characterWidthList);
		}
		else
		{
			this.lines = [];
			this.clipList = {};
			this.clipUV = {};
			this.characterWidthList = {};
		}
		this.text_changed = true;
		this.lastwrapwidth = this.width;
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
			this.webGL_texture = this.type.webGL_texture;
		}
		this.SplitSheet();
	};
	instanceProto.saveToJSON = function ()
	{
		var save = {
			"t": this.text,
			"csc": this.characterScale,
			"csp": this.characterSpacing,
			"lh": this.lineHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick,
			"cw": {}
		};
		for (var ch in this.characterWidthList)
			save["cw"][ch] = this.characterWidthList[ch];
		return save;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.characterScale = o["csc"];
		this.characterSpacing = o["csp"];
		this.lineHeight = o["lh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		for(var ch in o["cw"])
			this.characterWidthList[ch] = o["cw"][ch];
		this.text_changed = true;
		this.lastwrapwidth = this.width;
	};
	function trimRight(text)
	{
		return text.replace(/\s\s*$/, '');
	}
	var MAX_CACHE_SIZE = 1000;
	function alloc(cache,Constructor)
	{
		if (cache.length)
			return cache.pop();
		else
			return new Constructor();
	}
	function free(cache,data)
	{
		if (cache.length < MAX_CACHE_SIZE)
		{
			cache.push(data);
		}
	}
	function freeAll(cache,dataList,isArray)
	{
		if (isArray) {
			var i, len;
			for (i = 0, len = dataList.length; i < len; i++)
			{
				free(cache,dataList[i]);
			}
			dataList.length = 0;
		} else {
			var prop;
			for(prop in dataList) {
				if(Object.prototype.hasOwnProperty.call(dataList,prop)) {
					free(cache,dataList[prop]);
					delete dataList[prop];
				}
			}
		}
	}
	function addLine(inst,lineIndex,cur_line) {
		var lines = inst.lines;
		var line;
		cur_line = trimRight(cur_line);
		if (lineIndex >= lines.length)
			lines.push(allocLine());
		line = lines[lineIndex];
		line.text = cur_line;
		line.width = inst.measureWidth(cur_line);
		inst.textWidth = cr.max(inst.textWidth,line.width);
	}
	var linesCache = [];
	function allocLine()       { return alloc(linesCache,Object); }
	function freeLine(l)       { free(linesCache,l); }
	function freeAllLines(arr) { freeAll(linesCache,arr,true); }
	function addClip(obj,property,x,y,w,h) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipCache,Object);
		}
		obj[property].x = x;
		obj[property].y = y;
		obj[property].w = w;
		obj[property].h = h;
	}
	var clipCache = [];
	function allocClip()      { return alloc(clipCache,Object); }
	function freeAllClip(obj) { freeAll(clipCache,obj,false);}
	function addClipUV(obj,property,left,top,right,bottom) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipUVCache,cr.rect);
		}
		obj[property].left   = left;
		obj[property].top    = top;
		obj[property].right  = right;
		obj[property].bottom = bottom;
	}
	var clipUVCache = [];
	function allocClipUV()      { return alloc(clipUVCache,cr.rect);}
	function freeAllClipUV(obj) { freeAll(clipUVCache,obj,false);}
	instanceProto.SplitSheet = function() {
		var texture      = this.texture_img;
		var texWidth     = texture.width;
		var texHeight    = texture.height;
		var charWidth    = this.characterWidth;
		var charHeight   = this.characterHeight;
		var charU        = charWidth /texWidth;
		var charV        = charHeight/texHeight;
		var charSet      = this.characterSet ;
		var cols = Math.floor(texWidth/charWidth);
		var rows = Math.floor(texHeight/charHeight);
		for ( var c = 0; c < charSet.length; c++) {
			if  (c >= cols * rows) break;
			var x = c%cols;
			var y = Math.floor(c/cols);
			var letter = charSet.charAt(c);
			if (this.runtime.glwrap) {
				addClipUV(
					this.clipUV, letter,
					x * charU ,
					y * charV ,
					(x+1) * charU ,
					(y+1) * charV
				);
			} else {
				addClip(
					this.clipList, letter,
					x * charWidth,
					y * charHeight,
					charWidth,
					charHeight
				);
			}
		}
	};
	/*
     *	Word-Wrapping
     */
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	pluginProto.WordWrap = function (inst)
	{
		var text = inst.text;
		var lines = inst.lines;
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		var width = inst.width;
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		var charWidth = inst.characterWidth;
		var charScale = inst.characterScale;
		var charSpacing = inst.characterSpacing;
		if ( (text.length * (charWidth * charScale + charSpacing) - charSpacing) <= width && text.indexOf("\n") === -1)
		{
			var all_width = inst.measureWidth(text);
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				inst.textWidth  = all_width;
				inst.textHeight = inst.characterHeight * charScale + inst.lineHeight;
				return;
			}
		}
		var wrapbyword = inst.wrapbyword;
		this.WrapText(inst);
		inst.textHeight = lines.length * (inst.characterHeight * charScale + inst.lineHeight);
	};
	pluginProto.WrapText = function (inst)
	{
		var wrapbyword = inst.wrapbyword;
		var text       = inst.text;
		var lines      = inst.lines;
		var width      = inst.width;
		var wordArray;
		if (wrapbyword) {
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		} else {
			wordArray = text;
		}
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		var ignore_newline = false;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (ignore_newline === true) {
					ignore_newline = false;
				} else {
					addLine(inst,lineIndex,cur_line);
					lineIndex++;
				}
				cur_line = "";
				continue;
			}
			ignore_newline = false;
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = inst.measureWidth(trimRight(cur_line));
			if (line_width > width)
			{
				if (prev_line === "") {
					addLine(inst,lineIndex,cur_line);
					cur_line = "";
					ignore_newline = true;
				} else {
					addLine(inst,lineIndex,prev_line);
					cur_line = wordArray[i];
				}
				lineIndex++;
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (trimRight(cur_line).length)
		{
			addLine(inst,lineIndex,cur_line);
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	instanceProto.measureWidth = function(text) {
		var spacing = this.characterSpacing;
		var len     = text.length;
		var width   = 0;
		for (var i = 0; i < len; i++) {
			width += this.getCharacterWidth(text.charAt(i)) * this.characterScale + spacing;
		}
		width -= (width > 0) ? spacing : 0;
		return width;
	};
	/***/
	instanceProto.getCharacterWidth = function(character) {
		var widthList = this.characterWidthList;
		if (widthList[character] !== undefined) {
			return widthList[character];
		} else {
			return this.characterWidth;
		}
	};
	instanceProto.rebuildText = function() {
		if (this.text_changed || this.width !== this.lastwrapwidth) {
			this.textWidth = 0;
			this.textHeight = 0;
			this.type.plugin.WordWrap(this);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
	};
	var EPSILON = 0.00001;
	instanceProto.draw = function(ctx, glmode)
	{
		var texture = this.texture_img;
		if (this.text !== "" && texture != null) {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			ctx.globalAlpha = this.opacity;
			var myx = this.x;
			var myy = this.y;
			if (this.runtime.pixel_rounding)
			{
				myx = Math.round(myx);
				myy = Math.round(myy);
			}
			var viewLeft = this.layer.viewLeft;
			var viewTop = this.layer.viewTop;
			var viewRight = this.layer.viewRight;
			var viewBottom = this.layer.viewBottom;
			ctx.save();
			ctx.translate(myx, myy);
			ctx.rotate(this.angle);
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var letterWidth;
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = -(this.hotspotX * this.width);
			var offy = -(this.hotspotY * this.height);
			offy += valign;
			var drawX ;
			var drawY = offy;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line = lines[i].text;
				var len  = lines[i].width;
				halign = ha * cr.max(0,this.width - len);
				drawX = offx + halign;
				drawY += lineHeight;
				if (myy + drawY + charHeight < viewTop)
				{
					drawY += charHeight;
					continue;
				}
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					letterWidth = this.getCharacterWidth(letter);
					var clip = this.clipList[letter];
					if (myx + drawX + letterWidth * scale + charSpace < viewLeft)
					{
						drawX += letterWidth * scale + charSpace;
						continue;
					}
					if ( drawX + letterWidth * scale > this.width + EPSILON ) {
						break;
					}
					if (clip !== undefined) {
						roundX = drawX;
						roundY = drawY;
						if (this.angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						ctx.drawImage( this.texture_img,
									 clip.x, clip.y, clip.w, clip.h,
									 roundX,roundY,clip.w*scale,clip.h*scale);
					}
					drawX += letterWidth * scale + charSpace;
					if (myx + drawX > viewRight)
						break;
				}
				drawY += charHeight;
				if (drawY + charHeight + lineHeight > this.height || myy + drawY > viewBottom)
				{
					break;
				}
			}
			ctx.restore();
		}
	};
	var dQuad = new cr.quad();
	function rotateQuad(quad,cosa,sina) {
		var x_temp;
		x_temp   = (quad.tlx * cosa) - (quad.tly * sina);
		quad.tly = (quad.tly * cosa) + (quad.tlx * sina);
		quad.tlx = x_temp;
		x_temp    = (quad.trx * cosa) - (quad.try_ * sina);
		quad.try_ = (quad.try_ * cosa) + (quad.trx * sina);
		quad.trx  = x_temp;
		x_temp   = (quad.blx * cosa) - (quad.bly * sina);
		quad.bly = (quad.bly * cosa) + (quad.blx * sina);
		quad.blx = x_temp;
		x_temp    = (quad.brx * cosa) - (quad.bry * sina);
		quad.bry = (quad.bry * cosa) + (quad.brx * sina);
		quad.brx  = x_temp;
	}
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		if (!this.text)
			return;
		this.rebuildText();
		if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
			return;
		}
		this.update_bbox();
		var q = this.bquad;
		var ox = 0;
		var oy = 0;
		if (this.runtime.pixel_rounding)
		{
			ox = Math.round(this.x) - this.x;
			oy = Math.round(this.y) - this.y;
		}
		var viewLeft = this.layer.viewLeft;
		var viewTop = this.layer.viewTop;
		var viewRight = this.layer.viewRight;
		var viewBottom = this.layer.viewBottom;
		var angle      = this.angle;
		var ha         = this.halign;
		var va         = this.valign;
		var scale      = this.characterScale;
		var charHeight = this.characterHeight * scale;   // to precalculate in onCreate or on change
		var lineHeight = this.lineHeight;
		var charSpace  = this.characterSpacing;
		var lines = this.lines;
		var textHeight = this.textHeight;
		var letterWidth;
		var cosa,sina;
		if (angle !== 0)
		{
			cosa = Math.cos(angle);
			sina = Math.sin(angle);
		}
		var halign;
		var valign = va * cr.max(0,(this.height - textHeight));
		var offx = q.tlx + ox;
		var offy = q.tly + oy;
		var drawX ;
		var drawY = valign;
		var roundX, roundY;
		for(var i = 0; i < lines.length; i++) {
			var line       = lines[i].text;
			var lineWidth  = lines[i].width;
			halign = ha * cr.max(0,this.width - lineWidth);
			drawX = halign;
			drawY += lineHeight;
			if (offy + drawY + charHeight < viewTop)
			{
				drawY += charHeight;
				continue;
			}
			for(var j = 0; j < line.length; j++) {
				var letter = line.charAt(j);
				letterWidth = this.getCharacterWidth(letter);
				var clipUV = this.clipUV[letter];
				if (offx + drawX + letterWidth * scale + charSpace < viewLeft)
				{
					drawX += letterWidth * scale + charSpace;
					continue;
				}
				if (drawX + letterWidth * scale > this.width + EPSILON)
				{
					break;
				}
				if (clipUV !== undefined) {
					var clipWidth  = this.characterWidth*scale;
					var clipHeight = this.characterHeight*scale;
					roundX = drawX;
					roundY = drawY;
					if (angle === 0)
					{
						roundX = Math.round(roundX);
						roundY = Math.round(roundY);
					}
					dQuad.tlx  = roundX;
					dQuad.tly  = roundY;
					dQuad.trx  = roundX + clipWidth;
					dQuad.try_ = roundY ;
					dQuad.blx  = roundX;
					dQuad.bly  = roundY + clipHeight;
					dQuad.brx  = roundX + clipWidth;
					dQuad.bry  = roundY + clipHeight;
					if(angle !== 0)
					{
						rotateQuad(dQuad,cosa,sina);
					}
					dQuad.offset(offx,offy);
					glw.quadTex(
						dQuad.tlx, dQuad.tly,
						dQuad.trx, dQuad.try_,
						dQuad.brx, dQuad.bry,
						dQuad.blx, dQuad.bly,
						clipUV
					);
				}
				drawX += letterWidth * scale + charSpace;
				if (offx + drawX > viewRight)
					break;
			}
			drawY += charHeight;
			if (drawY + charHeight + lineHeight > this.height || offy + drawY > viewBottom)
			{
				break;
			}
		}
	};
	function Cnds() {}
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {}
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetScale = function(param)
	{
		if (param !== this.characterScale) {
			this.characterScale = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterSpacing = function(param)
	{
		if (param !== this.CharacterSpacing) {
			this.characterSpacing = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetLineHeight = function(param)
	{
		if (param !== this.lineHeight) {
			this.lineHeight = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	instanceProto.SetCharWidth = function(character,width) {
		var w = parseInt(width,10);
		if (this.characterWidthList[character] !== w) {
			this.characterWidthList[character] = w;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterWidth = function(characterSet,width)
	{
		if (characterSet !== "") {
			for(var c = 0; c < characterSet.length; c++) {
				this.SetCharWidth(characterSet.charAt(c),width);
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetHAlign = function (a)
	{
		this.halign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetVAlign = function (a)
	{
		this.valign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {}
	Exps.prototype.CharacterWidth = function(ret,character)
	{
		ret.set_int(this.getCharacterWidth(character));
	};
	Exps.prototype.CharacterHeight = function(ret)
	{
		ret.set_int(this.characterHeight);
	};
	Exps.prototype.CharacterScale = function(ret)
	{
		ret.set_float(this.characterScale);
	};
	Exps.prototype.CharacterSpacing = function(ret)
	{
		ret.set_int(this.characterSpacing);
	};
	Exps.prototype.LineHeight = function(ret)
	{
		ret.set_int(this.lineHeight);
	};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textWidth);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textHeight);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Text = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Text.prototype;
	pluginProto.onCreate = function ()
	{
		pluginProto.acts.SetWidth = function (w)
		{
			if (this.width !== w)
			{
				this.width = w;
				this.text_changed = true;	// also recalculate text wrapping
				this.set_bbox_changed();
			}
		};
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.mycanvas = null;
			inst.myctx = null;
			inst.mytex = null;
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		if (this.recycled)
			this.lines.length = 0;
		else
			this.lines = [];		// for word wrapping
		this.text_changed = true;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var requestedWebFonts = {};		// already requested web fonts have an entry here
	instanceProto.onCreate = function()
	{
		this.text = this.properties[0];
		this.visible = (this.properties[1] === 0);		// 0=visible, 1=invisible
		this.font = this.properties[2];
		this.color = this.properties[3];
		this.halign = this.properties[4];				// 0=left, 1=center, 2=right
		this.valign = this.properties[5];				// 0=top, 1=center, 2=bottom
		this.wrapbyword = (this.properties[7] === 0);	// 0=word, 1=character
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
		this.line_height_offset = this.properties[8];
		this.facename = "";
		this.fontstyle = "";
		this.ptSize = 0;
		this.textWidth = 0;
		this.textHeight = 0;
		this.parseFont();
		this.mycanvas = null;
		this.myctx = null;
		this.mytex = null;
		this.need_text_redraw = false;
		this.last_render_tick = this.runtime.tickcount;
		if (this.recycled)
			this.rcTex.set(0, 0, 1, 1);
		else
			this.rcTex = new cr.rect(0, 0, 1, 1);
		if (this.runtime.glwrap)
			this.runtime.tickMe(this);
;
	};
	instanceProto.parseFont = function ()
	{
		var arr = this.font.split(" ");
		var i;
		for (i = 0; i < arr.length; i++)
		{
			if (arr[i].substr(arr[i].length - 2, 2) === "pt")
			{
				this.ptSize = parseInt(arr[i].substr(0, arr[i].length - 2));
				this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
				if (i > 0)
					this.fontstyle = arr[i - 1];
				this.facename = arr[i + 1];
				for (i = i + 2; i < arr.length; i++)
					this.facename += " " + arr[i];
				break;
			}
		}
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"t": this.text,
			"f": this.font,
			"c": this.color,
			"ha": this.halign,
			"va": this.valign,
			"wr": this.wrapbyword,
			"lho": this.line_height_offset,
			"fn": this.facename,
			"fs": this.fontstyle,
			"ps": this.ptSize,
			"pxh": this.pxHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.font = o["f"];
		this.color = o["c"];
		this.halign = o["ha"];
		this.valign = o["va"];
		this.wrapbyword = o["wr"];
		this.line_height_offset = o["lho"];
		this.facename = o["fn"];
		this.fontstyle = o["fs"];
		this.ptSize = o["ps"];
		this.pxHeight = o["pxh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		this.text_changed = true;
		this.lastwidth = this.width;
		this.lastwrapwidth = this.width;
		this.lastheight = this.height;
	};
	instanceProto.tick = function ()
	{
		if (this.runtime.glwrap && this.mytex && (this.runtime.tickcount - this.last_render_tick >= 300))
		{
			var layer = this.layer;
            this.update_bbox();
            var bbox = this.bbox;
            if (bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom)
			{
				this.runtime.glwrap.deleteTexture(this.mytex);
				this.mytex = null;
				this.myctx = null;
				this.mycanvas = null;
			}
		}
	};
	instanceProto.onDestroy = function ()
	{
		this.myctx = null;
		this.mycanvas = null;
		if (this.runtime.glwrap && this.mytex)
			this.runtime.glwrap.deleteTexture(this.mytex);
		this.mytex = null;
	};
	instanceProto.updateFont = function ()
	{
		this.font = this.fontstyle + " " + this.ptSize.toString() + "pt " + this.facename;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	instanceProto.draw = function(ctx, glmode)
	{
		ctx.font = this.font;
		ctx.textBaseline = "top";
		ctx.fillStyle = this.color;
		ctx.globalAlpha = glmode ? 1 : this.opacity;
		var myscale = 1;
		if (glmode)
		{
			myscale = this.layer.getScale();
			ctx.save();
			ctx.scale(myscale, myscale);
		}
		if (this.text_changed || this.width !== this.lastwrapwidth)
		{
			this.type.plugin.WordWrap(this.text, this.lines, ctx, this.width, this.wrapbyword);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
		this.update_bbox();
		var penX = glmode ? 0 : this.bquad.tlx;
		var penY = glmode ? 0 : this.bquad.tly;
		if (this.runtime.pixel_rounding)
		{
			penX = (penX + 0.5) | 0;
			penY = (penY + 0.5) | 0;
		}
		if (this.angle !== 0 && !glmode)
		{
			ctx.save();
			ctx.translate(penX, penY);
			ctx.rotate(this.angle);
			penX = 0;
			penY = 0;
		}
		var endY = penY + this.height;
		var line_height = this.pxHeight;
		line_height += this.line_height_offset;
		var drawX;
		var i;
		if (this.valign === 1)		// center
			penY += Math.max(this.height / 2 - (this.lines.length * line_height) / 2, 0);
		else if (this.valign === 2)	// bottom
			penY += Math.max(this.height - (this.lines.length * line_height) - 2, 0);
		for (i = 0; i < this.lines.length; i++)
		{
			drawX = penX;
			if (this.halign === 1)		// center
				drawX = penX + (this.width - this.lines[i].width) / 2;
			else if (this.halign === 2)	// right
				drawX = penX + (this.width - this.lines[i].width);
			ctx.fillText(this.lines[i].text, drawX, penY);
			penY += line_height;
			if (penY >= endY - line_height)
				break;
		}
		if (this.angle !== 0 || glmode)
			ctx.restore();
		this.last_render_tick = this.runtime.tickcount;
	};
	instanceProto.drawGL = function(glw)
	{
		if (this.width < 1 || this.height < 1)
			return;
		var need_redraw = this.text_changed || this.need_text_redraw;
		this.need_text_redraw = false;
		var layer_scale = this.layer.getScale();
		var layer_angle = this.layer.getAngle();
		var rcTex = this.rcTex;
		var floatscaledwidth = layer_scale * this.width;
		var floatscaledheight = layer_scale * this.height;
		var scaledwidth = Math.ceil(floatscaledwidth);
		var scaledheight = Math.ceil(floatscaledheight);
		var halfw = this.runtime.draw_width / 2;
		var halfh = this.runtime.draw_height / 2;
		if (!this.myctx)
		{
			this.mycanvas = document.createElement("canvas");
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			this.lastwidth = scaledwidth;
			this.lastheight = scaledheight;
			need_redraw = true;
			this.myctx = this.mycanvas.getContext("2d");
		}
		if (scaledwidth !== this.lastwidth || scaledheight !== this.lastheight)
		{
			this.mycanvas.width = scaledwidth;
			this.mycanvas.height = scaledheight;
			if (this.mytex)
			{
				glw.deleteTexture(this.mytex);
				this.mytex = null;
			}
			need_redraw = true;
		}
		if (need_redraw)
		{
			this.myctx.clearRect(0, 0, scaledwidth, scaledheight);
			this.draw(this.myctx, true);
			if (!this.mytex)
				this.mytex = glw.createEmptyTexture(scaledwidth, scaledheight, this.runtime.linearSampling, this.runtime.isMobile);
			glw.videoToTexture(this.mycanvas, this.mytex, this.runtime.isMobile);
		}
		this.lastwidth = scaledwidth;
		this.lastheight = scaledheight;
		glw.setTexture(this.mytex);
		glw.setOpacity(this.opacity);
		glw.resetModelView();
		glw.translate(-halfw, -halfh);
		glw.updateModelView();
		var q = this.bquad;
		var tlx = this.layer.layerToCanvas(q.tlx, q.tly, true, true);
		var tly = this.layer.layerToCanvas(q.tlx, q.tly, false, true);
		var trx = this.layer.layerToCanvas(q.trx, q.try_, true, true);
		var try_ = this.layer.layerToCanvas(q.trx, q.try_, false, true);
		var brx = this.layer.layerToCanvas(q.brx, q.bry, true, true);
		var bry = this.layer.layerToCanvas(q.brx, q.bry, false, true);
		var blx = this.layer.layerToCanvas(q.blx, q.bly, true, true);
		var bly = this.layer.layerToCanvas(q.blx, q.bly, false, true);
		if (this.runtime.pixel_rounding || (this.angle === 0 && layer_angle === 0))
		{
			var ox = ((tlx + 0.5) | 0) - tlx;
			var oy = ((tly + 0.5) | 0) - tly
			tlx += ox;
			tly += oy;
			trx += ox;
			try_ += oy;
			brx += ox;
			bry += oy;
			blx += ox;
			bly += oy;
		}
		if (this.angle === 0 && layer_angle === 0)
		{
			trx = tlx + scaledwidth;
			try_ = tly;
			brx = trx;
			bry = tly + scaledheight;
			blx = tlx;
			bly = bry;
			rcTex.right = 1;
			rcTex.bottom = 1;
		}
		else
		{
			rcTex.right = floatscaledwidth / scaledwidth;
			rcTex.bottom = floatscaledheight / scaledheight;
		}
		glw.quadTex(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex);
		glw.resetModelView();
		glw.scale(layer_scale, layer_scale);
		glw.rotateZ(-this.layer.getAngle());
		glw.translate((this.layer.viewLeft + this.layer.viewRight) / -2, (this.layer.viewTop + this.layer.viewBottom) / -2);
		glw.updateModelView();
		this.last_render_tick = this.runtime.tickcount;
	};
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	var linesCache = [];
	function allocLine()
	{
		if (linesCache.length)
			return linesCache.pop();
		else
			return {};
	};
	function freeLine(l)
	{
		linesCache.push(l);
	};
	function freeAllLines(arr)
	{
		var i, len;
		for (i = 0, len = arr.length; i < len; i++)
		{
			freeLine(arr[i]);
		}
		arr.length = 0;
	};
	pluginProto.WordWrap = function (text, lines, ctx, width, wrapbyword)
	{
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		if (text.length <= 100 && text.indexOf("\n") === -1)
		{
			var all_width = ctx.measureText(text).width;
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				return;
			}
		}
		this.WrapText(text, lines, ctx, width, wrapbyword);
	};
	pluginProto.WrapText = function (text, lines, ctx, width, wrapbyword)
	{
		var wordArray;
		if (wrapbyword)
		{
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		}
		else
			wordArray = text;
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = cur_line;
				line.width = ctx.measureText(cur_line).width;
				lineIndex++;
				cur_line = "";
				continue;
			}
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = ctx.measureText(cur_line).width;
			if (line_width >= width)
			{
				if (lineIndex >= lines.length)
					lines.push(allocLine());
				line = lines[lineIndex];
				line.text = prev_line;
				line.width = ctx.measureText(prev_line).width;
				lineIndex++;
				cur_line = wordArray[i];
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (cur_line.length)
		{
			if (lineIndex >= lines.length)
				lines.push(allocLine());
			line = lines[lineIndex];
			line.text = cur_line;
			line.width = ctx.measureText(cur_line).width;
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	function Cnds() {};
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetFontFace = function (face_, style_)
	{
		var newstyle = "";
		switch (style_) {
		case 1: newstyle = "bold"; break;
		case 2: newstyle = "italic"; break;
		case 3: newstyle = "bold italic"; break;
		}
		if (face_ === this.facename && newstyle === this.fontstyle)
			return;		// no change
		this.facename = face_;
		this.fontstyle = newstyle;
		this.updateFont();
	};
	Acts.prototype.SetFontSize = function (size_)
	{
		if (this.ptSize === size_)
			return;
		this.ptSize = size_;
		this.pxHeight = Math.ceil((this.ptSize / 72.0) * 96.0) + 4;	// assume 96dpi...
		this.updateFont();
	};
	Acts.prototype.SetFontColor = function (rgb)
	{
		var newcolor = "rgb(" + cr.GetRValue(rgb).toString() + "," + cr.GetGValue(rgb).toString() + "," + cr.GetBValue(rgb).toString() + ")";
		if (newcolor === this.color)
			return;
		this.color = newcolor;
		this.need_text_redraw = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetWebFont = function (familyname_, cssurl_)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");
			return;		// DC todo
		}
		var self = this;
		var refreshFunc = (function () {
							self.runtime.redraw = true;
							self.text_changed = true;
						});
		if (requestedWebFonts.hasOwnProperty(cssurl_))
		{
			var newfacename = "'" + familyname_ + "'";
			if (this.facename === newfacename)
				return;	// no change
			this.facename = newfacename;
			this.updateFont();
			for (var i = 1; i < 10; i++)
			{
				setTimeout(refreshFunc, i * 100);
				setTimeout(refreshFunc, i * 1000);
			}
			return;
		}
		var wf = document.createElement("link");
		wf.href = cssurl_;
		wf.rel = "stylesheet";
		wf.type = "text/css";
		wf.onload = refreshFunc;
		document.getElementsByTagName('head')[0].appendChild(wf);
		requestedWebFonts[cssurl_] = true;
		this.facename = "'" + familyname_ + "'";
		this.updateFont();
		for (var i = 1; i < 10; i++)
		{
			setTimeout(refreshFunc, i * 100);
			setTimeout(refreshFunc, i * 1000);
		}
;
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.FaceName = function (ret)
	{
		ret.set_string(this.facename);
	};
	Exps.prototype.FaceSize = function (ret)
	{
		ret.set_int(this.ptSize);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		var w = 0;
		var i, len, x;
		for (i = 0, len = this.lines.length; i < len; i++)
		{
			x = this.lines[i].width;
			if (w < x)
				w = x;
		}
		ret.set_int(w);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		ret.set_int(this.lines.length * (this.pxHeight + this.line_height_offset) - this.line_height_offset);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Tilemap = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Tilemap.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		var i, len, p;
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.runtime.waitForImageLoad(this.texture_img);
		this.cut_tiles = [];
		this.cut_tiles_valid = false;
		this.tile_polys = [];
		this.tile_polys_cached = false;		// first instance will cache polys with the tile width/height
		if (this.tile_poly_data && this.tile_poly_data.length)
		{
			for (i = 0, len = this.tile_poly_data.length; i < len; ++i)
			{
				p = this.tile_poly_data[i];
				if (p)
				{
					this.tile_polys.push({
						poly: p,
						flipmap: [[[null, null], [null, null]], [[null, null], [null, null]]]
					});
				}
				else
					this.tile_polys.push(null);
			}
		}
	};
	typeProto.cacheTilePoly = function (tileid, tilewidth, tileheight, fliph, flipv, flipd)
	{
		if (tileid < 0 || tileid >= this.tile_polys.length)
			return;
		if (!this.tile_polys[tileid])
			return;		// no poly for this tile
		var poly = this.tile_polys[tileid].poly;
		var flipmap = this.tile_polys[tileid].flipmap;
		var cached_poly = new cr.CollisionPoly(poly);
		cached_poly.cache_poly(tilewidth, tileheight, 0);
		if (flipd)
			cached_poly.diag();
		if (fliph)
			cached_poly.mirror(tilewidth / 2);
		if (flipv)
			cached_poly.flip(tileheight / 2);
		flipmap[fliph?1:0][flipv?1:0][flipd?1:0] = cached_poly;
	};
	typeProto.getTilePoly = function (id)
	{
		if (id === -1)
			return null;
		var tileid = (id & TILE_ID_MASK);
		if (tileid < 0 || tileid >= this.tile_polys.length)
			return null;		// out of range
		if (!this.tile_polys[tileid])
			return null;		// no poly for this tile
		var fliph = (id & TILE_FLIPPED_HORIZONTAL) ? 1 : 0;
		var flipv = (id & TILE_FLIPPED_VERTICAL) ? 1 : 0;
		var flipd = (id & TILE_FLIPPED_DIAGONAL) ? 1 : 0;
		return this.tile_polys[tileid].flipmap[fliph][flipv][flipd];
	};
	typeProto.freeCutTiles = function ()
	{
		var i, len;
		var glwrap = this.runtime.glwrap;
		if (glwrap)
		{
			for (i = 0, len = this.cut_tiles.length; i < len; ++i)
				glwrap.deleteTexture(this.cut_tiles[i]);
		}
		this.cut_tiles.length = 0;
		this.cut_tiles_valid = false;
	}
	typeProto.maybeCutTiles = function (tw, th, offx, offy, sepx, sepy, seamless)
	{
		if (this.cut_tiles_valid)
			return;		// no changed
		if (tw <= 0 || th <= 0)
			return;
		this.freeCutTiles();
		var img_width = this.texture_img.width;
		var img_height = this.texture_img.height;
		var x, y;
		for (y = offy; y + th <= img_height; y += (th + sepy))
		{
			for (x = offx; x + tw <= img_width; x += (tw + sepx))
			{
				this.cut_tiles.push(this.CutTileImage(x, y, tw, th, seamless));
			}
		}
		this.cut_tiles_valid = true;
	};
	typeProto.CutTileImage = function(x, y, w, h, seamless)
	{
		if (this.runtime.glwrap)
		{
			return this.DoCutTileImage(x, y, w, h, false, false, false, seamless);
		}
		else
		{
			var flipmap = [[[null, null], [null, null]], [[null, null], [null, null]]];
			flipmap[0][0][0] = this.DoCutTileImage(x, y, w, h, false, false, false, seamless);
			return {
				flipmap: flipmap,
				x: x,
				y: y,
				w: w,
				h: h
			};
		}
	};
	typeProto.GetFlippedTileImage = function (tileid, fliph, flipv, flipd, seamless)
	{
		if (tileid < 0 || tileid >= this.cut_tiles.length)
			return null;
		var tile = this.cut_tiles[tileid];
		var flipmap = tile.flipmap;
		var hi = (fliph ? 1 : 0);
		var vi = (flipv ? 1 : 0);
		var di = (flipd ? 1 : 0);
		var ret = flipmap[hi][vi][di];
		if (ret)
		{
			return ret;
		}
		else
		{
			ret = this.DoCutTileImage(tile.x, tile.y, tile.w, tile.h, hi!==0, vi!==0, di!==0, seamless);
			flipmap[hi][vi][di] = ret;
			return ret;
		}
	};
	typeProto.DoCutTileImage = function(x, y, w, h, fliph, flipv, flipd, seamless)
	{
		var dw = w;
		var dh = h;
		if (this.runtime.glwrap)
		{
			if (!cr.isPOT(dw))
				dw = cr.nextHighestPowerOfTwo(dw);
			if (!cr.isPOT(dh))
				dh = cr.nextHighestPowerOfTwo(dh);
		}
		var tmpcanvas = document.createElement("canvas");
		tmpcanvas.width = dw;
		tmpcanvas.height = dh;
		var tmpctx = tmpcanvas.getContext("2d");
		if (this.runtime.ctx)
		{
			if (fliph)
			{
				if (flipv)
				{
					if (flipd)
					{
						tmpctx.rotate(Math.PI / 2);
						tmpctx.scale(-1, 1);
						tmpctx.translate(-dw, -dh);
					}
					else
					{
						tmpctx.scale(-1, -1);
						tmpctx.translate(-dw, -dh);
					}
				}
				else
				{
					if (flipd)
					{
						tmpctx.rotate(Math.PI / 2);
						tmpctx.translate(0, -dh);
					}
					else
					{
						tmpctx.scale(-1, 1);
						tmpctx.translate(-dw, 0);
					}
				}
			}
			else
			{
				if (flipv)
				{
					if (flipd)
					{
						tmpctx.rotate(-Math.PI / 2);
						tmpctx.translate(-dw, 0);
					}
					else
					{
						tmpctx.scale(1, -1);
						tmpctx.translate(0, -dh);
					}
				}
				else
				{
					if (flipd)
					{
						tmpctx.scale(-1, 1);
						tmpctx.rotate(Math.PI / 2);
					}
				}
			}
			tmpctx.drawImage(this.texture_img, x, y, w, h, 0, 0, dw, dh);
			if (seamless)
				return tmpcanvas;
			else
				return this.runtime.ctx.createPattern(tmpcanvas, "repeat");
		}
		else
		{
;
			tmpctx.drawImage(this.texture_img, x, y, w, h, 0, 0, dw, dh);
			var tex = this.runtime.glwrap.createEmptyTexture(dw, dh, this.runtime.linearSampling, false, !seamless);
			this.runtime.glwrap.videoToTexture(tmpcanvas, tex);
			return tex;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.freeCutTiles();
	};
	typeProto.onRestoreWebGLContext = function ()
	{
	};
	typeProto.loadTextures = function ()
	{
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length)
			return;
		this.freeCutTiles();
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var TILE_FLIPPED_HORIZONTAL = -0x80000000		// note: pretend is a signed int, so negate
	var TILE_FLIPPED_VERTICAL = 0x40000000
	var TILE_FLIPPED_DIAGONAL = 0x20000000
	var TILE_FLAGS_MASK = 0xE0000000
	var TILE_ID_MASK = 0x1FFFFFFF
	function TileQuad()
	{
		this.id = -1;
		this.tileid = -1;
		this.horiz_flip = false;
		this.vert_flip = false;
		this.diag_flip = false;
		this.any_flip = false;
		this.rc = new cr.rect(0, 0, 0, 0);
	};
	var tilequad_cache = [];
	function allocTileQuad()
	{
		if (tilequad_cache.length)
			return tilequad_cache.pop();
		else
			return new TileQuad();
	};
	function freeTileQuad(tq)
	{
		if (tilequad_cache.length < 10000)
			tilequad_cache.push(tq);
	};
	function TileCollisionRect()
	{
		this.id = -1;
		this.rc = new cr.rect(0, 0, 0, 0);
		this.poly = null;
	}
	var collrect_cache = [];
	function allocCollRect()
	{
		if (collrect_cache.length)
			return collrect_cache.pop();
		else
			return new TileCollisionRect();
	};
	function freeCollRect(r)
	{
		if (collrect_cache.length < 10000)
			collrect_cache.push(r);
	};
	var tile_cell_cache = [];
	function allocTileCell(inst_, x_, y_)
	{
		var ret;
		if (tile_cell_cache.length)
		{
			ret = tile_cell_cache.pop();
			ret.inst = inst_;
			ret.x = x_;
			ret.y = y_;
			ret.left = ret.x * ret.inst.cellwidth * ret.inst.tilewidth;
			ret.top = ret.y * ret.inst.cellheight * ret.inst.tileheight;
			ret.clear();
			ret.quadmap_valid = false;
			return ret;
		}
		else
			return new TileCell(inst_, x_, y_);
	};
	function freeTileCell(tc)
	{
		var i, len;
		for (i = 0, len = tc.quads.length; i < len; ++i)
			freeTileQuad(tc.quads[i]);
		tc.quads.length = 0;
		for (i = 0, len = tc.collision_rects.length; i < len; ++i)
			freeCollRect(tc.collision_rects[i]);
		tc.collision_rects.length = 0;
		if (tile_cell_cache.length < 1000)
			tile_cell_cache.push(tc);
	};
	function TileCell(inst_, x_, y_)
	{
		this.inst = inst_;
		this.x = x_;
		this.y = y_;
		this.left = this.x * this.inst.cellwidth * this.inst.tilewidth;
		this.top = this.y * this.inst.cellheight * this.inst.tileheight;
		this.tiles = [];
		this.quads = [];
		this.collision_rects = [];
		this.quadmap_valid = false;
		var i, len, j, lenj, arr;
		for (i = 0, len = this.inst.cellheight; i < len; ++i)
		{
			arr = [];
			for (j = 0, lenj = this.inst.cellwidth; j < lenj; ++j)
				arr.push(-1);
			this.tiles.push(arr);
		}
	};
	TileCell.prototype.clear = function ()
	{
		var i, len, j, lenj, arr;
		this.tiles.length = this.inst.cellheight;
		for (i = 0, len = this.tiles.length; i < len; ++i)
		{
			arr = this.tiles[i];
			if (!arr)
			{
				arr = [];
				this.tiles[i] = arr;
			}
			arr.length = this.inst.cellwidth;
			for (j = 0, lenj = arr.length; j < lenj; ++j)
				arr[j] = -1;
		}
	};
	TileCell.prototype.maybeBuildQuadMap = function ()
	{
		if (this.quadmap_valid)
			return;		// not changed
		var tilewidth = this.inst.tilewidth;
		var tileheight = this.inst.tileheight;
		if (tilewidth <= 0 || tileheight <= 0)
			return;
		var i, j, len, y, leny, x, lenx, arr, t, p, q;
		for (i = 0, len = this.quads.length; i < len; ++i)
			freeTileQuad(this.quads[i]);
		for (i = 0, len = this.collision_rects.length; i < len; ++i)
			freeCollRect(this.collision_rects[i]);
		this.quads.length = 0;
		this.collision_rects.length = 0;
		var extentwidth = Math.floor(this.inst.width / tilewidth);
		var extentheight = Math.floor(this.inst.height / tileheight);
		extentwidth -= this.left / tilewidth;
		extentheight -= this.top / tileheight;
		if (extentwidth > this.inst.cellwidth)
			extentwidth = this.inst.cellwidth;
		if (extentheight > this.inst.cellheight)
			extentheight = this.inst.cellheight;
		var seamless = this.inst.seamless;
		var cur_quad = null;
		for (y = 0, leny = extentheight; y < leny; ++y)
		{
			arr = this.tiles[y];
			for (x = 0, lenx = extentwidth; x < lenx; ++x)
			{
				t = arr[x];
				if (t === -1)
				{
					if (cur_quad)
					{
						this.quads.push(cur_quad);
						cur_quad = null;
					}
					continue;
				}
				if (seamless || !cur_quad || t !== cur_quad.id)
				{
					if (cur_quad)
						this.quads.push(cur_quad);
					cur_quad = allocTileQuad();
					cur_quad.id = t;
					cur_quad.tileid = (t & TILE_ID_MASK);
					cur_quad.horiz_flip = (t & TILE_FLIPPED_HORIZONTAL) !== 0;
					cur_quad.vert_flip = (t & TILE_FLIPPED_VERTICAL) !== 0;
					cur_quad.diag_flip = (t & TILE_FLIPPED_DIAGONAL) !== 0;
					cur_quad.any_flip = (cur_quad.horiz_flip || cur_quad.vert_flip || cur_quad.diag_flip);
					cur_quad.rc.left = x * tilewidth + this.left;
					cur_quad.rc.top = y * tileheight + this.top;
					cur_quad.rc.right = cur_quad.rc.left + tilewidth;
					cur_quad.rc.bottom = cur_quad.rc.top + tileheight;
				}
				else
				{
					cur_quad.rc.right += tilewidth;
				}
			}
			if (cur_quad)
			{
				this.quads.push(cur_quad);
				cur_quad = null;
			}
		}
		var cur_rect = null;
		var tileid, tilepoly;
		var cur_has_poly = false;
		var rc;
		for (y = 0, leny = extentheight; y < leny; ++y)
		{
			arr = this.tiles[y];
			for (x = 0, lenx = extentwidth; x < lenx; ++x)
			{
				t = arr[x];
				if (t === -1)
				{
					if (cur_rect)
					{
						this.collision_rects.push(cur_rect);
						cur_rect = null;
						cur_has_poly = false;
					}
					continue;
				}
				tileid = (t & TILE_ID_MASK);
				tilepoly = this.inst.type.getTilePoly(t);
				if (!cur_rect || tilepoly || cur_has_poly)
				{
					if (cur_rect)
					{
						this.collision_rects.push(cur_rect);
						cur_rect = null;
					}
;
					cur_rect = allocCollRect();
					cur_rect.id = t;
					cur_rect.poly = tilepoly ? tilepoly : null;
					rc = cur_rect.rc;
					rc.left = x * tilewidth + this.left;
					rc.top = y * tileheight + this.top;
					rc.right = rc.left + tilewidth;
					rc.bottom = rc.top + tileheight;
					cur_has_poly = !!tilepoly;
				}
				else
				{
					cur_rect.rc.right += tilewidth;
				}
			}
			if (cur_rect)
			{
				this.collision_rects.push(cur_rect);
				cur_rect = null;
				cur_has_poly = false;
			}
		}
		if (!seamless)
		{
			len = this.quads.length;
			for (i = 0; i < len; ++i)
			{
				q = this.quads[i];
				for (j = i + 1; j < len; ++j)
				{
					p = this.quads[j];
					if (p.rc.top < q.rc.bottom)
						continue;
					if (p.rc.top > q.rc.bottom)
						break;
					if (p.rc.right > q.rc.right || p.rc.left > q.rc.left)
						break;
					if (p.id === q.id && p.rc.left === q.rc.left && p.rc.right === q.rc.right)
					{
						freeTileQuad(this.quads[j]);
						this.quads.splice(j, 1);
						--len;
						q.rc.bottom += tileheight;
						--j;		// look at same j index again
					}
				}
			}
		}
		len = this.collision_rects.length;
		var prc, qrc;
		for (i = 0; i < len; ++i)
		{
			q = this.collision_rects[i];
			if (q.poly)
				continue;
			qrc = q.rc;
			for (j = i + 1; j < len; ++j)
			{
				p = this.collision_rects[j];
				prc = p.rc;
				if (prc.top < qrc.bottom)
					continue;
				if (prc.top > qrc.bottom)
					break;
				if (prc.right > qrc.right || prc.left > qrc.left)
					break;
				if (p.poly)
					continue;
				if (prc.left === qrc.left && prc.right === qrc.right)
				{
					freeCollRect(this.collision_rects[j]);
					this.collision_rects.splice(j, 1);
					--len;
					qrc.bottom += tileheight;
					--j;		// look at same j index again
				}
			}
		}
		this.quadmap_valid = true;
	};
	TileCell.prototype.setTileAt = function (x_, y_, t_)
	{
		if (this.tiles[y_][x_] !== t_)
		{
			this.tiles[y_][x_] = t_;
			this.quadmap_valid = false;
			this.inst.any_quadmap_changed = true;
			this.inst.physics_changed = true;
			this.inst.runtime.redraw = true;
		}
	};
	instanceProto.onCreate = function()
	{
;
		var i, len, p;
		this.visible = (this.properties[0] === 0);
		this.tilewidth = this.properties[1];
		this.tileheight = this.properties[2];
		this.tilexoffset = this.properties[3];
		this.tileyoffset = this.properties[4];
		this.tilexspacing = this.properties[5];
		this.tileyspacing = this.properties[6];
		this.seamless = (this.properties[7] !== 0);
		this.mapwidth = this.tilemap_width;
		this.mapheight = this.tilemap_height;
		this.lastwidth = this.width;
		this.lastheight = this.height;
		var tw = this.tilewidth;
		var th = this.tileheight;
		if (tw === 0)
			tw = 1;
		if (th === 0)
			th = 1;
		this.cellwidth = Math.ceil(this.runtime.original_width / tw);
		this.cellheight = Math.ceil(this.runtime.original_height / th);
		if (!this.type.tile_polys_cached)
		{
			this.type.tile_polys_cached = true;
			for (i = 0, len = this.type.tile_polys.length; i < len; ++i)
			{
				p = this.type.tile_polys[i];
				if (!p)
					continue;
				this.type.cacheTilePoly(i, tw, th, false, false, false);
				this.type.cacheTilePoly(i, tw, th, false, false, true);
				this.type.cacheTilePoly(i, tw, th, false, true, false);
				this.type.cacheTilePoly(i, tw, th, false, true, true);
				this.type.cacheTilePoly(i, tw, th, true, false, false);
				this.type.cacheTilePoly(i, tw, th, true, false, true);
				this.type.cacheTilePoly(i, tw, th, true, true, false);
				this.type.cacheTilePoly(i, tw, th, true, true, true);
			}
		}
		if (!this.recycled)
			this.tilecells = [];
		this.maybeResizeTilemap(true);
		this.setTilesFromRLECSV(this.tilemap_data);
		this.type.maybeCutTiles(this.tilewidth, this.tileheight, this.tilexoffset, this.tileyoffset, this.tilexspacing, this.tileyspacing, this.seamless);
		this.physics_changed = false;		// to indicate to physics behavior to recreate body
		this.any_quadmap_changed = true;
		this.maybeBuildAllQuadMap();
	};
	instanceProto.maybeBuildAllQuadMap = function ()
	{
		if (!this.any_quadmap_changed)
			return;		// no change
		var i, len, j, lenj, arr;
		for (i = 0, len = this.tilecells.length; i < len; ++i)
		{
			arr = this.tilecells[i];
			for (j = 0, lenj = arr.length; j < lenj; ++j)
			{
				arr[j].maybeBuildQuadMap();
			}
		}
		this.any_quadmap_changed = false;
	};
	instanceProto.setAllQuadMapChanged = function ()
	{
		var i, len, j, lenj, arr;
		for (i = 0, len = this.tilecells.length; i < len; ++i)
		{
			arr = this.tilecells[i];
			for (j = 0, lenj = arr.length; j < lenj; ++j)
			{
				arr[j].quadmap_valid = false;
			}
		}
		this.any_quadmap_changed = true;
	};
	function RunLengthDecode(str)
	{
		var ret = [];
		var parts = str.split(",");
		var i, len, p, x, n, t, part;
		for (i = 0, len = parts.length; i < len; ++i)
		{
			p = parts[i];
			x = p.indexOf("x");
			if (x > -1)
			{
				n = parseInt(p.substring(0, x), 10);
				part = p.substring(x + 1);
				t = parseInt(part, 10);
				if (part.indexOf("h") > -1)
					t = t | TILE_FLIPPED_HORIZONTAL;
				if (part.indexOf("v") > -1)
					t = t | TILE_FLIPPED_VERTICAL;
				if (part.indexOf("d") > -1)
					t = t | TILE_FLIPPED_DIAGONAL;
				for ( ; n > 0; --n)
					ret.push(t);
			}
			else
			{
				t = parseInt(p, 10);
				if (p.indexOf("h") > -1)
					t = t | TILE_FLIPPED_HORIZONTAL;
				if (p.indexOf("v") > -1)
					t = t | TILE_FLIPPED_VERTICAL;
				if (p.indexOf("d") > -1)
					t = t | TILE_FLIPPED_DIAGONAL;
				ret.push(t);
			}
		}
		return ret;
	};
	instanceProto.maybeResizeTilemap = function (force)
	{
		var curwidth = cr.floor(this.width / this.tilewidth);
		var curheight = cr.floor(this.height / this.tileheight);
		if (curwidth <= this.mapwidth && curheight <= this.mapheight && !force)
			return;
		var vcells, hcells;
		if (force)
		{
			vcells = Math.ceil(this.mapheight / this.cellheight);
			hcells = Math.ceil(this.mapwidth / this.cellwidth);
		}
		else
		{
			vcells = this.tilecells.length;
			hcells = Math.ceil(this.mapwidth / this.cellwidth);
			if (curheight > this.mapheight)
			{
				this.mapheight = curheight;
				vcells = Math.ceil(this.mapheight / this.cellheight);
			}
			if (curwidth > this.mapwidth)
			{
				this.mapwidth = curwidth;
				hcells = Math.ceil(this.mapwidth / this.cellwidth);
			}
			this.setAllQuadMapChanged();
			this.physics_changed = true;
			this.runtime.redraw = true;
		}
		var y, x, arr;
		for (y = 0; y < vcells; ++y)
		{
			arr = this.tilecells[y];
			if (!arr)
			{
				arr = [];
				for (x = 0; x < hcells; ++x)
					arr.push(allocTileCell(this, x, y));
				this.tilecells[y] = arr;
			}
			else
			{
				for (x = arr.length; x < hcells; ++x)
					arr.push(allocTileCell(this, x, y));
			}
		}
	};
	instanceProto.cellAt = function (tx, ty)
	{
		if (tx < 0 || ty < 0)
			return null;
		var cy = cr.floor(ty / this.cellheight);
		if (cy >= this.tilecells.length)
			return null;
		var row = this.tilecells[cy];
		var cx = cr.floor(tx / this.cellwidth);
		if (cx >= row.length)
			return null;
		return row[cx];
	};
	instanceProto.cellAtIndex = function (cx, cy)
	{
		if (cx < 0 || cy < 0 || cy >= this.tilecells.length)
			return null;
		var row = this.tilecells[cy];
		if (cx >= row.length)
			return null;
		return row[cx];
	};
	instanceProto.setTilesFromRLECSV = function (str)
	{
		var tilestream = RunLengthDecode(str);
		var next = 0;
		var y, x, arr, tile, cell;
		for (y = 0; y < this.mapheight; ++y)
		{
			for (x = 0; x < this.mapwidth; ++x)
			{
				tile = tilestream[next++];
				cell = this.cellAt(x, y);
				if (cell)
					cell.setTileAt(x % this.cellwidth, y % this.cellheight, tile);
			}
		}
	};
	instanceProto.getTilesAsRLECSV = function ()
	{
		var ret = "";
		if (this.mapwidth <= 0 || this.mapheight <= 0)
			return ret;
		var run_count = 1;
		var run_number = this.getTileAt(0, 0);
		var y, leny = this.mapheight, x, lenx = this.mapwidth, t;
		var tileid, horiz_flip, vert_flip, diag_flip;
		for (y = 0; y < leny; ++y)
		{
			for (x = (y === 0 ? 1 : 0) ; x < lenx; ++x)
			{
				t = this.getTileAt(x, y);
				if (t === run_number)
					++run_count;
				else
				{
					if (run_number === -1)
					{
						tileid = -1;
						horiz_flip = false;
						vert_flip = false;
						diag_flip = false;
					}
					else
					{
						tileid = (run_number & TILE_ID_MASK);
						horiz_flip = (run_number & TILE_FLIPPED_HORIZONTAL) !== 0;
						vert_flip = (run_number & TILE_FLIPPED_VERTICAL) !== 0;
						diag_flip = (run_number & TILE_FLIPPED_DIAGONAL) !== 0;
					}
					if (run_count === 1)
						ret += "" + tileid;
					else
						ret += "" + run_count + "x" + tileid;
					if (horiz_flip)
						ret += "h";
					if (vert_flip)
						ret += "v";
					if (diag_flip)
						ret += "d";
					ret += ",";
					run_count = 1;
					run_number = t;
				}
			}
		}
		if (run_number === -1)
		{
			tileid = -1;
			horiz_flip = false;
			vert_flip = false;
			diag_flip = false;
		}
		else
		{
			tileid = (run_number & TILE_ID_MASK);
			horiz_flip = (run_number & TILE_FLIPPED_HORIZONTAL) !== 0;
			vert_flip = (run_number & TILE_FLIPPED_VERTICAL) !== 0;
			diag_flip = (run_number & TILE_FLIPPED_DIAGONAL) !== 0;
		}
		if (run_count === 1)
			ret += "" + tileid;
		else
			ret += "" + run_count + "x" + tileid;
		if (horiz_flip)
			ret += "h";
		if (vert_flip)
			ret += "v";
		if (diag_flip)
			ret += "d";
		return ret;
	};
	instanceProto.getTileAt = function (x_, y_)
	{
		x_ = Math.floor(x_);
		y_ = Math.floor(y_);
		if (x_ < 0 || y_ < 0 || x_ >= this.mapwidth || y_ >= this.mapheight)
			return -1;
		var cell = this.cellAt(x_, y_);
		if (!cell)
			return -1;
		return cell.tiles[y_ % this.cellheight][x_ % this.cellwidth];
	};
	instanceProto.setTileAt = function (x_, y_, t_)
	{
		x_ = Math.floor(x_);
		y_ = Math.floor(y_);
		if (x_ < 0 || y_ < 0 || x_ >= this.mapwidth || y_ >= this.mapheight)
			return -1;
		var cell = this.cellAt(x_, y_);
		if (!cell)
			return -1;
		cell.setTileAt(x_ % this.cellwidth, y_ % this.cellheight, t_);
	};
	instanceProto.worldToCellX = function (x)
	{
		return Math.floor((x - this.x) / (this.cellwidth * this.tilewidth));
	};
	instanceProto.worldToCellY = function (y)
	{
		return Math.floor((y - this.y) / (this.cellheight * this.tileheight));
	};
	instanceProto.getCollisionRectCandidates = function (bbox, candidates)
	{
		var firstCellX = this.worldToCellX(bbox.left);
		var firstCellY = this.worldToCellY(bbox.top);
		var lastCellX = this.worldToCellX(bbox.right);
		var lastCellY = this.worldToCellY(bbox.bottom);
		var cx, cy, cell;
		for (cx = firstCellX; cx <= lastCellX; ++cx)
		{
			for (cy = firstCellY; cy <= lastCellY; ++cy)
			{
				cell = this.cellAtIndex(cx, cy);
				if (!cell)
					continue;
				cell.maybeBuildQuadMap();
				cr.appendArray(candidates, cell.collision_rects);
			}
		}
	};
	instanceProto.getAllCollisionRects = function (candidates)
	{
		var i, len, j, lenj, row, cell;
		for (i = 0, len = this.tilecells.length; i < len; ++i)
		{
			row = this.tilecells[i];
			for (j = 0, lenj = row.length; j < lenj; ++j)
			{
				cell = row[j];
				cell.maybeBuildQuadMap();
				cr.appendArray(candidates, cell.collision_rects);
			}
		}
	};
	instanceProto.onDestroy = function ()
	{
		var i, len, j, lenj, arr;
		for (i = 0, len = this.tilecells.length; i < len; ++i)
		{
			arr = this.tilecells[i];
			for (j = 0, lenj = arr.length; j < lenj; ++j)
			{
				freeTileCell(arr[j]);
			}
			arr.length = 0;
		}
		this.tilecells.length = 0;
	};
	instanceProto.saveToJSON = function ()
	{
		return {
			"w": this.mapwidth,
			"h": this.mapheight,
			"d": this.getTilesAsRLECSV()
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.mapwidth = o["w"];
		this.mapheight = o["h"];
		this.setTilesFromRLECSV(o["d"]);
		this.physics_changed = true;
		this.setAllQuadMapChanged();
	};
	instanceProto.draw = function(ctx)
	{
		if (this.tilewidth <= 0 || this.tileheight <= 0)
			return;
		this.type.maybeCutTiles(this.tilewidth, this.tileheight, this.tilexoffset, this.tileyoffset, this.tilexspacing, this.tileyspacing, this.seamless);
		if (this.width !== this.lastwidth || this.height !== this.lastheight)
		{
			this.physics_changed = true;
			this.setAllQuadMapChanged();
			this.maybeBuildAllQuadMap();
			this.lastwidth = this.width;
			this.lastheight = this.height;
		}
		ctx.globalAlpha = this.opacity;
		var layer = this.layer;
		var viewLeft = layer.viewLeft;
		var viewTop = layer.viewTop;
		var viewRight = layer.viewRight;
		var viewBottom = layer.viewBottom;
		var myx = this.x;
		var myy = this.y;
		var seamless = this.seamless;
		var qrc;
		if (this.runtime.pixel_rounding)
		{
			myx = Math.round(myx);
			myy = Math.round(myy);
		}
		var cellWidthPx = this.cellwidth * this.tilewidth;
		var cellHeightPx = this.cellheight * this.tileheight;
		var firstCellX = Math.floor((viewLeft - myx) / cellWidthPx);
		var lastCellX = Math.floor((viewRight - myx) / cellWidthPx);
		var firstCellY = Math.floor((viewTop - myy) / cellHeightPx);
		var lastCellY = Math.floor((viewBottom - myy) / cellHeightPx);
		var offx = myx % this.tilewidth;
		var offy = myy % this.tileheight;
		if (this.seamless)
		{
			offx = 0;
			offy = 0;
		}
		if (offx !== 0 || offy !== 0)
		{
			ctx.save();
			ctx.translate(offx, offy);
			myx -= offx;
			myy -= offy;
			viewLeft -= offx;
			viewTop -= offy;
			viewRight -= offx;
			viewBottom -= offy;
		}
		var cx, cy, cell, i, len, q, qleft, qtop, qright, qbottom, img;
		for (cx = firstCellX; cx <= lastCellX; ++cx)
		{
			for (cy = firstCellY; cy <= lastCellY; ++cy)
			{
				cell = this.cellAtIndex(cx, cy);
				if (!cell)
					continue;
				cell.maybeBuildQuadMap();
				for (i = 0, len = cell.quads.length; i < len; ++i)
				{
					q = cell.quads[i];
					if (q.id === -1)
						continue;
					qrc = q.rc;
					qleft = qrc.left + myx;
					qtop = qrc.top + myy;
					qright = qrc.right + myx;
					qbottom = qrc.bottom + myy;
					if (qleft > viewRight || qright < viewLeft || qtop > viewBottom || qbottom < viewTop)
						continue;
					img = this.type.GetFlippedTileImage(q.tileid, q.horiz_flip, q.vert_flip, q.diag_flip, this.seamless);
					if (seamless)
					{
						ctx.drawImage(img, qleft, qtop);
					}
					else
					{
						ctx.fillStyle = this.type.GetFlippedTileImage(q.tileid, q.horiz_flip, q.vert_flip, q.diag_flip, this.seamless);
						ctx.fillRect(qleft, qtop, qright - qleft, qbottom - qtop);
					}
				}
				/*
				for (i = 0, len = cell.collision_rects.length; i < len; ++i)
				{
					qrc = cell.collision_rects[i].rc;
					qleft = qrc.left + myx;
					qtop = qrc.top + myy;
					qright = qrc.right + myx;
					qbottom = qrc.bottom + myy;
					ctx.strokeRect(qleft, qtop, qright - qleft, qbottom - qtop);
				}
				*/
			}
		}
		if (offx !== 0 || offy !== 0)
			ctx.restore();
	};
	var tmp_rect = new cr.rect(0, 0, 1, 1);
	instanceProto.drawGL = function (glw)
	{
		if (this.tilewidth <= 0 || this.tileheight <= 0)
			return;
		this.type.maybeCutTiles(this.tilewidth, this.tileheight, this.tilexoffset, this.tileyoffset, this.tilexspacing, this.tileyspacing, this.seamless);
		if (this.width !== this.lastwidth || this.height !== this.lastheight)
		{
			this.physics_changed = true;
			this.setAllQuadMapChanged();
			this.maybeBuildAllQuadMap();
			this.lastwidth = this.width;
			this.lastheight = this.height;
		}
		glw.setOpacity(this.opacity);
		var cut_tiles = this.type.cut_tiles;
		var layer = this.layer;
		var viewLeft = layer.viewLeft;
		var viewTop = layer.viewTop;
		var viewRight = layer.viewRight;
		var viewBottom = layer.viewBottom;
		var myx = this.x;
		var myy = this.y;
		var qrc;
		if (this.runtime.pixel_rounding)
		{
			myx = Math.round(myx);
			myy = Math.round(myy);
		}
		var cellWidthPx = this.cellwidth * this.tilewidth;
		var cellHeightPx = this.cellheight * this.tileheight;
		var firstCellX = Math.floor((viewLeft - myx) / cellWidthPx);
		var lastCellX = Math.floor((viewRight - myx) / cellWidthPx);
		var firstCellY = Math.floor((viewTop - myy) / cellHeightPx);
		var lastCellY = Math.floor((viewBottom - myy) / cellHeightPx);
		var i, len, q, qleft, qtop, qright, qbottom;
		var qtlx, qtly, qtrx, qtry, qbrx, qbry, qblx, qbly, temp;
		var cx, cy, cell;
		for (cx = firstCellX; cx <= lastCellX; ++cx)
		{
			for (cy = firstCellY; cy <= lastCellY; ++cy)
			{
				cell = this.cellAtIndex(cx, cy);
				if (!cell)
					continue;
				cell.maybeBuildQuadMap();
				for (i = 0, len = cell.quads.length; i < len; ++i)
				{
					q = cell.quads[i];
					if (q.id === -1)
						continue;
					qrc = q.rc;
					qleft = qrc.left + myx;
					qtop = qrc.top + myy;
					qright = qrc.right + myx;
					qbottom = qrc.bottom + myy;
					if (qleft > viewRight || qright < viewLeft || qtop > viewBottom || qbottom < viewTop)
						continue;
					glw.setTexture(cut_tiles[q.tileid]);
					tmp_rect.right = (qright - qleft) / this.tilewidth;
					tmp_rect.bottom = (qbottom - qtop) / this.tileheight;
					if (q.any_flip)
					{
						if (q.diag_flip)
						{
							temp = tmp_rect.right;
							tmp_rect.right = tmp_rect.bottom;
							tmp_rect.bottom = temp;
						}
						qtlx = 0;
						qtly = 0;
						qtrx = tmp_rect.right;
						qtry = 0;
						qbrx = tmp_rect.right;
						qbry = tmp_rect.bottom;
						qblx = 0;
						qbly = tmp_rect.bottom;
						if (q.diag_flip)
						{
							temp = qblx;		qblx = qtrx;		qtrx = temp;
							temp = qbly;		qbly = qtry;		qtry = temp;
						}
						if (q.horiz_flip)
						{
							temp = qtlx;		qtlx = qtrx;		qtrx = temp;
							temp = qtly;		qtly = qtry;		qtry = temp;
							temp = qblx;		qblx = qbrx;		qbrx = temp;
							temp = qbly;		qbly = qbry;		qbry = temp;
						}
						if (q.vert_flip)
						{
							temp = qtlx;		qtlx = qblx;		qblx = temp;
							temp = qtly;		qtly = qbly;		qbly = temp;
							temp = qtrx;		qtrx = qbrx;		qbrx = temp;
							temp = qtry;		qtry = qbry;		qbry = temp;
						}
						glw.quadTexUV(qleft, qtop, qright, qtop, qright, qbottom, qleft, qbottom, qtlx, qtly, qtrx, qtry, qbrx, qbry, qblx, qbly);
					}
					else
					{
						glw.quadTex(qleft, qtop, qright, qtop, qright, qbottom, qleft, qbottom, tmp_rect);
					}
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareTileAt = function (tx, ty, cmp, t)
	{
		var tile = this.getTileAt(tx, ty);
		if (tile !== -1)
			tile = (tile & TILE_ID_MASK);
		return cr.do_cmp(tile, cmp, t);
	};
	function StateComboToFlags(state)
	{
		switch (state) {
		case 0:		// normal
			return 0;
		case 1:		// flipped horizontal
			return TILE_FLIPPED_HORIZONTAL;
		case 2:		// flipped vertical
			return TILE_FLIPPED_VERTICAL;
		case 3:		// rotated 90
			return TILE_FLIPPED_HORIZONTAL | TILE_FLIPPED_DIAGONAL;
		case 4:		// rotated 180
			return TILE_FLIPPED_HORIZONTAL | TILE_FLIPPED_VERTICAL;
		case 5:		// rotated 270
			return TILE_FLIPPED_VERTICAL | TILE_FLIPPED_DIAGONAL;
		case 6:		// rotated 90, flipped vertical
			return TILE_FLIPPED_HORIZONTAL | TILE_FLIPPED_VERTICAL | TILE_FLIPPED_DIAGONAL;
		case 7:		// rotated 270, flipped vertical
			return TILE_FLIPPED_DIAGONAL;
		default:
			return 0;
		}
	};
	Cnds.prototype.CompareTileStateAt = function (tx, ty, state)
	{
		var tile = this.getTileAt(tx, ty);
		var flags = 0;
		if (tile !== -1)
			flags = (tile & TILE_FLAGS_MASK);
		return flags === StateComboToFlags(state);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.EraseTile = function (tx, ty)
	{
		this.maybeResizeTilemap();
		this.setTileAt(tx, ty, -1);
	};
	Acts.prototype.SetTile = function (tx, ty, t, state)
	{
		this.maybeResizeTilemap();
		this.setTileAt(tx, ty, (t & TILE_ID_MASK) | StateComboToFlags(state));
	};
	Acts.prototype.SetTileState = function (tx, ty, state)
	{
		var t = this.getTileAt(tx, ty);
		if (t !== -1)
		{
			this.maybeResizeTilemap();
			this.setTileAt(tx, ty, (t & TILE_ID_MASK) | StateComboToFlags(state));
		}
	};
	Acts.prototype.EraseTileRange = function (tx, ty, tw, th)
	{
		var fromx = Math.floor(cr.max(tx, 0));
		var fromy = Math.floor(cr.max(ty, 0));
		var tox = Math.floor(cr.min(tx + tw, this.mapwidth));
		var toy = Math.floor(cr.min(ty + th, this.mapheight));
		var x, y;
		for (y = fromy; y < toy; ++y)
		{
			for (x = fromx; x < tox; ++x)
			{
				this.setTileAt(x, y, -1);
			}
		}
	};
	Acts.prototype.SetTileRange = function (tx, ty, tw, th, t, state)
	{
		this.maybeResizeTilemap();
		var fromx = Math.floor(cr.max(tx, 0));
		var fromy = Math.floor(cr.max(ty, 0));
		var tox = Math.floor(cr.min(tx + tw, this.mapwidth));
		var toy = Math.floor(cr.min(ty + th, this.mapheight));
		var settile = (t & TILE_ID_MASK) | StateComboToFlags(state);
		var x, y;
		for (y = fromy; y < toy; ++y)
		{
			for (x = fromx; x < tox; ++x)
			{
				this.setTileAt(x, y, settile);
			}
		}
	};
	Acts.prototype.SetTileStateRange = function (tx, ty, tw, th, state)
	{
		this.maybeResizeTilemap();
		var fromx = Math.floor(cr.max(tx, 0));
		var fromy = Math.floor(cr.max(ty, 0));
		var tox = Math.floor(cr.min(tx + tw, this.mapwidth));
		var toy = Math.floor(cr.min(ty + th, this.mapheight));
		var setstate = StateComboToFlags(state);
		var x, y, t;
		for (y = fromy; y < toy; ++y)
		{
			for (x = fromx; x < tox; ++x)
			{
				t = this.getTileAt(x, y);
				if (t !== -1)
					this.setTileAt(x, y, (t & TILE_ID_MASK) | setstate);
			}
		}
	};
	Acts.prototype.LoadFromJSON = function (str)
	{
		var o;
		try {
			o = JSON.parse(str);
		}
		catch (e) {
			return;
		}
		if (!o["c2tilemap"])
			return;		// not a known tilemap data format
		this.mapwidth = o["width"];
		this.mapheight = o["height"];
		this.setTilesFromRLECSV(o["data"]);
		this.setAllQuadMapChanged();
		this.physics_changed = true;
	};
	Acts.prototype.JSONDownload = function (filename)
	{
		var a = document.createElement("a");
		var o = {
			"c2tilemap": true,
			"width": this.mapwidth,
			"height": this.mapheight,
			"data": this.getTilesAsRLECSV()
		};
		if (typeof a.download === "undefined")
		{
			var str = 'data:text/html,' + encodeURIComponent("<p><a download='data.json' href=\"data:application/json,"
				+ encodeURIComponent(JSON.stringify(o))
				+ "\">Download link</a></p>");
			window.open(str);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename;
			a.href = "data:application/json," + encodeURIComponent(JSON.stringify(o));
			a.download = filename;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.TileAt = function (ret, tx, ty)
	{
		var tile = this.getTileAt(tx, ty);
		ret.set_int(tile === -1 ? -1 : (tile & TILE_ID_MASK));
	};
	Exps.prototype.PositionToTileX = function (ret, x_)
	{
		ret.set_float(Math.floor((x_ - this.x) / this.tilewidth));
	};
	Exps.prototype.PositionToTileY = function (ret, y_)
	{
		ret.set_float(Math.floor((y_ - this.y) / this.tileheight));
	};
	Exps.prototype.TileToPositionX = function (ret, x_)
	{
		ret.set_float((x_ * this.tilewidth) + this.x + (this.tilewidth / 2));
	};
	Exps.prototype.TileToPositionY = function (ret, y_)
	{
		ret.set_float((y_ * this.tileheight) + this.y + (this.tileheight / 2));
	};
	Exps.prototype.SnapX = function (ret, x_)
	{
		ret.set_float((Math.floor((x_ - this.x) / this.tilewidth) * this.tilewidth) + this.x + (this.tilewidth / 2));
	};
	Exps.prototype.SnapY = function (ret, y_)
	{
		ret.set_float((Math.floor((y_ - this.y) / this.tileheight) * this.tileheight) + this.y + (this.tileheight / 2));
	};
	Exps.prototype.TilesJSON = function (ret)
	{
		ret.set_string(JSON.stringify({
			"c2tilemap": true,
			"width": this.mapwidth,
			"height": this.mapheight,
			"data": this.getTilesAsRLECSV()
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Touch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Touch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.touches = [];
		this.mouseDown = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var dummyoffset = {left: 0, top: 0};
	instanceProto.findTouch = function (id)
	{
		var i, len;
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			if (this.touches[i]["id"] === id)
				return i;
		}
		return -1;
	};
	var appmobi_accx = 0;
	var appmobi_accy = 0;
	var appmobi_accz = 0;
	function AppMobiGetAcceleration(evt)
	{
		appmobi_accx = evt.x;
		appmobi_accy = evt.y;
		appmobi_accz = evt.z;
	};
	var pg_accx = 0;
	var pg_accy = 0;
	var pg_accz = 0;
	function PhoneGapGetAcceleration(evt)
	{
		pg_accx = evt.x;
		pg_accy = evt.y;
		pg_accz = evt.z;
	};
	var theInstance = null;
	var touchinfo_cache = [];
	function AllocTouchInfo(x, y, id, index)
	{
		var ret;
		if (touchinfo_cache.length)
			ret = touchinfo_cache.pop();
		else
			ret = new TouchInfo();
		ret.init(x, y, id, index);
		return ret;
	};
	function ReleaseTouchInfo(ti)
	{
		if (touchinfo_cache.length < 100)
			touchinfo_cache.push(ti);
	};
	var GESTURE_HOLD_THRESHOLD = 15;		// max px motion for hold gesture to register
	var GESTURE_HOLD_TIMEOUT = 500;			// time for hold gesture to register
	var GESTURE_TAP_TIMEOUT = 333;			// time for tap gesture to register
	var GESTURE_DOUBLETAP_THRESHOLD = 25;	// max distance apart for taps to be
	function TouchInfo()
	{
		this.starttime = 0;
		this.time = 0;
		this.lasttime = 0;
		this.startx = 0;
		this.starty = 0;
		this.x = 0;
		this.y = 0;
		this.lastx = 0;
		this.lasty = 0;
		this["id"] = 0;
		this.startindex = 0;
		this.triggeredHold = false;
		this.tooFarForHold = false;
	};
	TouchInfo.prototype.init = function (x, y, id, index)
	{
		var nowtime = cr.performance_now();
		this.time = nowtime;
		this.lasttime = nowtime;
		this.starttime = nowtime;
		this.startx = x;
		this.starty = y;
		this.x = x;
		this.y = y;
		this.lastx = x;
		this.lasty = y;
		this["id"] = id;
		this.startindex = index;
		this.triggeredHold = false;
		this.tooFarForHold = false;
	};
	TouchInfo.prototype.update = function (nowtime, x, y)
	{
		this.lasttime = this.time;
		this.time = nowtime;
		this.lastx = this.x;
		this.lasty = this.y;
		this.x = x;
		this.y = y;
		if (!this.tooFarForHold && cr.distanceTo(this.startx, this.starty, this.x, this.y) >= GESTURE_HOLD_THRESHOLD)
		{
			this.tooFarForHold = true;
		}
	};
	TouchInfo.prototype.maybeTriggerHold = function (inst, index)
	{
		if (this.triggeredHold)
			return;		// already triggered this gesture
		var nowtime = cr.performance_now();
		if (nowtime - this.starttime >= GESTURE_HOLD_TIMEOUT && !this.tooFarForHold && cr.distanceTo(this.startx, this.starty, this.x, this.y) < GESTURE_HOLD_THRESHOLD)
		{
			this.triggeredHold = true;
			inst.trigger_index = this.startindex;
			inst.trigger_id = this["id"];
			inst.getTouchIndex = index;
			inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnHoldGesture, inst);
			inst.curTouchX = this.x;
			inst.curTouchY = this.y;
			inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnHoldGestureObject, inst);
			inst.getTouchIndex = 0;
		}
	};
	var lastTapX = -1000;
	var lastTapY = -1000;
	var lastTapTime = -10000;
	TouchInfo.prototype.maybeTriggerTap = function (inst, index)
	{
		if (this.triggeredHold)
			return;
		var nowtime = cr.performance_now();
		if (nowtime - this.starttime <= GESTURE_TAP_TIMEOUT && !this.tooFarForHold && cr.distanceTo(this.startx, this.starty, this.x, this.y) < GESTURE_HOLD_THRESHOLD)
		{
			inst.trigger_index = this.startindex;
			inst.trigger_id = this["id"];
			inst.getTouchIndex = index;
			if ((nowtime - lastTapTime <= GESTURE_TAP_TIMEOUT * 2) && cr.distanceTo(lastTapX, lastTapY, this.x, this.y) < GESTURE_DOUBLETAP_THRESHOLD)
			{
				inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnDoubleTapGesture, inst);
				inst.curTouchX = this.x;
				inst.curTouchY = this.y;
				inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnDoubleTapGestureObject, inst);
				lastTapX = -1000;
				lastTapY = -1000;
				lastTapTime = -10000;
			}
			else
			{
				inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTapGesture, inst);
				inst.curTouchX = this.x;
				inst.curTouchY = this.y;
				inst.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTapGestureObject, inst);
				lastTapX = this.x;
				lastTapY = this.y;
				lastTapTime = nowtime;
			}
			inst.getTouchIndex = 0;
		}
	};
	instanceProto.onCreate = function()
	{
		theInstance = this;
		this.isWindows8 = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.orient_alpha = 0;
		this.orient_beta = 0;
		this.orient_gamma = 0;
		this.acc_g_x = 0;
		this.acc_g_y = 0;
		this.acc_g_z = 0;
		this.acc_x = 0;
		this.acc_y = 0;
		this.acc_z = 0;
		this.curTouchX = 0;
		this.curTouchY = 0;
		this.trigger_index = 0;
		this.trigger_id = 0;
		this.getTouchIndex = 0;
		this.useMouseInput = (this.properties[0] !== 0);
		var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
		var elem2 = document;
		if (this.runtime.isDirectCanvas)
			elem2 = elem = window["Canvas"];
		else if (this.runtime.isCocoonJs)
			elem2 = elem = window;
		var self = this;
		if (window.navigator["pointerEnabled"])
		{
			elem.addEventListener("pointerdown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("pointermove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("pointerup",
				function(info) {
					self.onPointerEnd(info, false);
				},
				false
			);
			elem2.addEventListener("pointercancel",
				function(info) {
					self.onPointerEnd(info, true);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				this.runtime.canvas.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else if (window.navigator["msPointerEnabled"])
		{
			elem.addEventListener("MSPointerDown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("MSPointerMove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("MSPointerUp",
				function(info) {
					self.onPointerEnd(info, false);
				},
				false
			);
			elem2.addEventListener("MSPointerCancel",
				function(info) {
					self.onPointerEnd(info, true);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else
		{
			elem.addEventListener("touchstart",
				function(info) {
					self.onTouchStart(info);
				},
				false
			);
			elem.addEventListener("touchmove",
				function(info) {
					self.onTouchMove(info);
				},
				false
			);
			elem2.addEventListener("touchend",
				function(info) {
					self.onTouchEnd(info, false);
				},
				false
			);
			elem2.addEventListener("touchcancel",
				function(info) {
					self.onTouchEnd(info, true);
				},
				false
			);
		}
		if (this.isWindows8)
		{
			var win8accelerometerFn = function(e) {
					var reading = e["reading"];
					self.acc_x = reading["accelerationX"];
					self.acc_y = reading["accelerationY"];
					self.acc_z = reading["accelerationZ"];
				};
			var win8inclinometerFn = function(e) {
					var reading = e["reading"];
					self.orient_alpha = reading["yawDegrees"];
					self.orient_beta = reading["pitchDegrees"];
					self.orient_gamma = reading["rollDegrees"];
				};
			var accelerometer = Windows["Devices"]["Sensors"]["Accelerometer"]["getDefault"]();
            if (accelerometer)
			{
                accelerometer["reportInterval"] = Math.max(accelerometer["minimumReportInterval"], 16);
				accelerometer.addEventListener("readingchanged", win8accelerometerFn);
            }
			var inclinometer = Windows["Devices"]["Sensors"]["Inclinometer"]["getDefault"]();
			if (inclinometer)
			{
				inclinometer["reportInterval"] = Math.max(inclinometer["minimumReportInterval"], 16);
				inclinometer.addEventListener("readingchanged", win8inclinometerFn);
			}
			document.addEventListener("visibilitychange", function(e) {
				if (document["hidden"] || document["msHidden"])
				{
					if (accelerometer)
						accelerometer.removeEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.removeEventListener("readingchanged", win8inclinometerFn);
				}
				else
				{
					if (accelerometer)
						accelerometer.addEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.addEventListener("readingchanged", win8inclinometerFn);
				}
			}, false);
		}
		else
		{
			window.addEventListener("deviceorientation", function (eventData) {
				self.orient_alpha = eventData["alpha"] || 0;
				self.orient_beta = eventData["beta"] || 0;
				self.orient_gamma = eventData["gamma"] || 0;
			}, false);
			window.addEventListener("devicemotion", function (eventData) {
				if (eventData["accelerationIncludingGravity"])
				{
					self.acc_g_x = eventData["accelerationIncludingGravity"]["x"] || 0;
					self.acc_g_y = eventData["accelerationIncludingGravity"]["y"] || 0;
					self.acc_g_z = eventData["accelerationIncludingGravity"]["z"] || 0;
				}
				if (eventData["acceleration"])
				{
					self.acc_x = eventData["acceleration"]["x"] || 0;
					self.acc_y = eventData["acceleration"]["y"] || 0;
					self.acc_z = eventData["acceleration"]["z"] || 0;
				}
			}, false);
		}
		if (this.useMouseInput && !this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
		}
		if (this.runtime.isAppMobi && !this.runtime.isDirectCanvas)
		{
			AppMobi["accelerometer"]["watchAcceleration"](AppMobiGetAcceleration, { "frequency": 40, "adjustForRotation": true });
		}
		if (this.runtime.isPhoneGap && navigator["accelerometer"] && navigator["accelerometer"]["watchAcceleration"])
		{
			navigator["accelerometer"]["watchAcceleration"](PhoneGapGetAcceleration, null, { "frequency": 40 });
		}
		this.runtime.tick2Me(this);
	};
	instanceProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		var nowtime = cr.performance_now();
		if (i >= 0)
		{
			var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
			var t = this.touches[i];
			if (nowtime - t.time < 2)
				return;
			t.update(nowtime, info.pageX - offset.left, info.pageY - offset.top);
		}
	};
	instanceProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var touchx = info.pageX - offset.left;
		var touchy = info.pageY - offset.top;
		var nowtime = cr.performance_now();
		this.trigger_index = this.touches.length;
		this.trigger_id = info["pointerId"];
		this.touches.push(AllocTouchInfo(touchx, touchy, info["pointerId"], this.trigger_index));
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
		this.curTouchX = touchx;
		this.curTouchY = touchy;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onPointerEnd = function (info, isCancel)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		this.trigger_index = (i >= 0 ? this.touches[i].startindex : -1);
		this.trigger_id = (i >= 0 ? this.touches[i]["id"] : -1);
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
		if (i >= 0)
		{
			if (!isCancel)
				this.touches[i].maybeTriggerTap(this, i);
			ReleaseTouchInfo(this.touches[i]);
			this.touches.splice(i, 1);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var nowtime = cr.performance_now();
		var i, len, t, u;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			var j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
				u = this.touches[j];
				if (nowtime - u.time < 2)
					continue;
				u.update(nowtime, t.pageX - offset.left, t.pageY - offset.top);
			}
		}
	};
	instanceProto.onTouchStart = function (info)
	{
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var nowtime = cr.performance_now();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j !== -1)
				continue;
			var touchx = t.pageX - offset.left;
			var touchy = t.pageY - offset.top;
			this.trigger_index = this.touches.length;
			this.trigger_id = t["identifier"];
			this.touches.push(AllocTouchInfo(touchx, touchy, t["identifier"], this.trigger_index));
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
			this.curTouchX = touchx;
			this.curTouchY = touchy;
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchEnd = function (info, isCancel)
	{
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				this.trigger_index = this.touches[j].startindex;
				this.trigger_id = this.touches[j]["id"];
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
				if (!isCancel)
					this.touches[j].maybeTriggerTap(this, j);
				ReleaseTouchInfo(this.touches[j]);
				this.touches.splice(j, 1);
			}
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.getAlpha = function ()
	{
		if (this.runtime.isAppMobi && this.orient_alpha === 0 && appmobi_accz !== 0)
			return appmobi_accz * 90;
		else if (this.runtime.isPhoneGap  && this.orient_alpha === 0 && pg_accz !== 0)
			return pg_accz * 90;
		else
			return this.orient_alpha;
	};
	instanceProto.getBeta = function ()
	{
		if (this.runtime.isAppMobi && this.orient_beta === 0 && appmobi_accy !== 0)
			return appmobi_accy * -90;
		else if (this.runtime.isPhoneGap  && this.orient_beta === 0 && pg_accy !== 0)
			return pg_accy * -90;
		else
			return this.orient_beta;
	};
	instanceProto.getGamma = function ()
	{
		if (this.runtime.isAppMobi && this.orient_gamma === 0 && appmobi_accx !== 0)
			return appmobi_accx * 90;
		else if (this.runtime.isPhoneGap  && this.orient_gamma === 0 && pg_accx !== 0)
			return pg_accx * 90;
		else
			return this.orient_gamma;
	};
	var noop_func = function(){};
	instanceProto.onMouseDown = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchStart(fakeinfo);
		this.mouseDown = true;
	};
	instanceProto.onMouseMove = function(info)
	{
		if (!this.mouseDown)
			return;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchMove(fakeinfo);
	};
	instanceProto.onMouseUp = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchEnd(fakeinfo);
		this.mouseDown = false;
	};
	instanceProto.tick2 = function()
	{
		var i, len, t;
		var nowtime = cr.performance_now();
		for (i = 0, len = this.touches.length; i < len; ++i)
		{
			t = this.touches[i];
			if (t.time <= nowtime - 50)
				t.lasttime = nowtime;
			t.maybeTriggerHold(this, i);
		}
	};
	function Cnds() {};
	Cnds.prototype.OnTouchStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnTouchEnd = function ()
	{
		return true;
	};
	Cnds.prototype.IsInTouch = function ()
	{
		return this.touches.length;
	};
	Cnds.prototype.OnTouchObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	var touching = [];
	Cnds.prototype.IsTouchingObject = function (type)
	{
		if (!type)
			return false;
		var sol = type.getCurrentSol();
		var instances = sol.getObjects();
		var px, py;
		var i, leni, j, lenj;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			var inst = instances[i];
			inst.update_bbox();
			for (j = 0, lenj = this.touches.length; j < lenj; j++)
			{
				var touch = this.touches[j];
				px = inst.layer.canvasToLayer(touch.x, touch.y, true);
				py = inst.layer.canvasToLayer(touch.x, touch.y, false);
				if (inst.contains_pt(px, py))
				{
					touching.push(inst);
					break;
				}
			}
		}
		if (touching.length)
		{
			sol.select_all = false;
			cr.shallowAssignArray(sol.instances, touching);
			type.applySolToContainer();
			touching.length = 0;
			return true;
		}
		else
			return false;
	};
	Cnds.prototype.CompareTouchSpeed = function (index, cmp, s)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
			return false;
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		var speed = 0;
		if (timediff > 0)
			speed = dist / timediff;
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.OrientationSupported = function ()
	{
		return typeof window["DeviceOrientationEvent"] !== "undefined";
	};
	Cnds.prototype.MotionSupported = function ()
	{
		return typeof window["DeviceMotionEvent"] !== "undefined";
	};
	Cnds.prototype.CompareOrientation = function (orientation_, cmp_, angle_)
	{
		var v = 0;
		if (orientation_ === 0)
			v = this.getAlpha();
		else if (orientation_ === 1)
			v = this.getBeta();
		else
			v = this.getGamma();
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.CompareAcceleration = function (acceleration_, cmp_, angle_)
	{
		var v = 0;
		if (acceleration_ === 0)
			v = this.acc_g_x;
		else if (acceleration_ === 1)
			v = this.acc_g_y;
		else if (acceleration_ === 2)
			v = this.acc_g_z;
		else if (acceleration_ === 3)
			v = this.acc_x;
		else if (acceleration_ === 4)
			v = this.acc_y;
		else if (acceleration_ === 5)
			v = this.acc_z;
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.OnNthTouchStart = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.OnNthTouchEnd = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.HasNthTouch = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return this.touches.length >= touch_ + 1;
	};
	Cnds.prototype.OnHoldGesture = function ()
	{
		return true;
	};
	Cnds.prototype.OnTapGesture = function ()
	{
		return true;
	};
	Cnds.prototype.OnDoubleTapGesture = function ()
	{
		return true;
	};
	Cnds.prototype.OnHoldGestureObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.OnTapGestureObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.OnDoubleTapGestureObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	pluginProto.cnds = new Cnds();
	function Exps() {};
	Exps.prototype.TouchCount = function (ret)
	{
		ret.set_int(this.touches.length);
	};
	Exps.prototype.X = function (ret, layerparam)
	{
		var index = this.getTouchIndex;
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		var index = this.getTouchIndex;
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = 1;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = 0;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].x);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteXAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].x);
	};
	Exps.prototype.AbsoluteXForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.x);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].y);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteYAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].y);
	};
	Exps.prototype.AbsoluteYForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.y);
	};
	Exps.prototype.SpeedAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.SpeedForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var dist = cr.distanceTo(touch.x, touch.y, touch.lastx, touch.lasty);
		var timediff = (touch.time - touch.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.AngleAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(t.lastx, t.lasty, t.x, t.y)));
	};
	Exps.prototype.AngleForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(touch.lastx, touch.lasty, touch.x, touch.y)));
	};
	Exps.prototype.Alpha = function (ret)
	{
		ret.set_float(this.getAlpha());
	};
	Exps.prototype.Beta = function (ret)
	{
		ret.set_float(this.getBeta());
	};
	Exps.prototype.Gamma = function (ret)
	{
		ret.set_float(this.getGamma());
	};
	Exps.prototype.AccelerationXWithG = function (ret)
	{
		ret.set_float(this.acc_g_x);
	};
	Exps.prototype.AccelerationYWithG = function (ret)
	{
		ret.set_float(this.acc_g_y);
	};
	Exps.prototype.AccelerationZWithG = function (ret)
	{
		ret.set_float(this.acc_g_z);
	};
	Exps.prototype.AccelerationX = function (ret)
	{
		ret.set_float(this.acc_x);
	};
	Exps.prototype.AccelerationY = function (ret)
	{
		ret.set_float(this.acc_y);
	};
	Exps.prototype.AccelerationZ = function (ret)
	{
		ret.set_float(this.acc_z);
	};
	Exps.prototype.TouchIndex = function (ret)
	{
		ret.set_int(this.trigger_index);
	};
	Exps.prototype.TouchID = function (ret)
	{
		ret.set_float(this.trigger_id);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.WebStorage = function(runtime)
{
	this.runtime = runtime;
};
(function()
{
	var pluginProto = cr.plugins_.WebStorage.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var prefix = "";
	var is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	if (is_arcade)
		prefix = "arcade" + window["scirra_arcade_id"];
	var logged_sessionnotsupported = false;
	function LogSessionNotSupported()
	{
		if (logged_sessionnotsupported)
			return;
		cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead.");
		logged_sessionnotsupported = true;
	};
	instanceProto.onCreate = function()
	{
	};
	function Cnds() {};
	Cnds.prototype.LocalStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.SessionStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.LocalStorageExists = function(key)
	{
		return localStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.SessionStorageExists = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return false;
		}
		return sessionStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.OnQuotaExceeded = function ()
	{
		return true;
	};
	Cnds.prototype.CompareKeyText = function (key, text_to_compare, case_sensitive)
	{
		var value = localStorage.getItem(prefix + key) || "";
		if (case_sensitive)
			return value == text_to_compare;
		else
			return cr.equals_nocase(value, text_to_compare);
	};
	Cnds.prototype.CompareKeyNumber = function (key, cmp, x)
	{
		var value = localStorage.getItem(prefix + key) || "";
		return cr.do_cmp(parseFloat(value), cmp, x);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StoreLocal = function(key, data)
	{
		try {
			localStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.StoreSession = function(key,data)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		try {
			sessionStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.RemoveLocal = function(key)
	{
		localStorage.removeItem(prefix + key);
	};
	Acts.prototype.RemoveSession = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		sessionStorage.removeItem(prefix + key);
	};
	Acts.prototype.ClearLocal = function()
	{
		if (!is_arcade)
			localStorage.clear();
	};
	Acts.prototype.ClearSession = function()
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		if (!is_arcade)
			sessionStorage.clear();
	};
	Acts.prototype.JSONLoad = function (json_, mode_)
	{
		var d;
		try {
			d = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!d["c2dictionary"])			// presumably not a c2dictionary object
			return;
		var o = d["data"];
		if (mode_ === 0 && !is_arcade)	// 'set' mode: must clear webstorage first
			localStorage.clear();
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
			{
				try {
					localStorage.setItem(prefix + p, o[p]);
				}
				catch (e)
				{
					this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
					return;
				}
			}
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LocalValue = function(ret,key)
	{
		ret.set_string(localStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.SessionValue = function(ret,key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		ret.set_string(sessionStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.LocalCount = function(ret)
	{
		ret.set_int(is_arcade ? 0 : localStorage.length);
	};
	Exps.prototype.SessionCount = function(ret)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_int(0);
			return;
		}
		ret.set_int(is_arcade ? 0 : sessionStorage.length);
	};
	Exps.prototype.LocalAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.getItem(localStorage.key(n)) || "");
	};
	Exps.prototype.SessionAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.getItem(sessionStorage.key(n)) || "");
	};
	Exps.prototype.LocalKeyAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.key(n) || "");
	};
	Exps.prototype.SessionKeyAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.key(n) || "");
	};
	Exps.prototype.AsJSON = function (ret)
	{
		var o = {}, i, len, k;
		for (i = 0, len = localStorage.length; i < len; i++)
		{
			k = localStorage.key(i);
			if (is_arcade)
			{
				if (k.substr(0, prefix.length) === prefix)
				{
					o[k.substr(prefix.length)] = localStorage.getItem(k);
				}
			}
			else
				o[k] = localStorage.getItem(k);
		}
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": o
		}));
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.behaviors.Bullet = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Bullet.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var speed = this.properties[0];
		this.acc = this.properties[1];
		this.g = this.properties[2];
		this.bounceOffSolid = (this.properties[3] !== 0);
		this.setAngle = (this.properties[4] !== 0);
		this.dx = Math.cos(this.inst.angle) * speed;
		this.dy = Math.sin(this.inst.angle) * speed;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		this.lastKnownAngle = this.inst.angle;
		this.travelled = 0;
		this.enabled = (this.properties[5] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"acc": this.acc,
			"g": this.g,
			"dx": this.dx,
			"dy": this.dy,
			"lx": this.lastx,
			"ly": this.lasty,
			"lka": this.lastKnownAngle,
			"t": this.travelled,
			"e": this.enabled
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.acc = o["acc"];
		this.g = o["g"];
		this.dx = o["dx"];
		this.dy = o["dy"];
		this.lastx = o["lx"];
		this.lasty = o["ly"];
		this.lastKnownAngle = o["lka"];
		this.travelled = o["t"];
		this.enabled = o["e"];
	};
	behinstProto.tick = function ()
	{
		if (!this.enabled)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s, a;
		var bounceSolid, bounceAngle;
		if (this.inst.angle !== this.lastKnownAngle)
		{
			if (this.setAngle)
			{
				s = cr.distanceTo(0, 0, this.dx, this.dy);
				this.dx = Math.cos(this.inst.angle) * s;
				this.dy = Math.sin(this.inst.angle) * s;
			}
			this.lastKnownAngle = this.inst.angle;
		}
		if (this.acc !== 0)
		{
			s = cr.distanceTo(0, 0, this.dx, this.dy);
			if (this.dx === 0 && this.dy === 0)
				a = this.inst.angle;
			else
				a = cr.angleTo(0, 0, this.dx, this.dy);
			s += this.acc * dt;
			if (s < 0)
				s = 0;
			this.dx = Math.cos(a) * s;
			this.dy = Math.sin(a) * s;
		}
		if (this.g !== 0)
			this.dy += this.g * dt;
		this.lastx = this.inst.x;
		this.lasty = this.inst.y;
		if (this.dx !== 0 || this.dy !== 0)
		{
			this.inst.x += this.dx * dt;
			this.inst.y += this.dy * dt;
			this.travelled += cr.distanceTo(0, 0, this.dx * dt, this.dy * dt)
			if (this.setAngle)
			{
				this.inst.angle = cr.angleTo(0, 0, this.dx, this.dy);
				this.inst.set_bbox_changed();
				this.lastKnownAngle = this.inst.angle;
			}
			this.inst.set_bbox_changed();
			if (this.bounceOffSolid)
			{
				bounceSolid = this.runtime.testOverlapSolid(this.inst);
				if (bounceSolid)
				{
					this.runtime.registerCollision(this.inst, bounceSolid);
					s = cr.distanceTo(0, 0, this.dx, this.dy);
					bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty);
					this.dx = Math.cos(bounceAngle) * s;
					this.dy = Math.sin(bounceAngle) * s;
					this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
					this.inst.y += this.dy * dt;
					this.inst.set_bbox_changed();
					if (this.setAngle)
					{
						this.inst.angle = bounceAngle;
						this.lastKnownAngle = bounceAngle;
						this.inst.set_bbox_changed();
					}
					if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
						this.runtime.pushOutSolidNearest(this.inst, 100);
				}
			}
		}
	};
	function Cnds() {};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		return cr.do_cmp(cr.distanceTo(0, 0, this.dx, this.dy), cmp, s);
	};
	Cnds.prototype.CompareTravelled = function (cmp, d)
	{
		return cr.do_cmp(this.travelled, cmp, d);
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetSpeed = function (s)
	{
		var a = cr.angleTo(0, 0, this.dx, this.dy);
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.acc = a;
	};
	Acts.prototype.SetGravity = function (g)
	{
		this.g = g;
	};
	Acts.prototype.SetAngleOfMotion = function (a)
	{
		a = cr.to_radians(a);
		var s = cr.distanceTo(0, 0, this.dx, this.dy)
		this.dx = Math.cos(a) * s;
		this.dy = Math.sin(a) * s;
	};
	Acts.prototype.Bounce = function (objtype)
	{
		if (!objtype)
			return;
		var otherinst = objtype.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		var dt = this.runtime.getDt(this.inst);
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		var bounceAngle = this.runtime.calculateSolidBounceAngle(this.inst, this.lastx, this.lasty, otherinst);
		this.dx = Math.cos(bounceAngle) * s;
		this.dy = Math.sin(bounceAngle) * s;
		this.inst.x += this.dx * dt;			// move out for one tick since the object can't have spent a tick in the solid
		this.inst.y += this.dy * dt;
		this.inst.set_bbox_changed();
		if (this.setAngle)
		{
			this.inst.angle = bounceAngle;
			this.lastKnownAngle = bounceAngle;
			this.inst.set_bbox_changed();
		}
		if (this.bounceOffSolid)
		{
			if (!this.runtime.pushOutSolid(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30)))
				this.runtime.pushOutSolidNearest(this.inst, 100);
		}
		else
		{
			this.runtime.pushOut(this.inst, this.dx / s, this.dy / s, Math.max(s * 2.5 * dt, 30), otherinst)
		}
	};
	Acts.prototype.SetEnabled = function (en)
	{
		this.enabled = (en === 1);
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.Speed = function (ret)
	{
		var s = cr.distanceTo(0, 0, this.dx, this.dy);
		s = cr.round6dp(s);
		ret.set_float(s);
	};
	Exps.prototype.Acceleration = function (ret)
	{
		ret.set_float(this.acc);
	};
	Exps.prototype.AngleOfMotion = function (ret)
	{
		ret.set_float(cr.to_degrees(cr.angleTo(0, 0, this.dx, this.dy)));
	};
	Exps.prototype.DistanceTravelled = function (ret)
	{
		ret.set_float(this.travelled);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.DragnDrop = function(runtime)
{
	this.runtime = runtime;
	var self = this;
	if (!this.runtime.isDomFree)
	{
		jQuery(document).mousemove(
			function(info) {
				self.onMouseMove(info);
			}
		);
		jQuery(document).mousedown(
			function(info) {
				self.onMouseDown(info);
			}
		);
		jQuery(document).mouseup(
			function(info) {
				self.onMouseUp(info);
			}
		);
	}
	var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
	if (this.runtime.isDirectCanvas)
		elem = window["Canvas"];
	else if (this.runtime.isCocoonJs)
		elem = window;
	if (window.navigator["pointerEnabled"])
	{
		elem.addEventListener("pointerdown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("pointermove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("pointerup",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("pointercancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else if (window.navigator["msPointerEnabled"])
	{
		elem.addEventListener("MSPointerDown",
			function(info) {
				self.onPointerStart(info);
			},
			false
		);
		elem.addEventListener("MSPointerMove",
			function(info) {
				self.onPointerMove(info);
			},
			false
		);
		elem.addEventListener("MSPointerUp",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
		elem.addEventListener("MSPointerCancel",
			function(info) {
				self.onPointerEnd(info);
			},
			false
		);
	}
	else
	{
		elem.addEventListener("touchstart",
			function(info) {
				self.onTouchStart(info);
			},
			false
		);
		elem.addEventListener("touchmove",
			function(info) {
				self.onTouchMove(info);
			},
			false
		);
		elem.addEventListener("touchend",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
		elem.addEventListener("touchcancel",
			function(info) {
				self.onTouchEnd(info);
			},
			false
		);
	}
};
(function ()
{
	var behaviorProto = cr.behaviors.DragnDrop.prototype;
	var dummyoffset = {left: 0, top: 0};
	function GetDragDropBehavior(inst)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i] instanceof behaviorProto.Instance)
				return inst.behavior_insts[i];
		}
		return null;
	};
	behaviorProto.onMouseDown = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputDown("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseMove = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputMove("leftmouse", info.pageX, info.pageY);
	};
	behaviorProto.onMouseUp = function (info)
	{
		if (info.which !== 1)
			return;		// not left mouse button
		this.onInputUp("leftmouse");
	};
	behaviorProto.onTouchStart = function (info)
	{
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputDown(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputMove(id ? id.toString() : "<none>", t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchEnd = function (info)
	{
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputUp(id ? id.toString() : "<none>");
		}
	};
	behaviorProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		this.onInputDown(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputMove(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault && cr.isCanvasInputEvent(info))
			info.preventDefault();
		this.onInputUp(info["pointerId"].toString());
	};
	behaviorProto.onInputDown = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly, topx, topy;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst, topmost = null;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || b.dragging)
				continue;		// don't consider disabled or already-dragging instances
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			if (!inst.contains_pt(lx, ly))
				continue;		// don't consider instances not over this point
			if (!topmost)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index > topmost.layer.index)
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
			if (inst.layer.index === topmost.layer.index && inst.get_zindex() > topmost.get_zindex())
			{
				topmost = inst;
				topx = lx;
				topy = ly;
				continue;
			}
		}
		if (topmost)
			GetDragDropBehavior(topmost).onDown(src, topx, topy);
	};
	behaviorProto.onInputMove = function (src, pageX, pageY)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var lx, ly;
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (!b.enabled || !b.dragging || (b.dragging && b.dragsource !== src))
				continue;		// don't consider disabled, not-dragging, or dragging by other sources
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			b.onMove(lx, ly);
		}
	};
	behaviorProto.onInputUp = function (src)
	{
		var arr = this.my_instances.valuesRef();
		var i, len, b, inst;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetDragDropBehavior(inst);
			if (b.dragging && b.dragsource === src)
				b.onUp();
		}
	};
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.dragging = false;
		this.dx = 0;
		this.dy = 0;
		this.dragsource = "<none>";
		this.axes = this.properties[0];
		this.enabled = (this.properties[1] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return { "enabled": this.enabled };
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.enabled = o["enabled"];
		this.dragging = false;
	};
	behinstProto.onDown = function(src, x, y)
	{
		this.dx = x - this.inst.x;
		this.dy = y - this.inst.y;
		this.dragging = true;
		this.dragsource = src;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.onMove = function(x, y)
	{
		var newx = x - this.dx;
		var newy = y - this.dy;
		if (this.axes === 0)		// both
		{
			if (this.inst.x !== newx || this.inst.y !== newy)
			{
				this.inst.x = newx;
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 1)	// horizontal
		{
			if (this.inst.x !== newx)
			{
				this.inst.x = newx;
				this.inst.set_bbox_changed();
			}
		}
		else if (this.axes === 2)	// vertical
		{
			if (this.inst.y !== newy)
			{
				this.inst.y = newy;
				this.inst.set_bbox_changed();
			}
		}
	};
	behinstProto.onUp = function()
	{
		this.dragging = false;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop, this.inst);
		this.runtime.isInUserInputEvent = false;
	};
	behinstProto.tick = function ()
	{
	};
	function Cnds() {};
	Cnds.prototype.IsDragging = function ()
	{
		return this.dragging;
	};
	Cnds.prototype.OnDragStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnDrop = function ()
	{
		return true;
	};
	Cnds.prototype.IsEnabled = function ()
	{
		return !!this.enabled;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetEnabled = function (s)
	{
		this.enabled = (s !== 0);
		if (!this.enabled)
			this.dragging = false;
	};
	Acts.prototype.Drop = function ()
	{
		if (this.dragging)
			this.onUp();
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Fade = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Fade.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		var active_at_start = this.properties[0] === 1;
		this.fadeInTime = this.properties[1];
		this.waitTime = this.properties[2];
		this.fadeOutTime = this.properties[3];
		this.destroy = this.properties[4];			// 0 = no, 1 = after fade out
		this.stage = active_at_start ? 0 : 3;		// 0 = fade in, 1 = wait, 2 = fade out, 3 = done
		if (this.recycled)
			this.stageTime.reset();
		else
			this.stageTime = new cr.KahanAdder();
		this.maxOpacity = (this.inst.opacity ? this.inst.opacity : 1.0);
		if (active_at_start)
		{
			if (this.fadeInTime === 0)
			{
				this.stage = 1;
				if (this.waitTime === 0)
					this.stage = 2;
			}
			else
			{
				this.inst.opacity = 0;
				this.runtime.redraw = true;
			}
		}
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"fit": this.fadeInTime,
			"wt": this.waitTime,
			"fot": this.fadeOutTime,
			"s": this.stage,
			"st": this.stageTime.sum,
			"mo": this.maxOpacity,
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.fadeInTime = o["fit"];
		this.waitTime = o["wt"];
		this.fadeOutTime = o["fot"];
		this.stage = o["s"];
		this.stageTime.reset();
		this.stageTime.sum = o["st"];
		this.maxOpacity = o["mo"];
	};
	behinstProto.tick = function ()
	{
		this.stageTime.add(this.runtime.getDt(this.inst));
		if (this.stage === 0)
		{
			this.inst.opacity = (this.stageTime.sum / this.fadeInTime) * this.maxOpacity;
			this.runtime.redraw = true;
			if (this.inst.opacity >= this.maxOpacity)
			{
				this.inst.opacity = this.maxOpacity;
				this.stage = 1;	// wait stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 1)
		{
			if (this.stageTime.sum >= this.waitTime)
			{
				this.stage = 2;	// fade out stage
				this.stageTime.reset();
			}
		}
		if (this.stage === 2)
		{
			if (this.fadeOutTime !== 0)
			{
				this.inst.opacity = this.maxOpacity - ((this.stageTime.sum / this.fadeOutTime) * this.maxOpacity);
				this.runtime.redraw = true;
				if (this.inst.opacity < 0)
				{
					this.inst.opacity = 0;
					this.stage = 3;	// done
					this.stageTime.reset();
					this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd, this.inst);
					if (this.destroy === 1)
						this.runtime.DestroyInstance(this.inst);
				}
			}
		}
	};
	behinstProto.doStart = function ()
	{
		this.stage = 0;
		this.stageTime.reset();
		if (this.fadeInTime === 0)
		{
			this.stage = 1;
			if (this.waitTime === 0)
				this.stage = 2;
		}
		else
		{
			this.inst.opacity = 0;
			this.runtime.redraw = true;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnFadeOutEnd = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StartFade = function ()
	{
		if (this.stage === 3)
			this.doStart();
	};
	Acts.prototype.RestartFade = function ()
	{
		this.doStart();
	};
	behaviorProto.acts = new Acts();
}());
;
;
cr.behaviors.Flash = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Flash.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.ontime = 0;
		this.offtime = 0;
		this.stage = 0;			// 0 = on, 1 = off
		this.stagetimeleft = 0;
		this.timeleft = 0;
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"ontime": this.ontime,
			"offtime": this.offtime,
			"stage": this.stage,
			"stagetimeleft": this.stagetimeleft,
			"timeleft": this.timeleft
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.ontime = o["ontime"];
		this.offtime = o["offtime"];
		this.stage = o["stage"];
		this.stagetimeleft = o["stagetimeleft"];
		this.timeleft = o["timeleft"];
	};
	behinstProto.tick = function ()
	{
		if (this.timeleft <= 0)
			return;		// not flashing
		var dt = this.runtime.getDt(this.inst);
		this.timeleft -= dt;
		if (this.timeleft <= 0)
		{
			this.timeleft = 0;
			this.inst.visible = true;
			this.runtime.redraw = true;
			this.runtime.trigger(cr.behaviors.Flash.prototype.cnds.OnFlashEnded, this.inst);
			return;
		}
		this.stagetimeleft -= dt;
		if (this.stagetimeleft <= 0)
		{
			if (this.stage === 0)
			{
				this.inst.visible = false;
				this.stage = 1;
				this.stagetimeleft += this.offtime;
			}
			else
			{
				this.inst.visible = true;
				this.stage = 0;
				this.stagetimeleft += this.ontime;
			}
			this.runtime.redraw = true;
		}
	};
	function Cnds() {};
	Cnds.prototype.IsFlashing = function ()
	{
		return this.timeleft > 0;
	};
	Cnds.prototype.OnFlashEnded = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Flash = function (on_, off_, dur_)
	{
		this.ontime = on_;
		this.offtime = off_;
		this.stage = 1;		// always start off
		this.stagetimeleft = off_;
		this.timeleft = dur_;
		this.inst.visible = false;
		this.runtime.redraw = true;
	};
	Acts.prototype.StopFlashing = function ()
	{
		this.timeleft = 0;
		this.inst.visible = true;
		this.runtime.redraw = true;
		return;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Pin = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Pin.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.pinObject = null;
		this.pinObjectUid = -1;		// for loading
		this.pinAngle = 0;
		this.pinDist = 0;
		this.myStartAngle = 0;
		this.theirStartAngle = 0;
		this.lastKnownAngle = 0;
		this.mode = 0;				// 0 = position & angle; 1 = position; 2 = angle; 3 = rope; 4 = bar
		var self = this;
		if (!this.recycled)
		{
			this.myDestroyCallback = (function(inst) {
													self.onInstanceDestroyed(inst);
												});
		}
		this.runtime.addDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"uid": this.pinObject ? this.pinObject.uid : -1,
			"pa": this.pinAngle,
			"pd": this.pinDist,
			"msa": this.myStartAngle,
			"tsa": this.theirStartAngle,
			"lka": this.lastKnownAngle,
			"m": this.mode
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.pinObjectUid = o["uid"];		// wait until afterLoad to look up
		this.pinAngle = o["pa"];
		this.pinDist = o["pd"];
		this.myStartAngle = o["msa"];
		this.theirStartAngle = o["tsa"];
		this.lastKnownAngle = o["lka"];
		this.mode = o["m"];
	};
	behinstProto.afterLoad = function ()
	{
		if (this.pinObjectUid === -1)
			this.pinObject = null;
		else
		{
			this.pinObject = this.runtime.getObjectByUID(this.pinObjectUid);
;
		}
		this.pinObjectUid = -1;
	};
	behinstProto.onInstanceDestroyed = function (inst)
	{
		if (this.pinObject == inst)
			this.pinObject = null;
	};
	behinstProto.onDestroy = function()
	{
		this.pinObject = null;
		this.runtime.removeDestroyCallback(this.myDestroyCallback);
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.tick2 = function ()
	{
		if (!this.pinObject)
			return;
		if (this.lastKnownAngle !== this.inst.angle)
			this.myStartAngle = cr.clamp_angle(this.myStartAngle + (this.inst.angle - this.lastKnownAngle));
		var newx = this.inst.x;
		var newy = this.inst.y;
		if (this.mode === 3 || this.mode === 4)		// rope mode or bar mode
		{
			var dist = cr.distanceTo(this.inst.x, this.inst.y, this.pinObject.x, this.pinObject.y);
			if ((dist > this.pinDist) || (this.mode === 4 && dist < this.pinDist))
			{
				var a = cr.angleTo(this.pinObject.x, this.pinObject.y, this.inst.x, this.inst.y);
				newx = this.pinObject.x + Math.cos(a) * this.pinDist;
				newy = this.pinObject.y + Math.sin(a) * this.pinDist;
			}
		}
		else
		{
			newx = this.pinObject.x + Math.cos(this.pinObject.angle + this.pinAngle) * this.pinDist;
			newy = this.pinObject.y + Math.sin(this.pinObject.angle + this.pinAngle) * this.pinDist;
		}
		var newangle = cr.clamp_angle(this.myStartAngle + (this.pinObject.angle - this.theirStartAngle));
		this.lastKnownAngle = newangle;
		if ((this.mode === 0 || this.mode === 1 || this.mode === 3 || this.mode === 4)
			&& (this.inst.x !== newx || this.inst.y !== newy))
		{
			this.inst.x = newx;
			this.inst.y = newy;
			this.inst.set_bbox_changed();
		}
		if ((this.mode === 0 || this.mode === 2) && (this.inst.angle !== newangle))
		{
			this.inst.angle = newangle;
			this.inst.set_bbox_changed();
		}
	};
	function Cnds() {};
	Cnds.prototype.IsPinned = function ()
	{
		return !!this.pinObject;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Pin = function (obj, mode_)
	{
		if (!obj)
			return;
		var otherinst = obj.getFirstPicked(this.inst);
		if (!otherinst)
			return;
		this.pinObject = otherinst;
		this.pinAngle = cr.angleTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y) - otherinst.angle;
		this.pinDist = cr.distanceTo(otherinst.x, otherinst.y, this.inst.x, this.inst.y);
		this.myStartAngle = this.inst.angle;
		this.lastKnownAngle = this.inst.angle;
		this.theirStartAngle = otherinst.angle;
		this.mode = mode_;
	};
	Acts.prototype.Unpin = function ()
	{
		this.pinObject = null;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.PinnedUID = function (ret)
	{
		ret.set_int(this.pinObject ? this.pinObject.uid : -1);
	};
	behaviorProto.exps = new Exps();
}());
;
;
cr.behaviors.Rex_bNickname = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Rex_bNickname.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
	    this.set_nickname(this.properties[0]);
	};
	behinstProto.tick = function ()
	{
	};
	behinstProto.set_nickname = function (nickname)
	{
	    this.nickname = nickname;
	    if (cr.plugins_.Rex_Nickname == null)
		    return;
        if (cr.plugins_.Rex_Nickname.nickname2objtype[nickname] != null)
            return;
		cr.plugins_.Rex_Nickname.nickname2objtype[nickname] = {sid:this.inst.type.sid, index:-1};
	};
	function Cnds() {};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	behaviorProto.acts = new Acts();
	function Exps() {};
	behaviorProto.exps = new Exps();
	Exps.prototype.Nickname = function (ret)
	{
		ret.set_string(this.nickname);
	};
}());
;
;
cr.behaviors.destroy = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.destroy.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
	};
	behinstProto.tick = function ()
	{
		this.inst.update_bbox();
		var bbox = this.inst.bbox;
		var layout = this.inst.layer.layout;
		if (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height)
			this.runtime.DestroyInstance(this.inst);
	};
}());
;
;
cr.behaviors.scrollto = function(runtime)
{
	this.runtime = runtime;
	this.shakeMag = 0;
	this.shakeStart = 0;
	this.shakeEnd = 0;
	this.shakeMode = 0;
};
(function ()
{
	var behaviorProto = cr.behaviors.scrollto.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.enabled = (this.properties[0] !== 0);
	};
	behinstProto.saveToJSON = function ()
	{
		return {
			"smg": this.behavior.shakeMag,
			"ss": this.behavior.shakeStart,
			"se": this.behavior.shakeEnd,
			"smd": this.behavior.shakeMode
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.behavior.shakeMag = o["smg"];
		this.behavior.shakeStart = o["ss"];
		this.behavior.shakeEnd = o["se"];
		this.behavior.shakeMode = o["smd"];
	};
	behinstProto.tick = function ()
	{
	};
	function getScrollToBehavior(inst)
	{
		var i, len, binst;
		for (i = 0, len = inst.behavior_insts.length; i < len; ++i)
		{
			binst = inst.behavior_insts[i];
			if (binst.behavior instanceof cr.behaviors.scrollto)
				return binst;
		}
		return null;
	};
	behinstProto.tick2 = function ()
	{
		if (!this.enabled)
			return;
		var all = this.behavior.my_instances.valuesRef();
		var sumx = 0, sumy = 0;
		var i, len, binst, count = 0;
		for (i = 0, len = all.length; i < len; i++)
		{
			binst = getScrollToBehavior(all[i]);
			if (!binst || !binst.enabled)
				continue;
			sumx += all[i].x;
			sumy += all[i].y;
			++count;
		}
		var layout = this.inst.layer.layout;
		var now = this.runtime.kahanTime.sum;
		var offx = 0, offy = 0;
		if (now >= this.behavior.shakeStart && now < this.behavior.shakeEnd)
		{
			var mag = this.behavior.shakeMag * Math.min(this.runtime.timescale, 1);
			if (this.behavior.shakeMode === 0)
				mag *= 1 - (now - this.behavior.shakeStart) / (this.behavior.shakeEnd - this.behavior.shakeStart);
			var a = Math.random() * Math.PI * 2;
			var d = Math.random() * mag;
			offx = Math.cos(a) * d;
			offy = Math.sin(a) * d;
		}
		layout.scrollToX(sumx / count + offx);
		layout.scrollToY(sumy / count + offy);
	};
	function Acts() {};
	Acts.prototype.Shake = function (mag, dur, mode)
	{
		this.behavior.shakeMag = mag;
		this.behavior.shakeStart = this.runtime.kahanTime.sum;
		this.behavior.shakeEnd = this.behavior.shakeStart + dur;
		this.behavior.shakeMode = mode;
	};
	Acts.prototype.SetEnabled = function (e)
	{
		this.enabled = (e !== 0);
	};
	behaviorProto.acts = new Acts();
}());
cr.getProjectModel = function() { return [
	null,
	"Menu",
	[
	[
		cr.plugins_.Arr,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSAds,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Audio,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Browser,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Function,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Mouse,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Particles,
		false,
		true,
		true,
		false,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Sprite,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Tilemap,
		false,
		true,
		true,
		true,
		false,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Spritefont2,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Text,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.Touch,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Rex_Nickname,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.WebStorage,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
	],
	[
	[
		"t0",
		cr.plugins_.Sprite,
		false,
		[2234285965267135],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			656334856467047,
			[
				["logo-sheet0.png", 30981, 0, 0, 256, 131, 1, 0.51171875, 0.4198473393917084,[],[-0.46484375,-0.3282442390918732,0.4375002384185791,-0.3206107318401337,0.4375002384185791,0.07633566856384277,0.34765625,0.3053436577320099,-0.01171875,0.5496186017990112,-0.3476557433605194,0.2595416605472565,-0.48046875,0.07633566856384277],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			985527803863962
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			9643134195289972
		]
		],
		false,
		false,
		1001639834380976,
		[],
		null
	]
,	[
		"t1",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8650057660384638,
			[
				["backgroundmenue-sheet0.png", 247988, 0, 0, 512, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		8206824694669842,
		[],
		null
	]
,	[
		"t2",
		cr.plugins_.Text,
		false,
		[2510080659259072],
		3,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			6193013892792657
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			7976522225113086
		]
,		[
			"Flash",
			cr.behaviors.Flash,
			1458273119956071
		]
		],
		false,
		false,
		5672043612879747,
		[],
		null
	]
,	[
		"t3",
		cr.plugins_.Touch,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9740569570841854,
		[],
		null
		,[1]
	]
,	[
		"t4",
		cr.plugins_.Browser,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		7771559254674431,
		[],
		null
		,[]
	]
,	[
		"t5",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			75453374448434,
			[
				["backgroundmainmenu-sheet0.png", 175031, 0, 0, 512, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		8602045915736699,
		[],
		null
	]
,	[
		"t6",
		cr.plugins_.Sprite,
		false,
		[7518374006690707,4837224252182338],
		1,
		0,
		null,
		[
			[
			"Menu",
			0,
			false,
			1,
			0,
			false,
			7840498127183205,
			[
				["menubuttons-sheet0.png", 395537, 775, 259, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.078125,-0.2421869933605194,-0.453125,0.4453129768371582,-0.3359369933605194,0.3515629768371582,0.3515629768371582,0.0703129768371582,0.4453129768371582,-0.3125,0.3125],0],
				["menubuttons-sheet0.png", 395537, 775, 1, 128, 256, 1, 0.5, 0.5,[],[-0.453125,-0.4140625,0.296875,-0.4609374105930328,0.2578129768371582,0,0.265625,0.3554689884185791,-0.4531244933605194,0.265625,-0.4609375,0],0],
				["menubuttons-sheet0.png", 395537, 1, 1, 256, 256, 1, 0.5, 0.5,[],[-0.4756636917591095,-0.47516930103302,-0.1054689884185791,-0.4609025120735169,0.4347350001335144,-0.2824310064315796,0.4446899890899658,-0.001129001379013062,0.4601079821586609,0.2928540110588074,0.0625,0.2544980049133301,-0.4681277871131897,0.2560669779777527,-0.4734512865543366,-0.001129001379013062],0],
				["menubuttons-sheet0.png", 395537, 259, 1, 256, 256, 1, 0.5, 0.5,[],[-0.4756636917591095,-0.47516930103302,-0.0898439884185791,-0.4726212024688721,0.4659850001335144,-0.2668060064315796,0.4446899890899658,-0.001129001379013062,0.4679200053215027,0.3006669878959656,0.015625,0.242779016494751,-0.4642215073108673,0.2170040011405945,-0.4734512865543366,-0.001129001379013062],0],
				["menubuttons-sheet0.png", 395537, 517, 1, 256, 256, 1, 0.5, 0.5,[],[-0.4756636917591095,-0.47516930103302,-0.0898439884185791,-0.4374650120735169,0.4581729769706726,-0.2707130014896393,0.4446899890899658,-0.001129001379013062,0.4562010169029236,0.3123850226402283,0.007812976837158203,0.2154350280761719,-0.4720340073108673,0.2209110260009766,-0.4734512865543366,-0.001129001379013062],0]
			]
			]
,			[
			"Normal",
			10,
			true,
			1,
			0,
			false,
			9479824003801827,
			[
				["menubuttons-sheet0.png", 395537, 1, 259, 256, 256, 1, 0.48828125, 0.80859375,[],[-0.2617182433605194,-0.5820307731628418,0.01171875,-0.4921877384185791,0.13671875,-0.43359375,0.3164067268371582,-0.30859375,0.3007817268371582,-0.0195307731628418,0.01171875,0.0703122615814209,-0.2929682433605194,-0.003905773162841797,-0.36328125,-0.30859375],0]
			]
			]
,			[
			"Mecha",
			10,
			true,
			1,
			0,
			false,
			1540530913126897,
			[
				["menubuttons-sheet0.png", 395537, 259, 259, 256, 256, 1, 0.734375, 0.8984375,[],[-0.234375,-0.8046875,0.09375,-0.7265625,0.1445310115814209,-0.3984375,0.140625,-0.0234375,-0.234375,-0.003906488418579102,-0.2539060115814209,-0.3789064884185791,-0.5625,-0.3984375],0]
			]
			]
,			[
			"Rainbow",
			10,
			true,
			1,
			0,
			false,
			8561380841192673,
			[
				["menubuttons-sheet0.png", 395537, 517, 259, 256, 256, 1, 0.49609375, 0.8515625,[],[-0.2851557433605194,-0.7460935115814209,0.0703122615814209,-0.7890625,0.45703125,-0.6679685115814209,0.2812502384185791,4.76837158203125e-007,-0.1093747615814209,0.0664064884185791,-0.4042968451976776,-0.04882848262786865],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			2271916453414972
		]
		],
		false,
		false,
		2637158126336333,
		[],
		null
	]
,	[
		"t7",
		cr.plugins_.Sprite,
		false,
		[7439111997058668,9271798949410333],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4066799163409899,
			[
				["buygold-sheet0.png", 8285, 0, 0, 205, 117, 1, 0.502439022064209, 0.504273533821106,[],[-0.4585366249084473,-0.4273504316806793,-0.004878014326095581,-0.4615385234355927,0.4536589980125427,-0.4273504316806793,0.4634149670600891,-0.008547544479370117,0.4487800002098084,0.4102564454078674,-0.004878014326095581,0.4358974695205689,-0.4536585211753845,0.4102564454078674],0]
			]
			]
		],
		[
		],
		false,
		false,
		9033232872502047,
		[],
		null
	]
,	[
		"t8",
		cr.plugins_.Sprite,
		false,
		[5092797025583134],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4973874531923969,
			[
				["coin-sheet0.png", 14607, 1, 1, 64, 64, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.390625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.390625,0],0]
			]
			]
,			[
			"dropped",
			10,
			true,
			1,
			0,
			false,
			5298603460416993,
			[
				["coin-sheet0.png", 14607, 67, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 133, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 1, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 67, 67, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2809450830969579
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			7184774604687533
		]
		],
		false,
		false,
		6973252051556268,
		[],
		null
	]
,	[
		"t9",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3564695090129136,
			[
				["confirmyes-sheet0.png", 5817, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.4921875,0.4609379768371582,-0.4609375,0.4921879768371582,0,0.46875,0.46875,0,0.5,-0.4609375,0.4609379768371582,-0.4921875,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		333515654531097,
		[],
		null
	]
,	[
		"t10",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4287985715029749,
			[
				["backbutton-sheet0.png", 5793, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.4921875,0.4609379768371582,-0.4609375,0.4921879768371582,0,0.46875,0.46875,0,0.5,-0.4609375,0.4609379768371582,-0.4921875,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1802159228219037,
		[],
		null
	]
,	[
		"t11",
		cr.plugins_.Function,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		5187951044771408,
		[],
		null
		,[]
	]
,	[
		"t12",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			1663069302931154,
			[
				["background_1-sheet0.png", 120787, 1, 1, 246, 118, 1, 0, 0,[],[],0],
				["background_1-sheet0.png", 120787, 1, 1, 246, 118, 1, 0, 0,[],[],0],
				["background_1-sheet0.png", 120787, 1, 121, 246, 118, 1, 0, 0,[],[],0],
				["background_1-sheet1.png", 87818, 1, 1, 246, 118, 1, 0, 0,[],[],0],
				["background_1-sheet1.png", 87818, 1, 121, 246, 118, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6822950552792443,
		[],
		null
	]
,	[
		"t13",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5522353220851033,
			[
				["movebar-sheet0.png", 1685, 0, 0, 32, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		5785159433236946,
		[],
		null
	]
,	[
		"t14",
		cr.plugins_.Sprite,
		false,
		[],
		4,
		0,
		null,
		[
			[
			"Idle_Normal",
			20,
			true,
			1,
			0,
			false,
			1686373360174689,
			[
				["player-sheet0.png", 387012, 1, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player-sheet0.png", 387012, 259, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player-sheet0.png", 387012, 517, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0]
			]
			]
,			[
			"Shoot_Normal",
			20,
			true,
			1,
			0,
			false,
			6133416492132742,
			[
				["player-sheet0.png", 387012, 1, 131, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1093747615814209,-0.2187494933605194,0.1835942268371582,-0.1796875,0.2421872615814209,0.2656254768371582,-0.2499997466802597,0.1562504768371582],0],
				["player-sheet0.png", 387012, 259, 131, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1093747615814209,-0.2187494933605194,0.1835942268371582,-0.1796875,0.2421872615814209,0.2656254768371582,-0.2499997466802597,0.1562504768371582],0],
				["player-sheet0.png", 387012, 517, 131, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1093747615814209,-0.2187494933605194,0.1835942268371582,-0.1796875,0.2421872615814209,0.2656254768371582,-0.2499997466802597,0.1562504768371582],0]
			]
			]
,			[
			"Rocket_Normal",
			20,
			true,
			1,
			0,
			false,
			2267901824648111,
			[
				["player-sheet0.png", 387012, 1, 261, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.84765625, 0.1640625]],[-0.15234375,-0.1874994933605194,0.1992192268371582,-0.2421875,0.2539061903953552,0.2109375,-0.2343747466802597,0.1484375],0],
				["player-sheet0.png", 387012, 259, 261, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.84765625, 0.1640625]],[-0.15234375,-0.1874994933605194,0.1992192268371582,-0.2421875,0.2539061903953552,0.2109375,-0.2343747466802597,0.1484375],0],
				["player-sheet0.png", 387012, 517, 261, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.84765625, 0.1640625]],[-0.15234375,-0.1874994933605194,0.1992192268371582,-0.2421875,0.2539061903953552,0.2109375,-0.2343747466802597,0.1484375],0]
			]
			]
,			[
			"Revolver_Normal",
			20,
			true,
			1,
			0,
			false,
			7097326922508388,
			[
				["player-sheet0.png", 387012, 1, 391, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.8359375, 0.328125]],[-0.1289057433605194,-0.2031244933605194,0.2148442268371582,-0.1640625,0.2539061903953552,0.2656254768371582,-0.2382807433605194,0.1640625],0],
				["player-sheet0.png", 387012, 259, 391, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.8359375, 0.328125]],[-0.1289057433605194,-0.2031244933605194,0.2148442268371582,-0.1640625,0.2539061903953552,0.2656254768371582,-0.2382807433605194,0.1640625],0],
				["player-sheet0.png", 387012, 517, 391, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.8359375, 0.328125]],[-0.1289057433605194,-0.2031244933605194,0.2148442268371582,-0.1640625,0.2539061903953552,0.2656254768371582,-0.2382807433605194,0.1640625],0]
			]
			]
,			[
			"Shotgun_Normal",
			20,
			true,
			1,
			0,
			false,
			161564750840089,
			[
				["player-sheet0.png", 387012, 1, 521, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.828125, 0.2734375]],[-0.1289057433605194,-0.1953125,0.1835942268371582,-0.1796875,0.2500002384185791,0.2578125,-0.24609375,0.1875004768371582],0],
				["player-sheet0.png", 387012, 259, 521, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.828125, 0.2734375]],[-0.1289057433605194,-0.1953125,0.1835942268371582,-0.1796875,0.2500002384185791,0.2578125,-0.24609375,0.1875004768371582],0],
				["player-sheet0.png", 387012, 517, 521, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.828125, 0.2734375]],[-0.1289057433605194,-0.1953125,0.1835942268371582,-0.1796875,0.2500002384185791,0.2578125,-0.24609375,0.1875004768371582],0]
			]
			]
,			[
			"Boost_Normal",
			20,
			true,
			1,
			0,
			false,
			9441579676297819,
			[
				["player-sheet0.png", 387012, 1, 651, 256, 128, 1, 0.43359375, 0.5078125,[],[-0.18359375,-0.04687449336051941,0.1171872615814209,-0.2109375,0.31640625,0.0546875,-0.19921875,0.3359375],0],
				["player-sheet0.png", 387012, 259, 651, 256, 128, 1, 0.43359375, 0.5078125,[],[-0.18359375,-0.04687449336051941,0.1171872615814209,-0.2109375,0.31640625,0.0546875,-0.19921875,0.3359375],0],
				["player-sheet0.png", 387012, 517, 651, 256, 128, 1, 0.43359375, 0.5078125,[],[-0.18359375,-0.04687449336051941,0.1171872615814209,-0.2109375,0.31640625,0.0546875,-0.19921875,0.3359375],0]
			]
			]
,			[
			"Dead_Normal",
			10,
			false,
			1,
			0,
			false,
			7419520473171224,
			[
				["player-sheet0.png", 387012, 1, 781, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player-sheet0.png", 387012, 259, 781, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0]
			]
			]
,			[
			"Idle_Mecha",
			20,
			true,
			1,
			0,
			false,
			253127344234182,
			[
				["player-sheet0.png", 387012, 517, 781, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player-sheet1.png", 451951, 1, 1, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player-sheet1.png", 451951, 259, 1, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0]
			]
			]
,			[
			"Shoot_Mecha",
			20,
			true,
			1,
			0,
			false,
			3947180533156251,
			[
				["player-sheet1.png", 451951, 517, 1, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1367182433605194,-0.0234375,0.1093747615814209,-0.2578125,0.2343747615814209,-0.0078125,-0.0859372615814209,0.2968754768371582],0],
				["player-sheet1.png", 451951, 1, 131, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1367182433605194,-0.0234375,0.1093747615814209,-0.2578125,0.2343747615814209,-0.0078125,-0.0859372615814209,0.2968754768371582],0],
				["player-sheet1.png", 451951, 259, 131, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1367182433605194,-0.0234375,0.1093747615814209,-0.2578125,0.2343747615814209,-0.0078125,-0.0859372615814209,0.2968754768371582],0]
			]
			]
,			[
			"Rocket_Mecha",
			20,
			true,
			1,
			0,
			false,
			7151332268432243,
			[
				["player-sheet1.png", 451951, 517, 131, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.85546875, 0.2734375]],[-0.14453125,-0.03124949336051941,0.07421875,-0.3046875,0.2695317268371582,0.0078125,-0.06640625,0.3359375],0],
				["player-sheet1.png", 451951, 1, 261, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.85546875, 0.2734375]],[-0.14453125,-0.03124949336051941,0.07421875,-0.3046875,0.2695317268371582,0.0078125,-0.06640625,0.3359375],0],
				["player-sheet1.png", 451951, 259, 261, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.85546875, 0.2734375]],[-0.14453125,-0.03124949336051941,0.07421875,-0.3046875,0.2695317268371582,0.0078125,-0.06640625,0.3359375],0]
			]
			]
,			[
			"Revolver_Mecha",
			20,
			true,
			1,
			0,
			false,
			857205718489396,
			[
				["player-sheet1.png", 451951, 517, 261, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.828125, 0.375]],[-0.1523432433605194,-0.03124949336051941,0.08984375,-0.2812494933605194,0.23046875,-0.0234375,-0.07421824336051941,0.2968754768371582],0],
				["player-sheet1.png", 451951, 1, 391, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.828125, 0.375]],[-0.1523432433605194,-0.03124949336051941,0.08984375,-0.2812494933605194,0.23046875,-0.0234375,-0.07421824336051941,0.2968754768371582],0],
				["player-sheet1.png", 451951, 259, 391, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.828125, 0.375]],[-0.1523432433605194,-0.03124949336051941,0.08984375,-0.2812494933605194,0.23046875,-0.0234375,-0.07421824336051941,0.2968754768371582],0]
			]
			]
,			[
			"Shotgun_Mecha",
			20,
			true,
			1,
			0,
			false,
			5233075078633535,
			[
				["player-sheet1.png", 451951, 517, 391, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.90234375, 0.3203125]],[-0.1406252384185791,-0.01562449336051941,0.0937497615814209,-0.3046875,0.2617186903953552,0.0234375,-0.09765625,0.3437504768371582],0],
				["player-sheet1.png", 451951, 1, 521, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.90234375, 0.3203125]],[-0.1406252384185791,-0.01562449336051941,0.0937497615814209,-0.3046875,0.2617186903953552,0.0234375,-0.09765625,0.3437504768371582],0],
				["player-sheet1.png", 451951, 259, 521, 256, 128, 1, 0.42578125, 0.3828125,[["Imagepoint 1", 0.90234375, 0.3203125]],[-0.1406252384185791,-0.01562449336051941,0.0937497615814209,-0.3046875,0.2617186903953552,0.0234375,-0.09765625,0.3437504768371582],0]
			]
			]
,			[
			"Boost_Mecha",
			20,
			true,
			1,
			0,
			false,
			5694226133540266,
			[
				["player-sheet0.png", 387012, 517, 781, 256, 128, 1, 0.46484375, 0.390625,[],[-0.18359375,0.046875,0.16015625,-0.25,0.1210942268371582,0.25,-0.0468747615814209,0.3203129768371582],0],
				["player-sheet1.png", 451951, 1, 1, 256, 128, 1, 0.46484375, 0.390625,[],[-0.18359375,0.046875,0.16015625,-0.25,0.1210942268371582,0.25,-0.0468747615814209,0.3203129768371582],0],
				["player-sheet1.png", 451951, 259, 1, 256, 128, 1, 0.46484375, 0.390625,[],[-0.18359375,0.046875,0.16015625,-0.25,0.1210942268371582,0.25,-0.0468747615814209,0.3203129768371582],0]
			]
			]
,			[
			"Dead_Mecha",
			10,
			false,
			1,
			0,
			false,
			4775650549883917,
			[
				["player-sheet1.png", 451951, 517, 521, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player-sheet1.png", 451951, 1, 651, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0]
			]
			]
,			[
			"Idle_Rainbow",
			20,
			true,
			1,
			0,
			false,
			5883265210696697,
			[
				["player-sheet1.png", 451951, 259, 651, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player-sheet1.png", 451951, 517, 651, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player-sheet1.png", 451951, 1, 781, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0]
			]
			]
,			[
			"Shoot_Rainbow",
			20,
			true,
			1,
			0,
			false,
			7850859277107231,
			[
				["player-sheet1.png", 451951, 259, 781, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0625002384185791,-0.2734375,0.2734377384185791,-0.1953125,0.15234375,0.3828125,-0.2343752533197403,0.3359375],0],
				["player-sheet1.png", 451951, 517, 781, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0625002384185791,-0.2734375,0.2734377384185791,-0.1953125,0.15234375,0.3828125,-0.2343752533197403,0.3359375],0],
				["player-sheet2.png", 478657, 1, 1, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0625002384185791,-0.2734375,0.2734377384185791,-0.1953125,0.15234375,0.3828125,-0.2343752533197403,0.3359375],0]
			]
			]
,			[
			"Rocket_Rainbow",
			20,
			true,
			1,
			0,
			false,
			1424383375340712,
			[
				["player-sheet2.png", 478657, 259, 1, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8828125, 0.2109375]],[-0.05859324336051941,-0.3046875,0.3203127384185791,-0.2265625,0.1406247615814209,0.3750004768371582,-0.2421872466802597,0.3515625],0],
				["player-sheet2.png", 478657, 517, 1, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8828125, 0.2109375]],[-0.05859324336051941,-0.3046875,0.3203127384185791,-0.2265625,0.1406247615814209,0.3750004768371582,-0.2421872466802597,0.3515625],0],
				["player-sheet2.png", 478657, 1, 131, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8828125, 0.2109375]],[-0.05859324336051941,-0.3046875,0.3203127384185791,-0.2265625,0.1406247615814209,0.3750004768371582,-0.2421872466802597,0.3515625],0]
			]
			]
,			[
			"Revolver_Rainbow",
			20,
			true,
			1,
			0,
			false,
			9831315269753324,
			[
				["player-sheet2.png", 478657, 259, 131, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8125, 0.3125]],[-0.08203125,-0.3124994933605194,0.3320317268371582,-0.2109375,0.1328127384185791,0.3593754768371582,-0.22265625,0.3593754768371582],0],
				["player-sheet2.png", 478657, 517, 131, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8125, 0.3125]],[-0.08203125,-0.3124994933605194,0.3320317268371582,-0.2109375,0.1328127384185791,0.3593754768371582,-0.22265625,0.3593754768371582],0],
				["player-sheet2.png", 478657, 1, 261, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8125, 0.3125]],[-0.08203125,-0.3124994933605194,0.3320317268371582,-0.2109375,0.1328127384185791,0.3593754768371582,-0.22265625,0.3593754768371582],0]
			]
			]
,			[
			"Shotgun_Rainbow",
			20,
			true,
			1,
			0,
			false,
			9095442856244262,
			[
				["player-sheet2.png", 478657, 259, 261, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8671875, 0.25]],[-0.0625002384185791,-0.2968744933605194,0.3476567268371582,-0.1796875,0.1640627384185791,0.3593754768371582,-0.2148432433605194,0.3437504768371582],0],
				["player-sheet2.png", 478657, 517, 261, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8671875, 0.25]],[-0.0625002384185791,-0.2968744933605194,0.3476567268371582,-0.1796875,0.1640627384185791,0.3593754768371582,-0.2148432433605194,0.3437504768371582],0],
				["player-sheet2.png", 478657, 1, 391, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.8671875, 0.25]],[-0.0625002384185791,-0.2968744933605194,0.3476567268371582,-0.1796875,0.1640627384185791,0.3593754768371582,-0.2148432433605194,0.3437504768371582],0]
			]
			]
,			[
			"Boost_Rainbow",
			20,
			true,
			1,
			0,
			false,
			5014948774711783,
			[
				["player-sheet2.png", 478657, 259, 391, 256, 128, 1, 0.36328125, 0.4609375,[],[-0.08984324336051941,-0.2578125,0.3203127384185791,-0.3515625,0.19921875,0.2890625,-0.17578125,0.4531254768371582],0],
				["player-sheet2.png", 478657, 517, 391, 256, 128, 1, 0.36328125, 0.4609375,[],[-0.08984324336051941,-0.2578125,0.3203127384185791,-0.3515625,0.19921875,0.2890625,-0.17578125,0.4531254768371582],0],
				["player-sheet2.png", 478657, 1, 521, 256, 128, 1, 0.36328125, 0.4609375,[],[-0.08984324336051941,-0.2578125,0.3203127384185791,-0.3515625,0.19921875,0.2890625,-0.17578125,0.4531254768371582],0]
			]
			]
,			[
			"Dead_Rainbow",
			10,
			false,
			1,
			0,
			false,
			8633935316923826,
			[
				["player-sheet2.png", 478657, 259, 521, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player-sheet2.png", 478657, 517, 521, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0]
			]
			]
		],
		[
		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			2438484034315576
		]
,		[
			"Bullet",
			cr.behaviors.Bullet,
			729256512126325
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			3001453137365819
		]
,		[
			"Flash",
			cr.behaviors.Flash,
			1684971308936503
		]
		],
		false,
		false,
		5804541699193957,
		[],
		null
	]
,	[
		"t15",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1140039872640573,
			[
				["pausebutton-sheet0.png", 1019, 0, 0, 118, 118, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7993652899333441,
		[],
		null
	]
,	[
		"t16",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			686845701689097,
			[
				["shootbutton-sheet0.png", 2926, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.34375,-0.34375,0,-0.484375,0.34375,-0.34375,0.4921879768371582,0,0.3515629768371582,0.3515629768371582,0,0.4921879768371582,-0.34375,0.34375,-0.484375,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		8720201340204122,
		[],
		null
	]
,	[
		"t17",
		cr.plugins_.Sprite,
		false,
		[9962807133177501],
		2,
		0,
		null,
		[
			[
			"Default_Normal",
			0,
			false,
			1,
			0,
			false,
			774953417863779,
			[
				["projectile-sheet0.png", 55623, 131, 1, 88, 36, 1, 0.1590909063816071, 0.5,[["Imagepoint 1", 0.8522727489471436, 0.5]],[0.01136408746242523,-0.08333298563957214,0.3409090936183929,-0.25,0.6704541444778442,-0.08333298563957214,0.6818181276321411,0,0.6704541444778442,0.08333301544189453,0.3409090936183929,0.25,0.01136408746242523,0.08333301544189453,8.940696716308594e-008,0],0]
			]
			]
,			[
			"Charged_Normal",
			5,
			true,
			1,
			0,
			false,
			8959782619108809,
			[
				["projectile-sheet0.png", 55623, 1, 1, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0],
				["projectile-sheet1.png", 27129, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0]
			]
			]
,			[
			"Revolver_Normal",
			0,
			false,
			1,
			0,
			false,
			5474754460700715,
			[
				["projectile-sheet0.png", 55623, 1, 183, 128, 8, 1, 0.03125, 0.5,[["Imagepoint 1", 1, 0.5]],[],0]
			]
			]
,			[
			"Shotgun_Normal",
			0,
			false,
			1,
			0,
			false,
			2738714541962798,
			[
				["projectile-sheet0.png", 55623, 131, 111, 64, 16, 1, -0.03125, 0.5,[["Imagepoint 1", 1.03125, 0.625]],[],0]
			]
			]
,			[
			"Rocket_Normal",
			0,
			true,
			1,
			0,
			false,
			6599354286798831,
			[
				["projectile-sheet0.png", 55623, 1, 131, 205, 32, 1, 0.502439022064209, 0.5,[],[-0.502439022064209,-0.5,0.497560977935791,-0.5,0.497560977935791,0.453125,-0.502439022064209,0.5],0]
			]
			]
,			[
			"Default_Mecha",
			0,
			true,
			1,
			0,
			false,
			3825676101752021,
			[
				["projectile-sheet0.png", 55623, 131, 39, 88, 36, 1, 0.1363636404275894, 0.5,[["Imagepoint 1", 0.8636363744735718, 0.5]],[0.004261359572410584,-0.21875,0.3636363744735718,-0.4375,0.7230113744735718,-0.21875,0.7855113744735718,0,0.7230113744735718,0.21875,0.3636363744735718,0.4374999403953552,0.004261359572410584,0.21875,-0.05823864042758942,0],0]
			]
			]
,			[
			"Charged_Mecha",
			5,
			true,
			1,
			0,
			false,
			7381547427744056,
			[
				["projectile-sheet0.png", 55623, 1, 1, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0],
				["projectile-sheet1.png", 27129, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0]
			]
			]
,			[
			"Revolver_Mecha",
			0,
			false,
			1,
			0,
			false,
			1069225293634228,
			[
				["projectile-sheet0.png", 55623, 1, 165, 128, 16, 1, 0.03125, 0.5,[["Imagepoint 1", 1.015625, 0.625]],[],0]
			]
			]
,			[
			"Shotgun_Mecha",
			0,
			false,
			1,
			0,
			false,
			1352732930822451,
			[
				["projectile-sheet0.png", 55623, 131, 192, 64, 16, 1, -0.0625, 0.5625,[["Imagepoint 1", 1, 0.4375]],[],0]
			]
			]
,			[
			"Rocket_Mecha",
			0,
			true,
			1,
			0,
			false,
			1065028838039617,
			[
				["projectile-sheet0.png", 55623, 1, 131, 205, 32, 1, 0.502439022064209, 0.5,[],[],0]
			]
			]
,			[
			"Default_Rainbow",
			0,
			false,
			1,
			0,
			false,
			2884348843245549,
			[
				["projectile-sheet0.png", 55623, 131, 165, 64, 25, 1, -0.015625, 0.4799999892711639,[["Imagepoint 1", 1.03125, 0.5199999809265137]],[],0]
			]
			]
,			[
			"Charged_Rainbow",
			5,
			true,
			1,
			0,
			false,
			3739128768302295,
			[
				["projectile-sheet2.png", 27128, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0],
				["projectile-sheet1.png", 27129, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3100000023841858,-0.3100000023841858,0,-0.4350000023841858,0.3050000071525574,-0.3050000071525574,0.4350000023841858,0,0.3100000023841858,0.3100000023841858,0,0.4399999976158142,-0.3100000023841858,0.3100000023841858,-0.4399999976158142,0],0]
			]
			]
,			[
			"Revolver_Rainbow",
			0,
			false,
			1,
			0,
			false,
			1578060587476702,
			[
				["projectile-sheet0.png", 55623, 131, 77, 64, 32, 1, 0.046875, 0.53125,[["Imagepoint 1", 1, 0.53125]],[],0]
			]
			]
,			[
			"Shotgun_Rainbow",
			0,
			false,
			1,
			0,
			false,
			7805047047618809,
			[
				["projectile-sheet0.png", 55623, 1, 193, 64, 16, 1, -0.0625, 0.5,[["Imagepoint 1", 1.0625, 0.5]],[],0]
			]
			]
,			[
			"Rocket_Rainbow",
			0,
			true,
			1,
			0,
			false,
			8068146178002534,
			[
				["projectile-sheet0.png", 55623, 1, 131, 205, 32, 1, 0.502439022064209, 0.5,[],[],0]
			]
			]
,			[
			"Orbs_Normal",
			0,
			false,
			1,
			0,
			false,
			1131644621324706,
			[
				["projectile-sheet0.png", 55623, 67, 210, 64, 8, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			5412593061061037
		]
,		[
			"Bullet",
			cr.behaviors.Bullet,
			8831208337832974
		]
		],
		false,
		false,
		5141728146565069,
		[],
		null
	]
,	[
		"t18",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			8687211294018273,
			[
				["enemy_exploder_1-sheet0.png", 24358, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2734369933605194,-0.375,0.171875,-0.4453125,0.2734379768371582,0.2734379768371582,-0.296875,0.3515629768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			7252982384544884,
			[
				["enemy_exploder_1-sheet1.png", 17888, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2734369933605194,-0.375,0.171875,-0.4453125,0.2734379768371582,0.2734379768371582,-0.296875,0.3515629768371582],0],
				["enemy_exploder_1-sheet2.png", 3145, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2734369933605194,-0.375,0.171875,-0.4453125,0.2734379768371582,0.2734379768371582,-0.296875,0.3515629768371582],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			9385419695771355
		]
		],
		false,
		false,
		3249571780415203,
		[],
		null
	]
,	[
		"t19",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			20,
			true,
			1,
			0,
			false,
			5210359092090384,
			[
				["enemy_shooter_1-sheet0.png", 268346, 1, 1, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 249, 1, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 1, 121, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 249, 121, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 1, 241, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			8273385130439953,
			[
				["enemy_shooter_1-sheet0.png", 268346, 249, 241, 246, 118, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.2542372941970825]],[-0.4179686903953552,-0.2734369933605194,0.0898439884185791,-0.4296875,0.4257810115814209,0.3046879768371582,-0.1875,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 1, 361, 246, 118, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.2542372941970825]],[-0.4179686903953552,-0.2734369933605194,0.0898439884185791,-0.4296875,0.4257810115814209,0.3046879768371582,-0.1875,0.3671879768371582],0],
				["enemy_shooter_1-sheet0.png", 268346, 249, 361, 246, 118, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.2542372941970825]],[-0.4179686903953552,-0.2734369933605194,0.0898439884185791,-0.4296875,0.4257810115814209,0.3046879768371582,-0.1875,0.3671879768371582],0],
				["enemy_shooter_1-sheet1.png", 112667, 1, 1, 246, 118, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.2542372941970825]],[-0.4179686903953552,-0.2734369933605194,0.0898439884185791,-0.4296875,0.4257810115814209,0.3046879768371582,-0.1875,0.3671879768371582],0],
				["enemy_shooter_1-sheet1.png", 112667, 249, 1, 246, 118, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.2542372941970825]],[-0.4179686903953552,-0.2734369933605194,0.0898439884185791,-0.4296875,0.4257810115814209,0.3046879768371582,-0.1875,0.3671879768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			531630225711988,
			[
				["enemy_shooter_1-sheet1.png", 112667, 1, 121, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0],
				["enemy_shooter_1-sheet1.png", 112667, 249, 121, 246, 118, 1, 0.5, 0.5,[],[-0.4023436903953552,-0.296875,0.0898439884185791,-0.4453125,0.3320310115814209,0.2421879768371582,-0.1523439884185791,0.3671879768371582],0]
			]
			]
		],
		[
		],
		false,
		false,
		1913213135773023,
		[],
		null
	]
,	[
		"t20",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			1201821859987956,
			[
				["enemy_solid_1-sheet0.png", 25790, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2265619933605194,-0.3671869933605194,0.265625,-0.4296875,0.1874999403953552,0.421875,-0.375,0.21875],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			7463798392310096,
			[
				["enemy_solid_1-sheet1.png", 20215, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2265619933605194,-0.3671869933605194,0.265625,-0.4296875,0.1874999403953552,0.421875,-0.375,0.21875],0],
				["enemy_solid_1-sheet2.png", 5513, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2265619933605194,-0.3671869933605194,0.265625,-0.4296875,0.1874999403953552,0.421875,-0.375,0.21875],0]
			]
			]
		],
		[
		],
		false,
		false,
		1278576335392678,
		[],
		null
	]
,	[
		"t21",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Normal",
			5,
			false,
			1,
			0,
			false,
			1373708211585368,
			[
				["muzzlefire-sheet0.png", 3371, 0, 0, 62, 37, 1, 0.1290322542190552, 0.5675675868988037,[],[0.2822587490081787,-0.2837826013565064,0.4032257199287415,-0.270270586013794,0.4999997615814209,-0.2432435750961304,0.7741937637329102,-0.08108159899711609,0.4032257199287415,0.2162163853645325,0.2338717579841614,0.2027034163475037,-0.008064255118370056,-0.08108159899711609],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7623294859690213
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			375458332378685
		]
		],
		false,
		false,
		2474090974435301,
		[],
		null
	]
,	[
		"t22",
		cr.plugins_.Sprite,
		false,
		[2461455045012892],
		1,
		0,
		null,
		[
			[
			"Default",
			10,
			false,
			1,
			0,
			false,
			6599677259807252,
			[
				["rocketdestroyenemy-sheet0.png", 37088, 1, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 67, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 133, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 1, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 67, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 133, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 1, 133, 64, 64, 1, 0.5, 0.5,[],[],0],
				["rocketdestroyenemy-sheet0.png", 37088, 67, 133, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			6598158025638605
		]
		],
		false,
		false,
		3028479476734489,
		[],
		null
	]
,	[
		"t23",
		cr.plugins_.Sprite,
		false,
		[5568685262997647],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5628876220923283,
			[
				["collisionhelper-sheet0.png", 391, 0, 0, 120, 60, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7653032811855359
		]
		],
		false,
		false,
		1564448105600794,
		[],
		null
	]
,	[
		"t24",
		cr.plugins_.Sprite,
		false,
		[2916688956921758],
		2,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			8863049169463006,
			[
				["healthbar-sheet0.png", 343, 1, 1, 64, 16, 1, 0, 0,[],[0.02962959930300713,0.1923079937696457,0.9629629850387573,0.1923079937696457,0.9629629850387573,0.8076919913291931,0.02962959930300713,0.8076919913291931],0],
				["healthbar-sheet0.png", 343, 1, 19, 64, 16, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			9135517528183443
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			7819788220334478
		]
		],
		false,
		false,
		1392186114984435,
		[],
		null
	]
,	[
		"t25",
		cr.plugins_.Sprite,
		false,
		[3464120847041606,6210031047786964,7781717888966151],
		0,
		0,
		null,
		[
			[
			"normal",
			10,
			true,
			1,
			0,
			false,
			6831612303972016,
			[
				["ammo_1-sheet0.png", 137292, 1, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 113, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"rainbow",
			10,
			true,
			1,
			0,
			false,
			8094026109600627,
			[
				["ammo_1-sheet0.png", 137292, 121, 113, 118, 54, 1, 0.5, 0.4074074029922485,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 225, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"mecha",
			10,
			true,
			1,
			0,
			false,
			3740507235005259,
			[
				["ammo_1-sheet0.png", 137292, 241, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 361, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 1, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 121, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_1-sheet0.png", 137292, 241, 337, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		8846012467380051,
		[],
		null
	]
,	[
		"t26",
		cr.plugins_.Sprite,
		false,
		[3464120847041606,6210031047786964,7781717888966151],
		0,
		0,
		null,
		[
			[
			"normal",
			10,
			true,
			1,
			0,
			false,
			9380199860575866,
			[
				["ammo_2-sheet0.png", 162276, 1, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 113, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"rainbow",
			10,
			true,
			1,
			0,
			false,
			5363375483694932,
			[
				["ammo_2-sheet0.png", 162276, 121, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 225, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"mecha",
			10,
			true,
			1,
			0,
			false,
			7481877141101673,
			[
				["ammo_2-sheet0.png", 162276, 241, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 361, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 1, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 121, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_2-sheet0.png", 162276, 241, 337, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		8877866856553136,
		[],
		null
	]
,	[
		"t27",
		cr.plugins_.Sprite,
		false,
		[3464120847041606,6210031047786964,7781717888966151],
		0,
		0,
		null,
		[
			[
			"normal",
			10,
			true,
			1,
			0,
			false,
			1882146597499496,
			[
				["ammo_3-sheet0.png", 114908, 1, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 1, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 57, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 113, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"rainbow",
			10,
			true,
			1,
			0,
			false,
			6473254004207892,
			[
				["ammo_3-sheet0.png", 114908, 121, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 113, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 169, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 225, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"mecha",
			10,
			true,
			1,
			0,
			false,
			1570221765947854,
			[
				["ammo_3-sheet0.png", 114908, 241, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 225, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 361, 281, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 1, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 121, 337, 118, 54, 1, 0.5, 0.5,[],[],0],
				["ammo_3-sheet0.png", 114908, 241, 337, 118, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		229442384524149,
		[],
		null
	]
,	[
		"t28",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			4771505913675075,
			[
				["speedboost-sheet0.png", 2478, 1, 1, 54, 22, 1, 0.5, 0.5,[],[],0],
				["speedboost-sheet0.png", 2478, 1, 25, 54, 22, 1, 0.5, 0.5,[],[],0],
				["speedboost-sheet1.png", 1483, 0, 0, 54, 22, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6949525640087364,
		[],
		null
	]
,	[
		"t29",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7333952435350354,
			[
				["buttonmainmenu-sheet0.png", 5798, 0, 0, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5443837062941503,
		[],
		null
	]
,	[
		"t30",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8055425950997349,
			[
				["buttonrestart-sheet0.png", 5070, 0, 0, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		3771025014633134,
		[],
		null
	]
,	[
		"t31",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8409338303680945,
			[
				["buttonrevive-sheet0.png", 5432, 0, 0, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		6714526624667717,
		[],
		null
	]
,	[
		"t32",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			662300869161467,
			[
				["buttontryagain-sheet0.png", 6016, 0, 0, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5016681378787746,
		[],
		null
	]
,	[
		"t33",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Normal",
			2,
			false,
			1,
			0,
			false,
			893781692201228,
			[
				["charge-sheet0.png", 1637, 1, 1, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 19, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 37, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 55, 128, 16, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Mecha",
			5,
			false,
			1,
			0,
			false,
			5108284994303289,
			[
				["charge-sheet0.png", 1637, 1, 73, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 91, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 109, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 127, 128, 16, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Rainbow",
			5,
			false,
			1,
			0,
			false,
			871653096942085,
			[
				["charge-sheet0.png", 1637, 1, 73, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 91, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 109, 128, 16, 1, 0.5, 0.5,[],[],0],
				["charge-sheet0.png", 1637, 1, 127, 128, 16, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			5342067690583241
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			5175721588549649
		]
		],
		false,
		false,
		5575788181137726,
		[],
		null
	]
,	[
		"t34",
		cr.plugins_.Sprite,
		false,
		[2997528603995076,6375481521416239],
		2,
		0,
		null,
		[
			[
			"shooter_1",
			0,
			true,
			1,
			0,
			false,
			9961272931487326,
			[
				["enemyprojectile-sheet0.png", 252221, 1, 463, 128, 20, 1, 1, 0.6000000238418579,[["Imagepoint 1", 0.5078125, 0.5]],[],0]
			]
			]
,			[
			"shooter_2",
			10,
			true,
			1,
			0,
			false,
			9855356497608445,
			[
				["enemyprojectile-sheet1.png", 95247, 1, 131, 256, 54, 1, 0.57421875, 0.4814814925193787,[["Imagepoint 1", 0.71875, 0.5]],[],0],
				["enemyprojectile-sheet1.png", 95247, 1, 187, 256, 54, 1, 0.57421875, 0.4814814925193787,[["Imagepoint 1", 0.71875, 0.5]],[],0]
			]
			]
,			[
			"shooter_3",
			0,
			false,
			1,
			0,
			false,
			6257512758878357,
			[
				["enemyprojectile-sheet0.png", 252221, 1, 485, 128, 20, 1, 1, 0.5,[["Imagepoint 1", 0.5, 0.5]],[],0]
			]
			]
,			[
			"shooter_4",
			0,
			false,
			1,
			0,
			false,
			6594958911787527,
			[
				["enemyprojectile-sheet1.png", 95247, 261, 1, 128, 20, 1, 1.0078125, 0.550000011920929,[["Imagepoint 1", 0.5234375, 0.5]],[],0]
			]
			]
,			[
			"boss_1",
			10,
			true,
			1,
			0,
			false,
			6659931802314158,
			[
				["enemyprojectile-sheet0.png", 252221, 1, 203, 256, 128, 1, 0.5, 0.5,[["Imagepoint 1", 0.75390625, 0.5078125]],[-0.4804686903953552,-0.2578119933605194,0.0390629768371582,-0.2890619933605194,0.0390629768371582,0.2734379768371582,-0.484375,0.2421879768371582],0],
				["enemyprojectile-sheet0.png", 252221, 1, 333, 256, 128, 1, 0.5, 0.5,[["Imagepoint 1", 0.75390625, 0.5078125]],[-0.4804686903953552,-0.2578119933605194,0.0390629768371582,-0.2890619933605194,0.0390629768371582,0.2734379768371582,-0.484375,0.2421879768371582],0]
			]
			]
,			[
			"boss_2",
			0,
			false,
			1,
			0,
			false,
			4899212619787854,
			[
				["enemyprojectile-sheet1.png", 95247, 261, 23, 128, 20, 1, 1.0078125, 0.550000011920929,[["Imagepoint 1", 0.5078125, 0.6000000238418579]],[],0]
			]
			]
,			[
			"boss_3",
			5,
			false,
			1,
			0,
			false,
			1598395333599024,
			[
				["enemyprojectile-sheet0.png", 252221, 259, 203, 150, 150, 1, 0.5133333206176758, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.32833331823349,-0.3149999976158142,-0.01333332061767578,-0.4449999928474426,0.29666668176651,-0.3100000023841858,0.4266666769981384,0,0.29666668176651,0.3100000023841858,-0.01333332061767578,0.4449999928474426,-0.32833331823349,0.3149999976158142,-0.4633333086967468,0],0],
				["enemyprojectile-sheet0.png", 252221, 259, 355, 150, 150, 1, 0.5133333206176758, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.32833331823349,-0.3149999976158142,-0.01333332061767578,-0.4449999928474426,0.29666668176651,-0.3100000023841858,0.4266666769981384,0,0.29666668176651,0.3100000023841858,-0.01333332061767578,0.4449999928474426,-0.32833331823349,0.3149999976158142,-0.4633333086967468,0],0]
			]
			]
,			[
			"boss_4",
			5,
			false,
			1,
			0,
			false,
			5765170972179557,
			[
				["enemyprojectile-sheet1.png", 95247, 1, 1, 128, 128, 1, 0.4921875, 0.4921875,[["Imagepoint 1", 0.5, 0.5]],[-0.3071874976158142,-0.3071874976158142,0.0078125,-0.4371874928474426,0.3178125023841858,-0.3021875023841858,0.4478124976158142,0.0078125,0.3178125023841858,0.3178125023841858,0.0078125,0.4528124928474426,-0.3071874976158142,0.3228124976158142,-0.442187488079071,0.0078125],0],
				["enemyprojectile-sheet1.png", 95247, 131, 1, 128, 128, 1, 0.4921875, 0.4921875,[["Imagepoint 1", 0.5, 0.5]],[-0.3071874976158142,-0.3071874976158142,0.0078125,-0.4371874928474426,0.3178125023841858,-0.3021875023841858,0.4478124976158142,0.0078125,0.3178125023841858,0.3178125023841858,0.0078125,0.4528124928474426,-0.3071874976158142,0.3228124976158142,-0.442187488079071,0.0078125],0]
			]
			]
,			[
			"rocket_big_1",
			0,
			true,
			1,
			0,
			false,
			815399551973848,
			[
				["enemyprojectile-sheet0.png", 252221, 405, 1, 8, 8, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.1162790060043335,-0.2484660148620606,0,-0.3343560099601746,0.1085270047187805,-0.2361960113048554,0.2286819815635681,-0.06441700458526611,0.1395350098609924,0.1564419865608215,0,0.2116559743881226,-0.1395350098609924,0.1564419865608215,-0.24031001329422,-0.06441700458526611],0]
			]
			]
,			[
			"rocket_big_2",
			0,
			false,
			1,
			0,
			false,
			4332034685905775,
			[
				["enemyprojectile-sheet0.png", 252221, 405, 1, 8, 8, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.09302300214767456,-0.4166666865348816,0,-0.4749999940395355,0.0775189995765686,-0.3833329975605011,0.267441987991333,-0.2166669964790344,0.1821709871292114,0.175000011920929,0,0.2333329916000366,-0.1860469877719879,0.1833329796791077,-0.3023259937763214,-0.2166669964790344],0]
			]
			]
,			[
			"rocket_big_3",
			0,
			false,
			1,
			0,
			false,
			6292880012755182,
			[
				["enemyprojectile-sheet0.png", 252221, 405, 1, 8, 8, 1, 0.5, 0.375,[["Imagepoint 1", 0.5, 0.5]],[-0.09302300214767456,-0.2916666865348816,0,-0.3499999940395355,0.0775189995765686,-0.2583329975605011,0.267441987991333,-0.09166699647903442,0.1821709871292114,0.300000011920929,0,0.3583329916000366,-0.1860469877719879,0.3083329796791077,-0.3023259937763214,-0.09166699647903442],0]
			]
			]
,			[
			"rocket_big_4",
			0,
			false,
			1,
			0,
			false,
			2528231760241093,
			[
				["enemyprojectile-sheet1.png", 95247, 261, 45, 128, 20, 1, 1.015625, 0.550000011920929,[["Imagepoint 1", 0.5, 0.5]],[-1.015625,-0.550000011920929,-0.515625,-0.550000011920929,-0.28125,-0.05000001192092896,-0.515625,0.449999988079071,-1.015625,0.449999988079071],0]
			]
			]
,			[
			"LaneMissile",
			5,
			true,
			1,
			0,
			false,
			9845224993263402,
			[
				["enemyprojectile-sheet0.png", 252221, 1, 1, 200, 200, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.3149999976158142,-0.3149999976158142,0,-0.4449999928474426,0.3100000023841858,-0.3100000023841858,0.4399999976158142,0,0.3100000023841858,0.3100000023841858,0,0.4449999928474426,-0.3149999976158142,0.3149999976158142,-0.449999988079071,0],0],
				["enemyprojectile-sheet0.png", 252221, 203, 1, 200, 200, 1, 0.5, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-0.3149999976158142,-0.3149999976158142,0,-0.4449999928474426,0.3100000023841858,-0.3100000023841858,0.4399999976158142,0,0.3100000023841858,0.3100000023841858,0,0.4449999928474426,-0.3149999976158142,0.3149999976158142,-0.449999988079071,0],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			9497603609773344
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			945279393231538
		]
		],
		false,
		false,
		9664524969405904,
		[],
		null
	]
,	[
		"t35",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8274327334297933,
			[
				["grenade-sheet0.png", 3780, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.34375,-0.34375,0,-0.484375,0.34375,-0.34375,0.4921879768371582,0,0.3515629768371582,0.3515629768371582,0,0.4921879768371582,-0.34375,0.34375,-0.484375,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9540670659777733,
		[],
		null
	]
,	[
		"t36",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Normal",
			0,
			false,
			1,
			0,
			false,
			7424204647644619,
			[
				["grenadeui-sheet0.png", 8334, 0, 0, 128, 64, 1, 0.5, 0.5,[],[-0.3847349882125855,-0.2448279857635498,-0.001558005809783936,-0.4310345053672791,0.3847349882125855,-0.2448279857635498,0.4688469767570496,-0.003448009490966797,0.3847349882125855,0.2448279857635498,-0.001558005809783936,0.4241380095481873,-0.3847349882125855,0.2448279857635498,-0.468847393989563,-0.003448009490966797],0]
			]
			]
,			[
			"Mecha",
			0,
			false,
			1,
			0,
			false,
			3974871336484148,
			[
				["grenadeui-sheet0.png", 8334, 0, 0, 128, 64, 1, 0.5, 0.5,[],[-0.3847349882125855,-0.2448279857635498,-0.001558005809783936,-0.4310345053672791,0.3847349882125855,-0.2448279857635498,0.4688469767570496,-0.003448009490966797,0.3847349882125855,0.2448279857635498,-0.001558005809783936,0.4241380095481873,-0.3847349882125855,0.2448279857635498,-0.468847393989563,-0.003448009490966797],0]
			]
			]
,			[
			"Rainbow",
			0,
			false,
			1,
			0,
			false,
			9075333467066757,
			[
				["grenadeui-sheet0.png", 8334, 0, 0, 128, 64, 1, 0.5, 0.5,[],[-0.3847349882125855,-0.2448279857635498,-0.001558005809783936,-0.4310345053672791,0.3847349882125855,-0.2448279857635498,0.4688469767570496,-0.003448009490966797,0.3847349882125855,0.2448279857635498,-0.001558005809783936,0.4241380095481873,-0.3847349882125855,0.2448279857635498,-0.468847393989563,-0.003448009490966797],0]
			]
			]
		],
		[
		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			6014254036602519
		]
		],
		false,
		false,
		3836601800494541,
		[],
		null
	]
,	[
		"t37",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Normal",
			20,
			false,
			1,
			0,
			false,
			6547729033963302,
			[
				["grenadeexplosion-sheet0.png", 42958, 1, 1, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 57, 1, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 113, 1, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 169, 1, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 1, 57, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 57, 57, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 113, 57, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 169, 57, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 1, 113, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 57, 113, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 113, 113, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 169, 113, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 1, 169, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 57, 169, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 113, 169, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0],
				["grenadeexplosion-sheet0.png", 42958, 169, 169, 54, 54, 1, 0.5185185074806213, 0.7222222089767456,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7545985056946615
		]
		],
		false,
		false,
		6485037967654866,
		[],
		null
	]
,	[
		"t38",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Normal",
			5,
			false,
			1,
			0,
			false,
			7891345994858376,
			[
				["enemymuzzlefire-sheet0.png", 3366, 0, 0, 62, 37, 1, 0.8870967626571655, 0.5675675868988037,[],[-0.008063733577728272,-0.08108159899711609,-0.2499997615814209,0.2027034163475037,-0.4193547666072846,0.2162163853645325,-0.7903225421905518,-0.08108159899711609,-0.5161287784576416,-0.2432435750961304,-0.4193547666072846,-0.270270586013794,-0.2983867526054382,-0.2837826013565064],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7833809291459183
		]
		],
		false,
		false,
		2698045008073955,
		[],
		null
	]
,	[
		"t39",
		cr.plugins_.Arr,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		true,
		false,
		6058620433100067,
		[],
		null
	]
,	[
		"t40",
		cr.plugins_.WebStorage,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		4434954711072722,
		[],
		null
		,[]
	]
,	[
		"t41",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3497230662191225,
			[
				["backgroundachievement-sheet0.png", 63546, 0, 0, 512, 256, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		9106899865071001,
		[],
		null
	]
,	[
		"t42",
		cr.plugins_.Sprite,
		false,
		[1363533037578237],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1488039032557368,
			[
				["buttonachievement-sheet0.png", 44042, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 253, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 253, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 1, 175, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 253, 175, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 1, 262, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 253, 262, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 1, 349, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet0.png", 44042, 253, 349, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet1.png", 16778, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet1.png", 16778, 253, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonachievement-sheet1.png", 16778, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5058823823928833]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			4901526514337373
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			4914708852668894
		]
		],
		false,
		false,
		9631694131075744,
		[],
		null
	]
,	[
		"t43",
		cr.plugins_.Sprite,
		false,
		[4573261037089241],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8924822651923223,
			[
				["achieved-sheet0.png", 647, 0, 0, 64, 64, 1, 0.5, 0.515625,[],[-0.4558824002742767,-0.4708488881587982,0,-0.515625,0.4558820128440857,-0.4708488881587982,0.485293984413147,-0.0230880081653595,0.4558820128440857,0.4395989775657654,0,0.484375,-0.4558824002742767,0.4395989775657654,-0.4852941036224365,-0.0230880081653595],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2178015950419636
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			5583738403741035
		]
		],
		false,
		false,
		7512923806913373,
		[],
		null
	]
,	[
		"t44",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6230281178878019,
			[
				["backgroundupgrades-sheet0.png", 61905, 0, 0, 512, 256, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		905053765079433,
		[],
		null
	]
,	[
		"t45",
		cr.plugins_.Sprite,
		false,
		[5082802678113427],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9653680924447362,
			[
				["buttonupgrade-sheet0.png", 6517, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5176470875740051]],[-0.4382719099521637,-0.529411792755127,0.4382719993591309,-0.529411792755127,0.5,0.04429018497467041,0.421887993812561,0.4705882072448731,-0.4218879044055939,0.4705882072448731,-0.5,0.04429018497467041],0],
				["buttonupgrade-sheet0.png", 6517, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5176470875740051]],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonupgrade-sheet1.png", 8390, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5176470875740051]],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonupgrade-sheet1.png", 8390, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5176470875740051]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonupgrade-sheet2.png", 3847, 0, 0, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.5176470875740051]],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			6748696816391195
		]
		],
		false,
		false,
		9888995841628474,
		[],
		null
	]
,	[
		"t46",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1947367030457816,
			[
				["backgroundcatalogue-sheet0.png", 58295, 0, 0, 512, 256, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4602573640207141,
		[],
		null
	]
,	[
		"t47",
		cr.plugins_.Sprite,
		false,
		[56764715844762,4059838104388143,771766505292576],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8858053286439196,
			[
				["buttoncatalogue-sheet0.png", 47922, 1, 1, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 253, 1, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 1, 88, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 253, 88, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 1, 175, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 253, 175, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 1, 262, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 253, 262, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 1, 349, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet0.png", 47922, 253, 349, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 1, 1, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 253, 1, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 1, 88, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 253, 88, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 1, 175, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 253, 175, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0],
				["buttoncatalogue-sheet1.png", 41042, 1, 262, 250, 85, 1, 0.5, 0.5411764979362488,[["Imagepoint 1", 0.1679999977350235, 0.5176470875740051]],[-0.4280000030994415,-0.5176470875740051,0.4279999732971191,-0.5176470875740051,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470584988594055,-0.4120000004768372,0.4470584988594055,-0.4959999918937683,-0.0117645263671875],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4144729281310744
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			5506812296540059
		]
		],
		false,
		false,
		5462320775316013,
		[],
		null
	]
,	[
		"t48",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7588238378036476,
			[
				["highlightupgrade-sheet0.png", 1083, 0, 0, 250, 85, 1, 0.5, 0.529411792755127,[],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1574446932358689
		]
		],
		false,
		false,
		2786975920874139,
		[],
		null
	]
,	[
		"t49",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			4877817965195461,
			[
				["popup_buttons-sheet0.png", 9719, 1, 1, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0],
				["popup_buttons-sheet0.png", 9719, 1, 67, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0],
				["popup_buttons-sheet0.png", 9719, 1, 133, 217, 64, 1, 0.5023041367530823, 0.5,[],[-0.4838709235191345,-0.4375,-0.004608124494552612,-0.5,0.4792628884315491,-0.4375,0.4976958632469177,0,0.4792628884315491,0.4374999403953552,-0.004608124494552612,0.484375,-0.47926265001297,0.421875,-0.4976958334445953,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1735715158704029,
		[],
		null
	]
,	[
		"t50",
		cr.plugins_.Tilemap,
		false,
		[],
		0,
		0,
		["tilemap.png", 1676, 0],
		null,
		[
		],
		false,
		false,
		4398525533790143,
		[],
		[
		]
	]
,	[
		"t51",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Normal",
			0,
			false,
			1,
			0,
			false,
			5110101906958041,
			[
				["forcefield-sheet0.png", 11918, 0, 0, 128, 128, 1, 0.5, 0.4765625,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3294292502298846
		]
		],
		false,
		false,
		1405106626393825,
		[],
		null
	]
,	[
		"t52",
		cr.plugins_.Sprite,
		false,
		[4419465393592016],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			9884081489468668,
			[
				["slider-sheet0.png", 8142, 1, 1, 246, 57, 1, 0.5, 0.5087719559669495,[],[-0.4852217137813568,-0.4421052634716034,0,-0.4976608455181122,0.4852219820022583,-0.4421052634716034,0.5,-0.008771955966949463,0.4827589988708496,0.4134500622749329,0,0.4690060615539551,-0.4827586114406586,0.4134500622749329,-0.5,-0.008771955966949463],0],
				["slider-sheet0.png", 8142, 1, 60, 246, 57, 1, 0.5, 0.5087719559669495,[],[-0.4753695130348206,-0.3976609706878662,0,-0.4865497648715973,0.4802960157394409,-0.4198830723762512,0.4950739741325378,-0.008771955966949463,0.4802960157394409,0.4023390412330627,0,0.4690060615539551,-0.4753695130348206,0.3801170587539673,-0.4876846969127655,-0.008771955966949463],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7377480036649675
		]
		],
		false,
		false,
		1984208637210746,
		[],
		null
	]
,	[
		"t53",
		cr.plugins_.Sprite,
		false,
		[1308232177427912,8576037654448275,879218995330747],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4481449737205436,
			[
				["scrollhelper-sheet0.png", 107, 0, 0, 1, 1, 1, 1, 1,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		9314192338685627,
		[],
		null
	]
,	[
		"t54",
		cr.plugins_.Rex_Nickname,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3713838551105084,
		[],
		null
		,[]
	]
,	[
		"t55",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			20,
			true,
			1,
			0,
			false,
			6250416738911571,
			[
				["enemy_boss_1-sheet0.png", 196339, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1829268336296082, 0.6910569071769714],["Imagepoint 2", 0.5934959053993225, 0.5609756112098694],["Imagepoint 3", 0.4552845656871796, 0.2804878056049347],["Imagepoint 4", 0.4471544623374939, 0.6788617968559265]],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0],
				["enemy_boss_1-sheet0.png", 196339, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1829268336296082, 0.6910569071769714],["Imagepoint 2", 0.5934959053993225, 0.5609756112098694],["Imagepoint 3", 0.4552845656871796, 0.2804878056049347],["Imagepoint 4", 0.4471544623374939, 0.6788617968559265]],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0],
				["enemy_boss_1-sheet0.png", 196339, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1829268336296082, 0.6910569071769714],["Imagepoint 2", 0.5934959053993225, 0.5609756112098694],["Imagepoint 3", 0.4552845656871796, 0.2804878056049347],["Imagepoint 4", 0.4471544623374939, 0.6788617968559265]],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0],
				["enemy_boss_1-sheet0.png", 196339, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1829268336296082, 0.6910569071769714],["Imagepoint 2", 0.5934959053993225, 0.5609756112098694],["Imagepoint 3", 0.4552845656871796, 0.2804878056049347],["Imagepoint 4", 0.4471544623374939, 0.6788617968559265]],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0],
				["enemy_boss_1-sheet1.png", 207236, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1829268336296082, 0.6910569071769714],["Imagepoint 2", 0.5934959053993225, 0.5609756112098694],["Imagepoint 3", 0.4552845656871796, 0.2804878056049347],["Imagepoint 4", 0.4471544623374939, 0.6788617968559265]],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			6302012330657484,
			[
				["enemy_boss_1-sheet1.png", 207236, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1219512224197388, 0.3861788511276245]],[-0.3515619933605194,-0.1992189884185791,0.2382810115814209,-0.2851560115814209,0.34375,0.2851560115814209,-0.4023436903953552,0.28125],0],
				["enemy_boss_1-sheet1.png", 207236, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1219512224197388, 0.3861788511276245]],[-0.3515619933605194,-0.1992189884185791,0.2382810115814209,-0.2851560115814209,0.34375,0.2851560115814209,-0.4023436903953552,0.28125],0],
				["enemy_boss_1-sheet1.png", 207236, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1219512224197388, 0.3861788511276245]],[-0.3515619933605194,-0.1992189884185791,0.2382810115814209,-0.2851560115814209,0.34375,0.2851560115814209,-0.4023436903953552,0.28125],0],
				["enemy_boss_1-sheet2.png", 177562, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1219512224197388, 0.3861788511276245]],[-0.3515619933605194,-0.1992189884185791,0.2382810115814209,-0.2851560115814209,0.34375,0.2851560115814209,-0.4023436903953552,0.28125],0],
				["enemy_boss_1-sheet2.png", 177562, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.1219512224197388, 0.3861788511276245]],[-0.3515619933605194,-0.1992189884185791,0.2382810115814209,-0.2851560115814209,0.34375,0.2851560115814209,-0.4023436903953552,0.28125],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			4754218305104999,
			[
				["enemy_boss_1-sheet2.png", 177562, 1, 249, 246, 246, 1, 0.5, 0.5,[],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0],
				["enemy_boss_1-sheet2.png", 177562, 249, 249, 246, 246, 1, 0.5, 0.5,[],[-0.3671869933605194,-0.1875,0.1992189884185791,-0.2773439884185791,0.3242189884185791,0.25,-0.390625,0.2695310115814209],0]
			]
			]
		],
		[
		],
		false,
		false,
		6954854100726463,
		[],
		null
	]
,	[
		"t56",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			1325831706277308,
			[
				["artworks-sheet0.png", 321599, 1, 775, 256, 128, 1, 0.5, 0.5,[],[-0.4101561903953552,-0.3203119933605194,0,-0.4375,0.25,0,0.3476560115814209,0,0.4023439884185791,0.3046879768371582,0,0.4453129768371582,-0.1445310115814209,-0.2109369933605194,-0.1601560115814209,0],0],
				["artworks-sheet0.png", 321599, 775, 1, 128, 128, 1, 0.5, 0.5,[],[-0.296875,-0.296875,0,-0.421875,0.203125,-0.203125,0.1796879768371582,0,0.265625,0.265625,0,0.453125,-0.2734369933605194,0.2734379768371582,-0.3046869933605194,0],0],
				["artworks-sheet0.png", 321599, 775, 131, 128, 128, 1, 0.5, 0.5,[],[-0.1953119933605194,-0.1953119933605194,0,-0.4765625,0.25,-0.25,0.28125,0,0.21875,0.21875,0,0.4374999403953552,-0.3515619933605194,0.3515629768371582,-0.265625,0],0],
				["artworks-sheet0.png", 321599, 1, 1, 256, 256, 1, 0.5, 0.5,[],[-0.2070310115814209,-0.2070310115814209,0,-0.2890619933605194,0.2226560115814209,-0.2226560115814209,0.4101560115814209,0,0.2929689884185791,0.2929689884185791,-0.2890619933605194,0.2890629768371582,-0.40625,0],0],
				["artworks-sheet0.png", 321599, 259, 1, 256, 256, 1, 0.5, 0.46875,[],[-0.28125,-0.25,0,-0.3359369933605194,0.3828129768371582,-0.3515619933605194,0.1171879768371582,0.03125,0.3046879768371582,0.3359379768371582,0,0.4726560115814209,-0.3046869933605194,0.3359379768371582,-0.2070310115814209,0.03125],0],
				["artworks-sheet0.png", 321599, 775, 261, 128, 128, 1, 0.5, 0.5,[],[-0.171875,-0.171875,0,-0.3203119933605194,0.25,-0.25,0.21875,0,0.3125,0.3125,0,0.421875,-0.3359369933605194,0.3359379768371582,-0.1796869933605194,0],0],
				["artworks-sheet0.png", 321599, 775, 391, 128, 128, 1, 0.5, 0.5,[],[-0.25,-0.25,0,-0.453125,0.3359379768371582,-0.3359369933605194,0.3671879768371582,0,0.359375,0.359375,0,0.453125,-0.3828119933605194,0.3828129768371582,-0.359375,0],0],
				["artworks-sheet0.png", 321599, 517, 1, 256, 256, 1, 0.5, 0.5,[],[-0.4101561903953552,-0.4101561903953552,0,-0.02343699336051941,0.359375,-0.359375,0.4257810115814209,0.4257810115814209,0,0.3671879768371582,-0.34375,0.34375,-0.0117189884185791,0],0],
				["artworks-sheet0.png", 321599, 1, 259, 256, 256, 1, 0.5, 0.5,[],[-0.2578119933605194,-0.2578119933605194,0,-0.4492186903953552,0.1640629768371582,-0.1640619933605194,0.4257810115814209,0,0.3984379768371582,0.3984379768371582,0,0.4023439884185791,-0.3632810115814209,0.3632810115814209,-0.3789060115814209,0],0],
				["artworks-sheet0.png", 321599, 775, 521, 128, 128, 1, 0.5, 0.5,[],[-0.3203119933605194,-0.3203119933605194,0,-0.375,0.265625,-0.265625,0.328125,0,0.3359379768371582,0.3359379768371582,0,0.4296879768371582,-0.34375,0.34375],0],
				["artworks-sheet0.png", 321599, 775, 651, 128, 128, 1, 0.5, 0.5,[],[-0.21875,-0.21875,0,-0.4140625,0.2109379768371582,-0.2109369933605194,0.328125,0,0.234375,0.234375,0,0.46875,-0.3359369933605194,0.3359379768371582,-0.3125,0],0],
				["artworks-sheet0.png", 321599, 259, 259, 256, 256, 1, 0.578125, 0.46484375,[],[-0.171875,-0.05859375,-0.078125,-0.3632807433605194,0.25,-0.29296875,0.2539060115814209,0.03515625,0.2773439884185791,0.3906252384185791,-0.078125,0.4140622615814209,-0.28125,0.23828125,-0.2734369933605194,0.03515625],0],
				["artworks-sheet0.png", 321599, 517, 259, 256, 256, 1, 0.5, 0.5,[],[-0.2851560115814209,-0.2851560115814209,0,-0.3710939884185791,0.3515629768371582,-0.3515619933605194,0.3046879768371582,0,0.3710939884185791,0.3710939884185791,0,0.4374999403953552,-0.4179686903953552,0.4179689884185791,-0.2929689884185791,0],0],
				["artworks-sheet0.png", 321599, 517, 775, 128, 128, 1, 0.5, 0.5,[],[-0.34375,-0.34375,0,-0.40625,0.2734379768371582,-0.2734369933605194,0.328125,0,0.3515629768371582,0.3515629768371582,0,0.4453129768371582,-0.3671869933605194,0.3671879768371582],0],
				["artworks-sheet0.png", 321599, 647, 781, 128, 128, 1, 0.5, 0.5,[],[-0.3125,-0.3125,0,-0.484375,0.1953129768371582,-0.1953119933605194,0.375,0,0.375,0.375,0,0.46875,-0.3046869933605194,0.3046879768371582],0],
				["artworks-sheet0.png", 321599, 1, 517, 256, 256, 1, 0.5, 0.5,[],[-0.1875,-0.1875,0,-0.4335936903953552,0.3046879768371582,-0.3046869933605194,0.265625,0,0.3476560115814209,0.3476560115814209,0,0.4804689884185791,-0.3828119933605194,0.3828129768371582,-0.390625,0],0]
			]
			]
,			[
			"blank",
			0,
			false,
			1,
			0,
			false,
			6296114314097471,
			[
				["artworks-sheet0.png", 321599, 259, 775, 256, 128, 1, 0.5, 0.5,[],[],0],
				["enemy_exploder_1-sheet0.png", 24358, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0],
				["enemy_solid_1-sheet0.png", 25790, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet0.png", 321599, 259, 517, 256, 256, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet0.png", 321599, 517, 517, 256, 256, 1, 0.5, 0.46875,[],[],0],
				["artworks-sheet0.png", 321599, 777, 781, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 775, 1, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 1, 1, 256, 256, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 259, 1, 256, 256, 1, 0.5, 0.5,[],[-0.2578119933605194,-0.2578119933605194,0,-0.4492186903953552,0.1640629768371582,-0.1640619933605194,0.4257810115814209,0,0.3984379768371582,0.3984379768371582,0,0.4023439884185791,-0.3632810115814209,0.3632810115814209,-0.3789060115814209,0],0],
				["artworks-sheet1.png", 461366, 775, 131, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 769, 261, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 517, 1, 256, 256, 1, 0.578125, 0.46484375,[],[],0],
				["artworks-sheet1.png", 461366, 1, 259, 256, 256, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 769, 391, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 517, 511, 128, 128, 1, 0.5, 0.5,[],[],0],
				["artworks-sheet1.png", 461366, 259, 259, 256, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"unlocked",
			5,
			false,
			1,
			0,
			false,
			1012712615507933,
			[
				["artworks-sheet1.png", 461366, 517, 259, 250, 250, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2763516140038777,
		[],
		null
	]
,	[
		"t57",
		cr.plugins_.Sprite,
		false,
		[3024644451989054],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			2932820480886169,
			[
				["arrows-sheet0.png", 4924, 1, 1, 56, 108, 1, 0.5714285969734192, 0.5,[],[-0.1272326111793518,-0.3270739912986755,-0.01785761117935181,-0.3959319889545441,0.3258923888206482,-0.4561809897422791,0.4040173888206482,0,0.3258923888206482,0.4561809897422791,-0.01785761117935181,0.3959320187568665,-0.1272326111793518,0.3270739912986755,-0.5491071939468384,0],0],
				["arrows-sheet1.png", 4440, 1, 1, 108, 56, 1, 0.4907407462596893, 0.5714285969734192,[],[0.3363332450389862,-0.1272326111793518,0.4051912724971771,-0.01785761117935181,0.4654402434825897,0.3258923888206482,0.009259253740310669,0.4040173888206482,-0.4469217360019684,0.3258923888206482,-0.3866727352142334,-0.01785761117935181,-0.3178147673606873,-0.1272326111793518,0.009259253740310669,-0.5491071939468384],0],
				["arrows-sheet0.png", 4924, 59, 1, 56, 108, 1, 0.4285714328289032, 0.5,[],[0.1272325813770294,0.3270739912986755,0.01785758137702942,0.3959320187568665,-0.325892448425293,0.4561809897422791,-0.404017835855484,0,-0.325892448425293,-0.4561809897422791,0.01785758137702942,-0.3959319889545441,0.1272325813770294,-0.3270739912986755,0.549107551574707,0],0],
				["arrows-sheet1.png", 4440, 1, 59, 108, 56, 1, 0.5, 0.4285714328289032,[],[-0.3270739912986755,0.1272325813770294,-0.3959319889545441,0.01785758137702942,-0.4561809897422791,-0.325892448425293,0,-0.404017835855484,0.4561809897422791,-0.325892448425293,0.3959320187568665,0.01785758137702942,0.3270739912986755,0.1272325813770294,0,0.549107551574707],0]
			]
			]
		],
		[
		],
		false,
		false,
		3165944690640515,
		[],
		null
	]
,	[
		"t58",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3278220216266723,
			[
				["highlightupgrade-sheet0.png", 1083, 0, 0, 250, 85, 1, 0.5, 0.5411764979362488,[],[-0.4279999136924744,-0.5176463127136231,0.4279999732971191,-0.5176463127136231,0.4959999918937683,-0.0117645263671875,0.4120000004768372,0.4470595121383667,-0.41199991106987,0.4470595121383667,-0.4959999918937683,-0.0117645263671875],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4830964396706326
		]
		],
		false,
		false,
		5146025367577733,
		[],
		null
	]
,	[
		"t59",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			674524622750906,
			[
				["reset-sheet0.png", 3395, 0, 0, 246, 57, 1, 0.5040650367736816, 0.5087719559669495,[],[-0.4818975329399109,-0.4087719619274139,-0.004065036773681641,-0.4865497648715973,0.4762309789657593,-0.4198830723762512,0.4910089373588562,-0.008771955966949463,0.4762309789657593,0.4023390412330627,-0.004065036773681641,0.4690060615539551,-0.4818975329399109,0.3912280201911926],0]
			]
			]
		],
		[
		],
		false,
		false,
		9900433924527095,
		[],
		null
	]
,	[
		"t60",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9450537963409302,
			[
				["scrollhelper-sheet0.png", 107, 0, 0, 1, 1, 1, 1, 1,[],[],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			1325564158562641
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			9508158494746609
		]
		],
		false,
		false,
		7066150940707881,
		[],
		null
	]
,	[
		"t61",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			1368982342073531,
			[
				["enemy_boss_2-sheet0.png", 233018, 1, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.3455284535884857, 0.2520325183868408],["Imagepoint 2", 0.4430894255638123, 0.4186991751194],["Imagepoint 3", 0.353658527135849, 0.5569105744361877],["Imagepoint 4", 0.7520325183868408, 0.2682926952838898]],[-0.5316940546035767,-0.2357403486967087,0.007367908954620361,-0.3998030424118042,0.204633891582489,-0.231834352016449,0.1763129234313965,0.4634786248207092,-0.2035691142082214,0.3697286248207092,-0.5277881026268005,0.127540647983551],0],
				["enemy_boss_2-sheet0.png", 233018, 249, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.3455284535884857, 0.2520325183868408],["Imagepoint 2", 0.4430894255638123, 0.4186991751194],["Imagepoint 3", 0.353658527135849, 0.5569105744361877],["Imagepoint 4", 0.7520325183868408, 0.2682926952838898]],[-0.5316940546035767,-0.2357403486967087,0.007367908954620361,-0.3998030424118042,0.204633891582489,-0.231834352016449,0.1763129234313965,0.4634786248207092,-0.2035691142082214,0.3697286248207092,-0.5277881026268005,0.127540647983551],0],
				["enemy_boss_2-sheet0.png", 233018, 1, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.3455284535884857, 0.2520325183868408],["Imagepoint 2", 0.4430894255638123, 0.4186991751194],["Imagepoint 3", 0.353658527135849, 0.5569105744361877],["Imagepoint 4", 0.7520325183868408, 0.2682926952838898]],[-0.5316940546035767,-0.2357403486967087,0.007367908954620361,-0.3998030424118042,0.204633891582489,-0.231834352016449,0.1763129234313965,0.4634786248207092,-0.2035691142082214,0.3697286248207092,-0.5277881026268005,0.127540647983551],0],
				["enemy_boss_2-sheet0.png", 233018, 249, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.3455284535884857, 0.2520325183868408],["Imagepoint 2", 0.4430894255638123, 0.4186991751194],["Imagepoint 3", 0.353658527135849, 0.5569105744361877],["Imagepoint 4", 0.7520325183868408, 0.2682926952838898]],[-0.5316940546035767,-0.2357403486967087,0.007367908954620361,-0.3998030424118042,0.204633891582489,-0.231834352016449,0.1763129234313965,0.4634786248207092,-0.2035691142082214,0.3697286248207092,-0.5277881026268005,0.127540647983551],0],
				["enemy_boss_2-sheet1.png", 261553, 1, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.3455284535884857, 0.2520325183868408],["Imagepoint 2", 0.4430894255638123, 0.4186991751194],["Imagepoint 3", 0.353658527135849, 0.5569105744361877],["Imagepoint 4", 0.7520325183868408, 0.2682926952838898]],[-0.5316940546035767,-0.2357403486967087,0.007367908954620361,-0.3998030424118042,0.204633891582489,-0.231834352016449,0.1763129234313965,0.4634786248207092,-0.2035691142082214,0.3697286248207092,-0.5277881026268005,0.127540647983551],0]
			]
			]
,			[
			"Shoot",
			10,
			false,
			1,
			0,
			false,
			6141517020498568,
			[
				["enemy_boss_2-sheet1.png", 261553, 249, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.0203252024948597, 0.4065040647983551]],[-0.5551320910453796,-0.2357403486967087,-0.0004441142082214356,-0.3919905424118042,0.2026808857917786,-0.2337873578071594,0.1558058857917786,0.471290647983551,-0.2074760794639587,0.3755876421928406,-0.5395070910453796,0.1314466595649719],0],
				["enemy_boss_2-sheet1.png", 261553, 1, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.0203252024948597, 0.4065040647983551]],[-0.5551320910453796,-0.2357403486967087,-0.0004441142082214356,-0.3919905424118042,0.2026808857917786,-0.2337873578071594,0.1558058857917786,0.471290647983551,-0.2074760794639587,0.3755876421928406,-0.5395070910453796,0.1314466595649719],0],
				["enemy_boss_2-sheet1.png", 261553, 249, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.0203252024948597, 0.4065040647983551]],[-0.5551320910453796,-0.2357403486967087,-0.0004441142082214356,-0.3919905424118042,0.2026808857917786,-0.2337873578071594,0.1558058857917786,0.471290647983551,-0.2074760794639587,0.3755876421928406,-0.5395070910453796,0.1314466595649719],0],
				["enemy_boss_2-sheet2.png", 220233, 1, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.0203252024948597, 0.4065040647983551]],[-0.5551320910453796,-0.2357403486967087,-0.0004441142082214356,-0.3919905424118042,0.2026808857917786,-0.2337873578071594,0.1558058857917786,0.471290647983551,-0.2074760794639587,0.3755876421928406,-0.5395070910453796,0.1314466595649719],0],
				["enemy_boss_2-sheet2.png", 220233, 249, 1, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[["Imagepoint 1", 0.0203252024948597, 0.4065040647983551]],[-0.5551320910453796,-0.2357403486967087,-0.0004441142082214356,-0.3919905424118042,0.2026808857917786,-0.2337873578071594,0.1558058857917786,0.471290647983551,-0.2074760794639587,0.3755876421928406,-0.5395070910453796,0.1314466595649719],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			3992502366851244,
			[
				["enemy_boss_2-sheet2.png", 220233, 1, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[],[-0.5277881026268005,-0.2396463453769684,-0.01606911420822144,-0.411521852016449,0.1948679089546204,-0.2201153486967087,0.1831489205360413,0.4361346364021301,-0.2152881026268005,0.3580096364021301,-0.5180230736732483,0.1314466595649719],0],
				["enemy_boss_2-sheet2.png", 220233, 249, 249, 246, 246, 1, 0.7113820910453796, 0.434959352016449,[],[-0.5277881026268005,-0.2396463453769684,-0.01606911420822144,-0.411521852016449,0.1948679089546204,-0.2201153486967087,0.1831489205360413,0.4361346364021301,-0.2152881026268005,0.3580096364021301,-0.5180230736732483,0.1314466595649719],0]
			]
			]
		],
		[
		],
		false,
		false,
		6556457792358195,
		[],
		null
	]
,	[
		"t62",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			7520486001783838,
			[
				["enemy_boss_3-sheet0.png", 190911, 1, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.4430894255638123, 0.2520325183868408],["Imagepoint 2", 0.7439024448394775, 0.3089430928230286],["Imagepoint 3", 0.6544715166091919, 0.4959349632263184],["Imagepoint 4", 0.577235758304596, 0.7113820910453796]],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0],
				["enemy_boss_3-sheet0.png", 190911, 249, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.4430894255638123, 0.2520325183868408],["Imagepoint 2", 0.7439024448394775, 0.3089430928230286],["Imagepoint 3", 0.6544715166091919, 0.4959349632263184],["Imagepoint 4", 0.577235758304596, 0.7113820910453796]],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0],
				["enemy_boss_3-sheet0.png", 190911, 1, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.4430894255638123, 0.2520325183868408],["Imagepoint 2", 0.7439024448394775, 0.3089430928230286],["Imagepoint 3", 0.6544715166091919, 0.4959349632263184],["Imagepoint 4", 0.577235758304596, 0.7113820910453796]],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0],
				["enemy_boss_3-sheet0.png", 190911, 249, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.4430894255638123, 0.2520325183868408],["Imagepoint 2", 0.7439024448394775, 0.3089430928230286],["Imagepoint 3", 0.6544715166091919, 0.4959349632263184],["Imagepoint 4", 0.577235758304596, 0.7113820910453796]],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0],
				["enemy_boss_3-sheet1.png", 202836, 1, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.4430894255638123, 0.2520325183868408],["Imagepoint 2", 0.7439024448394775, 0.3089430928230286],["Imagepoint 3", 0.6544715166091919, 0.4959349632263184],["Imagepoint 4", 0.577235758304596, 0.7113820910453796]],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			7889159182886316,
			[
				["enemy_boss_3-sheet1.png", 202836, 249, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.03252032399177551, 0.4268292784690857]],[-0.1556778252124786,-0.2769628763198853,0.3677591681480408,-0.2144628912210465,0.125572144985199,0.449600100517273,-0.5306783318519592,0.03163111209869385],0],
				["enemy_boss_3-sheet1.png", 202836, 1, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.03252032399177551, 0.4268292784690857]],[-0.1556778252124786,-0.2769628763198853,0.3677591681480408,-0.2144628912210465,0.125572144985199,0.449600100517273,-0.5306783318519592,0.03163111209869385],0],
				["enemy_boss_3-sheet1.png", 202836, 249, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.03252032399177551, 0.4268292784690857]],[-0.1556778252124786,-0.2769628763198853,0.3677591681480408,-0.2144628912210465,0.125572144985199,0.449600100517273,-0.5306783318519592,0.03163111209869385],0],
				["enemy_boss_3-sheet2.png", 177888, 1, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.03252032399177551, 0.4268292784690857]],[-0.1556778252124786,-0.2769628763198853,0.3677591681480408,-0.2144628912210465,0.125572144985199,0.449600100517273,-0.5306783318519592,0.03163111209869385],0],
				["enemy_boss_3-sheet2.png", 177888, 249, 1, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[["Imagepoint 1", 0.03252032399177551, 0.4268292784690857]],[-0.1556778252124786,-0.2769628763198853,0.3677591681480408,-0.2144628912210465,0.125572144985199,0.449600100517273,-0.5306783318519592,0.03163111209869385],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			9817633615349116,
			[
				["enemy_boss_3-sheet2.png", 177888, 1, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0],
				["enemy_boss_3-sheet2.png", 177888, 249, 249, 246, 246, 1, 0.5853658318519592, 0.3902438879013062,[],[-0.1713028252124786,-0.2769628763198853,0.3677591681480408,-0.2066498845815659,0.1294781565666199,0.4769440889358521,-0.3158348202705383,0.277725100517273],0]
			]
			]
		],
		[
		],
		false,
		false,
		6492946500759485,
		[],
		null
	]
,	[
		"t63",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			2561838582680558,
			[
				["artworks-sheet0.png", 321599, 777, 781, 128, 128, 1, 0.5, 0.5,[],[-0.2812489867210388,-0.4374994933605194,0.390625,-0.4140619933605194,0.3359379768371582,0.390625,-0.40625,0.2734379768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			9866457220588441,
			[
				["enemy_exploder_2-sheet0.png", 17347, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2812489867210388,-0.4374994933605194,0.390625,-0.4140619933605194,0.3359379768371582,0.390625,-0.40625,0.2734379768371582],0],
				["enemy_exploder_2-sheet1.png", 4942, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2812489867210388,-0.4374994933605194,0.390625,-0.4140619933605194,0.3359379768371582,0.390625,-0.40625,0.2734379768371582],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			5498224002323844
		]
		],
		false,
		false,
		8088074300942851,
		[],
		null
	]
,	[
		"t64",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			4878409845376094,
			[
				["artworks-sheet1.png", 461366, 775, 131, 128, 128, 1, 0.5, 0.5,[],[-0.2890619933605194,-0.4453125,0.328125,-0.3125,0.3125,0.28125,-0.296875,0.3828129768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			2150725859635857,
			[
				["enemy_exploder_3-sheet0.png", 20821, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2890619933605194,-0.4453125,0.328125,-0.3125,0.3125,0.28125,-0.296875,0.3828129768371582],0],
				["enemy_exploder_3-sheet1.png", 5971, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.2890619933605194,-0.4453125,0.328125,-0.3125,0.3125,0.28125,-0.296875,0.3828129768371582],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			5337356637671769
		]
		],
		false,
		false,
		7958976774872076,
		[],
		null
	]
,	[
		"t65",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			20,
			true,
			1,
			0,
			false,
			2449980076752654,
			[
				["enemy_shooter_2-sheet0.png", 156496, 1, 1, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0],
				["enemy_shooter_2-sheet0.png", 156496, 249, 1, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0],
				["enemy_shooter_2-sheet0.png", 156496, 1, 249, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0],
				["enemy_shooter_2-sheet0.png", 156496, 249, 249, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			2967332942794949,
			[
				["enemy_shooter_2-sheet1.png", 158901, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.2154471576213837, 0.5]],[-0.0429689884185791,-0.34375,0.34375,-0.3554689884185791,-0.0507810115814209,0.1054689884185791,-0.2734369933605194,-0.0351560115814209],0],
				["enemy_shooter_2-sheet1.png", 158901, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.2154471576213837, 0.5]],[-0.0429689884185791,-0.34375,0.34375,-0.3554689884185791,-0.0507810115814209,0.1054689884185791,-0.2734369933605194,-0.0351560115814209],0],
				["enemy_shooter_2-sheet1.png", 158901, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.2154471576213837, 0.5]],[-0.0429689884185791,-0.34375,0.34375,-0.3554689884185791,-0.0507810115814209,0.1054689884185791,-0.2734369933605194,-0.0351560115814209],0],
				["enemy_shooter_2-sheet1.png", 158901, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.2154471576213837, 0.5]],[-0.0429689884185791,-0.34375,0.34375,-0.3554689884185791,-0.0507810115814209,0.1054689884185791,-0.2734369933605194,-0.0351560115814209],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			4517732124077205,
			[
				["enemy_shooter_2-sheet2.png", 64931, 1, 1, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0],
				["enemy_shooter_2-sheet2.png", 64931, 249, 1, 246, 246, 1, 0.5, 0.5,[],[-0.28125,-0.0507810115814209,-0.003906011581420898,-0.3789060115814209,0.3632810115814209,-0.3476560115814209,-0.0117189884185791,0.0976560115814209],0]
			]
			]
		],
		[
		],
		false,
		false,
		265430042201187,
		[],
		null
	]
,	[
		"t66",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			20,
			true,
			1,
			0,
			false,
			2883036403255394,
			[
				["enemy_shooter_3-sheet0.png", 219205, 1, 1, 246, 246, 1, 0.5, 0.5,[],[],0],
				["enemy_shooter_3-sheet0.png", 219205, 249, 1, 246, 246, 1, 0.5, 0.5,[],[],0],
				["enemy_shooter_3-sheet0.png", 219205, 1, 249, 246, 246, 1, 0.5, 0.5,[],[],0],
				["enemy_shooter_3-sheet0.png", 219205, 249, 249, 246, 246, 1, 0.5, 0.5,[],[],0],
				["enemy_shooter_3-sheet1.png", 264744, 1, 1, 246, 246, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			249288398865653,
			[
				["enemy_shooter_3-sheet1.png", 264744, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[],0],
				["enemy_shooter_3-sheet1.png", 264744, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[],0],
				["enemy_shooter_3-sheet1.png", 264744, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[],0],
				["enemy_shooter_3-sheet2.png", 224151, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[],0],
				["enemy_shooter_3-sheet2.png", 224151, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			5881401791668978,
			[
				["enemy_shooter_3-sheet2.png", 224151, 1, 249, 246, 246, 1, 0.5, 0.5,[],[],0],
				["enemy_shooter_3-sheet2.png", 224151, 249, 249, 246, 246, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		1473815171478372,
		[],
		null
	]
,	[
		"t67",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			6937704719962479,
			[
				["artworks-sheet1.png", 461366, 775, 1, 128, 128, 1, 0.5, 0.5,[],[-0.21875,-0.3828119933605194,0.3125,-0.359375,0.3828129768371582,0.296875,-0.3984369933605194,0.3359379768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			4857955471946404,
			[
				["enemy_solid_2-sheet0.png", 23916, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.21875,-0.3828119933605194,0.3125,-0.359375,0.3828129768371582,0.296875,-0.3984369933605194,0.3359379768371582],0],
				["enemy_solid_2-sheet1.png", 6612, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.21875,-0.3828119933605194,0.3125,-0.359375,0.3828129768371582,0.296875,-0.3984369933605194,0.3359379768371582],0]
			]
			]
		],
		[
		],
		false,
		false,
		5541669701348427,
		[],
		null
	]
,	[
		"t68",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			264961141424527,
			[
				["artworks-sheet1.png", 461366, 769, 261, 128, 128, 1, 0.5, 0.5,[],[-0.3125,-0.15625,0.125,-0.453125,0.3359379768371582,0.265625,-0.2890619933605194,0.40625],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			9163050182199348,
			[
				["enemy_solid_3-sheet0.png", 21038, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3125,-0.15625,0.125,-0.453125,0.3359379768371582,0.265625,-0.2890619933605194,0.40625],0],
				["enemy_solid_3-sheet1.png", 5647, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3125,-0.15625,0.125,-0.453125,0.3359379768371582,0.265625,-0.2890619933605194,0.40625],0]
			]
			]
		],
		[
		],
		false,
		false,
		8017242960229933,
		[],
		null
	]
,	[
		"t69",
		cr.plugins_.CJSAds,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		6400132286732414,
		[],
		null
		,[0,0,0,1,"","",""]
	]
,	[
		"t70",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3230397376993056,
			[
				["backgroundshop-sheet0.png", 62925, 0, 0, 512, 256, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3643814134667542,
		[],
		null
	]
,	[
		"t71",
		cr.plugins_.Sprite,
		false,
		[2698026279443718,492446028114469],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			746555282350218,
			[
				["buttonshop-sheet0.png", 7728, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.529411792755127]],[-0.4382719099521637,-0.529411792755127,0.4382719993591309,-0.529411792755127,0.5,0.04429018497467041,0.421887993812561,0.4705882072448731,-0.4218879044055939,0.4705882072448731,-0.5,0.04429018497467041],0],
				["buttonshop-sheet0.png", 7728, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.529411792755127]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonshop-sheet1.png", 11666, 1, 1, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.529411792755127]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonshop-sheet1.png", 11666, 1, 88, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.529411792755127]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0],
				["buttonshop-sheet2.png", 5735, 0, 0, 250, 85, 1, 0.5, 0.529411792755127,[["Imagepoint 1", 0.164000004529953, 0.529411792755127]],[-0.4280000030994415,-0.5058823823928833,0.4279999732971191,-0.5058823823928833,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588232040405273,-0.4120000004768372,0.4588232040405273,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		],
		false,
		false,
		1429192901593711,
		[],
		null
	]
,	[
		"t72",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2479441763785407,
			[
				["warning-sheet0.png", 31342, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.34375,-0.34375,0.3828129768371582,-0.3828119933605194,0.2851560115814209,0,0.2578129768371582,0.2578129768371582,0,0.4101560115814209,-0.2617189884185791,0.2617189884185791,-0.2890619933605194,0],0]
			]
			]
		],
		[
		[
			"Flash",
			cr.behaviors.Flash,
			4466851582310595
		]
		],
		false,
		false,
		9428828385405635,
		[],
		null
	]
,	[
		"t73",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			8553541858442934,
			[
				["ending-sheet0.png", 267654, 1, 1, 502, 246, 1, 0, 0,[],[],0],
				["ending-sheet0.png", 267654, 1, 249, 502, 246, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			4821913314903356
		]
		],
		false,
		false,
		83940066996958,
		[],
		null
	]
,	[
		"t74",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			true,
			1,
			0,
			false,
			2518953683260801,
			[
				["next-sheet0.png", 1447, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.1640619933605194,-0.1640619933605194,0,-0.40625,0.1874999403953552,-0.1875,0.3125,0,0.1874999403953552,0.1874999403953552,0,0.3984379768371582,-0.1640619933605194,0.1640629768371582],0],
				["next-sheet1.png", 1367, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.1640619933605194,-0.1640619933605194,0,-0.40625,0.1874999403953552,-0.1875,0.3125,0,0.1874999403953552,0.1874999403953552,0,0.3984379768371582,-0.1640619933605194,0.1640629768371582],0]
			]
			]
		],
		[
		],
		false,
		false,
		8098505698742248,
		[],
		null
	]
,	[
		"t75",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			6979325447439904,
			[
				["whitefader-sheet0.png", 405, 0, 0, 128, 128, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9981928486503169
		]
		],
		false,
		false,
		631030613524893,
		[],
		null
	]
,	[
		"t76",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			34560287216954,
			[
				["tutorial-sheet0.png", 233199, 1, 1, 502, 246, 1, 0, 0,[],[],0],
				["tutorial-sheet0.png", 233199, 1, 249, 502, 246, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			5708760988927902
		]
		],
		false,
		false,
		774405579109465,
		[],
		null
	]
,	[
		"t77",
		cr.plugins_.Audio,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		7491592401072018,
		[],
		null
		,[0,0,0,1,1,600,600,10000,1,5000,1]
	]
,	[
		"t78",
		cr.plugins_.Text,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		3630099690001402,
		[],
		null
	]
,	[
		"t79",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Stage_1",
			0,
			false,
			1,
			0,
			false,
			5618067453752712,
			[
				["stages-sheet0.png", 778114, 1, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 111, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 221, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 331, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 441, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 551, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 661, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 771, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 881, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 1, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 111, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0]
			]
			]
,			[
			"Stage_2",
			5,
			false,
			1,
			0,
			false,
			3161446847837526,
			[
				["stages-sheet0.png", 778114, 221, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 331, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 441, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 551, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 661, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 771, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 881, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 1, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 111, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 221, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 331, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0]
			]
			]
,			[
			"Stage_3",
			5,
			false,
			1,
			0,
			false,
			1309091806974443,
			[
				["stages-sheet0.png", 778114, 441, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 551, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 661, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 771, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 881, 477, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 1, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 111, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 221, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 331, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 441, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 551, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0]
			]
			]
,			[
			"Stage_4",
			5,
			false,
			1,
			0,
			false,
			4568653788702047,
			[
				["stages-sheet0.png", 778114, 661, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 771, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet0.png", 778114, 881, 715, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 1, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 111, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 221, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 331, 1, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 1, 239, 108, 236, 1, 0, 0.0762711837887764,[],[],0],
				["stages-sheet1.png", 192272, 111, 239, 108, 236, 1, 0, 0.0762711837887764,[],[0,-0.0762711837887764,0.5,-0.0381355844438076,1,-0.0762711837887764,1,0.9237288236618042,0,0.9237288236618042],0],
				["stages-sheet1.png", 192272, 221, 239, 108, 236, 1, 0, 0.0762711837887764,[],[0,-0.0762711837887764,0.5,-0.0381355844438076,1,-0.0762711837887764,1,0.9237288236618042,0,0.9237288236618042],0],
				["stages-sheet1.png", 192272, 221, 239, 108, 236, 1, 0, 0.0762711837887764,[],[0,-0.0762711837887764,0.5,-0.0381355844438076,1,-0.0762711837887764,1,0.9237288236618042,0,0.9237288236618042],0]
			]
			]
		],
		[
		],
		false,
		false,
		8210036580127375,
		[],
		null
	]
,	[
		"t80",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5683283976694163,
			[
				["highlightupgrade-sheet0.png", 1083, 0, 0, 250, 85, 1, 0.5, 0.529411792755127,[],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			8711466464905344
		]
		],
		false,
		false,
		2255062687784104,
		[],
		null
	]
,	[
		"t81",
		cr.plugins_.Sprite,
		false,
		[8682497663152504,5625238327959951],
		1,
		0,
		null,
		[
			[
			"BossLight",
			5,
			true,
			1,
			0,
			false,
			4285593255524006,
			[
				["bosslight-sheet0.png", 2801, 0, 0, 54, 54, 1, 0.4259259402751923, 0.6296296119689941,[],[0.2576680481433868,-0.2858796119689941,0.261574000120163,0.2688083648681641,-0.2853009402751923,0.257089376449585,-0.2735819220542908,-0.2819736003875732],0],
				["bosslight-sheet1.png", 2058, 0, 0, 54, 54, 1, 0.4259259402751923, 0.6296296119689941,[],[0.2576680481433868,-0.2858796119689941,0.261574000120163,0.2688083648681641,-0.2853009402751923,0.257089376449585,-0.2735819220542908,-0.2819736003875732],0],
				["bosslight-sheet0.png", 2801, 0, 0, 54, 54, 1, 0.4259259402751923, 0.6296296119689941,[],[0.2576680481433868,-0.2858796119689941,0.261574000120163,0.2688083648681641,-0.2853009402751923,0.257089376449585,-0.2735819220542908,-0.2819736003875732],0],
				["bosslight-sheet1.png", 2058, 0, 0, 54, 54, 1, 0.4259259402751923, 0.6296296119689941,[],[0.2576680481433868,-0.2858796119689941,0.261574000120163,0.2688083648681641,-0.2853009402751923,0.257089376449585,-0.2735819220542908,-0.2819736003875732],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4497873104545009
		]
		],
		false,
		false,
		7761220161752846,
		[],
		null
	]
,	[
		"t82",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8518391226397281,
			[
				["backgroundcharacters-sheet0.png", 67449, 0, 0, 512, 256, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7404547251361402,
		[],
		null
	]
,	[
		"t83",
		cr.plugins_.Sprite,
		false,
		[3761132095185261,2885068435492347],
		1,
		0,
		null,
		[
			[
			"Normal",
			5,
			false,
			1,
			0,
			false,
			4381112427455575,
			[
				["buttoncharacters-sheet0.png", 84389, 1, 1, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0],
				["buttoncharacters-sheet0.png", 84389, 193, 1, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0]
			]
			]
,			[
			"Rainbow",
			5,
			false,
			1,
			0,
			false,
			7831492590082326,
			[
				["buttoncharacters-sheet0.png", 84389, 1, 249, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0],
				["buttoncharacters-sheet0.png", 84389, 193, 249, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0]
			]
			]
,			[
			"Mecha",
			5,
			false,
			1,
			0,
			false,
			8911778063752112,
			[
				["buttoncharacters-sheet1.png", 58119, 1, 1, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0],
				["buttoncharacters-sheet1.png", 58119, 193, 1, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0]
			]
			]
,			[
			"Locked",
			5,
			false,
			1,
			0,
			false,
			4032169375635214,
			[
				["buttoncharacters-sheet1.png", 58119, 1, 249, 190, 246, 1, 0.5, 0.5040650367736816,[["Imagepoint 1", 0.4842105209827423, 0.3414634168148041]],[-0.4750002920627594,-0.3751590251922607,0,-0.4923462271690369,0.425000011920929,-0.3360960483551025,0.425000011920929,0.3279659748077393,0,0.4842159748077393,-0.4750002920627594,0.3670289516448975],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7204385023419564
		]
		],
		false,
		false,
		7618563391003772,
		[],
		null
	]
,	[
		"t84",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1380758107552498,
			[
				["highlightcharacter-sheet0.png", 2179, 0, 0, 190, 246, 1, 0.5, 0.5040650367736816,[],[-0.4849996864795685,-0.5040650367736816,0.4399999976158142,-0.5001587867736816,0.4399999976158142,0.4881229400634766,-0.4899994134902954,0.4764039516448975],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			2173814767412525
		]
		],
		false,
		false,
		2887679361197059,
		[],
		null
	]
,	[
		"t85",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			355984647003601,
			[
				["thumbbutton-sheet0.png", 7343, 0, 0, 128, 128, 1, 0.5078125, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"DragDrop",
			cr.behaviors.DragnDrop,
			3003688065338781
		]
,		[
			"Bullet",
			cr.behaviors.Bullet,
			9065956279097318
		]
		],
		false,
		false,
		1677780379287962,
		[],
		null
	]
,	[
		"t86",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1246021056259432,
			[
				["facebook-sheet0.png", 2456, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1144966489240894,
		[],
		null
	]
,	[
		"t87",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		1,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5416436614736796,
			[
				["fancybackground-sheet0.png", 274708, 0, 0, 512, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		2872626917734852,
		[["tint", "Tint"]],
		null
	]
,	[
		"t88",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			9018495768074105,
			[
				["artworks-sheet1.png", 461366, 769, 391, 128, 128, 1, 0.5, 0.5,[],[-0.328125,-0.4609375,0.3125,-0.28125,0.3125,0.2734379768371582,-0.328125,0.3671879768371582],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			4562231284942772,
			[
				["enemy_exploder_4-sheet0.png", 23365, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.328125,-0.4609375,0.3125,-0.28125,0.3125,0.2734379768371582,-0.328125,0.3671879768371582],0],
				["enemy_exploder_4-sheet1.png", 4619, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.328125,-0.4609375,0.3125,-0.28125,0.3125,0.2734379768371582,-0.328125,0.3671879768371582],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			89998324308659
		]
		],
		false,
		false,
		5677786831128124,
		[],
		null
	]
,	[
		"t89",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			0,
			true,
			1,
			0,
			false,
			1017434282115545,
			[
				["artworks-sheet1.png", 461366, 517, 511, 128, 128, 1, 0.5, 0.5,[],[-0.34375,-0.3671869933605194,0.1796879768371582,-0.4375,0.328125,0.34375,-0.2734369933605194,0.375],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			9389812767421104,
			[
				["enemy_solid_4-sheet0.png", 17953, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.34375,-0.3671869933605194,0.1796879768371582,-0.4375,0.328125,0.34375,-0.2734369933605194,0.375],0],
				["enemy_solid_4-sheet1.png", 4077, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.34375,-0.3671869933605194,0.1796879768371582,-0.4375,0.328125,0.34375,-0.2734369933605194,0.375],0]
			]
			]
		],
		[
		],
		false,
		false,
		6376287721068593,
		[],
		null
	]
,	[
		"t90",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			20,
			true,
			1,
			0,
			false,
			2442870336154619,
			[
				["enemy_boss_4-sheet0.png", 246438, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.6910569071769714, 0.211382120847702],["Imagepoint 2", 0.2723577320575714, 0.4959349632263184],["Imagepoint 3", 0.6910569071769714, 0.4837398231029511],["Imagepoint 4", 0.5203251838684082, 0.6951219439506531]],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0],
				["enemy_boss_4-sheet0.png", 246438, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.6910569071769714, 0.211382120847702],["Imagepoint 2", 0.2723577320575714, 0.4959349632263184],["Imagepoint 3", 0.6910569071769714, 0.4837398231029511],["Imagepoint 4", 0.5203251838684082, 0.6951219439506531]],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0],
				["enemy_boss_4-sheet0.png", 246438, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.6910569071769714, 0.211382120847702],["Imagepoint 2", 0.2723577320575714, 0.4959349632263184],["Imagepoint 3", 0.6910569071769714, 0.4837398231029511],["Imagepoint 4", 0.5203251838684082, 0.6951219439506531]],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0],
				["enemy_boss_4-sheet0.png", 246438, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.6910569071769714, 0.211382120847702],["Imagepoint 2", 0.2723577320575714, 0.4959349632263184],["Imagepoint 3", 0.6910569071769714, 0.4837398231029511],["Imagepoint 4", 0.5203251838684082, 0.6951219439506531]],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0],
				["enemy_boss_4-sheet1.png", 253570, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.6910569071769714, 0.211382120847702],["Imagepoint 2", 0.2723577320575714, 0.4959349632263184],["Imagepoint 3", 0.6910569071769714, 0.4837398231029511],["Imagepoint 4", 0.5203251838684082, 0.6951219439506531]],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0]
			]
			]
,			[
			"Shoot",
			20,
			false,
			1,
			0,
			false,
			3139518656860364,
			[
				["enemy_boss_4-sheet1.png", 253570, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[-0.265625,-0.3085939884185791,0.328125,-0.3789060115814209,0.28125,0.3398439884185791,-0.2148439884185791,0.375],0],
				["enemy_boss_4-sheet1.png", 253570, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[-0.265625,-0.3085939884185791,0.328125,-0.3789060115814209,0.28125,0.3398439884185791,-0.2148439884185791,0.375],0],
				["enemy_boss_4-sheet1.png", 253570, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[-0.265625,-0.3085939884185791,0.328125,-0.3789060115814209,0.28125,0.3398439884185791,-0.2148439884185791,0.375],0],
				["enemy_boss_4-sheet2.png", 221905, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[-0.265625,-0.3085939884185791,0.328125,-0.3789060115814209,0.28125,0.3398439884185791,-0.2148439884185791,0.375],0],
				["enemy_boss_4-sheet2.png", 221905, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.05691057071089745, 0.5243902206420898]],[-0.265625,-0.3085939884185791,0.328125,-0.3789060115814209,0.28125,0.3398439884185791,-0.2148439884185791,0.375],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			1207401371714038,
			[
				["enemy_boss_4-sheet2.png", 221905, 1, 249, 246, 246, 1, 0.5, 0.5,[],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0],
				["enemy_boss_4-sheet2.png", 221905, 249, 249, 246, 246, 1, 0.5, 0.5,[],[-0.2421869933605194,-0.3203119933605194,0.3164060115814209,-0.3789060115814209,0.2421879768371582,0.3242189884185791,-0.21875,0.359375],0]
			]
			]
		],
		[
		],
		false,
		false,
		368839621905563,
		[],
		null
	]
,	[
		"t91",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		0,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			8123723029871478,
			[
				["enemy_shooter_4-sheet0.png", 281986, 1, 1, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0],
				["enemy_shooter_4-sheet0.png", 281986, 249, 1, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0],
				["enemy_shooter_4-sheet0.png", 281986, 1, 249, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0],
				["enemy_shooter_4-sheet0.png", 281986, 249, 249, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0]
			]
			]
,			[
			"Shoot",
			10,
			false,
			1,
			0,
			false,
			9809214730619914,
			[
				["enemy_shooter_4-sheet1.png", 298105, 1, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.3252032399177551]],[-0.4023436903953552,-0.2226560115814209,0.0625,-0.3789060115814209,0.4023439884185791,0.1328129768371582,-0.171875,0.2929689884185791],0],
				["enemy_shooter_4-sheet1.png", 298105, 249, 1, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.3252032399177551]],[-0.4023436903953552,-0.2226560115814209,0.0625,-0.3789060115814209,0.4023439884185791,0.1328129768371582,-0.171875,0.2929689884185791],0],
				["enemy_shooter_4-sheet1.png", 298105, 1, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.3252032399177551]],[-0.4023436903953552,-0.2226560115814209,0.0625,-0.3789060115814209,0.4023439884185791,0.1328129768371582,-0.171875,0.2929689884185791],0],
				["enemy_shooter_4-sheet1.png", 298105, 249, 249, 246, 246, 1, 0.5, 0.5,[["Imagepoint 1", 0.04878048598766327, 0.3252032399177551]],[-0.4023436903953552,-0.2226560115814209,0.0625,-0.3789060115814209,0.4023439884185791,0.1328129768371582,-0.171875,0.2929689884185791],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			3166816505165837,
			[
				["enemy_shooter_4-sheet2.png", 99888, 1, 1, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0],
				["enemy_shooter_4-sheet2.png", 99888, 249, 1, 246, 246, 1, 0.5, 0.5,[],[-0.3789060115814209,-0.2070310115814209,0.0390629768371582,-0.375,0.421875,0.1640629768371582,-0.21875,0.2617189884185791],0]
			]
			]
		],
		[
		],
		false,
		false,
		577972894141062,
		[],
		null
	]
,	[
		"t92",
		cr.plugins_.Sprite,
		false,
		[7609575955708062],
		0,
		0,
		null,
		[
			[
			"rate",
			5,
			false,
			1,
			0,
			false,
			3815877443768695,
			[
				["socialbuttons-sheet0.png", 21870, 1, 1, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
,			[
			"credits",
			5,
			false,
			1,
			0,
			false,
			8599543364033621,
			[
				["socialbuttons-sheet0.png", 21870, 131, 1, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
,			[
			"like",
			5,
			false,
			1,
			0,
			false,
			85758659223632,
			[
				["socialbuttons-sheet0.png", 21870, 261, 1, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
,			[
			"share",
			5,
			false,
			1,
			0,
			false,
			4413961895060467,
			[
				["socialbuttons-sheet0.png", 21870, 1, 131, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
,			[
			"tweet",
			5,
			false,
			1,
			0,
			false,
			1382962998558603,
			[
				["socialbuttons-sheet0.png", 21870, 131, 131, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1760518029243177,
		[],
		null
	]
,	[
		"t93",
		cr.plugins_.Text,
		false,
		[594495435386649],
		2,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9560337791513665
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			5034885120391903
		]
		],
		false,
		false,
		3006400675025938,
		[],
		null
	]
,	[
		"t94",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8253068271710099,
			[
				["artworks-sheet1.png", 461366, 517, 259, 250, 250, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"ScrollTo",
			cr.behaviors.scrollto,
			8211053871184521
		]
		],
		false,
		false,
		1503515016033098,
		[],
		null
	]
,	[
		"t95",
		cr.plugins_.Particles,
		false,
		[],
		2,
		0,
		["smoke_particles.png", 20414, 0],
		null,
		[
		[
			"Pin",
			cr.behaviors.Pin,
			710091142333814
		]
,		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			4192975177491082
		]
		],
		false,
		false,
		3709021031886281,
		[],
		null
	]
,	[
		"t96",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["spritefont.png", 5679, 0],
		null,
		[
		],
		false,
		false,
		5547489414910443,
		[],
		null
	]
,	[
		"t97",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3277744009210915,
			[
				["backgroundcredits-sheet0.png", 92612, 0, 0, 512, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4386096776333797,
		[],
		null
	]
,	[
		"t98",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5084142615512654,
			[
				["backgroundpopup-sheet0.png", 443, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7228114185086751,
		[],
		null
	]
,	[
		"t99",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5251159617380809,
			[
				["warning_tint-sheet0.png", 411, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Flash",
			cr.behaviors.Flash,
			7646685832967582
		]
		],
		false,
		false,
		1245277083939116,
		[],
		null
	]
,	[
		"t100",
		cr.plugins_.Sprite,
		false,
		[7623882733325794],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4716786590367202,
			[
				["coin-sheet0.png", 14607, 1, 1, 64, 64, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.390625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.390625,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			8258717539244123
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			9676772227351879
		]
		],
		false,
		false,
		2127905239825461,
		[],
		null
	]
,	[
		"t101",
		cr.plugins_.Text,
		false,
		[],
		2,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7742968353001281
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			4606577134331084
		]
		],
		false,
		false,
		2431297501918284,
		[],
		null
	]
,	[
		"t102",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Shield",
			0,
			false,
			1,
			0,
			false,
			2091488052609884,
			[
				["shield-sheet0.png", 11967, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.3203119933605194,-0.3203119933605194,0,-0.453125,-0.3046869933605194,0.3046879768371582,-0.4296875,0,-0.3046869933605194,-0.3046869933605194,0,-0.4335936903953552,-0.3164060115814209,0.3164060115814209,-0.453125,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			793905380202753
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			4815907082766528
		]
		],
		false,
		false,
		4447890359198444,
		[],
		null
	]
,	[
		"t103",
		cr.plugins_.Spritefont2,
		false,
		[],
		1,
		1,
		["text_damage2.png", 21343, 0],
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			1351620197774288
		]
		],
		false,
		false,
		3955753197033413,
		[["tint", "Tint"]],
		null
	]
,	[
		"t104",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			10,
			false,
			0,
			0,
			false,
			9573064142784094,
			[
				["redline-sheet0.png", 4289, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet1.png", 2815, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet0.png", 4289, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet1.png", 2815, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet0.png", 4289, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet1.png", 2815, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0],
				["redline-sheet0.png", 4289, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.203125,-0.203125,0,-0.421875,0.1874999403953552,-0.1875,0.3125,0,0.375,0.375,-0.375,0.375,-0.3125,0],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			1953211018366454
		]
		],
		false,
		false,
		3075309079401507,
		[],
		null
	]
,	[
		"t105",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"blastmark",
			5,
			false,
			1,
			0,
			false,
			9785560266504986,
			[
				["blastmark-sheet0.png", 27357, 0, 0, 128, 128, 1, 0.484375, 0.5859375,[],[-0.3164060115814209,-0.4179685115814209,0.015625,-0.4296875,0.2539060115814209,-0.3242185115814209,0.234375,-0.0859375,0.3671879768371582,0.2656254768371582,0.015625,0.1992185115814209,-0.1367189884185791,0.0664064884185791,-0.2890619933605194,-0.0859375],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			9143726892154925
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			7029364225769731
		]
		],
		false,
		false,
		8638472652925765,
		[],
		null
	]
,	[
		"t106",
		cr.plugins_.Text,
		false,
		[5746543828539467],
		3,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			8411905614806883
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			1429745172526904
		]
,		[
			"Flash",
			cr.behaviors.Flash,
			1221208443215559
		]
		],
		false,
		false,
		7616181614484059,
		[],
		null
	]
,	[
		"t107",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Slide1",
			0,
			true,
			1,
			0,
			false,
			6269326257346509,
			[
				["story-sheet0.png", 433521, 0, 0, 512, 512, 1, 1, 0.5,[],[-1,0.5,-1,-0.5,0,-0.5,0,0.5],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			4467001548496642
		]
,		[
			"Fade",
			cr.behaviors.Fade,
			9201223882353832
		]
		],
		false,
		false,
		5930419643689307,
		[],
		null
	]
,	[
		"t108",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1622317893426389,
			[
				["blackin-sheet0.png", 443, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7770450221720916
		]
		],
		false,
		false,
		5423099637755868,
		[],
		null
	]
,	[
		"t109",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5501581479520327,
			[
				["blackout-sheet0.png", 475, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			6727580551833025
		]
		],
		false,
		false,
		7831858076215934,
		[],
		null
	]
,	[
		"t110",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Slide6",
			4,
			false,
			1,
			0,
			false,
			7866421752815196,
			[
				["story2-sheet0.png", 499859, 1, 1, 502, 246, 1, 0, 0,[],[],0],
				["story2-sheet0.png", 499859, 1, 249, 502, 246, 1, 0, 0,[],[],0],
				["story2-sheet1.png", 508510, 1, 1, 502, 246, 1, 0, 0,[],[],0],
				["story2-sheet1.png", 508510, 1, 249, 502, 246, 1, 0, 0,[],[],0],
				["story2-sheet2.png", 509119, 1, 1, 502, 246, 1, 0, 0,[],[],0],
				["story2-sheet2.png", 509119, 1, 249, 502, 246, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7684959482900732,
		[],
		null
	]
,	[
		"t111",
		cr.plugins_.Text,
		false,
		[],
		1,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			7453140714257945
		]
		],
		false,
		false,
		6647168459995127,
		[],
		null
	]
,	[
		"t112",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5543461314350172,
			[
				["mask-sheet0.png", 442, 0, 0, 128, 128, 1, 0, 1,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		6710397815975784,
		[],
		null
	]
,	[
		"t113",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Idle1",
			5,
			true,
			1,
			0,
			false,
			4988492998140204,
			[
				["layna-sheet0.png", 28154, 0, 0, 128, 256, 1, 0.5, 0.5,[],[-0.15625,-0.328125,0,-0.3828119933605194,0.125,-0.3125,0.2109379768371582,0,0.1874999403953552,0.34375,0,0.3554689884185791,-0.1953119933605194,0.3476560115814209,-0.1484369933605194,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		7334669633801894,
		[],
		null
	]
,	[
		"t114",
		cr.plugins_.Mouse,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		1079307469116797,
		[],
		null
		,[]
	]
,	[
		"t115",
		cr.plugins_.Text,
		false,
		[8243362886802898],
		3,
		0,
		null,
		null,
		[
		[
			"Fade",
			cr.behaviors.Fade,
			2576771026389924
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			7756222882208932
		]
,		[
			"Flash",
			cr.behaviors.Flash,
			7664022564930376
		]
		],
		false,
		false,
		8495827111184279,
		[],
		null
	]
,	[
		"t116",
		cr.plugins_.Sprite,
		false,
		[],
		2,
		0,
		null,
		[
			[
			"Normal",
			5,
			false,
			1,
			0,
			false,
			3647297295879759,
			[
				["ammo_circle-sheet0.png", 3981, 0, 0, 128, 52, 1, 0.5, 0.5,[],[-0.375,-0.1923080086708069,0,-0.3846150040626526,0.3671879768371582,-0.1730769872665405,0.4140629768371582,0,0.3671879768371582,0.1730769872665405,0,0.3846150040626526,-0.375,0.1923080086708069,-0.4375,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3437432716909488
		]
,		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			6886930709973635
		]
		],
		false,
		false,
		9754384749147829,
		[],
		null
	]
,	[
		"t117",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			0,
			false,
			1,
			0,
			false,
			7867517714441245,
			[
				["flare-sheet0.png", 4851, 1, 1, 22, 22, 1, 0.5, 0.5,[],[],0],
				["flare-sheet0.png", 4851, 1, 1, 22, 22, 1, 0.5, 0.5,[],[],0],
				["flare-sheet0.png", 4851, 25, 1, 22, 22, 1, 0.5, 0.5,[],[],0],
				["flare-sheet0.png", 4851, 1, 25, 22, 22, 1, 0.5, 0.5,[],[],0],
				["flare-sheet0.png", 4851, 25, 25, 22, 22, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		4064162779890988,
		[],
		null
	]
,	[
		"t118",
		cr.plugins_.Sprite,
		false,
		[7721844337492949],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3472362791379619,
			[
				["introflare-sheet0.png", 6088, 0, 0, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Flash",
			cr.behaviors.Flash,
			7303710400587735
		]
		],
		false,
		false,
		4285430914106022,
		[],
		null
	]
,	[
		"t119",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			8116285473928394,
			[
				["enemy_trap_1-sheet0.png", 39898, 1, 1, 118, 118, 1, 0.5, 0.5,[],[-0.328125,-0.2890619933605194,0.2890629768371582,-0.3125,0.484375,0.265625,-0.4609375,0.234375],0],
				["enemy_trap_1-sheet0.png", 39898, 121, 1, 118, 118, 1, 0.5, 0.5,[],[-0.328125,-0.2890619933605194,0.2890629768371582,-0.3125,0.484375,0.265625,-0.4609375,0.234375],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			5305080323234751,
			[
				["enemy_trap_1-sheet0.png", 39898, 1, 121, 118, 118, 1, 0.5, 0.5,[],[-0.328125,-0.2890619933605194,0.2890629768371582,-0.3125,0.484375,0.265625,-0.4609375,0.234375],0],
				["enemy_trap_1-sheet0.png", 39898, 121, 121, 118, 118, 1, 0.5, 0.5,[],[-0.328125,-0.2890619933605194,0.2890629768371582,-0.3125,0.484375,0.265625,-0.4609375,0.234375],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			9546456574735827
		]
		],
		false,
		false,
		3114268589040396,
		[],
		null
	]
,	[
		"t120",
		cr.plugins_.Sprite,
		false,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		1,
		0,
		null,
		[
			[
			"Idle",
			10,
			true,
			1,
			0,
			false,
			6271567544553509,
			[
				["enemy_trap_2-sheet0.png", 46670, 131, 1, 118, 118, 1, 0.5, 0.5,[],[-0.421875,-0.140625,0.4609379768371582,-0.1875,0.4609379768371582,0.1953129768371582,-0.421875,0.1874999403953552],0],
				["enemy_trap_2-sheet0.png", 46670, 131, 121, 118, 118, 1, 0.5, 0.5,[],[-0.421875,-0.140625,0.4609379768371582,-0.1875,0.4609379768371582,0.1953129768371582,-0.421875,0.1874999403953552],0]
			]
			]
,			[
			"Death",
			5,
			false,
			1,
			0,
			false,
			9619436607071178,
			[
				["enemy_trap_2-sheet0.png", 46670, 1, 1, 128, 128, 1, 0.5, 0.5,[],[-0.421875,-0.140625,0.4609379768371582,-0.1875,0.4609379768371582,0.1953129768371582,-0.421875,0.1874999403953552],0],
				["enemy_trap_2-sheet1.png", 3254, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.421875,-0.140625,0.4609379768371582,-0.1875,0.4609379768371582,0.1953129768371582,-0.421875,0.1874999403953552],0]
			]
			]
		],
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			2050717457917922
		]
		],
		false,
		false,
		669613431049754,
		[],
		null
	]
,	[
		"t121",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6104513920728075,
			[
				["garagemask-sheet0.png", 10824, 0, 0, 256, 128, 1, 0.5, 0.5,[],[0,-0.5,0.3198590278625488,-0.1796869933605194,0.3304039835929871,0,0.3145869970321655,0.1703130006790161,0,-0.2015619874000549,-0.03690698742866516,-0.3234370052814484,0.0623900294303894,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		6174046170987615,
		[],
		null
	]
,	[
		"t122",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"boost",
			20,
			true,
			1,
			0,
			false,
			8248648535031449,
			[
				["boost-sheet0.png", 3057, 1, 1, 54, 54, 1, 0.5925925970077515, 0.5,[],[],0],
				["boost-sheet0.png", 3057, 57, 1, 54, 54, 1, 0.5925925970077515, 0.5,[],[],0],
				["boost-sheet0.png", 3057, 1, 57, 54, 54, 1, 0.5925925970077515, 0.5,[],[],0],
				["boost-sheet0.png", 3057, 57, 57, 54, 54, 1, 0.5925925970077515, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			6762522309765171
		]
		],
		false,
		false,
		9575121546881804,
		[],
		null
	]
,	[
		"t123",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			386565467999094,
			[
				["highlightupgrade-sheet0.png", 1083, 0, 0, 250, 85, 1, 0.5, 0.529411792755127,[],[-0.4279999136924744,-0.5058816075325012,0.4279999732971191,-0.5058816075325012,0.4959999918937683,1.788139343261719e-007,0.4120000004768372,0.4588242173194885,-0.41199991106987,0.4588242173194885,-0.4959999918937683,1.788139343261719e-007],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			684174718531326
		]
		],
		false,
		false,
		8914177515785101,
		[],
		null
	]
,	[
		"t124",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Slide2",
			0,
			false,
			1,
			0,
			false,
			9935095438316095,
			[
				["story3-sheet0.png", 620483, 1, 1, 502, 246, 1, 0, 0,[],[],0]
			]
			]
,			[
			"Slide3",
			0,
			false,
			1,
			0,
			false,
			2853534420672498,
			[
				["story3-sheet0.png", 620483, 1, 249, 502, 246, 1, 0, 0,[],[],0]
			]
			]
,			[
			"Slide4",
			0,
			false,
			1,
			0,
			false,
			7428646578833862,
			[
				["story3-sheet1.png", 592453, 1, 1, 502, 246, 1, 0, 0,[],[],0]
			]
			]
,			[
			"Slide5",
			0,
			false,
			1,
			0,
			false,
			184700271344674,
			[
				["story3-sheet1.png", 592453, 1, 249, 502, 246, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			5886959801615428
		]
		],
		false,
		false,
		5788151730058321,
		[],
		null
	]
,	[
		"t125",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Normal",
			20,
			true,
			1,
			0,
			false,
			8096350933508342,
			[
				["player-sheet0.png", 387012, 1, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player-sheet0.png", 387012, 259, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player-sheet0.png", 387012, 517, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player_loading-sheet0.png", 70716, 1, 1, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0],
				["player_loading-sheet0.png", 70716, 1, 131, 256, 128, 1, 0.43359375, 0.5078125,[["Imagepoint 1", 0.77734375, 0.265625]],[-0.1445307433605194,-0.1874994933605194,0.2031252384185791,-0.1640625,0.2460942268371582,0.2734375,-0.2421877533197403,0.1718754768371582],0]
			]
			]
,			[
			"Mecha",
			20,
			true,
			1,
			0,
			false,
			7568928956214222,
			[
				["player-sheet0.png", 387012, 517, 781, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player-sheet1.png", 451951, 1, 1, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player-sheet1.png", 451951, 259, 1, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player_loading-sheet0.png", 70716, 1, 261, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0],
				["player_loading-sheet1.png", 96613, 1, 1, 256, 128, 1, 0.46484375, 0.390625,[["Imagepoint 1", 0.8515625, 0.3203125]],[-0.1953127384185791,-0.2734369933605194,0.1953122615814209,-0.1484369933605194,0.09765625,0.1953129768371582,-0.0624997615814209,0.3125],0]
			]
			]
,			[
			"Rainbow",
			20,
			true,
			1,
			0,
			false,
			3154863558315027,
			[
				["player-sheet1.png", 451951, 259, 651, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player-sheet1.png", 451951, 517, 651, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player-sheet1.png", 451951, 1, 781, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player_loading-sheet1.png", 96613, 1, 131, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0],
				["player_loading-sheet1.png", 96613, 1, 261, 256, 128, 1, 0.36328125, 0.4609375,[["Imagepoint 1", 0.75390625, 0.3046875]],[-0.0468752384185791,-0.2499994933605194,0.2499997615814209,-0.2031244933605194,0.10546875,0.4140625,-0.23828125,0.3515625],0]
			]
			]
		],
		[
		],
		false,
		false,
		268391869136991,
		[],
		null
	]
,	[
		"t126",
		cr.plugins_.Sprite,
		false,
		[5518119869991582],
		2,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			10618955660395,
			[
				["coin-sheet0.png", 14607, 1, 1, 64, 64, 1, 0.5, 0.5,[],[-0.28125,-0.28125,0,-0.390625,0.28125,-0.28125,0.40625,0,0.28125,0.28125,0,0.40625,-0.28125,0.28125,-0.390625,0],0]
			]
			]
,			[
			"dropped",
			10,
			true,
			1,
			0,
			false,
			613952209498575,
			[
				["coin-sheet0.png", 14607, 67, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 133, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 1, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["coin-sheet0.png", 14607, 67, 67, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			3700948053012149
		]
,		[
			"Pin",
			cr.behaviors.Pin,
			5267329716614883
		]
		],
		false,
		false,
		9080339453315471,
		[],
		null
	]
,	[
		"t127",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			4,
			true,
			1,
			0,
			false,
			9590276429795173,
			[
				["confirmstart-sheet0.png", 16523, 1, 1, 246, 118, 1, 0.5, 0.5,[],[-0.4804686903953552,-0.4609375,0,-0.4921875,0.4804689884185791,-0.4609375,0.4960939884185791,0,0.484375,0.46875,0,0.5,-0.4804686903953552,0.4609379768371582,-0.49609375,0],0],
				["confirmstart-sheet0.png", 16523, 1, 121, 246, 118, 1, 0.5, 0.5,[],[-0.4804686903953552,-0.4609375,0,-0.4921875,0.4804689884185791,-0.4609375,0.4960939884185791,0,0.484375,0.46875,0,0.5,-0.4804686903953552,0.4609379768371582,-0.49609375,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1993239271238485,
		[],
		null
	]
,	[
		"t128",
		cr.plugins_.Sprite,
		false,
		[1175882623420589],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5222517047001323,
			[
				["backbutton-sheet0.png", 5793, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.4921875,0.4609379768371582,-0.4609375,0.4921879768371582,0,0.46875,0.46875,0,0.5,-0.4609375,0.4609379768371582,-0.4921875,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		863205589456105,
		[],
		null
	]
,	[
		"t129",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			5924228540218063,
			[
				["smokescreen-sheet0.png", 64288, 1, 1, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 57, 1, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 113, 1, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 169, 1, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 1, 57, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 57, 57, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 113, 57, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 169, 57, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 1, 113, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 57, 113, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 113, 113, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 169, 113, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 1, 169, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 57, 169, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 113, 169, 54, 54, 1, 0.5, 0.5,[],[],0],
				["smokescreen-sheet0.png", 64288, 169, 169, 54, 54, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9016392062853545
		]
		],
		false,
		false,
		1267385105747597,
		[],
		null
	]
,	[
		"t130",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			9675517616676415,
			[
				["forcefield_ammo-sheet0.png", 47128, 1, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 67, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 133, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 1, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 67, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 133, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 1, 133, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 67, 133, 64, 64, 1, 0.5, 0.5,[],[],0],
				["forcefield_ammo-sheet0.png", 47128, 133, 133, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3218471606511186,
		[],
		null
	]
,	[
		"t131",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			796111713897611,
			[
				["grenade_ammo-sheet0.png", 28554, 1, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 67, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 133, 1, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 1, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 67, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 133, 67, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 1, 133, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 67, 133, 64, 64, 1, 0.5, 0.5,[],[],0],
				["grenade_ammo-sheet0.png", 28554, 133, 133, 64, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3336536888319179,
		[],
		null
	]
,	[
		"t132",
		cr.plugins_.Sprite,
		false,
		[8767712427539122],
		0,
		0,
		null,
		[
			[
			"achievement",
			20,
			false,
			1,
			0,
			false,
			7652139266555057,
			[
				["mainmenu_highlight-sheet0.png", 30484, 1, 517, 128, 128, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 131, 517, 128, 128, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 261, 517, 128, 128, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 391, 517, 128, 128, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 1, 517, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"upgrade",
			20,
			false,
			1,
			0,
			false,
			8223031994330238,
			[
				["mainmenu_highlight-sheet0.png", 30484, 1, 1, 256, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 259, 1, 256, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 517, 1, 256, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 1, 259, 256, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 1, 1, 256, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"character",
			20,
			false,
			1,
			0,
			false,
			5667700928557679,
			[
				["mainmenu_highlight-sheet0.png", 30484, 649, 259, 256, 64, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 649, 325, 256, 64, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 649, 391, 256, 64, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 649, 457, 256, 64, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 649, 259, 256, 64, 1, 0.5, 0.5,[],[],0]
			]
			]
,			[
			"catalogue",
			20,
			false,
			1,
			0,
			false,
			6467187288863485,
			[
				["mainmenu_highlight-sheet0.png", 30484, 775, 1, 128, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 259, 259, 128, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 389, 259, 128, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 519, 259, 128, 256, 1, 0.5, 0.5,[],[],0],
				["mainmenu_highlight-sheet0.png", 30484, 775, 1, 128, 256, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7362350149605276,
		[],
		null
	]
,	[
		"t133",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			10,
			true,
			1,
			0,
			false,
			3790024836096027,
			[
				["smokescreen_black-sheet0.png", 56659, 1, 1, 54, 54, 1, 0.5, 0.5,[],[0.2037039995193481,0.2037039995193481,0,0.2222219705581665,-0.1666670143604279,0.1666669845581055,0.4074069857597351,0.4074069857597351,0,0.3518519997596741,-0.2037039995193481,0.2037039995193481],0],
				["smokescreen_black-sheet0.png", 56659, 57, 1, 54, 54, 1, 0.5, 0.5,[],[0.2777779698371887,0.2777779698371887,0,0.1666669845581055,0.4074069857597351,0.4074069857597351,0,0.3333330154418945],0],
				["smokescreen_black-sheet0.png", 56659, 113, 1, 54, 54, 1, 0.5, 0.5,[],[0.2592589855194092,0.2592589855194092,0,0.1666669845581055,0.3888890147209168,0.3888890147209168,0,0.3148149847984314],0],
				["smokescreen_black-sheet0.png", 56659, 169, 1, 54, 54, 1, 0.5, 0.5,[],[0.2592589855194092,0.2592589855194092,0,0.2037039995193481,0.3703699707984924,0.3703699707984924,0,0.2962960004806519],0],
				["smokescreen_black-sheet0.png", 56659, 1, 57, 54, 54, 1, 0.5, 0.5,[],[0.2407410144805908,0.2407410144805908,0,0.2592589855194092,-0.1666670143604279,0.1666669845581055,0.3518519997596741,0.3518519997596741,0,0.2777779698371887,-0.3518519997596741,0.3518519997596741],0],
				["smokescreen_black-sheet0.png", 56659, 57, 57, 54, 54, 1, 0.5, 0.5,[],[0.2222219705581665,0.2222219705581665,0,0.2777779698371887,-0.1666670143604279,0.1666669845581055,0.3333330154418945,0.3333330154418945,0,0.3888890147209168,-0.3703700006008148,0.3703699707984924],0],
				["smokescreen_black-sheet0.png", 56659, 113, 57, 54, 54, 1, 0.5, 0.5,[],[0.2037039995193481,0.2037039995193481,0,0.2777779698371887,-0.1851849853992462,0.1851850152015686,0.2962960004806519,0.2962960004806519,0,0.4074069857597351,-0.3333330154418945,0.3333330154418945],0],
				["smokescreen_black-sheet0.png", 56659, 169, 57, 54, 54, 1, 0.5, 0.5,[],[0.1851850152015686,0.1851850152015686,0,0.2592589855194092,-0.2222220003604889,0.2222219705581665,0.2777779698371887,0.2777779698371887,0,0.4074069857597351,-0.3148149847984314,0.3148149847984314],0],
				["smokescreen_black-sheet0.png", 56659, 1, 113, 54, 54, 1, 0.5, 0.5,[],[0.1666669845581055,0.1666669845581055,0,0.2222219705581665,0.2407410144805908,0.2407410144805908,0,0.3888890147209168],0],
				["smokescreen_black-sheet0.png", 56659, 57, 113, 54, 54, 1, 0.5, 0.5,[],[0.1481480002403259,0.1481480002403259,0,0.2037039995193481,-0.2592589855194092,0.2592589855194092,0.3703699707984924,0.3703699707984924,0,0.3703699707984924,-0.2962960004806519,0.2962960004806519],0],
				["smokescreen_black-sheet0.png", 56659, 113, 113, 54, 54, 1, 0.5, 0.5,[],[0.1666669845581055,0.1666669845581055,0,0.1666669845581055,-0.2777779996395111,0.2777779698371887,0.3518519997596741,0.3518519997596741,-0.3148149847984314,0.3148149847984314],0],
				["smokescreen_black-sheet0.png", 56659, 169, 113, 54, 54, 1, 0.5, 0.5,[],[0.2777779698371887,0.2777779698371887,0,0.1666669845581055,-0.2592589855194092,0.2592589855194092,0.3518519997596741,0.3518519997596741,0,0.2777779698371887,-0.3703700006008148,0.3703699707984924],0],
				["smokescreen_black-sheet0.png", 56659, 1, 169, 54, 54, 1, 0.5, 0.5,[],[0.2407410144805908,0.2407410144805908,0,0.1666669845581055,-0.2037039995193481,0.2037039995193481,0.3333330154418945,0.3333330154418945,0,0.2222219705581665,-0.4074074029922485,0.4074069857597351],0],
				["smokescreen_black-sheet0.png", 56659, 57, 169, 54, 54, 1, 0.5, 0.5,[],[0.2037039995193481,0.2037039995193481,0,0.1666669845581055,-0.1666670143604279,0.1666669845581055,0.3148149847984314,0.3148149847984314,0,0.1851850152015686,-0.4074074029922485,0.4074069857597351],0],
				["smokescreen_black-sheet0.png", 56659, 113, 169, 54, 54, 1, 0.5, 0.5,[],[0.1666669845581055,0.1666669845581055,-0.1481480002403259,0.1481480002403259,0.2962960004806519,0.2962960004806519,-0.3888890147209168,0.3888890147209168],0],
				["smokescreen_black-sheet0.png", 56659, 169, 169, 54, 54, 1, 0.5, 0.5,[],[0.1666669845581055,0.1666669845581055,0,0.2777779698371887,-0.1666670143604279,0.1666669845581055,0.3888890147209168,0.3888890147209168,-0.3518519997596741,0.3518519997596741],0]
			]
			]
		],
		[
		],
		false,
		false,
		4501252685481141,
		[],
		null
	]
,	[
		"t134",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6296592680397734,
			[
				["titlelogo-sheet0.png", 72808, 0, 0, 512, 126, 1, 0.5, 0.5,[],[-0.4609375,-0.3412699997425079,0,-0.4444443881511688,0.4609379768371582,-0.3412699997425079,0.4394530057907105,0,0.4121090173721314,0.1428570151329041,0,0.4047619700431824,-0.4140625,0.1507940292358398,-0.4414061903953552,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		1711977537610269,
		[],
		null
	]
,	[
		"t135",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3901716475023559,
			[
				["rating2-sheet0.png", 2306, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		292508348411418,
		[],
		null
	]
,	[
		"t136",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6460314586268432,
			[
				["credits-sheet0.png", 2241, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.484375,0.453125,-0.453125,0.46875,0,0.4453129768371582,0.4453129768371582,0,0.46875,-0.453125,0.453125,-0.4765625,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5924988622027136,
		[],
		null
	]
,	[
		"t137",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2541890497399531,
			[
				["scrollhelper-sheet0.png", 107, 0, 0, 1, 1, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Bullet",
			cr.behaviors.Bullet,
			455079833094937
		]
		],
		false,
		false,
		8641912743052444,
		[],
		null
	]
,	[
		"t138",
		cr.plugins_.Sprite,
		false,
		[4004452093310002],
		0,
		0,
		null,
		[
			[
			"upgrades",
			5,
			true,
			1,
			0,
			false,
			9813157374715529,
			[
				["ping-sheet0.png", 18120, 1, 113, 118, 54, 1, 0.5, 0.5,[],[-0.390625,-0.28125,0,-0.203125,0.3515629768371582,-0.203125,-0.078125,0,0.25,0,0,0.421875,-0.2734369933605194,0.046875,-0.2734369933605194,0],0],
				["ping-sheet0.png", 18120, 121, 113, 118, 54, 1, 0.5, 0.5,[],[-0.390625,-0.28125,0,-0.203125,0.3515629768371582,-0.203125,-0.078125,0,0.25,0,0,0.421875,-0.2734369933605194,0.046875,-0.2734369933605194,0],0]
			]
			]
,			[
			"missions",
			5,
			true,
			1,
			0,
			false,
			7951768114129471,
			[
				["ping-sheet0.png", 18120, 1, 1, 165, 54, 1, 0.5030303001403809, 0.5,[],[-0.4230303168296814,-0.28125,-0.005887299776077271,-0.1875,0.3883987069129944,-0.203125,0.3141127228736877,0,-0.005887299776077271,-0.015625,-0.3201732933521271,0],0],
				["ping-sheet0.png", 18120, 1, 57, 165, 54, 1, 0.5030303001403809, 0.5,[],[-0.4230303168296814,-0.28125,-0.005887299776077271,-0.1875,0.3883987069129944,-0.203125,0.3141127228736877,0,-0.005887299776077271,-0.015625,-0.3201732933521271,0],0]
			]
			]
,			[
			"vehicles",
			5,
			true,
			1,
			0,
			false,
			9797547198505791,
			[
				["ping-sheet0.png", 18120, 1, 169, 118, 54, 1, 0.5, 0.5,[],[-0.34375,-0.1875,0,0.234375,0.3359379768371582,-0.171875,0.234375,-0.03125,0,0.421875,-0.234375,-0.03125],0],
				["ping-sheet0.png", 18120, 121, 169, 118, 54, 1, 0.5, 0.5,[],[-0.34375,-0.1875,0,0.234375,0.3359379768371582,-0.171875,0.234375,-0.03125,0,0.421875,-0.234375,-0.03125],0]
			]
			]
,			[
			"catalogue",
			5,
			true,
			1,
			0,
			false,
			8760168441151518,
			[
				["ping-sheet1.png", 4630, 1, 1, 118, 54, 1, 0.5, 0.5,[],[-0.3828119933605194,-0.265625,0,0.234375,0.3125,-0.125,0.2109379768371582,0,0.25,0,0,0.421875,-0.2421869933605194,-0.015625,0.1796879768371582,0],0],
				["ping-sheet1.png", 4630, 1, 57, 118, 54, 1, 0.5, 0.5,[],[-0.3828119933605194,-0.265625,0,0.234375,0.3125,-0.125,0.2109379768371582,0,0.25,0,0,0.421875,-0.2421869933605194,-0.015625,0.1796879768371582,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5950991017021907,
		[],
		null
	]
,	[
		"t139",
		cr.plugins_.Sprite,
		false,
		[5394984284027154],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2548128163085632,
			[
				["note-sheet0.png", 14189, 1, 1, 256, 128, 1, 0.5, 0.515625,[],[-0.3476560115814209,-0.2109369933605194,0,-0.15625,0.3359379768371582,-0.1875,0.296875,0.078125,0,-0.09375,-0.3164060115814209,0.1171879768371582],0],
				["note-sheet0.png", 14189, 1, 131, 256, 128, 1, 0.5, 0.515625,[],[-0.3554689884185791,-0.2265619933605194,0,-0.1875,0.3007810115814209,-0.1171869933605194,0.1015629768371582,-0.015625,0.359375,0.203125,0,0.2109379768371582,-0.3398439884185791,0.1640629768371582,0.0351560115814209,-0.015625],0]
			]
			]
		],
		[
		],
		false,
		false,
		31373196387014,
		[],
		null
	]
,	[
		"t140",
		cr.plugins_.Sprite,
		false,
		[1016997083577179],
		1,
		0,
		null,
		[
			[
			"Red",
			5,
			true,
			1,
			0,
			false,
			1292480664215377,
			[
				["tutorialui-sheet0.png", 781, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.4140625,-0.4140625,0,-0.4609375,0.4140629768371582,-0.4140625,0.40625,0.40625,0,0.453125,-0.4140625,0.4140629768371582],0],
				["rocketdestroyenemy-sheet0.png", 37088, 67, 133, 64, 64, 1, 0.5, 0.5,[],[-0.4140625,-0.4140625,0,-0.4609375,0.4140629768371582,-0.4140625,0.40625,0.40625,0,0.453125,-0.4140625,0.4140629768371582],0]
			]
			]
,			[
			"Green",
			5,
			true,
			1,
			0,
			false,
			7158496318808351,
			[
				["tutorialui-sheet1.png", 875, 0, 0, 64, 64, 1, 0.5, 0.5,[],[-0.4140625,-0.4140625,0,-0.4609375,0.4140629768371582,-0.4140625,0.40625,0.40625,0,0.453125,-0.4140625,0.4140629768371582],0],
				["rocketdestroyenemy-sheet0.png", 37088, 67, 133, 64, 64, 1, 0.5, 0.5,[],[-0.4140625,-0.4140625,0,-0.4609375,0.4140629768371582,-0.4140625,0.40625,0.40625,0,0.453125,-0.4140625,0.4140629768371582],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			3789171234988459
		]
		],
		false,
		false,
		1663885081851626,
		[],
		null
	]
,	[
		"t141",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6471934761935995,
			[
				["backbutton-sheet0.png", 5793, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.4609375,-0.4609375,0,-0.4921875,0.4609379768371582,-0.4609375,0.4921879768371582,0,0.46875,0.46875,0,0.5,-0.4609375,0.4609379768371582,-0.4921875,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9577816118737315,
		[],
		null
	]
,	[
		"t142",
		cr.plugins_.Sprite,
		false,
		[8824036033984015],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5296414998048327,
			[
				["credit_list-sheet0.png", 6311, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.1796869933605194,-0.1796869933605194,0,-0.1835939884185791,0.1679689884185791,-0.1679689884185791,0.2890629768371582,0,0.1914060115814209,0.1914060115814209,-0.1992189884185791,0.1992189884185791,0.2617189884185791,0],0],
				["credit_list-sheet1.png", 12973, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.265625,-0.265625,0.2695310115814209,-0.2695310115814209,0.1601560115814209,0,0.2421879768371582,0.2421879768371582,0,0.4804689884185791,-0.4414061903953552,0.4414060115814209,-0.4648436903953552,0],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			229688866993403
		]
		],
		false,
		false,
		2526762594558302,
		[],
		null
	]
,	[
		"t143",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8880756867644448,
			[
				["gameovertext-sheet0.png", 8718, 0, 0, 512, 256, 1, 0.5, 0.5,[],[-0.2753909826278687,-0.0507810115814209,0,-0.203125,0.2695310115814209,-0.03906199336051941,0.4882810115814209,0,0.2734379768371582,0.046875,0,0.1914060115814209,-0.2617189884185791,0.0234379768371582,-0.4667969048023224,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		6590275417732629,
		[],
		null
	]
,	[
		"t144",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			true,
			1,
			0,
			false,
			6961507341924684,
			[
				["orbs-sheet0.png", 1218, 0, 0, 32, 32, 1, 1.875, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-1.703125,0.328125,-1.84375,0,-1.703125,-0.328125,-1.375,-0.453125,-1.054687023162842,-0.3203119933605194,-0.9140620231628418,0,-1.046875,0.328125,-1.375,0.4609379768371582],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			7997383278286486
		]
		],
		false,
		false,
		3170781231558472,
		[],
		null
	]
,	[
		"t145",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			true,
			1,
			0,
			false,
			5396715836832503,
			[
				["orbs-sheet0.png", 1218, 0, 0, 32, 32, 1, 1.875, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-1.703125,0.328125,-1.84375,0,-1.703125,-0.328125,-1.375,-0.453125,-1.054687023162842,-0.3203119933605194,-0.9140620231628418,0,-1.046875,0.328125,-1.375,0.4609379768371582],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4485930099003927
		]
		],
		false,
		false,
		3005875332156071,
		[],
		null
	]
,	[
		"t146",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			0,
			true,
			1,
			0,
			false,
			5178137379374872,
			[
				["orbs-sheet0.png", 1218, 0, 0, 32, 32, 1, 1.875, 0.5,[["Imagepoint 1", 0.5, 0.5]],[-1.703125,0.328125,-1.84375,0,-1.703125,-0.328125,-1.375,-0.453125,-1.054687023162842,-0.3203119933605194,-0.9140620231628418,0,-1.046875,0.328125,-1.375,0.4609379768371582],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			4848566639154886
		]
		],
		false,
		false,
		5934539773201805,
		[],
		null
	]
,	[
		"t147",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"shape",
			1,
			false,
			1,
			0,
			false,
			9679786452781889,
			[
				["shape-sheet0.png", 232936, 0, 0, 502, 246, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9754702862417974
		]
		],
		false,
		false,
		277354934607313,
		[],
		null
	]
,	[
		"t148",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9588896536988572,
			[
				["title_white-sheet0.png", 165, 0, 0, 32, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			9376796337695799
		]
		],
		false,
		false,
		4762306263148969,
		[],
		null
	]
,	[
		"t149",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2421949520321225,
			[
				["player_hit-sheet0.png", 5182, 0, 0, 128, 128, 1, 0, 0,[],[],0]
			]
			]
		],
		[
		[
			"Fade",
			cr.behaviors.Fade,
			8282763907415403
		]
		],
		false,
		false,
		6989938053440183,
		[],
		null
	]
,	[
		"t150",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3095987015276117,
			[
				["highlightupgrade-sheet0.png", 1083, 0, 0, 250, 85, 1, 0.5, 0.5058823823928833,[],[-0.4279999136924744,-0.4823521971702576,0.4279999732971191,-0.4823521971702576,0.4959999918937683,0.02352958917617798,0.4120000004768372,0.4823536276817322,-0.41199991106987,0.4823536276817322,-0.4959999918937683,0.02352958917617798],0]
			]
			]
		],
		[
		[
			"Pin",
			cr.behaviors.Pin,
			1890941500689702
		]
		],
		false,
		false,
		7834359697602986,
		[],
		null
	]
,	[
		"t151",
		cr.plugins_.Sprite,
		false,
		[9830797958094654],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9477990964667854,
			[
				["gamespeedbg-sheet0.png", 610, 0, 0, 250, 85, 1, 0.5, 0.5058823823928833,[],[-0.4839999973773956,-0.4588235914707184,0,-0.4823529720306397,0.484000027179718,-0.4588235914707184,0.4959999918937683,-0.01176437735557556,0.484000027179718,0.4470586180686951,0,0.482352614402771,-0.4839999973773956,0.4470586180686951,-0.4959999918937683,-0.01176437735557556],0]
			]
			]
		],
		[
		],
		false,
		false,
		207212209148296,
		[],
		null
	]
,	[
		"t152",
		cr.plugins_.Sprite,
		true,
		[4193720929942528,969804187716241,6498492997112083,7038601351437344,3126954576978324,4895944099337276,3034751649729148,5278097064057907,6679088622707549,7628853345338871],
		3,
		1,
		null,
		null,
		[
		[
			"Flash",
			cr.behaviors.Flash,
			986585260316244
		]
,		[
			"Nickname",
			cr.behaviors.Rex_bNickname,
			4975633604858552
		]
,		[
			"DestroyOutsideLayout2",
			cr.behaviors.destroy,
			8490899043639233
		]
		],
		false,
		false,
		9238965621703121,
		[["tint", "Tint"]],
		null
	]
,	[
		"t153",
		cr.plugins_.Sprite,
		true,
		[3464120847041606,6210031047786964,7781717888966151],
		1,
		0,
		null,
		null,
		[
		[
			"DestroyOutsideLayout",
			cr.behaviors.destroy,
			9006465464269858
		]
		],
		false,
		false,
		7648209159938145,
		[],
		null
	]
,	[
		"t154",
		cr.plugins_.Sprite,
		true,
		[],
		1,
		0,
		null,
		null,
		[
		[
			"Nickname",
			cr.behaviors.Rex_bNickname,
			9851211661507834
		]
		],
		false,
		false,
		6002018833583398,
		[],
		null
	]
	],
	[
		[152,55,61,62,90,18,63,64,88,19,65,66,91,20,67,68,89,119,120]
,		[153,25,26,27]
,		[154,79]
	],
	[
	[
		"Menu",
		1136,
		640,
		true,
		"Menu",
		7149293822721916,
		[
		[
			"BLACK",
			0,
			2870095964102435,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"Intro",
			1,
			9184401975692943,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[572, 304, 0, 610.3162231445313, 312.3102416992188, 0, 0, 1, 0.51171875, 0.4198473393917084, 0, 0, []],
				0,
				0,
				[
					["intro"]
				],
				[
				[
					0,
					1,
					1,
					1,
					1
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Story",
			2,
			335064516081709,
			false,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-1039, 811, 0, 1136, 1136, 0, 1.570796370506287, 1, 1, 0.5, 0, 0, []],
				107,
				427,
				[
				],
				[
				[
					25,
					0,
					0,
					0,
					1,
					1
				],
				[
					0,
					2,
					22,
					2,
					1
				]
				],
				[
					1,
					"default",
					0,
					1
				]
			]
,			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				108,
				428,
				[
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 320, 0, 1325.536010742188, 746.7808837890625, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				109,
				429,
				[
				],
				[
				[
					0,
					2,
					6,
					0,
					1
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[2226, 721, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				110,
				431,
				[
				],
				[
				],
				[
					0,
					"default",
					0,
					1
				]
			]
,			[
				[568, 882, 0, 1136, 227, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				111,
				432,
				[
				],
				[
				[
					1,
					1,
					3,
					2,
					0
				]
				],
				[
					"Text",
					0,
					"bold 36pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[-624, 1098, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				124,
				448,
				[
				],
				[
				[
					0,
					2,
					12,
					2,
					1
				]
				],
				[
					1,
					"default",
					0,
					1
				]
			]
,			[
				[963, -200, 0, 451, 167, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				430,
				[
					["skip_intro"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Skip Intro",
					0,
					"bold 36pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[573, 237, 0, 1579.838012695313, 1579.838012695313, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				118,
				177,
				[
					["intro"]
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[558, 293, 0, 1331.169189453125, 1047.966064453125, 0, 0.2178337275981903, 0.5, 0.5, 0.5, 1, 0, []],
				129,
				246,
				[
				],
				[
				[
					1,
					2,
					40,
					2,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[763, 1224, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				147,
				96,
				[
				],
				[
				[
					1,
					3,
					4,
					2,
					1
				]
				],
				[
					0,
					"default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"TitleScreen",
			3,
			3121278982765154,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				1,
				1,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 320, 0, 1356.399536132813, 1196.219116210938, 0, 0.5374003648757935, 0.300000011920929, 0.5, 0.5, 0, 0, []],
				133,
				449,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 449, 0, 601, 118, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				93,
				467,
				[
					["start_game"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				]
				],
				[
					"Start Game",
					0,
					"bold 60pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[568, 548, 0, 453.0496520996094, 119.8544082641602, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				93,
				476,
				[
					["options"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				]
				],
				[
					"Options",
					0,
					"bold 60pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[78, 544, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				490,
				[
					["rate"]
				],
				[
				],
				[
					0,
					"rate",
					0,
					1
				]
			]
,			[
				[573.1171264648438, 275.2354125976563, 0, 1026.091064453125, 252.5146179199219, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				134,
				539,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[232, 544, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				546,
				[
					["like"]
				],
				[
				],
				[
					0,
					"like",
					0,
					1
				]
			]
,			[
				[1062, 544, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				550,
				[
					["share"]
				],
				[
				],
				[
					0,
					"share",
					0,
					1
				]
			]
,			[
				[913, 544, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				21,
				[
					["tweet"]
				],
				[
				],
				[
					0,
					"tweet",
					0,
					1
				]
			]
,			[
				[78, 80, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				547,
				[
					["credits"]
				],
				[
				],
				[
					0,
					"credits",
					0,
					1
				]
			]
,			[
				[155, 428, 0, 273.6092529296875, 136.8046112060547, 0, 0, 1, 0.5, 0.515625, 0, 0, []],
				139,
				605,
				[
					[0]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[983, 428, 0, 273.6092529296875, 136.8046112060547, 0, 0, 1, 0.5, 0.515625, 0, 0, []],
				139,
				606,
				[
					[1]
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[995, 70, 0, 256, 131, 0, 0, 1, 0.51171875, 0.4198473393917084, 0, 0, []],
				0,
				98,
				[
					["title"]
				],
				[
				[
					0,
					1,
					1,
					1,
					1
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 623.5, 0, 981, 59, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				59,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Copyright © 2014 Sammu Studios, Inc. All Rights Reserved.",
					0,
					"bold 20pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[568, 320, 0, 1399.101196289063, 788.22607421875, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				148,
				117,
				[
				],
				[
				[
					0,
					0,
					0,
					2,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Options",
			4,
			5651182069982325,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				1,
				97,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[954, 384, 0, 290.4089965820313, 85, 0, 0, 1, 0.5, 0.5058823823928833, 0, 0, []],
				151,
				155,
				[
					["fast"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[954, 556, 0, 290.4092407226563, 67.28994750976563, 0, 0, 1, 0.5040650367736816, 0.5087719559669495, 0, 0, []],
				59,
				240,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[580, 556, 0, 290.4092407226563, 67.28994750976563, 0, 0, 1, 0.5, 0.5087719559669495, 0, 0, []],
				52,
				242,
				[
					["bg_sound"]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[196, 556, 0, 290.4092407226563, 67.28994750976563, 0, 0, 1, 0.5, 0.5087719559669495, 0, 0, []],
				52,
				243,
				[
					["fx_sound"]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[196, 491, 0, 380, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				437,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"FX Sound",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[580, 491, 0, 380, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				241,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"BG Sound",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[954, 491, 0, 380, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				245,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Clear Data",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[568, 623.5, 0, 981, 59, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				116,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Copyright © 2014 Sammu Studios, Inc. All Rights Reserved.",
					0,
					"bold 20pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[580, 384, 0, 290.4089965820313, 85, 0, 0, 1, 0.5, 0.5058823823928833, 0, 0, []],
				151,
				130,
				[
					["normal"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[580, 304, 0, 435, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				128,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Game Speed",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[196, 384, 0, 290.4089965820313, 85, 0, 0, 1, 0.5, 0.5058823823928833, 0, 0, []],
				151,
				129,
				[
					["slow"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[196, 384, 0, 329, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				131,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Slower",
					0,
					"bold 40pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[580, 384, 0, 329, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				146,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Normal",
					0,
					"bold 40pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[954, 384, 0, 329, 103, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				148,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Faster",
					0,
					"bold 40pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[580, 384, 0, 290.4089965820313, 85, 0, 0, 1, 0.5, 0.5058823823928833, 0, 0, []],
				150,
				151,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1060, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				128,
				538,
				[
					["options"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Credits",
			5,
			7143823726394076,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				97,
				552,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 1855, 0, 217.3706512451172, 217.3706512451172, 0, -1.570796489715576, 1, 0, 0, 0, 0, []],
				137,
				587,
				[
				],
				[
				[
					50,
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				128,
				553,
				[
					["credits"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 702, 0, 256, 131, 0, 0, 1, 0.51171875, 0.4198473393917084, 0, 0, []],
				0,
				433,
				[
					[""]
				],
				[
				[
					0,
					1,
					1,
					1,
					1
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 1013, 0, 503.4938049316406, 503.4938049316406, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				142,
				124,
				[
					[0]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 1517, 0, 503.4938049316406, 503.4938049316406, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				142,
				144,
				[
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
			],
			[			]
		]
,		[
			"MainMenu",
			6,
			848292806528198,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				5,
				7,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 320, 0, 1136, 640, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				121,
				99,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[237, 373, 0, 426.4328918457031, 426.4328918457031, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				6,
				11,
				[
					["upgrades"],
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"Menu",
					2,
					1
				]
			]
,			[
				[1413, 460, 0, 330, 330, 0, 0, 1, 0.734375, 0.8984375, 0, 0, []],
				6,
				9,
				[
					["Characters"],
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"mecha",
					3,
					1
				]
			]
,			[
				[834.8770141601563, 481.625, 0, 404.0322265625, 101.008056640625, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				132,
				102,
				[
					["character"]
				],
				[
				],
				[
					0,
					"character",
					0,
					1
				]
			]
,			[
				[548, 500, 0, 200, 200, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				6,
				17,
				[
					["achievements"],
					[2]
				],
				[
				[
				]
				],
				[
					0,
					"Menu",
					0,
					1
				]
			]
,			[
				[1056, 338, 0, 128, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				6,
				8,
				[
					["catalogue"],
					[5]
				],
				[
				[
				]
				],
				[
					0,
					"Menu",
					1,
					1
				]
			]
,			[
				[237, 373, 0, 426.4330139160156, 426.4330139160156, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				132,
				101,
				[
					["upgrade"]
				],
				[
				],
				[
					0,
					"upgrade",
					0,
					1
				]
			]
,			[
				[548, 500, 0, 200, 200, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				132,
				100,
				[
					["achievement"]
				],
				[
				],
				[
					0,
					"achievement",
					0,
					1
				]
			]
,			[
				[587, 365, 0, 239.2730560302734, 78.30754852294922, 0, 0, 1, 0.5030303001403809, 0.5, 0, 0, []],
				138,
				593,
				[
					["missions"]
				],
				[
				],
				[
					0,
					"missions",
					0,
					1
				]
			]
,			[
				[419, 483, 0, 209.9976196289063, 419.9952392578125, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				113,
				435,
				[
				],
				[
				],
				[
					0,
					"Idle1",
					0,
					1
				]
			]
,			[
				[275, 567, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				18,
				[
					[""]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 549, 0, 347, 112, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				19,
				[
					["gold"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123456",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[985, 561, 0, 246, 118, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				127,
				451,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				128,
				22,
				[
					["mainmenu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[273, 217, 0, 171.1164855957031, 78.30754852294922, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				138,
				592,
				[
					["upgrades"]
				],
				[
				],
				[
					0,
					"upgrades",
					0,
					1
				]
			]
,			[
				[827, 199, 0, 171.1164855957031, 78.30754852294922, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				138,
				594,
				[
					["vehicles"]
				],
				[
				],
				[
					0,
					"vehicles",
					0,
					1
				]
			]
,			[
				[1038, 200, 0, 171.1164855957031, 78.30754852294922, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				138,
				595,
				[
					["catalogue"]
				],
				[
				],
				[
					0,
					"catalogue",
					0,
					1
				]
			]
,			[
				[125, 569, 0, 205, 117, 0, 0, 1, 0.502439022064209, 0.504273533821106, 0, 0, []],
				7,
				10,
				[
					["MainMenu"],
					["Menu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1056, 338, 0, 128, 256, 0, 0, 0.4000000059604645, 0.5, 0.5, 1, 0, []],
				132,
				103,
				[
					["catalogue"]
				],
				[
				],
				[
					0,
					"catalogue",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Upgrades",
			7,
			5600160102228013,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				44,
				78,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				79,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1049, 561, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				9,
				80,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[125, 569, 0, 205, 117, 0, 0, 1, 0.502439022064209, 0.504273533821106, 0, 0, []],
				7,
				81,
				[
					["Upgrades"],
					["Menu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[275, 567, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				82,
				[
					[""]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 549, 0, 406, 99, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				83,
				[
					["gold"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123456",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[832, 525, 0, 419, 190, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				84,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Buy",
					0,
					"bold 72pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[316, 238, 0, 482.8980712890625, 164.1853332519531, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				45,
				85,
				[
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[316, 426, 0, 482.8980712890625, 164.1853332519531, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				45,
				86,
				[
					[3]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					3,
					1
				]
			]
,			[
				[812, 238, 0, 482.8980712890625, 164.1853332519531, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				45,
				87,
				[
					[2]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[732, 225, 0, 293, 79, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				126,
				[
					["grenade_limit"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"0/20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[282, 457, 0, 309, 80, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				133,
				[
					["upgrade_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"7000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[282, 268, 0, 309, 80, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				134,
				[
					["upgrade_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[780, 268, 0, 309, 80, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				135,
				[
					["upgrade_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"9000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[813, 426, 0, 482.8980712890625, 164.1853332519531, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				45,
				145,
				[
					[5]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					4,
					1
				]
			]
,			[
				[732, 411, 0, 293, 79, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				147,
				[
					["attackdamage"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Level 1/50",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[780, 457, 0, 309, 80, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				149,
				[
					["upgrade_5"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"200",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				175,
				[
					[0],
					["X"],
					[361]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[236, 225, 0, 293, 79, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				125,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Boost to 520m",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[236, 411, 0, 293, 79, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				127,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Extra firepower",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-66, -764, 0, 482.8980102539063, 164.1849975585938, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				48,
				137,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-559, -540, 0, 140.6450042724609, 140.6450042724609, 0, 0, 1, 0.5, 0.515625, 0, 0, []],
				43,
				142,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1251, 824, 0, 80, 142, 0, 0, 1, 0.4285714328289032, 0.5, 0, 0, []],
				57,
				233,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[-100, 823, 0, 80, 142, 0, 0, 1, 0.5714285969734192, 0.5, 0, 0, []],
				57,
				232,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Achievements",
			8,
			1502466928052218,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				41,
				70,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[311, 244, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				71,
				[
					[2]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[1447, 244, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				72,
				[
					[1]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					5,
					1
				]
			]
,			[
				[820, 431, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				75,
				[
					[4]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					4,
					1
				]
			]
,			[
				[311, 431, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				76,
				[
					[3]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					3,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				77,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[274, 276, 0, 271, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				106,
				[
					["achieve_2_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"500",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[274, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				107,
				[
					["achieve_3_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"600",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1410, 276, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				108,
				[
					["achieve_1_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"1000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[783, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				120,
				[
					["achieve_4_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"400",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1447, 431, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				176,
				[
					[5]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					6,
					1
				]
			]
,			[
				[1410, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				182,
				[
					["achieve_5_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1956, 244, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				188,
				[
					[6]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					7,
					1
				]
			]
,			[
				[1919, 276, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				194,
				[
					["achieve_6_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"3000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				200,
				[
					[71],
					["X"],
					[516]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1956, 431, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				158,
				[
					[7]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					8,
					1
				]
			]
,			[
				[1919, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				163,
				[
					["achieve_7_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"4000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[820, 244, 0, 499.0224914550781, 169.6676483154297, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				164,
				[
					[8]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[783, 276, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				169,
				[
					["achieve_8_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"300",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[2583, 244, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				170,
				[
					[9]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					9,
					1
				]
			]
,			[
				[2546, 276, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				183,
				[
					["achieve_9_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"500",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[3092, 244, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				184,
				[
					[11]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					11,
					1
				]
			]
,			[
				[3055, 276, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				195,
				[
					["achieve_11_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"1500",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[2583, 431, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				196,
				[
					[10]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					10,
					1
				]
			]
,			[
				[2546, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				276,
				[
					["achieve_10_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"1000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[3092, 431, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				277,
				[
					[12]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					12,
					1
				]
			]
,			[
				[3055, 464, 0, 269, 83, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				327,
				[
					["achieve_12_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				492,
				[
					[0],
					["X"],
					[361]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				493,
				[
					[71],
					["X"],
					[516]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 1.570796370506287, 1, 1, 1, 0, 0, []],
				53,
				494,
				[
					[142],
					["Y"],
					[188]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				495,
				[
					[0],
					["X"],
					[361]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[326, -822, 0, 499.0220031738281, 169.6679992675781, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				123,
				496,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-116, 242, 0, 140.6449432373047, 140.6449432373047, 0, 0, 1, 0.5, 0.515625, 0, 0, []],
				43,
				69,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1104, 333, 0, 80, 142, 0, 0, 1, 0.4285714328289032, 0.5, 0, 0, []],
				57,
				235,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[27, 333, 0, 80, 142, 0, 0, 1, 0.5714285969734192, 0.5, 0, 0, []],
				57,
				234,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Catalogue",
			9,
			9490267610727676,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				46,
				89,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[740, 138, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				90,
				[
					["1_1"],
					[0],
					[1]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[740, 327, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				91,
				[
					["2_1"],
					[0],
					[2]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[740, 514, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				92,
				[
					["3_1"],
					[0],
					[3]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					3,
					1
				]
			]
,			[
				[740, 778, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				201,
				[
					["4_1"],
					[0],
					[4]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					4,
					1
				]
			]
,			[
				[663, 122, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				204,
				[
					["1_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 166, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				207,
				[
					["1_1_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"4000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 311, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				209,
				[
					["2_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 355, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				212,
				[
					["2_1_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 498, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				214,
				[
					["3_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 542, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				217,
				[
					["3_1_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 762, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				219,
				[
					["4_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 806, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				222,
				[
					["4_1_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"6000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[272, 351, 0, 323.2182006835938, 323.2182006835938, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				56,
				230,
				[
				],
				[
				],
				[
					0,
					"default",
					12,
					1
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 1.570796370506287, 1, 1, 1, 0, 0, []],
				53,
				231,
				[
					[142],
					["Y"],
					[188]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[740, 1154, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				373,
				[
					["2_2"],
					[0],
					[6]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					6,
					1
				]
			]
,			[
				[740, 1418, 0, 525.1420288085938, 178.5480041503906, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				374,
				[
					["3_2"],
					[0],
					[7]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					7,
					1
				]
			]
,			[
				[663, 1138, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				376,
				[
					["2_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 1182, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				379,
				[
					["2_2_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 1402, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				381,
				[
					["3_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 1446, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				384,
				[
					["3_2_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 1607, 0, 525.1420288085938, 178.5480041503906, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				385,
				[
					["4_2"],
					[0],
					[8]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					8,
					1
				]
			]
,			[
				[663, 1591, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				387,
				[
					["4_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 1635, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				390,
				[
					["4_2_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"6000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 1794, 0, 525.1420288085938, 178.5480041503906, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				391,
				[
					["1_3"],
					[0],
					[9]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					9,
					1
				]
			]
,			[
				[663, 1778, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				393,
				[
					["1_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 1822, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				396,
				[
					["1_3_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"4000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 2058, 0, 525.1420288085938, 178.5480041503906, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				397,
				[
					["2_3"],
					[0],
					[10]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					10,
					1
				]
			]
,			[
				[740, 2247, 0, 525.1420288085938, 178.5480041503906, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				398,
				[
					["3_3"],
					[0],
					[11]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					11,
					1
				]
			]
,			[
				[663, 2042, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				400,
				[
					["2_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 2086, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				403,
				[
					["2_3_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 2231, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				405,
				[
					["3_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 2275, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				408,
				[
					["3_3_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 2434, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				409,
				[
					["4_3"],
					[0],
					[12]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					12,
					1
				]
			]
,			[
				[663, 2418, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				411,
				[
					["4_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 2462, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				414,
				[
					["4_3_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"6000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 2698, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				328,
				[
					["1_4"],
					[0],
					[13]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					13,
					1
				]
			]
,			[
				[740, 2887, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				353,
				[
					["2_4"],
					[0],
					[14]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					14,
					1
				]
			]
,			[
				[663, 2682, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				355,
				[
					["1_4"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 2726, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				360,
				[
					["1_4_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"4000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[663, 2871, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				362,
				[
					["2_4"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 2915, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				365,
				[
					["2_4_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 3073.9375, 0, 525.1416015625, 178.5484619140625, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				366,
				[
					["3_4"],
					[0],
					[15]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					15,
					1
				]
			]
,			[
				[663, 3058, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				370,
				[
					["3_4"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"20",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 3102, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				416,
				[
					["3_4_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 3338, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				417,
				[
					["4_4"],
					[0],
					[16]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					16,
					1
				]
			]
,			[
				[663, 3322, 0, 150.4279632568359, 57.43613052368164, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				419,
				[
					["4_4"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"2",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 3366, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				422,
				[
					["4_4_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"6000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 967, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				202,
				[
					["1_2"],
					[0],
					[5]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					5,
					1
				]
			]
,			[
				[664, 951, 0, 150, 57, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				224,
				[
					["1_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[700, 995, 0, 318, 91, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				227,
				[
					["1_2_c"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"4000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[740, 3714, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				498,
				[
					["blank"],
					[0],
					[0]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[740, 3527, 0, 525.1419067382813, 178.5482482910156, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				497,
				[
					["blank"],
					[0],
					[0]
				],
				[
				[
				],
				[
					0,
					0,
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[672, -783, 0, 525.1416015625, 178.5484619140625, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				58,
				239,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				93,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[744, 610, 0, 142, 80, 0, 0, 1, 0.5, 0.4285714328289032, 0, 0, []],
				57,
				236,
				[
					[640]
				],
				[
				],
				[
					0,
					"Default",
					3,
					1
				]
			]
,			[
				[744, 38, 0, 142, 80, 0, 0, 1, 0.4907407462596893, 0.5714285969734192, 0, 0, []],
				57,
				237,
				[
					[640]
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
			],
			[			]
		]
,		[
			"Characters",
			10,
			4761610355972667,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				82,
				273,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[265, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				88,
				[
					["normal"],
					[1]
				],
				[
				[
				]
				],
				[
					0,
					"Normal",
					0,
					1
				]
			]
,			[
				[887, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				132,
				[
					["mecha"],
					[2]
				],
				[
				[
				]
				],
				[
					0,
					"Mecha",
					0,
					1
				]
			]
,			[
				[579, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				136,
				[
					["rainbow"],
					[3]
				],
				[
				[
				]
				],
				[
					0,
					"Rainbow",
					0,
					1
				]
			]
,			[
				[858, 487, 0, 56.70978927612305, 56.70978927612305, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				285,
				[
					["suit_2"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[549, 487, 0, 56.70978927612305, 56.70978927612305, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				286,
				[
					["suit_3"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[886, 472, 0, 147, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				283,
				[
					["suit_2"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"30000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[575, 473, 0, 147, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				284,
				[
					["suit_3"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"10000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[233, 487, 0, 56.70978927612305, 56.70978927612305, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				287,
				[
					["suit_1"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[262, 473, 0, 147, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				288,
				[
					["suit_1"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"5000",
					0,
					"bold 28pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[275, 567, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				290,
				[
					[""]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 549, 0, 454, 103, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				291,
				[
					["gold"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123456",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1401, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				324,
				[
					["locked"],
					[4]
				],
				[
				[
				]
				],
				[
					0,
					"Locked",
					0,
					1
				]
			]
,			[
				[1715, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				356,
				[
					["locked"],
					[4]
				],
				[
				[
				]
				],
				[
					0,
					"Locked",
					0,
					1
				]
			]
,			[
				[2023, 332, 0, 302.6499328613281, 391.8520202636719, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				83,
				368,
				[
					["locked"],
					[4]
				],
				[
				[
				]
				],
				[
					0,
					"Locked",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 1, 1, 0, 0, 1, 1, 1, 0, 0, []],
				53,
				372,
				[
					[0],
					["X"],
					[361]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-562, 296, 0, 302.6499938964844, 391.8519897460938, 0, 0, 1, 0.5, 0.5040650367736816, 0, 0, []],
				84,
				281,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1069, 319.5, 0, 80, 142, 0, 0, 1, 0.4285714328289032, 0.5, 0, 0, []],
				57,
				323,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[69, 316.5, 0, 80, 142, 0, 0, 1, 0.5714285969734192, 0.5, 0, 0, []],
				57,
				321,
				[
					[1136]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[812, 525, 0, 395, 143, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				309,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Buy",
					0,
					"bold 72pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1049, 561, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				9,
				282,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[125, 569, 0, 205, 117, 0, 0, 1, 0.502439022064209, 0.504273533821106, 0, 0, []],
				7,
				289,
				[
					["Upgrades"],
					["Menu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1059, 72, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				274,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"PopUp",
			11,
			8182424191189135,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1391.9169921875, 784.1790161132813, 0, 0, 0.800000011920929, 0.5, 0.5, 0, 0, []],
				98,
				316,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[780, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				139,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[571, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				140,
				[
				],
				[
				],
				[
					1,
					"Default",
					2,
					1
				]
			]
,			[
				[361, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				141,
				[
				],
				[
				],
				[
					1,
					"Default",
					1,
					1
				]
			]
,			[
				[195, 231, 0, 751, 338, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				138,
				[
					["popup_error"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					0,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Loading",
			12,
			4181854663826147,
			false,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 323, 161, 0, 0, 1, 0.43359375, 0.5078125, 0, 0, []],
				125,
				14,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 418, 0, 323, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				491,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Now Loading..",
					0,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					1,
					0,
					0
				]
			]
,			[
				[568, 601, 0, 1040, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				331,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Tip: Grenades can do massive damage",
					0,
					"bold 28pt Arial",
					"rgb(75,75,75)",
					1,
					0,
					1,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Border",
			13,
			4323524849484784,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-128, -1157, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				15,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-128, 0, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				16,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-128, 1280, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				49,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
,	[
		"Game",
		1136,
		640,
		true,
		"Game",
		9075055488873191,
		[
		[
			"BLACK",
			0,
			9965822035924544,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			],
			[			]
		]
,		[
			"Background",
			1,
			5593037054558441,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				12,
				25,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1237, 5.3125, 0, 324, 708, 0, 0, 1, 0, 0.0762711837887764, 0, 0, []],
				79,
				352,
				[
				],
				[
				[
					""
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1100, -212, 0, 480.7799987792969, 262.5979919433594, 0, 0, 1, 0.484375, 0.5859375, 0, 0, []],
				105,
				157,
				[
				],
				[
				[
				],
				[
					1,
					0,
					1,
					5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Game",
			2,
			8175101052113721,
			true,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[863, 780, 0, 132.2879791259766, 132.2871704101563, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				104,
				154,
				[
				],
				[
				[
					1,
					0,
					1,
					0.5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[358, -261, 0, 88, 36, 0, 0, 1, 0.1590909063816071, 0.5, 0, 0, []],
				17,
				32,
				[
					[1]
				],
				[
				[
				],
				[
					1000,
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1018, 1828, 0, 118, 118, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				119,
				481,
				[
					[1000],
					[1000],
					["Exploder"],
					[0],
					[0],
					["0"],
					[0],
					[0],
					[0],
					["Trap_1"]
				],
				[
				[
				],
				[
					"trap_1"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1024, 1967, 0, 118, 118, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				120,
				482,
				[
					[4000],
					[4000],
					["Exploder"],
					[0],
					[0],
					["0"],
					[0],
					[0],
					[0],
					["Trap_2"]
				],
				[
				[
				],
				[
					"trap_2"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[84, 1062, 0, 374.2182312011719, 179.5030517578125, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				19,
				35,
				[
					[10000],
					[10000],
					["Shooter"],
					[1],
					[0],
					["1_1"],
					[1],
					[1],
					[0],
					["Enforcers"]
				],
				[
				[
				],
				[
					"shooter_1"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[883, 932, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				20,
				36,
				[
					[200],
					[200],
					["Solid"],
					[0],
					[0],
					["3_1"],
					[1],
					[3],
					[0],
					["Storm Walkers"]
				],
				[
				[
				],
				[
					"solid_1"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-310, 391, 0, 86.60431671142578, 51.68321990966797, 0, 0, 1, 0.1290322542190552, 0.5675675868988037, 1, 0, []],
				21,
				33,
				[
				],
				[
				[
					1,
					0,
					0,
					0.05,
					1
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-633, 160, 0, 179, 179, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				22,
				37,
				[
					[0]
				],
				[
				[
					1,
					0,
					2,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-431, 514, 0, 50, 45, 0, 0, 1, 0, 0, 0, 0, []],
				23,
				38,
				[
					[0]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-413, 417, 0, 189.6782836914063, 77.05680084228516, 0, 0, 0.5, 0.5, 0.5, 0, 0, []],
				116,
				439,
				[
				],
				[
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-264.1583251953125, 665, 0, 254.2704467773438, 116.3610534667969, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				26,
				41,
				[
					[3],
					["rocket"],
					[10]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-567, 976, 0, 279.3235778808594, 127.826042175293, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				27,
				42,
				[
					[4],
					["shotgun"],
					[10]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-882, 785, 0, 139.6043395996094, 56.87549591064453, 0, 0, 1, 0.5, 0.5, 1, 0, []],
				28,
				44,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-202, 489, 0, 146.0301361083984, 18.25376701354981, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				33,
				62,
				[
				],
				[
				[
					0,
					2,
					0,
					0,
					0
				],
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[632, 945, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				18,
				73,
				[
					[100],
					[100],
					["Exploder"],
					[0],
					[0],
					["2_1"],
					[1],
					[2],
					[0],
					["Soldiers"]
				],
				[
				[
				],
				[
					"exploder_1"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[406, -334, 0, 1, 1, 0, -1.213890433311462, 1, 1, 1, 0, 0, []],
				60,
				251,
				[
				],
				[
				[
					0,
					0,
					0,
					0,
					0,
					1
				],
				[
					1,
					0,
					1,
					0.5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1957, 388, 0, 438.0821228027344, 438.0821228027344, 0, 0, 1, 0.7113820910453796, 0.434959352016449, 0, 0, [[1, 1, 1]]],
				61,
				248,
				[
					[40000],
					[40000],
					["Boss"],
					[1],
					[0],
					["4_2"],
					[2],
					[4],
					[4],
					["Star Gunners"]
				],
				[
				[
				],
				[
					"boss_2"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[1473, 881, 0, 484.0979614257813, 484.0979614257813, 0, 0, 1, 0.5853658318519592, 0.3902438879013062, 0, 0, [[1, 1, 1]]],
				62,
				252,
				[
					[80000],
					[80000],
					["Boss"],
					[1],
					[0],
					["4_3"],
					[3],
					[4],
					[4],
					["Metal Goliaths"]
				],
				[
				[
				],
				[
					"boss_3"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[634, 1086, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				63,
				253,
				[
					[700],
					[700],
					["Exploder"],
					[0],
					[0],
					["2_2"],
					[2],
					[2],
					[0],
					["Desert Reavers"]
				],
				[
				[
				],
				[
					"exploder_2"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[624, 1244, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				64,
				254,
				[
					[2000],
					[2000],
					["Exploder"],
					[0],
					[0],
					["2_3"],
					[3],
					[2],
					[0],
					["Heavy Troopers"]
				],
				[
				[
				],
				[
					"exploder_3"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[80, 1422, 0, 536.2478637695313, 536.2478637695313, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				65,
				255,
				[
					[20000],
					[20000],
					["Shooter"],
					[1],
					[0],
					["1_2"],
					[2],
					[1],
					[0],
					["Iron Vulcans"]
				],
				[
				[
				],
				[
					"shooter_2"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[94, 1675, 0, 366.5897827148438, 366.5897827148438, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				66,
				256,
				[
					[40000],
					[40000],
					["Shooter"],
					[1],
					[0],
					["1_3"],
					[3],
					[1],
					[0],
					["Iron Hellions"]
				],
				[
				[
				],
				[
					"shooter_3"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[890, 1087, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				67,
				257,
				[
					[1500],
					[1500],
					["Solid"],
					[0],
					[0],
					["3_2"],
					[2],
					[3],
					[0],
					["Storm Scarabs"]
				],
				[
				[
				],
				[
					"solid_2"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[895, 1236, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				68,
				258,
				[
					[3000],
					[3000],
					["Solid"],
					[0],
					[0],
					["3_3"],
					[3],
					[3],
					[0],
					["Tactical Sentrys"]
				],
				[
				[
				],
				[
					"solid_3"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1925, -88, 0, 440.5309143066406, 440.5309143066406, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				55,
				229,
				[
					[20000],
					[20000],
					["Boss"],
					[1],
					[0],
					["4_1"],
					[1],
					[4],
					[4],
					["Desert Bradleys"]
				],
				[
				[
				],
				[
					"boss_1"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[-510, 772, 0, 254.2704467773438, 116.3610534667969, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				25,
				40,
				[
					[2],
					["revolver"],
					[30]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[627, 1403, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				88,
				472,
				[
					[4000],
					[4000],
					["Exploder"],
					[0],
					[0],
					["2_4"],
					[4],
					[2],
					[0],
					["Strike Troopers"]
				],
				[
				[
				],
				[
					"exploder_4"
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[893, 1382, 0, 110, 110, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				89,
				473,
				[
					[5000],
					[5000],
					["Solid"],
					[0],
					[0],
					["3_4"],
					[4],
					[3],
					[0],
					["Steel Sentrys"]
				],
				[
				[
				],
				[
					"solid_4"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1466, 1378, 0, 403.5262451171875, 403.5262451171875, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				90,
				474,
				[
					[100000],
					[100000],
					["Boss"],
					[1],
					[0],
					["4_4"],
					[4],
					[4],
					[4],
					["Grand Sentinels"]
				],
				[
				[
				],
				[
					"boss_4"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					0
				]
			]
,			[
				[106, 1988, 0, 336.8000183105469, 336.8000183105469, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				91,
				475,
				[
					[80000],
					[80000],
					["Shooter"],
					[1],
					[0],
					["1_4"],
					[4],
					[1],
					[0],
					["Battle Hounds"]
				],
				[
				[
				],
				[
					"shooter_4"
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-263, 137, 0, 99.23040008544922, 15.85640525817871, 0, 0, 1, 1, 0.6000000238418579, 0, 0, []],
				34,
				60,
				[
					[1000],
					[1000]
				],
				[
				[
				],
				[
				]
				],
				[
					0,
					"default",
					0,
					1
				]
			]
,			[
				[217, 464, 0, 323, 161, 0, 0, 1, 0.43359375, 0.5078125, 0, 0, []],
				14,
				27,
				[
				],
				[
				[
					2,
					1
				],
				[
					0,
					0,
					0,
					0,
					0,
					1
				],
				[
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[238.8101806640625, 465, 0, 220.1454010009766, 220.1454010009766, 0, 0, 1, 0.5925925970077515, 0.5, 1, 0, []],
				122,
				453,
				[
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-645, 495, 0, 202.9384155273438, 202.9384155273438, 0, 0, 1, 0.5, 0.4765625, 1, 0, []],
				51,
				143,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1989, 1035, 0, 491.4429931640625, 491.4429931640625, 0, 0, 0.25, 0.5, 0.5, 1, 0, []],
				102,
				152,
				[
				],
				[
				[
				],
				[
					1,
					0,
					0,
					0.5,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[639, -195, 0, 193, 83, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				101,
				113,
				[
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				]
				],
				[
					"0",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[553, -650, 0, 705.593017578125, 115.256233215332, 0, 0, 1, 0.5, 0.5, 0, 0, [[1, 1, 1]]],
				103,
				153,
				[
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					32,
					32,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"9999",
					2,
					0,
					1,
					1,
					1,
					0,
					-40,
					0
				]
			]
,			[
				[-453, -630, 0, 694.789306640625, 694.789306640625, 0, 0, 1, 0.5185185074806213, 0.7222222089767456, 0, 0, []],
				37,
				65,
				[
				],
				[
				[
					1,
					0,
					2,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[67, -243, 0, 86.60431671142578, 51.68321990966797, 0, 0, 1, 0.8870967626571655, 0.5675675868988037, 1, 0, []],
				38,
				68,
				[
				],
				[
				[
					1,
					0,
					0,
					0.05,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[212, -256, 0, 94.69567108154297, 94.69567108154297, 0, 0, 1, 0.4259259402751923, 0.6296296119689941, 0, 0, []],
				81,
				272,
				[
					[10000],
					[10000]
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[742, -329, 0, 106, 11, 0, 0, 1, 0, 0, 0, 0, []],
				24,
				39,
				[
					[0]
				],
				[
				[
				],
				[
					0,
					0,
					1,
					2,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-159, -151, 0, 128, 128, 0, -2.73877477645874, 1, 0, 0.5, 0, 0, []],
				95,
				3,
				[
				],
				[
				[
				],
				[
				]
				],
				[
					5,
					90,
					0,
					200,
					120,
					40,
					70,
					0,
					0,
					0,
					0,
					0,
					-50,
					-200,
					0,
					50,
					0,
					0,
					1.5
				]
			]
,			[
				[-957, 519, 0, 126.4752960205078, 126.4752960205078, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				130,
				244,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-981, 286, 0, 111.5526809692383, 111.5526809692383, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				131,
				533,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[862, 157, 0, 1037.981689453125, 607.3084106445313, 0, 0, 0.300000011920929, 0.5, 0.5, 1, 0, []],
				117,
				57,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-393, 156, 0, 64, 64, 0, 0, 1, 1.875, 0.5, 0, 0, []],
				144,
				20,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-393, 48, 0, 64, 64, 0, 2.094395160675049, 1, 1.875, 0.5, 0, 0, []],
				145,
				104,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-549, -90, 0, 64, 64, 0, -2.094395160675049, 1, 1.875, 0.5, 0, 0, []],
				146,
				105,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Interface",
			3,
			3605002594812081,
			true,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[64, 140, 0, 64, 64, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				67,
				[
					["Interface"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[64, 71, 0, 95.3939208984375, 95.3939208984375, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				15,
				30,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[458, 587, 0, 95.20503997802734, 95.20503997802734, 0, 0, 1, 0.5, 0.515625, 0, 0, []],
				43,
				115,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[569, 588, 0, 329.1839904785156, 111.9229965209961, 0, 0, 1, 0.5, 0.5411764979362488, 0, 0, []],
				47,
				238,
				[
					[""],
					[0],
					[0]
				],
				[
				[
				],
				[
					0,
					0,
					2,
					1,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[65.9320068359375, 417.7359619140625, 0, 102, 450, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				13,
				26,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1047, 556, 0, 151.4929962158203, 151.4929962158203, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				16,
				31,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[107, 20, 0, 224, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				29,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Distance:",
					0,
					"bold 24pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1047, 87, 0, 151.4929962158203, 151.4929962158203, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				35,
				61,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[816, 47, 0, 163, 96, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				63,
				[
					["grenades"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"0 x",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					2,
					0,
					0,
					0,
					0
				]
			]
,			[
				[569, 588, 0, 329.1844177246094, 111.9226989746094, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				42,
				109,
				[
					[0]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[511, 545, 0, 287.6448974609375, 58.75299835205078, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				110,
				[
					["achieve_header"]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				],
				[
				]
				],
				[
					"Trigger Happy",
					1,
					"bold 26pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[511, 576, 0, 373, 77, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				111,
				[
					["achieve_description"]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				],
				[
				]
				],
				[
					"Kill 30 Enemies",
					1,
					"bold 20pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[511, 602, 0, 128, 44, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				112,
				[
					["achievement"]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				],
				[
				]
				],
				[
					"Reward: ",
					1,
					"bold 20pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[651, 602, 0, 195, 95, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				114,
				[
					["achievement_gold"]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				],
				[
				]
				],
				[
					"200",
					1,
					"bold 20pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[651, 602, 0, 194, 83, 0, 0, 1, 0, 0, 0, 0, []],
				106,
				423,
				[
					["appear"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"200",
					1,
					"bold 20pt Arial",
					"rgb(0,0,0)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[568, 320, 0, 341.4718017578125, 341.4718017578125, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				72,
				334,
				[
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[563, -170, 0, 284, 135, 0, 0, 1, 0, 0, 0, 0, []],
				78,
				23,
				[
				],
				[
				],
				[
					"Debugger",
					0,
					"bold 16pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[568, 320, 0, 250, 250, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				94,
				2,
				[
				],
				[
				[
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[633, 612, 0, 31.47585296630859, 31.47585296630859, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				100,
				150,
				[
					["achievement"]
				],
				[
				[
					0,
					0,
					0,
					3,
					0
				],
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[107, 47, 0, 265, 98, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				28,
				[
					["distance"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[568, 85, 0, 188, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				43,
				[
					["ammo"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[107, 120, 0, 214, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				66,
				[
					["gold"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"0",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-360, 356, 0, 272.9542236328125, 136.4771118164063, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				36,
				64,
				[
				],
				[
				[
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1355, 316, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				140,
				610,
				[
					["TutorialUI"]
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1496, 574, 0, 497, 143, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				611,
				[
					["TutorialUI"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Instructions",
					1,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[66, 457, 0, 136, 136, 0, 0, 1, 0.5078125, 0.5, 0, 0, []],
				85,
				322,
				[
				],
				[
				[
					2,
					1
				],
				[
					0,
					0,
					0,
					0,
					0,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 320, 0, 1136, 640, 0, 0, 0.800000011920929, 0.5, 0.5, 1, 0, []],
				99,
				58,
				[
				],
				[
				[
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-576, 97, 0, 421, 102, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				95,
				[
					["pickup"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"pickup",
					1,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[-438, -178, 0, 421, 102, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				118,
				[
					["boss_shield"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"boss_shield",
					1,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[107, 97, 0, 411, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				119,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Gold:",
					0,
					"bold 24pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-10.5, -11, 0, 1157, 663, 0, 0, 1, 0, 0, 0, 0, []],
				149,
				123,
				[
				],
				[
				[
					1,
					0,
					0,
					1,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Pause",
			4,
			1453351557096917,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[554, 319, 0, 437, 154, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				45,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Paused",
					0,
					"bold 72pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[341, 822, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				29,
				46,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[779, 822, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				30,
				47,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1049, 82, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				48,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"GameOver",
			5,
			2972475304376639,
			false,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1136, 640, 0, 0, 1, 0.5, 0.5, 0, 0, [[0.5, 0.5, 0.5]]],
				87,
				471,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 260, 0, 798.5699462890625, 399.2849731445313, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				143,
				5,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[337, 331, 0, 360, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				51,
				[
					["distance_score"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[337, 387, 0, 360, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				52,
				[
					["kills_score"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[758, 490, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				31,
				55,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1437, 670, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				32,
				56,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[125, 569, 0, 205, 117, 0, 0, 1, 0.502439022064209, 0.504273533821106, 0, 0, []],
				7,
				296,
				[
					["Upgrades"],
					["Menu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[655, 571, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				335,
				[
					["Interface"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[702, 549, 0, 321, 103, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				336,
				[
					["revive"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"500",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[275, 571, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				343,
				[
					["Interface"]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 549, 0, 306, 103, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				344,
				[
					["gold_total"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"500",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[783, 331, 0, 360, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				464,
				[
					["distance_score_best"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[783, 387, 0, 360, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				465,
				[
					["kills_score_best"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"123",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[568, 437, 0, 477, 96, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				468,
				[
					["bestscore"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"NEW RECORD!",
					0,
					"bold 36pt Arial",
					"rgb(0,255,51)",
					1,
					1,
					1,
					0,
					0
				]
			]
,			[
				[1044, 95, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				466,
				[
					["share"]
				],
				[
				],
				[
					0,
					"share",
					0,
					1
				]
			]
,			[
				[94, 96, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				92,
				554,
				[
					["tweet"]
				],
				[
				],
				[
					0,
					"tweet",
					0,
					1
				]
			]
,			[
				[513.322998046875, 490, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				29,
				602,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1004, 490, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				30,
				603,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 529, 0, 304, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				121,
				[
					["total_gold"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Total Gold:",
					0,
					"bold 24pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[702, 529, 0, 304, 75, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				122,
				[
					["death_toll"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Death Toll:",
					0,
					"bold 24pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"PopUp",
			6,
			8308208877328131,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1391.9169921875, 784.1790161132813, 0, 0, 0.800000011920929, 0.5, 0.5, 0, 0, []],
				98,
				317,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[195, 231, 0, 751, 243, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				337,
				[
					["popup_error"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					0,
					0,
					0
				]
			]
,			[
				[780, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				338,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[571, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				339,
				[
				],
				[
				],
				[
					1,
					"Default",
					2,
					1
				]
			]
,			[
				[361, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				340,
				[
				],
				[
				],
				[
					1,
					"Default",
					1,
					1
				]
			]
			],
			[			]
		]
,		[
			"Ending",
			7,
			9245755441814493,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				75,
				345,
				[
				],
				[
				[
					0,
					2,
					0,
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				73,
				341,
				[
				],
				[
				[
					0,
					2,
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1047, 320, 0, 151.4929962158203, 151.4929962158203, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				74,
				342,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Starting",
			8,
			5419983185123526,
			false,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 323, 161, 0, 0, 1, 0.43359375, 0.5078125, 0, 0, []],
				125,
				12,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 418, 0, 323, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				13,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Now Loading..",
					0,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					1,
					0,
					0
				]
			]
,			[
				[568, 601, 0, 1040, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				426,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Tip: Remember to upgrade to increase your damage",
					0,
					"bold 28pt Arial",
					"rgb(75,75,75)",
					1,
					0,
					1,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Tutorial",
			9,
			8739054278951561,
			false,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				76,
				348,
				[
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1048, 344, 0, 151.4929962158203, 151.4929962158203, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				74,
				349,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Border",
			10,
			5543415927236991,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-128, 0, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				50,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-128, 1280, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				53,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
			[
				null,
				39,
				74,
				[
				],
				[
				],
				[
					4,
					4,
					1
				]
			]
		],
		[]
	]
,	[
		"Shop",
		1136,
		640,
		true,
		"Shop",
		4468043604685365,
		[
		[
			"MenuShop",
			0,
			3928497611360382,
			true,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[0, 0, 0, 1136, 640, 0, 0, 1, 0, 0, 0, 0, []],
				70,
				534,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1049, 561, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				9,
				536,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[775, 513, 0, 233, 136, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				537,
				[
					["achieve_header"]
				],
				[
				[
					0,
					0,
					2,
					1,
					0
				],
				[
				],
				[
				]
				],
				[
					"Buy!",
					1,
					"bold 72pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[275, 567, 0, 82, 82, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				540,
				[
					[""]
				],
				[
				[
					0,
					0,
					1,
					1,
					0
				],
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[324, 549, 0, 442, 97, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				542,
				[
					["gold"]
				],
				[
				[
					0,
					0,
					2,
					1,
					0
				],
				[
				],
				[
				]
				],
				[
					"11234",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-623, 81, 0, 311, 421, 0, 0, 1, 0, 0, 0, 0, []],
				78,
				551,
				[
				],
				[
				],
				[
					"Debugger",
					0,
					"16pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[320, 237, 0, 482.8984375, 164.1854705810547, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				71,
				612,
				[
					["sammustudios.colossaldefenders.iap01"],
					[50000]
				],
				[
				],
				[
					0,
					"Default",
					1,
					1
				]
			]
,			[
				[320, 408, 0, 482.8984375, 164.1854705810547, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				71,
				617,
				[
					["sammustudios.colossaldefenders.iap02"],
					[125000]
				],
				[
				],
				[
					0,
					"Default",
					2,
					1
				]
			]
,			[
				[832, 525, 0, 395, 143, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				623,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Buy",
					0,
					"bold 72pt Arial",
					"rgb(255,255,255)",
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[125, 569, 0, 205, 117, 0, 0, 1, 0.502439022064209, 0.504273533821106, 0, 0, []],
				7,
				624,
				[
					["Upgrades"],
					["Menu"]
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[816, 237, 0, 482.8984375, 164.1854705810547, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				71,
				625,
				[
					["sammustudios.colossaldefenders.iap03"],
					[250000]
				],
				[
				],
				[
					0,
					"Default",
					3,
					1
				]
			]
,			[
				[816, 408, 0, 482.8984375, 164.1854705810547, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				71,
				630,
				[
					["sammustudios.colossaldefenders.iap04"],
					[500000]
				],
				[
				],
				[
					0,
					"Default",
					4,
					1
				]
			]
,			[
				[625, -592, 0, 482.8984375, 164.1854705810547, 0, 0, 1, 0.5, 0.529411792755127, 0, 0, []],
				80,
				635,
				[
				],
				[
				[
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1049, 82, 0, 128, 128, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				141,
				636,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"PopUp",
			1,
			1371440997073584,
			true,
			[0, 0, 0],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 1391.9169921875, 784.1790161132813, 0, 0, 0.800000011920929, 0.5, 0.5, 0, 0, []],
				98,
				535,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[780, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				637,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[571, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				638,
				[
				],
				[
				],
				[
					1,
					"Default",
					2,
					1
				]
			]
,			[
				[361, 371, 0, 217, 64, 0, 0, 1, 0.5023041367530823, 0.5, 0, 0, []],
				49,
				639,
				[
				],
				[
				],
				[
					1,
					"Default",
					1,
					1
				]
			]
,			[
				[195, 231, 0, 751, 338, 0, 0, 1, 0, 0, 0, 0, []],
				2,
				640,
				[
					["popup_error"]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"",
					0,
					"bold 48pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					0,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"ShopLoading",
			2,
			2015358266178657,
			false,
			[0, 0, 0],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[568, 320, 0, 323, 161, 0, 0, 1, 0.43359375, 0.5078125, 0, 0, []],
				125,
				641,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[568, 418, 0, 323, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				642,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Please Wait..",
					0,
					"bold 28pt Arial",
					"rgb(255,255,255)",
					1,
					0,
					1,
					0,
					0
				]
			]
,			[
				[568, 601, 0, 1040, 57, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				643,
				[
					[""]
				],
				[
				[
					0,
					0,
					0,
					1,
					1
				],
				[
				],
				[
				]
				],
				[
					"Tip: Shooting at Lane Missiles will shrink them!",
					0,
					"bold 28pt Arial",
					"rgb(75,75,75)",
					1,
					0,
					1,
					0,
					0
				]
			]
			],
			[			]
		]
,		[
			"Border",
			3,
			9338164768243108,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-128, 0, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				54,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-128, 1280, 0, 1424, 640, 0, 0, 1, 0, 1, 0, 0, []],
				112,
				94,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
	],
	[
	[
		"Menu",
		[
		[
			2,
			"GlobalFunctions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			2343328264369877,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLoadFinished,
				null,
				1,
				false,
				false,
				false,
				1679468407324048,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6212055919995285,
				[
				[
					0,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9573523250729726,
					false
					,[
					[
						5,
						[
							2,
							"Intro"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8488369211290204,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					107,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5425039698891486,
					false
				]
,				[
					110,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6866982356737564,
					false
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3813406893011678,
					false
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3565497712658191,
					false
				]
,				[
					92,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7475406936070904,
					false
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1707979842424276,
					false
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2134163609763356,
					false
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3441068396636303,
					false
				]
,				[
					97,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8523441657661554,
					false
				]
,				[
					44,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3453922790297327,
					false
				]
,				[
					41,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7813057602639291,
					false
				]
,				[
					82,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1134672936062172,
					false
				]
,				[
					46,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7036647787431953,
					false
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4954006622359273,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5081446702750076,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2957910395518234,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					0,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					4373532607407127,
					false
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					7811494726718179,
					false
					,[
					[
						0,
						[
							1,
							1.4
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5184426895812588,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					6079874158909924,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							6
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2236074510609525,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
						null,
						0,
						false,
						true,
						false,
						6484250891641029,
						false
						,[
						[
							1,
							[
								10,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
								,[
									2,
									"_1"
								]
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7255418985759415,
						false
						,[
						[
							1,
							[
								10,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
								,[
									2,
									"_1"
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9045873767911734,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
						null,
						0,
						false,
						true,
						false,
						1518681025130063,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"achieve_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9734088578041244,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"achieve_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1947083096119009,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					7603412313228338,
					false
					,[
					[
						1,
						[
							2,
							"AdToggle"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1641653017500578,
					false
					,[
					[
						1,
						[
							2,
							"AdToggle"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6207623511492498,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					1805245983074568,
					false
					,[
					[
						1,
						[
							2,
							"SocialGold"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6455979134097382,
					false
					,[
					[
						1,
						[
							2,
							"SocialGold"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2038788775286026,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2318650735600037,
					false
					,[
					[
						1,
						[
							2,
							"grenades"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3786876940602062,
					false
					,[
					[
						1,
						[
							2,
							"grenades"
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1858891942052372,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					6710122593586065,
					false
					,[
					[
						1,
						[
							2,
							"kills_overall"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7706820573984306,
					false
					,[
					[
						1,
						[
							2,
							"kills_overall"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8820159170825129,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					197516300155981,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8201824135735502,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						7,
						[
							0,
							500
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4957992237014653,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						1514172074806595,
						false
						,[
						[
							1,
							[
								2,
								"1"
							]
						]
,						[
							0,
							[
								0,
								1
							]
						]
,						[
							0,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						246639140907683,
						false
						,[
						[
							1,
							[
								10,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
								,[
									2,
									"_1"
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						454612523450993,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"achieve_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1156602343746374,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"upgrade_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						6217093115577911,
						[
						[
							-1,
							cr.system_object.prototype.cnds.For,
							null,
							0,
							true,
							false,
							false,
							4176431543397799,
							false
							,[
							[
								1,
								[
									2,
									"catalogue"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									16
								]
							]
							]
						]
						],
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							3249899165529103,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											19,
											cr.system_object.prototype.exps.loopindex
											,[
[
												2,
												"1"
											]
											]
										]
										,[
											2,
											"_"
										]
									]
									,[
										19,
										cr.system_object.prototype.exps.loopindex
										,[
[
											2,
											"catalogue"
										]
										]
									]
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5007494948845857,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8938893915437864,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"fx_sound"
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7728642627595243,
						false
						,[
						[
							1,
							[
								2,
								"fx_sound"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7191912240181217,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						1036642765078605,
						false
						,[
						[
							3,
							0
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7061303098125851,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1290159914182263,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"bg_sound"
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3617396360512254,
						false
						,[
						[
							1,
							[
								2,
								"bg_sound"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5174291879838134,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						40632042490686,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						5828539028148457,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							1
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				270808087466408,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					8835259519896678,
					false
					,[
					[
						1,
						[
							2,
							"attackdamage"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6903129607218749,
					false
					,[
					[
						1,
						[
							2,
							"attackdamage"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2717495241032008,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					9016786185826437,
					false
					,[
					[
						1,
						[
							2,
							"suit"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5637805033147924,
					false
					,[
					[
						1,
						[
							2,
							"suit"
						]
					]
,					[
						7,
						[
							2,
							"normal"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4138505473655248,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					5090194634690073,
					false
					,[
					[
						1,
						[
							2,
							"suit_1"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					90181095255326,
					false
					,[
					[
						1,
						[
							2,
							"suit_1"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6572878454764966,
					false
					,[
					[
						1,
						[
							2,
							"suit_2"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2585243005667103,
					false
					,[
					[
						1,
						[
							2,
							"suit_3"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4270589273957394,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2924868106298288,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8263837766983848,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8718294713765188,
					false
					,[
					[
						11,
						"speed_normal"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3115786646844837,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7381567679403175,
					[
					[
						151,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6686049464978384,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"normal"
							]
						]
						]
					]
					],
					[
					[
						150,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9488459743718897,
						false
						,[
						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5684664606899339,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					3376054627896805,
					false
					,[
					[
						1,
						[
							2,
							"bestdistance"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6413557994409747,
					false
					,[
					[
						1,
						[
							2,
							"bestdistance"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6459165898794359,
					false
					,[
					[
						1,
						[
							2,
							"bestkills"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4616660648799225,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				1161140387448398,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				4167853947128057,
				false
				,[
				[
					5,
					[
						2,
						"Loading"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				137,
				cr.behaviors.Bullet.prototype.acts.SetSpeed,
				"Bullet",
				3325040722979586,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1022246888506725,
				false
				,[
				[
					1,
					[
						2,
						"PreloadAdBanner"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				982883255880328,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8062063479045413,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8933581617524211,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							0,
							-8
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7552575797024515,
					false
					,[
					[
						11,
						"speed_normal"
					]
,					[
						7,
						[
							0,
							-8
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3312492656777717,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					1898399215723783,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6454775749034287,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4278052975305997,
					false
					,[
					[
						11,
						"speed_normal"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4779235713295025,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					951679439193339,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5619544060248013,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							0,
							-15
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					505845367603745,
					false
					,[
					[
						11,
						"speed_normal"
					]
,					[
						7,
						[
							0,
							-15
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1572185499346647,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7760040719030723,
					false
					,[
					[
						1,
						[
							2,
							"fx_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4984668965289798,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1552104070952102,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"fx_sound"
							]
						]
						]
					]
					],
					[
					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8733268569986327,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						5193085336761469,
						false
						,[
						[
							3,
							0
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				884958524404352,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7429513014770531,
					false
					,[
					[
						1,
						[
							2,
							"bg_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6574542040647353,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5905778035247113,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"bg_sound"
							]
						]
						]
					]
					],
					[
					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5127669210277366,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						741094067954025,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						259784547831404,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							1
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8466845213512064,
				[
				],
				[
				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					2271674856688418,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					8600428715960768,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					3579528441716915,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					860917065274353,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					9733155080016906,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					4923649327080353,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					5636651261954795,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					689543031217695,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					9684531772159483,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					9791458886789408,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					3322441252300145,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
,					[
						0,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					6746850050328185,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							2
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					4551896875802536,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							3
						]
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					7282948309164767,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							3
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					4818493237920486,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
,					[
						0,
						[
							0,
							3
						]
					]
,					[
						7,
						[
							0,
							20
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Arr.prototype.acts.SetXY,
					null,
					7476169670392213,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							3
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2360201445150046,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8376082427912581,
					false
					,[
					[
						1,
						[
							2,
							"grenades"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					7048505437849658,
					false
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					910255901393334,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"grenade_limit"
								]
							]
,
							[
								7,
								[
									10,
									[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"grenades"
										]
										]
									]
									,[
										2,
										"/20"
									]
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6919797981215088,
					[
					[
						45,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6307202822912382,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					[
						45,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2237021323378252,
						false
						,[
						[
							4,
							43
						]
,						[
							5,
							[
								2,
								"Upgrades"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						43,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						4524135958737654,
						false
						,[
						[
							4,
							45
						]
,						[
							3,
							0
						]
						]
					]
,					[
						43,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5523950237640708,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							45
						]
						]
					]
,					[
						43,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6619436960122619,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"Grenades"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1272307174648862,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3300078298613331,
					false
					,[
					[
						1,
						[
							2,
							"attackdamage"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					2056068346210346,
					false
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5158939780289733,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"attackdamage"
								]
							]
,
							[
								7,
								[
									10,
									[
										10,
										[
											2,
											"Level "
										]
										,[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"attackdamage"
											]
											]
										]
									]
									,[
										2,
										"/50"
									]
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4361643241673526,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"upgrade_5"
								]
							]
,
							[
								7,
								[
									6,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"attackdamage"
											]
											]
										]
										]
									]
									,[
										0,
										500
									]
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9580331087936436,
					[
					[
						45,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6751571708657858,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						45,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						4781909943847208,
						false
						,[
						[
							4,
							43
						]
,						[
							5,
							[
								2,
								"Upgrades"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						43,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						4865965729955008,
						false
						,[
						[
							4,
							45
						]
,						[
							3,
							0
						]
						]
					]
,					[
						43,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7922156518199457,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							45
						]
						]
					]
,					[
						43,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7577228872907029,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"Grenades"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9312886005191345,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					3222785154950747,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							12
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9850845000751252,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						338526447042862,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"achieve_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2263116195042957,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											10,
											[
												2,
												"achieve_"
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
										,[
											2,
											"_c"
										]
									]
								]
,
								[
									7,
									[
										2,
										"Completed"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2051429108105762,
						false
						,[
						[
							1,
							[
								2,
								"setTextColor"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											10,
											[
												2,
												"achieve_"
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
											]
										]
										,[
											2,
											"_c"
										]
									]
								]
,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											0
										]
,[
											0,
											160
										]
,[
											0,
											0
										]
										]
									]
								]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5704707795221257,
						[
						[
							8,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7471333085413899,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									10,
									[
										2,
										"achieve_"
									]
									,[
										19,
										cr.system_object.prototype.exps.loopindex
									]
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							928398816864185,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						682328760178876,
						[
						[
							42,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							686295036751149,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
							null,
							0,
							false,
							false,
							false,
							4349206722014593,
							false
							,[
							[
								5,
								[
									2,
									"Achievements"
								]
							]
							]
						]
						],
						[
						[
							42,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							6587106893679594,
							false
							,[
							[
								4,
								43
							]
,							[
								5,
								[
									2,
									"Achievements"
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							43,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							8631208876610499,
							false
							,[
							[
								4,
								53
							]
,							[
								3,
								0
							]
							]
						]
,						[
							43,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							188244053125255,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								42
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				170592270662239,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					7958387679373888,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6528471271429981,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						1879485881740401,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"upgrade_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							8,
							5
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						5352286154302224,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps.loopindex
							]
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						643276524092708,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											2,
											"upgrade_"
										]
										,[
											19,
											cr.system_object.prototype.exps.loopindex
										]
									]
								]
,
								[
									7,
									[
										2,
										""
									]
								]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5906568397063271,
						[
						[
							8,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2902681172690527,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									10,
									[
										2,
										"upgrade_"
									]
									,[
										19,
										cr.system_object.prototype.exps.loopindex
									]
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							5064884613161083,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						546595337450383,
						[
						[
							45,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7690146500357107,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
							]
						]
,						[
							53,
							cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
							null,
							0,
							false,
							false,
							false,
							6423335177640645,
							false
							,[
							[
								5,
								[
									2,
									"Upgrades"
								]
							]
							]
						]
						],
						[
						[
							45,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							5440095513717309,
							false
							,[
							[
								4,
								43
							]
,							[
								5,
								[
									2,
									"Upgrades"
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							43,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							8694314834345535,
							false
							,[
							[
								4,
								53
							]
,							[
								3,
								0
							]
							]
						]
,						[
							43,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							5426441117630552,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								45
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2120544242932721,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5169773541329211,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							937205599205664,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1827483969224436,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
								null,
								0,
								false,
								false,
								false,
								5270635615657658,
								false
								,[
								[
									1,
									[
										2,
										"mecha_suit_activated"
									]
								]
,								[
									8,
									0
								]
,								[
									0,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								52,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								6947230477169713,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2423325678597164,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
								null,
								0,
								false,
								false,
								false,
								4951682487317609,
								false
								,[
								[
									1,
									[
										2,
										"mecha_suit_activated"
									]
								]
,								[
									8,
									0
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								52,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								5593925625441834,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1593087146237266,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					183294494078002,
					false
					,[
					[
						1,
						[
							2,
							"id"
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							16
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					533634528560176,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						8499015805280175,
						false
						,[
						[
							1,
							[
								2,
								"stage"
							]
						]
,						[
							0,
							[
								0,
								1
							]
						]
,						[
							0,
							[
								0,
								4
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						3686531547285563,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5107684589751161,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									10,
									[
										10,
										[
											19,
											cr.system_object.prototype.exps.loopindex
											,[
[
												2,
												"id"
											]
											]
										]
										,[
											2,
											"_"
										]
									]
									,[
										19,
										cr.system_object.prototype.exps.loopindex
										,[
[
											2,
											"stage"
										]
										]
									]
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							1809539795294241,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Compare,
								null,
								0,
								false,
								false,
								false,
								3011024431462034,
								false
								,[
								[
									7,
									[
										20,
										39,
										cr.plugins_.Arr.prototype.exps.At,
										false,
										null
										,[
[
											5,
											[
												19,
												cr.system_object.prototype.exps.loopindex
												,[
[
													2,
													"id"
												]
												]
											]
											,[
												0,
												1
											]
										]
,[
											5,
											[
												19,
												cr.system_object.prototype.exps.loopindex
												,[
[
													2,
													"stage"
												]
												]
											]
											,[
												0,
												1
											]
										]
										]
									]
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												10,
												[
													10,
													[
														19,
														cr.system_object.prototype.exps.loopindex
														,[
[
															2,
															"id"
														]
														]
													]
													,[
														2,
														"_"
													]
												]
												,[
													19,
													cr.system_object.prototype.exps.loopindex
													,[
[
														2,
														"stage"
													]
													]
												]
											]
											]
										]
										]
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4886889487368458,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													10,
													[
														19,
														cr.system_object.prototype.exps.loopindex
														,[
[
															2,
															"id"
														]
														]
													]
													,[
														2,
														"_"
													]
												]
												,[
													19,
													cr.system_object.prototype.exps.loopindex
													,[
[
														2,
														"stage"
													]
													]
												]
											]
										]
,
										[
											7,
											[
												10,
												[
													10,
													[
														20,
														2,
														cr.plugins_.Text.prototype.exps.Text,
														true,
														null
													]
													,[
														2,
														"/"
													]
												]
												,[
													20,
													2,
													cr.plugins_.Text.prototype.exps.Text,
													true,
													null
												]
											]
										]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1484965986631171,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													10,
													[
														10,
														[
															19,
															cr.system_object.prototype.exps.loopindex
															,[
[
																2,
																"id"
															]
															]
														]
														,[
															2,
															"_"
														]
													]
													,[
														19,
														cr.system_object.prototype.exps.loopindex
														,[
[
															2,
															"stage"
														]
														]
													]
												]
												,[
													2,
													"_c"
												]
											]
										]
,
										[
											7,
											[
												2,
												"Completed"
											]
										]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								877217416750722,
								false
								,[
								[
									1,
									[
										2,
										"setTextColor"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													10,
													[
														10,
														[
															19,
															cr.system_object.prototype.exps.loopindex
															,[
[
																2,
																"id"
															]
															]
														]
														,[
															2,
															"_"
														]
													]
													,[
														19,
														cr.system_object.prototype.exps.loopindex
														,[
[
															2,
															"stage"
														]
														]
													]
												]
												,[
													2,
													"_c"
												]
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.rgb
												,[
[
													0,
													0
												]
,[
													0,
													160
												]
,[
													0,
													0
												]
												]
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5687280114739815,
								[
								[
									8,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4480256071096468,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											10,
											[
												10,
												[
													19,
													cr.system_object.prototype.exps.loopindex
													,[
[
														2,
														"id"
													]
													]
												]
												,[
													2,
													"_"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
												,[
[
													2,
													"stage"
												]
												]
											]
										]
									]
									]
								]
								],
								[
								[
									8,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3845245102247536,
									false
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								815300256092158,
								[
								[
									47,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									5269110255316545,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											10,
											[
												10,
												[
													19,
													cr.system_object.prototype.exps.loopindex
													,[
[
														2,
														"id"
													]
													]
												]
												,[
													2,
													"_"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps.loopindex
												,[
[
													2,
													"stage"
												]
												]
											]
										]
									]
									]
								]
,								[
									53,
									cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
									null,
									0,
									false,
									false,
									false,
									4555076168025688,
									false
									,[
									[
										5,
										[
											2,
											"Catalogue"
										]
									]
									]
								]
								],
								[
								[
									47,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									6112480008299161,
									false
									,[
									[
										4,
										43
									]
,									[
										5,
										[
											2,
											"Catalogue"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									43,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									3771692985760754,
									false
									,[
									[
										4,
										53
									]
,									[
										3,
										0
									]
									]
								]
,								[
									43,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									6069107028180921,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										47
									]
									]
								]
,								[
									47,
									cr.plugins_.Sprite.prototype.acts.SetBoolInstanceVar,
									null,
									6143455913468875,
									false
									,[
									[
										10,
										1
									]
,									[
										3,
										1
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5153992055105132,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								3884527991899506,
								false
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6242352480723631,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													10,
													[
														19,
														cr.system_object.prototype.exps.loopindex
														,[
[
															2,
															"id"
														]
														]
													]
													,[
														2,
														"_"
													]
												]
												,[
													19,
													cr.system_object.prototype.exps.loopindex
													,[
[
														2,
														"stage"
													]
													]
												]
											]
										]
,
										[
											7,
											[
												10,
												[
													10,
													[
														20,
														40,
														cr.plugins_.WebStorage.prototype.exps.LocalValue,
														true,
														null
														,[
[
															10,
															[
																10,
																[
																	19,
																	cr.system_object.prototype.exps.loopindex
																	,[
[
																		2,
																		"id"
																	]
																	]
																]
																,[
																	2,
																	"_"
																]
															]
															,[
																19,
																cr.system_object.prototype.exps.loopindex
																,[
[
																	2,
																	"stage"
																]
																]
															]
														]
														]
													]
													,[
														2,
														"/"
													]
												]
												,[
													20,
													2,
													cr.plugins_.Text.prototype.exps.Text,
													true,
													null
												]
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1399005796515916,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					6553029107903841,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							1
						]
					]
,					[
						0,
						[
							0,
							3
						]
					]
					]
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8860361263507869,
					false
					,[
					[
						10,
						1
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							19,
							cr.system_object.prototype.exps.loopindex
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4419948153640937,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						8136259999596576,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6145704961726639,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3949419025272825,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4390687219209815,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8402373600764015,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2494038786094694,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							1768918735876899,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"normal"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							752128991717261,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1305605511528018,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								1881010276270551,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9137638032920456,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7268468422366263,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								623978666729341,
								false
								,[
								[
									1,
									[
										2,
										"Normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3052367755275316,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							727476540531251,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"mecha"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							4649803166713657,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9183014071698964,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								5719785651734022,
								false
								,[
								[
									0,
									[
										0,
										3
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1120590017380353,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1076384389726668,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9905035411824903,
								false
								,[
								[
									1,
									[
										2,
										"Mecha"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3683882865492618,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							2968191732593514,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"rainbow"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							4617284904033398,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								5900353681942324,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								1545537282577165,
								false
								,[
								[
									0,
									[
										0,
										4
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7283261623407702,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7835514841334023,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9851454844543711,
								false
								,[
								[
									1,
									[
										2,
										"Rainbow"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9016112201468239,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						9289363181858702,
						false
					]
					],
					[
					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetOpacity,
						null,
						9182964388410617,
						false
						,[
						[
							0,
							[
								0,
								99
							]
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3513972706922655,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			862486726836894,
			[
			[
				0,
				cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,
				"Fade",
				1,
				false,
				false,
				false,
				4838783021994782,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				5342546557327027,
				false
				,[
				[
					5,
					[
						2,
						"Intro"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetGroupActive,
				null,
				5478252995653681,
				false
				,[
				[
					1,
					[
						2,
						"Story"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				7196723351525545,
				false
				,[
				[
					5,
					[
						2,
						"Story"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				77,
				cr.plugins_.Audio.prototype.acts.SetVolume,
				null,
				4614984485798793,
				false
				,[
				[
					1,
					[
						2,
						"BGM_intro"
					]
				]
,				[
					0,
					[
						0,
						-5
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				4796179144914322,
				false
				,[
				[
					1,
					[
						2,
						"handleMusic"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"BGM_intro"
							]
						]
,
						[
							7,
							[
								2,
								"start_nonloop"
							]
						]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				9803902775764396,
				false
				,[
				[
					0,
					[
						1,
						1
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				976035452883276,
				false
				,[
				[
					1,
					[
						2,
						"handleMusic"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"heartbeat"
							]
						]
,
						[
							7,
							[
								2,
								"start_nonloop"
							]
						]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9635803013162135,
			[
			[
				2,
				cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
				null,
				0,
				false,
				false,
				false,
				5346038127644317,
				false
				,[
				[
					10,
					0
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						2,
						"gold"
					]
				]
				]
			]
,			[
				40,
				cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
				null,
				0,
				false,
				false,
				false,
				6326125772181633,
				false
				,[
				[
					1,
					[
						2,
						"gold"
					]
				]
,				[
					8,
					1
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps["int"]
						,[
[
							20,
							2,
							cr.plugins_.Text.prototype.exps.Text,
							true,
							null
						]
						]
					]
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				109961495701698,
				false
				,[
				[
					1,
					[
						2,
						"setText"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"gold"
							]
						]
,
						[
							7,
							[
								20,
								40,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"gold"
								]
								]
							]
						]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8472283599077399,
			[
			[
				3,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				7731161266818619,
				false
				,[
				[
					4,
					10
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				6555483546520635,
				false
				,[
				[
					1,
					[
						2,
						"handleSound"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"button_close"
							]
						]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2087625966014541,
			[
			[
				3,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				2552565088943088,
				false
				,[
				[
					4,
					9
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1494806442444534,
				false
				,[
				[
					1,
					[
						2,
						"handleSound"
					]
				]
,				[
					13,
											[
							7,
							[
								2,
								"button_confirm"
							]
						]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5672715494443669,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				5243092828590083,
				false
			]
			],
			[
			[
				148,
				cr.plugins_.Sprite.prototype.acts.MoveToTop,
				null,
				3433391871515652,
				false
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				1952569104054565,
				[
				[
					6,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6789535064110662,
					false
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					1806685387498801,
					false
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5664658260183776,
					false
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					1518284373030879,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2443313681951097,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4597845361976388,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ping"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.MoveToTop,
						null,
						4758649127818422,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				721650096269917,
				[
				[
					45,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9079213972420349,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					2665960638144242,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2916085856591563,
				[
				[
					45,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3722192150270356,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					6763233055516417,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6221398666201362,
				[
				[
					45,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5849350783469247,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					6077875130300447,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6447035041514978,
				[
				[
					45,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5841514608899509,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4931749329036759,
					false
					,[
					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				282356752429041,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6045394373607316,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					2801096195078648,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6680450449595693,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3426007007952182,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							8
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4110031343932459,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4960760099605786,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2237066173018333,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9134722064958028,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3587817256020819,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5377510063780784,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					43068575121287,
					false
					,[
					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				311123541176581,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1630132813603385,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7858759910277039,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8727644571918867,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8927438255965927,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3585231917996075,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				181155794150553,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7857970746007196,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					2137200780673924,
					false
					,[
					[
						0,
						[
							0,
							7
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9200465286535693,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8217372658698102,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					737049818541565,
					false
					,[
					[
						0,
						[
							0,
							6
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2459848351409216,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8940822169261809,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							7
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4966169696029178,
					false
					,[
					[
						0,
						[
							0,
							8
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3380816428229865,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1862927933228536,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							9
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9419944926141993,
					false
					,[
					[
						0,
						[
							0,
							9
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6599611431141487,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					76607592364915,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7192115261361682,
					false
					,[
					[
						0,
						[
							0,
							10
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3289176014051483,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7827650032458192,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							11
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3564604870394804,
					false
					,[
					[
						0,
						[
							0,
							11
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2347586285277643,
				[
				[
					42,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					268350909884195,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							12
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4728559449971398,
					false
					,[
					[
						0,
						[
							0,
							12
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1088188555290673,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					554784122994968,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					1596387916169005,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7379774282173965,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3368014049514507,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3038478190472949,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1328525060813439,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6869785866219942,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8291067889086797,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3198411806174744,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1115552055543969,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							3
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4873244040218197,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3702344732961913,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7351010926666549,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7589362280573228,
					false
					,[
					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8346030515088314,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6574971061797741,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7308593390048612,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3598843937996168,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1660656772030237,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					1705083676531754,
					false
					,[
					[
						0,
						[
							0,
							6
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6951779943787989,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3087244641787543,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							6
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4508863611473009,
					false
					,[
					[
						0,
						[
							0,
							6
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2961118037114214,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9319173447529411,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							7
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					603885696423274,
					false
					,[
					[
						0,
						[
							0,
							7
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3364616321424901,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1385779256369672,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							8
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4649526082521146,
					false
					,[
					[
						0,
						[
							0,
							8
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4121223431447281,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7694761048321509,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							9
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7912603445039573,
					false
					,[
					[
						0,
						[
							0,
							9
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4919674194737506,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7349259503781008,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							10
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					6705711557540115,
					false
					,[
					[
						0,
						[
							0,
							10
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7978995912065439,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1629504687272384,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							11
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7673209075165479,
					false
					,[
					[
						0,
						[
							0,
							11
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5640032788001482,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					318037582315351,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							12
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					467597180998457,
					false
					,[
					[
						0,
						[
							0,
							12
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8657942007896296,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3033849562824682,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							13
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7013650106663892,
					false
					,[
					[
						0,
						[
							0,
							13
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5772488351891258,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8462293971562271,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							14
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					317234149822216,
					false
					,[
					[
						0,
						[
							0,
							14
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7565673166600134,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7279579601281799,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							15
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4457424661893784,
					false
					,[
					[
						0,
						[
							0,
							15
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5970407450315992,
				[
				[
					47,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1200043379578221,
					false
					,[
					[
						10,
						2
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							16
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					5750297632249078,
					false
					,[
					[
						0,
						[
							0,
							16
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3163054176728393,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4746432169317284,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"upgrades"
						]
					]
					]
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9554036448786244,
					false
					,[
					[
						1,
						[
							2,
							"upgrades"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5772701976959575,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4394184920908968,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"missions"
						]
					]
					]
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					6070016609723094,
					false
					,[
					[
						1,
						[
							2,
							"missions"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				642570273685803,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2421843640518577,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"vehicles"
						]
					]
					]
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					7510930873835061,
					false
					,[
					[
						1,
						[
							2,
							"vehicles"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4187441619046494,
				[
				[
					138,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					833996996181229,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"catalogue"
						]
					]
					]
				]
				],
				[
				[
					138,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3651973262181761,
					false
					,[
					[
						1,
						[
							2,
							"catalogue"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8353538209679321,
				[
				[
					139,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8784057094130167,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					139,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9633413827989812,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9159369656283897,
				[
				[
					139,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6050513087884172,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					139,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3609128120975409,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				3889817421929046,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3836048050313539,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					7088135957876597,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4338777871250244,
					[
					[
						5,
						cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
						null,
						0,
						false,
						false,
						false,
						8528502890676768,
						false
						,[
						[
							4,
							5
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						5802703631179704,
						false
					]
					],
					[
					[
						5,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5789324312684257,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2515532384098841,
						[
						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							1921744274816347,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2307760860174286,
							false
							,[
							[
								4,
								5
							]
,							[
								5,
								[
									2,
									"MainMenu"
								]
							]
,							[
								0,
								[
									0,
									568
								]
							]
,							[
								0,
								[
									0,
									320
								]
							]
							]
						]
,						[
							5,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							7735400561522059,
							false
							,[
							[
								0,
								[
									0,
									1136
								]
							]
,							[
								0,
								[
									0,
									640
								]
							]
							]
						]
,						[
							5,
							cr.plugins_.Sprite.prototype.acts.MoveToBottom,
							null,
							9564352371692497,
							false
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				3929034791091176,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					8075323382810875,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5960019146039862,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				[
					109,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7266631254109555,
					false
				]
,				[
					108,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8152957938170981,
					false
				]
,				[
					107,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3811690487494968,
					false
				]
,				[
					110,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2013094378150616,
					false
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9641547190110624,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4344106506531088,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						7880833344711102,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8181812094714427,
						false
						,[
						[
							4,
							5
						]
,						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						7449201915233639,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						6699142274862635,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						60332375313314,
						[
						[
							5,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							1754259688597157,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							3927167219262468,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4838231250420514,
							false
							,[
							[
								4,
								6
							]
,							[
								5,
								[
									2,
									"MainMenu"
								]
							]
,							[
								0,
								[
									0,
									835
								]
							]
,							[
								0,
								[
									0,
									475
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1012404824496694,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									2,
									"Characters"
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1004619797411519,
							false
							,[
							[
								10,
								1
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3564649184057541,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								4188455576429476,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"normal"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3494527553521577,
								false
								,[
								[
									1,
									[
										2,
										"Normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								1738201366738487,
								false
								,[
								[
									0,
									[
										0,
										350
									]
								]
,								[
									0,
									[
										0,
										350
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9006866253931868,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								2274457374141088,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"mecha"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3573791451187708,
								false
								,[
								[
									1,
									[
										2,
										"Mecha"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								9871362856656489,
								false
								,[
								[
									0,
									[
										0,
										350
									]
								]
,								[
									0,
									[
										0,
										350
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3745949727705678,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								2079498484756436,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"rainbow"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8230930538864674,
								false
								,[
								[
									1,
									[
										2,
										"Rainbow"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								7669602345560551,
								false
								,[
								[
									0,
									[
										0,
										350
									]
								]
,								[
									0,
									[
										0,
										350
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						573778169341892,
						[
						[
							5,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							8319035760926964,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							1768850371988289,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8904930674406123,
							false
							,[
							[
								4,
								6
							]
,							[
								5,
								[
									2,
									"MainMenu"
								]
							]
,							[
								0,
								[
									0,
									237
								]
							]
,							[
								0,
								[
									0,
									373
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8194951300387078,
							false
							,[
							[
								0,
								[
									1,
									426.433
								]
							]
,							[
								0,
								[
									1,
									426.433
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4572513467742586,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									2,
									"upgrades"
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6960264450901699,
							false
							,[
							[
								10,
								1
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2570700884560416,
							false
							,[
							[
								1,
								[
									2,
									"Menu"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							2230354553479617,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								7
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							7668862385025093,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								8
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							1818974156473286,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								113
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4770592094204698,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								686239881806361,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"normal"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								8841492394234851,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							958902173807515,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								2733109784759242,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"mecha"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								3252133141477409,
								false
								,[
								[
									0,
									[
										0,
										3
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4524147287851517,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
								null,
								0,
								false,
								false,
								false,
								9791020947131804,
								false
								,[
								[
									1,
									[
										2,
										"suit"
									]
								]
,								[
									1,
									[
										2,
										"rainbow"
									]
								]
,								[
									3,
									0
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								2214566100328009,
								false
								,[
								[
									0,
									[
										0,
										4
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8844499882081292,
						[
						[
							5,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							3403146503616744,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							7143635913556157,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1719710012644395,
							false
							,[
							[
								4,
								6
							]
,							[
								5,
								[
									2,
									"MainMenu"
								]
							]
,							[
								0,
								[
									0,
									548
								]
							]
,							[
								0,
								[
									0,
									500
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6375529826942522,
							false
							,[
							[
								1,
								[
									2,
									"Menu"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2698144912066317,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									2,
									"achievements"
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6781750258290558,
							false
							,[
							[
								10,
								1
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
,						[
							133,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5081027920148522,
							false
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1582516503178468,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6929895560913291,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"achievements"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								4692707810373214,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								6845984125375765,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									113
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8021296196241647,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									132
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8600927581701587,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									2
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								2214603260257734,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									5
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								2713178336793473,
								[
								[
									6,
									cr.plugins_.Sprite.prototype.cnds.IsVisible,
									null,
									0,
									false,
									false,
									false,
									531238141776187,
									false
								]
								],
								[
								[
									6,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									6047928920993897,
									false
									,[
									[
										0,
										[
											0,
											200
										]
									]
,									[
										0,
										[
											0,
											200
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6119385982022919,
						[
						[
							5,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							8241821347944691,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							9728837815605433,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6157402025082659,
							false
							,[
							[
								4,
								6
							]
,							[
								5,
								[
									2,
									"MainMenu"
								]
							]
,							[
								0,
								[
									0,
									1056
								]
							]
,							[
								0,
								[
									0,
									338
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9298523292553588,
							false
							,[
							[
								1,
								[
									2,
									"Menu"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9031349678599152,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									2,
									"catalogue"
								]
							]
							]
						]
,						[
							6,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4187147498195307,
							false
							,[
							[
								10,
								1
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9114701350378379,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2075712587418182,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"catalogue"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								7874922021269182,
								false
								,[
								[
									0,
									[
										0,
										128
									]
								]
,								[
									0,
									[
										0,
										256
									]
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								9919549981427354,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								7525764682751512,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									6
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								9409519076351002,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									132
								]
								]
							]
,							[
								6,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								2082408088454258,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									5
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3222069807029217,
								[
								[
									6,
									cr.plugins_.Sprite.prototype.cnds.IsVisible,
									null,
									0,
									false,
									false,
									false,
									7109742779255403,
									false
								]
								],
								[
								[
									6,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									726561372604316,
									false
									,[
									[
										0,
										[
											0,
											128
										]
									]
,									[
										0,
										[
											0,
											256
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				7555944698462225,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					7224229734058224,
					false
					,[
					[
						1,
						[
							2,
							"Story"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					2092049026332655,
					false
					,[
					[
						5,
						[
							2,
							"Story"
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4207950244624743,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_bike"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1825320327331425,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"heartbeat"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				1476383319327262,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					5867303587956647,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					6089152341242764,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8251840003498744,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						7705589799470127,
						false
					]
					],
					[
					[
						5,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6289608248469847,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				4320069772518281,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1593583457015313,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					594777528361475,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2297314191726149,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						2853612759582737,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9064584510104732,
						false
						,[
						[
							4,
							1
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						5617090248883445,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						5032952870655881,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				3304957415479743,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					6446303759183912,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					8325987075710054,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					733482254672082,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						511335107179185,
						false
					]
					],
					[
					[
						1,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8513596022531855,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				995430461604801,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					4470394818150346,
					false
					,[
					[
						1,
						[
							2,
							"Options"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					6563885333502083,
					false
					,[
					[
						5,
						[
							2,
							"Options"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3889236796859807,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						7710240341373516,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5324738977540345,
						false
						,[
						[
							4,
							1
						]
,						[
							5,
							[
								2,
								"Options"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						9931866515659267,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						9008920578748144,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				6788244446040942,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					4403963771447582,
					false
					,[
					[
						1,
						[
							2,
							"Options"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					3382584910461852,
					false
					,[
					[
						5,
						[
							2,
							"Options"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3285304700842349,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						9237955296409572,
						false
					]
					],
					[
					[
						97,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6472572723390114,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				295139440593852,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					4927143536313435,
					false
					,[
					[
						1,
						[
							2,
							"Credits"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					700173765605082,
					false
					,[
					[
						5,
						[
							2,
							"Credits"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4013425006202834,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						2559996962986837,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6871655992512939,
						false
						,[
						[
							4,
							97
						]
,						[
							5,
							[
								2,
								"Credits"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						5093601926526516,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						9576136284703701,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				8199267370624963,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					4194659480216442,
					false
					,[
					[
						1,
						[
							2,
							"Credits"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					8167193020359482,
					false
					,[
					[
						5,
						[
							2,
							"Credits"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6118879500348815,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						4108538122424959,
						false
					]
					],
					[
					[
						97,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8049714994526526,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				1524047587994239,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					828142819889385,
					false
					,[
					[
						1,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					461002190668278,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9781861016233193,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						3444762490540984,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5714680189092891,
						false
						,[
						[
							4,
							44
						]
,						[
							5,
							[
								2,
								"Upgrades"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						884273325643737,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						44,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						2426660815464724,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				9870042707833243,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					1677615842487563,
					false
					,[
					[
						1,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					2464378817119321,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8873270061884668,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						1197137236068982,
						false
					]
					],
					[
					[
						44,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1371471726809169,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				2010995674175452,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					9686204210822602,
					false
					,[
					[
						1,
						[
							2,
							"Achievements"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5349658175008892,
					false
					,[
					[
						5,
						[
							2,
							"Achievements"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					151406994780242,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						3737096781793099,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9101540820998056,
						false
						,[
						[
							4,
							41
						]
,						[
							5,
							[
								2,
								"Achievements"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						41,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						4252766900378158,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						41,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						4349857254501092,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				704383115138067,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					779762212269079,
					false
					,[
					[
						1,
						[
							2,
							"Achievements"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					4406903370462972,
					false
					,[
					[
						5,
						[
							2,
							"Achievements"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8904601675015333,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						5540362904357055,
						false
					]
					],
					[
					[
						41,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						673667425932573,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				5911617694198063,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7579161075575286,
					false
					,[
					[
						1,
						[
							2,
							"Characters"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5531294766712108,
					false
					,[
					[
						5,
						[
							2,
							"Characters"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2617455323403103,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						1659994096088459,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3867425476612115,
						false
						,[
						[
							4,
							82
						]
,						[
							5,
							[
								2,
								"Characters"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						8484554882922115,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						5628819343149336,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				6981821725226403,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					5947364096823105,
					false
					,[
					[
						1,
						[
							2,
							"Characters"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					6575943649608155,
					false
					,[
					[
						5,
						[
							2,
							"Characters"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2610736522528498,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						1127942501782225,
						false
					]
					],
					[
					[
						82,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						195482146822539,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				2810118931810744,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7667184984584516,
					false
					,[
					[
						1,
						[
							2,
							"Catalogue"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5305945256530595,
					false
					,[
					[
						5,
						[
							2,
							"Catalogue"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8807676769324146,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						3695818489947809,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1754574394934442,
						false
						,[
						[
							4,
							46
						]
,						[
							5,
							[
								2,
								"Catalogue"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						46,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						3287027816114876,
						false
						,[
						[
							0,
							[
								0,
								1136
							]
						]
,						[
							0,
							[
								0,
								640
							]
						]
						]
					]
,					[
						46,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						5387678548084456,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				7682010783867698,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					7876435025672592,
					false
					,[
					[
						1,
						[
							2,
							"Catalogue"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					2849127950392162,
					false
					,[
					[
						5,
						[
							2,
							"Catalogue"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5156238856554777,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						8148528401517548,
						false
					]
					],
					[
					[
						46,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6121065594863155,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				5347925360152719,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					9644247071913453,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5306176839341321,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1423947479088414,
					[
					[
						139,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3576890825817184,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						9842217608265101,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5751439810672851,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								78
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7786236701056021,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"rate"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5080208509060283,
						false
						,[
						[
							1,
							[
								2,
								"rate"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5405106635718214,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							148
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3244250835353098,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6606779034789316,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"title"
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							4844580809483432,
							false
							,[
							[
								0,
								[
									0,
									995
								]
							]
,							[
								0,
								[
									0,
									70
								]
							]
							]
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.MoveToTop,
							null,
							6394282946371806,
							false
						]
,						[
							0,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							9277042250551999,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								148
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5823679470702589,
					[
					[
						139,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7211589058138213,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						3690224750480292,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8964986116704576,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								78
							]
						]
,						[
							0,
							[
								0,
								80
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8451159476442247,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"credits"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7145781990289629,
						false
						,[
						[
							1,
							[
								2,
								"credits"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7318902679246947,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							148
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4895330501777764,
					[
					[
						139,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7026184772201262,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						8272716921421623,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7612101388041458,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								232
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3875507033736305,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"like"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9487858449592617,
						false
						,[
						[
							1,
							[
								2,
								"like"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4890432747990375,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							148
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2451023229866724,
					[
					[
						139,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8263015229419335,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						2983858383844863,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8195020171272056,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								913
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5203384070629754,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"tweet"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1383551131334606,
						false
						,[
						[
							1,
							[
								2,
								"tweet"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						6756616971189666,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							148
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2988878041464575,
					[
					[
						139,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3505155681240993,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						3392368801116638,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3245967099479894,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								1062
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6547954624519529,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"share"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						332165290982485,
						false
						,[
						[
							1,
							[
								2,
								"share"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						2765917209553003,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							148
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				7223930997173809,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					4648957498701161,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					8773825738817409,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					4108368299711859,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					112341002406228,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				[
					92,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					1375123890173359,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2512145469064763,
					[
					[
						0,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8141806259714722,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"title"
							]
						]
						]
					]
					],
					[
					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4793932675763002,
						false
						,[
						[
							0,
							[
								0,
								-1000
							]
						]
,						[
							0,
							[
								0,
								-1000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				4419998383352259,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					4900047669605705,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					6016432526179834,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3121238999549764,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6032492141916653,
					false
					,[
					[
						0,
						[
							0,
							1315
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9319832646691251,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8869724447543471,
				[
				[
					137,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					8461281776387623,
					false
					,[
					[
						8,
						3
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					137,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7618053772037574,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							1855
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7291626745984667,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1307200834767227,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"gold"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9325731174998698,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						8,
						2
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8226828084895901,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						7,
						[
							2,
							"0"
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9935775155894166,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold"
								]
							]
,
							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				7229580755115978,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7592859914277638,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					3952243832253611,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6479776204508693,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4784146080038911,
					false
					,[
					[
						0,
						[
							0,
							985
						]
					]
,					[
						0,
						[
							0,
							561
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9347847809366442,
					[
					[
						132,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						1066765075483489,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8978915500750461,
						[
						[
							132,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7834267191169376,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5128967978898683,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								8738419503381216,
								false
								,[
								[
									0,
									[
										1,
										3
									]
								]
								]
							]
							],
							[
							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								7185866779355855,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3166603048774733,
								false
								,[
								[
									1,
									[
										2,
										"achievement"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.StartAnim,
								null,
								3860500868203639,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9945302644135692,
								[
								[
									132,
									cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
									null,
									1,
									false,
									false,
									false,
									7134608612284609,
									false
									,[
									[
										1,
										[
											2,
											"achievement"
										]
									]
									]
								]
								],
								[
								[
									132,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									3788339419792039,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5192960646094402,
						[
						[
							132,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2641013306987869,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"upgrade"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3915088077024514,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								6838201349995866,
								false
								,[
								[
									0,
									[
										1,
										4
									]
								]
								]
							]
							],
							[
							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								3476212699937939,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3368789941921387,
								false
								,[
								[
									1,
									[
										2,
										"upgrade"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.StartAnim,
								null,
								7596747158397644,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								2872760088998066,
								[
								[
									132,
									cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
									null,
									1,
									false,
									false,
									false,
									9576359470631085,
									false
									,[
									[
										1,
										[
											2,
											"upgrade"
										]
									]
									]
								]
								],
								[
								[
									132,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									7107348055339091,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3417157619552565,
						[
						[
							132,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							716331632382399,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"character"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							1136106913878236,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								5522272649028493,
								false
								,[
								[
									0,
									[
										1,
										5
									]
								]
								]
							]
							],
							[
							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								3939505466541822,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4849494026691551,
								false
								,[
								[
									1,
									[
										2,
										"character"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.StartAnim,
								null,
								4577616905952765,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5238055139251432,
								[
								[
									132,
									cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
									null,
									1,
									false,
									false,
									false,
									7600093303954887,
									false
									,[
									[
										1,
										[
											2,
											"character"
										]
									]
									]
								]
								],
								[
								[
									132,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									4318604744168647,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5319142017382531,
						[
						[
							132,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5607004352950144,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"catalogue"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8592314887147591,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								7513791694173828,
								false
								,[
								[
									0,
									[
										1,
										6
									]
								]
								]
							]
							],
							[
							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								4315369278057301,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5979774579485991,
								false
								,[
								[
									1,
									[
										2,
										"catalogue"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								132,
								cr.plugins_.Sprite.prototype.acts.StartAnim,
								null,
								7306567024109306,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								4901480674309306,
								[
								[
									132,
									cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
									null,
									1,
									false,
									false,
									false,
									250063521912009,
									false
									,[
									[
										1,
										[
											2,
											"catalogue"
										]
									]
									]
								]
								],
								[
								[
									132,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									2467640244957772,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			1,
			"slider_helper",
			0,
			0,
false,false,299226699755176,false
		]
,		[
			0,
			[true, "Story"],
			false,
			null,
			5293928076475929,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5293928076475929,
				false
				,[
				[
					1,
					[
						2,
						"Story"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7087325028887734,
				[
				[
					124,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					1107949397231428,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					7244122405506777,
					false
				]
				],
				[
				[
					77,
					cr.plugins_.Audio.prototype.acts.SetVolume,
					null,
					7606566172209183,
					false
					,[
					[
						1,
						[
							2,
							"BGM_intro2"
						]
					]
,					[
						0,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4202681133725931,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_intro2"
								]
							]
,
							[
								7,
								[
									2,
									"start_nonloop"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7718504584081523,
				[
				[
					107,
					cr.plugins_.Sprite.prototype.cnds.CompareY,
					null,
					0,
					false,
					false,
					false,
					3690869605948041,
					false
					,[
					[
						8,
						5
					]
,					[
						0,
						[
							0,
							1136
						]
					]
					]
				]
				],
				[
				[
					107,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					4154701362018614,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3845172042653548,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					1561604925560383,
					false
					,[
					[
						5,
						[
							2,
							"Story"
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9830445575034407,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"skip_intro"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					1168658810441756,
					false
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetPos,
					null,
					2141915912792035,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7405908609339733,
					false
					,[
					[
						0,
						[
							1,
							1.5
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.acts.SetPos,
					null,
					1411236681434932,
					false
					,[
					[
						0,
						[
							0,
							1000
						]
					]
,					[
						0,
						[
							0,
							40
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2247610464835638,
				[
				[
					107,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					8696729085555739,
					false
					,[
					[
						1,
						[
							2,
							"Slide1"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1418656719815003,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						1041749094805184,
						false
						,[
						[
							0,
							[
								1,
								4
							]
						]
						]
					]
					],
					[
					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						878499757351855,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7745279646021725,
						false
						,[
						[
							0,
							[
								1,
								0.01
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5648223176532118,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						3773982404939452,
						false
						,[
						[
							0,
							[
								1,
								0.05
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4672490061373238,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9666639418143712,
						false
						,[
						[
							0,
							[
								1,
								0.05
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						955982151937229,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7665002908784937,
						false
						,[
						[
							0,
							[
								1,
								0.05
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1969092365599573,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4024132914047322,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7634444072601609,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6496604491846993,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						118,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8836210483421474,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2056758893745715,
				[
				[
					110,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					4119569516387561,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5446303330261168,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8795997432965933,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"skip_intro"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.MoveToTop,
						null,
						1768757774293129,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4859922564312814,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					5533445563975667,
					false
					,[
					[
						5,
						[
							2,
							"Story"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					1197026563745483,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					7577047638386916,
					false
					,[
					[
						4,
						107
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							640
						]
					]
					]
				]
,				[
					107,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					9712761300329544,
					false
					,[
					[
						1,
						[
							2,
							"Slide1"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					107,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					9910820973391392,
					false
				]
,				[
					129,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					393138571658357,
					false
				]
,				[
					107,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1646582688513954,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					107,
					cr.plugins_.Sprite.prototype.acts.MoveToBottom,
					null,
					6403896212900588,
					false
				]
,				[
					107,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					132333043728119,
					false
					,[
					[
						0,
						[
							0,
							25
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4192978461016139,
					false
					,[
					[
						0,
						[
							1,
							4
						]
					]
					]
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7573547182556018,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2598002890044842,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					9242533489897422,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					7798776782991652,
					false
					,[
					[
						7,
						[
							2,
							"The machines began to have a mind of its own,"
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					8489615506324058,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6013609581703599,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					7312685446468154,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							590
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					7423046896368085,
					false
					,[
					[
						7,
						[
							2,
							"..and their army continues to rise.."
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					8641591199555689,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5997097111803956,
					false
					,[
					[
						0,
						[
							0,
							8
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					1698074426533435,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					601026251961868,
					false
					,[
					[
						7,
						[
							2,
							"The colossals had brought chaos and corruption,"
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					4915240941478854,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4581633820357979,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					2394965493843167,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							590
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					2610478258295147,
					false
					,[
					[
						7,
						[
							2,
							"..and nearly ended the human race."
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					875049240485472,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6049302712300485,
					false
					,[
					[
						0,
						[
							1,
							8
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					5494049203285729,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					1495264633221475,
					false
					,[
					[
						7,
						[
							2,
							"But there was one soldier.."
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					735714023166291,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6357470983815618,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					9423820262472533,
					false
					,[
					[
						4,
						147
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					147,
					cr.behaviors.Fade.prototype.acts.StartFade,
					"Fade",
					385421312372118,
					false
				]
,				[
					147,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					5253630031271013,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						111
					]
					]
				]
,				[
					147,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					224214734596745,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						2
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					590488089352939,
					false
					,[
					[
						4,
						111
					]
,					[
						5,
						[
							2,
							"Story"
						]
					]
,					[
						0,
						[
							0,
							568
						]
					]
,					[
						0,
						[
							0,
							590
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					4565886127382952,
					false
					,[
					[
						7,
						[
							2,
							"..destined to restore that balance."
						]
					]
					]
				]
,				[
					111,
					cr.behaviors.Fade.prototype.acts.RestartFade,
					"Fade",
					8095740177864316,
					false
				]
,				[
					107,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					3258335544966,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6940011631172999,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1987269333554722,
						false
						,[
						[
							0,
							[
								1,
								6
							]
						]
						]
					]
,					[
						107,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8409382842994167,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9295828383036799,
						false
						,[
						[
							0,
							[
								1,
								4
							]
						]
						]
					]
,					[
						129,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						3875009088696808,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1084999656115016,
						false
						,[
						[
							4,
							124
						]
,						[
							5,
							[
								2,
								"Story"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						124,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7932563924510813,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							2
						]
						]
					]
,					[
						124,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						72778188421341,
						false
						,[
						[
							1,
							[
								2,
								"Slide2"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						124,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1934786204376058,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8626457494946823,
						[
						[
							111,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							1982521539397551,
							false
							,[
							[
								1,
								[
									2,
									"The soldier's name was...Layna"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3718663022665967,
							[
							[
								118,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8684772067680863,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"intro"
									]
								]
								]
							]
							],
							[
							[
								118,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								3173495265122208,
								false
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9076062671805304,
						[
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							9119329066147581,
							false
							,[
							[
								0,
								[
									1,
									2.5
								]
							]
							]
						]
,						[
							124,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7967603253784116,
							false
							,[
							[
								1,
								[
									2,
									"Slide3"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3536422940692069,
							[
							],
							[
							[
								124,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6929919720717189,
								false
								,[
								[
									1,
									[
										2,
										"Slide4"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3015860106469678,
								false
								,[
								[
									4,
									111
								]
,								[
									5,
									[
										2,
										"Story"
									]
								]
,								[
									0,
									[
										0,
										568
									]
								]
,								[
									0,
									[
										0,
										550
									]
								]
								]
							]
,							[
								111,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								4686969501052398,
								false
								,[
								[
									7,
									[
										2,
										"Her name was Layna.."
									]
								]
								]
							]
,							[
								111,
								cr.behaviors.Fade.prototype.acts.RestartFade,
								"Fade",
								9438341859703443,
								false
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								7783622727099598,
								[
								[
									111,
									cr.plugins_.Text.prototype.cnds.CompareText,
									null,
									0,
									false,
									false,
									false,
									6169196811535131,
									false
									,[
									[
										1,
										[
											2,
											"Her name was Layna.."
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.TriggerOnce,
									null,
									0,
									false,
									false,
									false,
									4264923521778685,
									false
								]
								],
								[
								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									9348397191362002,
									false
									,[
									[
										1,
										[
											2,
											"handleMusic"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"BGM_bike"
												]
											]
,
											[
												7,
												[
													2,
													"start_nonloop"
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								9085682603267584,
								[
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									2032444405981309,
									false
									,[
									[
										0,
										[
											1,
											3
										]
									]
									]
								]
,								[
									124,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4784345357201438,
									false
									,[
									[
										1,
										[
											2,
											"Slide5"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									1700765947690337,
									false
									,[
									[
										0,
										[
											1,
											2.5
										]
									]
									]
								]
,								[
									124,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									8882294301736982,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8367968077140112,
									false
									,[
									[
										4,
										110
									]
,									[
										5,
										[
											2,
											"Story"
										]
									]
,									[
										0,
										[
											0,
											0
										]
									]
,									[
										0,
										[
											0,
											0
										]
									]
									]
								]
,								[
									110,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									5822031339683143,
									false
									,[
									[
										3,
										0
									]
,									[
										4,
										107
									]
									]
								]
,								[
									110,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2544415604162791,
									false
									,[
									[
										1,
										[
											2,
											"Slide6"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									4323948865783437,
									false
									,[
									[
										0,
										[
											1,
											1
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									7987703007780306,
									[
									],
									[
									[
										109,
										cr.plugins_.Sprite.prototype.acts.SetVisible,
										null,
										2401228922840202,
										false
										,[
										[
											3,
											1
										]
										]
									]
,									[
										109,
										cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
										null,
										8359315220931707,
										false
										,[
										[
											3,
											0
										]
,										[
											4,
											110
										]
										]
									]
,									[
										109,
										cr.behaviors.Fade.prototype.acts.StartFade,
										"Fade",
										9909733330128992,
										false
									]
,									[
										-1,
										cr.system_object.prototype.acts.Wait,
										null,
										1336766702880267,
										false
										,[
										[
											0,
											[
												1,
												1
											]
										]
										]
									]
,									[
										-1,
										cr.system_object.prototype.acts.CreateObject,
										null,
										4086447040646497,
										false
										,[
										[
											4,
											111
										]
,										[
											5,
											[
												2,
												"Story"
											]
										]
,										[
											0,
											[
												0,
												568
											]
										]
,										[
											0,
											[
												0,
												550
											]
										]
										]
									]
,									[
										111,
										cr.plugins_.Text.prototype.acts.SetFontColor,
										null,
										989088176996682,
										false
										,[
										[
											0,
											[
												19,
												cr.system_object.prototype.exps.rgb
												,[
[
													0,
													100
												]
,[
													0,
													100
												]
,[
													0,
													100
												]
												]
											]
										]
										]
									]
,									[
										111,
										cr.plugins_.Text.prototype.acts.SetText,
										null,
										9811167012143539,
										false
										,[
										[
											7,
											[
												2,
												"Layna was once human.."
											]
										]
										]
									]
,									[
										111,
										cr.behaviors.Fade.prototype.acts.RestartFade,
										"Fade",
										9809712405881564,
										false
									]
,									[
										-1,
										cr.system_object.prototype.acts.Wait,
										null,
										3906430428857617,
										false
										,[
										[
											0,
											[
												1,
												2
											]
										]
										]
									]
,									[
										-1,
										cr.system_object.prototype.acts.CreateObject,
										null,
										1847470443385326,
										false
										,[
										[
											4,
											111
										]
,										[
											5,
											[
												2,
												"Story"
											]
										]
,										[
											0,
											[
												0,
												568
											]
										]
,										[
											0,
											[
												0,
												590
											]
										]
										]
									]
,									[
										111,
										cr.plugins_.Text.prototype.acts.SetFontColor,
										null,
										4811373102115541,
										false
										,[
										[
											0,
											[
												19,
												cr.system_object.prototype.exps.rgb
												,[
[
													0,
													100
												]
,[
													0,
													100
												]
,[
													0,
													100
												]
												]
											]
										]
										]
									]
,									[
										111,
										cr.plugins_.Text.prototype.acts.SetText,
										null,
										8995327058202192,
										false
										,[
										[
											7,
											[
												2,
												"..but will she discover the truth about her past?"
											]
										]
										]
									]
,									[
										111,
										cr.behaviors.Fade.prototype.acts.RestartFade,
										"Fade",
										9118351438670033,
										false
									]
,									[
										-1,
										cr.system_object.prototype.acts.Wait,
										null,
										8213489183229302,
										false
										,[
										[
											0,
											[
												1,
												8
											]
										]
										]
									]
									]
									,[
									[
										0,
										null,
										false,
										null,
										6060797505482938,
										[
										],
										[
										[
											11,
											cr.plugins_.Function.prototype.acts.CallFunction,
											null,
											6403653848640634,
											false
											,[
											[
												1,
												[
													2,
													"handleMusic"
												]
											]
,											[
												13,
																									[
														7,
														[
															2,
															"BGM_bike"
														]
													]
,
													[
														7,
														[
															2,
															"stop"
														]
													]
											]
											]
										]
,										[
											11,
											cr.plugins_.Function.prototype.acts.CallFunction,
											null,
											3002450626920852,
											false
											,[
											[
												1,
												[
													2,
													"handleMusic"
												]
											]
,											[
												13,
																									[
														7,
														[
															2,
															"heartbeat"
														]
													]
,
													[
														7,
														[
															2,
															"stop"
														]
													]
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetLayerVisible,
											null,
											3135333239426781,
											false
											,[
											[
												5,
												[
													2,
													"Story"
												]
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetGroupActive,
											null,
											4655906113562353,
											false
											,[
											[
												1,
												[
													2,
													"Story"
												]
											]
,											[
												3,
												0
											]
											]
										]
,										[
											107,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											1485126656590755,
											false
										]
,										[
											110,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											4428672801453321,
											false
										]
,										[
											109,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											8004383675599244,
											false
										]
,										[
											108,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											8283751169164625,
											false
										]
,										[
											129,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											8998096670548548,
											false
										]
,										[
											147,
											cr.plugins_.Sprite.prototype.acts.Destroy,
											null,
											8581628246741032,
											false
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetLayerVisible,
											null,
											6020953376975163,
											false
											,[
											[
												5,
												[
													2,
													"TitleScreen"
												]
											]
,											[
												3,
												1
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetGroupActive,
											null,
											3160249011549713,
											false
											,[
											[
												1,
												[
													2,
													"TitleScreen"
												]
											]
,											[
												3,
												1
											]
											]
										]
,										[
											148,
											cr.behaviors.Fade.prototype.acts.StartFade,
											"Fade",
											3423247917413166,
											false
										]
,										[
											11,
											cr.plugins_.Function.prototype.acts.CallFunction,
											null,
											3824860561548894,
											false
											,[
											[
												1,
												[
													2,
													"handleMusic"
												]
											]
,											[
												13,
																									[
														7,
														[
															2,
															"BGM_intro"
														]
													]
,
													[
														7,
														[
															2,
															"stop"
														]
													]
											]
											]
										]
,										[
											11,
											cr.plugins_.Function.prototype.acts.CallFunction,
											null,
											5852868027463787,
											false
											,[
											[
												1,
												[
													2,
													"handleMusic"
												]
											]
,											[
												13,
																									[
														7,
														[
															2,
															"BGM_menu"
														]
													]
,
													[
														7,
														[
															2,
															"start"
														]
													]
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.CreateObject,
											null,
											543848997367854,
											false
											,[
											[
												4,
												133
											]
,											[
												5,
												[
													2,
													"TitleScreen"
												]
											]
,											[
												0,
												[
													0,
													567
												]
											]
,											[
												0,
												[
													0,
													317
												]
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.SetSize,
											null,
											2741356837683502,
											false
											,[
											[
												0,
												[
													1,
													1325.473
												]
											]
,											[
												0,
												[
													1,
													1168.944
												]
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.MoveToLayer,
											null,
											7164576295994348,
											false
											,[
											[
												5,
												[
													2,
													"TitleScreen"
												]
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											3955384885206865,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												139
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											9800823268648855,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												92
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											9948564829569171,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												134
											]
											]
										]
,										[
											133,
											cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
											null,
											2089418321057715,
											false
											,[
											[
												3,
												1
											]
,											[
												4,
												93
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.CreateObject,
											null,
											9976693297924945,
											false
											,[
											[
												4,
												148
											]
,											[
												5,
												[
													2,
													"TitleScreen"
												]
											]
,											[
												0,
												[
													0,
													0
												]
											]
,											[
												0,
												[
													0,
													0
												]
											]
											]
										]
,										[
											148,
											cr.plugins_.Sprite.prototype.acts.SetPos,
											null,
											1944052139249759,
											false
											,[
											[
												0,
												[
													0,
													568
												]
											]
,											[
												0,
												[
													0,
													320
												]
											]
											]
										]
,										[
											148,
											cr.plugins_.Sprite.prototype.acts.SetSize,
											null,
											976307452833337,
											false
											,[
											[
												0,
												[
													1,
													1399.101
												]
											]
,											[
												0,
												[
													1,
													788.226
												]
											]
											]
										]
,										[
											148,
											cr.behaviors.Fade.prototype.acts.StartFade,
											"Fade",
											9485459320571281,
											false
										]
										]
										,[
										[
											0,
											null,
											false,
											null,
											3940651629437632,
											[
											[
												148,
												cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,
												"Fade",
												1,
												false,
												false,
												false,
												4485348086428044,
												false
											]
											],
											[
											[
												148,
												cr.plugins_.Sprite.prototype.acts.Destroy,
												null,
												7112940547630108,
												false
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				253810135983493,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					2571496458372071,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					3816627676016015,
					false
					,[
					[
						4,
						2
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					3751368996211931,
					false
					,[
					[
						5,
						[
							2,
							"Story"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetFontSize,
					null,
					3566669277857589,
					false
					,[
					[
						0,
						[
							6,
							[
								20,
								2,
								cr.plugins_.Text.prototype.exps.FaceSize,
								false,
								null
							]
							,[
								1,
								0.9
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5333679907649897,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.acts.SetFontSize,
					null,
					7240076715039258,
					false
					,[
					[
						0,
						[
							7,
							[
								20,
								2,
								cr.plugins_.Text.prototype.exps.FaceSize,
								false,
								null
							]
							,[
								1,
								0.9
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1867855556428964,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7960864460142032,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						691303970460318,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"skip_intro"
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3497918213399661,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_bike"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7565640883344148,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"heartbeat"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						3248175570542773,
						false
						,[
						[
							5,
							[
								2,
								"Story"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						7195920670052345,
						false
						,[
						[
							1,
							[
								2,
								"Story"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						107,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1029614468001311,
						false
					]
,					[
						110,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9095663323138234,
						false
					]
,					[
						109,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9000346867343452,
						false
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8318877882661358,
						false
					]
,					[
						148,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						5382772365231308,
						false
					]
,					[
						129,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2371160733229371,
						false
					]
,					[
						147,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						659565318159633,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						7698857035956187,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5575475894989945,
						false
						,[
						[
							1,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						148,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1497131607479586,
						false
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6546878999331095,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_intro"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4000905605788368,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_intro2"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5737472788333266,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_menu"
									]
								]
,
								[
									7,
									[
										2,
										"start"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8169846732447313,
						false
						,[
						[
							4,
							133
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								567
							]
						]
,						[
							0,
							[
								0,
								317
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						6220763598173448,
						false
						,[
						[
							0,
							[
								1,
								1325.473
							]
						]
,						[
							0,
							[
								1,
								1168.944
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.MoveToLayer,
						null,
						6005488788782161,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5691476492561013,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							139
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7849245191682326,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							92
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						3357732414754973,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							134
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						8448535844158719,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							93
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6428322708919081,
					[
					[
						118,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						689351334500025,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"intro"
							]
						]
						]
					]
					],
					[
					[
						118,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						16989423367003,
						false
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "TitleScreen"],
			false,
			null,
			9433686419982734,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9433686419982734,
				false
				,[
				[
					1,
					[
						2,
						"TitleScreen"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4309056400297549,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					8570812896384757,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					4037945004610713,
					false
					,[
					[
						4,
						93
					]
					]
				]
,				[
					93,
					cr.plugins_.Text.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					3887806435920353,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
				],
				[
				[
					93,
					cr.plugins_.Text.prototype.acts.SetFontSize,
					null,
					7168002854244672,
					false
					,[
					[
						0,
						[
							6,
							[
								20,
								93,
								cr.plugins_.Text.prototype.exps.FaceSize,
								false,
								null
							]
							,[
								1,
								0.9
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4314995182785406,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					93,
					cr.plugins_.Text.prototype.acts.SetFontSize,
					null,
					6497478755255427,
					false
					,[
					[
						0,
						[
							7,
							[
								20,
								93,
								cr.plugins_.Text.prototype.exps.FaceSize,
								false,
								null
							]
							,[
								1,
								0.9
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3523917702394254,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2686289820303101,
					[
					[
						93,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3760570409077485,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"start_game"
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						90729464758243,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_bike"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						1722148833002963,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						6070503714723033,
						false
						,[
						[
							1,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						9875112313791828,
						false
						,[
						[
							1,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						4491286366656142,
						false
						,[
						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						9144736336544612,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6033254553564072,
					[
					[
						93,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8407757783877934,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"options"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						299988093359811,
						false
						,[
						[
							1,
							[
								2,
								"Options"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						912028439331104,
						false
						,[
						[
							5,
							[
								2,
								"Options"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						2718815588410404,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4599303410818053,
						false
						,[
						[
							1,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.MoveToLayer,
						null,
						3162100867778812,
						false
						,[
						[
							5,
							[
								2,
								"Options"
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5491999394751414,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							134
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5426558580778903,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							115
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						2120964175122118,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							52
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4381729028469026,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							59
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						9590822444356114,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
							null,
							0,
							false,
							false,
							false,
							4494255258832281,
							false
							,[
							[
								1,
								[
									2,
									"gamespeed"
								]
							]
,							[
								8,
								0
							]
,							[
								0,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							155132236787848,
							[
							[
								151,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8573246053509288,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"slow"
									]
								]
								]
							]
							],
							[
							[
								150,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								6828702555049815,
								false
								,[
								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1485765731558569,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
							null,
							0,
							false,
							false,
							false,
							9890067809591017,
							false
							,[
							[
								1,
								[
									2,
									"gamespeed"
								]
							]
,							[
								8,
								0
							]
,							[
								0,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							4037345869310057,
							[
							[
								151,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7152761889826636,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"normal"
									]
								]
								]
							]
							],
							[
							[
								150,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								1812956676538075,
								false
								,[
								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2993890981751728,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
							null,
							0,
							false,
							false,
							false,
							8220562249654442,
							false
							,[
							[
								1,
								[
									2,
									"gamespeed"
								]
							]
,							[
								8,
								0
							]
,							[
								0,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							2542992999167957,
							[
							[
								151,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								496211183414155,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"fast"
									]
								]
								]
							]
							],
							[
							[
								150,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								3983754576606347,
								false
								,[
								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										20,
										151,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7788789503643417,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4166884942044732,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					6849812201574469,
					false
					,[
					[
						4,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					3527579607783824,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					913692306768973,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3170240430408122,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5050813941060213,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2917977677158976,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					6283613899857392,
					false
					,[
					[
						1,
						[
							2,
							"http://sammustudios.com"
						]
					]
,					[
						1,
						[
							2,
							"NewWindow"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1530431421354771,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					4736956107174988,
					false
					,[
					[
						4,
						92
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5481116957887094,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5036044582563466,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"rate"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7306770072952562,
						[
						[
							-1,
							cr.system_object.prototype.cnds.IsOnPlatform,
							null,
							0,
							false,
							false,
							false,
							907636803364286,
							false
							,[
							[
								3,
								1
							]
							]
						]
						],
						[
						[
							92,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							5721041757960965,
							false
							,[
							[
								0,
								[
									1,
									0.9
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4080887304715218,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							92,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							4807783798641567,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1570858113557484,
							false
							,[
							[
								0,
								[
									1,
									0.1
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Browser.prototype.acts.GoToURLWindow,
							null,
							8635687285504531,
							false
							,[
							[
								1,
								[
									2,
									"http://itunes.apple.com/us/app/colossal-defenders/id908456978?ls=1&mt=8"
								]
							]
,							[
								1,
								[
									2,
									"NewWindow"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3064578046470694,
						[
						[
							-1,
							cr.system_object.prototype.cnds.IsOnPlatform,
							null,
							0,
							false,
							false,
							false,
							1772647876518288,
							false
							,[
							[
								3,
								2
							]
							]
						]
						],
						[
						[
							92,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							1520084033375057,
							false
							,[
							[
								0,
								[
									1,
									0.9
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2422809075839442,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							92,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							1097418054976695,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2765882147274825,
							false
							,[
							[
								0,
								[
									1,
									0.1
								]
							]
							]
						]
,						[
							4,
							cr.plugins_.Browser.prototype.acts.GoToURLWindow,
							null,
							49711565383496,
							false
							,[
							[
								1,
								[
									2,
									"http://play.google.com/store/apps/details?id=com.sammustudios.colossaldefenders"
								]
							]
,							[
								1,
								[
									2,
									"NewWindow"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7635086508113211,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3235190885990861,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"credits"
							]
						]
						]
					]
					],
					[
					[
						137,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9892896335519186,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								1855
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						2296294736973922,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1818199855001618,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						362027144644085,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4371246078016721,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						7120291467048643,
						false
						,[
						[
							1,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						1703543811765467,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8138074455484888,
						false
						,[
						[
							5,
							[
								2,
								"Credits"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						6852345503217432,
						false
						,[
						[
							1,
							[
								2,
								"Credits"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						137,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						604194377255472,
						false
						,[
						[
							0,
							[
								0,
								50
							]
						]
						]
					]
,					[
						137,
						cr.plugins_.Sprite.prototype.acts.SetAngle,
						null,
						6550903975724907,
						false
						,[
						[
							0,
							[
								0,
								270
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.MoveToLayer,
						null,
						3650722674755603,
						false
						,[
						[
							5,
							[
								2,
								"Credits"
							]
						]
						]
					]
,					[
						133,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						6498410656045402,
						false
						,[
						[
							3,
							0
						]
,						[
							4,
							97
						]
						]
					]
,					[
						142,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						5040635840635785,
						false
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.MoveToTop,
						null,
						8902415986285721,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7281518549392158,
						[
						[
							0,
							cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
							null,
							0,
							false,
							false,
							false,
							4663785994610272,
							false
							,[
							[
								5,
								[
									2,
									"Credits"
								]
							]
							]
						]
						],
						[
						[
							0,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							633785873216374,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							0,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							3133865927166229,
							false
							,[
							[
								4,
								137
							]
,							[
								3,
								0
							]
							]
						]
,						[
							137,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							6558134266526984,
							false
							,[
							[
								0,
								[
									0,
									270
								]
							]
							]
						]
,						[
							142,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							5898605994788386,
							false
							,[
							[
								4,
								0
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							2282174240968583,
							[
							[
								142,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								3444612275351996,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								142,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								3404446239444156,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8636115677184323,
							[
							[
								142,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7258184713977487,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								142,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								3471502581731091,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7117054792008624,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						770364453106854,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"like"
							]
						]
						]
					]
					],
					[
					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						5808314722361465,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						5952177083901584,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						4765014784471398,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7291844426209685,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.GoToURLWindow,
						null,
						8100748043902929,
						false
						,[
						[
							1,
							[
								2,
								"http://facebook.com/colossaldefenders"
							]
						]
,						[
							1,
							[
								2,
								"NewWindow"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7740584510980471,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3414737671069343,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"tweet"
							]
						]
						]
					]
					],
					[
					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						6449011230424965,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1269820788378331,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						5678033078705149,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4251919071028957,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.GoToURLWindow,
						null,
						5648401733336019,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"http://twitter.com/intent/tweet?source=webclient&text=My%20highscore%20is%20"
												]
												,[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"bestdistance"
													]
													]
												]
											]
											,[
												2,
												"%20Meters%20and%20destroyed%20"
											]
										]
										,[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"bestkills"
											]
											]
										]
									]
									,[
										2,
										"%20Enemies"
									]
								]
								,[
									2,
									"%20%23ColossalDefenders%20http://colossaldefenders.com"
								]
							]
						]
,						[
							1,
							[
								2,
								"NewWindow"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6166231549957101,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5845710080619624,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"share"
							]
						]
						]
					]
					],
					[
					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						667677007358727,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1630742383524447,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						427293843074691,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2386870730088508,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.GoToURLWindow,
						null,
						8587573501707182,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"http://facebook.com/dialog/feed?app_id=1421485314794501&redirect_uri=https://apps.facebook.com/colossaldefenders&name=Play%20Colossal%20Defenders%20FREE%20on%20the%20App%20Store%20and%20Google%20Play!&link=http://colossaldefenders.com&picture=https://sammustudios.files.wordpress.com/2014/08/colossal_icon2.png&caption=http://colossaldefenders.com&description=My%20highscore%20is%20"
												]
												,[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"bestdistance"
													]
													]
												]
											]
											,[
												2,
												"%20Meters%20and%20destroyed%20"
											]
										]
										,[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"bestkills"
											]
											]
										]
									]
									,[
										2,
										"%20Enemies"
									]
								]
								,[
									2,
									"%20%23ColossalDefenders"
								]
							]
						]
,						[
							1,
							[
								2,
								"NewWindow"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Options"],
			false,
			null,
			5434845767081095,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5434845767081095,
				false
				,[
				[
					1,
					[
						2,
						"Options"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3415949023255693,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					6228530641631655,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					7904693850418937,
					false
					,[
					[
						4,
						128
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4798616854607322,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"options"
						]
					]
					]
				]
				],
				[
				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6862990741838115,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1131842145453738,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					7679131347527224,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9643649491701532,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5898287621481227,
					false
					,[
					[
						1,
						[
							2,
							"Options"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7694312862912207,
					false
					,[
					[
						5,
						[
							2,
							"Options"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					9158171671021844,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7985149493978332,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					6217651700326063,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					3616297432203032,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						139
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					8031444964877447,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						92
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					1727124430936941,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						134
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					1706796201687512,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						93
					]
					]
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8484623827506563,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1539206657289273,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					1214348646912035,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					3037529326229635,
					false
					,[
					[
						4,
						59
					]
					]
				]
				],
				[
				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					1824092692716755,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6800788405455976,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3092460386292061,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					431298218306852,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3443110991726142,
					false
					,[
					[
						1,
						[
							2,
							"PopUp"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Options"
								]
							]
,
							[
								7,
								[
									2,
									"confirm"
								]
							]
,
							[
								7,
								[
									2,
									"resetGame"
								]
							]
					]
					]
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					286597659635177,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2672682230966667,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					9335232657999518,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					6805512142691294,
					false
					,[
					[
						4,
						151
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1420898922237592,
					[
					[
						151,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2073290138533595,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"slow"
							]
						]
						]
					]
					],
					[
					[
						150,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2617696370582521,
						false
						,[
						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1929932371539119,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								0,
								-8
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9073712124449307,
						false
						,[
						[
							11,
							"speed_normal"
						]
,						[
							7,
							[
								0,
								-8
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6146140214998915,
						false
						,[
						[
							1,
							[
								2,
								"gamespeed"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5035835176093547,
					[
					[
						151,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3773760099038344,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"normal"
							]
						]
						]
					]
					],
					[
					[
						150,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						44885841138158,
						false
						,[
						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5106553422685287,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								0,
								-10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9847057498732971,
						false
						,[
						[
							11,
							"speed_normal"
						]
,						[
							7,
							[
								0,
								-10
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9830087836507325,
						false
						,[
						[
							1,
							[
								2,
								"gamespeed"
							]
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1791885019615286,
					[
					[
						151,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7258141565786172,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"fast"
							]
						]
						]
					]
					],
					[
					[
						150,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3616795760976776,
						false
						,[
						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								151,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1840950602421582,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								0,
								-15
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4375286382715071,
						false
						,[
						[
							11,
							"speed_normal"
						]
,						[
							7,
							[
								0,
								-15
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4840362648272514,
						false
						,[
						[
							1,
							[
								2,
								"gamespeed"
							]
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9626679553529412,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					6985132840513054,
					false
					,[
					[
						1,
						[
							2,
							"resetGame"
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5294579765594095,
					false
					,[
					[
						1,
						[
							2,
							"grenades"
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8237790270971364,
					false
					,[
					[
						1,
						[
							2,
							"kills_overall"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1500540535893906,
					false
					,[
					[
						1,
						[
							2,
							"mecha_suit_activated"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4670197503394822,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						7,
						[
							0,
							500
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.RemoveLocal,
					null,
					3401019357887973,
					false
					,[
					[
						1,
						[
							2,
							"tutorial"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2652019586992205,
					false
					,[
					[
						1,
						[
							2,
							"attackdamage"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7701534349251564,
					false
					,[
					[
						1,
						[
							2,
							"suit_2"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					364699719042625,
					false
					,[
					[
						1,
						[
							2,
							"suit_3"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4400592322098113,
					false
					,[
					[
						1,
						[
							2,
							"suit"
						]
					]
,					[
						7,
						[
							2,
							"normal"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5876567721012975,
					false
					,[
					[
						1,
						[
							2,
							"bestdistance"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2789639964637894,
					false
					,[
					[
						1,
						[
							2,
							"bestkills"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6138570621034271,
					false
					,[
					[
						1,
						[
							2,
							"PlayTutorial"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9635627280251469,
					false
					,[
					[
						1,
						[
							2,
							"Step1"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8024181611246084,
					false
					,[
					[
						1,
						[
							2,
							"Step2"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5597364236014981,
					false
					,[
					[
						1,
						[
							2,
							"Step3"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3164742083440936,
					false
					,[
					[
						1,
						[
							2,
							"AdToggle"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5383197826519786,
					false
					,[
					[
						1,
						[
							2,
							"SocialGold"
						]
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8019558805847113,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5682273852661779,
					false
					,[
					[
						11,
						"speed_normal"
					]
,					[
						7,
						[
							0,
							-10
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8940519636246031,
					false
					,[
					[
						1,
						[
							2,
							"gamespeed"
						]
					]
,					[
						7,
						[
							0,
							2
						]
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6127514361122631,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4460772837738858,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4879223420331032,
					[
					[
						-1,
						cr.system_object.prototype.cnds.For,
						null,
						0,
						true,
						false,
						false,
						3901124252395975,
						false
						,[
						[
							1,
							[
								2,
								"1"
							]
						]
,						[
							0,
							[
								0,
								1
							]
						]
,						[
							0,
							[
								0,
								12
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						701906897030326,
						false
						,[
						[
							1,
							[
								10,
								[
									19,
									cr.system_object.prototype.exps.loopindex
								]
								,[
									2,
									"_1"
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						534554569343468,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"achieve_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8663926938771535,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"upgrade_"
								]
								,[
									19,
									cr.system_object.prototype.exps.loopindex
								]
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						879928429330383,
						[
						[
							-1,
							cr.system_object.prototype.cnds.For,
							null,
							0,
							true,
							false,
							false,
							7936974796089686,
							false
							,[
							[
								1,
								[
									2,
									"catalogue"
								]
							]
,							[
								0,
								[
									0,
									1
								]
							]
,							[
								0,
								[
									0,
									16
								]
							]
							]
						]
						],
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							4903281633980453,
							false
							,[
							[
								1,
								[
									10,
									[
										10,
										[
											19,
											cr.system_object.prototype.exps.loopindex
											,[
[
												2,
												"1"
											]
											]
										]
										,[
											2,
											"_"
										]
									]
									,[
										19,
										cr.system_object.prototype.exps.loopindex
										,[
[
											2,
											"catalogue"
										]
										]
									]
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5454819594962275,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.RestartLayout,
						null,
						8504069333094295,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4240047115274696,
						false
						,[
						[
							1,
							[
								2,
								"Options"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8256763526711051,
				[
				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					6938883825109794,
					false
					,[
					[
						5,
						[
							2,
							"Options"
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					6349615955713554,
					false
					,[
					[
						4,
						52
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7979045022996939,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						5676528544468218,
						false
						,[
						[
							7,
							[
								20,
								3,
								cr.plugins_.Touch.prototype.exps.AbsoluteX,
								false,
								null
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								23,
								"slider_helper"
							]
						]
						]
					]
					],
					[
					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9540940131347129,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6615860947985022,
						false
						,[
						[
							1,
							[
								21,
								52,
								true,
								null
								,0
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5980902354994289,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3142545911375968,
							false
							,[
							[
								7,
								[
									21,
									52,
									true,
									null
									,0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"bg_sound"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							321665005344338,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6838242561268126,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"BGM_menu"
										]
									]
,
									[
										7,
										[
											2,
											"start"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5662384292520368,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3775231392913695,
							false
							,[
							[
								7,
								[
									21,
									52,
									true,
									null
									,0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"fx_sound"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							405778556003845,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5669612893551735,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"player_revolver"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1228263322918109,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						8463768651337463,
						false
						,[
						[
							7,
							[
								20,
								3,
								cr.plugins_.Touch.prototype.exps.AbsoluteX,
								false,
								null
							]
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"slider_helper"
							]
						]
						]
					]
					],
					[
					[
						52,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4499809496202654,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						9210375384632099,
						false
						,[
						[
							1,
							[
								21,
								52,
								true,
								null
								,0
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8101839523955507,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							7281422454988206,
							false
							,[
							[
								7,
								[
									21,
									52,
									true,
									null
									,0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"bg_sound"
								]
							]
							]
						]
						],
						[
						[
							77,
							cr.plugins_.Audio.prototype.acts.Stop,
							null,
							2006722714099165,
							false
							,[
							[
								1,
								[
									2,
									"BGM_menu"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9686000433126285,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3066393112921684,
							false
							,[
							[
								7,
								[
									21,
									52,
									true,
									null
									,0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"fx_sound"
								]
							]
							]
						]
						],
						[
						[
							77,
							cr.plugins_.Audio.prototype.acts.Stop,
							null,
							1054709417473221,
							false
							,[
							[
								1,
								[
									2,
									"player_revolver"
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1345456833642171,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4579489966591758,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					199475201456505,
					false
					,[
					[
						4,
						52
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					7881851782109899,
					false
					,[
					[
						5,
						[
							2,
							"Options"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2641879496360423,
					false
					,[
					[
						11,
						"slider_helper"
					]
,					[
						7,
						[
							20,
							3,
							cr.plugins_.Touch.prototype.exps.AbsoluteX,
							false,
							null
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Credits"],
			false,
			null,
			8143204110859523,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8143204110859523,
				false
				,[
				[
					1,
					[
						2,
						"Credits"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3415949023255693,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					6228530641631655,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					7904693850418937,
					false
					,[
					[
						4,
						128
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					346856634322885,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"credits"
						]
					]
					]
				]
				],
				[
				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6862990741838115,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1131842145453738,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					7679131347527224,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9643649491701532,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					137,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6732253017805797,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							1855
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5898287621481227,
					false
					,[
					[
						1,
						[
							2,
							"Credits"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7694312862912207,
					false
					,[
					[
						5,
						[
							2,
							"Credits"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					9158171671021844,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7985149493978332,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					137,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					3723246138188953,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					2211121036021596,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					6354469663199048,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						139
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					7061560320603888,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						92
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					5490351915734427,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						134
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					2574021959259503,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						93
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "MainMenu"],
			false,
			null,
			5815371180803969,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5815371180803969,
				false
				,[
				[
					1,
					[
						2,
						"MainMenu"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7166370246367462,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					1688274567778669,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					6074858575486733,
					false
					,[
					[
						4,
						6
					]
					]
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6614710071519234,
					false
					,[
					[
						0,
						[
							0,
							1315
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					4678790311902549,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7459010238180955,
					[
					[
						6,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3705600898625665,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievements"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						8029033825423577,
						false
						,[
						[
							1,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						5469815716110024,
						false
						,[
						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						9469513280605151,
						false
						,[
						[
							1,
							[
								2,
								"Achievements"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						286491350130114,
						false
						,[
						[
							5,
							[
								2,
								"Achievements"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5938222079896972,
						false
						,[
						[
							1,
							[
								2,
								"Browse"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1564432867104091,
						false
						,[
						[
							1,
							[
								2,
								"initiateBrowsing"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										6,
										true,
										null
										,0
									]
								]
,
								[
									7,
									[
										21,
										6,
										false,
										null
										,1
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					732290978282242,
					[
					[
						6,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2955140816453753,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"catalogue"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						9878360658529233,
						false
						,[
						[
							1,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8610477858912706,
						false
						,[
						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						6384153607198334,
						false
						,[
						[
							1,
							[
								2,
								"Catalogue"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						1745498905557519,
						false
						,[
						[
							5,
							[
								2,
								"Catalogue"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3530644556446497,
						false
						,[
						[
							1,
							[
								2,
								"Browse"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4654233742120428,
						false
						,[
						[
							1,
							[
								2,
								"initiateBrowsing"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										6,
										true,
										null
										,0
									]
								]
,
								[
									7,
									[
										21,
										6,
										false,
										null
										,1
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8934482740683159,
					[
					[
						6,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9897709657645226,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"upgrades"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3062270054961515,
						false
						,[
						[
							1,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8740707361382379,
						false
						,[
						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1182221408663933,
						false
						,[
						[
							1,
							[
								2,
								"Upgrades"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						9546304453397334,
						false
						,[
						[
							5,
							[
								2,
								"Upgrades"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3880809211485649,
						false
						,[
						[
							1,
							[
								2,
								"Browse"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5703114167569344,
						false
						,[
						[
							1,
							[
								2,
								"initiateBrowsing"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										6,
										true,
										null
										,0
									]
								]
,
								[
									7,
									[
										21,
										6,
										false,
										null
										,1
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6989560060462049,
					[
					[
						6,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4599821927290274,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Characters"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						2452473722826394,
						false
						,[
						[
							1,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						3568121899032325,
						false
						,[
						[
							5,
							[
								2,
								"MainMenu"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3306455806942605,
						false
						,[
						[
							1,
							[
								2,
								"Characters"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						4463932263473693,
						false
						,[
						[
							5,
							[
								2,
								"Characters"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4505084563404942,
						false
						,[
						[
							1,
							[
								2,
								"Browse"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4686891587359014,
						false
						,[
						[
							1,
							[
								2,
								"initiateBrowsing"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										6,
										true,
										null
										,0
									]
								]
,
								[
									7,
									[
										21,
										6,
										false,
										null
										,1
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8460163712523913,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4354706175988004,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					2719239795167227,
					false
					,[
					[
						4,
						128
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9984678847666413,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"mainmenu"
						]
					]
					]
				]
				],
				[
				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8380758436318113,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2074647200929899,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					489340183811698,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3236537615414368,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9066211796762454,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7270820539283502,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3734025261444985,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					768351743354992,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9692836243002723,
					false
					,[
					[
						1,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					3565725145359095,
					false
					,[
					[
						4,
						133
					]
,					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
,					[
						0,
						[
							0,
							567
						]
					]
,					[
						0,
						[
							0,
							317
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.SetSize,
					null,
					2541984887821243,
					false
					,[
					[
						0,
						[
							1,
							1325.473
						]
					]
,					[
						0,
						[
							1,
							1168.944
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.MoveToLayer,
					null,
					1458429937622529,
					false
					,[
					[
						5,
						[
							2,
							"TitleScreen"
						]
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					2714864753100996,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						139
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					2827696757326412,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						92
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					3795295227214315,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						134
					]
					]
				]
,				[
					133,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					6370572765377168,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						93
					]
					]
				]
,				[
					148,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7771678685055478,
					false
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8453677153452404,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						2760549236774178,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1218399554573003,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								78
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5407494904090733,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"rate"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5773785206324559,
						false
						,[
						[
							1,
							[
								2,
								"rate"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6332934645481834,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						5202727334382772,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8145556121235615,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								78
							]
						]
,						[
							0,
							[
								0,
								80
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						4130104791097805,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"credits"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1128756082512384,
						false
						,[
						[
							1,
							[
								2,
								"credits"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5081531060352574,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						4862743350368517,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5637489301615938,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								232
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						3243941624868672,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"like"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7572416542827883,
						false
						,[
						[
							1,
							[
								2,
								"like"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6171781191317325,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						4089075729412788,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8997431050175733,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								913
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7311303760817404,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"tweet"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						646256539828874,
						false
						,[
						[
							1,
							[
								2,
								"tweet"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					969333499230873,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						6189359374587503,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						8577933301953211,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							0,
							[
								0,
								1062
							]
						]
,						[
							0,
							[
								0,
								544
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						1268932086629865,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"share"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						724377623146658,
						false
						,[
						[
							1,
							[
								2,
								"share"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4899770577949125,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					316273520033806,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					5620282513097479,
					false
					,[
					[
						4,
						127
					]
					]
				]
				],
				[
				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5108496704524007,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7297730263501059,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					4277624127855817,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4241576588470995,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6703793622158609,
					false
					,[
					[
						5,
						[
							2,
							"Loading"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8860193267666059,
					false
					,[
					[
						1,
						[
							2,
							"Loading"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8704336908785199,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					57962536842593,
					false
					,[
					[
						6,
						"Game"
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2254678257395059,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					6037076880538984,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					3424396194306623,
					false
					,[
					[
						4,
						7
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					8474936674750668,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3610022264054277,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7908458392790932,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8590156098527424,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1635605175825914,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4188456870067651,
					false
					,[
					[
						1,
						[
							2,
							"handleShopMenu"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9222565388368353,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8098669138771247,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					7934907936164722,
					false
					,[
					[
						0,
						[
							1,
							4
						]
					]
					]
				]
				],
				[
				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3427820094850793,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4151060849840632,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7386813924889045,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3822222596794896,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1122473652216099,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2242754519600353,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1326321595230798,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2824812572276514,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5971214731123628,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2934986631270067,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
,				[
					121,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6134587543039721,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Loading"],
			false,
			null,
			3091296999154563,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3091296999154563,
				false
				,[
				[
					1,
					[
						2,
						"Loading"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3209752797607454,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					2512864724650735,
					false
					,[
					[
						5,
						[
							2,
							"Loading"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2104006017030416,
					[
					[
						125,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8258220688939412,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						3827868671977088,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9383539549005067,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"normal"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							730812327224742,
							false
							,[
							[
								1,
								[
									2,
									"Normal"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							6953507124317186,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3757947884791288,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							503957005195625,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"mecha"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							616273465558358,
							false
							,[
							[
								1,
								[
									2,
									"Mecha"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8371249801891082,
							false
							,[
							[
								0,
								[
									0,
									415
								]
							]
,							[
								0,
								[
									0,
									207
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4131610032051396,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							3823877309076755,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"rainbow"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7236225756422069,
							false
							,[
							[
								1,
								[
									2,
									"Rainbow"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							3374330513048923,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5519598296403045,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					1485998711045396,
					false
					,[
					[
						5,
						[
							2,
							"Loading"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2291998429617766,
					false
					,[
					[
						1,
						[
							2,
							"Loading"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Achievements"],
			false,
			null,
			1203039403830067,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1203039403830067,
				false
				,[
				[
					1,
					[
						2,
						"Achievements"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				310999677851479,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2506310534947191,
					false
					,[
					[
						4,
						42
					]
					]
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.CompareTouchSpeed,
					null,
					0,
					false,
					false,
					false,
					9587415895489085,
					false
					,[
					[
						0,
						[
							20,
							3,
							cr.plugins_.Touch.prototype.exps.TouchIndex,
							false,
							null
						]
					]
,					[
						8,
						2
					]
,					[
						0,
						[
							0,
							5
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9788037398757675,
					false
					,[
					[
						5,
						[
							2,
							"Achievements"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					5130792290423685,
					false
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					5093608059510928,
					false
					,[
					[
						4,
						42
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					123,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					2357757482395261,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5060132963586078,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					1851187821861027,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					113619318874818,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5116283705215438,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6834640779882941,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8769556050713265,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3865342117949543,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7156978720179041,
					false
					,[
					[
						1,
						[
							2,
							"Achievements"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					4100712799102193,
					false
					,[
					[
						5,
						[
							2,
							"Achievements"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1276026175472596,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					1033365735427954,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6161854743699505,
					false
					,[
					[
						0,
						[
							0,
							1315
						]
					]
,					[
						0,
						[
							0,
							550
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Upgrades"],
			false,
			null,
			3341782374324812,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3341782374324812,
				false
				,[
				[
					1,
					[
						2,
						"Upgrades"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"upgrade_picked",
				0,
				0,
true,false,7165184358212528,false
			]
,			[
				0,
				null,
				false,
				null,
				7130432734860159,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					34208359908113,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					2990842009925897,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8306718311370182,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7283385062101018,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					597085897400408,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3173895824338138,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					35420633220382,
					false
					,[
					[
						1,
						[
							2,
							"Upgrades"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					834243170572842,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7359395781316142,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					51173153230339,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4248732115245596,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					8890668274696236,
					false
					,[
					[
						4,
						45
					]
					]
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.CompareTouchSpeed,
					null,
					0,
					false,
					false,
					false,
					6975895057046715,
					false
					,[
					[
						0,
						[
							20,
							3,
							cr.plugins_.Touch.prototype.exps.TouchIndex,
							false,
							null
						]
					]
,					[
						8,
						2
					]
,					[
						0,
						[
							0,
							5
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9126767483452235,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
				],
				[
				[
					48,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					7690749049957425,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					3967938458720744,
					false
					,[
					[
						4,
						45
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					48,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					5204283430597815,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6401880954996046,
					false
					,[
					[
						11,
						"upgrade_picked"
					]
,					[
						7,
						[
							21,
							45,
							false,
							null
							,0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6169847727737352,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					8076570457562078,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					5937900804646037,
					false
					,[
					[
						4,
						7
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					6154238918755441,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					9905479943643534,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7207077969756694,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5417116586259336,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7083110596976214,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3319106860096064,
					false
					,[
					[
						1,
						[
							2,
							"handleShopMenu"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9968485985355885,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				1,
				"security",
				0,
				0,
false,false,6552705651870714,false
			]
,			[
				0,
				null,
				false,
				null,
				2946985303521794,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1998754838397295,
					false
					,[
					[
						4,
						9
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					113634973277027,
					false
					,[
					[
						11,
						"security"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1833841089214191,
					false
					,[
					[
						11,
						"security"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					4921670592971217,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4098151996894584,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					110048505658365,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7438327326325186,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2677956600794309,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4832981245149204,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"upgrade_"
								]
								,[
									23,
									"upgrade_picked"
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.Compare,
						null,
						0,
						false,
						false,
						false,
						3665445527888904,
						false
						,[
						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									2,
									cr.plugins_.Text.prototype.exps.Text,
									true,
									null
								]
								]
							]
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								20,
								40,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"gold"
								]
								]
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7216919891847018,
						false
						,[
						[
							1,
							[
								2,
								"PopUp"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Upgrades"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"gold"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1041337515123084,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						6577361109311063,
						false
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2303716892359068,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"upgrade_"
								]
								,[
									23,
									"upgrade_picked"
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						true,
						null,
						3028300410481294,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6214550526564214,
							false
							,[
							[
								11,
								"upgrade_picked"
							]
,							[
								8,
								1
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6386183433322096,
							false
							,[
							[
								11,
								"upgrade_picked"
							]
,							[
								8,
								1
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							1417051613204939,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
								null,
								0,
								false,
								false,
								false,
								9135484404214656,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"upgrade_"
										]
										,[
											23,
											"upgrade_picked"
										]
									]
								]
,								[
									8,
									0
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7510955243643326,
								false
								,[
								[
									1,
									[
										2,
										"PopUp"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Upgrades"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"limit"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1552247273360954,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								8892004059708034,
								false
							]
							],
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								3847766254672705,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"upgrade_"
										]
										,[
											23,
											"upgrade_picked"
										]
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								117276304762268,
								false
								,[
								[
									1,
									[
										2,
										"gold"
									]
								]
,								[
									7,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
											]
										]
										,[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												2,
												cr.plugins_.Text.prototype.exps.Text,
												true,
												null
											]
											]
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5790991692879179,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
										]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3491330631616998,
								false
								,[
								[
									1,
									[
										2,
										"PopUp"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Upgrades"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"unlocked"
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8457968669416129,
								[
								[
									45,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									6481778593110861,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											23,
											"upgrade_picked"
										]
									]
									]
								]
								],
								[
								[
									45,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									1816593482676197,
									false
									,[
									[
										4,
										43
									]
,									[
										5,
										[
											2,
											"Upgrades"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									43,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									7125101455376993,
									false
									,[
									[
										4,
										45
									]
,									[
										3,
										0
									]
									]
								]
,								[
									43,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									5825601515191133,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										45
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1238607590141843,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9578758191279013,
							false
							,[
							[
								11,
								"upgrade_picked"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									2
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5703231898671057,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
								null,
								0,
								false,
								false,
								false,
								4104738136764205,
								false
								,[
								[
									1,
									[
										2,
										"grenades"
									]
								]
,								[
									8,
									5
								]
,								[
									0,
									[
										0,
										20
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8747468104784605,
								false
								,[
								[
									1,
									[
										2,
										"PopUp"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Upgrades"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"limit"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8982516747148774,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								5521473913061356,
								false
							]
							],
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								1004767716916609,
								false
								,[
								[
									1,
									[
										2,
										"grenades"
									]
								]
,								[
									7,
									[
										4,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"grenades"
												]
												]
											]
											]
										]
										,[
											0,
											1
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9134011041922018,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"grenade_limit"
											]
										]
,
										[
											7,
											[
												10,
												[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"grenades"
													]
													]
												]
												,[
													2,
													"/20"
												]
											]
										]
								]
								]
							]
,							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								9799928378755653,
								false
								,[
								[
									1,
									[
										2,
										"gold"
									]
								]
,								[
									7,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
											]
										]
										,[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												2,
												cr.plugins_.Text.prototype.exps.Text,
												true,
												null
											]
											]
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2193401400280661,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
										]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5760515398399654,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7365109038559705,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							205197222538768,
							false
							,[
							[
								11,
								"upgrade_picked"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							1939043700015837,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							52,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							6580342160407309,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3371509478862606,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8432888396134774,
							false
							,[
							[
								11,
								"upgrade_picked"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							6425525273523859,
							[
							[
								40,
								cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
								null,
								0,
								false,
								false,
								false,
								843161539454396,
								false
								,[
								[
									1,
									[
										2,
										"attackdamage"
									]
								]
,								[
									8,
									5
								]
,								[
									0,
									[
										0,
										50
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2770849034661381,
								false
								,[
								[
									1,
									[
										2,
										"PopUp"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Upgrades"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"limit"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7556288979576255,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9461371725446576,
								false
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								222029847517526,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"attackdamage"
											]
										]
,
										[
											7,
											[
												10,
												[
													10,
													[
														2,
														"Level "
													]
													,[
														4,
														[
															19,
															cr.system_object.prototype.exps["int"]
															,[
[
																20,
																40,
																cr.plugins_.WebStorage.prototype.exps.LocalValue,
																true,
																null
																,[
[
																	2,
																	"attackdamage"
																]
																]
															]
															]
														]
														,[
															0,
															1
														]
													]
												]
												,[
													2,
													"/50"
												]
											]
										]
								]
								]
							]
,							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								8513722566769715,
								false
								,[
								[
									1,
									[
										2,
										"attackdamage"
									]
								]
,								[
									7,
									[
										4,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"attackdamage"
												]
												]
											]
											]
										]
										,[
											0,
											1
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1953944646341844,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"upgrade_5"
											]
										]
,
										[
											7,
											[
												6,
												[
													19,
													cr.system_object.prototype.exps["int"]
													,[
[
														20,
														40,
														cr.plugins_.WebStorage.prototype.exps.LocalValue,
														true,
														null
														,[
[
															2,
															"attackdamage"
														]
														]
													]
													]
												]
												,[
													0,
													500
												]
											]
										]
								]
								]
							]
,							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								8941089989416091,
								false
								,[
								[
									1,
									[
										2,
										"gold"
									]
								]
,								[
									7,
									[
										5,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
											]
										]
										,[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												2,
												cr.plugins_.Text.prototype.exps.Text,
												true,
												null
											]
											]
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3606998537320052,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
										]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7842757467843329,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8793936923774573,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7207954433622434,
						false
						,[
						[
							11,
							"security"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Catalogue"],
			false,
			null,
			4089130982398468,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4089130982398468,
				false
				,[
				[
					1,
					[
						2,
						"Catalogue"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5555961432815289,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					2804352664518228,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					738687722104815,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8132744327734584,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9934311634243125,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					9580848437296541,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6149455680298352,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6656882081126692,
					false
					,[
					[
						1,
						[
							2,
							"Catalogue"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2941581933997062,
					false
					,[
					[
						5,
						[
							2,
							"Catalogue"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8883541018652001,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					618543789024968,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2640855441652213,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					9077232003072183,
					false
					,[
					[
						4,
						47
					]
					]
				]
				],
				[
				[
					58,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					8503409591464694,
					false
				]
,				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					7640480957127794,
					false
					,[
					[
						4,
						47
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					58,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					4932132645192719,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
,				[
					152,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6605008485635979,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7621331956247338,
					false
					,[
					[
						0,
						[
							0,
							272
						]
					]
,					[
						0,
						[
							0,
							351
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3445304659131115,
					[
					[
						47,
						cr.plugins_.Sprite.prototype.cnds.IsBoolInstanceVarSet,
						null,
						0,
						false,
						false,
						false,
						2594688121691268,
						false
						,[
						[
							10,
							1
						]
						]
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7432718001103179,
						false
						,[
						[
							1,
							[
								2,
								"unlocked"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8520936945741826,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2426189841553993,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"1_1"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							3807304592160862,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8010438986429406,
							false
							,[
							[
								4,
								19
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							19,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							1941779384319592,
							false
							,[
							[
								0,
								[
									1,
									350.111
								]
							]
,							[
								0,
								[
									1,
									175.056
								]
							]
							]
						]
,						[
							19,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8582935364738947,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetScale,
							null,
							5207189887350044,
							false
							,[
							[
								0,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3273608116924658,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2924776875096001,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"2_1"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5400347216418664,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3148969904507867,
							false
							,[
							[
								4,
								18
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							18,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							5785571061742249,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							18,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							178021315374682,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6309792721922804,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8954039627995078,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"3_1"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6039555153562377,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1701131558546089,
							false
							,[
							[
								4,
								20
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							20,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8433046843417525,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							20,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3651943350427001,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9366797348137102,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2922788658534554,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"4_1"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							2056964837104842,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9744508193602518,
							false
							,[
							[
								4,
								55
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							55,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							1138080714875391,
							false
							,[
							[
								0,
								[
									1,
									340.963
								]
							]
,							[
								0,
								[
									1,
									340.963
								]
							]
							]
						]
,						[
							55,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2872208602591183,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9272900093650033,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6403011640287408,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"1_2"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8555714473819811,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4558715681123764,
							false
							,[
							[
								4,
								65
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									367
								]
							]
							]
						]
,						[
							65,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							5765135223023094,
							false
							,[
							[
								0,
								[
									1,
									339.497
								]
							]
,							[
								0,
								[
									1,
									339.497
								]
							]
							]
						]
,						[
							65,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5836048711081168,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8535604248868292,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5407537338695035,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"2_2"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5036808783091757,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5235988127749217,
							false
							,[
							[
								4,
								63
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							334350569337225,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5809711111228291,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6651947076792393,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1062130692585045,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"3_2"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							9538802802686971,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							289899743322345,
							false
							,[
							[
								4,
								67
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							148120605351869,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							67,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6717457671358529,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2446883083663874,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1810436687754421,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"4_2"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							899901771343981,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3768507253939256,
							false
							,[
							[
								4,
								61
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									345
								]
							]
,							[
								0,
								[
									0,
									341
								]
							]
							]
						]
,						[
							61,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							6390911764753017,
							false
							,[
							[
								0,
								[
									1,
									334.819
								]
							]
,							[
								0,
								[
									1,
									334.819
								]
							]
							]
						]
,						[
							61,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							411689548467342,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2536489479179111,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5284457569643739,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"1_3"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							2962903131477072,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							331924173700109,
							false
							,[
							[
								4,
								66
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							66,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							4579071234904865,
							false
							,[
							[
								0,
								[
									1,
									314.975
								]
							]
,							[
								0,
								[
									1,
									314.975
								]
							]
							]
						]
,						[
							66,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3521811910274407,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4399936282979656,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2468351348558786,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"2_3"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6755893237845823,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8739479767974991,
							false
							,[
							[
								4,
								64
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							64,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							7317924911749963,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							64,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8338664250946296,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6176787073794772,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9945939248323748,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"3_3"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							982268278739639,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8770520310646449,
							false
							,[
							[
								4,
								68
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							68,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							2158265218553137,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							68,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1919396920213737,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3795454645476444,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9594595224848494,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"4_3"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6877523578417548,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7179703838826111,
							false
							,[
							[
								4,
								62
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									273
								]
							]
,							[
								0,
								[
									0,
									315
								]
							]
							]
						]
,						[
							62,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							5003323958265123,
							false
							,[
							[
								0,
								[
									0,
									394
								]
							]
,							[
								0,
								[
									0,
									394
								]
							]
							]
						]
,						[
							62,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9456226036892829,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						36340775871253,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6221012992786088,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"1_4"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							9372736362564689,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1564790238809442,
							false
							,[
							[
								4,
								91
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							91,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							3413373968387432,
							false
							,[
							[
								0,
								[
									1,
									297.958
								]
							]
,							[
								0,
								[
									1,
									297.958
								]
							]
							]
						]
,						[
							91,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1926899368308882,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8772794523159576,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							412790398744715,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"2_4"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							3664719878204235,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1896608328917836,
							false
							,[
							[
								4,
								88
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							88,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							3606790652400733,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							88,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1934377506085273,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2797644451397268,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1706609749181347,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"3_4"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7966617041739919,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3150920716344961,
							false
							,[
							[
								4,
								89
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							89,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							4639605398178042,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
,							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							89,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5848397017548859,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8817159811946564,
						[
						[
							47,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9185502196977674,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"4_4"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							1853244613076884,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5617258122766485,
							false
							,[
							[
								4,
								90
							]
,							[
								5,
								[
									2,
									"Catalogue"
								]
							]
,							[
								0,
								[
									0,
									272
								]
							]
,							[
								0,
								[
									0,
									351
								]
							]
							]
						]
,						[
							90,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							9133117569034304,
							false
							,[
							[
								0,
								[
									1,
									362.491
								]
							]
,							[
								0,
								[
									1,
									362.491
								]
							]
							]
						]
,						[
							90,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							860395597451482,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1687123794267225,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						1865160285328114,
						false
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1033812068013491,
						false
						,[
						[
							1,
							[
								2,
								"default"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					241232711918887,
					[
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9708101328426832,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									47,
									false,
									null
									,2
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Characters"],
			false,
			null,
			6755835277385043,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6755835277385043,
				false
				,[
				[
					1,
					[
						2,
						"Characters"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5555961432815289,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					2804352664518228,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					738687722104815,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8132744327734584,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9934311634243125,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					10,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					9580848437296541,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6149455680298352,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6656882081126692,
					false
					,[
					[
						1,
						[
							2,
							"Characters"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2941581933997062,
					false
					,[
					[
						5,
						[
							2,
							"Characters"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8883541018652001,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					618543789024968,
					false
					,[
					[
						5,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2733463018213197,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					8805826230489581,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					602576248036565,
					[
					[
						83,
						cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
						null,
						0,
						false,
						false,
						false,
						5656781123845706,
						false
						,[
						[
							8,
							0
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
					],
					[
					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1913393068552768,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3999560863964559,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5165608904215218,
					false
					,[
					[
						4,
						83
					]
					]
				]
				],
				[
				[
					84,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					9399987715450577,
					false
					,[
					[
						4,
						83
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2290550463532702,
					[
					[
						83,
						cr.plugins_.Sprite.prototype.cnds.CompareOpacity,
						null,
						0,
						false,
						false,
						false,
						5369173222467739,
						false
						,[
						[
							8,
							0
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						533219685319617,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									21,
									83,
									false,
									null
									,1
								]
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6378449910761611,
						false
						,[
						[
							1,
							[
								2,
								"suit"
							]
						]
,						[
							7,
							[
								21,
								83,
								true,
								null
								,0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7378285311673855,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							2944888572339355,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"normal"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							2328685994396657,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1400535023844362,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								2549028434878202,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1658366692894579,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8570917460160843,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3479464474676671,
								false
								,[
								[
									1,
									[
										2,
										"Normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6670785440005308,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9754046539932895,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"mecha"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3145009268780737,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1263229660928469,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								2873149640169574,
								false
								,[
								[
									0,
									[
										0,
										3
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7452670215957226,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8490687192485807,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7499655271790029,
								false
								,[
								[
									1,
									[
										2,
										"Mecha"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6736073511037775,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9264925006155491,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"rainbow"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7798327668205606,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								5327602636713445,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"upgrades"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								4617000170572618,
								false
								,[
								[
									0,
									[
										0,
										4
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8093663903569231,
							[
							[
								6,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7588368284998817,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Characters"
									]
								]
								]
							]
							],
							[
							[
								6,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8500257863929205,
								false
								,[
								[
									1,
									[
										2,
										"Rainbow"
									]
								]
,								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3285563333559378,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					5686767592662429,
					false
					,[
					[
						1,
						[
							2,
							"Characters"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					3658954910989934,
					false
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6174877303656578,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							20,
							40,
							cr.plugins_.WebStorage.prototype.exps.LocalValue,
							true,
							null
							,[
[
								2,
								"suit"
							]
							]
						]
					]
					]
				]
				],
				[
				[
					84,
					cr.plugins_.Sprite.prototype.acts.SetPosToObject,
					null,
					8355836788577798,
					false
					,[
					[
						4,
						83
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4893296991656755,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					2201165901949476,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					4261602028218906,
					false
					,[
					[
						4,
						7
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					6994789343349522,
					false
					,[
					[
						5,
						[
							2,
							"Characters"
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5675751666381654,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6751424543588519,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3321886219790653,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6144892280337829,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8240756687404735,
					false
					,[
					[
						1,
						[
							2,
							"handleShopMenu"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4864114738538417,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				1,
				"security",
				0,
				0,
false,false,6618583836689213,false
			]
,			[
				0,
				null,
				false,
				null,
				4286144543107559,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7084713789716638,
					false
					,[
					[
						4,
						9
					]
					]
				]
,				[
					83,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					3931804517044498,
					false
					,[
					[
						8,
						0
					]
,					[
						0,
						[
							20,
							84,
							cr.plugins_.Sprite.prototype.exps.X,
							false,
							null
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7604875203636155,
					false
					,[
					[
						11,
						"security"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					9036652183942927,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1835563089206106,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					7052632362425751,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2210440684362171,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2649886795201344,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						1062398023934439,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									21,
									83,
									false,
									null
									,1
								]
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8195704870477706,
						false
						,[
						[
							1,
							[
								2,
								"PopUp"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Characters"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"already_purchased"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3334489892739116,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						1688657005972878,
						false
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9567811054106129,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"suit_"
								]
								,[
									21,
									83,
									false,
									null
									,1
								]
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8396917940275516,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5541504681716116,
							false
							,[
							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										2,
										cr.plugins_.Text.prototype.exps.Text,
										true,
										null
									]
									]
								]
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2831940725072795,
							false
							,[
							[
								1,
								[
									2,
									"PopUp"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Characters"
										]
									]
,
									[
										7,
										[
											2,
											"ok"
										]
									]
,
									[
										7,
										[
											2,
											"gold"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4439648817545168,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							8416610562910457,
							false
						]
						],
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							4523073933807411,
							false
							,[
							[
								1,
								[
									2,
									"gold"
								]
							]
,							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"gold"
											]
											]
										]
										]
									]
									,[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											2,
											cr.plugins_.Text.prototype.exps.Text,
											true,
											null
										]
										]
									]
								]
							]
							]
						]
,						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							2032056940487997,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"suit_"
									]
									,[
										21,
										83,
										false,
										null
										,1
									]
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							4021417465142134,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								7,
								[
									21,
									83,
									true,
									null
									,0
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2034882075247045,
							false
							,[
							[
								1,
								[
									2,
									"PopUp"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"Characters"
										]
									]
,
									[
										7,
										[
											2,
											"ok"
										]
									]
,
									[
										7,
										[
											2,
											"unlocked"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9241254555672817,
							false
							,[
							[
								11,
								"security"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							83,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							6334521526117249,
							false
							,[
							[
								0,
								[
									0,
									100
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7450699166308864,
							[
							[
								8,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7145026061092779,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										10,
										[
											2,
											"suit_"
										]
										,[
											21,
											83,
											false,
											null
											,1
										]
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								3992484516709433,
								false
								,[
								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								3191867167909198,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3024012144666319,
								[
								[
									40,
									cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
									null,
									0,
									false,
									false,
									false,
									2148733971498971,
									false
									,[
									[
										1,
										[
											2,
											"suit"
										]
									]
,									[
										1,
										[
											2,
											"normal"
										]
									]
,									[
										3,
										0
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									5405065605630208,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										5736377943645719,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"upgrades"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
										null,
										6179353375571013,
										false
										,[
										[
											0,
											[
												0,
												2
											]
										]
										]
									]
									]
								]
,								[
									0,
									null,
									false,
									null,
									8231470921645389,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										5107184893815341,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Characters"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnim,
										null,
										7024906349754339,
										false
										,[
										[
											1,
											[
												2,
												"Normal"
											]
										]
,										[
											3,
											1
										]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								2857483895913126,
								[
								[
									40,
									cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
									null,
									0,
									false,
									false,
									false,
									2431979069542614,
									false
									,[
									[
										1,
										[
											2,
											"suit"
										]
									]
,									[
										1,
										[
											2,
											"mecha"
										]
									]
,									[
										3,
										0
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									8638411274562125,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										3920251882317808,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"upgrades"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
										null,
										8645500555137692,
										false
										,[
										[
											0,
											[
												0,
												3
											]
										]
										]
									]
									]
								]
,								[
									0,
									null,
									false,
									null,
									8626376490523953,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										1124874684602065,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Characters"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnim,
										null,
										4367814113801383,
										false
										,[
										[
											1,
											[
												2,
												"Mecha"
											]
										]
,										[
											3,
											1
										]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7959781493822841,
								[
								[
									40,
									cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
									null,
									0,
									false,
									false,
									false,
									2061658966824125,
									false
									,[
									[
										1,
										[
											2,
											"suit"
										]
									]
,									[
										1,
										[
											2,
											"rainbow"
										]
									]
,									[
										3,
										0
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									9783101252362419,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										9246717458884475,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"upgrades"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
										null,
										6906701392095662,
										false
										,[
										[
											0,
											[
												0,
												4
											]
										]
										]
									]
									]
								]
,								[
									0,
									null,
									false,
									null,
									3684842730439074,
									[
									[
										6,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										640672327513359,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"Characters"
											]
										]
										]
									]
									],
									[
									[
										6,
										cr.plugins_.Sprite.prototype.acts.SetAnim,
										null,
										5396118931172407,
										false
										,[
										[
											1,
											[
												2,
												"Rainbow"
											]
										]
,										[
											3,
											1
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Game",
		[
		[
			2,
			"GlobalFunctions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			6142110436834451,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutEnd,
				null,
				1,
				false,
				false,
				false,
				2964908496335588,
				false
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				6675943980886309,
				false
				,[
				[
					1,
					[
						2,
						"CloseAdBanner"
					]
				]
,				[
					13,
				]
				]
			]
,			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				8171769388017161,
				false
				,[
				[
					1,
					[
						2,
						"DeleteAdBanner"
					]
				]
,				[
					13,
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3905804253969194,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				2171491971749169,
				false
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				2338509185980301,
				false
				,[
				[
					1,
					[
						2,
						"PreloadAdFull"
					]
				]
,				[
					13,
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				1243085330356251,
				false
				,[
				[
					5,
					[
						2,
						"Loading"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				14,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				3408713659897228,
				false
				,[
				[
					4,
					85
				]
,				[
					3,
					0
				]
				]
			]
,			[
				85,
				cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
				"DragDrop",
				2790860940515694,
				false
				,[
				[
					3,
					1
				]
				]
			]
,			[
				33,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				8629967527295829,
				false
				,[
				[
					4,
					14
				]
,				[
					3,
					0
				]
				]
			]
,			[
				122,
				cr.behaviors.Pin.prototype.acts.Pin,
				"Pin",
				7521786963717924,
				false
				,[
				[
					4,
					14
				]
,				[
					3,
					0
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				530882744918545,
				false
				,[
				[
					11,
					"grenades"
				]
,				[
					7,
					[
						20,
						40,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"grenades"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetGroupActive,
				null,
				8882009924594677,
				false
				,[
				[
					1,
					[
						2,
						"PlayTutorial"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				8764611246683999,
				false
			]
,			[
				152,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				9616140309650237,
				false
			]
,			[
				79,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				3080632762966389,
				false
			]
,			[
				95,
				cr.plugins_.Particles.prototype.acts.Destroy,
				null,
				5788692355336559,
				false
			]
,			[
				37,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				3430559468350321,
				false
			]
,			[
				22,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				4438068723581315,
				false
			]
,			[
				153,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				8529928317515224,
				false
			]
,			[
				103,
				cr.plugins_.Spritefont2.prototype.acts.Destroy,
				null,
				1848443524978589,
				false
			]
,			[
				92,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				2916572724703861,
				false
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				1342028641224207,
				false
			]
,			[
				87,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				764643194370255,
				false
			]
			]
			,[
			[
				0,
				[true, "UpgradesGame"],
				false,
				null,
				8164792471554169,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					8164792471554169,
					false
					,[
					[
						1,
						[
							2,
							"UpgradesGame"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6258888459925224,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2410502524748849,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5540161093710241,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8896610911305712,
					[
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8143896016554815,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenades"
									]
								]
,
								[
									7,
									[
										10,
										[
											23,
											"grenades"
										]
										,[
											2,
											"/5"
										]
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5173454192081579,
						false
						,[
						[
							11,
							"attack_damage"
						]
,						[
							7,
							[
								20,
								40,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"attackdamage"
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4200076511296075,
						false
						,[
						[
							11,
							"suit"
						]
,						[
							7,
							[
								20,
								40,
								cr.plugins_.WebStorage.prototype.exps.LocalValue,
								true,
								null
								,[
[
									2,
									"suit"
								]
								]
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1624056725041866,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Idle_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						33,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						8392630002051718,
						false
						,[
						[
							1,
							[
								23,
								"suit"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2298610657751274,
						false
						,[
						[
							1,
							[
								23,
								"suit"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						36,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4143314324065735,
						false
						,[
						[
							1,
							[
								23,
								"suit"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9223331072433156,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						2486848505060465,
						false
						,[
						[
							1,
							[
								2,
								"upgrade_3"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						144,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						8876020867835075,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						144,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						1718390724326474,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						145,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						1112274568349759,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						145,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						4992862320842195,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						146,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						998695403955929,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						146,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						7379336606253765,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8719327853209802,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						6232305886482428,
						false
						,[
						[
							1,
							[
								2,
								"upgrade_1"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						1676485027548295,
						false
						,[
						[
							5,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						2438325802703169,
						false
						,[
						[
							1,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8737938440485462,
						false
						,[
						[
							1,
							[
								2,
								"upgrade_1"
							]
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						335112299493324,
						false
						,[
						[
							11,
							"ahead_start"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2375905926082918,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						5051752256888191,
						false
						,[
						[
							0,
							[
								0,
								66
							]
						]
						]
					]
,					[
						85,
						cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
						"DragDrop",
						5044761948180928,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						9659443227917385,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Boost_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4876899010879312,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								23,
								"speed_fast"
							]
						]
						]
					]
,					[
						85,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						7661340969282632,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6121973038220621,
				[
				[
					-1,
					cr.system_object.prototype.cnds.For,
					null,
					0,
					true,
					false,
					false,
					2347412839885118,
					false
					,[
					[
						1,
						[
							2,
							""
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.CreateObject,
					null,
					8501032238400548,
					false
					,[
					[
						4,
						79
					]
,					[
						5,
						[
							2,
							"Background"
						]
					]
,					[
						0,
						[
							6,
							[
								19,
								cr.system_object.prototype.exps.loopindex
							]
							,[
								0,
								320
							]
						]
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					6588819195336156,
					false
					,[
					[
						0,
						[
							19,
							cr.system_object.prototype.exps.floor
							,[
[
								19,
								cr.system_object.prototype.exps.random
								,[
[
									0,
									0
								]
,[
									0,
									4
								]
								]
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2616051911886111,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					true,
					false,
					2134557278627171,
					false
					,[
					[
						1,
						[
							2,
							"tutorial"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3335592292095377,
					false
					,[
					[
						1,
						[
							2,
							"Tutorial"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2134776745724654,
					false
					,[
					[
						5,
						[
							2,
							"Tutorial"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5051437660531532,
					false
					,[
					[
						1,
						[
							2,
							"PlayTutorial"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2700960657051527,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Else,
					null,
					0,
					false,
					false,
					false,
					1942278799318686,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					1790547937198248,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1320880356315281,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1153823138055117,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_menu"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3427401064258366,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_Stage1"
								]
							]
,
							[
								7,
								[
									2,
									"start"
								]
							]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7010036143446171,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9654927313932467,
					false
					,[
					[
						1,
						[
							2,
							"GameLoop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8472066309324682,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9182084792394799,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5544341590601669,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
,					[
						0,
						[
							0,
							457
						]
					]
					]
				]
,				[
					76,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3699386690686083,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7853362578218231,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				4681540475558768,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				true,
				null,
				7738387459105587,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					true,
					false,
					1238410182138211,
					false
					,[
					[
						1,
						[
							2,
							"GameOver"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					1360901916574926,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
					]
				]
				],
				[
				[
					92,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9284347784796823,
					false
				]
				]
			]
,			[
				0,
				null,
				true,
				null,
				6463312565505102,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					36785779780743,
					false
					,[
					[
						1,
						[
							2,
							"GameOver"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					2590300652505633,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7440845339332697,
					[
					[
						143,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						6947221342748938,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						7802228051426409,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7961044688371846,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"GameOver"
							]
						]
,						[
							0,
							[
								0,
								94
							]
						]
,						[
							0,
							[
								0,
								96
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9932500910330296,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"tweet"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4696759398894071,
						false
						,[
						[
							1,
							[
								2,
								"tweet"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3146110005238606,
					[
					[
						143,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						711362301980578,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						9304324031642416,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1079740169714838,
						false
						,[
						[
							4,
							92
						]
,						[
							5,
							[
								2,
								"GameOver"
							]
						]
,						[
							0,
							[
								0,
								1044
							]
						]
,						[
							0,
							[
								0,
								95
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						7801335643146788,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								2,
								"share"
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3471799442057565,
						false
						,[
						[
							1,
							[
								2,
								"share"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Starting"],
			false,
			null,
			693672681234042,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				693672681234042,
				false
				,[
				[
					1,
					[
						2,
						"Starting"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4653701941710566,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					7026164204577836,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3679285740224555,
					[
					[
						125,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						542942064081626,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7485110928675127,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9212415796675906,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"normal"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2444805646611042,
							false
							,[
							[
								1,
								[
									2,
									"Normal"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							7859824548479743,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						78489681785463,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9968670129955401,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"mecha"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							494633618875092,
							false
							,[
							[
								1,
								[
									2,
									"Mecha"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							2906415544723106,
							false
							,[
							[
								0,
								[
									0,
									415
								]
							]
,							[
								0,
								[
									0,
									207
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8505734215916296,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							6691241922033321,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"rainbow"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6507236658004302,
							false
							,[
							[
								1,
								[
									2,
									"Rainbow"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							5744248719646344,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5519598296403045,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					1485998711045396,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2291998429617766,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8075958660477997,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
,					[
						0,
						[
							0,
							457
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "PlayTutorial"],
			false,
			null,
			4934839143645594,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4934839143645594,
				false
				,[
				[
					1,
					[
						2,
						"PlayTutorial"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Step1"],
				false,
				null,
				1091508000280397,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1091508000280397,
					false
					,[
					[
						1,
						[
							2,
							"Step1"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7643485980082532,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1112054432640359,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5038217337345917,
						[
						[
							18,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							1373069685549598,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8567920707239395,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3118825113288877,
							false
							,[
							[
								1,
								[
									2,
									"Step2"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9310892056602326,
							false
							,[
							[
								11,
								"speed"
							]
,							[
								7,
								[
									23,
									"speed_slow"
								]
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							5208872682283268,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7267292684375282,
							false
							,[
							[
								1,
								[
									2,
									"Red"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetPosToObject,
							null,
							816522211394837,
							false
							,[
							[
								4,
								18
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							140,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							5442137511624666,
							false
							,[
							[
								4,
								18
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							8035082420382811,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8716911746320765,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"TutorialUI"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								2452699092070791,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								9516595096276133,
								false
								,[
								[
									0,
									[
										20,
										18,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											18,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								9073275910145234,
								false
								,[
								[
									4,
									18
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7334404596567568,
								false
								,[
								[
									7,
									[
										2,
										"Enemy Encounter!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								9989970237354129,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							true,
							null,
							9874428865092015,
							[
							[
								18,
								cr.plugins_.Sprite.prototype.cnds.CompareX,
								null,
								0,
								false,
								false,
								false,
								5450248348962972,
								false
								,[
								[
									8,
									3
								]
,								[
									0,
									[
										0,
										300
									]
								]
								]
							]
,							[
								18,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2754013773761516,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								6296893245177363,
								false
								,[
								[
									4,
									18
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4314044550399512,
								false
								,[
								[
									11,
									"speed"
								]
,								[
									7,
									[
										23,
										"speed_normal"
									]
								]
								]
							]
,							[
								140,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								878316097395674,
								false
							]
,							[
								140,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								9928654321487935,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3568212395212542,
								[
								[
									2,
									cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2225196657355388,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"TutorialUI"
										]
									]
									]
								]
								],
								[
								[
									2,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									5448762573110312,
									false
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetVisible,
									null,
									8722178639982181,
									false
									,[
									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetGroupActive,
									null,
									4571387473695254,
									false
									,[
									[
										1,
										[
											2,
											"Step1"
										]
									]
,									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Step2"],
				false,
				null,
				3778314283579759,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3778314283579759,
					false
					,[
					[
						1,
						[
							2,
							"Step2"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6515851514935938,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						454390860808453,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8061290153690977,
						[
						[
							34,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							5430903221830173,
							false
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							2225411294978685,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5774949337332238,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3351570273996578,
							false
							,[
							[
								1,
								[
									2,
									"Step3"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9077084763366042,
							false
							,[
							[
								11,
								"speed"
							]
,							[
								7,
								[
									23,
									"speed_slow"
								]
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							7815062586423802,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6459771686033355,
							false
							,[
							[
								1,
								[
									2,
									"Red"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetPosToObject,
							null,
							9190875275908224,
							false
							,[
							[
								4,
								34
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							140,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							7176997491624266,
							false
							,[
							[
								4,
								34
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4222300005979799,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9261303956323864,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"TutorialUI"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								893970415748863,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								6679803596405819,
								false
								,[
								[
									0,
									[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								5423342590788452,
								false
								,[
								[
									4,
									34
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								2512219016627569,
								false
								,[
								[
									7,
									[
										2,
										"Dodge or Shoot!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								6987177091374971,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1466467969853734,
							[
							[
								34,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1348102117250892,
								false
								,[
								[
									1,
									[
										2,
										"LaneMissile"
									]
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								true,
								null,
								8779355360701665,
								[
								[
									34,
									cr.plugins_.Sprite.prototype.cnds.CompareX,
									null,
									0,
									false,
									false,
									false,
									8130010189880774,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											300
										]
									]
									]
								]
,								[
									14,
									cr.plugins_.Sprite.prototype.cnds.OnCollision,
									null,
									0,
									false,
									false,
									true,
									7090279560336186,
									false
									,[
									[
										4,
										34
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
									null,
									1,
									false,
									false,
									false,
									2516474971839965,
									false
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.SetVar,
									null,
									1792831124226689,
									false
									,[
									[
										11,
										"speed"
									]
,									[
										7,
										[
											23,
											"speed_normal"
										]
									]
									]
								]
,								[
									140,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									9533250947272749,
									false
								]
,								[
									140,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									6521574354529353,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									20096863759027,
									[
									[
										2,
										cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										8794747539851771,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"TutorialUI"
											]
										]
										]
									]
									],
									[
									[
										2,
										cr.behaviors.Pin.prototype.acts.Unpin,
										"Pin",
										6876512151473337,
										false
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetVisible,
										null,
										2889571390207688,
										false
										,[
										[
											3,
											0
										]
										]
									]
,									[
										-1,
										cr.system_object.prototype.acts.SetGroupActive,
										null,
										7360081737845736,
										false
										,[
										[
											1,
											[
												2,
												"Step2"
											]
										]
,										[
											3,
											0
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Step3"],
				false,
				null,
				3194420864593817,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3194420864593817,
					false
					,[
					[
						1,
						[
							2,
							"Step3"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2432774716905172,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7774527410729815,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8061290153690977,
						[
						[
							153,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							5430903221830173,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6707655011033863,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3351570273996578,
							false
							,[
							[
								1,
								[
									2,
									"Step4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							7815062586423802,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							125451876435407,
							false
							,[
							[
								1,
								[
									2,
									"Green"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetPosToObject,
							null,
							9190875275908224,
							false
							,[
							[
								4,
								153
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							140,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							7176997491624266,
							false
							,[
							[
								4,
								153
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4222300005979799,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9261303956323864,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"TutorialUI"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								893970415748863,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								6679803596405819,
								false
								,[
								[
									0,
									[
										20,
										153,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											153,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								5423342590788452,
								false
								,[
								[
									4,
									153
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								2512219016627569,
								false
								,[
								[
									7,
									[
										2,
										"Pickup items!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								6987177091374971,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											0
										]
,[
											0,
											255
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1466467969853734,
							[
							[
								153,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								1348102117250892,
								false
							]
							],
							[
							]
							,[
							[
								0,
								null,
								true,
								null,
								8779355360701665,
								[
								[
									153,
									cr.plugins_.Sprite.prototype.cnds.CompareX,
									null,
									0,
									false,
									false,
									false,
									8130010189880774,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											300
										]
									]
									]
								]
,								[
									14,
									cr.plugins_.Sprite.prototype.cnds.OnCollision,
									null,
									0,
									false,
									false,
									true,
									7090279560336186,
									false
									,[
									[
										4,
										153
									]
									]
								]
,								[
									153,
									cr.plugins_.Sprite.prototype.cnds.CompareY,
									null,
									0,
									false,
									false,
									false,
									2516474971839965,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											200
										]
									]
									]
								]
								],
								[
								[
									140,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									9533250947272749,
									false
								]
,								[
									140,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									6521574354529353,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									20096863759027,
									[
									[
										2,
										cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										8794747539851771,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"TutorialUI"
											]
										]
										]
									]
									],
									[
									[
										2,
										cr.behaviors.Pin.prototype.acts.Unpin,
										"Pin",
										6876512151473337,
										false
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetVisible,
										null,
										2889571390207688,
										false
										,[
										[
											3,
											0
										]
										]
									]
,									[
										-1,
										cr.system_object.prototype.acts.SetGroupActive,
										null,
										7360081737845736,
										false
										,[
										[
											1,
											[
												2,
												"Step3"
											]
										]
,										[
											3,
											0
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Step4"],
				false,
				null,
				1111950287979824,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1111950287979824,
					false
					,[
					[
						1,
						[
							2,
							"Step4"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7408672166838294,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3137323358120534,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5038217337345917,
						[
						[
							20,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							1373069685549598,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4383162158883956,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							3118825113288877,
							false
							,[
							[
								1,
								[
									2,
									"Step5"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							9310892056602326,
							false
							,[
							[
								11,
								"speed"
							]
,							[
								7,
								[
									23,
									"speed_slow"
								]
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							5208872682283268,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							342357581115618,
							false
							,[
							[
								1,
								[
									2,
									"Red"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							140,
							cr.plugins_.Sprite.prototype.acts.SetPosToObject,
							null,
							816522211394837,
							false
							,[
							[
								4,
								20
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							140,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							5442137511624666,
							false
							,[
							[
								4,
								20
							]
,							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							8035082420382811,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8716911746320765,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"TutorialUI"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								2452699092070791,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								9516595096276133,
								false
								,[
								[
									0,
									[
										20,
										20,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											20,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								9073275910145234,
								false
								,[
								[
									4,
									20
								]
,								[
									3,
									0
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								7334404596567568,
								false
								,[
								[
									7,
									[
										2,
										"Stronger Enemies!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								9989970237354129,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							true,
							null,
							9874428865092015,
							[
							[
								20,
								cr.plugins_.Sprite.prototype.cnds.CompareX,
								null,
								0,
								false,
								false,
								false,
								5450248348962972,
								false
								,[
								[
									8,
									3
								]
,								[
									0,
									[
										0,
										300
									]
								]
								]
							]
,							[
								20,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2754013773761516,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								6296893245177363,
								false
								,[
								[
									4,
									20
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4314044550399512,
								false
								,[
								[
									11,
									"speed"
								]
,								[
									7,
									[
										23,
										"speed_normal"
									]
								]
								]
							]
,							[
								140,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								878316097395674,
								false
							]
,							[
								140,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								9928654321487935,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								3568212395212542,
								[
								[
									2,
									cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2225196657355388,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"TutorialUI"
										]
									]
									]
								]
								],
								[
								[
									2,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									5448762573110312,
									false
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetVisible,
									null,
									8722178639982181,
									false
									,[
									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetGroupActive,
									null,
									4571387473695254,
									false
									,[
									[
										1,
										[
											2,
											"Step4"
										]
									]
,									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Step5"],
				false,
				null,
				2998554126715517,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2998554126715517,
					false
					,[
					[
						1,
						[
							2,
							"Step5"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6005592229211125,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8227107193390181,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8858438632046854,
						[
						[
							19,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							8407084011623131,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1622546395214595,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8061290153690977,
							[
							[
								34,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								5430903221830173,
								false
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								2225411294978685,
								false
								,[
								[
									1,
									[
										2,
										"shooter_1"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								9077084763366042,
								false
								,[
								[
									11,
									"speed"
								]
,								[
									7,
									[
										23,
										"speed_slow"
									]
								]
								]
							]
,							[
								140,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								7815062586423802,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								140,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6593788330514162,
								false
								,[
								[
									1,
									[
										2,
										"Red"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								140,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								7561824718236988,
								false
								,[
								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											65
										]
									]
								]
,								[
									0,
									[
										20,
										34,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
,							[
								140,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								7176997491624266,
								false
								,[
								[
									4,
									34
								]
,								[
									3,
									0
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								4222300005979799,
								[
								[
									2,
									cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									9261303956323864,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"TutorialUI"
										]
									]
									]
								]
								],
								[
								[
									2,
									cr.plugins_.Text.prototype.acts.SetVisible,
									null,
									893970415748863,
									false
									,[
									[
										3,
										1
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetPos,
									null,
									6679803596405819,
									false
									,[
									[
										0,
										[
											5,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.X,
												false,
												null
											]
											,[
												0,
												65
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.Y,
												false,
												null
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									5423342590788452,
									false
									,[
									[
										4,
										34
									]
,									[
										3,
										0
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetText,
									null,
									2512219016627569,
									false
									,[
									[
										7,
										[
											2,
											"Watch out!"
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetFontColor,
									null,
									6987177091374971,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.rgb
											,[
[
												0,
												255
											]
,[
												0,
												0
											]
,[
												0,
												0
											]
											]
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								4137649042289637,
								[
								[
									19,
									cr.plugins_.Sprite.prototype.cnds.IsVisible,
									null,
									0,
									false,
									false,
									false,
									9337119567213795,
									false
								]
								],
								[
								]
								,[
								[
									0,
									null,
									true,
									null,
									8779355360701665,
									[
									[
										34,
										cr.plugins_.Sprite.prototype.cnds.CompareX,
										null,
										0,
										false,
										false,
										false,
										8130010189880774,
										false
										,[
										[
											8,
											3
										]
,										[
											0,
											[
												0,
												300
											]
										]
										]
									]
,									[
										14,
										cr.plugins_.Sprite.prototype.cnds.OnCollision,
										null,
										0,
										false,
										false,
										true,
										7090279560336186,
										false
										,[
										[
											4,
											34
										]
										]
									]
,									[
										19,
										cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
										null,
										1,
										false,
										false,
										false,
										7046284053400476,
										false
									]
									],
									[
									[
										-1,
										cr.system_object.prototype.acts.SetVar,
										null,
										1792831124226689,
										false
										,[
										[
											11,
											"speed"
										]
,										[
											7,
											[
												23,
												"speed_normal"
											]
										]
										]
									]
,									[
										140,
										cr.behaviors.Pin.prototype.acts.Unpin,
										"Pin",
										9533250947272749,
										false
									]
,									[
										140,
										cr.plugins_.Sprite.prototype.acts.SetVisible,
										null,
										6521574354529353,
										false
										,[
										[
											3,
											0
										]
										]
									]
									]
									,[
									[
										0,
										null,
										false,
										null,
										20096863759027,
										[
										[
											2,
											cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											8794747539851771,
											false
											,[
											[
												10,
												0
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													2,
													"TutorialUI"
												]
											]
											]
										]
										],
										[
										[
											2,
											cr.behaviors.Pin.prototype.acts.Unpin,
											"Pin",
											6876512151473337,
											false
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetVisible,
											null,
											2889571390207688,
											false
											,[
											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetGroupActive,
											null,
											7360081737845736,
											false
											,[
											[
												1,
												[
													2,
													"Step5"
												]
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.SetGroupActive,
											null,
											7759577753831753,
											false
											,[
											[
												1,
												[
													2,
													"PlayTutorial"
												]
											]
,											[
												3,
												0
											]
											]
										]
,										[
											40,
											cr.plugins_.WebStorage.prototype.acts.StoreLocal,
											null,
											9720497536322137,
											false
											,[
											[
												1,
												[
													2,
													"tutorial"
												]
											]
,											[
												7,
												[
													0,
													1
												]
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			249565344056166,
			[
			[
				72,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				1744465194311958,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4120830775386473,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6008909049897271,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"TutorialUI"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					620602897359988,
					false
				]
,				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					4356296070706858,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3185049288813804,
					false
					,[
					[
						1,
						[
							2,
							"Step1"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9909916577716155,
					false
					,[
					[
						1,
						[
							2,
							"Step2"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9860211387245541,
					false
					,[
					[
						1,
						[
							2,
							"Step3"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9058408257430137,
					false
					,[
					[
						1,
						[
							2,
							"Step4"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2840288467144606,
					false
					,[
					[
						1,
						[
							2,
							"Step5"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					4308090479670888,
					false
					,[
					[
						1,
						[
							2,
							"PlayTutorial"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8453424400286384,
					false
					,[
					[
						1,
						[
							2,
							"tutorial"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					140,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					1949280248088322,
					false
				]
,				[
					140,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8116177450860412,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3103602731608281,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							23,
							"speed_normal"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9788016748280237,
			[
			[
				3,
				cr.plugins_.Touch.prototype.cnds.OnTouchObject,
				null,
				1,
				false,
				false,
				false,
				5572834737767903,
				false
				,[
				[
					4,
					15
				]
				]
			]
,			[
				15,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				5372593337256816,
				false
			]
			],
			[
			[
				152,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				9347203052271528,
				false
			]
,			[
				153,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				9729127012683219,
				false
			]
,			[
				14,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				9191236501285964,
				false
			]
,			[
				81,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				7297496164863338,
				false
			]
,			[
				34,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				2171898022274305,
				false
			]
,			[
				122,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				8812760997050132,
				false
			]
,			[
				28,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				8738520104672655,
				false
			]
,			[
				8,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				2834069070908014,
				false
			]
,			[
				42,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				349360343141886,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				47,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				9870454994366188,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				43,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5292426718234497,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetGroupActive,
				null,
				7009299387962441,
				false
				,[
				[
					1,
					[
						2,
						"GameLoop"
					]
				]
,				[
					3,
					0
				]
				]
			]
,			[
				85,
				cr.behaviors.Bullet.prototype.acts.SetSpeed,
				"Bullet",
				9486031049850016,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetGroupActive,
				null,
				3614306168961545,
				false
				,[
				[
					1,
					[
						2,
						"Paused"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerOpacity,
				null,
				7894445560830078,
				false
				,[
				[
					5,
					[
						2,
						"Game"
					]
				]
,				[
					0,
					[
						0,
						50
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerOpacity,
				null,
				7098336708851258,
				false
				,[
				[
					5,
					[
						2,
						"Interface"
					]
				]
,				[
					0,
					[
						0,
						50
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerOpacity,
				null,
				1485513944746716,
				false
				,[
				[
					5,
					[
						2,
						"Background"
					]
				]
,				[
					0,
					[
						0,
						50
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetLayerVisible,
				null,
				5347888485926393,
				false
				,[
				[
					5,
					[
						2,
						"Pause"
					]
				]
,				[
					3,
					1
				]
				]
			]
,			[
				33,
				cr.plugins_.Sprite.prototype.acts.StopAnim,
				null,
				4949271147228954,
				false
			]
,			[
				85,
				cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
				"DragDrop",
				2378412077361266,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				77,
				cr.plugins_.Audio.prototype.acts.SetMasterVolume,
				null,
				316889069007047,
				false
				,[
				[
					0,
					[
						0,
						-10
					]
				]
				]
			]
,			[
				29,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				2496726553737168,
				false
				,[
				[
					0,
					[
						0,
						341
					]
				]
,				[
					0,
					[
						0,
						490
					]
				]
				]
			]
,			[
				30,
				cr.plugins_.Sprite.prototype.acts.SetPos,
				null,
				6568977711236123,
				false
				,[
				[
					0,
					[
						0,
						779
					]
				]
,				[
					0,
					[
						0,
						490
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				1748756589621973,
				false
				,[
				[
					1,
					[
						2,
						"ShowAdBanner"
					]
				]
,				[
					13,
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				3450315319250469,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1719523068232227,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"achievement"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					3807163042298299,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8780306476899485,
				[
				[
					106,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6607341559927822,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"appear"
						]
					]
					]
				]
				],
				[
				[
					106,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					512408047284527,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8865863033100858,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					59387632759616,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"achieve_header"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					5365806166785857,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4691910646871447,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4752207091292719,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"achieve_description"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					9369952751224325,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2855622159441969,
				[
				[
					100,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4928616338893868,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"achievement"
						]
					]
					]
				]
				],
				[
				[
					100,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8143880749687674,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8376137942145084,
				[
				[
					43,
					cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
					null,
					0,
					false,
					false,
					false,
					6020726721111819,
					false
				]
				],
				[
				[
					43,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3243607069326428,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			1,
			"grenades",
			0,
			0,
false,false,7061632564777143,false
		]
,		[
			1,
			"ammo_amount",
			0,
			0,
false,false,6020856309174269,false
		]
,		[
			1,
			"ammo_type",
			1,
			"shoot",
false,false,7381442800174701,false
		]
,		[
			1,
			"speed",
			0,
			-15,
false,false,3266807095346067,false
		]
,		[
			1,
			"speed_normal",
			0,
			-15,
false,false,1553795376754555,false
		]
,		[
			1,
			"speed_slow",
			0,
			-5,
false,false,9830970854935609,false
		]
,		[
			1,
			"speed_fast",
			0,
			-100,
false,false,4260890042030529,false
		]
,		[
			1,
			"speed_fast_revive",
			0,
			-30,
false,false,9575753312947254,false
		]
,		[
			1,
			"speed_fast_pickup",
			0,
			-50,
false,false,5108305489198346,false
		]
,		[
			1,
			"distance_meters",
			0,
			0,
false,false,7137644293723941,false
		]
,		[
			1,
			"level",
			0,
			1,
false,false,4690861372726883,false
		]
,		[
			1,
			"kills",
			0,
			0,
false,false,7976207432771565,false
		]
,		[
			1,
			"gold_collected",
			0,
			0,
false,false,9671592056845231,false
		]
,		[
			1,
			"attack_damage",
			0,
			1,
false,false,209646429705476,false
		]
,		[
			1,
			"speed_boost",
			0,
			0,
false,false,5748835210325844,false
		]
,		[
			1,
			"boss",
			0,
			0,
false,false,1615621358339552,false
		]
,		[
			1,
			"charge",
			0,
			0,
false,false,9093952906327785,false
		]
,		[
			1,
			"levelchanged",
			0,
			0,
false,false,2305800699687997,false
		]
,		[
			1,
			"cycle",
			0,
			0,
false,false,6693153546753079,false
		]
,		[
			1,
			"distance_start",
			0,
			-8,
false,false,52005151455316,false
		]
,		[
			1,
			"ahead_start",
			0,
			0,
false,false,554401523619832,false
		]
,		[
			1,
			"formation_1",
			0,
			0,
false,false,6698356305886329,false
		]
,		[
			1,
			"suit",
			1,
			"normal",
false,false,8605086081740076,false
		]
,		[
			0,
			[false, "GameLoop"],
			false,
			null,
			2719746092976266,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2719746092976266,
				false
				,[
				[
					1,
					[
						2,
						"GameLoop"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				88367239845587,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					9219310635108247,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7583419748421307,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						true,
						false,
						6278340593069927,
						false
						,[
						[
							4,
							16
						]
						]
					]
					],
					[
					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						8039387598256683,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Idle_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				389508252294941,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					9032583837511009,
					false
					,[
					[
						0,
						[
							1,
							0.05
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					true,
					null,
					1236192995121794,
					[
					[
						144,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						5244641024414748,
						false
					]
,					[
						145,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8964585340576421,
						false
					]
,					[
						146,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						409802673762001,
						false
					]
					],
					[
					[
						144,
						cr.plugins_.Sprite.prototype.acts.RotateClockwise,
						null,
						819225697967795,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
						]
					]
,					[
						145,
						cr.plugins_.Sprite.prototype.acts.RotateClockwise,
						null,
						4087681713698067,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
						]
					]
,					[
						146,
						cr.plugins_.Sprite.prototype.acts.RotateClockwise,
						null,
						207263342831396,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5084172422324885,
				[
				[
					125,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6096971899365258,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7669459571283274,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						9712239259039312,
						false
						,[
						[
							1,
							[
								2,
								"suit"
							]
						]
,						[
							1,
							[
								2,
								"rainbow"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5293033864642989,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							1542318559200688,
							false
							,[
							[
								0,
								[
									1,
									0.01
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							315194457272643,
							[
							[
								8,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5371441373492295,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
								]
							]
							],
							[
							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetTowardPosition,
								null,
								2532587201701398,
								false
								,[
								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								5571899414302672,
								false
								,[
								[
									0,
									[
										6,
										[
											0,
											-5
										]
										,[
											23,
											"speed"
										]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8179737836322775,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
						null,
						0,
						false,
						false,
						false,
						5985304894179136,
						false
						,[
						[
							1,
							[
								2,
								"suit"
							]
						]
,						[
							1,
							[
								2,
								"mecha"
							]
						]
,						[
							3,
							0
						]
						]
					]
					],
					[
					[
						144,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						6318670061815245,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						144,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						7049665914013607,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						145,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						5934549185423788,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						145,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						8453397813631567,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						146,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						1546948153635465,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						146,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						9883757165159832,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1550680028155272,
				[
				[
					-1,
					cr.system_object.prototype.cnds.EveryTick,
					null,
					0,
					false,
					false,
					false,
					9520495676576077,
					false
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					315005843121493,
					false
					,[
					[
						0,
						[
							23,
							"speed"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					7628437782612287,
					false
					,[
					[
						11,
						"distance_meters"
					]
,					[
						7,
						[
							6,
							[
								1,
								-0.01
							]
							,[
								23,
								"speed"
							]
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					1956446911776608,
					false
					,[
					[
						0,
						[
							6,
							[
								1,
								-1.5
							]
							,[
								23,
								"speed"
							]
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					582703494891479,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"distance"
								]
							]
,
							[
								7,
								[
									10,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										2,
										" m"
									]
								]
							]
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					8969365768182248,
					false
					,[
					[
						0,
						[
							23,
							"speed"
						]
					]
					]
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					7292806293413493,
					false
					,[
					[
						0,
						[
							23,
							"speed"
						]
					]
					]
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					3188335024813428,
					false
					,[
					[
						0,
						[
							23,
							"speed"
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Sprite.prototype.acts.MoveForward,
					null,
					9898945687260979,
					false
					,[
					[
						0,
						[
							23,
							"speed"
						]
					]
					]
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					361058931651087,
					false
					,[
					[
						3,
						0
					]
,					[
						4,
						152
					]
					]
				]
,				[
					105,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					3861619843742865,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						34
					]
					]
				]
,				[
					24,
					cr.plugins_.Sprite.prototype.acts.MoveToTop,
					null,
					7240971422263007,
					false
				]
,				[
					152,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6002002788728978,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					22,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					8141161569456095,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						34
					]
					]
				]
,				[
					104,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					1580429000707281,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						42
					]
					]
				]
,				[
					104,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					2548003115075741,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						47
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2027266086574061,
					[
					[
						51,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						2501066229931834,
						false
						,[
						[
							4,
							34
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3085716396107017,
						false
						,[
						[
							4,
							22
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								14,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								14,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						9262147540086011,
						false
						,[
						[
							0,
							[
								0,
								300
							]
						]
,						[
							0,
							[
								0,
								300
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						8626542392762946,
						false
						,[
						[
							1,
							[
								2,
								"default"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7306022896663155,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						9426492158588422,
						false
						,[
						[
							4,
							130
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1515709184564982,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7862234566234551,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"pickup"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							9757830283401445,
							false
							,[
							[
								7,
								[
									2,
									"Shield up!"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetFontColor,
							null,
							5150715251396998,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.rgb
									,[
[
										0,
										0
									]
,[
										0,
										255
									]
,[
										0,
										255
									]
									]
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetPos,
							null,
							8673529110572006,
							false
							,[
							[
								0,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
,						[
							2,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							251795540065596,
							false
							,[
							[
								4,
								14
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1588181379617882,
							false
							,[
							[
								0,
								[
									1,
									0.5
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							9454150288650806,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6822482078490253,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						7755873175331095,
						false
						,[
						[
							4,
							25
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5078334186688319,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2317927544948192,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"pickup"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							3620278078774715,
							false
							,[
							[
								7,
								[
									2,
									"Laser!"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetFontColor,
							null,
							5538653948517622,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.rgb
									,[
[
										0,
										0
									]
,[
										0,
										255
									]
,[
										0,
										255
									]
									]
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetPos,
							null,
							293877225533488,
							false
							,[
							[
								0,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
,						[
							2,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							4536543566259095,
							false
							,[
							[
								4,
								14
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6429503172111905,
							false
							,[
							[
								0,
								[
									1,
									0.5
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2751504975993596,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7191150426596753,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						1271030835979745,
						false
						,[
						[
							4,
							26
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9482265886052165,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9255306982085824,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"pickup"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							8891418603422067,
							false
							,[
							[
								7,
								[
									2,
									"Rocket Launcher!"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetFontColor,
							null,
							9758491613176043,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.rgb
									,[
[
										0,
										0
									]
,[
										0,
										255
									]
,[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetPos,
							null,
							5289654155065158,
							false
							,[
							[
								0,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
,						[
							2,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							7724086269548727,
							false
							,[
							[
								4,
								14
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5826874564612973,
							false
							,[
							[
								0,
								[
									1,
									0.5
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							3588306835928222,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4741490327796086,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						1780179398574759,
						false
						,[
						[
							4,
							27
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4169440343431189,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5675500894227545,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"pickup"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							319753576839569,
							false
							,[
							[
								7,
								[
									2,
									"Shotgun!"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetFontColor,
							null,
							9123607285796009,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.rgb
									,[
[
										0,
										255
									]
,[
										0,
										0
									]
,[
										0,
										0
									]
									]
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetPos,
							null,
							9486201759578634,
							false
							,[
							[
								0,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
,						[
							2,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							548551161490425,
							false
							,[
							[
								4,
								14
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4851254161235582,
							false
							,[
							[
								0,
								[
									1,
									0.5
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							9261417211552829,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5328676759686515,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						562997570889217,
						false
						,[
						[
							4,
							131
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						694207966942121,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6698553461781666,
							false
							,[
							[
								11,
								"grenades"
							]
,							[
								8,
								2
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5943856292972145,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7448518949644152,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"pickup"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								5136514818536801,
								false
								,[
								[
									7,
									[
										2,
										"Grenade!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								7074689354790604,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											0
										]
,[
											0,
											255
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								9502890719339615,
								false
								,[
								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								765836959974571,
								false
								,[
								[
									4,
									14
								]
,								[
									3,
									0
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								2263450052933328,
								false
								,[
								[
									0,
									[
										1,
										0.5
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								4182822780757096,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6900899262364716,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							981016436016318,
							false
							,[
							[
								11,
								"grenades"
							]
,							[
								8,
								5
							]
,							[
								7,
								[
									0,
									5
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5265675952948863,
							[
							[
								2,
								cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9157503577749657,
								false
								,[
								[
									10,
									0
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"pickup"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								6795105206879567,
								false
								,[
								[
									7,
									[
										2,
										"Full!"
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								450487988822874,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetPos,
								null,
								1984680586830289,
								false
								,[
								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								2,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								8843761198207534,
								false
								,[
								[
									4,
									14
								]
,								[
									3,
									0
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								5562401263534306,
								false
								,[
								[
									0,
									[
										1,
										0.5
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								759302666389554,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3618190992317291,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						5419028274209753,
						false
						,[
						[
							4,
							28
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9514390214182136,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4461658523182744,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"pickup"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							4385113697736326,
							false
							,[
							[
								7,
								[
									2,
									"Speed up!"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetFontColor,
							null,
							5645302199689233,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.rgb
									,[
[
										0,
										0
									]
,[
										0,
										255
									]
,[
										0,
										255
									]
									]
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetPos,
							null,
							5393325577515976,
							false
							,[
							[
								0,
								[
									20,
									14,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									5,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										100
									]
								]
							]
							]
						]
,						[
							2,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							1020992486641247,
							false
							,[
							[
								4,
								14
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							916817683766215,
							false
							,[
							[
								0,
								[
									1,
									0.5
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							3265311774006636,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8411813820026856,
					[
					[
						42,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8735342137907413,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						42,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4766322344328797,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3853496519254857,
					[
					[
						47,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						834202961744241,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						47,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5746525219798039,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2755217801157648,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						6232574932536967,
						false
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2662082344939252,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1698193152258952,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6489878630220063,
							false
							,[
							[
								10,
								8
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5173902147520049,
							[
							[
								81,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								8329718761484161,
								false
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								3696124180496581,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									5137115710727072,
									false
									,[
									[
										10,
										2
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"Boss"
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									6505463766003304,
									false
									,[
									[
										10,
										8
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1707394002594794,
					[
					[
						81,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						true,
						false,
						9799516048879572,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2322261842319393,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2325259013841999,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1759509174376703,
							false
							,[
							[
								10,
								8
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6479130607655316,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8399361052700016,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5052598780758946,
						false
						,[
						[
							10,
							8
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6023670763045844,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2753264894807708,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							2894159401354561,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3780592419338732,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5875610728091683,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Shooter"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5553560172001807,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						6555196159519765,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						295326322743087,
						false
						,[
						[
							4,
							37
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						7031500971317243,
						false
						,[
						[
							1,
							[
								2,
								"normal"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7624634883042064,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenade_explosion"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						3001809231446049,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1221787969960991,
						false
						,[
						[
							4,
							105
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									100
								]
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7397920453794224,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							153
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						4572836800040845,
						false
						,[
						[
							0,
							[
								1,
								587.162
							]
						]
,						[
							0,
							[
								1,
								303.494
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2995021257839532,
						false
						,[
						[
							1,
							[
								2,
								"blastmark"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						105,
						cr.behaviors.Fade.prototype.acts.StartFade,
						"Fade",
						4422296523024779,
						false
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						9489454071005016,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4308083135749432,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							55
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						1419629868992331,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							61
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						2603547043519564,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							62
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						3085951329573366,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							90
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7820758983382323,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5174712415842259,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5072779047031816,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Minion"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						664871402061461,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						9446559811927384,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1159055706641539,
						false
						,[
						[
							4,
							37
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6961832187922815,
						false
						,[
						[
							1,
							[
								2,
								"normal"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5287127718650438,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenade_explosion"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						9833967882739944,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6817687259636731,
						false
						,[
						[
							4,
							105
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									100
								]
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						3806325642009101,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							153
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						5271205723602082,
						false
						,[
						[
							0,
							[
								1,
								587.162
							]
						]
,						[
							0,
							[
								1,
								303.494
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6300696071032859,
						false
						,[
						[
							1,
							[
								2,
								"blastmark"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						105,
						cr.behaviors.Fade.prototype.acts.StartFade,
						"Fade",
						8634196746376737,
						false
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						2575226952172376,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						1627251453391956,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							55
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4418723747010498,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							61
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7842439172049179,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							62
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7588757385509186,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							90
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						6138827827256163,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1227735599150709,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8001849576106498,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7880381910311611,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						2455735741262179,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7675709714045994,
						false
						,[
						[
							4,
							37
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6111151208904215,
						false
						,[
						[
							1,
							[
								2,
								"normal"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2224817050353915,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenade_explosion"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						7722275527976202,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1218388864998993,
						false
						,[
						[
							4,
							105
						]
,						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								4,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									100
								]
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						2817855232523438,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							153
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						7034166022550594,
						false
						,[
						[
							0,
							[
								1,
								587.162
							]
						]
,						[
							0,
							[
								1,
								303.494
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3896958624932652,
						false
						,[
						[
							1,
							[
								2,
								"blastmark"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						105,
						cr.behaviors.Fade.prototype.acts.StartFade,
						"Fade",
						4148188575985443,
						false
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4749183597494314,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						3352308992070926,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							55
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4530465065989554,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							61
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						3384938540526217,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							62
						]
						]
					]
,					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						463930762688228,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							90
						]
						]
					]
,					[
						37,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						4256913167028618,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7326811062648195,
					[
					[
						119,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4731795786396774,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						9211165518457779,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4062202923413206,
						false
						,[
						[
							1,
							[
								2,
								"destroyEnemy"
							]
						]
,						[
							13,
															[
									7,
									[
										20,
										11,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						7211040163221038,
						false
						,[
						[
							4,
							22
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3254221635804461,
						false
						,[
						[
							1,
							[
								2,
								"default"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6916157904164718,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenade_explosion"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						7950524144908904,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2
							]
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1415273166411325,
					[
					[
						120,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9855764757407605,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						7303052837891601,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1818585311412802,
						false
						,[
						[
							1,
							[
								2,
								"destroyEnemy"
							]
						]
,						[
							13,
															[
									7,
									[
										20,
										11,
										cr.plugins_.Function.prototype.exps.Param,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2566174278257847,
						false
						,[
						[
							4,
							22
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						740368691904287,
						false
						,[
						[
							1,
							[
								2,
								"default"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5785803962989663,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenade_explosion"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						1696968967257332,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2
							]
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					609443385796429,
					[
					[
						37,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3029616444674891,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						true,
						null,
						189232569682125,
						[
						[
							37,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							8953348224693777,
							false
							,[
							[
								1,
								[
									2,
									"Normal"
								]
							]
							]
						]
,						[
							37,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							6284247828231397,
							false
							,[
							[
								1,
								[
									2,
									"Mecha"
								]
							]
							]
						]
,						[
							37,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							2640636581853983,
							false
							,[
							[
								1,
								[
									2,
									"Rainbow"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							763692418978273,
							[
							[
								37,
								cr.plugins_.Sprite.prototype.cnds.CompareFrame,
								null,
								0,
								false,
								false,
								false,
								4462764143118323,
								false
								,[
								[
									8,
									4
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								37,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4639400930807749,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5067302499946647,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						9823870811965361,
						false
						,[
						[
							4,
							152
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9349722881333363,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1130479656387057,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9206893388037033,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						2286974181838125,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6261288826076817,
						[
						[
							34,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							4198191152017425,
							false
							,[
							[
								1,
								[
									2,
									"boss_3"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							4453928264941539,
							false
						]
						],
						[
						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							6915387972190948,
							false
							,[
							[
								0,
								[
									0,
									250
								]
							]
,							[
								0,
								[
									0,
									250
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8333676178367181,
						[
						[
							34,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							229571728819895,
							false
							,[
							[
								1,
								[
									2,
									"boss_3"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							1670306083254941,
							[
							[
								34,
								cr.plugins_.Sprite.prototype.cnds.CompareWidth,
								null,
								0,
								false,
								false,
								false,
								8796600895327637,
								false
								,[
								[
									8,
									3
								]
,								[
									0,
									[
										0,
										30
									]
								]
								]
							]
							],
							[
							[
								34,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								5447660608140428,
								false
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6387400717281132,
							[
							[
								34,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								7556590277831347,
								false
								,[
								[
									4,
									17
								]
								]
							]
							],
							[
							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								1563738287851661,
								false
								,[
								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											0,
											25
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
										,[
											0,
											25
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6300282166860498,
								false
								,[
								[
									11,
									"gold_collected"
								]
,								[
									7,
									[
										4,
										[
											23,
											"gold_collected"
										]
										,[
											0,
											1
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3754234984316005,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												23,
												"gold_collected"
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8166454035009004,
								[
								[
									34,
									cr.plugins_.Sprite.prototype.cnds.CompareWidth,
									null,
									0,
									false,
									false,
									false,
									3829992147653899,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											200
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.cnds.CompareWidth,
									null,
									0,
									false,
									false,
									false,
									6755188647591214,
									false
									,[
									[
										8,
										5
									]
,									[
										0,
										[
											0,
											100
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.cnds.TriggerOnce,
									null,
									0,
									false,
									false,
									false,
									7812228489908044,
									false
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									4963128938872947,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.X,
												false,
												null
											]
											,[
												0,
												50
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.Y,
												false,
												null
											]
											,[
												0,
												200
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									6284930355857036,
									false
									,[
									[
										1,
										[
											2,
											"boss_3"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									1864459997431724,
									false
									,[
									[
										0,
										[
											0,
											90
										]
									]
,									[
										0,
										[
											0,
											90
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									1028707626172639,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.X,
												false,
												null
											]
											,[
												0,
												50
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.Y,
												false,
												null
											]
											,[
												0,
												300
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									3286650574752386,
									false
									,[
									[
										1,
										[
											2,
											"boss_3"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									4510936229942716,
									false
									,[
									[
										0,
										[
											0,
											80
										]
									]
,									[
										0,
										[
											0,
											80
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									381853343055285,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.X,
												false,
												null
											]
											,[
												0,
												200
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												34,
												cr.plugins_.Sprite.prototype.exps.Y,
												false,
												null
											]
											,[
												0,
												50
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									8387719245799698,
									false
									,[
									[
										1,
										[
											2,
											"boss_3"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									7793366109157768,
									false
									,[
									[
										0,
										[
											0,
											70
										]
									]
,									[
										0,
										[
											0,
											70
										]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3873524733742384,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						5572489402497644,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5501939120058622,
						[
						[
							34,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							7758539266180588,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
							]
						]
						],
						[
						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveForward,
							null,
							2641870229625722,
							false
							,[
							[
								0,
								[
									6,
									[
										1,
										1.5
									]
									,[
										23,
										"speed"
									]
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7389033625531416,
							[
							[
								34,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								761140439353201,
								false
								,[
								[
									4,
									17
								]
								]
							]
							],
							[
							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								4324889785593719,
								false
								,[
								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.Width,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											34,
											cr.plugins_.Sprite.prototype.exps.Height,
											false,
											null
										]
										,[
											0,
											5
										]
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1355050552930247,
								false
								,[
								[
									11,
									"gold_collected"
								]
,								[
									7,
									[
										4,
										[
											23,
											"gold_collected"
										]
										,[
											0,
											1
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7829134350248792,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												23,
												"gold_collected"
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5545582191456533,
								[
								[
									34,
									cr.plugins_.Sprite.prototype.cnds.CompareWidth,
									null,
									0,
									false,
									false,
									false,
									6017679546950958,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											50
										]
									]
									]
								]
								],
								[
								[
									34,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									9895808128618502,
									false
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2084834150752122,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						2292774860165851,
						false
						,[
						[
							1,
							[
								2,
								"shooter_1"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						7621005037658817,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8585056188728704,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						4541070759838161,
						false
						,[
						[
							1,
							[
								2,
								"shooter_2"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						4406105020277959,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9473063380680656,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						7638861478479324,
						false
						,[
						[
							1,
							[
								2,
								"shooter_3"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						9162099562454022,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8239684254364302,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						648299143330519,
						false
						,[
						[
							1,
							[
								2,
								"shooter_4"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						5486389840937364,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6504268822408691,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						8115923551202614,
						false
						,[
						[
							1,
							[
								2,
								"boss_1"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						8656933940757639,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2825297886529648,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						3433149808178437,
						false
						,[
						[
							1,
							[
								2,
								"boss_2"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						8073682989454857,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3725210178518484,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						4796829905899194,
						false
						,[
						[
							1,
							[
								2,
								"boss_3"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						6320814533289827,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.1
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2024897516858921,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						3681360041078233,
						false
						,[
						[
							1,
							[
								2,
								"boss_4"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						9473538929722141,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8468558906430758,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						3711589329438502,
						false
						,[
						[
							1,
							[
								2,
								"rocket_big_1"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						8182683824655421,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1737289393484319,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						9417896406305324,
						false
						,[
						[
							1,
							[
								2,
								"rocket_big_2"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						1444469195798661,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2319297027753454,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						5003080731957864,
						false
						,[
						[
							1,
							[
								2,
								"rocket_big_3"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						2950141358822072,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1668928336910969,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						5530887524308341,
						false
						,[
						[
							1,
							[
								2,
								"rocket_big_4"
							]
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						7361957719964886,
						false
						,[
						[
							0,
							[
								6,
								[
									1,
									1.5
								]
								,[
									23,
									"speed"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2356503227560524,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						5850666060226243,
						false
					]
					],
					[
					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						6176791725159411,
						false
						,[
						[
							0,
							[
								0,
								323
							]
						]
,						[
							0,
							[
								0,
								161
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						9663834484827706,
						[
						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							3218426854425789,
							false
							,[
							[
								1,
								[
									2,
									"Idle_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							5590777679861828,
							false
							,[
							[
								1,
								[
									2,
									"Shoot_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							3101491448791656,
							false
							,[
							[
								1,
								[
									2,
									"Boost_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							7063315437785075,
							false
							,[
							[
								1,
								[
									2,
									"Dead_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							8640517526088046,
							false
							,[
							[
								1,
								[
									2,
									"Shotgun_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							9538605248420507,
							false
							,[
							[
								1,
								[
									2,
									"Revolver_Mecha"
								]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							8695875993687049,
							false
							,[
							[
								1,
								[
									2,
									"Rocket_Mecha"
								]
							]
							]
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							3769182431576121,
							false
							,[
							[
								0,
								[
									1,
									386.782
								]
							]
,							[
								0,
								[
									1,
									192.925
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4738325370298561,
					[
					[
						-1,
						cr.system_object.prototype.cnds.ForEach,
						null,
						0,
						true,
						false,
						false,
						2097364679934062,
						false
						,[
						[
							4,
							152
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						420823394524456,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							9797683565750749,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							3652201139514989,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							5661568747496208,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7418281696565967,
								false
								,[
								[
									10,
									2
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Shooter"
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7041578595195247,
								false
								,[
								[
									10,
									2
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Boss"
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								1606210951932933,
								false
								,[
								[
									10,
									2
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Minion"
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								2280653049065233,
								false
								,[
								[
									0,
									[
										23,
										"speed"
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1495586940220271,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
						null,
						1,
						false,
						false,
						false,
						4701846431783675,
						false
						,[
						[
							1,
							[
								2,
								"Death"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9756072390819491,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9146381069908353,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Shooter"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9519210785056083,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Minion"
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						4129883016419528,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						5888354690885118,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1396787675806122,
					[
					[
						22,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						384211310013865,
						false
					]
					],
					[
					[
						22,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						6966547683463045,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6689171488686706,
					[
					[
						105,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8987483011781522,
						false
					]
					],
					[
					[
						105,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						9404801478204662,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					561016176869995,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4930469305075952,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5256539741282673,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							1822984179855949,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1620483930409215,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							117,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4534798550296683,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5950780413712467,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							451484978412551,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							401835966726567,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
,						[
							117,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4710377259528453,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3120387913678005,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
						null,
						0,
						false,
						false,
						false,
						5425694206002666,
						false
						,[
						[
							4,
							105
						]
						]
					]
					],
					[
					[
						105,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						8571967984139433,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							14
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					755503560419189,
					[
					[
						153,
						cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
						null,
						0,
						false,
						false,
						false,
						5386155776691148,
						false
						,[
						[
							4,
							105
						]
						]
					]
					],
					[
					[
						153,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5458070618487983,
						false
						,[
						[
							3,
							0
						]
,						[
							4,
							105
						]
						]
					]
					]
				]
,				[
					0,
					null,
					true,
					null,
					5356157260973472,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1525849227928231,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Solid"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6855435410451807,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Exploder"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						4550529344055469,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								1000
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						1177432187553685,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					true,
					null,
					5932242939892878,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						160340406749303,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1663551179372443,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Shooter"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2827757618389943,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Minion"
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						7618684936713307,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									21,
									152,
									false,
									null
									,3
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						9383822527542043,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							1753725506805538,
							false
							,[
							[
								8,
								2
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9191513282264832,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6910682955159402,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							3464142750152581,
							false
							,[
							[
								8,
								4
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							2670732734224988,
							false
							,[
							[
								10,
								3
							]
,							[
								7,
								[
									0,
									-1
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8792186093354902,
					[
					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						1550540076125342,
						false
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6729996325036809,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							1
						]
,						[
							7,
							[
								2,
								"Interface"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						5303573842849408,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						6853842843395365,
						false
						,[
						[
							3,
							0
						]
,						[
							4,
							105
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						6094872951606632,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							152
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						7528936703728361,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							34
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						5093383209721904,
						[
						[
							8,
							cr.plugins_.Sprite.prototype.cnds.CompareX,
							null,
							0,
							false,
							false,
							false,
							6714132266406704,
							false
							,[
							[
								8,
								2
							]
,							[
								0,
								[
									0,
									-20
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5536729775872917,
							false
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8222133076141434,
					[
					[
						153,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						7624906847154729,
						false
						,[
						[
							5,
							[
								2,
								"Game"
							]
						]
						]
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						6030889548261923,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								200
							]
						]
						]
					]
					],
					[
					[
						153,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						3803344644128596,
						false
						,[
						[
							0,
							[
								23,
								"speed"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8711643137560372,
					[
					[
						79,
						cr.plugins_.Sprite.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						4820190368065316,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								-344
							]
						]
						]
					]
					],
					[
					[
						79,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7026055805663962,
						false
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						9196473398378024,
						false
						,[
						[
							1,
							[
								2,
								"spawnBackground"
							]
						]
,						[
							13,
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4038070308981946,
					[
					[
						79,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						808682699788874,
						false
						,[
						[
							1,
							[
								2,
								"Stage_1"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4306513695010387,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							2900651809461535,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6190935641968814,
					[
					[
						79,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						5743285238862523,
						false
						,[
						[
							1,
							[
								2,
								"Stage_3"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9120495782337721,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							4342027514391395,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7576925776398513,
					[
					[
						79,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						7837651168828345,
						false
						,[
						[
							1,
							[
								2,
								"Stage_4"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8673657413324645,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							9685669859432722,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4800102987406172,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					253016377068588,
					false
					,[
					[
						1,
						[
							2,
							"spawnBackground"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8970509842732262,
					[
					[
						79,
						cr.plugins_.Sprite.prototype.cnds.PickDistance,
						null,
						0,
						false,
						false,
						true,
						3315645276762702,
						false
						,[
						[
							3,
							0
						]
,						[
							0,
							[
								0,
								1300
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6547002090439026,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2696609011929895,
							false
							,[
							[
								11,
								"levelchanged"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2347250095328026,
							false
							,[
							[
								4,
								79
							]
,							[
								5,
								[
									2,
									"Background"
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										79,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
									,[
										0,
										320
									]
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5767066433849039,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Stage_"
									]
									,[
										23,
										"level"
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.acts.StopAnim,
							null,
							7386096841092007,
							false
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							2064868065318217,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6846519389818604,
								false
								,[
								[
									11,
									"boss"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								79,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								2784877719244313,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												0
											]
,[
												0,
												4
											]
											]
										]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3155031436326886,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								9436483026733238,
								false
							]
							],
							[
							[
								79,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								4126661483768322,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												5
											]
,[
												0,
												9
											]
											]
										]
										]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7876406049600272,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							7418004712911653,
							false
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6993463256784353,
							false
							,[
							[
								4,
								79
							]
,							[
								5,
								[
									2,
									"Background"
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										79,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
									,[
										0,
										320
									]
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.acts.StopAnim,
							null,
							3254506023316593,
							false
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4425905694620303,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Stage_"
									]
									,[
										5,
										[
											23,
											"level"
										]
										,[
											0,
											1
										]
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							5019597871998436,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7909637624406898,
							false
							,[
							[
								11,
								"levelchanged"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4772263709090655,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9725333106739832,
					false
					,[
					[
						11,
						"ahead_start"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					4585016797486689,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							0,
							66
						]
					]
					]
				]
				],
				[
				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					179380538892144,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
					]
				]
,				[
					85,
					cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
					"DragDrop",
					9406600086184869,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6356040610928882,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5867078883152568,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					5241108699246214,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Boost_"
							]
							,[
								23,
								"suit"
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4986439872287114,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					85,
					cr.behaviors.Bullet.prototype.acts.SetEnabled,
					"Bullet",
					3382215804551874,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4863143392577684,
					false
					,[
					[
						11,
						"ahead_start"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4615173595792392,
					false
					,[
					[
						11,
						"speed_boost"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2688662536938747,
					false
					,[
					[
						11,
						"speed"
					]
,					[
						7,
						[
							23,
							"speed_normal"
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2983643047139554,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					686356960337396,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Idle_"
							]
							,[
								23,
								"suit"
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					6610038061882307,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3564966855161671,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetCollisions,
					null,
					2096758561261911,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					9802836654138327,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1733339459274665,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1603640580962072,
					false
					,[
					[
						11,
						"ahead_start"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2234917814399383,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1030176024328221,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					4499358312787511,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
					]
				]
,				[
					85,
					cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
					"DragDrop",
					1652042907117545,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					4411174199823654,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Boost_"
							]
							,[
								23,
								"suit"
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9095192530363147,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					94,
					cr.behaviors.scrollto.prototype.acts.Shake,
					"ScrollTo",
					1935357974462618,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
,					[
						0,
						[
							1,
							2.5
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					7638695177307337,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					559004219981908,
					[
					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						8281631792461194,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1608901989873133,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"boost_of_speed"
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6282856835393358,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7758811416265649,
					false
					,[
					[
						11,
						"ahead_start"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7876824479615142,
					false
					,[
					[
						11,
						"distance_meters"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							520
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.TriggerOnce,
					null,
					0,
					false,
					false,
					false,
					5485151036599359,
					false
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					4907040126618006,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8388169557977527,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetX,
					null,
					6988666064120962,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
					]
				]
,				[
					85,
					cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
					"DragDrop",
					5942452219119073,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.SetAnim,
					null,
					3979585729738675,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Boost_"
							]
							,[
								23,
								"suit"
							]
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4060126637372714,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					85,
					cr.behaviors.Bullet.prototype.acts.SetAngleOfMotion,
					"Bullet",
					4728815235027499,
					false
					,[
					[
						0,
						[
							0,
							180
						]
					]
					]
				]
,				[
					85,
					cr.behaviors.Bullet.prototype.acts.SetSpeed,
					"Bullet",
					2907604100913291,
					false
					,[
					[
						0,
						[
							0,
							500
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Items"],
				false,
				null,
				9788319156209614,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					9788319156209614,
					false
					,[
					[
						1,
						[
							2,
							"Items"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1930385372487859,
					[
					[
						114,
						cr.plugins_.Mouse.prototype.cnds.IsButtonDown,
						null,
						0,
						false,
						false,
						false,
						4092323484851438,
						false
						,[
						[
							3,
							2
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3387495300829389,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						36,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8969357652675234,
						false
						,[
						[
							0,
							[
								20,
								114,
								cr.plugins_.Mouse.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								114,
								cr.plugins_.Mouse.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8750764105945872,
					[
					[
						114,
						cr.plugins_.Mouse.prototype.cnds.OnRelease,
						null,
						1,
						false,
						false,
						false,
						5717131081587728,
						false
						,[
						[
							3,
							2
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7715495297627302,
						[
						[
							36,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							556840175904497,
							false
							,[
							[
								8,
								4
							]
,							[
								0,
								[
									0,
									200
								]
							]
							]
						]
						],
						[
						[
							36,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							3019326107781773,
							false
							,[
							[
								4,
								105
							]
,							[
								5,
								[
									2,
									"Background"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5349372499798805,
							false
							,[
							[
								1,
								[
									2,
									"blastmark"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							105,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							381099829793008,
							false
						]
,						[
							36,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							3122390090877132,
							false
							,[
							[
								4,
								37
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							37,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1980228401713337,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							3182672096642661,
							false
							,[
							[
								11,
								"grenades"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2996083137862216,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenades"
										]
									]
,
									[
										7,
										[
											10,
											[
												23,
												"grenades"
											]
											,[
												2,
												" x"
											]
										]
									]
							]
							]
						]
,						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							3779923332234508,
							false
							,[
							[
								1,
								[
									2,
									"grenades"
								]
							]
,							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"grenades"
											]
											]
										]
										]
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3529816541664385,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenade_explosion"
										]
									]
							]
							]
						]
,						[
							94,
							cr.behaviors.scrollto.prototype.acts.Shake,
							"ScrollTo",
							8422285651049295,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
,							[
								0,
								[
									1,
									2
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							622348910771079,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							8105143003749253,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4979718678305782,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_massivedamage"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1884926267102181,
						[
						],
						[
						[
							36,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							2428519340557687,
							false
							,[
							[
								0,
								[
									0,
									-500
								]
							]
,							[
								0,
								[
									0,
									-100
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					324197206754543,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchObject,
						null,
						1,
						false,
						false,
						false,
						6825679436174018,
						false
						,[
						[
							4,
							35
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2348171821168639,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						36,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9502978291345083,
						false
						,[
						[
							0,
							[
								20,
								35,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								35,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7918355914777407,
					[
					[
						36,
						cr.behaviors.DragnDrop.prototype.cnds.OnDrop,
						"DragDrop",
						1,
						false,
						false,
						false,
						6461825023221032,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9842539883891973,
						[
						[
							36,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							9431935481175125,
							false
							,[
							[
								8,
								4
							]
,							[
								0,
								[
									0,
									200
								]
							]
							]
						]
						],
						[
						[
							36,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							5182942742981675,
							false
							,[
							[
								4,
								105
							]
,							[
								5,
								[
									2,
									"Background"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7141553110236531,
							false
							,[
							[
								1,
								[
									2,
									"blastmark"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							105,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							9985944871168964,
							false
						]
,						[
							36,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							4670650146173817,
							false
							,[
							[
								4,
								37
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							37,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3842749144868939,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							9769976754588169,
							false
							,[
							[
								11,
								"grenades"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8262887203663319,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenades"
										]
									]
,
									[
										7,
										[
											10,
											[
												23,
												"grenades"
											]
											,[
												2,
												" x"
											]
										]
									]
							]
							]
						]
,						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							1394211837610517,
							false
							,[
							[
								1,
								[
									2,
									"grenades"
								]
							]
,							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"grenades"
											]
											]
										]
										]
									]
									,[
										0,
										1
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8091126463624739,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenade_explosion"
										]
									]
							]
							]
						]
,						[
							94,
							cr.behaviors.scrollto.prototype.acts.Shake,
							"ScrollTo",
							2422938823318596,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
,							[
								0,
								[
									1,
									2
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							8682340745520957,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							105,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							5127403750813694,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1915114589502649,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_massivedamage"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4112895546029132,
						[
						],
						[
						[
							36,
							cr.plugins_.Sprite.prototype.acts.SetPos,
							null,
							9368762304417037,
							false
							,[
							[
								0,
								[
									0,
									-500
								]
							]
,							[
								0,
								[
									0,
									-100
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3898058668248826,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9724926156612394,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1462945276339155,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							1033049316167886,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
,[
										0,
										20
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1563173746010387,
							false
							,[
							[
								4,
								153
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										333
									]
,[
										0,
										588
									]
									]
								]
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4984296024162158,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							8019938872010579,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							5459259179078153,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9968315192179386,
							false
							,[
							[
								4,
								116
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									153,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										153,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										50
									]
								]
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4510473518336124,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							116,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							3821182114969809,
							false
							,[
							[
								4,
								153
							]
,							[
								3,
								0
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							3668726122168735,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								153
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4085326695691832,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7016516410073433,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								150
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4546287220871242,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							7124469375499116,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										20
									]
,[
										0,
										30
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4009589198341073,
							false
							,[
							[
								4,
								28
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										333
									]
,[
										0,
										588
									]
									]
								]
							]
							]
						]
,						[
							28,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							1826537592345387,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							28,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							3405167670147095,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2105959913975435,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9141988882548011,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								250
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7506902518164686,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							9349473699371407,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										80
									]
,[
										0,
										100
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							402858676843914,
							false
							,[
							[
								4,
								130
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										333
									]
,[
										0,
										588
									]
									]
								]
							]
							]
						]
,						[
							130,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							367248306644116,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							130,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							6139459764691137,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8696011519919075,
							false
							,[
							[
								4,
								116
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									130,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										130,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										50
									]
								]
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							409826542900302,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							116,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							902147689554447,
							false
							,[
							[
								4,
								130
							]
,							[
								3,
								0
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							3012981917112378,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								130
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					921443103747672,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5250225588785606,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4077303508324573,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							9340850129933834,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										10
									]
,[
										0,
										30
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							626836971326369,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1100
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							662426904063627,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1274321764402751,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7609309436047544,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							2340158429734417,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6020632827267025,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8714933310585888,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							2172747442815506,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							44077500842423,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							2943410951994872,
							[
							[
								8,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								7431228016349859,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8625467976353646,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								1023559083317963,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									152
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								663422572857219,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									34
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					148773926306672,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						344528249880846,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								200
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1612022454542152,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							7639284405498982,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										30
									]
,[
										0,
										50
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2901950154631388,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1100
								]
							]
,							[
								0,
								[
									0,
									588
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							985719807853823,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3512882035956523,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7024697354174838,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									588
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							4115132034166085,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9447294335565098,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2830847315212526,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									588
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							283358162723354,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2617503839837334,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9351462564123235,
							[
							[
								8,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								5367464831982986,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8465248209341525,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8677707398987795,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									152
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								6992768711783133,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									34
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2878547428029724,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3652817662277586,
						false
						,[
						[
							11,
							"distance_meters"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								300
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						8720067337800677,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							5378254817691413,
							false
							,[
							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										50
									]
,[
										0,
										70
									]
									]
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9288157860300522,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1100
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							589216990864382,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							480491208299196,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4261422345059927,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8628832372317841,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7951058835679497,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							440371750203319,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							9931089138339127,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5460238364154107,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							835617612389094,
							[
							[
								8,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								529820070901807,
								false
							]
							],
							[
							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								5193461037397977,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								2677322782691106,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									152
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								1539673840011861,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									34
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3169056161823983,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.OnFunction,
						null,
						2,
						false,
						false,
						false,
						8047987071776836,
						false
						,[
						[
							1,
							[
								2,
								"destroyOldPickup"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4857009109529247,
						[
						[
							153,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							377368237692454,
							false
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.cnds.CompareY,
							null,
							0,
							false,
							false,
							false,
							7565637478930843,
							false
							,[
							[
								8,
								3
							]
,							[
								0,
								[
									0,
									200
								]
							]
							]
						]
						],
						[
						[
							153,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							7090772296668303,
							false
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Enemies"],
				false,
				null,
				2260942708933342,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2260942708933342,
					false
					,[
					[
						1,
						[
							2,
							"Enemies"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					1,
					"shoot_limit",
					0,
					0,
true,false,9074160673552137,false
				]
,				[
					0,
					null,
					false,
					null,
					2891470350177235,
					[
					[
						65,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3285273129322972,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.TriggerOnce,
						null,
						0,
						false,
						false,
						false,
						5135443664587029,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4730272991087294,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"helicopter"
									]
								]
,
								[
									7,
									[
										2,
										"start"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3515737639630064,
					[
					[
						65,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						9503175561585949,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						9371601599465165,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"helicopter"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					855401531193057,
					[
					[
						55,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7585401064926677,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5566300044960252,
						[
						[
							119,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							970248752576032,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							68169968288677,
							[
							[
								119,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								5721177248505241,
								false
								,[
								[
									1,
									[
										2,
										"Idle"
									]
								]
								]
							]
							],
							[
							[
								119,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								1996800286276235,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8811535963697571,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							552232477186846,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3904824569063449,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"trap_1"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							119,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							280276086392203,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							119,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							580592851616301,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								55
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1546280158072048,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							2596265036156095,
							false
							,[
							[
								4,
								152
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							224215401848193,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								8910156032660385,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								23985438111778,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7658017946010521,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3872273862596471,
								false
								,[
								[
									1,
									[
										2,
										"hitEnemy"
									]
								]
,								[
									13,
																			[
											7,
											[
												21,
												17,
												false,
												null
												,0
											]
										]
,
										[
											7,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								1810351006769076,
								[
								[
									55,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1260605887009103,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									9174120304458215,
									[
									[
										55,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										6568335113871895,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											5
										]
,										[
											7,
											[
												5,
												[
													21,
													55,
													false,
													null
													,1
												]
												,[
													0,
													1000
												]
											]
										]
										]
									]
									],
									[
									]
									,[
									[
										0,
										null,
										false,
										null,
										5253299834981661,
										[
										[
											2,
											cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											7202999331525605,
											false
											,[
											[
												10,
												0
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													2,
													"boss_shield"
												]
											]
											]
										]
										],
										[
										[
											2,
											cr.plugins_.Text.prototype.acts.SetText,
											null,
											4754460171799342,
											false
											,[
											[
												7,
												[
													2,
													"Shield down!"
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetFontColor,
											null,
											4450921334491876,
											false
											,[
											[
												0,
												[
													19,
													cr.system_object.prototype.exps.rgb
													,[
[
														0,
														255
													]
,[
														0,
														0
													]
,[
														0,
														0
													]
													]
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetPos,
											null,
											1132302750712082,
											false
											,[
											[
												0,
												[
													20,
													55,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
											]
,											[
												0,
												[
													5,
													[
														20,
														55,
														cr.plugins_.Sprite.prototype.exps.Y,
														false,
														null
													]
													,[
														0,
														100
													]
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											4694992157921086,
											false
											,[
											[
												4,
												55
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.Wait,
											null,
											816897949133732,
											false
											,[
											[
												0,
												[
													1,
													0.5
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetVisible,
											null,
											7831702080482913,
											false
											,[
											[
												3,
												0
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5573455984834263,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1304976401220323,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7493909674784137,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								94,
								cr.behaviors.scrollto.prototype.acts.Shake,
								"ScrollTo",
								1614978430474929,
								false
								,[
								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										1,
										2
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								4436843552168553,
								false
								,[
								[
									4,
									22
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7916345377268566,
								false
								,[
								[
									1,
									[
										2,
										"default"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								746433885728172,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"collision"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3825977865351014,
					[
					[
						61,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						9004331461096205,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2867510540386174,
						[
						[
							119,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							322667896386069,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5444237015199638,
							[
							[
								119,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1048852595020037,
								false
								,[
								[
									1,
									[
										2,
										"Idle"
									]
								]
								]
							]
							],
							[
							[
								119,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4720202267676108,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7116269738771609,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							7837456586953264,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9764388613352025,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"trap_1"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							119,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							4133109822461262,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							119,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							297291911226534,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								61
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8231389612374528,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							1153389151196512,
							false
							,[
							[
								4,
								152
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8402071492509128,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6560586252913644,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								6171648096072082,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								1523972175206106,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1717119231343258,
								false
								,[
								[
									1,
									[
										2,
										"hitEnemy"
									]
								]
,								[
									13,
																			[
											7,
											[
												21,
												17,
												false,
												null
												,0
											]
										]
,
										[
											7,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8064096380722959,
								[
								[
									61,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2631262987918496,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									3595004187116685,
									[
									[
										61,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										947944317756038,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											5
										]
,										[
											7,
											[
												5,
												[
													21,
													61,
													false,
													null
													,1
												]
												,[
													0,
													1000
												]
											]
										]
										]
									]
									],
									[
									]
									,[
									[
										0,
										null,
										false,
										null,
										3480000852655376,
										[
										[
											2,
											cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											4431032387524929,
											false
											,[
											[
												10,
												0
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													2,
													"boss_shield"
												]
											]
											]
										]
										],
										[
										[
											2,
											cr.plugins_.Text.prototype.acts.SetText,
											null,
											1709696064545875,
											false
											,[
											[
												7,
												[
													2,
													"Shield down!"
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetFontColor,
											null,
											7806330050132947,
											false
											,[
											[
												0,
												[
													19,
													cr.system_object.prototype.exps.rgb
													,[
[
														0,
														255
													]
,[
														0,
														0
													]
,[
														0,
														0
													]
													]
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetPos,
											null,
											2338839596054635,
											false
											,[
											[
												0,
												[
													20,
													61,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
											]
,											[
												0,
												[
													5,
													[
														20,
														61,
														cr.plugins_.Sprite.prototype.exps.Y,
														false,
														null
													]
													,[
														0,
														100
													]
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											6169587480824976,
											false
											,[
											[
												4,
												61
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.Wait,
											null,
											9132866264386486,
											false
											,[
											[
												0,
												[
													1,
													0.5
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetVisible,
											null,
											9409787852336877,
											false
											,[
											[
												3,
												0
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6741704924627913,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								949580931707122,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2439863454560771,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								94,
								cr.behaviors.scrollto.prototype.acts.Shake,
								"ScrollTo",
								2034592933205426,
								false
								,[
								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										1,
										2
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								2750353865087177,
								false
								,[
								[
									4,
									22
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9715817420361301,
								false
								,[
								[
									1,
									[
										2,
										"default"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9218372431378287,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"collision"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2876696975137621,
					[
					[
						62,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7787669441196898,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1220338620029291,
						[
						[
							62,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							9858374858915395,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							9812513793808517,
							[
							[
								120,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								8705959202014848,
								false
								,[
								[
									1,
									[
										2,
										"Idle"
									]
								]
								]
							]
							],
							[
							[
								120,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								2791692798890206,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7624347366758517,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							432744091133064,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9344362146288604,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"trap_2"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							120,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							1563207022541627,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							120,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							1196982929195166,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								62
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5106435078457499,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							9491191706099661,
							false
							,[
							[
								4,
								152
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							9514020504728252,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6875131914067032,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								9518102987485444,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								6859850796262217,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2903242093665973,
								false
								,[
								[
									1,
									[
										2,
										"hitEnemy"
									]
								]
,								[
									13,
																			[
											7,
											[
												21,
												17,
												false,
												null
												,0
											]
										]
,
										[
											7,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6501560998998724,
								[
								[
									62,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									8371831546217428,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									2216525802775064,
									[
									[
										62,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										1505595043914579,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											5
										]
,										[
											7,
											[
												5,
												[
													21,
													62,
													false,
													null
													,1
												]
												,[
													0,
													1000
												]
											]
										]
										]
									]
									],
									[
									]
									,[
									[
										0,
										null,
										false,
										null,
										7412880699990119,
										[
										[
											2,
											cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											5610554214102598,
											false
											,[
											[
												10,
												0
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													2,
													"boss_shield"
												]
											]
											]
										]
										],
										[
										[
											2,
											cr.plugins_.Text.prototype.acts.SetText,
											null,
											2125041463425095,
											false
											,[
											[
												7,
												[
													2,
													"Shield down!"
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetFontColor,
											null,
											437962267981783,
											false
											,[
											[
												0,
												[
													19,
													cr.system_object.prototype.exps.rgb
													,[
[
														0,
														255
													]
,[
														0,
														0
													]
,[
														0,
														0
													]
													]
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetPos,
											null,
											652482882754935,
											false
											,[
											[
												0,
												[
													20,
													62,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
											]
,											[
												0,
												[
													5,
													[
														20,
														62,
														cr.plugins_.Sprite.prototype.exps.Y,
														false,
														null
													]
													,[
														0,
														100
													]
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											2024873908430665,
											false
											,[
											[
												4,
												62
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.Wait,
											null,
											3178686383660589,
											false
											,[
											[
												0,
												[
													1,
													0.5
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetVisible,
											null,
											1503856692055686,
											false
											,[
											[
												3,
												0
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3223943900936824,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								9076443447910137,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								3791022859749859,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								94,
								cr.behaviors.scrollto.prototype.acts.Shake,
								"ScrollTo",
								4140030424884845,
								false
								,[
								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										1,
										2
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								2038867575050253,
								false
								,[
								[
									4,
									22
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8417768143813284,
								false
								,[
								[
									1,
									[
										2,
										"default"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3564446249785643,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"collision"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					653467478268721,
					[
					[
						90,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						5623821250558036,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5122184391704907,
						[
						[
							63,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							4839811247944193,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							7650284345409143,
							[
							[
								63,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								4302550027365878,
								false
								,[
								[
									1,
									[
										2,
										"Idle"
									]
								]
								]
							]
							],
							[
							[
								63,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								2823860174816343,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4378840861368992,
						[
						[
							63,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8844298231868441,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							7059202991860655,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9794477959050552,
							false
							,[
							[
								1,
								[
									2,
									"destroyEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											11,
											cr.plugins_.Function.prototype.exps.Param,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9652132168349578,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"collision"
										]
									]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							8204502307543224,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1405322663156983,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							2787196443393785,
							false
							,[
							[
								0,
								[
									0,
									45
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							4665181917634707,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4786537064092386,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							510947719548013,
							false
							,[
							[
								0,
								[
									0,
									-45
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							8049292294705921,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							228462704893158,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							4391410935298748,
							false
							,[
							[
								0,
								[
									0,
									135
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							4200734733913535,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4448618896121589,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							3222414241936212,
							false
							,[
							[
								0,
								[
									0,
									-135
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							8389328073415709,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7756622295466083,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							4397975872643274,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							41750402276393,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4177422053332175,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							5524729957228871,
							false
							,[
							[
								0,
								[
									0,
									90
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							1180445226037375,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9289641573628908,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							4809833592463101,
							false
							,[
							[
								0,
								[
									0,
									180
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							523023861215269,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9930384142854113,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							8382227404720866,
							false
							,[
							[
								0,
								[
									0,
									-90
								]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							2666823093338512,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4348361952571594,
							false
							,[
							[
								1,
								[
									2,
									"rocket_big_4"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAngle,
							null,
							4716846886498854,
							false
							,[
							[
								0,
								[
									0,
									-180
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8121126454558082,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Every,
							null,
							0,
							false,
							false,
							false,
							8113041352425081,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3254842257717444,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_2"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							413255924429226,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							63,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							5839040139152648,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								90
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6810810544736141,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.OnCollision,
							null,
							0,
							false,
							false,
							true,
							8976584507378051,
							false
							,[
							[
								4,
								152
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							9493648346700712,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								3713645334451966,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.MoveForward,
								null,
								7599800337087811,
								false
								,[
								[
									0,
									[
										0,
										5
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								7069958183931557,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7282511776600752,
								false
								,[
								[
									1,
									[
										2,
										"hitEnemy"
									]
								]
,								[
									13,
																			[
											7,
											[
												21,
												17,
												false,
												null
												,0
											]
										]
,
										[
											7,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.UID,
												false,
												null
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5633902110960489,
								[
								[
									90,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									8203884195164313,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								]
								,[
								[
									0,
									null,
									false,
									null,
									9750395385893887,
									[
									[
										90,
										cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										2326128785981409,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											5
										]
,										[
											7,
											[
												5,
												[
													21,
													90,
													false,
													null
													,1
												]
												,[
													0,
													1000
												]
											]
										]
										]
									]
									],
									[
									]
									,[
									[
										0,
										null,
										false,
										null,
										4779139382762936,
										[
										[
											2,
											cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
											null,
											0,
											false,
											false,
											false,
											5456683949176068,
											false
											,[
											[
												10,
												0
											]
,											[
												8,
												0
											]
,											[
												7,
												[
													2,
													"boss_shield"
												]
											]
											]
										]
										],
										[
										[
											2,
											cr.plugins_.Text.prototype.acts.SetText,
											null,
											5814545386349909,
											false
											,[
											[
												7,
												[
													2,
													"Shield down!"
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetFontColor,
											null,
											2879267506328084,
											false
											,[
											[
												0,
												[
													19,
													cr.system_object.prototype.exps.rgb
													,[
[
														0,
														255
													]
,[
														0,
														0
													]
,[
														0,
														0
													]
													]
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetPos,
											null,
											148731305052977,
											false
											,[
											[
												0,
												[
													20,
													90,
													cr.plugins_.Sprite.prototype.exps.X,
													false,
													null
												]
											]
,											[
												0,
												[
													5,
													[
														20,
														90,
														cr.plugins_.Sprite.prototype.exps.Y,
														false,
														null
													]
													,[
														0,
														100
													]
												]
											]
											]
										]
,										[
											2,
											cr.behaviors.Pin.prototype.acts.Pin,
											"Pin",
											3585759833287934,
											false
											,[
											[
												4,
												90
											]
,											[
												3,
												0
											]
											]
										]
,										[
											-1,
											cr.system_object.prototype.acts.Wait,
											null,
											6290647917280497,
											false
											,[
											[
												0,
												[
													1,
													0.5
												]
											]
											]
										]
,										[
											2,
											cr.plugins_.Text.prototype.acts.SetVisible,
											null,
											8718286134403932,
											false
											,[
											[
												3,
												0
											]
											]
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5377589968535972,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
								null,
								0,
								false,
								false,
								false,
								1966159241524017,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								276424977790618,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								94,
								cr.behaviors.scrollto.prototype.acts.Shake,
								"ScrollTo",
								2723659415114628,
								false
								,[
								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										1,
										2
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3623749688324761,
								false
								,[
								[
									4,
									22
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9251421882412863,
								false
								,[
								[
									1,
									[
										2,
										"default"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5030733551656046,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"collision"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6140005031612577,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6517051766572164,
						false
						,[
						[
							11,
							"boss"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2383751865156673,
						false
						,[
						[
							11,
							"cycle"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2474100668949101,
						false
						,[
						[
							11,
							"boss"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7149013015402548,
						false
						,[
						[
							1,
							[
								2,
								"spawnEnemy"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"boss_"
									]
								]
,
								[
									7,
									[
										0,
										1000
									]
								]
,
								[
									7,
									[
										0,
										400
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9279591214072484,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						4262784072074641,
						false
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9130106986588984,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Shooter"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5032692554583418,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5537089098392678,
						false
						,[
						[
							11,
							"cycle"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8456345303640845,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											23,
											"level"
										]
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5377981298027193,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											10,
											[
												2,
												"BGM_stage"
											]
											,[
												23,
												"level"
											]
										]
										,[
											2,
											"_boss"
										]
									]
								]
,
								[
									7,
									[
										2,
										"start"
									]
								]
						]
						]
					]
,					[
						12,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8013791038654806,
						false
						,[
						[
							0,
							[
								23,
								"level"
							]
						]
						]
					]
,					[
						117,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						59830707024628,
						false
						,[
						[
							0,
							[
								23,
								"level"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4683575783341343,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"voice_warning"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5721794857142374,
						false
						,[
						[
							4,
							99
						]
,						[
							5,
							[
								2,
								"Interface"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						2510922728463683,
						false
						,[
						[
							4,
							72
						]
,						[
							5,
							[
								2,
								"Interface"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1314301919284349,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"warning"
									]
								]
						]
						]
					]
,					[
						72,
						cr.behaviors.Flash.prototype.acts.Flash,
						"Flash",
						3339503338751144,
						false
						,[
						[
							0,
							[
								1,
								0.8
							]
						]
,						[
							0,
							[
								1,
								0.4
							]
						]
,						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						99,
						cr.behaviors.Flash.prototype.acts.Flash,
						"Flash",
						4067433870501523,
						false
						,[
						[
							0,
							[
								1,
								0.8
							]
						]
,						[
							0,
							[
								1,
								0.4
							]
						]
,						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4928852012248435,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5976775700205389,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"voice_warning"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6668200094478136,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7475828337734442,
						false
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1128764440270519,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6340767135399202,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3245124979968329,
						false
						,[
						[
							11,
							"cycle"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8264556498231929,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1174269037950241,
						false
						,[
						[
							11,
							"boss"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1257978509968763,
						false
						,[
						[
							11,
							"cycle"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1105793545026065,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							8767085419422321,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									25
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6244280483866065,
							false
							,[
							[
								11,
								"formation_1"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8409476367445382,
							false
							,[
							[
								11,
								"formation_1"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8455987973700216,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5848691456658063,
							false
							,[
							[
								11,
								"formation_2"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_2",
						0,
						0,
true,false,3578338203694167,false
					]
,					[
						0,
						null,
						false,
						null,
						6146679882186792,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							568370764276377,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									50
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5814406045538839,
							false
							,[
							[
								11,
								"formation_2"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7733419230445374,
							false
							,[
							[
								11,
								"formation_2"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							92711797632878,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							530793191162654,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6845591760001858,
							false
							,[
							[
								11,
								"formation_3"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7819826204122509,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7318814372851813,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8174208754113691,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							990467340809142,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							485266541940898,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							2965171199625982,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3763782601743643,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							9715552439269192,
							false
						]
						]
					]
,					[
						1,
						"formation_3",
						0,
						0,
true,false,9960950906755504,false
					]
,					[
						0,
						null,
						false,
						null,
						9581052266324824,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6433364039776629,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									75
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7669450535149305,
							false
							,[
							[
								11,
								"formation_3"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7894775829140959,
							false
							,[
							[
								11,
								"formation_3"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4015600670027909,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3318279187875143,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8363600815974127,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5164281807735129,
							false
							,[
							[
								11,
								"formation_4"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8739041488387851,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4880908266245893,
							false
							,[
							[
								4,
								153
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										333
									]
,[
										0,
										588
									]
									]
								]
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							332223957988233,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							4217900904606773,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							153,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							8518184213017365,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8442131352855862,
							false
							,[
							[
								4,
								116
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									153,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										153,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
									,[
										0,
										50
									]
								]
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2980271722551636,
							false
							,[
							[
								1,
								[
									23,
									"suit"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							116,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							8838112180891859,
							false
							,[
							[
								4,
								153
							]
,							[
								3,
								0
							]
							]
						]
,						[
							116,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							6236930704764149,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								153
							]
							]
						]
						]
					]
,					[
						1,
						"formation_4",
						0,
						0,
true,false,415964659185432,false
					]
,					[
						0,
						null,
						false,
						null,
						2559204469139209,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							8656598922567379,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									100
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							620653752093715,
							false
							,[
							[
								11,
								"formation_4"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6509119634986041,
							false
							,[
							[
								11,
								"formation_4"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1754129988591434,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							406894005904331,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											900
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3338334073875402,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6225225163682919,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3176446489638103,
							false
							,[
							[
								11,
								"formation_5"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5772038839751095,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6518383353406966,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7665868680361752,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1155371543678057,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							4977620622934804,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							6577785410604448,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4873538589692895,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							5737630122746393,
							false
						]
						]
					]
,					[
						1,
						"formation_5",
						0,
						0,
true,false,6310238412305486,false
					]
,					[
						0,
						null,
						false,
						null,
						8248417044767888,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							7636696755214421,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									120
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5247255124202056,
							false
							,[
							[
								11,
								"formation_5"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8159850546753283,
							false
							,[
							[
								11,
								"formation_5"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7645354364767722,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3972402806498866,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1116410943733929,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8316640681206263,
							false
							,[
							[
								11,
								"formation_6"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_6",
						0,
						0,
true,false,4439009306807149,false
					]
,					[
						0,
						null,
						false,
						null,
						2979774603813332,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							9487744119413186,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									140
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1430533993860069,
							false
							,[
							[
								11,
								"formation_6"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7495891345695794,
							false
							,[
							[
								11,
								"formation_6"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8190679429835223,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7460264115592242,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8722099141767211,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2805797334546567,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3056510105816064,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							464652931081712,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2437173010000556,
							false
							,[
							[
								11,
								"formation_7"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6383825151611265,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1522393944834698,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2581262533234186,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3096024340492287,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9425380359433793,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							5234101250934033,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5487301886352339,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							333115790674767,
							false
						]
						]
					]
,					[
						1,
						"formation_7",
						0,
						0,
true,false,6582879564258628,false
					]
,					[
						0,
						null,
						false,
						null,
						6824839425530031,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5736528854927237,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									160
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6639872633460432,
							false
							,[
							[
								11,
								"formation_7"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7860521304950348,
							false
							,[
							[
								11,
								"formation_7"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7420449896820614,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4857006183343074,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3911837374107908,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4581559076185723,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3892394976382128,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4523010575881113,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6662507050846541,
							false
							,[
							[
								11,
								"formation_8"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_8",
						0,
						0,
true,false,2235055987818404,false
					]
,					[
						0,
						null,
						false,
						null,
						6442845422936577,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							333996068983366,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									180
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4037477931572879,
							false
							,[
							[
								11,
								"formation_8"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5548848762165474,
							false
							,[
							[
								11,
								"formation_8"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							279462428693565,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3280402411890099,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8139591159971773,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7623192000944879,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2859353729810664,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4329664869711756,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4996560742407074,
							false
							,[
							[
								11,
								"formation_9"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1320321767731292,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1554111253302192,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9568965069002106,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4967664091481779,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7361080569252785,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							4510604839987143,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5759325177690629,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							7825395986167965,
							false
						]
						]
					]
,					[
						1,
						"formation_9",
						0,
						0,
true,false,8324702481533823,false
					]
,					[
						0,
						null,
						false,
						null,
						4864764351101561,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							356857671929052,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									200
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3444488076553666,
							false
							,[
							[
								11,
								"formation_9"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4244967871476581,
							false
							,[
							[
								11,
								"formation_9"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5284292670372886,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4997017237270347,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8678911000978935,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4045195915296557,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7465728485982005,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5718315725140833,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3196017923753571,
							false
							,[
							[
								11,
								"formation_10"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5173192451683281,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							1534103945740165,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									200
								]
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							6955424305968501,
							false
							,[
							[
								1,
								[
									2,
									"Stage_2"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							3896319566534812,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4404081865492422,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"shooter_1"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							19,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							5479867381718021,
							false
							,[
							[
								10,
								2
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3323076366027385,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3899614003816636,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									200
								]
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							6696247511370125,
							false
							,[
							[
								1,
								[
									2,
									"Stage_3"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							3391322885579629,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9645211035585675,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"shooter_2"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							65,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1605984919154731,
							false
							,[
							[
								10,
								2
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1898743768843197,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5606187310154953,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									200
								]
							]
							]
						]
,						[
							79,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							2366770999567166,
							false
							,[
							[
								1,
								[
									2,
									"Stage_4"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.TriggerOnce,
							null,
							0,
							false,
							false,
							false,
							4218724951555047,
							false
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5707593440629515,
							false
							,[
							[
								1,
								[
									2,
									"spawnSingle"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"shooter_3"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												333
											]
,[
												0,
												588
											]
											]
										]
									]
							]
							]
						]
,						[
							66,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							3743053161803677,
							false
							,[
							[
								10,
								2
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_10",
						0,
						0,
true,false,7833971855080566,false
					]
,					[
						0,
						null,
						false,
						null,
						4078692177541921,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5186573838083077,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									220
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1731947858402653,
							false
							,[
							[
								11,
								"formation_10"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2260262342662477,
							false
							,[
							[
								11,
								"formation_10"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1272242571425934,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2790441902917742,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9822125673853324,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2775873963316781,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4740508022813527,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8991465238708905,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5540497061792105,
							false
							,[
							[
								11,
								"formation_11"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6492490690123105,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4157381981837872,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8588584700987984,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2057454816879399,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6610288863555649,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							6341772388394697,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6514622542087261,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							1226817842900658,
							false
						]
						]
					]
,					[
						1,
						"formation_11",
						0,
						0,
true,false,2773814289302469,false
					]
,					[
						0,
						null,
						false,
						null,
						227710766702403,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							4345438786995378,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									240
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3040970672065118,
							false
							,[
							[
								11,
								"formation_11"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							803766594235328,
							false
							,[
							[
								11,
								"formation_11"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8254454548614311,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7070574399235758,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5407831341651832,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2855544698870733,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							466756930424002,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7836443906701465,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2077776760709427,
							false
							,[
							[
								11,
								"formation_12"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_12",
						0,
						0,
true,false,6327749890832108,false
					]
,					[
						0,
						null,
						false,
						null,
						9312653551314978,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							8235613034757221,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									260
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1195185700253667,
							false
							,[
							[
								11,
								"formation_12"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7149774013094655,
							false
							,[
							[
								11,
								"formation_12"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6737059106171206,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5815055241352431,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3286671296020332,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2278260036843973,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9746667614964745,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1924014814536916,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6232218087803699,
							false
							,[
							[
								11,
								"formation_13"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7577105621293824,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2380618141027372,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3376244122629666,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							9151004608132948,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4597345109844643,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4350673505362925,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8989766446178871,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							7527290512658457,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							369426284321883,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6344046118769352,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5635359011625775,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9457028339431322,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							8565809416206596,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7552050828557108,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							8180880647884829,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3581281857491571,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							1297219621593884,
							false
						]
						]
					]
,					[
						1,
						"formation_13",
						0,
						0,
true,false,6144577297163407,false
					]
,					[
						0,
						null,
						false,
						null,
						3321666095415045,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							1281743037782234,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									280
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1239647272139566,
							false
							,[
							[
								11,
								"formation_13"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4889566251043583,
							false
							,[
							[
								11,
								"formation_13"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6520396511630202,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							152311564439923,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7430823605299241,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4081606958068717,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							579973448167466,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1286616816041295,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6685226515371493,
							false
							,[
							[
								11,
								"formation_14"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_14",
						0,
						0,
true,false,5835507700727117,false
					]
,					[
						0,
						null,
						false,
						null,
						4384900864331087,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							319484982599432,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									300
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							4048484439517573,
							false
							,[
							[
								11,
								"formation_14"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7607475047761957,
							false
							,[
							[
								11,
								"formation_14"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							819147183168626,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3043030722495242,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9616799743772976,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9807952614006091,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6779523757861483,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							757763448443403,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8371580123639433,
							false
							,[
							[
								11,
								"formation_15"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5837277171568512,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3638221796733273,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9351706519520354,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4292034115087446,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6535599588351128,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2503450258895196,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3658623713623329,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3638542751071578,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2583023629384724,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							9095075748641257,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5293563330417855,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1723850837404179,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7060454163357194,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							421076363958258,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							8261971658810175,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7194001837273458,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7771209070950402,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8846433897395174,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7074193633976701,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							8823439792699001,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							445730957032354,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							8671055578890999,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6516804797915102,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							247452942797672,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7020381483104645,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							6632139379605787,
							false
						]
						]
					]
,					[
						1,
						"formation_15",
						0,
						0,
true,false,2052817960820037,false
					]
,					[
						0,
						null,
						false,
						null,
						3182655634217938,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6734831068621751,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									320
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8393816434358962,
							false
							,[
							[
								11,
								"formation_15"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7010177125960595,
							false
							,[
							[
								11,
								"formation_15"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9230268769231635,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3287680749599326,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4382630656093039,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6131980376092624,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6408339181932369,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3494959713031749,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5600910167899464,
							false
							,[
							[
								11,
								"formation_16"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_16",
						0,
						0,
true,false,3179013310806399,false
					]
,					[
						0,
						null,
						false,
						null,
						9000692386179215,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							6069144107327655,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									340
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							690396368042983,
							false
							,[
							[
								11,
								"formation_16"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1426603416862448,
							false
							,[
							[
								11,
								"formation_16"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6238346831600737,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2853073983109529,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8886177388308588,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9512609136850203,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8260288781647508,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1898278685498342,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5589683056173788,
							false
							,[
							[
								11,
								"formation_17"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9486164864166225,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7898839298001837,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5669314459965212,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							9077382211319916,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							1072581986778928,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5693775472757087,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7696852519756773,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7579803753478061,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							373312983148942,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							4688916560983204,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3317809628825076,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7502027283734047,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							212976506512847,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							266644576020935,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							6149360442448383,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6442414796705802,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							927846431717258,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5766953654823477,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5579385828410403,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							7628722174715821,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							9507335896655346,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							421476292275019,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5683301304338604,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							1912529028735609,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3312864091083918,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							676281269323565,
							false
						]
						]
					]
,					[
						1,
						"formation_17",
						0,
						0,
true,false,5920718146719603,false
					]
,					[
						0,
						null,
						false,
						null,
						669125115372552,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2640138243431537,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									360
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5945272538842193,
							false
							,[
							[
								11,
								"formation_17"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1011436748333644,
							false
							,[
							[
								11,
								"formation_17"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7724086481243728,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1519249365390234,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							334955531804021,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4841236635794351,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2995655732477991,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8384433679480935,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							346144248327877,
							false
							,[
							[
								11,
								"formation_18"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_18",
						0,
						0,
true,false,7005375686645493,false
					]
,					[
						0,
						null,
						false,
						null,
						1027849547525857,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							8621166028407408,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									380
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7568339971944051,
							false
							,[
							[
								11,
								"formation_18"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7476775060924681,
							false
							,[
							[
								11,
								"formation_18"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1567401774457556,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8006878718416598,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5862098128270226,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1113428374719165,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5974879020958054,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8521545320756499,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6708214096404115,
							false
							,[
							[
								11,
								"formation_19"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4179616271595604,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6702594093915482,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7341066860265131,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7963031035328122,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2915512697627166,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7625888105515391,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8029283007382414,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6207593673316442,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3426978122107538,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							2533105763393025,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7238737489646386,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9152139236291042,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9230123210659157,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2641556657919602,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							2083632916938022,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7509372029933192,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							686423579160097,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6135908286648942,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							1749856360921491,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							9857647595708998,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8012784266901161,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							3842505696905292,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							6929337835704454,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							5055503004657557,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5499877514193148,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							4399995310403469,
							false
						]
						]
					]
,					[
						1,
						"formation_19",
						0,
						0,
true,false,5543038158723578,false
					]
,					[
						0,
						null,
						false,
						null,
						9677741265168698,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							5932833887656044,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									400
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5597619789643198,
							false
							,[
							[
								11,
								"formation_19"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6232411363032816,
							false
							,[
							[
								11,
								"formation_19"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9357961624209103,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3643300496201687,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6735112939810773,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3091277200169328,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5373925456172967,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8052097906631546,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7638713488169646,
							false
							,[
							[
								11,
								"formation_20"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_20",
						0,
						0,
true,false,4251591676986664,false
					]
,					[
						0,
						null,
						false,
						null,
						6301996350464964,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3746154069462986,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									420
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							7362681181013211,
							false
							,[
							[
								11,
								"formation_20"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5607969839470865,
							false
							,[
							[
								11,
								"formation_20"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							53855456329624,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7179234026750728,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6739366598941354,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4871395540123356,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5495918889357351,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2897839225890752,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							858016175831,
							false
							,[
							[
								11,
								"formation_21"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2883772597977831,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2349795676516554,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							8831042819351796,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7706486037205117,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9860663550879188,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							266685176153243,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5805687524248541,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							7934213005800176,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							8768541574921992,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							2331288061295118,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1598636484543354,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7303317808818626,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6541516583242211,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5960893840433543,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							2205914574976003,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							132666086964912,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2319061946023894,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5557446340680017,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7705647944323761,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							1916252831359525,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4271312180932863,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							2717786453438596,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							9871340853986128,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							5831148688907276,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							2873710630137477,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							1788663839338225,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5826375814549179,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							8274132154773694,
							false
						]
						]
					]
,					[
						1,
						"formation_21",
						0,
						0,
true,false,7029054081604252,false
					]
,					[
						0,
						null,
						false,
						null,
						7597076438843248,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2746780760867691,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									440
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6666298770993402,
							false
							,[
							[
								11,
								"formation_21"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1227266783874469,
							false
							,[
							[
								11,
								"formation_21"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							543997129249673,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6824750265931797,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2022298852046945,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7478771160748239,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8043111684858409,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7227956829862536,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4640827426577655,
							false
							,[
							[
								11,
								"formation_22"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_22",
						0,
						0,
true,false,4614857525084261,false
					]
,					[
						0,
						null,
						false,
						null,
						1480094756693274,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							3856578193622297,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									460
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9780820243989665,
							false
							,[
							[
								11,
								"formation_22"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5917875293721399,
							false
							,[
							[
								11,
								"formation_22"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3851064786887978,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7274218827399876,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2520059987116562,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3026482883704024,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1899571136981596,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9490675256231055,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8174625664975967,
							false
							,[
							[
								11,
								"formation_23"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5670420953729042,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1045460899429903,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							917651327440675,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1254656136778021,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							6649260899928094,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							236590426525482,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							970341594228306,
							false
							,[
							[
								4,
								104
							]
,							[
								5,
								[
									2,
									"Interface"
								]
							]
,							[
								0,
								[
									0,
									900
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1408897814933575,
							false
							,[
							[
								0,
								[
									1,
									0.4
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4926898068915594,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9715362937283928,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									333
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							989584737807422,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							8987978965872161,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4256732102536132,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7178594073849986,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							4895055502218499,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							7637785436277917,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							7303712659151816,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8326980947559185,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3082375996667954,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							2540875553750787,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									580
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5494382086726496,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							4845601053228597,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							3159735611550673,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4136375619101123,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"lane_missile"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							9143264774097999,
							false
							,[
							[
								4,
								34
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									0,
									1000
								]
							]
,							[
								0,
								[
									0,
									457
								]
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6897898497991149,
							false
							,[
							[
								1,
								[
									2,
									"LaneMissile"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.MoveToLayer,
							null,
							3098339354361405,
							false
							,[
							[
								5,
								[
									2,
									"Game"
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							4233168974286371,
							false
							,[
							[
								0,
								[
									1,
									1
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							8027230627326188,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							7865864038928011,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							1065270578231147,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							5174286364740688,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							5192633547737843,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8647511305857273,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							104,
							cr.behaviors.Fade.prototype.acts.StartFade,
							"Fade",
							7797192128594023,
							false
						]
						]
					]
,					[
						1,
						"formation_23",
						0,
						0,
true,false,8510235037103057,false
					]
,					[
						0,
						null,
						false,
						null,
						8119586718181555,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							7170253437252942,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									480
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							818816041587362,
							false
							,[
							[
								11,
								"formation_23"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8248814276294343,
							false
							,[
							[
								11,
								"formation_23"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1940042217726124,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6629275934452565,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4445950589167728,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4946646442846932,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5663026579977147,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							280663987360677,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"exploder_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							4622520164353474,
							false
							,[
							[
								11,
								"formation_24"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_24",
						0,
						0,
true,false,4262795832893036,false
					]
,					[
						0,
						null,
						false,
						null,
						8546578322428831,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							287070625886302,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									500
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5370053437701178,
							false
							,[
							[
								11,
								"formation_24"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5323508218278692,
							false
							,[
							[
								11,
								"formation_24"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5136719615372409,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3134494298085059,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											333
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6360903324068191,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							507224474855727,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											457
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1453704363179604,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4726547645029655,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"solid_"
										]
									]
,
									[
										7,
										[
											0,
											1100
										]
									]
,
									[
										7,
										[
											0,
											580
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8070214859008529,
							false
							,[
							[
								11,
								"formation_25"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
,					[
						1,
						"formation_25",
						0,
						0,
true,false,4868422917344883,false
					]
,					[
						0,
						null,
						false,
						null,
						4040578739910835,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Compare,
							null,
							0,
							false,
							false,
							false,
							2724403790334173,
							false
							,[
							[
								7,
								[
									5,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											23,
											"distance_meters"
										]
										]
									]
									,[
										23,
										"distance_start"
									]
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									520
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							8785158216623012,
							false
							,[
							[
								11,
								"formation_25"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3944883915062077,
							false
							,[
							[
								11,
								"formation_25"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4245740817304053,
							false
							,[
							[
								1,
								[
									2,
									"spawnEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"shooter_"
										]
									]
,
									[
										7,
										[
											0,
											1000
										]
									]
,
									[
										7,
										[
											0,
											300
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8088084130267085,
							false
							,[
							[
								11,
								"formation_1"
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4928456149193082,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
						null,
						1,
						false,
						false,
						false,
						9240348898533499,
						false
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						961835008216956,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						833714182911274,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Boss"
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7738322384545743,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"voice_targetdestroyed"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7358397930297713,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											10,
											[
												2,
												"BGM_stage"
											]
											,[
												23,
												"level"
											]
										]
										,[
											2,
											"_boss"
										]
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4466330589330107,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											4,
											[
												23,
												"level"
											]
											,[
												0,
												1
											]
										]
									]
								]
,
								[
									7,
									[
										2,
										"start"
									]
								]
						]
						]
					]
,					[
						34,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						1809723619638283,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						885261369134452,
						false
						,[
						[
							11,
							"level"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						575626248304693,
						false
						,[
						[
							11,
							"cycle"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4507826469581157,
						false
						,[
						[
							11,
							"boss"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						801949670568321,
						false
						,[
						[
							11,
							"distance_start"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									23,
									"distance_meters"
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9010557254184657,
						false
						,[
						[
							11,
							"levelchanged"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						95,
						cr.plugins_.Particles.prototype.acts.Destroy,
						null,
						1337275913653023,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8043018750304799,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8534041112096061,
							false
							,[
							[
								10,
								6
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1717813699586719,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												10,
												[
													2,
													"BGM_stage"
												]
												,[
													23,
													"level"
												]
											]
											,[
												2,
												"_boss"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9516371763644246,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												2,
												"BGM_stage"
											]
											,[
												23,
												"level"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
,						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							6962116838750137,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							15,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							6951218636663315,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							1167892552158734,
							false
						]
,						[
							34,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							2219071696184955,
							false
						]
,						[
							74,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							6791196159939974,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1916216596724693,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"BGM_victoryshort"
										]
									]
,
									[
										7,
										[
											2,
											"start_nonloop"
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9068727365219928,
							false
							,[
							[
								1,
								[
									2,
									"closeGameOver"
								]
							]
,							[
								13,
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8613792876121309,
							false
							,[
							[
								1,
								[
									2,
									"closePaused"
								]
							]
,							[
								13,
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							1145167754146572,
							false
							,[
							[
								1,
								[
									2,
									"Ending"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetLayerVisible,
							null,
							9355850492684126,
							false
							,[
							[
								5,
								[
									2,
									"Ending"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							75,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							8526764533755877,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5567115695837978,
							false
							,[
							[
								4,
								73
							]
,							[
								5,
								[
									2,
									"Ending"
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							73,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4210750492906875,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6985363817581753,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												10,
												[
													2,
													"BGM_stage"
												]
												,[
													23,
													"level"
												]
											]
											,[
												2,
												"_boss"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5289791928595243,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												2,
												"BGM_stage"
											]
											,[
												23,
												"level"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8638428180936548,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2953247099046848,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"BGM_ending"
										]
									]
,
									[
										7,
										[
											2,
											"start"
										]
									]
							]
							]
						]
,						[
							85,
							cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
							"DragDrop",
							3199648299123609,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.SetGroupActive,
							null,
							7599150484467414,
							false
							,[
							[
								1,
								[
									2,
									"GameLoop"
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							73,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2729628686908344,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							73,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							3463967255446977,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							73,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							7402436328945823,
							false
						]
,						[
							74,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							8113677015959296,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							74,
							cr.plugins_.Sprite.prototype.acts.MoveToTop,
							null,
							1457791073553886,
							false
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3265768464789766,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												10,
												[
													2,
													"BGM_stage"
												]
												,[
													23,
													"level"
												]
											]
											,[
												2,
												"_boss"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7644847879164805,
							false
							,[
							[
								1,
								[
									2,
									"handleMusic"
								]
							]
,							[
								13,
																	[
										7,
										[
											10,
											[
												2,
												"BGM_stage"
											]
											,[
												23,
												"level"
											]
										]
									]
,
									[
										7,
										[
											2,
											"stop"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7504435604424952,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.OnFunction,
						null,
						2,
						false,
						false,
						false,
						2948115458195926,
						false
						,[
						[
							1,
							[
								2,
								"spawnEnemy"
							]
						]
						]
					]
					],
					[
					[
						54,
						cr.plugins_.Rex_Nickname.prototype.acts.CreateInsts,
						null,
						2775352899605345,
						false
						,[
						[
							1,
							[
								10,
								[
									20,
									11,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										0
									]
									]
								]
								,[
									23,
									"level"
								]
							]
						]
,						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
,						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									2
								]
								]
							]
						]
,						[
							7,
							[
								2,
								"Game"
							]
						]
,						[
							4,
							152
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						6090845222856927,
						false
						,[
						[
							4,
							24
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									80
								]
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									150
								]
							]
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1235039644183215,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						24,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						9939090431505249,
						false
						,[
						[
							4,
							152
						]
,						[
							3,
							0
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						8877160861921778,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1946309163667082,
						false
						,[
						[
							4,
							24
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									80
								]
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									150
								]
							]
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2497583857517424,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						24,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						6170467153461316,
						false
						,[
						[
							4,
							152
						]
,						[
							3,
							0
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6688197582358477,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7831649417408083,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1955237193397473,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Exploder"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8324290904469305,
							false
							,[
							[
								0,
								[
									0,
									115
								]
							]
,							[
								0,
								[
									0,
									115
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3666931940800533,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							609430965390009,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Solid"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							1345566997772622,
							false
							,[
							[
								0,
								[
									0,
									115
								]
							]
,							[
								0,
								[
									0,
									115
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8732466104500081,
						[
						[
							11,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							5499252559241936,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"boss_"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							9275455844751242,
							false
							,[
							[
								10,
								8
							]
,							[
								7,
								[
									0,
									4
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9187208665156671,
							[
							[
								55,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								7867240113354981,
								false
							]
							],
							[
							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								6835215775062173,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										0,
										5000
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1754547103724499,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										0,
										5000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1560088779038698,
							[
							[
								61,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								6850134929070493,
								false
							]
							],
							[
							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2238189280324641,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										0,
										20000
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								6720231813205815,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										0,
										20000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							63925593410648,
							[
							[
								62,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								7495077487034018,
								false
							]
							],
							[
							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								4689943778174828,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										0,
										40000
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1142116546505693,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										0,
										40000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8413266134071047,
							[
							[
								90,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								false,
								false,
								9747467154875506,
								false
							]
							],
							[
							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5040082466406848,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										0,
										80000
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								569223659051022,
								false
								,[
								[
									10,
									1
								]
,								[
									7,
									[
										0,
										80000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4814347320294862,
							[
							[
								-1,
								cr.system_object.prototype.cnds.For,
								null,
								0,
								true,
								false,
								false,
								8703313712483628,
								false
								,[
								[
									1,
									[
										2,
										""
									]
								]
,								[
									0,
									[
										0,
										1
									]
								]
,								[
									0,
									[
										21,
										152,
										false,
										null
										,8
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6622552212437161,
								false
								,[
								[
									4,
									81
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.loopindex
									]
								]
								]
							]
,							[
								81,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								5944326309278403,
								false
								,[
								[
									4,
									152
								]
,								[
									3,
									0
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5905036443338968,
								false
								,[
								[
									1,
									[
										2,
										"BossLight"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								765572162689348,
								false
								,[
								[
									4,
									24
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											81,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											80
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											81,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											50
										]
									]
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								3997752416192034,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								24,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								7664087310642929,
								false
								,[
								[
									4,
									152
								]
,								[
									3,
									0
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1613663143920158,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										81,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3697068224052905,
								false
								,[
								[
									4,
									24
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											81,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											80
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											81,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											50
										]
									]
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								4172571047149794,
								false
								,[
								[
									0,
									[
										0,
										1
									]
								]
								]
							]
,							[
								24,
								cr.behaviors.Pin.prototype.acts.Pin,
								"Pin",
								6888356476056774,
								false
								,[
								[
									4,
									152
								]
,								[
									3,
									0
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5121652298023581,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										20,
										81,
										cr.plugins_.Sprite.prototype.exps.UID,
										false,
										null
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7385668650358179,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.OnFunction,
						null,
						2,
						false,
						false,
						false,
						9020476781970949,
						false
						,[
						[
							1,
							[
								2,
								"spawnSingle"
							]
						]
						]
					]
					],
					[
					[
						54,
						cr.plugins_.Rex_Nickname.prototype.acts.CreateInsts,
						null,
						2151276278247646,
						false
						,[
						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
,						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									2
								]
								]
							]
						]
,						[
							7,
							[
								2,
								"Game"
							]
						]
,						[
							4,
							152
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						5581777515234572,
						false
						,[
						[
							4,
							24
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									80
								]
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									150
								]
							]
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8675603726968339,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						24,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						414866046181439,
						false
						,[
						[
							4,
							152
						]
,						[
							3,
							0
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						5532873155793279,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						1190646921253704,
						false
						,[
						[
							4,
							24
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									80
								]
							]
						]
,						[
							0,
							[
								5,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
								,[
									0,
									150
								]
							]
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5302947884527388,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						24,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						2117837476777305,
						false
						,[
						[
							4,
							152
						]
,						[
							3,
							0
						]
						]
					]
,					[
						24,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						9184826697014261,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.UID,
								false,
								null
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9351510119510927,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						2208340130176825,
						false
						,[
						[
							4,
							37
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5084646305657433,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1623914344846841,
							false
							,[
							[
								10,
								8
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4605353233017984,
							false
							,[
							[
								1,
								[
									2,
									"hitEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													50000
												]
,[
													0,
													60000
												]
												]
											]
											]
										]
									]
,
									[
										7,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2687309996953973,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						2697160375358582,
						false
						,[
						[
							4,
							152
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
						null,
						6703237348315815,
						false
						,[
						[
							10,
							8
						]
,						[
							7,
							[
								20,
								81,
								cr.plugins_.Sprite.prototype.exps.Count,
								false,
								null
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.ConsoleLog,
						null,
						6522958291961395,
						false
						,[
						[
							3,
							0
						]
,						[
							7,
							[
								10,
								[
									2,
									"number of lights: "
								]
								,[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.Count,
									false,
									null
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						2844259346421828,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1333851439508554,
							false
							,[
							[
								10,
								8
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.MoveForward,
							null,
							8454862309867546,
							false
							,[
							[
								0,
								[
									0,
									5
								]
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6238974333568335,
							false
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9540991435880429,
							false
							,[
							[
								1,
								[
									2,
									"hitEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											21,
											17,
											false,
											null
											,0
										]
									]
,
									[
										7,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.UID,
											false,
											null
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1228875490622388,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							1476010198189561,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Rocket_"
									]
									,[
										23,
										"suit"
									]
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5549795483289894,
							false
							,[
							[
								10,
								8
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							94,
							cr.behaviors.scrollto.prototype.acts.Shake,
							"ScrollTo",
							7084126499291135,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
,							[
								0,
								[
									1,
									2
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							105396261620248,
							false
							,[
							[
								4,
								22
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							22,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							730857560241304,
							false
							,[
							[
								1,
								[
									2,
									"default"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							638566153676529,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"collision"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9077860939891598,
					[
					[
						17,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						7163103739489493,
						false
						,[
						[
							4,
							81
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
						null,
						0,
						false,
						false,
						false,
						3032348550390879,
						false
						,[
						[
							1,
							[
								2,
								"BossLight"
							]
						]
						]
					]
					],
					[
					[
						17,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						8903503953167504,
						false
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						1401954734247248,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								21,
								17,
								false,
								null
								,0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						550732471313381,
						false
						,[
						[
							4,
							102
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						102,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						717698597485792,
						false
						,[
						[
							4,
							152
						]
,						[
							3,
							0
						]
						]
					]
,					[
						102,
						cr.behaviors.Fade.prototype.acts.RestartFade,
						"Fade",
						1735767241833276,
						false
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						1392528314740137,
						[
						[
							17,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							2812482095203807,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Rocket_"
									]
									,[
										23,
										"suit"
									]
								]
							]
							]
						]
						],
						[
						[
							94,
							cr.behaviors.scrollto.prototype.acts.Shake,
							"ScrollTo",
							8927424548632534,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
,							[
								0,
								[
									1,
									2
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.Spawn,
							null,
							2518145569097083,
							false
							,[
							[
								4,
								22
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							22,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9671850487367353,
							false
							,[
							[
								1,
								[
									2,
									"default"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6383649668862568,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"collision"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6185649013682837,
						[
						],
						[
						]
					]
,					[
						0,
						null,
						false,
						null,
						4934363625882504,
						[
						[
							81,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8085916496255682,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9242122033650355,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							4,
							cr.plugins_.Browser.prototype.acts.ConsoleLog,
							null,
							522543917942288,
							false
							,[
							[
								3,
								0
							]
,							[
								7,
								[
									2,
									"SUBTRACT ONE FROM LIGHTS!"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							2855142622107725,
							false
							,[
							[
								10,
								8
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							81,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6830598726839569,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							5876548928977902,
							false
						]
,						[
							81,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							2397243671153635,
							false
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1562253726064751,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenade_explosion"
										]
									]
							]
							]
						]
,						[
							94,
							cr.behaviors.scrollto.prototype.acts.Shake,
							"ScrollTo",
							1777965235681062,
							false
							,[
							[
								0,
								[
									0,
									10
								]
							]
,							[
								0,
								[
									1,
									2
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							249546690356485,
							false
							,[
							[
								4,
								22
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							22,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9138475031271055,
							false
							,[
							[
								1,
								[
									2,
									"default"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							50279567173612,
							false
							,[
							[
								4,
								95
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							95,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							4024906705913963,
							false
							,[
							[
								4,
								152
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9415401378878766,
						[
						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3446043392436165,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							24,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							1138168100266026,
							false
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							1531730108367678,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							2232763119113764,
							false
							,[
							[
								0,
								[
									0,
									100
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							1694764861553912,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7520248359663247,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								true,
								false,
								4232233894163747,
								false
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8170945990345393,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								9302447522039264,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9257557857341544,
							[
							[
								24,
								cr.plugins_.Sprite.prototype.cnds.CompareFrame,
								null,
								0,
								false,
								false,
								false,
								9685507222734325,
								false
								,[
								[
									8,
									0
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetWidth,
								null,
								222752878748272,
								false
								,[
								[
									0,
									[
										6,
										[
											0,
											135
										]
										,[
											7,
											[
												21,
												81,
												false,
												null
												,0
											]
											,[
												21,
												81,
												false,
												null
												,1
											]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3295572181202968,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8988438005515241,
								false
								,[
								[
									0,
									[
										1,
										0.5
									]
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								4550200898294855,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					1,
					"grenadedmg",
					0,
					0,
false,false,7520228455192174,false
				]
,				[
					0,
					null,
					false,
					null,
					9214339872403148,
					[
					[
						34,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						3972930137779738,
						false
						,[
						[
							4,
							37
						]
						]
					]
					],
					[
					[
						34,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						6308330497313455,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3419419112584507,
					[
					[
						81,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						7011904125775951,
						false
						,[
						[
							4,
							37
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3933994806318634,
						false
						,[
						[
							11,
							"grenadedmg"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									19,
									cr.system_object.prototype.exps.random
									,[
[
										0,
										50000
									]
,[
										0,
										60000
									]
									]
								]
								]
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						4397261550916945,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								23,
								"grenadedmg"
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						6025658408017406,
						[
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							5232325539771737,
							false
							,[
							[
								4,
								102
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							102,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							5731077472153904,
							false
							,[
							[
								4,
								152
							]
,							[
								3,
								0
							]
							]
						]
,						[
							102,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							4788789359659861,
							false
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1166800337083944,
						[
						[
							81,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9355654637906892,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3644366593914977,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							4,
							cr.plugins_.Browser.prototype.acts.ConsoleLog,
							null,
							9611568588949629,
							false
							,[
							[
								3,
								0
							]
,							[
								7,
								[
									2,
									"SUBTRACT ONE FROM LIGHTS!"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
							null,
							6737713066828125,
							false
							,[
							[
								10,
								8
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							81,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							4879078364896813,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							8447685033844906,
							false
						]
,						[
							81,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							6609626969672742,
							false
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							612194307852071,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"grenade_explosion"
										]
									]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							401558674837164,
							false
							,[
							[
								4,
								95
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
							]
,							[
								0,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							95,
							cr.behaviors.Pin.prototype.acts.Pin,
							"Pin",
							7378096615285729,
							false
							,[
							[
								4,
								152
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						496469692737718,
						[
						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3109255556324088,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									81,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							24,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							7721865337507333,
							false
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2842507091763797,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							7670847881709103,
							false
							,[
							[
								0,
								[
									0,
									100
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							true,
							null,
							825570450699216,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								4911795699894821,
								false
								,[
								[
									10,
									8
								]
,								[
									8,
									3
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.cnds.IsVisible,
								null,
								0,
								false,
								true,
								false,
								6976819097691251,
								false
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8018469240530551,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								1338912065969269,
								false
								,[
								[
									3,
									1
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9386052903736101,
							[
							[
								24,
								cr.plugins_.Sprite.prototype.cnds.CompareFrame,
								null,
								0,
								false,
								false,
								false,
								1729832707202356,
								false
								,[
								[
									8,
									0
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetWidth,
								null,
								7631403765285652,
								false
								,[
								[
									0,
									[
										6,
										[
											0,
											135
										]
										,[
											7,
											[
												21,
												81,
												false,
												null
												,0
											]
											,[
												21,
												81,
												false,
												null
												,1
											]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4391921714955718,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3858256318607507,
								false
								,[
								[
									0,
									[
										1,
										0.5
									]
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								9372142107026133,
								false
								,[
								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4630833563452662,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,
						null,
						1,
						false,
						false,
						false,
						9307372740199503,
						false
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1879491802406959,
						false
						,[
						[
							1,
							[
								2,
								"idle"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6467184920391161,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						9506355084270013,
						false
						,[
						[
							0,
							[
								1,
								0.5
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1821812686497569,
						[
						[
							19,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							9534522433069622,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9968828737741571,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Shooter"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							3909993578795373,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							6670560573359152,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9090985059490284,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9023546506287355,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8165750464383238,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9382034390590638,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								5716895696102037,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7227726779300815,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3066880238631302,
								false
								,[
								[
									1,
									[
										2,
										"shooter_1"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2189744110080545,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								4984007976794916,
								false
								,[
								[
									0,
									[
										1,
										0.8
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2057748639636284,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								3328385807831419,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5738283175874227,
								false
								,[
								[
									1,
									[
										2,
										"spawnSingle"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"exploder_2"
											]
										]
,
										[
											7,
											[
												0,
												1000
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													333
												]
,[
													0,
													588
												]
												]
											]
										]
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								3070266771929772,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								3767838064855337,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									19
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7815129199680234,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								3139086225055584,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								247738040317462,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									9531626741459041,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									9194168848328873,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									151187542445287,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2828977118133168,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7618383514456056,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									2943125489559659,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									7224837601189444,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									2685310126438697,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									5847963186480782,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									370829797311166,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									7876173529695171,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8530186270106878,
						[
						[
							19,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							1525651794259769,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2381793250078321,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							9122330532471896,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							2599027766586338,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							8938287612718471,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7300706840915265,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								6585469176448138,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6346039011494744,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								683615600806702,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6138084500921024,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6125738188661191,
								false
								,[
								[
									1,
									[
										2,
										"shooter_1"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2251254148165756,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								1797527352813747,
								false
								,[
								[
									0,
									[
										1,
										0.8
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2455894527633206,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								6295771576441435,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								6512144941023806,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									3494698770952278,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									2430009747229337,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									601339130824165,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									8272013847058294,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3083779917508658,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									4879421952846643,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									3757779725868297,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									5355296312567769,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8517614786778239,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4792129904695619,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2611778465939561,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					488287993534834,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						9086372398310216,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						5150099081770968,
						[
						[
							65,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							6249876884173863,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1014454426876986,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Shooter"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							8371487515661147,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							9831714254873116,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							8681354872617331,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								2126709152388663,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								915932807211178,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4998921864753092,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								8498128031832462,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								681208930073902,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7832027906242359,
								false
								,[
								[
									1,
									[
										2,
										"shooter_2"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8048778942948046,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7636252123122704,
								false
								,[
								[
									0,
									[
										1,
										1.5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5843259222999854,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									5051476415256377,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									5616543882809877,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									4536502533899226,
									false
									,[
									[
										4,
										38
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									7890408727668668,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4705532733324219,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8970651087000211,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									6035447824947962,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									659707835784779,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_shoot"
												]
											]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							536245884653086,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								2617475392675512,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6039668840604841,
								false
								,[
								[
									1,
									[
										2,
										"spawnSingle"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"exploder_2"
											]
										]
,
										[
											7,
											[
												0,
												1000
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													333
												]
,[
													0,
													588
												]
												]
											]
										]
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								5663402212872309,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								560525938923452,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									65
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8097119217985783,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								7958004569301883,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								231874636789466,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4110394749872169,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									9652610881114113,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6289491270758047,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									7462266863926906,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3114938394636985,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									8903766497489186,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4577745846189452,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									435079289160204,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									1214268871859101,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									6886531222357694,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									5172300834325057,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						524638783658288,
						[
						[
							65,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							4469203204637809,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9143396507570118,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							4356559716570882,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							5076846868087572,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3820093776451038,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								9484132803766282,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								8575625909603711,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7458077733685217,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								1558661656717559,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9362018988606168,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4498791925521445,
								false
								,[
								[
									1,
									[
										2,
										"shooter_2"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8207820214008054,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								1749181958372694,
								false
								,[
								[
									0,
									[
										1,
										1.5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9618716839258236,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									7337574807855668,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									483828593839635,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									1821264893097328,
									false
									,[
									[
										4,
										38
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8643936440441799,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									501790637035963,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3162208281600961,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2780973856723227,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									9624194553933181,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_shoot"
												]
											]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							234919332446794,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								8275868348498452,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								6876093366942787,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4737091820493628,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									5168896132903327,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									3364635309861125,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									1006010002882555,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								2010138698459452,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									4300301303812119,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									3253326914733398,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									8915149494079735,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									1693114264830048,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9667330196976984,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									9286557874722395,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9665068092509366,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						846277491502436,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						9104459466802206,
						[
						[
							66,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							6405942726296934,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							931480750028351,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Shooter"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							559810215964982,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							9419136125530935,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7157417170450424,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								6425100955443869,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								390281809760315,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								116694918034747,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7988912865520145,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6358658133712535,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6274456854686404,
								false
								,[
								[
									1,
									[
										2,
										"shooter_3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3924248040727631,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9237205886186132,
								false
								,[
								[
									1,
									[
										2,
										"shooter_3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1961136343776097,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_lasersmall"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5156471294791933,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								7471776303416535,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9821415614454209,
								false
								,[
								[
									1,
									[
										2,
										"spawnSingle"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"exploder_2"
											]
										]
,
										[
											7,
											[
												0,
												1000
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													333
												]
,[
													0,
													588
												]
												]
											]
										]
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4869376923621051,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								6249248343967329,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									66
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8685025782270714,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								7624767182974344,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								1255127189435286,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4509904028482147,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									9126071169148046,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									8912871396225177,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									9014331302960561,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								3989767772709375,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									4602346698443258,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									2473491561308862,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									1832904200726363,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									274222816131937,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									4012222134109803,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									3928683612846242,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5387827804784951,
						[
						[
							66,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							6074616354727228,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1239216644022529,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Minion"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							1517276282889648,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							7746569148720911,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							6478442933763875,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7718948555849716,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								6862410609844565,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6972125232052235,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7529602159039316,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7874720253419075,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								1680920103315173,
								false
								,[
								[
									1,
									[
										2,
										"shooter_3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								3614566992230877,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											90
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7228206361845941,
								false
								,[
								[
									1,
									[
										2,
										"shooter_3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8068726560868601,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_lasersmall"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5048468191108077,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								2532193772254779,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								1579681047449779,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									8066900886442,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									2731695623480539,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									197523883154946,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									3439590977687166,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								1415513936950751,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									6353009488788828,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									1787923540301731,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									7404426692856409,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									5423158524536617,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									8772488922249835,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									378487197649501,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9148072793796043,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						5749007085082321,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						1226728692182066,
						[
						[
							91,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							8664674040188395,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6777578400134493,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Shooter"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							3738696900492426,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							9126674381345499,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							6457432360728504,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								7725536256831792,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								7887489436216536,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5565437899552226,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								4232763355749419,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6369331618059613,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_laser"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								321984713598575,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											200
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2416695406021981,
								false
								,[
								[
									1,
									[
										2,
										"shooter_4"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6966890495274609,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2753868329020728,
								false
								,[
								[
									1,
									[
										2,
										"shooter_4"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								828178099996612,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											200
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9597086750398428,
								false
								,[
								[
									1,
									[
										2,
										"shooter_4"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								9604043536987537,
								false
								,[
								[
									0,
									[
										1,
										1.5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								6933888666383971,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									754015966866484,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2248164394269485,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									5085567635772468,
									false
									,[
									[
										4,
										38
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									2305908685300261,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_lasersmall"
												]
											]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8799320480059535,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									8724740003592824,
									false
									,[
									[
										1,
										[
											2,
											"LaneMissile"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.MoveToLayer,
									null,
									1157185983607584,
									false
									,[
									[
										5,
										[
											2,
											"Game"
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6454568527764496,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								6912244478832358,
								false
								,[
								[
									0,
									[
										1,
										2
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6962627770522114,
								false
								,[
								[
									1,
									[
										2,
										"spawnSingle"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"exploder_2"
											]
										]
,
										[
											7,
											[
												0,
												1000
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps.random
												,[
[
													0,
													333
												]
,[
													0,
													588
												]
												]
											]
										]
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.SetCollisions,
								null,
								4212604129305375,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								63,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								9202620565576166,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									91
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3304670836172414,
							[
							[
								17,
								cr.plugins_.Sprite.prototype.cnds.OnCollision,
								null,
								0,
								false,
								false,
								true,
								899988708320233,
								false
								,[
								[
									4,
									152
								]
								]
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								2491778846203416,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4686436443824956,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.MoveForward,
									null,
									1079895821962952,
									false
									,[
									[
										0,
										[
											0,
											5
										]
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									9204524184709292,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									4022882395058114,
									false
									,[
									[
										1,
										[
											2,
											"hitEnemy"
										]
									]
,									[
										13,
																					[
												7,
												[
													21,
													17,
													false,
													null
													,0
												]
											]
,
											[
												7,
												[
													20,
													152,
													cr.plugins_.Sprite.prototype.exps.UID,
													false,
													null
												]
											]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								8120773885620736,
								[
								[
									17,
									cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
									null,
									0,
									false,
									false,
									false,
									921188510226656,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Rocket_"
											]
											,[
												23,
												"suit"
											]
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									7187153172419861,
									false
									,[
									[
										10,
										8
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									1367954451808559,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											2
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									17,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									4513879108113489,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9528674131904315,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									645965664160627,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"collision"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					489653228682314,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						887500567787485,
						false
						,[
						[
							0,
							[
								1,
								0.5
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7920354482231397,
						[
						[
							55,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							626499144659986,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3932986502294998,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							9844197595656048,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							8207169278624407,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3023648728655719,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								5603416216365004,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5738005343821654,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5524725945796806,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3929823573230061,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4741045601207424,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9164862771968624,
								false
								,[
								[
									1,
									[
										10,
										[
											10,
											[
												21,
												152,
												true,
												null
												,2
											]
											,[
												2,
												"_"
											]
										]
										,[
											23,
											"level"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8950725141483703,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								7041621429770999,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					245137226160494,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						9101443534462524,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						249775889781134,
						[
						[
							61,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							3142391442501096,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5478575528054965,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							962603621556617,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							3696022027708654,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7627177505919093,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								396871466149782,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								9031405719970765,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2795130797987253,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								8139853234734888,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											30
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9909886045122982,
								false
								,[
								[
									1,
									[
										10,
										[
											10,
											[
												21,
												152,
												true,
												null
												,2
											]
											,[
												2,
												"_"
											]
										]
										,[
											23,
											"level"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								294895419159661,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											30
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7225357050919012,
								false
								,[
								[
									1,
									[
										10,
										[
											10,
											[
												21,
												152,
												true,
												null
												,2
											]
											,[
												2,
												"_"
											]
										]
										,[
											23,
											"level"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8126332937038614,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_laser"
											]
										]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								5537967322529479,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7778715154031152,
								false
								,[
								[
									0,
									[
										1,
										1.5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								4271581756387227,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									6179080697077503,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
									null,
									529924332211827,
									false
									,[
									[
										10,
										4
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									8347326769945404,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									7872555131326066,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9490475292186171,
									false
									,[
									[
										1,
										[
											10,
											[
												10,
												[
													21,
													152,
													true,
													null
													,2
												]
												,[
													2,
													"_"
												]
											]
											,[
												23,
												"level"
											]
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3474142874391598,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												180
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9571085634243217,
									false
									,[
									[
										1,
										[
											10,
											[
												10,
												[
													21,
													152,
													true,
													null
													,2
												]
												,[
													2,
													"_"
												]
											]
											,[
												23,
												"level"
											]
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									2923717049647609,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												180
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									799331786868385,
									false
									,[
									[
										1,
										[
											10,
											[
												10,
												[
													21,
													152,
													true,
													null
													,2
												]
												,[
													2,
													"_"
												]
											]
											,[
												23,
												"level"
											]
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									7880400486266537,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_laser"
												]
											]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									7130738799091906,
									false
									,[
									[
										3,
										0
									]
,									[
										4,
										105
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7787586887447043,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						3119079388434901,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2419917971259618,
						[
						[
							62,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							3111996843576575,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3196137653874287,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							72166759969857,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							1634612175778908,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							587600055477894,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								4906998277404048,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5712582402636239,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2158072656555068,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6295064527306561,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								5620260543023218,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointY,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7472633208677294,
								false
								,[
								[
									1,
									[
										2,
										"boss_3"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3035082630601739,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_nuke"
											]
										]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8702568339373735,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7990559301053738,
								false
								,[
								[
									0,
									[
										1,
										2
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9996777664668083,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									5782051370620868,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									7336869659614168,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									8601838220310738,
									false
									,[
									[
										4,
										38
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									4116647209905641,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_shoot"
												]
											]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									377203451848306,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												140
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9406694106721377,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									6322207089442298,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											4,
											[
												20,
												152,
												cr.plugins_.Sprite.prototype.exps.ImagePointY,
												false,
												null
												,[
[
													0,
													1
												]
												]
											]
											,[
												0,
												140
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									2924701461205046,
									false
									,[
									[
										1,
										[
											2,
											"shooter_2"
										]
									]
,									[
										3,
										1
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9236942556908398,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						4747879503685632,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4389974668693916,
						[
						[
							90,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							8619229088189244,
							false
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6011930482590278,
							false
							,[
							[
								10,
								2
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"Boss"
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							true,
							false,
							7096428485318624,
							false
							,[
							[
								1,
								[
									2,
									"Death"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.AddInstanceVar,
							null,
							704569725305603,
							false
							,[
							[
								10,
								4
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							1042401637015278,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								115017050863774,
								false
								,[
								[
									10,
									4
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										3
									]
								]
								]
							]
							],
							[
							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2168681762703967,
								false
								,[
								[
									10,
									4
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9643154268474636,
								false
								,[
								[
									1,
									[
										2,
										"shoot"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								4267438931800359,
								false
								,[
								[
									4,
									38
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4247500883693517,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											140
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								4876013058931501,
								false
								,[
								[
									1,
									[
										10,
										[
											10,
											[
												21,
												152,
												true,
												null
												,2
											]
											,[
												2,
												"_"
											]
										]
										,[
											23,
											"level"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								7337749319103724,
								false
								,[
								[
									4,
									34
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.ImagePointX,
										false,
										null
										,[
[
											0,
											1
										]
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
										,[
											0,
											140
										]
									]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								217660108231388,
								false
								,[
								[
									1,
									[
										10,
										[
											10,
											[
												21,
												152,
												true,
												null
												,2
											]
											,[
												2,
												"_"
											]
										]
										,[
											23,
											"level"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1346389478677264,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"enemy_shoot"
											]
										]
								]
								]
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								8203683280588139,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8207026939358999,
								false
								,[
								[
									0,
									[
										1,
										1.5
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								9037329887714641,
								[
								[
									152,
									cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									true,
									false,
									2824632814081488,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										3
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								],
								[
								[
									152,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									6000974838599875,
									false
									,[
									[
										1,
										[
											2,
											"shoot"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									5833673426046696,
									false
									,[
									[
										4,
										38
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										7,
										[
											0,
											1
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									3721298659859894,
									false
									,[
									[
										4,
										34
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointX,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
,									[
										0,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.ImagePointY,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									6014047268868091,
									false
									,[
									[
										1,
										[
											10,
											[
												10,
												[
													21,
													152,
													true,
													null
													,2
												]
												,[
													2,
													"_"
												]
											]
											,[
												23,
												"level"
											]
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									1219498491437094,
									false
									,[
									[
										3,
										0
									]
,									[
										4,
										105
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									5368101206278293,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"enemy_laser"
												]
											]
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2507117349910643,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,
						null,
						1,
						false,
						false,
						false,
						2269848124051006,
						false
						,[
						[
							1,
							[
								2,
								"Death"
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4776278175269076,
						false
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						7011027877304491,
						false
						,[
						[
							1,
							[
								2,
								"kills_overall"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"kills_overall"
										]
										]
									]
									]
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						26937958151319,
						false
						,[
						[
							11,
							"kills"
						]
,						[
							7,
							[
								4,
								[
									23,
									"kills"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3769256260711532,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							253234598491449,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.CreateObject,
							null,
							3112375015921957,
							false
							,[
							[
								4,
								8
							]
,							[
								5,
								[
									2,
									"Game"
								]
							]
,							[
								0,
								[
									4,
									[
										20,
										152,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
									,[
										0,
										300
									]
								]
							]
,							[
								0,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.Y,
									false,
									null
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							8275652432545612,
							false
							,[
							[
								0,
								[
									0,
									40
								]
							]
,							[
								0,
								[
									0,
									40
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							9819283040149559,
							false
							,[
							[
								1,
								[
									2,
									"dropped"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							3628702450781272,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								152
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							4155920700444166,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								14
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							1712058490281199,
							false
							,[
							[
								3,
								0
							]
,							[
								4,
								105
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							3721176315429202,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								350147035721703,
								false
								,[
								[
									10,
									2
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Shooter"
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7188679015066472,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"CoinDrop"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								5056503379087873,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											347
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											23
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								3215855438796374,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9833499749810963,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9768910042836071,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											376
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											19
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								5010983958901582,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7358090574802629,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								3849982759353918,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									152
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								7981080926575127,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									14
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								6406618063226328,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8103692564542984,
							[
							[
								152,
								cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
								null,
								0,
								false,
								false,
								false,
								236281190418678,
								false
								,[
								[
									10,
									2
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"Boss"
									]
								]
								]
							]
							],
							[
							[
								95,
								cr.plugins_.Particles.prototype.acts.Destroy,
								null,
								3063315605327231,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4253206790672098,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"CoinDrop"
											]
										]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								2225833657175895,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											347
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											23
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								2239303681055557,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								283276946405919,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								6012499292934946,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											376
										]
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											19
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								3316293904294305,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5120208623088943,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								1751198862940857,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											422
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											21
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								6708370967213916,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3183152195521524,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								9891657101873048,
								false
								,[
								[
									4,
									8
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										4,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											478
										]
									]
								]
,								[
									0,
									[
										5,
										[
											20,
											152,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
										,[
											0,
											6
										]
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								799601450408589,
								false
								,[
								[
									0,
									[
										0,
										40
									]
								]
,								[
									0,
									[
										0,
										40
									]
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								6099639714058067,
								false
								,[
								[
									1,
									[
										2,
										"dropped"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								4284568676717706,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									152
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								7120038106288741,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									14
								]
								]
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								9618205781452048,
								false
								,[
								[
									3,
									0
								]
,								[
									4,
									105
								]
								]
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.Destroy,
								null,
								4654823735876039,
								false
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					104292095573964,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.OnFunction,
						null,
						2,
						false,
						false,
						false,
						8120853321551175,
						false
						,[
						[
							1,
							[
								2,
								"destroyEnemy"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						7082179069391594,
						false
						,[
						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4869790830756771,
						false
						,[
						[
							1,
							[
								2,
								"Death"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						9898976256943791,
						false
						,[
						[
							4,
							22
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.X,
								false,
								null
							]
						]
,						[
							0,
							[
								20,
								152,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						22,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						8918338143152124,
						false
						,[
						[
							1,
							[
								2,
								"default"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						1357278856176439,
						false
						,[
						[
							1,
							[
								2,
								"kills_overall"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"kills_overall"
										]
										]
									]
									]
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3685462103872243,
						false
						,[
						[
							11,
							"kills"
						]
,						[
							7,
							[
								4,
								[
									23,
									"kills"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6955030734866327,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"enemy_death"
									]
								]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectEnabled,
						null,
						7158887212367745,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								2,
								"Tint"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						775853265974751,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						1969590606954703,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								1
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						2244045938867417,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								2
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7634242803297102,
						[
						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8710628381172471,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									152,
									cr.plugins_.Sprite.prototype.exps.UID,
									false,
									null
								]
							]
							]
						]
						],
						[
						[
							24,
							cr.plugins_.Sprite.prototype.acts.Destroy,
							null,
							2231510464558907,
							false
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8595798922147108,
							false
							,[
							[
								0,
								[
									1,
									0.2
								]
							]
							]
						]
,						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetEffectEnabled,
							null,
							1522538009598714,
							false
							,[
							[
								3,
								0
							]
,							[
								1,
								[
									2,
									"Tint"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8283184339271862,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2109749864903048,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.AddVar,
							null,
							7001163094688767,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									0,
									10
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7186428055591672,
							[
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6066121188708375,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold"
											]
										]
,
										[
											7,
											[
												23,
												"gold_collected"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2963348310589069,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.OnFunction,
						null,
						2,
						false,
						false,
						false,
						7888676881047559,
						false
						,[
						[
							1,
							[
								2,
								"hitEnemy"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.PickByUID,
						null,
						0,
						false,
						false,
						true,
						975026603748956,
						false
						,[
						[
							0,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
						]
					]
					],
					[
					[
						152,
						cr.plugins_.Sprite.prototype.acts.SubInstanceVar,
						null,
						9757320541386416,
						false
						,[
						[
							10,
							0
						]
,						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectEnabled,
						null,
						6923055215783097,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								2,
								"Tint"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						4759166619964931,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						6783635271533183,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								1
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetEffectParam,
						null,
						9226163276912132,
						false
						,[
						[
							1,
							[
								2,
								"Tint"
							]
						]
,						[
							0,
							[
								0,
								2
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						1185453430985127,
						[
						],
						[
						]
					]
,					[
						0,
						null,
						false,
						null,
						2410967498155239,
						[
						[
							24,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3612604595143926,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									20,
									11,
									cr.plugins_.Function.prototype.exps.Param,
									false,
									null
									,[
[
										0,
										1
									]
									]
								]
							]
							]
						]
						],
						[
						[
							24,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							448953329353923,
							false
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2378335935818108,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							24,
							cr.plugins_.Sprite.prototype.acts.SetOpacity,
							null,
							3328350452080409,
							false
							,[
							[
								0,
								[
									0,
									100
								]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7706485238376318,
							[
							[
								24,
								cr.plugins_.Sprite.prototype.cnds.CompareFrame,
								null,
								0,
								false,
								false,
								false,
								5420026170626612,
								false
								,[
								[
									8,
									0
								]
,								[
									0,
									[
										0,
										1
									]
								]
								]
							]
							],
							[
							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetWidth,
								null,
								9475653928276324,
								false
								,[
								[
									0,
									[
										6,
										[
											0,
											135
										]
										,[
											7,
											[
												21,
												152,
												false,
												null
												,0
											]
											,[
												21,
												152,
												false,
												null
												,1
											]
										]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1734141028361184,
							[
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3301062790829922,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
,							[
								24,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								1542009922923492,
								false
								,[
								[
									3,
									0
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.SetEffectEnabled,
								null,
								3470257817185002,
								false
								,[
								[
									3,
									0
								]
,								[
									1,
									[
										2,
										"Tint"
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9327492066984502,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1210405882322496,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								3
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9508253039007046,
							false
							,[
							[
								1,
								[
									2,
									"destroyEnemy"
								]
							]
,							[
								13,
																	[
										7,
										[
											20,
											11,
											cr.plugins_.Function.prototype.exps.Param,
											false,
											null
											,[
[
												0,
												1
											]
											]
										]
									]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Player"],
				false,
				null,
				8918847687694678,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					8918847687694678,
					false
					,[
					[
						1,
						[
							2,
							"Player"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5670889481409948,
					[
					[
						85,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						1136988722605363,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								600
							]
						]
						]
					]
					],
					[
					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						1215645720813657,
						false
						,[
						[
							0,
							[
								0,
								600
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2591509799702802,
					[
					[
						85,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						8966072152172599,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								300
							]
						]
						]
					]
					],
					[
					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						7738003582700029,
						false
						,[
						[
							0,
							[
								0,
								300
							]
						]
						]
					]
					]
				]
,				[
					1,
					"limit_shots",
					0,
					0,
true,false,6227920016772044,false
				]
,				[
					1,
					"damage",
					0,
					0,
false,false,8116905365802331,false
				]
,				[
					0,
					null,
					true,
					null,
					7130295957486529,
					[
					[
						114,
						cr.plugins_.Mouse.prototype.cnds.IsButtonDown,
						null,
						0,
						false,
						false,
						false,
						3644357239790966,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						457567241477278,
						false
						,[
						[
							4,
							16
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						2335364987796276,
						[
						[
							144,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							1651944006873727,
							false
						]
,						[
							144,
							cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
							null,
							0,
							false,
							true,
							false,
							1597327943338074,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9864055039303553,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							3077356173085993,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3935758591474981,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								6684756935445808,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
							],
							[
							[
								144,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3986775318208173,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetX,
								null,
								8887062226345428,
								false
								,[
								[
									0,
									[
										4,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7681278876732682,
								false
								,[
								[
									1,
									[
										2,
										"Orbs_normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								9331335362232644,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								707291040256668,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5197537648330018,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												200
											]
,[
												0,
												400
											]
											]
										]
										]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7854302221683445,
						[
						[
							145,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							4468015119593122,
							false
						]
,						[
							144,
							cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
							null,
							0,
							false,
							true,
							false,
							7871599165679106,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							115324779749296,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							1810372267059998,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							5310307148473005,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								5776861533605505,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
							],
							[
							[
								145,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								3153319487502308,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetX,
								null,
								6836653572533866,
								false
								,[
								[
									0,
									[
										4,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								909370388498027,
								false
								,[
								[
									1,
									[
										2,
										"Orbs_normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								6992890275141735,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								9541269674033547,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								168667436295869,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												200
											]
,[
												0,
												400
											]
											]
										]
										]
									]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4080699098366277,
						[
						[
							146,
							cr.plugins_.Sprite.prototype.cnds.IsVisible,
							null,
							0,
							false,
							false,
							false,
							5876012720339371,
							false
						]
,						[
							144,
							cr.plugins_.Sprite.prototype.cnds.IsOutsideLayout,
							null,
							0,
							false,
							true,
							false,
							6989897333837743,
							false
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9811862151316048,
							false
							,[
							[
								11,
								"ahead_start"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2309513440706164,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							6823575130043681,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Every,
								null,
								0,
								false,
								false,
								false,
								5049308272934179,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
							],
							[
							[
								146,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								7272305695550028,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetX,
								null,
								5793779396221717,
								false
								,[
								[
									0,
									[
										4,
										[
											20,
											17,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
										,[
											0,
											100
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2227679837600311,
								false
								,[
								[
									1,
									[
										2,
										"Orbs_normal"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								8188248229585085,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								218607499893251,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3574853979534347,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												200
											]
,[
												0,
												400
											]
											]
										]
										]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1634388449243697,
					[
					[
						114,
						cr.plugins_.Mouse.prototype.cnds.IsButtonDown,
						null,
						0,
						false,
						false,
						false,
						5803699025115509,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5753916511728138,
						false
						,[
						[
							11,
							"limit_shots"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9947894279003673,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						14,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						7660571233618389,
						false
						,[
						[
							4,
							21
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						21,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						2004688113106739,
						false
						,[
						[
							1,
							[
								23,
								"suit"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						9059000411128412,
						false
						,[
						[
							4,
							17
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6927046241994353,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Default_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						84780299400809,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Shoot_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						21,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						8901559393163361,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						21,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5042202597007761,
						false
						,[
						[
							3,
							0
						]
,						[
							4,
							17
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						9711478346228482,
						[
						[
							33,
							cr.plugins_.Sprite.prototype.cnds.CompareFrame,
							null,
							0,
							false,
							false,
							false,
							3548662695708482,
							false
							,[
							[
								8,
								0
							]
,							[
								0,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6228547635162283,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											500
										]
,[
											0,
											1000
										]
										]
									]
									]
								]
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							5747294743563368,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Charged_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3548138853180282,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							2357394690250362,
							false
						]
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							6371397261013332,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											100
										]
,[
											0,
											100
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6938209682454225,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9792396830164809,
							false
							,[
							[
								11,
								"ammo_amount"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							5011979753047711,
							false
							,[
							[
								11,
								"ammo_amount"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2145783480492694,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"ammo"
										]
									]
,
									[
										7,
										[
											10,
											[
												2,
												"X"
											]
											,[
												23,
												"ammo_amount"
											]
										]
									]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							7343375845424385,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6724920491175591,
								false
								,[
								[
									11,
									"ammo_amount"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5447138816957143,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"ammo"
											]
										]
,
										[
											7,
											[
												10,
												[
													2,
													"X0"
												]
												,[
													23,
													"ammo_amount"
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3616379169589452,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								1721693236761275,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"revolver"
									]
								]
								]
							]
							],
							[
							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5113421483576013,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												200
											]
,[
												0,
												400
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8236001655219385,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Revolver_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2629853743593966,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Revolver_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								8724584025170556,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5629266668904223,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"player_revolver"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							540334851655729,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								2716088621850095,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"rocket"
									]
								]
								]
							]
							],
							[
							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								7587538867867802,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												600
											]
,[
												0,
												1000
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								1574435432437422,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								9003965891667619,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								2414456616109446,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6409915153172522,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													2,
													"player_shotgun_"
												]
												,[
													23,
													"suit"
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2345644789532151,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5538533977759164,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shotgun"
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2248516207955934,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													2,
													"player_shotgun_"
												]
												,[
													23,
													"suit"
												]
											]
										]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7629510454692566,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1438261507007757,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								883540975742309,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								973846987871878,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								3063561022193008,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								2940268188611816,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								1788823692291354,
								false
								,[
								[
									0,
									[
										0,
										-3
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2198526467900955,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								3476156329623692,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								8631329557756253,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								4567380413659884,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								466076534889547,
								false
								,[
								[
									0,
									[
										0,
										-6
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								1994074075316358,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								5395372243472324,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								6438770422285224,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								5339134695319655,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								7243573735046987,
								false
								,[
								[
									0,
									[
										0,
										3
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								6835630606540364,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7626587935133901,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								1604606047032794,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								6166897225489618,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								3678276978696553,
								false
								,[
								[
									0,
									[
										0,
										6
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5279675407782644,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8456500556623672,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								6123948132817282,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							6976429582314374,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								9281487679295439,
								false
								,[
								[
									11,
									"ammo_amount"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1485494353496792,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									7,
									[
										2,
										"shoot"
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2810877784811067,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"ammo"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								7025347512488385,
								[
								[
									153,
									cr.plugins_.Sprite.prototype.cnds.IsVisible,
									null,
									0,
									false,
									false,
									false,
									455242332134208,
									false
								]
,								[
									153,
									cr.plugins_.Sprite.prototype.cnds.CompareY,
									null,
									0,
									false,
									false,
									false,
									6789260367965215,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											200
										]
									]
									]
								]
								],
								[
								[
									153,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									359585392784021,
									false
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1625413239916011,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							8056990259590849,
							false
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3083366000704906,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Shoot_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1827335027680693,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"player_shoot"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4442217318000643,
						[
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							3492520869106549,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									6,
									[
										6,
										[
											21,
											17,
											false,
											null
											,0
										]
										,[
											23,
											"attack_damage"
										]
									]
									,[
										1,
										0.4
									]
								]
							]
							]
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							9339524909265937,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.StartAnim,
							null,
							2525743185826997,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							2985832429770003,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								191177751314621,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"revolver"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8602611669868072,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								264179886534606,
								false
								,[
								[
									0,
									[
										1,
										0.08
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4912174554218366,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3994872855656813,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4807267421570415,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"rocket"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2474620564560732,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7023037484101175,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5047389403859224,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7925674819168388,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								7670743045516589,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shotgun"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								4525371499118123,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								2678656228875577,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								244603434465126,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9032206395900059,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4868902108652298,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shoot"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3673207779750174,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8146467660969548,
								false
								,[
								[
									0,
									[
										1,
										0.15
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3377493310209002,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					54882990383521,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						5088393663003087,
						false
						,[
						[
							4,
							16
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9047764389948605,
						false
						,[
						[
							11,
							"limit_shots"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4300268324235291,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						14,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						6189134578341744,
						false
						,[
						[
							4,
							21
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						21,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5819061463199049,
						false
						,[
						[
							1,
							[
								23,
								"suit"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.Spawn,
						null,
						2058767929735722,
						false
						,[
						[
							4,
							17
						]
,						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						17,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						5522582915341991,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Default_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						3982074374512814,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Shoot_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						21,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						4461093185158736,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						21,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5885609400244493,
						false
						,[
						[
							3,
							0
						]
,						[
							4,
							17
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						9190412257137516,
						[
						[
							33,
							cr.plugins_.Sprite.prototype.cnds.CompareFrame,
							null,
							0,
							false,
							false,
							false,
							3924405471082769,
							false
							,[
							[
								8,
								0
							]
,							[
								0,
								[
									0,
									3
								]
							]
							]
						]
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							3708276302927564,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											500
										]
,[
											0,
											1000
										]
										]
									]
									]
								]
							]
							]
						]
,						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							221247354797535,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Charged_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3038609896679311,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							9686175339802197,
							false
						]
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							381163642570342,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										19,
										cr.system_object.prototype.exps.random
										,[
[
											0,
											100
										]
,[
											0,
											100
										]
										]
									]
									]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5921587591079949,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							5179528720153969,
							false
							,[
							[
								11,
								"ammo_amount"
							]
,							[
								8,
								4
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SubVar,
							null,
							2102935216632783,
							false
							,[
							[
								11,
								"ammo_amount"
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							504043682307459,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"ammo"
										]
									]
,
									[
										7,
										[
											10,
											[
												2,
												"X"
											]
											,[
												23,
												"ammo_amount"
											]
										]
									]
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5765262831755145,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5072931977892064,
								false
								,[
								[
									11,
									"ammo_amount"
								]
,								[
									8,
									2
								]
,								[
									7,
									[
										0,
										10
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6702462910557132,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"ammo"
											]
										]
,
										[
											7,
											[
												10,
												[
													2,
													"X0"
												]
												,[
													23,
													"ammo_amount"
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3958409704720653,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6608680989843534,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"revolver"
									]
								]
								]
							]
							],
							[
							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2019491391668676,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												200
											]
,[
												0,
												400
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								1296593412956737,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Revolver_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8633999338234537,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Revolver_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								8135845160597422,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								1908845336087435,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"player_revolver"
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3230996225544546,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4122218188993167,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"rocket"
									]
								]
								]
							]
							],
							[
							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								9971188066249746,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												600
											]
,[
												0,
												1000
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								372190200244956,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7262284973113876,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Rocket_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								9022880515619026,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2949296356393286,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													2,
													"player_shotgun_"
												]
												,[
													23,
													"suit"
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							9994033862066249,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								6060242831421641,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shotgun"
									]
								]
								]
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								5003091297842669,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												10,
												[
													2,
													"player_shotgun_"
												]
												,[
													23,
													"suit"
												]
											]
										]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2535254569636194,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								956982603435295,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
								null,
								7166562554024119,
								false
								,[
								[
									0,
									[
										0,
										0
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								272162502746564,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								3795533818600509,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								8339956086550285,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								9291898207562388,
								false
								,[
								[
									0,
									[
										0,
										-3
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								5466876143255463,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2483517785252182,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								2385600243605989,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								8446033148414203,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								6060954889998343,
								false
								,[
								[
									0,
									[
										0,
										-6
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								7957846027194173,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								1559827135966063,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								4848945516500217,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								8385801384856453,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								5886111939825235,
								false
								,[
								[
									0,
									[
										0,
										3
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								3618096476667958,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								8411416987120872,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								926080107762862,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								306960960974699,
								false
								,[
								[
									4,
									17
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAngle,
								null,
								2999396888111874,
								false
								,[
								[
									0,
									[
										0,
										6
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
								null,
								2746459044668495,
								false
								,[
								[
									10,
									0
								]
,								[
									7,
									[
										19,
										cr.system_object.prototype.exps.floor
										,[
[
											19,
											cr.system_object.prototype.exps.random
											,[
[
												0,
												100
											]
,[
												0,
												300
											]
											]
										]
										]
									]
								]
								]
							]
,							[
								17,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7031643057959804,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Shotgun_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								17,
								cr.behaviors.Bullet.prototype.acts.SetSpeed,
								"Bullet",
								9266787972056492,
								false
								,[
								[
									0,
									[
										0,
										1000
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5367232239602587,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								4396202276132838,
								false
								,[
								[
									11,
									"ammo_amount"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								2317659314043577,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									7,
									[
										2,
										"shoot"
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4065343629154274,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"ammo"
											]
										]
,
										[
											7,
											[
												2,
												""
											]
										]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								5614487543209438,
								[
								[
									153,
									cr.plugins_.Sprite.prototype.cnds.IsVisible,
									null,
									0,
									false,
									false,
									false,
									6030855852445817,
									false
								]
,								[
									153,
									cr.plugins_.Sprite.prototype.cnds.CompareY,
									null,
									0,
									false,
									false,
									false,
									18554125968132,
									false
									,[
									[
										8,
										3
									]
,									[
										0,
										[
											0,
											200
										]
									]
									]
								]
								],
								[
								[
									153,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									6972602169839454,
									false
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						94307785260994,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							8836438701353704,
							false
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2123144690227039,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Shoot_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9229336692250992,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"player_shoot"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5815048857800738,
						[
						],
						[
						[
							17,
							cr.plugins_.Sprite.prototype.acts.SetInstanceVar,
							null,
							1913883133587564,
							false
							,[
							[
								10,
								0
							]
,							[
								7,
								[
									6,
									[
										6,
										[
											21,
											17,
											false,
											null
											,0
										]
										,[
											23,
											"attack_damage"
										]
									]
									,[
										1,
										0.4
									]
								]
							]
							]
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
							null,
							3461493630420584,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							33,
							cr.plugins_.Sprite.prototype.acts.StartAnim,
							null,
							3102437566686908,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							5976696360011264,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								3991263327913085,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"revolver"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								1829977884174287,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								4447225257498394,
								false
								,[
								[
									0,
									[
										1,
										0.08
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								6072897983553953,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							366301623674883,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								9578230748210988,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"rocket"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3102766447803904,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7016568108159925,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								8495022225558798,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							1330035506017532,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								5046714887030144,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shotgun"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								5933493066960291,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3467043894738433,
								false
								,[
								[
									0,
									[
										1,
										0.2
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3000424953551908,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8591713767098413,
							[
							[
								-1,
								cr.system_object.prototype.cnds.CompareVar,
								null,
								0,
								false,
								false,
								false,
								9564676904772232,
								false
								,[
								[
									11,
									"ammo_type"
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"shoot"
									]
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								7857841686497971,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								4800035974291416,
								false
								,[
								[
									0,
									[
										1,
										0.15
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetVar,
								null,
								3700578161655376,
								false
								,[
								[
									11,
									"limit_shots"
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					1,
					"force_field",
					0,
					0,
true,false,4533575581057922,false
				]
,				[
					0,
					null,
					false,
					null,
					4400527660523857,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						3596343146341928,
						false
						,[
						[
							4,
							152
						]
						]
					]
					],
					[
					[
						42,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5257024409710068,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						47,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6946651995551208,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8703056964398951,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							567100388872861,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2581879380272595,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9266913844561703,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							7824972472255022,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement_gold"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2894335408469975,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9448891533274317,
						[
						[
							106,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							171485806995857,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"appear"
								]
							]
							]
						]
						],
						[
						[
							106,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							8084704837870792,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7466420299099309,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1028143992795901,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achieve_header"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							7839914189224366,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7226329400515612,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4118440381740109,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achieve_description"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							5972090775634169,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8688691344457663,
						[
						[
							100,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							90828835681026,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement"
								]
							]
							]
						]
						],
						[
						[
							100,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							5251180178788958,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7402947061431322,
						[
						[
							43,
							cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
							null,
							0,
							false,
							false,
							false,
							7772893912168735,
							false
						]
						],
						[
						[
							43,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							1202698638128424,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9162529014657718,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							2322947123671863,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							149,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							3223029861433539,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							149,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							7778742679307567,
							false
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							9267335469367732,
							[
							[
								51,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								315209101654248,
								false
								,[
								[
									4,
									14
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								4787069681255616,
								false
								,[
								[
									0,
									[
										1,
										0.6
									]
								]
								]
							]
,							[
								51,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								3451658209851148,
								false
							]
,							[
								51,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								162073364472877,
								false
								,[
								[
									0,
									[
										0,
										-500
									]
								]
,								[
									0,
									[
										0,
										-500
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								8314522765791913,
								[
								[
									51,
									cr.plugins_.Sprite.prototype.cnds.CompareWidth,
									null,
									0,
									false,
									false,
									false,
									8106689196067851,
									false
									,[
									[
										8,
										2
									]
,									[
										0,
										[
											0,
											140
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									6844529787331788,
									false
									,[
									[
										0,
										[
											1,
											0.6
										]
									]
									]
								]
,								[
									51,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									3157707201723835,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.SetPos,
									null,
									2916011034822845,
									false
									,[
									[
										0,
										[
											0,
											-500
										]
									]
,									[
										0,
										[
											0,
											-500
										]
									]
									]
								]
,								[
									40,
									cr.plugins_.WebStorage.prototype.acts.StoreLocal,
									null,
									9122871036618709,
									false
									,[
									[
										1,
										[
											2,
											"upgrade_3"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
								,[
								[
									0,
									null,
									false,
									null,
									883827781977341,
									[
									[
										2,
										cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
										null,
										0,
										false,
										false,
										false,
										1178147371465004,
										false
										,[
										[
											10,
											0
										]
,										[
											8,
											0
										]
,										[
											7,
											[
												2,
												"pickup"
											]
										]
										]
									]
									],
									[
									[
										11,
										cr.plugins_.Function.prototype.acts.CallFunction,
										null,
										2159395143623979,
										false
										,[
										[
											1,
											[
												2,
												"handleSound"
											]
										]
,										[
											13,
																							[
													7,
													[
														2,
														"voice_shielddown"
													]
												]
										]
										]
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetText,
										null,
										2388965496872396,
										false
										,[
										[
											7,
											[
												2,
												"Shield down!"
											]
										]
										]
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetFontColor,
										null,
										8550200422756258,
										false
										,[
										[
											0,
											[
												19,
												cr.system_object.prototype.exps.rgb
												,[
[
													0,
													255
												]
,[
													0,
													0
												]
,[
													0,
													0
												]
												]
											]
										]
										]
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetPos,
										null,
										8321538699651127,
										false
										,[
										[
											0,
											[
												20,
												14,
												cr.plugins_.Sprite.prototype.exps.X,
												false,
												null
											]
										]
,										[
											0,
											[
												5,
												[
													20,
													14,
													cr.plugins_.Sprite.prototype.exps.Y,
													false,
													null
												]
												,[
													0,
													100
												]
											]
										]
										]
									]
,									[
										2,
										cr.behaviors.Pin.prototype.acts.Pin,
										"Pin",
										7074031014726783,
										false
										,[
										[
											4,
											14
										]
,										[
											3,
											0
										]
										]
									]
,									[
										-1,
										cr.system_object.prototype.acts.Wait,
										null,
										3118052819048186,
										false
										,[
										[
											0,
											[
												1,
												0.5
											]
										]
										]
									]
,									[
										2,
										cr.plugins_.Text.prototype.acts.SetVisible,
										null,
										3721315465359912,
										false
										,[
										[
											3,
											0
										]
										]
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							7989637605485091,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								6086863259823614,
								false
							]
							],
							[
							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6267711820179986,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"player_death"
											]
										]
								]
								]
							]
,							[
								144,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								6926366988463473,
								false
							]
,							[
								144,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								6720615164932367,
								false
								,[
								[
									0,
									[
										0,
										-500
									]
								]
,								[
									0,
									[
										0,
										-500
									]
								]
								]
							]
,							[
								145,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								370721079260614,
								false
							]
,							[
								145,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								2636495769769668,
								false
								,[
								[
									0,
									[
										0,
										-500
									]
								]
,								[
									0,
									[
										0,
										-500
									]
								]
								]
							]
,							[
								146,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								8102710815114013,
								false
							]
,							[
								146,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								1535646128297857,
								false
								,[
								[
									0,
									[
										0,
										-500
									]
								]
,								[
									0,
									[
										0,
										-500
									]
								]
								]
							]
,							[
								40,
								cr.plugins_.WebStorage.prototype.acts.StoreLocal,
								null,
								8046302766846234,
								false
								,[
								[
									1,
									[
										2,
										"upgrade_3"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.Spawn,
								null,
								9651636246427111,
								false
								,[
								[
									4,
									105
								]
,								[
									5,
									[
										2,
										"Background"
									]
								]
,								[
									7,
									[
										0,
										0
									]
								]
								]
							]
,							[
								105,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7994987414863042,
								false
								,[
								[
									1,
									[
										2,
										"blastmark"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								105,
								cr.behaviors.Fade.prototype.acts.StartFade,
								"Fade",
								5651122442524175,
								false
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								6605987060108316,
								false
								,[
								[
									1,
									[
										2,
										"handleSound"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"grenade_explosion"
											]
										]
								]
								]
							]
,							[
								94,
								cr.behaviors.scrollto.prototype.acts.Shake,
								"ScrollTo",
								1326540032806718,
								false
								,[
								[
									0,
									[
										0,
										10
									]
								]
,								[
									0,
									[
										1,
										1
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								14,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								7346072830769026,
								false
								,[
								[
									1,
									[
										10,
										[
											2,
											"Dead_"
										]
										,[
											23,
											"suit"
										]
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								152,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								9132548691905893,
								false
							]
,							[
								153,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								3265850134626461,
								false
							]
,							[
								81,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								4870879739507342,
								false
							]
,							[
								34,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								7501214280423729,
								false
							]
,							[
								122,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								9228785352746571,
								false
							]
,							[
								28,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								2897457088255844,
								false
							]
,							[
								8,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								624154137317301,
								false
							]
,							[
								-1,
								cr.system_object.prototype.acts.CreateObject,
								null,
								4720066516994973,
								false
								,[
								[
									4,
									22
								]
,								[
									5,
									[
										2,
										"Game"
									]
								]
,								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.X,
										false,
										null
									]
								]
,								[
									0,
									[
										20,
										14,
										cr.plugins_.Sprite.prototype.exps.Y,
										false,
										null
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetAnim,
								null,
								2871654052197262,
								false
								,[
								[
									1,
									[
										2,
										"default"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.SetSize,
								null,
								2689201692296986,
								false
								,[
								[
									0,
									[
										0,
										300
									]
								]
,								[
									0,
									[
										0,
										300
									]
								]
								]
							]
,							[
								22,
								cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
								null,
								9734621685990354,
								false
								,[
								[
									3,
									1
								]
,								[
									4,
									14
								]
								]
							]
,							[
								85,
								cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
								"DragDrop",
								1868259886285138,
								false
								,[
								[
									3,
									0
								]
								]
							]
,							[
								33,
								cr.plugins_.Sprite.prototype.acts.StopAnim,
								null,
								9393951497480304,
								false
							]
,							[
								15,
								cr.plugins_.Sprite.prototype.acts.SetVisible,
								null,
								9820537555882871,
								false
								,[
								[
									3,
									0
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetGroupActive,
								null,
								7553918110118594,
								false
								,[
								[
									1,
									[
										2,
										"GameLoop"
									]
								]
,								[
									3,
									0
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3549340713144789,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetGroupActive,
								null,
								5206801053457955,
								false
								,[
								[
									1,
									[
										2,
										"GameOver"
									]
								]
,								[
									3,
									1
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3471320050554418,
								false
								,[
								[
									1,
									[
										2,
										"showScore"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7810775484382108,
					[
					[
						149,
						cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,
						"Fade",
						1,
						false,
						false,
						false,
						8685545496378409,
						false
					]
					],
					[
					[
						149,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2986378083629973,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6935748535022657,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						5353544992033556,
						false
						,[
						[
							4,
							34
						]
						]
					]
					],
					[
					[
						42,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9436116403345593,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						47,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						246715644227614,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7294304165481092,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2610039483118414,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							5882837545609664,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9392250524810251,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3662586158063839,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement_gold"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							9636515770002112,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3889350516414908,
						[
						[
							106,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1627358137549199,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"appear"
								]
							]
							]
						]
						],
						[
						[
							106,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2850777394062275,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2866422626228257,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1725440533748609,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achieve_header"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2633060775076159,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						924286368683216,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6945056209700041,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achieve_description"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							1624843945852763,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1583706474840277,
						[
						[
							100,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2190926921378962,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"achievement"
								]
							]
							]
						]
						],
						[
						[
							100,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2255674656701108,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4755451224921258,
						[
						[
							43,
							cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
							null,
							0,
							false,
							false,
							false,
							4001945329272906,
							false
						]
						],
						[
						[
							43,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							5463224801703304,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8550221526760181,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6730389403148403,
							false
							,[
							[
								11,
								"speed_boost"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							149,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							159305581345347,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							149,
							cr.behaviors.Fade.prototype.acts.RestartFade,
							"Fade",
							2144963181848316,
							false
						]
						]
						,[
						[
							0,
							null,
							false,
							null,
							4172721246845175,
							[
							[
								51,
								cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
								null,
								0,
								false,
								false,
								false,
								9433421788619464,
								false
								,[
								[
									4,
									14
								]
								]
							]
							],
							[
							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								2792874761655906,
								false
								,[
								[
									0,
									[
										1,
										0.6
									]
								]
								]
							]
,							[
								51,
								cr.behaviors.Pin.prototype.acts.Unpin,
								"Pin",
								3095021148414614,
								false
							]
,							[
								51,
								cr.plugins_.Sprite.prototype.acts.SetPos,
								null,
								7229438793922575,
								false
								,[
								[
									0,
									[
										0,
										-500
									]
								]
,								[
									0,
									[
										0,
										-500
									]
								]
								]
							]
							]
							,[
							[
								0,
								null,
								false,
								null,
								4317030570273755,
								[
								[
									51,
									cr.plugins_.Sprite.prototype.cnds.CompareWidth,
									null,
									0,
									false,
									false,
									false,
									8403008795545444,
									false
									,[
									[
										8,
										2
									]
,									[
										0,
										[
											0,
											140
										]
									]
									]
								]
								],
								[
								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									9021149827789531,
									false
									,[
									[
										0,
										[
											1,
											0.6
										]
									]
									]
								]
,								[
									51,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									3380406933734924,
									false
								]
,								[
									51,
									cr.plugins_.Sprite.prototype.acts.SetPos,
									null,
									6022794227316371,
									false
									,[
									[
										0,
										[
											0,
											-500
										]
									]
,									[
										0,
										[
											0,
											-500
										]
									]
									]
								]
,								[
									40,
									cr.plugins_.WebStorage.prototype.acts.StoreLocal,
									null,
									442176584048472,
									false
									,[
									[
										1,
										[
											2,
											"upgrade_3"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
								]
							]
,							[
								0,
								null,
								false,
								null,
								7536180331626193,
								[
								[
									2,
									cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
									null,
									0,
									false,
									false,
									false,
									4598433073727236,
									false
									,[
									[
										10,
										0
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											2,
											"pickup"
										]
									]
									]
								]
								],
								[
								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									7253877673720382,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"voice_shielddown"
												]
											]
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetText,
									null,
									5378309134091218,
									false
									,[
									[
										7,
										[
											2,
											"Shield down!"
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetFontColor,
									null,
									3340511568465227,
									false
									,[
									[
										0,
										[
											19,
											cr.system_object.prototype.exps.rgb
											,[
[
												0,
												255
											]
,[
												0,
												0
											]
,[
												0,
												0
											]
											]
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetPos,
									null,
									39171143159865,
									false
									,[
									[
										0,
										[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
									]
,									[
										0,
										[
											5,
											[
												20,
												14,
												cr.plugins_.Sprite.prototype.exps.Y,
												false,
												null
											]
											,[
												0,
												100
											]
										]
									]
									]
								]
,								[
									2,
									cr.behaviors.Pin.prototype.acts.Pin,
									"Pin",
									3627428319705915,
									false
									,[
									[
										4,
										14
									]
,									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									9970723112371087,
									false
									,[
									[
										0,
										[
											1,
											0.5
										]
									]
									]
								]
,								[
									2,
									cr.plugins_.Text.prototype.acts.SetVisible,
									null,
									6199013240962118,
									false
									,[
									[
										3,
										0
									]
									]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							4638917930673539,
							[
							[
								-1,
								cr.system_object.prototype.cnds.Else,
								null,
								0,
								false,
								false,
								false,
								3266410945378832,
								false
							]
							],
							[
							]
							,[
							[
								0,
								null,
								false,
								null,
								5890088208119657,
								[
								[
									-1,
									cr.system_object.prototype.cnds.CompareVar,
									null,
									0,
									false,
									false,
									false,
									9142642117948642,
									false
									,[
									[
										11,
										"speed_boost"
									]
,									[
										8,
										0
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									14,
									cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
									null,
									0,
									false,
									false,
									false,
									2726392587855366,
									false
									,[
									[
										4,
										34
									]
									]
								]
								],
								[
								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									4217965392031126,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"player_death"
												]
											]
									]
									]
								]
,								[
									144,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									2991860851773316,
									false
								]
,								[
									144,
									cr.plugins_.Sprite.prototype.acts.SetPos,
									null,
									1211115476177058,
									false
									,[
									[
										0,
										[
											0,
											-500
										]
									]
,									[
										0,
										[
											0,
											-500
										]
									]
									]
								]
,								[
									145,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									33111764048339,
									false
								]
,								[
									145,
									cr.plugins_.Sprite.prototype.acts.SetPos,
									null,
									5185337009158951,
									false
									,[
									[
										0,
										[
											0,
											-500
										]
									]
,									[
										0,
										[
											0,
											-500
										]
									]
									]
								]
,								[
									146,
									cr.behaviors.Pin.prototype.acts.Unpin,
									"Pin",
									8046184048966565,
									false
								]
,								[
									146,
									cr.plugins_.Sprite.prototype.acts.SetPos,
									null,
									1122681073165165,
									false
									,[
									[
										0,
										[
											0,
											-500
										]
									]
,									[
										0,
										[
											0,
											-500
										]
									]
									]
								]
,								[
									40,
									cr.plugins_.WebStorage.prototype.acts.StoreLocal,
									null,
									1461989073647519,
									false
									,[
									[
										1,
										[
											2,
											"upgrade_3"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									14,
									cr.plugins_.Sprite.prototype.acts.Spawn,
									null,
									528608938460558,
									false
									,[
									[
										4,
										105
									]
,									[
										5,
										[
											2,
											"Background"
										]
									]
,									[
										7,
										[
											0,
											0
										]
									]
									]
								]
,								[
									105,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									9754975556725644,
									false
									,[
									[
										1,
										[
											2,
											"blastmark"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									105,
									cr.behaviors.Fade.prototype.acts.StartFade,
									"Fade",
									8102492474313511,
									false
								]
,								[
									14,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									5944596798724436,
									false
									,[
									[
										1,
										[
											10,
											[
												2,
												"Dead_"
											]
											,[
												23,
												"suit"
											]
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									4394673761402557,
									false
								]
,								[
									153,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									9595028103135346,
									false
								]
,								[
									81,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									9765701219808109,
									false
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									2578949719276533,
									false
								]
,								[
									122,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									2838911941485313,
									false
								]
,								[
									28,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									4320277544787802,
									false
								]
,								[
									8,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									4256411734247305,
									false
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									9646432091050166,
									false
									,[
									[
										1,
										[
											2,
											"handleSound"
										]
									]
,									[
										13,
																					[
												7,
												[
													2,
													"grenade_explosion"
												]
											]
									]
									]
								]
,								[
									94,
									cr.behaviors.scrollto.prototype.acts.Shake,
									"ScrollTo",
									4968793443577128,
									false
									,[
									[
										0,
										[
											0,
											10
										]
									]
,									[
										0,
										[
											1,
											1
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.CreateObject,
									null,
									8151855768807514,
									false
									,[
									[
										4,
										22
									]
,									[
										5,
										[
											2,
											"Game"
										]
									]
,									[
										0,
										[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.X,
											false,
											null
										]
									]
,									[
										0,
										[
											20,
											14,
											cr.plugins_.Sprite.prototype.exps.Y,
											false,
											null
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetSize,
									null,
									1961473541360129,
									false
									,[
									[
										0,
										[
											0,
											300
										]
									]
,									[
										0,
										[
											0,
											300
										]
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.SetAnim,
									null,
									5726275392340677,
									false
									,[
									[
										1,
										[
											2,
											"default"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									22,
									cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
									null,
									3314123357257057,
									false
									,[
									[
										3,
										1
									]
,									[
										4,
										14
									]
									]
								]
,								[
									34,
									cr.plugins_.Sprite.prototype.acts.Destroy,
									null,
									5078940649272955,
									false
								]
,								[
									85,
									cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
									"DragDrop",
									7425186552418835,
									false
									,[
									[
										3,
										0
									]
									]
								]
,								[
									15,
									cr.plugins_.Sprite.prototype.acts.SetVisible,
									null,
									3489014460182513,
									false
									,[
									[
										3,
										0
									]
									]
								]
,								[
									152,
									cr.plugins_.Sprite.prototype.acts.StopAnim,
									null,
									5398128882717857,
									false
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetGroupActive,
									null,
									4221188929217965,
									false
									,[
									[
										1,
										[
											2,
											"GameLoop"
										]
									]
,									[
										3,
										0
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.Wait,
									null,
									7510964813748165,
									false
									,[
									[
										0,
										[
											1,
											1
										]
									]
									]
								]
,								[
									-1,
									cr.system_object.prototype.acts.SetGroupActive,
									null,
									538240828927951,
									false
									,[
									[
										1,
										[
											2,
											"GameOver"
										]
									]
,									[
										3,
										1
									]
									]
								]
,								[
									11,
									cr.plugins_.Function.prototype.acts.CallFunction,
									null,
									888257304840595,
									false
									,[
									[
										1,
										[
											2,
											"showScore"
										]
									]
,									[
										13,
									]
									]
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1168598886394642,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						3266116802617712,
						false
						,[
						[
							4,
							8
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						8842276188739809,
						false
						,[
						[
							5,
							[
								2,
								"Game"
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.plugins_.Sprite.prototype.acts.SetTowardPosition,
						null,
						23237510395263,
						false
						,[
						[
							0,
							[
								0,
								64
							]
						]
,						[
							0,
							[
								0,
								140
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						5357141915764032,
						false
						,[
						[
							0,
							[
								0,
								-5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8906241809466568,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									4
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3767188923175977,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7625398683020925,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Coin_pickup"
									]
								]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4495433033804389,
						false
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3711403440967926,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
						null,
						0,
						false,
						false,
						false,
						8188067650461242,
						false
						,[
						[
							4,
							153
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1608520307813777,
						false
						,[
						[
							1,
							[
								2,
								"destroyOldPickup"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7004016195678973,
						false
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9981596048946757,
						false
						,[
						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								60
							]
						]
						]
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
						null,
						5122549115257987,
						false
						,[
						[
							3,
							1
						]
,						[
							4,
							2
						]
						]
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.acts.MoveToLayer,
						null,
						8659891697854672,
						false
						,[
						[
							5,
							[
								2,
								"Interface"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						17806678884527,
						false
						,[
						[
							11,
							"ammo_type"
						]
,						[
							7,
							[
								21,
								153,
								true,
								null
								,1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5885607505328986,
						false
						,[
						[
							11,
							"ammo_amount"
						]
,						[
							7,
							[
								21,
								153,
								false,
								null
								,2
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4285523188040865,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"ammo"
									]
								]
,
								[
									7,
									[
										10,
										[
											2,
											"X"
										]
										,[
											23,
											"ammo_amount"
										]
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2944128236011239,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"pickup"
									]
								]
						]
						]
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.acts.StopAnim,
						null,
						2262123506936538,
						false
					]
,					[
						153,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1254928280999523,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						471877336202376,
						[
						[
							153,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9446715854828801,
							false
							,[
							[
								10,
								1
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"revolver"
								]
							]
							]
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							3270334758910427,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Revolver_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							9051763390631612,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_laser"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6844781600407381,
						[
						[
							153,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8098527717906303,
							false
							,[
							[
								10,
								1
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"rocket"
								]
							]
							]
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6935332039468837,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Rocket_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1358862124045535,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_rocketlauncher"
										]
									]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6630011638492429,
						[
						[
							153,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							8256802867833352,
							false
							,[
							[
								10,
								1
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"shotgun"
								]
							]
							]
						]
						],
						[
						[
							14,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6330971945170733,
							false
							,[
							[
								1,
								[
									10,
									[
										2,
										"Shotgun_"
									]
									,[
										23,
										"suit"
									]
								]
							]
,							[
								3,
								0
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5701872290659617,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_shotgun"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6324281235381081,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						3068178903706631,
						false
						,[
						[
							4,
							28
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7594043840447052,
						false
						,[
						[
							11,
							"ahead_start"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7194301379296564,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6215782692442757,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Boost_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						314515224128555,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						28,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2939474366841783,
						false
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2442620346431633,
						false
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3048796632082266,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"boost_of_speed"
									]
								]
						]
						]
					]
,					[
						94,
						cr.behaviors.scrollto.prototype.acts.Shake,
						"ScrollTo",
						2184162651668301,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
,						[
							0,
							[
								1,
								2.5
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8281135549076655,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								23,
								"speed_fast_pickup"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1244785859157197,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7243084407533995,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4652165584674314,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								23,
								"speed_normal"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8311747286509643,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7715085458500641,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						4458975172940816,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Idle_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetCollisions,
						null,
						6293115689416311,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4446708314115193,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetCollisions,
						null,
						8137322062417505,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9479005225452278,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						6232441817569768,
						false
						,[
						[
							4,
							130
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3086918481636171,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"voice_shieldup"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1164149576438956,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"pickup"
									]
								]
						]
						]
					]
,					[
						130,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						4644369324241626,
						false
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						622330352502761,
						false
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						638619212150712,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						51,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						8080788709715077,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
,					[
						51,
						cr.plugins_.Sprite.prototype.acts.SetSize,
						null,
						4393387733959738,
						false
						,[
						[
							0,
							[
								1,
								202.938
							]
						]
,						[
							0,
							[
								1,
								202.938
							]
						]
						]
					]
,					[
						144,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						8914815865174931,
						false
						,[
						[
							4,
							14
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						144,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						278592343531359,
						false
						,[
						[
							4,
							14
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3868488253343304,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.OnCollision,
						null,
						0,
						false,
						false,
						true,
						9618860271194477,
						false
						,[
						[
							4,
							131
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9692811637370041,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2869151087033494,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"voice_grenade"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1386594258560392,
						false
						,[
						[
							1,
							[
								2,
								"handleSound"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"pickup"
									]
								]
						]
						]
					]
,					[
						131,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						7812817277947432,
						false
					]
,					[
						116,
						cr.plugins_.Sprite.prototype.acts.Destroy,
						null,
						2009020809460842,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9294288257405617,
						false
						,[
						[
							11,
							"grenades"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2626719703648364,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"grenades"
									]
								]
,
								[
									7,
									[
										10,
										[
											23,
											"grenades"
										]
										,[
											2,
											" x"
										]
									]
								]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2770361954531145,
						false
						,[
						[
							1,
							[
								2,
								"grenades"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"grenades"
										]
										]
									]
									]
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4453704784263694,
				[
				[
					14,
					cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
					null,
					0,
					false,
					false,
					false,
					9310575880104565,
					false
					,[
					[
						1,
						[
							10,
							[
								2,
								"Boost_"
							]
							,[
								23,
								"suit"
							]
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7272235835043863,
					[
					[
						14,
						cr.plugins_.Sprite.prototype.cnds.IsOverlapping,
						null,
						0,
						false,
						false,
						false,
						9415244751671692,
						false
						,[
						[
							4,
							152
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						400756596003975,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1829517501721284,
						false
						,[
						[
							1,
							[
								2,
								"Death"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4522401938781439,
						false
						,[
						[
							1,
							[
								2,
								"kills_overall"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"kills_overall"
										]
										]
									]
									]
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3585513535576702,
						false
						,[
						[
							11,
							"kills"
						]
,						[
							7,
							[
								4,
								[
									23,
									"kills"
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3364535499346502,
						[
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5855096095751996,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7984380597594456,
				[
				[
					24,
					cr.plugins_.Sprite.prototype.cnds.CompareX,
					null,
					0,
					false,
					false,
					false,
					7137470372549834,
					false
					,[
					[
						8,
						2
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					24,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2161112239604484,
					false
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Paused"],
			false,
			null,
			6303646988046731,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6303646988046731,
				false
				,[
				[
					1,
					[
						2,
						"Paused"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4523454120549984,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5616510567683917,
					false
					,[
					[
						4,
						10
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2924701060785799,
					false
					,[
					[
						1,
						[
							2,
							"GameLoop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8863707301606092,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8458287396983825,
					false
					,[
					[
						1,
						[
							2,
							"Paused"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1589923512158123,
					false
					,[
					[
						1,
						[
							2,
							"closePaused"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					152,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					3714893575887132,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					14,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					7460215059590105,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					81,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					2475322933581324,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					1952658118772248,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					9960519090015157,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					28,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					6971335873082029,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					5055837772161894,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					4037539806414152,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4673399562260629,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2423668320052055,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					2125409902101442,
					false
					,[
					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					5065191709625258,
					false
					,[
					[
						5,
						[
							2,
							"Interface"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					5867289491194397,
					false
					,[
					[
						5,
						[
							2,
							"Background"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					85,
					cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
					"DragDrop",
					610513455936752,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1390789632740933,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4720345954862184,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					2487866832916937,
					false
					,[
					[
						4,
						29
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3780635236075973,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"helicopter"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1861653251092809,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											23,
											"level"
										]
									]
									,[
										2,
										"_boss"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6170717805231797,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										2,
										"BGM_stage"
									]
									,[
										23,
										"level"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8399987553037344,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_menu"
								]
							]
,
							[
								7,
								[
									2,
									"start"
								]
							]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6512880925360768,
					false
					,[
					[
						0,
						[
							1,
							0.95
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1023357402834316,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6579937541026032,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2151540724037491,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9830426112293114,
					false
					,[
					[
						1,
						[
							2,
							"closePaused"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					4659989071707958,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9969469799071204,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6568818623174675,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					9476151704621898,
					false
					,[
					[
						6,
						"Menu"
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					6014553631443804,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3572887771471217,
					false
					,[
					[
						11,
						"revive"
					]
,					[
						7,
						[
							0,
							200
						]
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					1305329073643896,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7688398016568628,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4120678124869226,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3708582983210441,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6741805650017456,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4381518372987994,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					4614522398878791,
					false
					,[
					[
						4,
						30
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1790902922140023,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"helicopter"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4891566110412768,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											23,
											"level"
										]
									]
									,[
										2,
										"_boss"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1452831697712322,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										2,
										"BGM_stage"
									]
									,[
										23,
										"level"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					4896548740050533,
					false
					,[
					[
						0,
						[
							1,
							0.95
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6302492925561937,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5429050443818663,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3530387092057674,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7109699659318599,
					false
					,[
					[
						1,
						[
							2,
							"closePaused"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2589500527826517,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7784409424357726,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6951845336846952,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					376513117156729,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.RestartLayout,
					null,
					7079690046616563,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7367454026000587,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6489155409743149,
					false
					,[
					[
						11,
						"revive"
					]
,					[
						7,
						[
							0,
							200
						]
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					3594300282450004,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4405620256416031,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6282924030297171,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7441186231757554,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					7461572439345185,
					false
					,[
					[
						1,
						[
							2,
							"closePaused"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					470513307677491,
					false
					,[
					[
						5,
						[
							2,
							"Pause"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					2702227993595225,
					false
					,[
					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					7152250311524787,
					false
					,[
					[
						5,
						[
							2,
							"Interface"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					6380453361704581,
					false
					,[
					[
						5,
						[
							2,
							"Background"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1995429534662933,
					false
					,[
					[
						1,
						[
							2,
							"Paused"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.StartAnim,
					null,
					7147842067559198,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
					"DragDrop",
					3243114628851116,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					4679875720197404,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1422951872623529,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7221410799038061,
						false
						,[
						[
							11,
							"ahead_start"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8510229582647847,
						false
						,[
						[
							0,
							[
								0,
								66
							]
						]
,						[
							0,
							[
								0,
								457
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						607652602281712,
						false
						,[
						[
							5,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						2730572106616102,
						false
						,[
						[
							1,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						14,
						cr.behaviors.Bullet.prototype.acts.SetSpeed,
						"Bullet",
						7005036115556479,
						false
						,[
						[
							0,
							[
								0,
								700
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			1,
			"revive",
			0,
			200,
false,false,7640624137981468,false
		]
,		[
			0,
			[false, "GameOver"],
			false,
			null,
			3733959367963587,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3733959367963587,
				false
				,[
				[
					1,
					[
						2,
						"GameOver"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9940830922645169,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5998914009398678,
					false
					,[
					[
						1,
						[
							2,
							"showScore"
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8071819123394219,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"bestscore"
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9707643988521734,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"voice_gameover"
								]
							]
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1525399513474391,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3647758782727967,
					false
					,[
					[
						1,
						[
							2,
							"GameLoop"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					5286816115884026,
					false
					,[
					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							0,
							30
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					103498328845836,
					false
					,[
					[
						5,
						[
							2,
							"Interface"
						]
					]
,					[
						0,
						[
							0,
							30
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					1471552249486765,
					false
					,[
					[
						5,
						[
							2,
							"Background"
						]
					]
,					[
						0,
						[
							0,
							30
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3213665597806912,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7986313030135401,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold_score"
								]
							]
,
							[
								7,
								[
									23,
									"gold_collected"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4375741974725669,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"kills_score"
								]
							]
,
							[
								7,
								[
									23,
									"kills"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3066827590811178,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"distance_score"
								]
							]
,
							[
								7,
								[
									19,
									cr.system_object.prototype.exps.floor
									,[
[
										23,
										"distance_meters"
									]
									]
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4879562862102178,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"revive"
								]
							]
,
							[
								7,
								[
									23,
									"revive"
								]
							]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2982649827533865,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						7,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
								]
							]
							,[
								23,
								"gold_collected"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5930250407048278,
					false
					,[
					[
						11,
						"gold_collected"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8388318812547623,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold_total"
								]
							]
,
							[
								7,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"gold"
										]
										]
									]
									]
								]
							]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					5446865057279408,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3097862129666734,
					false
					,[
					[
						0,
						[
							1,
							513.323
						]
					]
,					[
						0,
						[
							0,
							490
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3816245699478861,
					false
					,[
					[
						0,
						[
							0,
							1004
						]
					]
,					[
						0,
						[
							0,
							490
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8255917114942549,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8940777388304207,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4946274520382311,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					106,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					5655410307298308,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5775175863937009,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1247893130596784,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						4288795171474652,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8801261524951694,
					[
					[
						106,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						135492017554675,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"appear"
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						9998388489109067,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2628228711518663,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8326024203320038,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8434077583152942,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4088250963098286,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2881543422521919,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8779470780540325,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5400909268956623,
					[
					[
						100,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9104806525770367,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8645704668746038,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4207435672999603,
					[
					[
						43,
						cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
						null,
						0,
						false,
						false,
						false,
						70208396809048,
						false
					]
					],
					[
					[
						43,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2303208149768714,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7156105101185626,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						4372007219641073,
						false
						,[
						[
							1,
							[
								2,
								"bestdistance"
							]
						]
,						[
							8,
							2
						]
,						[
							0,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									23,
									"distance_meters"
								]
								]
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						839439222960449,
						false
						,[
						[
							1,
							[
								2,
								"bestdistance"
							]
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									23,
									"distance_meters"
								]
								]
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						9882619462513886,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.behaviors.Flash.prototype.acts.Flash,
						"Flash",
						4097935075174541,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
,						[
							0,
							[
								1,
								0.1
							]
						]
,						[
							0,
							[
								1,
								5
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1467795095019603,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						5124368350483124,
						false
						,[
						[
							1,
							[
								2,
								"bestkills"
							]
						]
,						[
							8,
							2
						]
,						[
							0,
							[
								23,
								"kills"
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						136558665764925,
						false
						,[
						[
							1,
							[
								2,
								"bestkills"
							]
						]
,						[
							7,
							[
								23,
								"kills"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						4148561843963604,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1743643522459699,
					[
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2362058182564334,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"kills_score_best"
									]
								]
,
								[
									7,
									[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"bestkills"
										]
										]
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7821223034027728,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"distance_score_best"
									]
								]
,
								[
									7,
									[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"bestdistance"
										]
										]
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2770564320388771,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					9499652068350269,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					2578953207297898,
					false
					,[
					[
						4,
						7
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8133507182562358,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8009960812181007,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8992724841445215,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2755685557293925,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SaveState,
					null,
					3646565215601338,
					false
					,[
					[
						1,
						[
							2,
							"mysave"
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4776256488035198,
					false
					,[
					[
						1,
						[
							2,
							"handleShopGame"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2157016448186406,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					1681365681600242,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					8563830658709291,
					false
					,[
					[
						4,
						29
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9828213817602212,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"helicopter"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1534895956629316,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											23,
											"level"
										]
									]
									,[
										2,
										"_boss"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3001306009536248,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										2,
										"BGM_stage"
									]
									,[
										23,
										"level"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1691949854009987,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_ending"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1812119270532948,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_victoryshort"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5415683116355966,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_menu"
								]
							]
,
							[
								7,
								[
									2,
									"start"
								]
							]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					1386282723961406,
					false
					,[
					[
						0,
						[
							1,
							0.95
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5831013371429872,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6405229080954074,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8258633625316761,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9139158932097842,
					false
					,[
					[
						1,
						[
							2,
							"closeGameOver"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					2838349557076707,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7134173547719362,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6280813673557375,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8152281600816658,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3070317361678921,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					87,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					8951111729335813,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					639152401610072,
					false
					,[
					[
						6,
						"Menu"
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					2587702049261721,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4233298097965021,
					false
					,[
					[
						11,
						"revive"
					]
,					[
						7,
						[
							0,
							200
						]
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					3741369074683581,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3566348626385376,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8371992055560219,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					55208503750449,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1018197836097456,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					1969079736954017,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					2637626794598095,
					false
					,[
					[
						4,
						30
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5865474331148383,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"helicopter"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5471402428961006,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										10,
										[
											2,
											"BGM_stage"
										]
										,[
											23,
											"level"
										]
									]
									,[
										2,
										"_boss"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5193151139251036,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									10,
									[
										2,
										"BGM_stage"
									]
									,[
										23,
										"level"
									]
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1416994721693245,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_ending"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6127520494829135,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"BGM_victoryshort"
								]
							]
,
							[
								7,
								[
									2,
									"stop"
								]
							]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3477785144249718,
					false
					,[
					[
						0,
						[
							1,
							0.95
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5519536745752949,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3303156283959628,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6152030344380469,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4648201721590684,
					false
					,[
					[
						1,
						[
							2,
							"closeGameOver"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					760282048144871,
					false
					,[
					[
						5,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6924472672192421,
					false
					,[
					[
						1,
						[
							2,
							"Starting"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4351437022577564,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7084406118374937,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3295668539497638,
					false
					,[
					[
						0,
						[
							0,
							-1000
						]
					]
,					[
						0,
						[
							0,
							-1000
						]
					]
					]
				]
,				[
					87,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					12667746916688,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.ResetGlobals,
					null,
					8494148546497847,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.RestartLayout,
					null,
					6558940301185757,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6568798034097043,
					false
					,[
					[
						1,
						[
							2,
							"MainMenu"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					493787273601345,
					false
					,[
					[
						11,
						"revive"
					]
,					[
						7,
						[
							0,
							200
						]
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					3452264814520817,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6097490307369064,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3437796827102586,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6741805650017456,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					4381518372987994,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					4614522398878791,
					false
					,[
					[
						4,
						31
					]
					]
				]
				],
				[
				[
					36,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9716817206933957,
					false
					,[
					[
						0,
						[
							0,
							-200
						]
					]
,					[
						0,
						[
							0,
							-200
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					4896548740050533,
					false
					,[
					[
						0,
						[
							1,
							0.95
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6302492925561937,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5429050443818663,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3530387092057674,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMasterVolume,
					null,
					5486651686185483,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8695245681092383,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6195157793784687,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					153,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					7982663138478613,
					false
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					326225982045037,
					false
				]
,				[
					131,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					5972093940990833,
					false
				]
,				[
					130,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9402864641194889,
					false
				]
,				[
					34,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					3283941278268413,
					false
				]
,				[
					42,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2104456071238096,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3020824995011658,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9477845433318984,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2422280502921787,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"TutorialUI"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						6765608404695911,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						140,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2913572093941864,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7123293424686133,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4314628430890184,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						923252324286613,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3505936255686227,
					[
					[
						106,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9716341574982182,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"appear"
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						1477384685913773,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1538062983374505,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						17936376347741,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						4942746654262371,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2444025348560295,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5009566325826991,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						1015777691138326,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8871821126375934,
					[
					[
						100,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1573304993346842,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3256747228740558,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6060673711550887,
					[
					[
						43,
						cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
						null,
						0,
						false,
						false,
						false,
						1403991417333579,
						false
					]
					],
					[
					[
						43,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3741299423541039,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					481561995803774,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						6587632671008956,
						false
						,[
						[
							1,
							[
								2,
								"gold"
							]
						]
,						[
							8,
							5
						]
,						[
							0,
							[
								23,
								"revive"
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7109699659318599,
						false
						,[
						[
							1,
							[
								2,
								"closeGameOver"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4723052202411166,
						false
						,[
						[
							1,
							[
								2,
								"GameLoop"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						29,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4912596628611446,
						false
						,[
						[
							0,
							[
								0,
								-1000
							]
						]
,						[
							0,
							[
								0,
								-1000
							]
						]
						]
					]
,					[
						30,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8762216639388137,
						false
						,[
						[
							0,
							[
								0,
								-1000
							]
						]
,						[
							0,
							[
								0,
								-1000
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						8162872962005237,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						81,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						5528609045874159,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						34,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						1812290684434531,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						9672434105856255,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						28,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						2431186222386679,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						8108150685142787,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						33,
						cr.plugins_.Sprite.prototype.acts.StartAnim,
						null,
						5762125093400531,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4162457196249356,
						false
						,[
						[
							1,
							[
								2,
								"gold"
							]
						]
,						[
							7,
							[
								5,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"gold"
										]
										]
									]
									]
								]
								,[
									23,
									"revive"
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6851068982806672,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										0,
										0
									]
								]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						1487180757935293,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Boost_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3193669500345386,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						85,
						cr.behaviors.DragnDrop.prototype.acts.SetEnabled,
						"DragDrop",
						7633228562326648,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9439032133538982,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								23,
								"speed_fast_revive"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4633378234247057,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						14,
						cr.behaviors.Flash.prototype.acts.Flash,
						"Flash",
						382939495107813,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
,						[
							0,
							[
								1,
								0.1
							]
						]
,						[
							0,
							[
								1,
								4
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4477651479824408,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9223338899520179,
						false
						,[
						[
							11,
							"speed"
						]
,						[
							7,
							[
								23,
								"speed_normal"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7910898579541317,
						false
						,[
						[
							11,
							"speed_boost"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						122,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3033131815694179,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetAnim,
						null,
						6328790994671176,
						false
						,[
						[
							1,
							[
								10,
								[
									2,
									"Idle_"
								]
								,[
									23,
									"suit"
								]
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4574682421252018,
						false
						,[
						[
							11,
							"revive"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									6,
									[
										23,
										"revive"
									]
									,[
										1,
										1.5
									]
								]
								]
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetCollisions,
						null,
						1903969104082425,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2897745632942482,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						14,
						cr.plugins_.Sprite.prototype.acts.SetCollisions,
						null,
						4231108662781138,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						33,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3746348164349017,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5992767548897431,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						3533693181484988,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4758026120232385,
						false
						,[
						[
							1,
							[
								2,
								"PopUp"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"GameOver"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"gold"
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7441186231757554,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					7461572439345185,
					false
					,[
					[
						1,
						[
							2,
							"closeGameOver"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					470513307677491,
					false
					,[
					[
						5,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					2702227993595225,
					false
					,[
					[
						5,
						[
							2,
							"Game"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					7152250311524787,
					false
					,[
					[
						5,
						[
							2,
							"Interface"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerOpacity,
					null,
					6380453361704581,
					false
					,[
					[
						5,
						[
							2,
							"Background"
						]
					]
,					[
						0,
						[
							0,
							100
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1995429534662933,
					false
					,[
					[
						1,
						[
							2,
							"GameOver"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					15,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5101141216345329,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					33,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7974595946118684,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2363291686154051,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2412470307941346,
					false
					,[
					[
						4,
						92
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					401701828139415,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						827409721104701,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"tweet"
							]
						]
						]
					]
					],
					[
					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						7984899667828313,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7659141957629471,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						7122049341956876,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6601562586692147,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.GoToURLWindow,
						null,
						2114772113372124,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"http://twitter.com/intent/tweet?source=webclient&text=My%20highscore%20is%20"
												]
												,[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"bestdistance"
													]
													]
												]
											]
											,[
												2,
												"%20Meters%20and%20destroyed%20"
											]
										]
										,[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"bestkills"
											]
											]
										]
									]
									,[
										2,
										"%20Enemies"
									]
								]
								,[
									2,
									"%20%23ColossalDefenders%20http://colossaldefenders.com"
								]
							]
						]
,						[
							1,
							[
								2,
								"NewWindow"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9587745744982105,
					[
					[
						92,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2114030608266694,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"share"
							]
						]
						]
					]
					],
					[
					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						2371646216971683,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4313225329530176,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						8846456756223275,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1644712656482019,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.GoToURLWindow,
						null,
						1318347477291884,
						false
						,[
						[
							1,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												10,
												[
													2,
													"http://facebook.com/dialog/feed?app_id=1421485314794501&redirect_uri=https://apps.facebook.com/colossaldefenders&name=Play%20Colossal%20Defenders%20FREE%20on%20the%20App%20Store%20and%20Google%20Play!&link=http://colossaldefenders.com&picture=https://sammustudios.files.wordpress.com/2014/08/colossal_icon2.png&caption=http://colossaldefenders.com&description=My%20highscore%20is%20"
												]
												,[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"bestdistance"
													]
													]
												]
											]
											,[
												2,
												"%20Meters%20and%20destroyed%20"
											]
										]
										,[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"bestkills"
											]
											]
										]
									]
									,[
										2,
										"%20Enemies"
									]
								]
								,[
									2,
									"%20%23ColossalDefenders"
								]
							]
						]
,						[
							1,
							[
								2,
								"NewWindow"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "AchievementTrigger"],
			false,
			null,
			4587354458869741,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4587354458869741,
				false
				,[
				[
					1,
					[
						2,
						"AchievementTrigger"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9175694669433679,
				[
				[
					19,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					363246958388707,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					721472121293294,
					false
					,[
					[
						1,
						[
							2,
							"achieve_9"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2956855208634346,
					false
					,[
					[
						1,
						[
							2,
							"achieve_9"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5510549930529094,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Enforcer"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1056868289494448,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8733428871802091,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									500
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2376560936979789,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1523979489138965,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5638943356597399,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						4531128767738362,
						false
						,[
						[
							7,
							[
								0,
								500
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				435084210062226,
				[
				[
					65,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5257195364514139,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6601091469411156,
					false
					,[
					[
						1,
						[
							2,
							"achieve_10"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1757844223906946,
					false
					,[
					[
						1,
						[
							2,
							"achieve_10"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9178985214392552,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Iron Vulcan"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7468288787301634,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4672778782488276,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									1000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6832027146701984,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4935659837760641,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4925915912319476,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						8716361199882714,
						false
						,[
						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2087729590285113,
				[
				[
					66,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8163074844979774,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					537203524593698,
					false
					,[
					[
						1,
						[
							2,
							"achieve_11"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1272638238293188,
					false
					,[
					[
						1,
						[
							2,
							"achieve_11"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4411915410360257,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Iron Hellion"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4070812006978505,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						325350569477797,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									1500
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7603658167836492,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2692369801972893,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7302402045270283,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6102225303234003,
						false
						,[
						[
							7,
							[
								0,
								1500
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2735988538611067,
				[
				[
					91,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					9495843704665502,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					7443255953796665,
					false
					,[
					[
						1,
						[
							2,
							"achieve_12"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7957321537842187,
					false
					,[
					[
						1,
						[
							2,
							"achieve_12"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4557188160221166,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Battle Hound"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					813320859134609,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9862219750788967,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									2000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						892667381283229,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5554150514112308,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3826872670510071,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						3437670333784725,
						false
						,[
						[
							7,
							[
								0,
								2000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				553746627384104,
				[
				[
					55,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					254864663564317,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2971720058502713,
					false
					,[
					[
						1,
						[
							2,
							"achieve_1"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9223671565117465,
					false
					,[
					[
						1,
						[
							2,
							"achieve_1"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5133352785979088,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Desert Bradley"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4084659706026251,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8101705797626446,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									1000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8302088538132187,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9025036768905748,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9892504696668978,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						7601584430456369,
						false
						,[
						[
							7,
							[
								0,
								1000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1518579689397794,
				[
				[
					61,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6607428674445462,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6720767862648565,
					false
					,[
					[
						1,
						[
							2,
							"achieve_5"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1841045677895387,
					false
					,[
					[
						1,
						[
							2,
							"achieve_5"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3284687233787999,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Star Gunner"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5400332744955479,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4475836931344951,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									2000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8858403934374337,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					989890596585539,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2411168833320326,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						9107652343470492,
						false
						,[
						[
							7,
							[
								0,
								2000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8657294429216937,
				[
				[
					62,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6832557722057064,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					5961518845133249,
					false
					,[
					[
						1,
						[
							2,
							"achieve_6"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					4680217162430999,
					false
					,[
					[
						1,
						[
							2,
							"achieve_6"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8146566571966973,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Metal Goliath"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1018919341057414,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5601694918472334,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									3000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5231013168372511,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7841792037774121,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5557523028382839,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						4398179039479045,
						false
						,[
						[
							7,
							[
								0,
								3000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2151472239509266,
				[
				[
					90,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2060884720783992,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8016884542638914,
					false
					,[
					[
						1,
						[
							2,
							"achieve_7"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					9357798725701902,
					false
					,[
					[
						1,
						[
							2,
							"achieve_7"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8525914046608148,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Grand Sentinel"
								]
							]
,
							[
								7,
								[
									2,
									"Encounter and Kill"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8656700935293752,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6662907403774021,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									4000
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						773855160655355,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6508108388969347,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3886394930422551,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						7307252846855513,
						false
						,[
						[
							7,
							[
								0,
								4000
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				78406837671343,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3188813627151046,
					false
					,[
					[
						1,
						[
							2,
							"achieve_2"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5833536392300727,
					false
					,[
					[
						11,
						"distance_meters"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1000
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8555965035323359,
					false
					,[
					[
						1,
						[
							2,
							"achieve_2"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8159893698124158,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Speed Racer"
								]
							]
,
							[
								7,
								[
									2,
									"Reach 1000m"
								]
							]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3458088216144449,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9252302145649435,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									500
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						4498089742306255,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9665218389296786,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1252866909028206,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						7774113775934996,
						false
						,[
						[
							7,
							[
								0,
								500
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6219352580489488,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3116776775843008,
					false
					,[
					[
						1,
						[
							2,
							"kills_overall"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							50
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					3601921374151909,
					false
					,[
					[
						1,
						[
							2,
							"achieve_3"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					754142806498407,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"Trigger Happy"
								]
							]
,
							[
								7,
								[
									2,
									"Kill 50 Enemies"
								]
							]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					1706663071741566,
					false
					,[
					[
						1,
						[
							2,
							"achieve_3"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7875829898609204,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2875935909236149,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									600
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8865133662607201,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2185282896142309,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7780037645291389,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						1705620157936486,
						false
						,[
						[
							7,
							[
								0,
								600
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2752465233462966,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9267849047523495,
					false
					,[
					[
						11,
						"kills"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							30
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8840655972298815,
					false
					,[
					[
						1,
						[
							2,
							"achieve_4"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8637579450553039,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"30 in a row"
								]
							]
,
							[
								7,
								[
									2,
									"Kill 30 Enemies"
								]
							]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					6447885322454249,
					false
					,[
					[
						1,
						[
							2,
							"achieve_4"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					1210196804737384,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6697143176723596,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									400
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8233476250124137,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6179770130941974,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3122313908562749,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						137993532908184,
						false
						,[
						[
							7,
							[
								0,
								400
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6030151853379325,
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6100018426348031,
					false
					,[
					[
						1,
						[
							2,
							"kills_overall"
						]
					]
,					[
						8,
						5
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					8859448213893145,
					false
					,[
					[
						1,
						[
							2,
							"achieve_8"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8587532631800085,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"First Blood"
								]
							]
,
							[
								7,
								[
									2,
									"Kill an enemy"
								]
							]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5687009397861381,
					false
					,[
					[
						1,
						[
							2,
							"achieve_8"
						]
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2035107508039442,
					[
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2127236309566273,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								4,
								[
									23,
									"gold_collected"
								]
								,[
									0,
									300
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						9553002946328686,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2418834652060876,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						7438796597718784,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2116661696327083,
						false
						,[
						[
							7,
							[
								0,
								300
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7341845557695773,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					3165163031344746,
					false
					,[
					[
						1,
						[
							2,
							"triggerAchievement"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8786277850376945,
					[
					[
						100,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4736969751556183,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						622063566712095,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7747099611161391,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1761517189281906,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						6372190921145722,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2020826075988865,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8696009737440334,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8420864782812013,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					434031774167166,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9457550034468901,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						2386324750925681,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6117194622806019,
						false
						,[
						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7416490285964075,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9993056931065325,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8448309587022152,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2744974543932661,
						false
						,[
						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						1572894547981596,
						[
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1736988541629098,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"achieved"
										]
									]
							]
							]
						]
,						[
							43,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2349109374669243,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							171185538091173,
							false
							,[
							[
								3,
								1
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							8487083528743349,
							false
							,[
							[
								0,
								[
									1,
									3
								]
							]
							]
						]
,						[
							43,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4565666581025894,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							42,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							1634868522374422,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							47,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							2379398142481108,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							100,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4601172509582452,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							104,
							cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
							null,
							1420495225012808,
							false
							,[
							[
								3,
								1
							]
,							[
								4,
								42
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2910289606768201,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9169633738265723,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6882122692858854,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						5341312157924669,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6867085837937251,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3559085455470166,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4550371685657926,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						3035581916616835,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2854597283044075,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						3506291863244353,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1047633701401686,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						7735962168865846,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1621772063162076,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						775456986497215,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1712091714796488,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						7240680609560934,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "CatalogueTrigger"],
			false,
			null,
			68316181502443,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				68316181502443,
				false
				,[
				[
					1,
					[
						2,
						"CatalogueTrigger"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4162692986679235,
				[
				[
					152,
					cr.plugins_.Sprite.prototype.cnds.OnDestroyed,
					null,
					1,
					false,
					false,
					false,
					9520285153114077,
					false
				]
,				[
					152,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1474510827941947,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					40,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3352066580316033,
					false
					,[
					[
						1,
						[
							21,
							152,
							true,
							null
							,5
						]
					]
,					[
						7,
						[
							4,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										21,
										152,
										true,
										null
										,5
									]
									]
								]
								]
							]
							,[
								0,
								1
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					5394987721356159,
					[
					[
						39,
						cr.plugins_.Arr.prototype.cnds.CompareXY,
						null,
						0,
						false,
						false,
						false,
						7446922351866782,
						false
						,[
						[
							0,
							[
								5,
								[
									21,
									152,
									false,
									null
									,7
								]
								,[
									0,
									1
								]
							]
						]
,						[
							0,
							[
								5,
								[
									21,
									152,
									false,
									null
									,6
								]
								,[
									0,
									1
								]
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps["int"]
								,[
[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										21,
										152,
										true,
										null
										,5
									]
									]
								]
								]
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3946779938294172,
						false
						,[
						[
							1,
							[
								2,
								"triggerCatalogue"
							]
						]
,						[
							13,
															[
									7,
									[
										21,
										152,
										true,
										null
										,9
									]
								]
,
								[
									7,
									[
										10,
										[
											10,
											[
												10,
												[
													10,
													[
														2,
														"Kill "
													]
													,[
														19,
														cr.system_object.prototype.exps["int"]
														,[
[
															20,
															40,
															cr.plugins_.WebStorage.prototype.exps.LocalValue,
															true,
															null
															,[
[
																21,
																152,
																true,
																null
																,5
															]
															]
														]
														]
													]
												]
												,[
													2,
													"/"
												]
											]
											,[
												19,
												cr.system_object.prototype.exps["int"]
												,[
[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														21,
														152,
														true,
														null
														,5
													]
													]
												]
												]
											]
										]
										,[
											2,
											" "
										]
									]
								]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				750216812501601,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5513231610083879,
					false
					,[
					[
						1,
						[
							2,
							"triggerCatalogue"
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4366278813003061,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"achieved"
								]
							]
					]
					]
				]
,				[
					47,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					246129864072808,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					43,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9679635421659056,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					104,
					cr.plugins_.Sprite.prototype.acts.ZMoveToObject,
					null,
					1096111914760729,
					false
					,[
					[
						3,
						1
					]
,					[
						4,
						47
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					8786277850376945,
					[
					[
						100,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4736969751556183,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						622063566712095,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7747099611161391,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1761517189281906,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						6372190921145722,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4824943662987023,
					[
					[
						106,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8010392931010559,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"appear"
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						7887898505769853,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3481364620493653,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9927569824689662,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement_gold"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						7218116965738579,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					434031774167166,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9457550034468901,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						2386324750925681,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						6117194622806019,
						false
						,[
						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						4475871050589613,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							5350819063456752,
							false
							,[
							[
								1,
								[
									2,
									"Enforcers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7393559134539895,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										4000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5492841862958511,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							6068901578351957,
							false
							,[
							[
								7,
								[
									2,
									"4000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						188522137377817,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							4683059511964001,
							false
							,[
							[
								1,
								[
									2,
									"Soldiers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							580355427264286,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3759465369322218,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							4606972908202745,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8538209710564751,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							892888704082009,
							false
							,[
							[
								1,
								[
									2,
									"Storm Walkers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7665432593551706,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							4544540190384406,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							7814749397959076,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4159115777132403,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							5880074760551711,
							false
							,[
							[
								1,
								[
									2,
									"Desert Bradleys"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2799849465097066,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										6000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2597989410163504,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							5397888113902844,
							false
							,[
							[
								7,
								[
									2,
									"6000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3197597249652096,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							8392702548172224,
							false
							,[
							[
								1,
								[
									2,
									"Iron Vulcans"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							1369055134441605,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										4000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7404884773991635,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							4587626284333473,
							false
							,[
							[
								7,
								[
									2,
									"4000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						161338359653637,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							2018214052155354,
							false
							,[
							[
								1,
								[
									2,
									"Desert Reavers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8058547874756045,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							5146431376712519,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							7763089514086684,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3650217795853271,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							1506656394595579,
							false
							,[
							[
								1,
								[
									2,
									"Storm Scarabs"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3511578164156056,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							40872604761129,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							8794552177218121,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3211538607179061,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							1043784147848121,
							false
							,[
							[
								1,
								[
									2,
									"Star Gunners"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							7327300318232266,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										6000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2190159928946789,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							2860450756422698,
							false
							,[
							[
								7,
								[
									2,
									"6000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7878802935137741,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							8810369477355864,
							false
							,[
							[
								1,
								[
									2,
									"Orion Alphas"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5512483781570188,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										4000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3922147752783744,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							2415154489618706,
							false
							,[
							[
								7,
								[
									2,
									"4000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4458865716585363,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							8762667818613434,
							false
							,[
							[
								1,
								[
									2,
									"Heavy Troopers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							8992087190399727,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2225304419473513,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							4036317550568532,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3603578083866679,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							1691984754293573,
							false
							,[
							[
								1,
								[
									2,
									"Tactical Sentrys"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							2605448211519351,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							3260296073528224,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							8524024192951386,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7139282175424917,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							7934889743999068,
							false
							,[
							[
								1,
								[
									2,
									"Ghost Machines"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							5437126845557679,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										6000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1971710895972535,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							3737226674530322,
							false
							,[
							[
								7,
								[
									2,
									"6000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8140612623680656,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							7819249772286007,
							false
							,[
							[
								1,
								[
									2,
									"Battle Hounds"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3358484427271802,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										4000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							1607098171912731,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							7127190495853824,
							false
							,[
							[
								7,
								[
									2,
									"4000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8364203578005318,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							3591197711983066,
							false
							,[
							[
								1,
								[
									2,
									"Strike Troopers"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							3599582998606038,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7015553595279442,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							7050974221300366,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4059024980442452,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							8293725691608507,
							false
							,[
							[
								1,
								[
									2,
									"Steel Sentrys"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							743132623073747,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										2000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6656625298576692,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							6873615895520377,
							false
							,[
							[
								7,
								[
									2,
									"2000"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2517097046818812,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareText,
							null,
							0,
							false,
							false,
							false,
							4825262154279226,
							false
							,[
							[
								1,
								[
									2,
									"Grand Sentinels"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							-1,
							cr.system_object.prototype.acts.SetVar,
							null,
							6371137924365158,
							false
							,[
							[
								11,
								"gold_collected"
							]
,							[
								7,
								[
									4,
									[
										23,
										"gold_collected"
									]
									,[
										0,
										6000
									]
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2126915939003154,
							false
							,[
							[
								1,
								[
									2,
									"setText"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"gold"
										]
									]
,
									[
										7,
										[
											23,
											"gold_collected"
										]
									]
							]
							]
						]
,						[
							106,
							cr.plugins_.Text.prototype.acts.SetText,
							null,
							7904354149934014,
							false
							,[
							[
								7,
								[
									2,
									"6000"
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7416490285964075,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9993056931065325,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						8448309587022152,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetText,
						null,
						2744974543932661,
						false
						,[
						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									1
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2595255402523617,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						9722891531031254,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8945186191139497,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						4606417903731315,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8397844840544531,
					[
					[
						106,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						4840482316794331,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"appear"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						3893513393252291,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						106,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						7834600045666086,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8295770791189097,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						8485516544178656,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_header"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8206769211432256,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						9958552190070688,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9348144774470609,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						1417518578777668,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achieve_description"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4723012654094344,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						683996011180633,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8498381796526672,
					[
					[
						100,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2247898586225615,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"achievement"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4421385969123644,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7975730704170075,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3303826940047703,
					[
					[
						43,
						cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
						null,
						0,
						false,
						false,
						false,
						2651964789119624,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9937198532720985,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						43,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6367575394065291,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5118882921872442,
					[
					[
						47,
						cr.plugins_.Sprite.prototype.cnds.IsOnScreen,
						null,
						0,
						false,
						false,
						false,
						8972095469365235,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7264835593088794,
						false
						,[
						[
							0,
							[
								1,
								3
							]
						]
						]
					]
,					[
						47,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						868251735274188,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						42,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3656017603703377,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Ending"],
			false,
			null,
			3146682864943014,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3146682864943014,
				false
				,[
				[
					1,
					[
						2,
						"Ending"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				5960803389949241,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5028162245759723,
					false
					,[
					[
						4,
						74
					]
					]
				]
,				[
					74,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					9525290713578302,
					false
					,[
					[
						5,
						[
							2,
							"Ending"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9734159515518898,
					[
					[
						73,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						5747594925581566,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6232437946916613,
						false
						,[
						[
							1,
							[
								2,
								"CloseAdBanner"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.CreateObject,
						null,
						3846888693303072,
						false
						,[
						[
							4,
							87
						]
,						[
							5,
							[
								2,
								"Gameover"
							]
						]
,						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								320
							]
						]
						]
					]
,					[
						87,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6360648675399237,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						87,
						cr.plugins_.Sprite.prototype.acts.MoveToBottom,
						null,
						7451253317730811,
						false
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerOpacity,
						null,
						944085506962388,
						false
						,[
						[
							5,
							[
								2,
								"Game"
							]
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerOpacity,
						null,
						5593227640639156,
						false
						,[
						[
							5,
							[
								2,
								"Interface"
							]
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerOpacity,
						null,
						4922512896363377,
						false
						,[
						[
							5,
							[
								2,
								"Background"
							]
						]
,						[
							0,
							[
								0,
								100
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						2931517030750708,
						false
						,[
						[
							5,
							[
								2,
								"Ending"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1214712460662697,
						false
						,[
						[
							1,
							[
								2,
								"Ending"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						31,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6970209795176067,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						30,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6015647558728663,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1530099396932129,
						false
						,[
						[
							1,
							[
								2,
								"GameOver"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3257332807149604,
						false
						,[
						[
							1,
							[
								2,
								"showScore"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						2015338744361041,
						false
						,[
						[
							1,
							[
								2,
								"CloseAdBanner"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5789540655780172,
						false
						,[
						[
							1,
							[
								2,
								"DeleteAdBanner"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						29,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5675550578760747,
						false
						,[
						[
							0,
							[
								0,
								568
							]
						]
,						[
							0,
							[
								0,
								490
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8805933861543807,
						[
						[
							7,
							cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
							null,
							0,
							false,
							false,
							false,
							7874240333306981,
							false
							,[
							[
								5,
								[
									2,
									"GameOver"
								]
							]
							]
						]
,						[
							8,
							cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
							null,
							0,
							false,
							false,
							false,
							4112304536018116,
							false
							,[
							[
								5,
								[
									2,
									"GameOver"
								]
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							57421848354803,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"gold_total"
								]
							]
							]
						]
						],
						[
						[
							8,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							533868375455525,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							7,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							244705966845764,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2400460107501636,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						4402413459184931,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							4090967945349296,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"revive"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2327448155109582,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3290317718046295,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							9605857835949824,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"total_gold"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							2167548190225737,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3876791232350133,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							3413512529911664,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"death_toll"
								]
							]
							]
						]
						],
						[
						[
							2,
							cr.plugins_.Text.prototype.acts.SetVisible,
							null,
							1621593846670314,
							false
							,[
							[
								3,
								0
							]
							]
						]
,						[
							-1,
							cr.system_object.prototype.acts.Wait,
							null,
							1176730512722583,
							false
							,[
							[
								0,
								[
									1,
									2
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8351996092559515,
							false
							,[
							[
								1,
								[
									2,
									"handleSound"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"voice_victory"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9098799983557671,
					[
					],
					[
					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8435164711446455,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									73,
									cr.plugins_.Sprite.prototype.exps.AnimationFrame,
									false,
									null
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "Tutorial"],
			false,
			null,
			8810782270673971,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8810782270673971,
				false
				,[
				[
					1,
					[
						2,
						"Tutorial"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1754226551791978,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					2632824866399389,
					false
					,[
					[
						4,
						74
					]
					]
				]
,				[
					74,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					5472217202042411,
					false
					,[
					[
						5,
						[
							2,
							"Tutorial"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5324894354520463,
					[
					[
						76,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						3240414846339904,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						204251608979445,
						false
						,[
						[
							1,
							[
								2,
								"Tutorial"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1609559172193893,
						false
						,[
						[
							1,
							[
								2,
								"GameLoop"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8055395307557755,
						false
						,[
						[
							5,
							[
								2,
								"Tutorial"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1198186176099432,
						false
						,[
						[
							1,
							[
								2,
								"GameLoop"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						3372065251342633,
						false
						,[
						[
							5,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5414511832200706,
						false
						,[
						[
							1,
							[
								2,
								"GameLoop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6832635218888431,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_menu"
									]
								]
,
								[
									7,
									[
										2,
										"stop"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6582967352959321,
						false
						,[
						[
							1,
							[
								2,
								"handleMusic"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"BGM_Stage1"
									]
								]
,
								[
									7,
									[
										2,
										"start"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2865367320879975,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3102312844429913,
						false
						,[
						[
							1,
							[
								2,
								"GameLoop"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						4473833149673811,
						false
						,[
						[
							5,
							[
								2,
								"Starting"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						6788013674229268,
						false
						,[
						[
							1,
							[
								2,
								"PlayTutorial"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						8237646300680257,
						false
						,[
						[
							1,
							[
								2,
								"Step1"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3003527390710282,
					[
					],
					[
					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7022772457797387,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									76,
									cr.plugins_.Sprite.prototype.exps.AnimationFrame,
									false,
									null
								]
								,[
									0,
									1
								]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2187421186929811,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				4599936134766833,
				false
				,[
				[
					0,
					[
						1,
						1
					]
				]
				]
			]
			],
			[
			[
				78,
				cr.plugins_.Text.prototype.acts.SetText,
				null,
				2291652631655362,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							"Revive: "
						]
						,[
							23,
							"revive"
						]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"GlobalFunctions",
		[
		[
			0,
			null,
			false,
			null,
			6032393999811175,
			[
			[
				3,
				cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
				null,
				0,
				false,
				false,
				false,
				7002675897359445,
				false
				,[
				[
					4,
					92
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8270520781747871,
				[
				[
					92,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7645661298761134,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"tweet"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8125111778858776,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						9531300758531838,
						false
						,[
						[
							1,
							[
								2,
								"SocialGold"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2023268106986181,
						false
						,[
						[
							1,
							[
								2,
								"gold"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"gold"
										]
										]
									]
									]
								]
								,[
									0,
									3000
								]
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5590740924401581,
						false
						,[
						[
							1,
							[
								2,
								"SocialGold"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				117110300123544,
				[
				[
					92,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6667743385396233,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"share"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5195687545140197,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						8053393478590567,
						false
						,[
						[
							1,
							[
								2,
								"SocialGold"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						752530088675871,
						false
						,[
						[
							1,
							[
								2,
								"gold"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"gold"
										]
										]
									]
									]
								]
								,[
									0,
									3000
								]
							]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5607288653827026,
						false
						,[
						[
							1,
							[
								2,
								"SocialGold"
							]
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5170215592351591,
			[
			[
				148,
				cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,
				"Fade",
				1,
				false,
				false,
				false,
				7783798098161257,
				false
			]
			],
			[
			[
				148,
				cr.plugins_.Sprite.prototype.acts.Destroy,
				null,
				2643769281849621,
				false
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4726125250764547,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				9146917604200262,
				false
				,[
				[
					0,
					[
						0,
						120
					]
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				5219853270062258,
				false
				,[
				[
					1,
					[
						2,
						"RefreshAdBanner"
					]
				]
,				[
					13,
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7446885285431484,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				7119010542624184,
				false
				,[
				[
					0,
					[
						0,
						120
					]
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.Function.prototype.acts.CallFunction,
				null,
				3626994001265115,
				false
				,[
				[
					1,
					[
						2,
						"RefreshAdFull"
					]
				]
,				[
					13,
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8666788751290763,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				5460817266482721,
				false
				,[
				[
					0,
					[
						1,
						0.5
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3735344933505621,
				[
				[
					152,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					3780432579355614,
					false
				]
				],
				[
				]
				,[
				[
					0,
					null,
					true,
					null,
					5064000040423723,
					[
					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						6287791742062852,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Solid"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						2440249575168248,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Exploder"
							]
						]
						]
					]
,					[
						152,
						cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						5413119714604506,
						false
						,[
						[
							10,
							2
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"Shooter"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4949596206114058,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							5971935595971189,
							false
							,[
							[
								1,
								[
									2,
									"Idle"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							4275030023113386,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						9383622660825575,
						[
						[
							152,
							cr.plugins_.Sprite.prototype.cnds.IsAnimPlaying,
							null,
							0,
							false,
							false,
							false,
							682548456584593,
							false
							,[
							[
								1,
								[
									2,
									"Shoot"
								]
							]
							]
						]
						],
						[
						[
							152,
							cr.plugins_.Sprite.prototype.acts.SetCollisions,
							null,
							5874283893900261,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9622176072004825,
				[
				[
					69,
					cr.plugins_.CJSAds.prototype.cnds.IsShowingBanner,
					null,
					0,
					false,
					false,
					false,
					7324097077990052,
					false
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5998367011783674,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9192761761813696,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6519431709880147,
				false
				,[
				[
					1,
					[
						2,
						"GameLoop"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7134008948249317,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					6119296758086571,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6650115607761208,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					8010674980870496,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8338928736937663,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7036446680555039,
				false
				,[
				[
					1,
					[
						2,
						"MainMenu"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4085492270133078,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					6329983862439959,
					false
					,[
					[
						0,
						[
							0,
							5
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5139374003996006,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					92547162024789,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
,					[
						13,
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1487003412752737,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				7200917177199853,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6288808661304124,
				[
				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					648420678057657,
					false
					,[
					[
						5,
						[
							2,
							"Upgrades"
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					8340362103552821,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					4269825770985632,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						8798535976865673,
						false
						,[
						[
							5,
							[
								2,
								"Upgrades"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						8397712448414297,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						3890354659859915,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								450
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						5811452392965295,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					946704943916129,
					[
					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						4206434292817803,
						false
						,[
						[
							5,
							[
								2,
								"Upgrades"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						496626499158493,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						4912940730013293,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								475
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						3835843339592724,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8682445093501898,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						8615165931384764,
						false
						,[
						[
							5,
							[
								2,
								"Upgrades"
							]
						]
						]
					]
					],
					[
					[
						52,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						2597285592089304,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4592884705915055,
				[
				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					2852045090679959,
					false
					,[
					[
						5,
						[
							2,
							"Achievements"
						]
					]
					]
				]
				],
				[
				[
					42,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					2239942050893016,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					6017868178795359,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						4257550773048283,
						false
						,[
						[
							5,
							[
								2,
								"Achievements"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						5495455385571357,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						5505929887460538,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								500
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						6307657473874421,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7828127237143752,
					[
					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						2559122679103246,
						false
						,[
						[
							5,
							[
								2,
								"Achievements"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						6922092472496432,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						2038835128417782,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								500
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						8777301259753568,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4922225179086131,
				[
				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					6306515098338656,
					false
					,[
					[
						5,
						[
							2,
							"Catalogue"
						]
					]
					]
				]
				],
				[
				[
					47,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					629174998343104,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					2148206900740198,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						2411889596450491,
						false
						,[
						[
							5,
							[
								2,
								"Catalogue"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						9784714592009496,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						6071697626869906,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								2600
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						9095326255536998,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3160522824216566,
					[
					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						6006933656238814,
						false
						,[
						[
							5,
							[
								2,
								"Catalogue"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						4068977444419174,
						false
						,[
						[
							8,
							4
						]
,						[
							0,
							[
								0,
								170
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareX,
						null,
						0,
						false,
						false,
						false,
						847516638641461,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								2600
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						5898753223005466,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2314424744237715,
				[
				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					1841542388006428,
					false
					,[
					[
						5,
						[
							2,
							"Characters"
						]
					]
					]
				]
				],
				[
				[
					83,
					cr.behaviors.Pin.prototype.acts.Pin,
					"Pin",
					8240199278061938,
					false
					,[
					[
						4,
						53
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					7539778173593101,
					[
					[
						2,
						cr.plugins_.Text.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						4963652900392094,
						false
						,[
						[
							5,
							[
								2,
								"Characters"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						4844612411873836,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								222
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						1689547763540865,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								0,
								520
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						7257250649954025,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					264679427140746,
					[
					[
						8,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						875128881313346,
						false
						,[
						[
							5,
							[
								2,
								"Characters"
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						7285440751763155,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								222
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.cnds.CompareY,
						null,
						0,
						false,
						false,
						false,
						1371071725766579,
						false
						,[
						[
							8,
							3
						]
,						[
							0,
							[
								0,
								520
							]
						]
						]
					]
					],
					[
					[
						8,
						cr.behaviors.Pin.prototype.acts.Pin,
						"Pin",
						3856975012540442,
						false
						,[
						[
							4,
							53
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9670713556728401,
			[
			[
				11,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				7861284412878389,
				false
				,[
				[
					1,
					[
						2,
						"setText"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2406745525704302,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					7698387435478762,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetText,
					null,
					8227243626864959,
					false
					,[
					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			347037626561937,
			[
			[
				11,
				cr.plugins_.Function.prototype.cnds.OnFunction,
				null,
				2,
				false,
				false,
				false,
				1627111092646459,
				false
				,[
				[
					1,
					[
						2,
						"setTextColor"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				26481528733489,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					5551240166394427,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Text.prototype.acts.SetFontColor,
					null,
					4244764531510402,
					false
					,[
					[
						0,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Browse"],
			false,
			null,
			1527291025135194,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1527291025135194,
				false
				,[
				[
					1,
					[
						2,
						"Browse"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"page",
				0,
				0,
true,false,2590408540653155,false
			]
,			[
				1,
				"layer",
				1,
				"",
true,false,2418518158234833,false
			]
,			[
				1,
				"maximumpage",
				0,
				0,
true,false,2653735554971595,false
			]
,			[
				0,
				null,
				false,
				null,
				2601746087193731,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					6014361328308633,
					false
					,[
					[
						1,
						[
							2,
							"initiateBrowsing"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9263153699971581,
					false
					,[
					[
						11,
						"page"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8319603536135004,
					false
					,[
					[
						11,
						"layer"
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1960786503475382,
					false
					,[
					[
						11,
						"maximumpage"
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					5941209049131161,
					false
					,[
					[
						1,
						[
							2,
							"arrowHandlingLeft"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"invisible"
								]
							]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4581068827395222,
					false
					,[
					[
						1,
						[
							2,
							"arrowHandlingRight"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"visible"
								]
							]
					]
					]
				]
,				[
					4,
					cr.plugins_.Browser.prototype.acts.ConsoleLog,
					null,
					7109618000223317,
					false
					,[
					[
						3,
						0
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					379591213488056,
					[
					[
						53,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						6894353414349009,
						false
						,[
						[
							5,
							[
								23,
								"layer"
							]
						]
						]
					]
					],
					[
					[
						53,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						442934470833342,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5228104934864355,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					9527930795408756,
					false
					,[
					[
						1,
						[
							2,
							"arrowHandlingLeft"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					372825556330379,
					[
					[
						57,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						4725337912699576,
						false
						,[
						[
							5,
							[
								23,
								"layer"
							]
						]
						]
					]
,					[
						57,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						2947289609233952,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6403375566753865,
						[
						[
							11,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							4207193187850521,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"visible"
								]
							]
							]
						]
						],
						[
						[
							57,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							9675997485084019,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						6834643094817447,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							8228770709850146,
							false
						]
						],
						[
						[
							57,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							1572395934115435,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3612527218163351,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					3652012311410252,
					false
					,[
					[
						1,
						[
							2,
							"arrowHandlingRight"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6178923612491186,
					[
					[
						57,
						cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
						null,
						0,
						false,
						false,
						false,
						7413600799271525,
						false
						,[
						[
							5,
							[
								23,
								"layer"
							]
						]
						]
					]
,					[
						57,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						6396580089912775,
						false
						,[
						[
							8,
							5
						]
,						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						6146384530926138,
						[
						[
							11,
							cr.plugins_.Function.prototype.cnds.CompareParam,
							null,
							0,
							false,
							false,
							false,
							1182675557369245,
							false
							,[
							[
								0,
								[
									0,
									0
								]
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"visible"
								]
							]
							]
						]
						],
						[
						[
							57,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							4522631447698652,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						3226556710291743,
						[
						[
							-1,
							cr.system_object.prototype.cnds.Else,
							null,
							0,
							false,
							false,
							false,
							5435584408765955,
							false
						]
						],
						[
						[
							57,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							437212226194479,
							false
							,[
							[
								3,
								0
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3174144352342835,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					7795778868941353,
					false
					,[
					[
						4,
						57
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					66148626967581,
					false
					,[
					[
						5,
						[
							23,
							"layer"
						]
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					2470127954636562,
					false
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.cnds.IsOnLayer,
					null,
					0,
					false,
					false,
					false,
					4152018160506092,
					false
					,[
					[
						5,
						[
							23,
							"layer"
						]
					]
					]
				]
				],
				[
				[
					58,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					432750832693812,
					false
				]
,				[
					58,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8024764541800239,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							-200
						]
					]
					]
				]
,				[
					48,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					7124638991085748,
					false
				]
,				[
					48,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5364386132657635,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							-200
						]
					]
					]
				]
,				[
					84,
					cr.behaviors.Pin.prototype.acts.Unpin,
					"Pin",
					5232196085020005,
					false
				]
,				[
					84,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1200660910868627,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
,					[
						0,
						[
							0,
							-200
						]
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					9031169735417658,
					[
					[
						57,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						6168816542419689,
						false
						,[
						[
							8,
							2
						]
,						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7793793543508467,
						false
						,[
						[
							1,
							[
								2,
								"arrowHandlingRight"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"visible"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						6877233546440079,
						false
						,[
						[
							11,
							"page"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						53,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						7676299183578653,
						false
						,[
						[
							0,
							[
								21,
								57,
								false,
								null
								,0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						7984887590771807,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9657670344320038,
							false
							,[
							[
								11,
								"page"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							8490304020497408,
							false
							,[
							[
								1,
								[
									2,
									"arrowHandlingLeft"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"invisible"
										]
									]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2870219781001825,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Else,
						null,
						0,
						false,
						false,
						false,
						4186274348808278,
						false
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3488889215354675,
						false
						,[
						[
							1,
							[
								2,
								"arrowHandlingLeft"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"visible"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6868598419080792,
						false
						,[
						[
							11,
							"page"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						53,
						cr.plugins_.Sprite.prototype.acts.MoveForward,
						null,
						7358753667541176,
						false
						,[
						[
							0,
							[
								6,
								[
									0,
									-1
								]
								,[
									21,
									57,
									false,
									null
									,0
								]
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Browser.prototype.acts.ConsoleLog,
						null,
						2608896040680651,
						false
						,[
						[
							3,
							0
						]
,						[
							7,
							[
								21,
								57,
								false,
								null
								,0
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3895710093007788,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							9200231826806484,
							false
							,[
							[
								11,
								"page"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									23,
									"maximumpage"
								]
							]
							]
						]
						],
						[
						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							7432690256590448,
							false
							,[
							[
								1,
								[
									2,
									"arrowHandlingRight"
								]
							]
,							[
								13,
																	[
										7,
										[
											2,
											"invisible"
										]
									]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9386270422086716,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					9717660116122209,
					false
					,[
					[
						4,
						57
					]
					]
				]
				],
				[
				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					8878174508281573,
					false
					,[
					[
						0,
						[
							1,
							1.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5866445945624267,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					3664939886722238,
					false
					,[
					[
						0,
						[
							1,
							1.4
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8298396055290504,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "ShopHandling"],
			false,
			null,
			6720918552689774,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6720918552689774,
				false
				,[
				[
					1,
					[
						2,
						"ShopHandling"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"shopbackbutton",
				1,
				"menu",
true,false,3557378021876165,false
			]
,			[
				1,
				"layout",
				1,
				"",
true,false,815711261875065,false
			]
,			[
				1,
				"layer",
				1,
				"",
true,false,6194920083854827,false
			]
,			[
				0,
				null,
				false,
				null,
				540984513115052,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					6609540205417496,
					false
					,[
					[
						1,
						[
							2,
							"handleShopMenu"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					2912608015200324,
					false
					,[
					[
						6,
						"Shop"
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9270372472051705,
					false
					,[
					[
						1,
						[
							2,
							"Shop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					9510680938699034,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3170258774480462,
					false
					,[
					[
						5,
						[
							2,
							"MenuShop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6781524554541812,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold"
								]
							]
,
							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1096219686644565,
					false
					,[
					[
						11,
						"shopbackbutton"
					]
,					[
						7,
						[
							2,
							"menu"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3491162781281147,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					1988025046574567,
					false
					,[
					[
						1,
						[
							2,
							"handleShopGame"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.GoToLayout,
					null,
					9653662474154541,
					false
					,[
					[
						6,
						"Shop"
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3656833815129662,
					false
					,[
					[
						1,
						[
							2,
							"Shop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2923784604030308,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					9971479567881805,
					false
					,[
					[
						5,
						[
							2,
							"MenuShop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					7003985236088407,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold"
								]
							]
,
							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6537882305085599,
					false
					,[
					[
						11,
						"shopbackbutton"
					]
,					[
						7,
						[
							2,
							"game"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2505543344151684,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					7279581595260889,
					false
					,[
					[
						1,
						[
							2,
							"handleShop"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					2217316886466937,
					false
					,[
					[
						11,
						"layer"
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					5679098464109594,
					false
					,[
					[
						11,
						"layout"
					]
,					[
						7,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								1
							]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					5437537207682741,
					false
					,[
					[
						5,
						[
							23,
							"layer"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					8213521823276721,
					false
					,[
					[
						1,
						[
							23,
							"layer"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					3126548730977164,
					false
					,[
					[
						1,
						[
							2,
							"Shop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					7322233492323746,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6788267861052639,
					false
					,[
					[
						5,
						[
							2,
							"Shop"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					1232251058708259,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold"
								]
							]
,
							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
					]
					]
				]
				]
			]
,			[
				1,
				"IAP",
				1,
				"",
true,false,3813672032156233,false
			]
,			[
				1,
				"IAPgold",
				0,
				0,
true,false,1665690663772936,false
			]
,			[
				0,
				[false, "Shop_Buttons"],
				false,
				null,
				4232106768578176,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					4232106768578176,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6367181785955031,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchStart,
						null,
						1,
						false,
						false,
						false,
						6486988313074546,
						false
					]
,					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						2490080939692721,
						false
						,[
						[
							4,
							141
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4332187299116763,
						false
						,[
						[
							11,
							"shopbackbutton"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"menu"
							]
						]
						]
					]
					],
					[
					[
						141,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						5261268163443612,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						953879323212194,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						141,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						9965719929442431,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2561075442344357,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3080327418019375,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop_Closed"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4703027780255303,
						false
						,[
						[
							1,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1887654418298175,
						false
						,[
						[
							1,
							[
								2,
								"Shop_Buttons"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						6946855919824414,
						false
						,[
						[
							5,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8992152217418889,
						false
						,[
						[
							5,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						3647746963002867,
						false
						,[
						[
							1,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6356426720006183,
						false
						,[
						[
							0,
							[
								1,
								0.5
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.GoToLayout,
						null,
						486353829645016,
						false
						,[
						[
							6,
							"Menu"
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						9046468639918219,
						false
						,[
						[
							5,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1561799954086155,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchStart,
						null,
						1,
						false,
						false,
						false,
						2216607982011758,
						false
					]
,					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						1804912608352753,
						false
						,[
						[
							4,
							141
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3568768411440644,
						false
						,[
						[
							11,
							"shopbackbutton"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"game"
							]
						]
						]
					]
					],
					[
					[
						141,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						9938013590916291,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						109110438328041,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						141,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						8661802926991017,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7606555298985924,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8033493519765433,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop_Closed"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5627738586470433,
						false
						,[
						[
							1,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5468583585182706,
						false
						,[
						[
							1,
							[
								2,
								"Shop_Buttons"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						6611566218925068,
						false
						,[
						[
							5,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						4821296432487823,
						false
						,[
						[
							5,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						6183124584132653,
						false
						,[
						[
							1,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4345407808904241,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.GoToLayout,
						null,
						744651871062294,
						false
						,[
						[
							6,
							"Game"
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.LoadState,
						null,
						5990100398426279,
						false
						,[
						[
							1,
							[
								2,
								"mysave"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6255091884654884,
					[
					[
						-1,
						cr.system_object.prototype.cnds.OnLoadComplete,
						null,
						1,
						false,
						false,
						false,
						6023468021749093,
						false
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6215660199469122,
						false
						,[
						[
							11,
							"gold_collected"
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						6448301486800636,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										23,
										"gold_collected"
									]
								]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						5006701885256693,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold_total"
									]
								]
,
								[
									7,
									[
										19,
										cr.system_object.prototype.exps["int"]
										,[
[
											20,
											40,
											cr.plugins_.WebStorage.prototype.exps.LocalValue,
											true,
											null
											,[
[
												2,
												"gold"
											]
											]
										]
										]
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						8412867914947791,
						false
						,[
						[
							5,
							[
								2,
								"ShopLoading"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						8766721424288619,
						false
						,[
						[
							1,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						7699849169824244,
						false
						,[
						[
							1,
							[
								2,
								"Shop_Buttons"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						69,
						cr.plugins_.CJSAds.prototype.acts.ShowBanner,
						null,
						1269559729060735,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3263049797127155,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchStart,
						null,
						1,
						false,
						false,
						false,
						1501700490312041,
						false
					]
,					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						9785999611265302,
						false
						,[
						[
							4,
							10
						]
						]
					]
					],
					[
					[
						10,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						5422855646332084,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6877550936679915,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						10,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						8661716993054078,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1493687614182612,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						9549018477682341,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop_Closed"
							]
						]
,						[
							13,
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						8118414228241922,
						false
						,[
						[
							1,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						8341082603939742,
						false
						,[
						[
							1,
							[
								2,
								"Shop_Buttons"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						2597916228611702,
						false
						,[
						[
							5,
							[
								2,
								"Shop"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						4783321458940046,
						false
						,[
						[
							5,
							[
								23,
								"layer"
							]
						]
,						[
							3,
							1
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						1089196425881498,
						false
						,[
						[
							1,
							[
								23,
								"layer"
							]
						]
,						[
							3,
							1
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6346534690796875,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchObject,
						null,
						1,
						false,
						false,
						false,
						5616331914967778,
						false
						,[
						[
							4,
							71
						]
						]
					]
					],
					[
					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetPosToObject,
						null,
						4123344657383267,
						false
						,[
						[
							4,
							71
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6454183813906049,
						false
						,[
						[
							11,
							"IAP"
						]
,						[
							7,
							[
								21,
								71,
								true,
								null
								,0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9738757361353694,
						false
						,[
						[
							11,
							"IAPgold"
						]
,						[
							7,
							[
								21,
								71,
								false,
								null
								,1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9578606240155854,
					[
					[
						3,
						cr.plugins_.Touch.prototype.cnds.OnTouchStart,
						null,
						1,
						false,
						false,
						false,
						7961850702854558,
						false
					]
,					[
						3,
						cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
						null,
						0,
						false,
						false,
						false,
						7779558115331655,
						false
						,[
						[
							4,
							9
						]
						]
					]
					],
					[
					[
						9,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						4017348876501444,
						false
						,[
						[
							0,
							[
								1,
								0.9
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						781689746229656,
						false
						,[
						[
							0,
							[
								1,
								0.2
							]
						]
						]
					]
,					[
						9,
						cr.plugins_.Sprite.prototype.acts.SetScale,
						null,
						6775976348782896,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1039071836205294,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						8180297998261845,
						[
						[
							69,
							cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
							null,
							0,
							false,
							false,
							false,
							5297897204345449,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							2492861461895471,
							[
							[
								69,
								cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,
								null,
								0,
								false,
								false,
								false,
								6981366391895367,
								false
							]
							],
							[
							[
								69,
								cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,
								null,
								293890667650935,
								false
								,[
								[
									1,
									[
										23,
										"IAP"
									]
								]
								]
							]
,							[
								78,
								cr.plugins_.Text.prototype.acts.AppendText,
								null,
								5145240338789033,
								false
								,[
								[
									7,
									[
										10,
										[
											2,
											"\nStore available. IAP is"
										]
										,[
											23,
											"IAP"
										]
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								600049909214135,
								false
								,[
								[
									1,
									[
										2,
										"PopUp_Shop"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Shop"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"please_wait"
											]
										]
								]
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1693759995501647,
						[
						[
							69,
							cr.plugins_.CJSAds.prototype.cnds.IsCocoonJS,
							null,
							0,
							false,
							true,
							false,
							6405609037920605,
							false
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							8441122931795661,
							[
							[
								69,
								cr.plugins_.CJSAds.prototype.cnds.IsStoreAvailable,
								null,
								0,
								false,
								true,
								false,
								9232727486746031,
								false
							]
							],
							[
							[
								78,
								cr.plugins_.Text.prototype.acts.AppendText,
								null,
								3649952170476006,
								false
								,[
								[
									7,
									[
										2,
										"\nFetch failed"
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9534166116004785,
								false
								,[
								[
									1,
									[
										2,
										"PopUp_Shop"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"Shop"
											]
										]
,
										[
											7,
											[
												2,
												"ok"
											]
										]
,
										[
											7,
											[
												2,
												"unavailable"
											]
										]
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[false, "Shop"],
				false,
				null,
				7786447906682515,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7786447906682515,
					false
					,[
					[
						1,
						[
							2,
							"Shop"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9491780390404092,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,
						null,
						1,
						false,
						false,
						false,
						6086225174742426,
						false
					]
					],
					[
					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						3693016598775924,
						false
						,[
						[
							7,
							[
								2,
								"\nFetch failed"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						7716054717804046,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"purchase_failed"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8039862850102383,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
						null,
						1,
						false,
						false,
						false,
						9955953648326385,
						false
					]
					],
					[
					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						4221114738111514,
						false
						,[
						[
							7,
							[
								2,
								"\nFetch completed"
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						6165194585572701,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									"\nCount "
								]
								,[
									20,
									69,
									cr.plugins_.CJSAds.prototype.exps.ProductCount,
									false,
									null
								]
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						743221111132566,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									"\nTItle "
								]
								,[
									20,
									69,
									cr.plugins_.CJSAds.prototype.exps.ProductTitle,
									true,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						3997888693765603,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									"\nID "
								]
								,[
									20,
									69,
									cr.plugins_.CJSAds.prototype.exps.ProductID,
									true,
									null
									,[
[
										0,
										0
									]
									]
								]
							]
						]
						]
					]
,					[
						69,
						cr.plugins_.CJSAds.prototype.acts.Purchase,
						null,
						3750337504559525,
						false
						,[
						[
							1,
							[
								23,
								"IAP"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8483860676008243,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"processing"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9115464742905168,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,
						null,
						1,
						false,
						false,
						false,
						771349198701118,
						false
						,[
						[
							1,
							[
								23,
								"IAP"
							]
						]
						]
					]
					],
					[
					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						6350319798130564,
						false
						,[
						[
							7,
							[
								2,
								"\npurchase started"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8837715659412653,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"processing"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7616565528031808,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
						null,
						1,
						false,
						false,
						false,
						3379779068552604,
						false
						,[
						[
							1,
							[
								23,
								"IAP"
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8780324301208564,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"purchase_completed"
									]
								]
						]
						]
					]
,					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						4130807765510304,
						false
						,[
						[
							7,
							[
								10,
								[
									10,
									[
										10,
										[
											10,
											[
												2,
												"\npurchase working, you reveived "
											]
											,[
												23,
												"IAPgold"
											]
										]
										,[
											2,
											" gold. You have "
										]
									]
									,[
										4,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
											]
										]
										,[
											23,
											"IAPgold"
										]
									]
								]
								,[
									2,
									"gold now"
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						8644517416561379,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"gold"
									]
								]
,
								[
									7,
									[
										4,
										[
											19,
											cr.system_object.prototype.exps["int"]
											,[
[
												20,
												40,
												cr.plugins_.WebStorage.prototype.exps.LocalValue,
												true,
												null
												,[
[
													2,
													"gold"
												]
												]
											]
											]
										]
										,[
											23,
											"IAPgold"
										]
									]
								]
						]
						]
					]
,					[
						40,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						744672834363211,
						false
						,[
						[
							1,
							[
								2,
								"gold"
							]
						]
,						[
							7,
							[
								4,
								[
									19,
									cr.system_object.prototype.exps["int"]
									,[
[
										20,
										40,
										cr.plugins_.WebStorage.prototype.exps.LocalValue,
										true,
										null
										,[
[
											2,
											"gold"
										]
										]
									]
									]
								]
								,[
									23,
									"IAPgold"
								]
							]
						]
						]
					]
,					[
						69,
						cr.plugins_.CJSAds.prototype.acts.ConsumePurchase,
						null,
						1541692275892189,
						false
						,[
						[
							1,
							[
								20,
								69,
								cr.plugins_.CJSAds.prototype.exps.PurchaseTransactionId,
								true,
								null
							]
						]
,						[
							1,
							[
								20,
								69,
								cr.plugins_.CJSAds.prototype.exps.PurchaseProductId,
								true,
								null
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						3031471391883698,
						[
						[
							71,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							6511317934511868,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"sammustudios.colossaldefenders.iap02"
								]
							]
							]
						]
,						[
							71,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							2045801880122063,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"sammustudios.colossaldefenders.iap03"
								]
							]
							]
						]
,						[
							71,
							cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							5698427528040501,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"sammustudios.colossaldefenders.iap04"
								]
							]
							]
						]
						],
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.acts.StoreLocal,
							null,
							881704345914935,
							false
							,[
							[
								1,
								[
									2,
									"AdToggle"
								]
							]
,							[
								7,
								[
									0,
									1
								]
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							2551356563978243,
							false
							,[
							[
								1,
								[
									2,
									"CloseAdBanner"
								]
							]
,							[
								13,
							]
							]
						]
,						[
							11,
							cr.plugins_.Function.prototype.acts.CallFunction,
							null,
							6541443882734293,
							false
							,[
							[
								1,
								[
									2,
									"DeleteAdBanner"
								]
							]
,							[
								13,
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9427950838096017,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
						null,
						1,
						false,
						false,
						false,
						4526244817544767,
						false
						,[
						[
							1,
							[
								23,
								"IAP"
							]
						]
						]
					]
					],
					[
					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						320052757637422,
						false
						,[
						[
							7,
							[
								2,
								"\npurchase failed"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						3517661065869328,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"purchase_failed"
									]
								]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1440139459271007,
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
						null,
						1,
						false,
						false,
						false,
						2912705169291665,
						false
					]
					],
					[
					[
						78,
						cr.plugins_.Text.prototype.acts.AppendText,
						null,
						2322337030005146,
						false
						,[
						[
							7,
							[
								2,
								"\npurchase failed"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1892253201284487,
						false
						,[
						[
							1,
							[
								2,
								"PopUp_Shop"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"Shop"
									]
								]
,
								[
									7,
									[
										2,
										"ok"
									]
								]
,
								[
									7,
									[
										2,
										"purchase_failed"
									]
								]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "PopUp_Shop"],
			false,
			null,
			9188752384855334,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9188752384855334,
				false
				,[
				[
					1,
					[
						2,
						"PopUp_Shop"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1252195087180319,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5418772585290233,
					false
					,[
					[
						1,
						[
							2,
							"PopUp_Shop"
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2048385763086097,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"popup_error"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8006276001262383,
					false
					,[
					[
						5,
						[
							2,
							"PopUp"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					98,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					653479199209226,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2115990013509633,
					false
					,[
					[
						1,
						[
							2,
							"Browse"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2537147432076551,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					510906813903265,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						9583152319162701,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ok"
							]
						]
						]
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						94917511935192,
						false
						,[
						[
							8,
							0
						]
,						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						1490063030820607,
						false
						,[
						[
							3,
							1
						]
						]
					]
					]
					,[
					[
						0,
						null,
						false,
						null,
						3615028954150017,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1505192437343756,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"popup_error"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							3597195236320902,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								6038153543971733,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"purchase_completed"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								4096589776050925,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											0
										]
,[
											0,
											255
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								5373693432904205,
								false
								,[
								[
									7,
									[
										2,
										"Purchase Completed!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3573614203275094,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								78396408587731,
								false
								,[
								[
									1,
									[
										2,
										"PopUp_Shop_Closed"
									]
								]
,								[
									13,
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								2751899756634741,
								false
								,[
								[
									1,
									[
										2,
										"setText"
									]
								]
,								[
									13,
																			[
											7,
											[
												2,
												"gold_total"
											]
										]
,
										[
											7,
											[
												19,
												cr.system_object.prototype.exps["int"]
												,[
[
													20,
													40,
													cr.plugins_.WebStorage.prototype.exps.LocalValue,
													true,
													null
													,[
[
														2,
														"gold"
													]
													]
												]
												]
											]
										]
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							916268005421656,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8579961506544361,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"purchase_failed"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								7628661002400082,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3542664822851771,
								false
								,[
								[
									7,
									[
										2,
										"Purchase Failed!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8362057085020115,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								7591873449712291,
								false
								,[
								[
									1,
									[
										2,
										"PopUp_Shop_Closed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8404239139754176,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								7961682668405213,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"unavailable"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								5639993764762097,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								1453281533261531,
								false
								,[
								[
									7,
									[
										2,
										"Unavailable!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								3949942752385797,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8376279990914345,
								false
								,[
								[
									1,
									[
										2,
										"PopUp_Shop_Closed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3865318035448344,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8871773093642414,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"please_wait"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								2131471943383984,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											255
										]
,[
											0,
											255
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								5037633725225821,
								false
								,[
								[
									7,
									[
										2,
										"Please Wait.."
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetGroupActive,
								null,
								4497256132713158,
								false
								,[
								[
									1,
									[
										2,
										"Shop_Buttons"
									]
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							2247994941552056,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								3857985760410922,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"processing"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								9566182837647285,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											255
										]
,[
											0,
											255
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								8872658195533163,
								false
								,[
								[
									7,
									[
										2,
										"Processing.."
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.SetGroupActive,
								null,
								2658205184338463,
								false
								,[
								[
									1,
									[
										2,
										"Shop_Buttons"
									]
								]
,								[
									3,
									0
								]
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4939232789335203,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					7826698105597213,
					false
					,[
					[
						1,
						[
							2,
							"PopUp_Shop_Closed"
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					1352777176450722,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"popup_error"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					3078277262604268,
					false
					,[
					[
						5,
						[
							2,
							"PopUp"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					98,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9565226511666422,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					2,
					cr.plugins_.Text.prototype.acts.SetVisible,
					null,
					2816466553996789,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6276889999120768,
					false
					,[
					[
						1,
						[
							2,
							"Browse"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2012344369116718,
					false
					,[
					[
						1,
						[
							2,
							"Shop_Buttons"
						]
					]
,					[
						3,
						1
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "PopUp"],
			false,
			null,
			2377232193260023,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2377232193260023,
				false
				,[
				[
					1,
					[
						2,
						"PopUp"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				1,
				"layer_before",
				1,
				"",
true,false,1313292385038308,false
			]
,			[
				1,
				"confirmFunction",
				1,
				"",
true,false,8068683542945303,false
			]
,			[
				0,
				null,
				false,
				null,
				1252195087180319,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5418772585290233,
					false
					,[
					[
						1,
						[
							2,
							"PopUp"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					8006276001262383,
					false
					,[
					[
						5,
						[
							2,
							"PopUp"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					6443568294079519,
					false
					,[
					[
						1,
						[
							2,
							"Browse"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					98,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					653479199209226,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					510906813903265,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						9583152319162701,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"ok"
							]
						]
						]
					]
,					[
						49,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						94917511935192,
						false
						,[
						[
							8,
							0
						]
,						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						3615028954150017,
						[
						[
							2,
							cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
							null,
							0,
							false,
							false,
							false,
							1505192437343756,
							false
							,[
							[
								10,
								0
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									2,
									"popup_error"
								]
							]
							]
						]
						],
						[
						]
						,[
						[
							0,
							null,
							false,
							null,
							2218193455705464,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								4771037650553419,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"gold"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								2084768482734689,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								8562807170616003,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								8372337919055801,
								false
								,[
								[
									7,
									[
										2,
										"Not enough gold!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								9072907538642955,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								9122612116731793,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8886530818110826,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								5061616185053988,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"already_purchased"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								8528798594840676,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								6785266513099379,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								4270192202552827,
								false
								,[
								[
									7,
									[
										2,
										"Already Purchased!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								4302596994452922,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3293573745276755,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							5207493534598158,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8714944235822523,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"unlocked"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								9675737753304496,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								7895030318721535,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											0
										]
,[
											0,
											255
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								4153050896837115,
								false
								,[
								[
									7,
									[
										2,
										"Unlocked!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								7511989473199793,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								8425138776199493,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							8369206463579088,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								5004196770008493,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"limit"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								6861554363295348,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								3384726451811609,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								5237807317213952,
								false
								,[
								[
									7,
									[
										2,
										"Limit reached!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								8914283414574473,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								4953047406623582,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							3597195236320902,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								6038153543971733,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"purchase_completed"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								9011562440496229,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								4096589776050925,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								5373693432904205,
								false
								,[
								[
									7,
									[
										2,
										"Purchase Completed!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								1380614777657038,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								318371276910799,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
,						[
							0,
							null,
							false,
							null,
							916268005421656,
							[
							[
								11,
								cr.plugins_.Function.prototype.cnds.CompareParam,
								null,
								0,
								false,
								false,
								false,
								8579961506544361,
								false
								,[
								[
									0,
									[
										0,
										2
									]
								]
,								[
									8,
									0
								]
,								[
									7,
									[
										2,
										"purchase_failed"
									]
								]
								]
							]
							],
							[
							[
								2,
								cr.plugins_.Text.prototype.acts.SetVisible,
								null,
								8059170556031134,
								false
								,[
								[
									3,
									1
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetFontColor,
								null,
								7628661002400082,
								false
								,[
								[
									0,
									[
										19,
										cr.system_object.prototype.exps.rgb
										,[
[
											0,
											255
										]
,[
											0,
											0
										]
,[
											0,
											0
										]
										]
									]
								]
								]
							]
,							[
								2,
								cr.plugins_.Text.prototype.acts.SetText,
								null,
								3542664822851771,
								false
								,[
								[
									7,
									[
										2,
										"Purchase Failed!"
									]
								]
								]
							]
,							[
								-1,
								cr.system_object.prototype.acts.Wait,
								null,
								1696103977859989,
								false
								,[
								[
									0,
									[
										1,
										1
									]
								]
								]
							]
,							[
								11,
								cr.plugins_.Function.prototype.acts.CallFunction,
								null,
								3657927370779422,
								false
								,[
								[
									1,
									[
										2,
										"PopUpClosed"
									]
								]
,								[
									13,
								]
								]
							]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8907066631213056,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						9634678674989339,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"confirm"
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
						null,
						0,
						false,
						false,
						false,
						972588798156974,
						false
						,[
						[
							10,
							0
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"popup_error"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						5310946018032106,
						false
						,[
						[
							1,
							[
								2,
								"Options"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetGroupActive,
						null,
						4414983432520471,
						false
						,[
						[
							1,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetLayerVisible,
						null,
						3698219405951389,
						false
						,[
						[
							5,
							[
								2,
								"TitleScreen"
							]
						]
,						[
							3,
							0
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetVisible,
						null,
						2364424453306126,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						2,
						cr.plugins_.Text.prototype.acts.SetFontColor,
						null,
						5568799571564951,
						false
						,[
						[
							0,
							[
								19,
								cr.system_object.prototype.exps.rgb
								,[
[
									0,
									255
								]
,[
									0,
									255
								]
,[
									0,
									255
								]
								]
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						447736498359124,
						false
						,[
						[
							1,
							[
								2,
								"setText"
							]
						]
,						[
							13,
															[
									7,
									[
										2,
										"popup_error"
									]
								]
,
								[
									7,
									[
										2,
										"Are you sure?"
									]
								]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5606530398519379,
						false
						,[
						[
							11,
							"confirmFunction"
						]
,						[
							7,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									2
								]
								]
							]
						]
						]
					]
					]
					,[
					[
						0,
						null,
						true,
						null,
						5351588740719306,
						[
						[
							49,
							cr.plugins_.Sprite.prototype.cnds.CompareFrame,
							null,
							0,
							false,
							false,
							false,
							5912594126250548,
							false
							,[
							[
								8,
								0
							]
,							[
								0,
								[
									0,
									0
								]
							]
							]
						]
,						[
							49,
							cr.plugins_.Sprite.prototype.cnds.CompareFrame,
							null,
							0,
							false,
							false,
							false,
							1703417395038264,
							false
							,[
							[
								8,
								0
							]
,							[
								0,
								[
									0,
									1
								]
							]
							]
						]
						],
						[
						[
							49,
							cr.plugins_.Sprite.prototype.acts.SetVisible,
							null,
							271028034624683,
							false
							,[
							[
								3,
								1
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3125890366473438,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5628081023522944,
					false
					,[
					[
						1,
						[
							2,
							"PopUpClosed"
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					4733132658166415,
					false
					,[
					[
						1,
						[
							2,
							"hideButtons"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					7386119727022662,
					false
					,[
					[
						5,
						[
							2,
							"PopUp"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					5297109760369023,
					false
					,[
					[
						1,
						[
							2,
							"Browse"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					98,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3901555991402982,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9630866175673582,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchStart,
					null,
					1,
					false,
					false,
					false,
					3067189294402882,
					false
				]
,				[
					3,
					cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
					null,
					0,
					false,
					false,
					false,
					7485231512125582,
					false
					,[
					[
						4,
						49
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					4794114695204894,
					false
				]
				],
				[
				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					6211013082337351,
					false
					,[
					[
						0,
						[
							1,
							0.9
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4030350535214146,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetScale,
					null,
					5573468363402343,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4485033571584385,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3555214495575158,
					false
					,[
					[
						1,
						[
							2,
							"hideButtons"
						]
					]
,					[
						13,
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetLayerVisible,
					null,
					6035296514263122,
					false
					,[
					[
						5,
						[
							2,
							"PopUp"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1514512511616996,
					false
					,[
					[
						1,
						[
							2,
							"Options"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					1754447499800062,
					false
					,[
					[
						1,
						[
							2,
							"Browse"
						]
					]
,					[
						3,
						1
					]
					]
				]
,				[
					98,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4853056836042464,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
				,[
				[
					0,
					null,
					false,
					null,
					3594415647434718,
					[
					[
						49,
						cr.plugins_.Sprite.prototype.cnds.CompareFrame,
						null,
						0,
						false,
						false,
						false,
						557627581076886,
						false
						,[
						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						11,
						cr.plugins_.Function.prototype.acts.CallFunction,
						null,
						1087895385291177,
						false
						,[
						[
							1,
							[
								23,
								"confirmFunction"
							]
						]
,						[
							13,
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9204349608812638,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					2567850489277584,
					false
					,[
					[
						1,
						[
							2,
							"hideButtons"
						]
					]
					]
				]
				],
				[
				[
					49,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3733642110442374,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "HandleSound"],
			false,
			null,
			8544364066462909,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8544364066462909,
				false
				,[
				[
					1,
					[
						2,
						"HandleSound"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				3828293680098871,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					7294560665190567,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					6274912130581457,
					false
					,[
					[
						1,
						[
							2,
							"fx_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					77,
					cr.plugins_.Audio.prototype.acts.PlayByName,
					null,
					3374596897218837,
					false
					,[
					[
						3,
						0
					]
,					[
						1,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
,					[
						3,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
,					[
						1,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6984124697905334,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					662450063976,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9656958212009671,
					false
					,[
					[
						1,
						[
							2,
							"bg_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8934144080921104,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						6586823246734093,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"start"
							]
						]
						]
					]
					],
					[
					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						3393235479645142,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							1
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9238350817389166,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						4825449201397929,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"start_nonloop"
							]
						]
						]
					]
					],
					[
					[
						77,
						cr.plugins_.Audio.prototype.acts.PlayByName,
						null,
						7945586227936163,
						false
						,[
						[
							3,
							1
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
,						[
							3,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
,						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4859056582591514,
					[
					[
						11,
						cr.plugins_.Function.prototype.cnds.CompareParam,
						null,
						0,
						false,
						false,
						false,
						2387381225972643,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								2,
								"stop"
							]
						]
						]
					]
					],
					[
					[
						77,
						cr.plugins_.Audio.prototype.acts.Stop,
						null,
						1806099989977729,
						false
						,[
						[
							1,
							[
								20,
								11,
								cr.plugins_.Function.prototype.exps.Param,
								false,
								null
								,[
[
									0,
									0
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				638387181325811,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					790104349577355,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					2752582530772929,
					false
					,[
					[
						1,
						[
							2,
							"fx_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMuted,
					null,
					6765598119119185,
					false
					,[
					[
						1,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4990611146717342,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					4584184572614139,
					false
					,[
					[
						1,
						[
							2,
							"handleMusic"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					9054868757759459,
					false
					,[
					[
						1,
						[
							2,
							"bg_sound"
						]
					]
,					[
						8,
						0
					]
,					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					77,
					cr.plugins_.Audio.prototype.acts.SetMuted,
					null,
					8238644820007146,
					false
					,[
					[
						1,
						[
							20,
							11,
							cr.plugins_.Function.prototype.exps.Param,
							false,
							null
							,[
[
								0,
								0
							]
							]
						]
					]
,					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "AdToggle"],
			false,
			null,
			9692377597816136,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9692377597816136,
				false
				,[
				[
					1,
					[
						2,
						"AdToggle"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4116644069280472,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					3835050224659275,
					false
					,[
					[
						1,
						[
							2,
							"PreloadAdBanner"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9275901149417504,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						2123936016759719,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.PreloadBanner,
						null,
						4644477327046718,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7491226588661821,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5882070460132899,
					false
					,[
					[
						1,
						[
							2,
							"PreloadAdFull"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					7523569848454307,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						4067449425752085,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,
						null,
						9735991270542988,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8414479984562579,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					5551312175985687,
					false
					,[
					[
						1,
						[
							2,
							"RefreshAdFull"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6595471468471392,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						8712119758482677,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.RefreshFullScreen,
						null,
						6694983476629156,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6363178526292879,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					9752738944095237,
					false
					,[
					[
						1,
						[
							2,
							"RefreshAdBanner"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3601297868181114,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						5584208732940783,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.RefreshBanner,
						null,
						8754834820848202,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3933009773333882,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					4314054025682872,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdBanner"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4215818610569142,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						391306109977503,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.ShowBanner,
						null,
						9147935118609292,
						false
						,[
						[
							3,
							0
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4064033058190329,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					3947078678530023,
					false
					,[
					[
						1,
						[
							2,
							"ShowAdFull"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					937820399294323,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						814571301389785,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
						null,
						6214225777718151,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				547308513812568,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					4326253354015319,
					false
					,[
					[
						1,
						[
							2,
							"CloseAdBanner"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					621630163153952,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						3864000909580494,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.HideBanner,
						null,
						8828386219232529,
						false
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3272184874785639,
				[
				[
					11,
					cr.plugins_.Function.prototype.cnds.OnFunction,
					null,
					2,
					false,
					false,
					false,
					8243178734974084,
					false
					,[
					[
						1,
						[
							2,
							"DeleteAdBanner"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					4911468362830817,
					[
					[
						40,
						cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
						null,
						0,
						false,
						false,
						false,
						587160291558023,
						false
						,[
						[
							1,
							[
								2,
								"AdToggle"
							]
						]
,						[
							8,
							0
						]
,						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						69,
						cr.plugins_.CJSAds.prototype.acts.HideBanner,
						null,
						5127922915912973,
						false
					]
					]
				]
				]
			]
			]
		]
		]
	]
,	[
		"Shop",
		[
		[
			2,
			"GlobalFunctions",
			false
		]
,		[
			0,
			null,
			false,
			null,
			9303616613772589,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				67226009685714,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7811685186768847,
				[
				[
					2,
					cr.plugins_.Text.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					2429846531477804,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"gold"
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.WebStorage.prototype.cnds.CompareKeyNumber,
					null,
					0,
					false,
					false,
					false,
					5824150883003199,
					false
					,[
					[
						1,
						[
							2,
							"gold"
						]
					]
,					[
						8,
						1
					]
,					[
						0,
						[
							19,
							cr.system_object.prototype.exps["int"]
							,[
[
								20,
								2,
								cr.plugins_.Text.prototype.exps.Text,
								true,
								null
							]
							]
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					6025298195547809,
					false
					,[
					[
						1,
						[
							2,
							"setText"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"gold"
								]
							]
,
							[
								7,
								[
									20,
									40,
									cr.plugins_.WebStorage.prototype.exps.LocalValue,
									true,
									null
									,[
[
										2,
										"gold"
									]
									]
								]
							]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			3981099464805327,
			[
			[
				-1,
				cr.system_object.prototype.cnds.EveryTick,
				null,
				0,
				false,
				false,
				false,
				3983813916805343,
				false
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4849017708816185,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					1530231529323111,
					false
					,[
					[
						4,
						141
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					9818029676535291,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"button_close"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1683869985777518,
				[
				[
					3,
					cr.plugins_.Touch.prototype.cnds.OnTouchObject,
					null,
					1,
					false,
					false,
					false,
					5249889631021678,
					false
					,[
					[
						4,
						9
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.Function.prototype.acts.CallFunction,
					null,
					3146049742949504,
					false
					,[
					[
						1,
						[
							2,
							"handleSound"
						]
					]
,					[
						13,
													[
								7,
								[
									2,
									"button_confirm"
								]
							]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4502028716326787,
				[
				[
					71,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					4104218869194476,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"sammustudios.colossaldefenders.iap01"
						]
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3335125331441604,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2495283236148302,
				[
				[
					71,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					6184240264764212,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"sammustudios.colossaldefenders.iap02"
						]
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					1065514672296581,
					false
					,[
					[
						0,
						[
							0,
							2
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8523278298048704,
				[
				[
					71,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					3270454769257286,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"sammustudios.colossaldefenders.iap03"
						]
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					7304280010487126,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				617995473714244,
				[
				[
					71,
					cr.plugins_.Sprite.prototype.cnds.CompareInstanceVar,
					null,
					0,
					false,
					false,
					false,
					8001212493899418,
					false
					,[
					[
						10,
						0
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							2,
							"sammustudios.colossaldefenders.iap04"
						]
					]
					]
				]
				],
				[
				[
					71,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9546652139047887,
					false
					,[
					[
						0,
						[
							0,
							4
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[false, "ShopLoading"],
			false,
			null,
			4159071795393429,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4159071795393429,
				false
				,[
				[
					1,
					[
						2,
						"ShopLoading"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				4653701941710566,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					false,
					false,
					7026164204577836,
					false
					,[
					[
						5,
						[
							2,
							"ShopLoading"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3679285740224555,
					[
					[
						125,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						542942064081626,
						false
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						7485110928675127,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9212415796675906,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"normal"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							2444805646611042,
							false
							,[
							[
								1,
								[
									2,
									"Normal"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							7859824548479743,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						78489681785463,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							9968670129955401,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"mecha"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							494633618875092,
							false
							,[
							[
								1,
								[
									2,
									"Mecha"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							2906415544723106,
							false
							,[
							[
								0,
								[
									0,
									415
								]
							]
,							[
								0,
								[
									0,
									207
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8505734215916296,
						[
						[
							40,
							cr.plugins_.WebStorage.prototype.cnds.CompareKeyText,
							null,
							0,
							false,
							false,
							false,
							6691241922033321,
							false
							,[
							[
								1,
								[
									2,
									"suit"
								]
							]
,							[
								1,
								[
									2,
									"rainbow"
								]
							]
,							[
								3,
								0
							]
							]
						]
						],
						[
						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetAnim,
							null,
							6507236658004302,
							false
							,[
							[
								1,
								[
									2,
									"Rainbow"
								]
							]
,							[
								3,
								1
							]
							]
						]
,						[
							125,
							cr.plugins_.Sprite.prototype.acts.SetSize,
							null,
							5744248719646344,
							false
							,[
							[
								0,
								[
									0,
									323
								]
							]
,							[
								0,
								[
									0,
									161
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5519598296403045,
				[
				[
					-1,
					cr.system_object.prototype.cnds.LayerVisible,
					null,
					0,
					false,
					true,
					false,
					1485998711045396,
					false
					,[
					[
						5,
						[
							2,
							"ShopLoading"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetGroupActive,
					null,
					2291998429617766,
					false
					,[
					[
						1,
						[
							2,
							"ShopLoading"
						]
					]
,					[
						3,
						0
					]
					]
				]
,				[
					85,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8075958660477997,
					false
					,[
					[
						0,
						[
							0,
							66
						]
					]
,					[
						0,
						[
							0,
							457
						]
					]
					]
				]
				]
			]
			]
		]
		]
	]
	],
	[
		["button_close.m4a", 1712],
		["button_close.ogg", 5115],
		["button_confirm.m4a", 1389],
		["button_confirm.ogg", 5866],
		["enemy_death.m4a", 38024],
		["enemy_death.ogg", 38229],
		["enemy_shoot.m4a", 61845],
		["enemy_shoot.ogg", 49097],
		["player_shotgun_normal.m4a", 18792],
		["player_shotgun_normal.ogg", 17943],
		["pickup.m4a", 25720],
		["pickup.ogg", 27171],
		["lane_missile.m4a", 13536],
		["lane_missile.ogg", 15711],
		["collision.m4a", 20480],
		["collision.ogg", 20188],
		["boss_death.m4a", 22276],
		["boss_death.ogg", 23332],
		["grenade_explosion.m4a", 37212],
		["grenade_explosion.ogg", 38157],
		["player_shotgun_mecha.m4a", 18579],
		["player_shotgun_mecha.ogg", 17943],
		["coindrop.m4a", 20402],
		["coindrop.ogg", 23959],
		["coin_pickup.m4a", 22700],
		["coin_pickup.ogg", 25254],
		["player_death.m4a", 43483],
		["player_death.ogg", 42265],
		["enemy_laser.m4a", 27349],
		["enemy_laser.ogg", 26531],
		["enemy_lasersmall.m4a", 15787],
		["enemy_lasersmall.ogg", 17070],
		["warning.m4a", 52788],
		["warning.ogg", 50066],
		["enemy_nuke.m4a", 28940],
		["enemy_nuke.ogg", 23971],
		["voice_laser.m4a", 16082],
		["voice_laser.ogg", 18115],
		["voice_rocketlauncher.m4a", 19072],
		["voice_rocketlauncher.ogg", 20269],
		["voice_shotgun.m4a", 13995],
		["voice_shotgun.ogg", 15902],
		["voice_grenade.m4a", 15296],
		["voice_grenade.ogg", 17336],
		["voice_shieldup.m4a", 21008],
		["voice_shieldup.ogg", 22127],
		["voice_shielddown.m4a", 20727],
		["voice_shielddown.ogg", 21675],
		["voice_warning.m4a", 13773],
		["voice_warning.ogg", 16478],
		["voice_gameover.m4a", 27517],
		["voice_gameover.ogg", 27811],
		["voice_victory.m4a", 17520],
		["voice_victory.ogg", 19339],
		["voice_massivedamage.m4a", 27552],
		["voice_massivedamage.ogg", 27648],
		["achieved.m4a", 21004],
		["achieved.ogg", 25078],
		["boost_of_speed.m4a", 65243],
		["boost_of_speed.ogg", 55517],
		["player_revolver.m4a", 11318],
		["player_revolver.ogg", 9264],
		["player_shoot.m4a", 9298],
		["player_shoot.ogg", 11200],
		["voice_targetdestroyed.m4a", 26682],
		["voice_targetdestroyed.ogg", 27592]
	],
	"",
	false,
	1136,
	640,
	4,
	true,
	true,
	true,
	"1.0.0.4",
	true,
	false,
	1,
	0,
	644,
	false,
	true,
	1,
	true,
	"Colossal Defenders",
	[
	]
];};

createCocoonJSRuntime();

})();
